<?php
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.system.nics.inc');
include_once(dirname(__FILE__).'/ressources/class.tcpip.inc');
include_once(dirname(__FILE__).'/ressources/class.ccurl.inc');

if($argv[1]=="--md"){Md5Files();exit;}

Startx();
function Startx(){

    $unix=new unix();
    $git=$unix->find_program("git");
    $tar=$unix->find_program("tar");
    $rm=$unix->find_program("rm");
    echo "Cloning...\n";

    if(is_dir("/home/Modsecurity")){
        shell_exec("$rm -rf /home/Modsecurity");
    }
    shell_exec("$git clone https://github.com/SpiderLabs/owasp-modsecurity-crs.git /home/Modsecurity");

    chdir("/home/Modsecurity/rules");
    system("cd /home/Modsecurity/rules");
    system("$tar -czf /home/modsecurity.tar.gz *");
    $old_md5=@file_get_contents("/root/owasp-modsecurity-crs.md5");
    $newmd5=Md5Files();

    echo "OLD MD5: $old_md5\n";
    echo "NEW MD5: $newmd5\n";

    if($old_md5<>$newmd5){
        $iniArry["zDate"]=time();
        $iniArry["md5"]=md5_file("/home/modsecurity.tar.gz");
        @file_put_contents("/home/modsecurity.txt",base64_encode(serialize($iniArry)));
        if(upload_category("/home/modsecurity.txt")){
            if(upload_category("/home/modsecurity.tar.gz")){
                @file_put_contents("/root/owasp-modsecurity-crs.md5",$newmd5);
            }
        }

    }



}

function Md5Files(){

    $unix=new unix();
    $list=$unix->DirFiles("/home/Modsecurity/rules");
    foreach ($list as $filename=>$none){
        $mds[]=md5_file("/home/Modsecurity/rules/$filename");
    }

    return md5(@implode(",",$mds));

}

function upload_category($filetext=null){

    $UfdbCatsUploadFTPserv=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UfdbCatsUploadFTPserv"));
    $UfdbCatsUploadFTPusr=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UfdbCatsUploadFTPusr"));
    $UfdbCatsUploadFTPpass=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UfdbCatsUploadFTPpass"));
    $UfdbCatsUploadFTPDir=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UfdbCatsUploadFTPDir"));


    if ( ($UfdbCatsUploadFTPserv==null) OR ($UfdbCatsUploadFTPusr==null)){
        return false;
    }
    echo "Connect to $UfdbCatsUploadFTPserv...\n";
    $conn_id = ftp_connect($UfdbCatsUploadFTPserv);        // set up basic connection

    if(!$conn_id){
        echo "Connection Failed....\n";
        return false;
    }
    echo "Login as $UfdbCatsUploadFTPusr...\n";
    $login_result = ftp_login($conn_id, $UfdbCatsUploadFTPusr, $UfdbCatsUploadFTPpass);

    if ((!$conn_id) || (!$login_result)) {
        echo "Failed $UfdbCatsUploadFTPusr@$UfdbCatsUploadFTPserv\n";
        squid_admin_mysql(0, "{failed} {connecting} $UfdbCatsUploadFTPusr@$UfdbCatsUploadFTPserv", null,__FILE__,__LINE__);
        @file_put_contents("$filetext.err",time());
        return false;
    }

    ftp_pasv($conn_id, true);
    if(!is_file($filetext)){echo "!!! unable to find $filetext\n";die();}
    $file = basename($filetext);
    $fp = fopen($filetext, 'r');

    if (ftp_fput($conn_id, "$UfdbCatsUploadFTPDir/$file", $fp, FTP_BINARY)) {
        echo "Uploading $filetext success ($UfdbCatsUploadFTPDir) $UfdbCatsUploadFTPusr@$UfdbCatsUploadFTPserv\n";

    } else {
        print_r( error_get_last() );
        echo "Failed to upload $filetext in $UfdbCatsUploadFTPDir\n";
        ftp_close($conn_id);
        fclose($fp);
        @file_put_contents("$filetext.err",time());
        return false;
    }
    fclose($fp);
    return true;



}


