<?php
$GLOBALS["VERBOSE"]=false;
$GLOBALS["FORCE"]=false;



$GLOBALS["SETTINGS"][]="EnableMilterRegex";
$GLOBALS["SETTINGS"][]="MilterGreyListEnabled";
$GLOBALS["SETTINGS"][]="MimeDefangEnabled";
$GLOBALS["SETTINGS"][]="NTPDClientEnabled";
$GLOBALS["SETTINGS"][]="NTPDUseSpecifiedServers";
$GLOBALS["SETTINGS"][]="NTPClientDefaultServerList";
$GLOBALS["SETTINGS"][]="CurlUserAgent";
$GLOBALS["SETTINGS"][]="ArticaProxySettings";

if(preg_match("#--force#",implode(" ",$argv))){$GLOBALS["FORCE"]=true;$GLOBALS["OUTPUT"]=true;}
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;$GLOBALS["OUTPUT"]=true;$GLOBALS["debug"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
ini_set('memory_limit','1000M');
$GLOBALS["PROGRESS"]=false;
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
include_once(dirname(__FILE__).'/ressources/class.templates.inc'); 
include_once(dirname(__FILE__).'/ressources/class.ini.inc');
include_once(dirname(__FILE__).'/ressources/class.samba.inc');
include_once(dirname(__FILE__).'/ressources/class.autofs.inc');
include_once(dirname(__FILE__).'/ressources/class.mysql.inc');
include_once(dirname(__FILE__).'/ressources/class.backup.inc');
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.cyrus.inc');
include_once(dirname(__FILE__).'/ressources/class.artica-meta.inc');
include_once(dirname(__FILE__).'/ressources/class.user.inc');
include_once(dirname(__FILE__).'/ressources/class.mount.inc');
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__)."/framework/frame.class.inc");
include_once(dirname(__FILE__)."/ressources/class.ccurl.inc");
include_once(dirname(__FILE__)."/ressources/class.mysql.powerdns.inc");
include_once(dirname(__FILE__)."/ressources/class.snapshots.blacklists.inc");
include_once(dirname(__FILE__)."/ressources/externals/class.aesCrypt.inc");

$GLOBALS["NOSTATUS"]=false;

$GLOBALS["COMMANDLINE"]=@implode(" ", $argv);
$GLOBALS["NOT_RESTORE_NETWORK"]=false;
$GLOBALS["SEND_META"]=false;
$GLOBALS["SNAPSHOT_NO_DELETE"]=false;
$GLOBALS["SNAPSHOT_NO_MYSQL"]=false;
if(preg_match("#--command=(.+?);#",$GLOBALS["COMMANDLINE"],$re)){$GLOBALS["COMMAND"]=$re[1];}
if(preg_match("#--verbose#",$GLOBALS["COMMANDLINE"])){$GLOBALS["VERBOSE"]=true;ini_set('html_errors',0);ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);}
if(preg_match("#--progress#",$GLOBALS["COMMANDLINE"])){$GLOBALS["PROGRESS"]=true;$GLOBALS["COMMAND"]="cluster-snapshot";}

if($argv[1]=="--xnotify"){export_cluster();exit;}
if($argv[1]=="--install"){cluster_install();exit;}
if($argv[1]=="--uninstall"){cluster_uninstall();exit;}

export_cluster();

function build_progress($pourc,$text){
	$echotext=$text;
	echo "Starting......: ".date("H:i:s")." {$pourc}% $echotext\n";
	$cachefile="/usr/share/artica-postfix/ressources/logs/artica.cluster.progress";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($cachefile, serialize($array));
	@chmod($cachefile,0755);
}
function progress($pourc,$text){
	build_progress($pourc,$text);
}


function cluster_install(){

    build_progress(50,"{installing}");
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("PowerDNSEnableClusterMaster",1);
    build_progress(100,"{installing} {done}");

}
function cluster_uninstall(){
    build_progress(50,"{uninstalling}");
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("PowerDNSEnableClusterMaster",0);
    export_cluster_remove_files();
    build_progress(100,"{installing} {done}");

}


function export_cluster(){
    $unix=new unix();
    $PowerDNSEnableClusterMaster=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PowerDNSEnableClusterMaster"));


    if($PowerDNSEnableClusterMaster==0){
        build_progress(100,"Master Service is disabled...");
        export_cluster_remove_files();
        return;
    }






    $ClusterWaitNotify=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ClusterWaitNotify"));
    $PowerDNSEnableClusterMasterTime=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PowerDNSEnableClusterMasterTime"));
    if($PowerDNSEnableClusterMasterTime>123){
        $diff=$unix->time_min($PowerDNSEnableClusterMasterTime);
        if(!$GLOBALS["FORCE"]) {
            if ($diff < 5) {
                cluster_syslog("{$diff}mn, require 5mn minimal");
                if($ClusterWaitNotify==0){
                    cluster_syslog("Add order to queue...");
                    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("ClusterWaitNotify",1);
                    @unlink("/etc/artica-postfix/ClusterWaitProgram");
                    @unlink("/etc/artica-postfix/ClusterTime");
                    @file_put_contents("/etc/artica-postfix/ClusterTime",time());
                    @file_put_contents("/etc/artica-postfix/ClusterWaitProgram",time());

                }
                build_progress(110,"{$diff}mn, require 5mn minimal");
                return;
            }
        }
    }

    if($ClusterWaitNotify==1){
        cluster_syslog("Disable ClusterWaitNotify...");
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("ClusterWaitNotify",0);
        @unlink("/etc/artica-postfix/ClusterWaitProgram");
        @unlink("/etc/artica-postfix/ClusterTime");
    }





    if(!is_dir("/home/artica/PowerDNS/Cluster/storage")){@mkdir("/home/artica/PowerDNS/Cluster/storage",0755,true);}
    @file_put_contents("/home/artica/PowerDNS/Cluster/storage/index.php","<?php header(\"location: index.html\"); ?>");
    @file_put_contents("/home/artica/PowerDNS/Cluster/storage/index.html", "<html><head></head><body><H1>This is the storage section for PowerCluster system, keep out !</H1></body></html>");
    @chmod("/home/artica/PowerDNS/Cluster/storage/index.html",0644);
    @chmod("/home/artica/PowerDNS/Cluster/storage/index.php",0755);



    $EnablePDNS=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnablePDNS");
    $i=10;

    if($EnablePDNS==1){
        $mysqldump=$unix->find_program("mysqldump");

        if(!is_file($mysqldump)){
            cluster_events(0, "Cannot export data MySQLDump missing", null,__LINE__);
            build_progress(110,"Cannot export data MySQLDump missing");
            return;
        }

        $IGNORES[]="perm_templ";
        $IGNORES[]="comments";
        $IGNORES[]="users";
        $IGNORES[]="perm_templ_items";
        $IGNORES[]="zones";
        $IGNORES[]="zone_templ";
        $IGNORES[]="zone_templ_records";
        $IGNORES[]="records_zone_templ";
        $IGNORES[]="migrations";

        foreach ($IGNORES as $table_ignore){

            $tblign[]="--ignore-table=powerdns.$table_ignore";

        }
        $i++;
        build_progress($i,"Exporting powerdns");
        $q=new mysql_pdns();
        $MYSQL_CMDLINES=$q->MYSQL_CMDLINES;
        $cmdline="$mysqldump ".@implode(" ", $tblign) ." --add-drop-table --skip-comments --insert-ignore $MYSQL_CMDLINES powerdns > /home/artica/PowerDNS/Cluster/storage/powerdns.sql 2>&1";
        exec($cmdline,$results);
        if($unix->MYSQL_BIN_PARSE_ERROR($results)){
            cluster_events(0, "Cluster: Error while exporting powerdns database", @implode("\n", $results),__LINE__);
            echo $unix->mysql_error."\n";
            @unlink("/home/artica/PowerDNS/Cluster/storage/powerdns.sql");
            build_progress(110,"Error while exporting powerdns database");
            return;
        }

        if($unix->MYSQL_BIN_PARSE_FILE("/home/artica/PowerDNS/Cluster/storage/powerdns.sql")){
            cluster_events(0, "Cluster: Error while exporting powerdns database", $unix->mysql_error,__LINE__);
            echo $unix->mysql_error."\n";
            build_progress(110,"Error while exporting powerdns database");
            @unlink("/home/artica/PowerDNS/Cluster/storage/powerdns.sql");
            return;
        }
        $i++;
        build_progress($i,"{compressing} powerdns");
        $unix->compress("/home/artica/PowerDNS/Cluster/storage/powerdns.sql", "/home/artica/PowerDNS/Cluster/storage/powerdns.gz");
        @unlink("/home/artica/PowerDNS/Cluster/storage/powerdns.sql");
    }



    $PERSONAL_CATEGORIES_TABLE=array();
    $EnableUfdbGuard=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableUfdbGuard"));
    $EnablePersonalCategories=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnablePersonalCategories"));
    $ClusterReplicateOfficalDatabases=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ClusterReplicateOfficalDatabases"));
    $ClusterNotReplicateWeb=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ClusterNotReplicateWeb"));

    if($EnableUfdbGuard==1){
        $cp         = $unix->find_program("cp");
        $rm         = $unix->find_program("rm");
        $TargetDir  = "/home/artica/PowerDNS/Cluster/storage/var/lib/ufdbartica";
        if(!is_dir($TargetDir)) { mkdir($TargetDir, 0755, true); }

        if($ClusterReplicateOfficalDatabases==1) {
             echo "Importing Web-filtering databases.....\n";
            shell_exec("$cp -rfd /var/lib/ufdbartica/* $TargetDir/");
        }else{
            shell_exec("rm -rf $TargetDir/*");
        }

    }

    if($EnablePersonalCategories==1){
        $PERSONAL_CATEGORIES_TABLE[]="personal_categories";
        $qCatz=new postgres_sql();
        $sql="SELECT category_id,categorytable FROM personal_categories WHERE official_category=0 AND free_category=0 order by categoryname ";
        $resultsCatz=$qCatz->QUERY_SQL($sql);
        while ($ligneCatz = pg_fetch_assoc($resultsCatz)) {
            $category_id    = $ligneCatz["category_id"];
            $SourceFile     = "/var/lib/ufdbartica/$category_id/domains.ufdb";
            $DestinationF   = "$TargetDir/$category_id/domains.ufdb";
            $PERSONAL_CATEGORIES_TABLE[]=$ligneCatz["categorytable"];

            if(!is_file($SourceFile)) {
                events("Replicate Personal category $category_id SKIP ( not compiled )", null, __LINE__);
                continue;
            }
            $SourceMD5=md5_file($SourceFile);
            if(is_file($DestinationF)) { $DestinationMD5 = md5_file($DestinationF); }

            if($SourceMD5 == $DestinationMD5){continue;}
            if(is_file($DestinationF)) {@unlink($DestinationF);}


            if(!is_dir("$TargetDir/$category_id")){@mkdir("$TargetDir/$category_id",0755,true);}
            events("Replicate Personal category $category_id",null,__LINE__);
            @copy($SourceFile,$DestinationF);
            $DestinationMD5=md5_file($DestinationF);
            if($SourceMD5 <> $DestinationMD5) {
                events("Replicate Personal category $category_id Failed, MD5 differ",null,__LINE__);
                @unlink($DestinationF);
                @rmdir("$TargetDir/$category_id");
                continue;
            }

        }
        $filesize = round(@filesize($DestinationF)/1024,2);

        events("Put Personal category $category_id ($filesize KB) into main package success",null,__LINE__);
    }
    
    $catzfiles=$unix->DirFiles("/home/artica/PowerDNS/Cluster/storage","\.catz$");

    foreach ($catzfiles as $filename){
        echo "Removing old fata ($filename)\n";
        @unlink("/home/artica/PowerDNS/Cluster/storage/$filename");
    }
    
    echo "Exporting ".count($PERSONAL_CATEGORIES_TABLE)." personal categories\n";

    foreach ($PERSONAL_CATEGORIES_TABLE as $pgtables){
        $tswitch[]="-t $pgtables";
    }
    $i++;build_progress($i,"{exporting} personal categories");
    echo "Exporting all personal categories\n";
    $cmd="/usr/local/ArticaStats/bin/pg_dump -Fc --file=/home/artica/PowerDNS/Cluster/storage/categories.pgdump ".@implode(" ",$tswitch)." -h /var/run/ArticaStats -U ArticaStats proxydb";
    echo $cmd."\n";
    shell_exec($cmd);


    $SQLITE=sqlitedb_list();
    foreach ($SQLITE as $db=>$none){

        $i++;build_progress($i,"{exporting} $db");
        if(is_file("/home/artica/PowerDNS/Cluster/storage/$db")){
            @unlink("/home/artica/PowerDNS/Cluster/storage/$db");
        }
        if(!@copy("/home/artica/SQLITE/$db", "/home/artica/PowerDNS/Cluster/storage/$db")){
            echo "FAILED TO COPY -> /home/artica/PowerDNS/Cluster/storage/$db\n";
        }else{
            echo "Success: /home/artica/PowerDNS/Cluster/storage/$db\n";
        }
    }


    foreach ($GLOBALS["PGDUMP"] as $pgtables){
        $i++;build_progress($i,"{exporting} $pgtables");
        $cmd="/usr/local/ArticaStats/bin/pg_dump --file=/home/artica/PowerDNS/Cluster/storage/$pgtables.pgsql --no-comments --inserts --data-only --format=custom --table=$pgtables -h /var/run/ArticaStats -U ArticaStats proxydb";
        shell_exec($cmd);
    }

    $BLACKLISTS=artica_settings_blacklists(true);

    if($ClusterNotReplicateWeb==1) {
        $BLACKLISTS["SquidGuardWebWebServiceID"]=true;
        $BLACKLISTS["SquidGuardWebUseInternalUri"]=true;
        $BLACKLISTS["SquidGuardWebUseExternalUri"]=true;
        $BLACKLISTS["SquidGuardWebExternalUri2"]=true;
        $BLACKLISTS["SquidGuardWebExternalUri"]=true;
        $BLACKLISTS["SquidGuardWebExternalUri"]=true;
        $BLACKLISTS["SquidGuardWebExternalUriSSL"]=true;
    }



    $dir_handle = @opendir("/etc/artica-postfix/settings/Daemons");
    if(!$dir_handle){events("Unable to open \"/etc/artica-postfix/settings/Daemons\"",null,__LINE__);return false;}
    $count=0;
    $i++;build_progress($i,"{exporting} {settings}");
    while ($file = readdir($dir_handle)) {
        if($file=='.'){continue;}
        if($file=='..'){continue;}
        if(is_dir("/etc/artica-postfix/settings/Daemons/$file")){continue;}
        if(preg_match("#_INSTALLED$#",$file)){continue;}
        if(preg_match("#_VERSION$#",$file)){continue;}
        if(preg_match("#Version$#",$file)){continue;}
        if(preg_match("#DNSFILTERD_STATS#",$file)){continue;}
        if(preg_match("#ETHCONFIG#",$file)){continue;}
        if(preg_match("#_hostname$#",$file)){continue;}
        if(isset($BLACKLISTS[$file])){continue;}
        $MAIN[$file] = $GLOBALS["CLASS_SOCKETS"]->GET_INFO($file);
    }

    @file_put_contents("/home/artica/PowerDNS/Cluster/storage/settings.conf", serialize($MAIN));


    $tar=$unix->find_program("tar");
    chdir("/home/artica/PowerDNS/Cluster/storage");
    system("cd /home/artica/PowerDNS/Cluster/storage");

    if(is_file("/home/artica/PowerDNS/Cluster/storage/krb5.keytab")){
        @unlink("/home/artica/PowerDNS/Cluster/storage/krb5.keytab");
    }

    if(is_file("/etc/squid3/krb5.keytab")){
        @copy("/etc/squid3/krb5.keytab","/home/artica/PowerDNS/Cluster/storage/krb5.keytab");
    }

    $SRCFILE="/home/artica/PowerDNS/Cluster/storage/powerdns.tar.gz";
    $DESTFILE="/home/artica/PowerDNS/Cluster/storage/powerdns.aes";
    if(is_file($SRCFILE)){@unlink($SRCFILE);}
    if(is_file($DESTFILE)){@unlink($DESTFILE);}
    $i++;build_progress($i,"{compressing}");
    system("$tar czf $SRCFILE *");
    export_cluster_remove_files();

    $PowerDNSClusterPassword=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PowerDNSClusterPassword"));
    $PowerDNSClusterPassword=$unix->shellEscapeChars($PowerDNSClusterPassword);




    $md5=md5_file($SRCFILE);


    $ARRAY["MD5"]=$md5;
    $ARRAY["SERIAL"]=time();
    $ARRAY["UUID"]=$unix->GetUniqueID();
    $ARRAY["ClusterReplicateOfficalDatabases"]=$ClusterReplicateOfficalDatabases;
    file_put_contents("/home/artica/PowerDNS/Cluster/storage/index.txt", base64_encode(serialize($ARRAY)));
    $filesize=filesize($SRCFILE);

    $filesizeKo=$filesize/1024;
    $filesizzUNit="KB";

    if($filesizeKo>1024){
        $filesizeKo=$filesizeKo/1024;
        $filesizzUNit="MB";
    }



    cluster_events(2, "Cluster: Success create Master cluster package ($filesizeKo{$filesizzUNit})", null,__LINE__);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("PowerDNSEnableClusterMasterTime",time());
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("PowerDNSEnableClusterMasterSize", $filesize);
    build_progress(100,"{success}");
    Cluster_clean();

}

function events($subject,$text=null,$line=0){
    $crit=2;
    if(preg_match("#(fatal|error|skip)",$subject)){$crit=0;}
    cluster_events($crit,"Cluster: $subject",$text,__LINE__);

}

function export_cluster_remove_files(){
    $unix=new unix();
    $rm=$unix->find_program("rm");
    $f[]="/home/artica/PowerDNS/Cluster/storage/artica_backup.sql";
    $f[]="/home/artica/PowerDNS/Cluster/storage/artica_backup.gz";
    $f[]="/home/artica/PowerDNS/Cluster/storage/powerdns.sql";
    $f[]="/home/artica/PowerDNS/Cluster/storage/powerdns.gz";
    $f[]="/home/artica/PowerDNS/Cluster/storage/powerdns.aes";

    $SQLITE["admins.db"]=true;
    $SQLITE["caches.db"]=true;
    $SQLITE["hypercache.db"]=true;
    $SQLITE["nginx.db"]=true;
    $SQLITE["ntp.db"]=true;
    $SQLITE["privileges.db"]=true;
    $SQLITE["rdpproxy.db"]=true;
    $SQLITE["sshd.db"]=true;
    $SQLITE["sys_schedules.db"]=true;
    $SQLITE["antivirus.db"]=true;
    $SQLITE["certificates.db"]=true;
    $SQLITE["etc_hosts.db"]=true;
    $SQLITE["ftpusers.db"]=true;
    $SQLITE["postfix.db"]=true;
    $SQLITE["proxy.db"]=true;
    $SQLITE["suricata.db"]=true;
    $SQLITE["acls.db"]=true;
    $SQLITE["dns.db"]=true;
    $SQLITE["firewall.db"]=true;
    $SQLITE["haproxy.db"]=true;
    $SQLITE["spamassassin.db"]=true;
    $SQLITE["webfilter.db"]=true;
    $SQLITE["webconsole.db"]=true;



    foreach ($SQLITE as $db=>$none){$f[]="/home/artica/PowerDNS/Cluster/storage/$db";}
    foreach ($GLOBALS["PGDUMP"] as $pgtables){$f[]="/home/artica/PowerDNS/Cluster/storage/$pgtables.pgsql";}



    foreach ($f as $path){
        if(is_file($path)){@unlink($path);}
    }

    if(is_dir("/home/artica/PowerDNS/Cluster/storage/var/lib/ufdbartica")){
        shell_exec("$rm -rf /home/artica/PowerDNS/Cluster/storage/var/lib/ufdbartica");
    }


}

function cluster_syslog($subject,$content=null){
    $file="cluster-master";
    if(function_exists('syslog')){
        openlog($file, LOG_PID | LOG_PERROR, LOG_LOCAL0);
        syslog(LOG_INFO, "$subject $content");
        closelog();
    }
}

function Cluster_clean(){

    $date = strtotime("-7 day");
    $q=new lib_sqlite("/home/artica/SQLITE/clusters_events.db");
    $q->QUERY_SQL("DELETE FROM events WHERE zdate < '$date'");
    if(!$q->ok){
        cluster_events(0,"MySQL error",$q->mysql_error,__LINE__);
    }
}

function cluster_events($prio,$subject,$content,$line=0){


    cluster_syslog($subject,$content);

    $q=new lib_sqlite("/home/artica/SQLITE/clusters_events.db");
    $sql="CREATE TABLE IF NOT EXISTS `events` (
    `ID` INTEGER PRIMARY KEY AUTOINCREMENT,
    `prio` INTEGER NOT NULL DEFAULT 2,
	`zdate` INTEGER,
	`sent` INTEGER NOT NULL DEFAULT 0,
	`subject` TEXT,
	`content` TEXT,
	`info` TEXT ) ";

    $q->QUERY_SQL($sql);
    $time=time();
    $info="Line ".$line ." file:".basename(__FILE__);
    $sql="INSERT INTO events (zdate,prio,sent,subject,content,info) VALUES('$time',$prio,0,'$subject','$content','$info');";
    $q->QUERY_SQL($sql);

}


