#!/usr/bin/php

<?php
/**
 * Created by PhpStorm.
 * User: dtouzeau
 * Date: 17/11/18
 * Time: 08:13
 */
if($argv[1]=="--no-compile"){$GLOBALS["NO_COMPILE"]=true;}
$MainVer="4.31";
$compiledate=date("mdH");
$compiledate="000000";
$VERSION="$MainVer.$compiledate";
system('rm -rf /usr/share/artica-postfix/ressources/backup');
system('rm -rf /usr/share/artica-postfix/ressources/conf/*');
system('rm -rf /usr/share/artica-postfix/ressources/logs/*');
system('rm -rf /usr/share/artica-postfix/ressources/userdb/*');
system('rm -rf /usr/share/artica-postfix/ressources/settings.inc');
system('rm -rf /usr/share/artica-postfix/ressources/install/*');
system('rm -rf /usr/share/artica-postfix/ressources/databases/*.cache');
system('rm -f  /usr/share/artica-postfix/ressources/usb.scan.inc');
system('rm -rf /usr/share/artica-postfix/ressources/settings.inc');
system('rm -rf /usr/share/artica-postfix/ressources/settings.new.inc');
system('rm -rf /usr/share/artica-postfix/PATCH');
system('rm -rf /usr/share/artica-postfix/PATCHS_HISTORY');
system('rm -rf /usr/share/artica-postfix/ressources/logs/*');
system('rm -rf /usr/share/artica-postfix/ressources/dar_collection');
system('rm -rf /usr/share/artica-postfix/artica-install');
system('rm -rf /usr/share/artica-postfix/class.templates.inc');
system('rm -rf /usr/share/artica-postfix/user-backup/ressources/profiles/icons/*.*');
system('rm -rf /usr/share/artica-postfix/user-backup/ressources/conf/upload/*.*');
system('rm -f /usr/share/artica-postfix/nohup.out');
system('/bin/rm -f /usr/share/artica-postfix/ressources/settings.inc');
system('/bin/rm -f /usr/share/artica-postfix/ressources/settings.new.inc');

$langues["fr"]=true;
$langues["it"]=true;
$langues["de"]=true;
$langues["po"]=true;
$langues["es"]=true;
$langues["br"]=true;
$langues["pol"]=true;

foreach ($langues as $lang=>$none){

    echo "Compile $lang\n";
    system("wget http://www.artica.fr/export.lang.php?lang=$lang -O /dev/null");

}
foreach ($langues as $lang=>$none){
    echo "Downloading $lang\n";
    system("wget http://www.artica.fr/languages/download/$lang/$lang.tar -O /tmp/$lang.tar");
    echo "Installing $lang\n";
    if(!is_dir("/usr/share/artica-postfix/ressources/language/$lang")){
    mkdir("/usr/share/artica-postfix/ressources/language/$lang",0755,true);}
    system("tar -xf /tmp/$lang.tar -C /usr/share/artica-postfix/ressources/language/$lang/");
    @unlink("/tmp/$lang.tar");
}

system('php /usr/share/artica-postfix/compile-lang.php');

if($GLOBALS["NO_COMPILE"]){die();}

@file_put_contents("/home/dtouzeau/PhpstormProjects/Articav4/VERSION",$VERSION);

mkdir("/home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix",0755,true);
echo "Copy files to [/home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix]\n";
system("cp -rf /home/dtouzeau/PhpstormProjects/Articav4/* /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix/");
system("rm -rf /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix/bin/src");
system("rm -f /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix/bin/artica-compile");
system("rm -rf /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix/bin/certs");
system("rm -rf /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix/bin/install/cups/drivers");
system("rm -rf /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix/bin/install/awstats");
system("rm -rf /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix/bin/install/distributions");
system("rm -rf /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix/ressources/language/en");
system("rm -rf /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix/css/kavweb");
system("rm -rf /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix/css/artica-theme");
system("rm -rf /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix/css/my-cosi");
system("rm -rf /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix/css/android-theme");
system("rm -rf /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix/css/templates.users.ressources");
system("rm -rf /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix/angular/js/plugins/nggrid");
system("rm -rf /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix/angular/js/plugins/pdfjs");
system("rm -rf /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix/.git");
foreach ($langues as $lang=>$none){
    echo "Removing artica-postfix/ressources/language/$lang\n";
    system("rm -rf /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix/ressources/language/$lang");
}


echo "Apply security to [/home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix]\n";
system("chown -R www-data:www-data /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix");
system("chmod -R 0755 /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix");

echo "Compressing /home/dtouzeau/artica-compile/$VERSION/usr/share/artica-postfix\n";
$cmd[]="cd /home/dtouzeau/artica-compile/$VERSION/usr/share && tar -czf /home/dtouzeau/artica-compile/artica-$VERSION.tgz artica-postfix";
$cmd[]=' --exclude artica-postfix/bin/src';
$cmd[]=' --exclude artica-postfix/bin/install/kas-linux-install';
$cmd[]=' --exclude artica-postfix/bin/install/kav4mailservers-linux-install';
$cmd[]=' --exclude artica-postfix/bin/install/roundcubemail';
$cmd[]=' --exclude artica-postfix/bin/install/kas-linux-mp1';
$cmd[]=' --exclude artica-postfix/LocalDatabases';
$cmd[]=' --exclude artica-postfix/bin/oldlibs';
$cmd[]=' --exclude artica-postfix/ressources/profiles';
$cmd[]=' --exclude artica-postfix/ressources/ldap-back';
$cmd[]=' --exclude artica-postfix/webmail';
$cmd[]=' --exclude artica-postfix/amavis';
$cmd[]=' --exclude artica-postfix/ldap';
$cmd[]=' --exclude artica-postfix/mysql';
$cmd[]=' --exclude artica-postfix/certs';
$cmd[]=' --exclude artica-postfix/sql';
$cmd[]=' --exclude artica-postfix/.git';
$cmd[]=' --exclude artica-postfix/roundcube';
$cmd[]=' --exclude artica-postfix/computers';
$cmd[]=' --exclude artica-postfix/oma';
$cmd[]=' --exclude artica-postfix/etc';
$cmd[]=' --exclude artica-postfix/computers';
$cmd[]=' --exclude artica-postfix/virtualbox';
$cmd[]=' --exclude artica-postfix/groupware';
$cmd[]=' --exclude artica-postfix/certs';
$cmd[]=' --exclude artica-postfix/bin/artica-compile';
$cmd[]=' --exclude artica-postfix/bin/setup-centos';
$cmd[]=' --exclude artica-postfix/bin/setup-mandrake';
$cmd[]=' --exclude artica-postfix/bin/setup-fedora';
$cmd[]=' --exclude artica-postfix/bin/setup-debian';
$cmd[]=' --exclude artica-postfix/bin/setup-suse';
$cmd[]=' --exclude artica-postfix/bin/artica-bogom';
$cmd[]=' --exclude artica-postfix/bin/install-sql';
$cmd[]=' --exclude artica-postfix/bin/mini-sendmail';
$cmd[]=' --exclude artica-postfix/bin/amavis-logwatch';
$cmd[]=' --exclude artica-postfix/bin/clear';
$cmd[]=' --exclude artica-postfix/bin/artica-mimedefang-pipe';
$cmd[]=' --exclude artica-postfix/ressources/sessions/SessionData';
$cmd[]=' --exclude artica-postfix/ressources/isoqlog';
$cmd[]=' --exclude artica-postfix/ressources/psps.inc';
$cmd[]=' --exclude artica-postfix/ressources/scan.printers.drivers.inc';
$cmd[]=' --exclude artica-postfix/ressources/processes.inc';
$cmd[]=' --exclude artica-postfix/ressources/logs/';
$cmd[]=' --exclude artica-postfix/ressources/language/en';
$cmd[]=' --exclude artica-postfix/ressources/language/fr';
$cmd[]=' --exclude artica-postfix/ressources/language/it';
$cmd[]=' --exclude artica-postfix/ressources/language/po';
$cmd[]=' --exclude artica-postfix/ressources/language/de';
$cmd[]=' --exclude artica-postfix/ressources/language/es';
$cmd[]=' --exclude artica-postfix/ressources/language/pol';
$cmd[]=' --exclude artica-postfix/artica-install';
$cmd[]=' --exclude artica-postfix/user-backup/.cache';
$cmd[]=' --exclude artica-postfix/user-backup/.settings';
$cmd[]=' --exclude artica-postfix/user-backup/php_logs';
$cmd[]=' --exclude artica-postfix/.settings';
$cmd[]=' --exclude artica-postfix/default.js.bak';
$cmd[]=' --exclude artica-postfix/ressources/ldap-back';
$cmd[]=' --exclude artica-postfix/ressources/sock';
$cmd[]=' --exclude artica-postfix/ressources/logs/web';
$cmd[]=' --exclude artica-postfix/ressources/kayaco';
$cmd[]=' --exclude artica-postfix/computers';
$cmd[]=' --exclude artica-postfix/user-backup';
$cmd[]=' --exclude artica-postfix/zabbix';
$cmd[]=' --exclude artica-postfix/exec.dshield.php';
$cmd[]=' --exclude artica-postfix/PDFs';
$cmd[]=' --exclude artica-postfix/tests.py';
$cmd[]=' --exclude artica-postfix/.eric4project';
$cmd[]=' --exclude artica-postfix/.settings';
$cmd[]=' --exclude artica-postfix/.mldonkey';
$cmd[]=' --exclude artica-postfix/exec.compile-official-ufdb.php';
$cmd[]=' --exclude artica-postfix/exec.malware-domains.php';
$cmd[]=' --exclude artica-postfix/exec.c-icap.cloud.php';
$cmd[]=' --exclude artica-postfix/exec.phistank.cloud.php';
$cmd[]=' --exclude artica-postfix/.git';

$cmdline=@implode(" ",$cmd);
system($cmdline);
system("rm -rf /home/dtouzeau/artica-compile/$VERSION");
system("chown dtouzeau:dtouzeau /home/dtouzeau/artica-compile/*");
echo "/home/dtouzeau/artica-compile/artica-$VERSION.tgz done...\n";
