<?php
if (!isset($GLOBALS["CLASS_SOCKETS"])) {if (!class_exists("sockets")) {include_once "/usr/share/artica-postfix/ressources/class.sockets.inc";}
    $GLOBALS["CLASS_SOCKETS"] = new sockets();}if (function_exists("posix_getuid")) {if (posix_getuid() != 0) {die("Cannot be used in web server mode\n\n");}}
include_once dirname(__FILE__) . '/ressources/class.templates.inc';
include_once dirname(__FILE__) . '/ressources/class.ldap.inc';
include_once dirname(__FILE__) . '/ressources/class.computers.inc';
include_once dirname(__FILE__) . '/ressources/class.system.network.inc';
include_once dirname(__FILE__) . '/ressources/class.ccurl.inc';
include_once dirname(__FILE__) . '/ressources/class.elasticssearch.inc';
include_once dirname(__FILE__) . '/framework/class.unix.inc';if (!isset($GLOBALS["CLASS_SOCKETS"])) {if (!class_exists("sockets")) {include_once "/usr/share/artica-postfix/ressources/class.sockets.inc";}
    $GLOBALS["CLASS_SOCKETS"] = new sockets();}
include_once dirname(__FILE__) . "/framework/frame.class.inc";
$GLOBALS["PROGRESS_FILE"] = "/usr/share/artica-postfix/ressources/logs/web/system.installsoft.progress";
if (preg_match("#--verbose#", implode(" ", $argv))) {$GLOBALS["VERBOSE"] = true;
    ini_set('display_errors', 1);
    ini_set('error_reporting', E_ALL);
    ini_set('error_prepend_string', null);
    ini_set('error_append_string', null);}
if ($argv[1] == "--install") {install($argv[2], $argv[3],$argv[4]);exit;}

function install($product, $key,$localpath=null){
    $AS_POSTFIX = false;
    $RESTART_CONSOLE=false;
	$UPDATES_ARRAY = unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("v4softsRepo")));
	$el = new elasticsearch();
    $CurrentVer = $el->GetVersion();

    if (!$UPDATES_ARRAY) {
        build_progress("v4softsRepo no array!", 110);
        return;
    }

    echo "Starting {{$product}} ($key)\n";

    if (!isset($UPDATES_ARRAY[$product])) {
        build_progress("$product no key!", 110);
        return;

    }
    $MAIN = $UPDATES_ARRAY[$product][$key];

    while (list($integ, $b) = each($MAIN)) {
        echo "$integ: $b\n";
    }

    $unix = new unix();
    $LINUX_CODE_NAME = $unix->LINUX_CODE_NAME();
    $LINUX_DISTRIBUTION = $unix->LINUX_DISTRIBUTION();
    $LINUX_VERS = $unix->LINUX_VERS();
    $LINUX_ARCHITECTURE = $unix->LINUX_ARCHITECTURE();
    $DebianVer = "debian{$LINUX_VERS[0]}";
    $TMP_DIR = $unix->TEMP_DIR();
    $UPLOADED_DIR = dirname(__FILE__) . "/ressources/conf/upload";
    $php = $unix->LOCATE_PHP5_BIN();

    $VERSION = $MAIN["VERSION"];
    $DISTRI = $MAIN["DISTRI"];
    $SIZE = $MAIN["SIZE"];
    $URL = $MAIN["URI"];
    $MD5 = $MAIN["MD5"];

    if ($URL == null) {
        build_progress("{{$product}} ($key) no such URL", 110);
        return;

    }
    build_progress("{downloading} $VERSION.tgz...", 10);
    $destfile = $TMP_DIR . "/package.tgz";
    if (is_file($destfile)) {@unlink($destfile);}

    echo "Current system..........: $LINUX_CODE_NAME $LINUX_DISTRIBUTION {$LINUX_VERS[0]}/{$LINUX_VERS[1]} $LINUX_ARCHITECTURE\n";
    echo "Package.................: $VERSION.tgz\n";
    echo "Version.................: $VERSION\n";
    echo "Operating system........: Debian{$DISTRI}/$DebianVer\n";
    echo "Temp dir................: $TMP_DIR\n";
    echo "Size....................: $SIZE bytes\n";
    $DOWNLOAD=True;
    if($localpath<>null) {
        if (is_file($localpath)) {
            $DOWNLOAD = false;
            $destfile=$localpath;
        }
    }
    echo "Destination file........: $destfile\n";

    if($DOWNLOAD) {
        $curl = new ccurl($URL);
        $curl->WriteProgress = true;
        $curl->ProgressFunction = "download_progress";
        if (!$curl->GetFile($destfile)) {
            @unlink($destfile);
            build_progress("{downloading} {{$product}} ($key) failed ...", 110);
            return;
        }
    }

    $newmd5 = md5_file($destfile);
    if ($newmd5 != $MD5) {
        echo "$newmd5<>$MD5\n";
        @unlink($destfile);
        build_progress("$destfile {{$product}} ($key) MD5 verification failed ...", 110);
        return;
    }

    build_progress("{stopping} {APP_MONIT} ($key)...", 35);
    shell_exec("/etc/init.d/monit stop");
    build_progress("{stopping} {APP_ARTICA_STATUS} ($key)...", 40);
    shell_exec("/etc/init.d/artica-status stop --force");



    if ($product == "APP_ELASTICSEARCH") {
        $ingesDir = "/etc/elasticsearch/ingest_geoip";
        if (is_dir($ingesDir)) {
            system("/usr/share/elasticsearch/bin/elasticsearch-plugin remove --purge ingest-geoip");
		}

        if (is_file("/etc/init.d/elasticsearch")) {

            if (substr($CurrentVer, 0, strlen('6.7')) < '6.7' && substr($VERSION, 0, strlen('7.0')) >= '7.0') {
                //FULL UPGRADE STOP
                build_progress("{do_full_upgrade_stop} {{$product}} ($key)...", 40);
                $el->FullUpgradeStop_Step1();
            }
            if ((substr($CurrentVer, 0, strlen('6.7')) >= '6.7' && substr($VERSION, 0, strlen('7.0')) >= '7.0') || (substr($CurrentVer, 0, strlen('6.7')) < '6.7' && substr($VERSION, 0, strlen('6.7')) == '6.7')) {
                //ROLLING UPGRADE STOP
                build_progress("{do_rolling_upgrade_stop} {{$product}} ($key)...", 40);
                $el->RollingUpgradeStop_Step1();
            }
            build_progress("{stopping} {{$product}} ($key)...", 40);
            @unlink("/etc/monit/conf.d/APP_ELASTICSEARCH.monitrc");
            system("/etc/init.d/monit restart");
            system("/etc/init.d/elasticsearch stop");
        }

        if (is_file("/etc/init.d/kibana")) {
            build_progress("{stopping} {{$product}} ($key)...", 45);
            @unlink("/etc/monit/conf.d/APP_KIBANA.monitrc");
            system("/etc/init.d/monit restart");
            build_progress("{stopping} {{$product}} ($key)...", 46);
            system("/etc/init.d/kibana stop");
        }
    }

    build_progress("{installing} {{$product}} ($key)...", 50);
    $tar = $unix->find_program("tar");
    $nohup = $unix->find_program("nohup");
    $php = $unix->LOCATE_PHP5_BIN();
    $rm=$unix->find_program("rm");

    if ($product == "APP_POSTFIX") {
        build_progress("{reconfiguring} {{$product}} ($key)...", 55);
        chdir("/etc/postfix");
        system("cd /etc/postfix");
        build_progress("{backup} {{$product}} ($key)...", 56);
        system("$tar -czf /root/postfix-backup.tar.gz *");
        chdir("/root");
        system("cd /root");
    }

    if ($product == "APP_MIMEDEFANG") {
        build_progress("{installing} {{$product}} (libmime-tools-perl)...", 56);
        if (!is_file("/usr/share/perl5/MIME/Tools.pm")) {$unix->DEBIAN_INSTALL_PACKAGE("libmime-tools-perl");} else {echo "libmime-tools-perl OK\n";}
        build_progress("{installing} {{$product}} (libmime-encwords-perl)...", 56);
        if (!is_file("/usr/share/perl5/MIME/EncWords.pm")) {$unix->DEBIAN_INSTALL_PACKAGE("libmime-encwords-perl");} else {echo "libmime-encwords-perl OK\n";}
        build_progress("{installing} {{$product}} (spamassassin)...", 56);
        if (!is_file("/usr/share/perl5/Mail/SpamAssassin.pm")) {$unix->DEBIAN_INSTALL_PACKAGE("spamassassin");} else {echo "spamassassin OK\n";}
        build_progress("{installing} {{$product}} (libhtml-parser-perl)...", 56);
        if (!is_file("/usr/lib/x86_64-linux-gnu/perl5/5.24/HTML/Parser.pm")) {$unix->DEBIAN_INSTALL_PACKAGE("libhtml-parser-perl");} else {echo "libhtml-parser-perl OK\n";}
        build_progress("{installing} {{$product}} (clamav)...", 56);
        if (!is_file("/usr/bin/clamscan")) {$unix->DEBIAN_INSTALL_PACKAGE("clamav");} else {echo "clamav OK\n";}
        build_progress("{installing} {{$product}} (clamav-daemon)...", 56);
        if (!is_file("/usr/bin/clamd")) {$unix->DEBIAN_INSTALL_PACKAGE("clamav-daemon");} else {echo "clamav-daemon OK\n";}
        build_progress("{installing} {{$product}} (ripmime)...", 56);
        if (!is_file("/usr/bin/ripmime")) {$unix->DEBIAN_INSTALL_PACKAGE("ripmime");} else {echo "ripmime OK\n";}
        build_progress("{installing} {{$product}} (spfquery)...", 56);
        if (!is_file("/usr/bin/spftest")) {$unix->DEBIAN_INSTALL_PACKAGE("spfquery");} else {echo "spfquery OK\n";}
    }

    if ($product == "APP_ELASTICSEARCH") {
        system("rm -rf /usr/share/elasticsearch/");
		system("rm -rf /usr/share/kibana/");
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("KibanaVersion", $VERSION);
    }

    if($product=="APP_NETDATA") {
        if(is_file("/etc/init.d/netdata")) {
            build_progress("{stopping} {{$product}} ($key)...", 56);
            shell_exec("/etc/init.d/netdata stop");

        }
    }

    if($product=="APP_SNMPD"){
        if(is_file("/etc/init.d/snmpd")){
            build_progress("{stopping} {{$product}} ($key)...", 56);
            shell_exec("/etc/init.d/snmpd stop");
        }
    }
    if($product=="APP_RDPPROXY") {
        build_progress("{stopping} {{$product}} ($key)...", 56);
        if (is_file("/etc/init.d/rdpproxy")) {
            shell_exec("/etc/init.d/rdpproxy stop");
        }
        if (is_file("/etc/init.d/rdpproxy-authhook")) {
            shell_exec("/etc/init.d/rdpproxy-authhook stop");
        }
    }


    if($product=="APP_MEMCACHED") {
        build_progress("{reconfiguring} {{$product}} ($key)...", 70);
        if(is_file("/etc/init.d/memcached")){
            system("/etc/init.d/memcached stop");
        }
    }

    build_progress("{uncompressing} {{$product}} ($key)...{success}", 59);

    $tmpdir=$unix->TEMP_DIR()."/$product";
    if(!is_dir($tmpdir)){@mkdir($tmpdir);}


    if(!is_dir($tmpdir)){
        echo "$tmpdir no such directory or permission denied\n";
        build_progress("{installing} {{$product}} ($key)...{failed}", 110);
        system("$nohup /etc/init.d/monit start >/dev/null 2>&1 &");
        shell_exec("/etc/init.d/artica-status start");
        return;
    }

    system("$tar xf $destfile -C $tmpdir/");
    build_progress("{uncompressing} {{$product}} ($key)...{success}", 60);

    build_progress("{installing} {{$product}} ($key)...", 65);
    $cp=$unix->find_program("cp");
    $binaries[]="usr/local/bin";
    $binaries[]="usr/local/sbin";
    $binaries[]="usr/local/lib";
    $binaries[]="usr/local/man";
    $binaries[]="usr/local/share/ntopng";
    $binaries[]="usr/local/share";
    $binaries[]="usr/lib/x86_64-linux-gnu/xtables";
    $binaries[]="usr/lib/x86_64-linux-gnu";
    $binaries[]="usr/lib";
    $binaries[]="usr/sbin";
    $binaries[]="usr/bin";
    $binaries[]="sbin";
    $binaries[]="bin";
    $binaries[]="lib/modules/4.19.0-6-amd64/extra";
    $binaries[]="lib/modules/4.19.0-6-amd64";
    $binaries[]="lib/modules";
    $binaries[]="lib/squid3";
    $binaries[]="lib";
    $binaries[]="usr/share/squid3";
    $binaries[]="etc/squid3";

    foreach ($binaries as $directory){
        $srcdir="$tmpdir/$directory";
        $destdir="/$directory";

        if(!is_dir($srcdir)){continue;}
        build_progress("{installing} {$destdir}...", 66);
        if(!is_dir($destdir)){@mkdir($destdir,0755,true);}
        echo "Copy files $srcdir to $destdir/\n";
        shell_exec("$cp -rfd $srcdir/* $destdir/");
        shell_exec("$rm -rf $srcdir");
    }

    shell_exec("$cp -rfvd $tmpdir/* /");
    build_progress("{removing} {$tmpdir}...", 67);
    echo "Removing $tmpdir\n";
    shell_exec("$rm -rf $tmpdir");



    $ldconfig = $unix->find_program("ldconfig");
    system("$ldconfig -v");

    if ($product == "APP_XTABLES"){
        $depmod=$unix->find_program("depmod");
        build_progress("{running} {$depmod}...", 68);
        system("$depmod -a");
    }

    if($product=="APP_NDPI"){
        build_progress("{running} {$depmod}...", 68);
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("nDPIEmergency",0);
        if(is_file("/etc/init.d/nDPI")){
            shell_exec("/etc/init.d/nDPI restart");
        }
        build_progress("{running} [OK]...", 68);
    }
    if($product=="APP_KASPERSKY_UPDATE_UTILITY"){
        $ln=$unix->find_program("ln");
        if(!is_file("/usr/lib/x86_64-linux-gnu/libQt5Widgets.so.5")) {
            build_progress("{installing} libqt5widgets5...", 68);
            $unix->DEBIAN_INSTALL_PACKAGE("libqt5widgets5");
        }
        if(!is_file("/usr/lib/x86_64-linux-gnu/libQt5Xml.so.5")) {
            build_progress("{installing} libqt5xml5...", 68);
            $unix->DEBIAN_INSTALL_PACKAGE("libqt5xml5");
        }

        if(!is_file("/lib/x86_64-linux-gnu/libssp.so.0")){
            if(is_file("/home/kuu3/libssp.so.0")){
                shell_exec("$ln -sf /home/kuu3/libssp.so.0 /lib/x86_64-linux-gnu/libssp.so.0");
            }
        }

    }



    if ($product == "APP_ELASTICSEARCH" && substr($VERSION, 0, strlen('6.6')) <= '6.6') {
        system("/usr/share/elasticsearch/bin/elasticsearch-plugin install ingest-geoip --batch");
    }

    if ($product == "APP_ELASTICSEARCH") {
        $EnableElasticSearch=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableElasticSearch"));
        if($EnableElasticSearch==1) {
            build_progress("{installing} {{$product}} ($key)...", 68);
            build_progress("{reconfiguring} {{$product}} ($key)...", 69);
            if (is_file("/etc/init.d/elasticsearch")) {
                system("$php /usr/share/artica-postfix/exec.elastic.search.php --monit");
            }
            build_progress("{reconfiguring} {{$product}} ($key)...", 70);
            if (is_file("/etc/init.d/elasticsearch")) {
                system("$php /usr/share/artica-postfix/exec.elastic.search.php --build");
            }
            if (is_file("/etc/init.d/elasticsearch")) {
                system("/etc/init.d/elasticsearch start");
            }
            build_progress("{reconfiguring} {{$product}} ($key)...", 71);
            if (is_file("/etc/init.d/kibana")) {
                system("$php /usr/share/artica-postfix/exec.kibana.php --monit");
            }
            if (is_file("/etc/init.d/kibana")) {
                system("$php /usr/share/artica-postfix/exec.kibana.php --build");
            }
            if (is_file("/etc/init.d/kibana")) {
                system("$php /usr/share/artica-postfix/exec.kibana.php --create_service");
            }
            build_progress("{reconfiguring} {{$product}} ($key)...", 72);
            if (is_file("/etc/init.d/kibana")) {
                system("/etc/init.d/kibana start");
            }
            if (substr($CurrentVer, 0, strlen('6.7')) < '6.7' && substr($VERSION, 0, strlen('7.0')) >= '7.0') {
                //FULL UPGRADE START
                build_progress("{do_full_upgrade_start} {{$product}} ($key)...", 75);
                $el->FullUpgradeStart_Step1();
            }
            if ((substr($CurrentVer, 0, strlen('6.7')) >= '6.7' && substr($VERSION, 0, strlen('7.0')) >= '7.0') || (substr($CurrentVer, 0, strlen('6.7')) < '6.7' && substr($VERSION, 0, strlen('6.7')) == '6.7')) {
                //ROLLING UPGRADE START
                build_progress("{do_rolling_upgrade_start} {{$product}} ($key)...", 90);
                $el->RollingUpgradeStart_Step1();
            }
        }
        system("$php /usr/share/artica-postfix/exec.squid.interface-size.php --version");
        build_progress("{restarting} Artica status...", 95);
        system("$nohup $php /usr/share/artica-postfix/exec.status.php --process1 >/dev/null 2>&1 &");
        system("/etc/init.d/artica-status restart --force >/dev/null");
        build_progress("{success} {{$product}} ($key)...", 100);
        sleep(3);
        $nohup=$unix->find_program("nohup");
        system("$nohup /etc/init.d/artica-phpfpm restart >/dev/null 2>&1");
        system("$nohup /etc/init.d/monit start >/dev/null 2>&1 &");
        return true;
    }

    if($product=="APP_PHP_GEOIP2"){
        build_progress("{reconfiguring} {{$product}} ($key)...", 70);
        shell_exec("$php /usr/share/artica-postfix/exec.php.ini.php");
        build_progress("{reconfiguring} {{$product}} ($key)...", 71);
        if(is_file("/etc/init.d/artica-status")){system("/etc/init.d/artica-status restart");}
        system("$php /usr/share/artica-postfix/exec.squid.interface-size.php --version");
        system("$nohup $php /usr/share/artica-postfix/exec.status.php --process1 >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/artica-status restart --force >/dev/null 2>&1 &");
        build_progress("{success} {{$product}} ($key)...", 100);
        sleep(3);
        $nohup=$unix->find_program("nohup");
        system("$nohup /etc/init.d/artica-phpfpm restart >/dev/null 2>&1");
        system("$nohup /etc/init.d/monit start >/dev/null 2>&1 &");
        shell_exec("/etc/init.d/artica-status start");
        return true;

    }
    if($product=="APP_NGINX") {
        build_progress("{reconfiguring} {{$product}} ($key)...", 70);
        shell_exec("$php /usr/share/artica-postfix/exec.nginx.php --dump-modules");
        build_progress("{reconfiguring} {{$product}} ($key)...", 71);
        if(is_file("/etc/init.d/nginx")){system("/etc/init.d/nginx restart");}
        system("$php /usr/share/artica-postfix/exec.squid.interface-size.php --version");
        system("$nohup $php /usr/share/artica-postfix/exec.status.php --process1 >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/artica-status restart --force >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/monit start >/dev/null 2>&1 &");
        build_progress("{success} {{$product}} ($key)...", 100);
        return true;
    }


    if($product=="APP_MEMCACHED") {
        build_progress("{reconfiguring} {{$product}} ($key)...", 70);
        if(is_file("/etc/init.d/memcached")){system("/etc/init.d/memcached restart");}
        system("$php /usr/share/artica-postfix/exec.squid.interface-size.php --version");
        system("$nohup $php /usr/share/artica-postfix/exec.status.php --process1 >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/artica-status restart --force >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/monit start >/dev/null 2>&1 &");
        build_progress("{success} {{$product}} ($key)...", 100);
        return true;
    }
    if($product=="APP_HAPROXY") {
        build_progress("{reconfiguring} {{$product}} ($key)...", 70);
        if(is_file("/etc/init.d/haproxy")){system("/etc/init.d/haproxy restart");}
        build_progress("{reconfiguring} {{$product}} ($key)...", 71);
        if(is_file("/etc/init.d/hacluster")){system("/etc/init.d/hacluster restart");}
        system("$php /usr/share/artica-postfix/exec.squid.interface-size.php --version");
        system("$nohup $php /usr/share/artica-postfix/exec.status.php --process1 >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/artica-status restart --force >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/monit start >/dev/null 2>&1 &");
        build_progress("{success} {{$product}} ($key)...", 100);
        return true;
    }




    if($product=="APP_UFDBGUARDD"){
        build_progress("{reconfiguring} {{$product}} ($key)...", 70);
        if(is_file("/etc/init.d/ufdbcat")){
            system("/etc/init.d/ufdbcat restart");
        }
        build_progress("{reconfiguring} {{$product}} ($key)...", 71);
        if(is_file("/etc/init.d/ufdb")){
            system("/etc/init.d/ufdb restart");
        }
        build_progress("{reconfiguring} {{$product}} ($key)...", 72);
        if(is_file("/etc/init.d/dnsfilterd")){
            system("/etc/init.d/dnsfilterd restart");
        }

        system("$php /usr/share/artica-postfix/exec.squid.interface-size.php --version");
        system("$nohup $php /usr/share/artica-postfix/exec.status.php --process1 >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/artica-status restart --force >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/monit start >/dev/null 2>&1 &");
        build_progress("{success} {{$product}} ($key)...", 100);
        return true;

    }


    if ($product == "APP_SQUID") {
        if(is_file("/etc/init.d/squid")) {
            build_progress("{reconfiguring} {{$product}} ($key)...", 70);
            if (is_file("/root/squid-good.tgz")) {
                shell_exec("/bin/tar -xf /root/squid-good.tgz -C /etc/squid3/");
            } else {
                system("$php /usr/share/artica-postfix/exec.squid.global.access.php");
            }
            build_progress("{restarting} {{$product}} ($key)...", 75);
            system("/etc/init.d/squid restart");
        }
        system("$php /usr/share/artica-postfix/exec.squid.interface-size.php --version");
        system("$nohup $php /usr/share/artica-postfix/exec.status.php --process1 >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/artica-status restart --force >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/monit start >/dev/null 2>&1 &");
        build_progress("{success} {{$product}} ($key)...", 100);
        return true;
    }

    if ($product == "APP_POSTFIX") {
        build_progress("{reconfiguring} {{$product}} ($key)...", 75);
        build_progress("{restore} {{$product}} ($key)...", 76);
        system("$tar -xf /root/postfix-backup.tar.gz -C /etc/postfix/");
        if (is_file("/etc/init.d/postfix")) {
            build_progress("{restarting} {{$product}} ($key)...", 77);
            system("/etc/init.d/postfix stop");
            system("/etc/init.d/postfix start");
        }
        system("$php /usr/share/artica-postfix/exec.squid.interface-size.php --version");
        system("$nohup $php /usr/share/artica-postfix/exec.status.php --process1 >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/artica-status restart --force >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/monit start >/dev/null 2>&1 &");
        build_progress("{success} {{$product}} ($key)...", 100);
        return true;
    }

    if ($product == "APP_UNBOUND") {
        build_progress("{reconfiguring} {{$product}} ($key)...", 75);
        if (!is_file("/etc/init.d/unbound")) {
            system("$nohup $php /usr/share/artica-postfix/exec.unbound.php --install >/dev/null 2>&1 &");
        } else {
            system("/etc/init.d/unbound restart");
        }
        system("$php /usr/share/artica-postfix/exec.squid.interface-size.php --version");
        system("$nohup $php /usr/share/artica-postfix/exec.status.php --process1 >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/artica-status restart --force >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/monit start >/dev/null 2>&1 &");
        build_progress("{success} {{$product}} ($key)...", 100);
        return true;
    }

    if($product=="APP_SNMPD"){
        build_progress("{reconfiguring} {{$product}} ($key)...", 75);
        if(is_file("/etc/init.d/snmpd")){
            shell_exec("/etc/init.d/snmpd start");
        }
        system("$php /usr/share/artica-postfix/exec.squid.interface-size.php --version");
        system("$nohup $php /usr/share/artica-postfix/exec.status.php --process1 >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/artica-status restart --force >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/monit start >/dev/null 2>&1 &");
        build_progress("{success} {{$product}} ($key)...", 100);
    }

    if($product=="APP_RDPPROXY"){
        build_progress("{reconfiguring} {{$product}} ($key)...", 75);
        if(is_file("/etc/init.d/rdpproxy")){
            shell_exec("/etc/init.d/rdpproxy start");
        }
        if(is_file("/etc/init.d/rdpproxy-authhook")){
            shell_exec("/etc/init.d/rdpproxy-authhook start");
        }
        system("$php /usr/share/artica-postfix/exec.squid.interface-size.php --version");
        system("$nohup $php /usr/share/artica-postfix/exec.status.php --process1 >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/artica-status restart --force >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/monit start >/dev/null 2>&1 &");
        build_progress("{success} {{$product}} ($key)...", 100);
    }

    if ($product == "APP_PDNS") {
        if (is_file("/etc/init.d/pdns")) {
            build_progress("{reconfiguring} {{$product}} ($key)...", 75);
            system("/etc/init.d/pdns restart");
        }
        if (is_file("/etc/init.d/pdns-recursor")) {
            build_progress("{reconfiguring} {{$product}} ($key)...", 80);
            system("/etc/init.d/pdns-recursor restart");
        }
        system("$php /usr/share/artica-postfix/exec.squid.interface-size.php --version");
        system("$nohup $php /usr/share/artica-postfix/exec.status.php --process1 >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/artica-status restart --force >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/monit start >/dev/null 2>&1 &");
        build_progress("{success} {{$product}} ($key)...", 100);
        return true;

    }

    if ($product == "APP_DHCP") {
        if (is_file("/etc/init.d/isc-dhcp-server")) {
            build_progress("{reconfiguring} {{$product}} ($key)...", 70);
            system("/etc/init.d/isc-dhcp-server restart");
        }
        system("$php /usr/share/artica-postfix/exec.squid.interface-size.php --version");
        system("$nohup $php /usr/share/artica-postfix/exec.status.php --process1 >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/artica-status restart --force >/dev/null 2>&1 &");
        system("$nohup /etc/init.d/monit start >/dev/null 2>&1 &");
        build_progress("{success} {{$product}} ($key)...", 100);
        return true;

    }
    system("$php /usr/share/artica-postfix/exec.squid.interface-size.php --version");
    system("$nohup $php /usr/share/artica-postfix/exec.status.php --process1 >/dev/null 2>&1 &");
    system("$nohup /etc/init.d/artica-status restart --force >/dev/null 2>&1 &");
    system("$nohup /etc/init.d/monit start >/dev/null 2>&1 &");
    build_progress("{success}...", 100);

    if($RESTART_CONSOLE){
        sleep(3);
        $nohup=$unix->find_program("nohup");
        system("$nohup /etc/init.d/artica-phpfpm restart >/dev/null 2>&1");
    }
}

function build_progress($text, $pourc)
{
    echo "[{$pourc}%] $text\n";
    $array["POURC"] = $pourc;
    $array["TEXT"] = $text;
    @file_put_contents($GLOBALS["PROGRESS_FILE"], serialize($array));
    @chmod($GLOBALS["PROGRESS_FILE"], 0755);
    $info = 2;
    if ($pourc > 100) {$info = 0;}
    $sock = new sockets();
    $EnableArticaMetaClient = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableArticaMetaClient"));
    if ($EnableArticaMetaClient == 0) {return;}
    squid_admin_mysql($info, "{$pourc}%: $text", null, __FILE__, __LINE__);
    if ($pourc == 100) {
        $unix = new unix();
        $php = $unix->LOCATE_PHP5_BIN();
        $nohup = $unix->find_program("nohup");
        system("$php /usr/share/artica-postfix/exec.artica-meta-client.php --ping --force >/dev/null 2>&1 &");
    }
}
function download_progress($client, $download_size, $downloaded, $upload_size, $uploaded)
{
    if ($download_size === 0) {return;}
    $percent = floor($downloaded * 100 / $download_size);
    if ($GLOBALS["PERCENT"][$download_size] == $percent) {return;}
    $GLOBALS["PERCENT"][$download_size] = $percent;
    $percent2 = $percent;
    if ($percent < 15) {$percent2 = 15;}
    if ($percent > 60) {$percent2 = 60;}
    build_progress("{downloading} {$percent}%", $percent2);
}
