<?php
$GLOBALS["HaClusterClient"]=0;
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;$GLOBALS["OUTPUT"]=true;$GLOBALS["debug"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}

if(preg_match("#--hacluster#",implode(" ",$argv))){$GLOBALS["HaClusterClient"]=1;}

include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__)."/framework/frame.class.inc");
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.system.network.inc');
include_once(dirname(__FILE__).'/ressources/class.samba.kerb.inc');
include_once(dirname(__FILE__).'/ressources/class.tcpip.inc');
include_once(dirname(__FILE__).'/ressources/class.users.menus.inc');
include_once(dirname(__FILE__)."/framework/class.settings.inc");
include_once(dirname(__FILE__).'/ressources/class.ActiveDirectoryRootDSE.inc');

if($argv[1]=="--klist"){print_r(klist());exit;}
if($argv[1]=="--install"){install($argv[2]);exit;}
if($argv[1]=="--uninstall"){uninstall();exit;}

function build_progress($pourc,$text){
	$echotext=$text;
    hacluster_syslog($text);
	echo "Starting......: ".date("H:i:s")." {$pourc}% $echotext\n";
	$cachefile="/usr/share/artica-postfix/ressources/logs/web/ActiveDirectoryFeature.progress";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($cachefile, serialize($array));
	@chmod($cachefile,0755);
}
function hacluster_syslog($text){
    if($GLOBALS["HaClusterClient"]==0){return;}
    if(!function_exists("syslog")){return;}
    $LOG_SEV=LOG_INFO;
    openlog("hacluster-client", LOG_PID , LOG_SYSLOG);
    syslog($LOG_SEV, "$text");
    closelog();

}

function install($filename=null){
	$unix=new unix();
	$filename=trim($filename);
	if($filename=="--hacluster"){$filename=null;$GLOBALS["HaClusterClient"]=1;}
    if($filename=="--verbose"){$filename=null;}
	$php=$unix->LOCATE_PHP5_BIN();
	if(!isset($GLOBALS["HaClusterClient"])) {
        $GLOBALS["HaClusterClient"] = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterClient"));
    }

	if($GLOBALS["HaClusterClient"]==1){
        hacluster_syslog("[KEYTAB]: Working in HaCluster mode...");
    }

    $newpath = "/etc/squid3/krb5.keytab";
    $keypath = "/usr/share/artica-postfix/ressources/conf/upload/$filename";

	if(!is_dir("/etc/squid3")){@mkdir("/etc/squid3",0755,true);}
    if($GLOBALS["HaClusterClient"]==0) {
        if ($filename <> null) {
            if (!is_file($keypath)) {
                if (is_file($newpath)) {
                    @copy($newpath, $keypath);
                    $filename = basename($newpath);
                }
            }
        }
    }
    if($GLOBALS["HaClusterClient"]==0) {
        $UseNativeKerberosAuth = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UseNativeKerberosAuth"));
        if ($UseNativeKerberosAuth == 0) {
            if ($filename == null) {
                $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EXEC_KEYTAB_ERROR", 1);
                $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EXEC_KEYTAB_ERROR_TEXT", "{installing} {failed} {missing} {file}: krb5.keytab");
                build_progress(110, "[KEYTAB]: {installing} {failed} {missing} {file}: krb5.keytab");
                return;
            }
        }
    }

    if($filename<>null) {
        $keypath = "/usr/share/artica-postfix/ressources/conf/upload/$filename";


        if (!is_file($keypath)) {
            build_progress(110, "[KEYTAB]: {installing} {failed} {missing} $filename");
            return;
        }


        if (is_file($newpath)) {
            @unlink($newpath);
        }
        if (!@copy($keypath, $newpath)) {
            @unlink($keypath);
            build_progress(110, "[KEYTAB]: {installing} {failed} {unable_to_copy} $filename");
            return;
        }
        @unlink($keypath);
    }

    if(!is_file("/etc/squid3/krb5.keytab")){
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EXEC_KEYTAB_ERROR",1);
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EXEC_KEYTAB_ERROR_TEXT","[KEYTAB]: {installing} {failed} {missing} /etc/squid3/krb5.keytab");
        build_progress(110, "[KEYTAB]: {installing} {failed} {missing} /etc/squid3/krb5.keytab");
        return;
    }


	build_progress(10, "{installing}");

    $kinit=$unix->find_program("kinit");
    $KerberosUsername=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("KerberosUsername");
    $kerberosRealm=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("kerberosRealm");
    $kerberosRealmLower=strtolower($kerberosRealm);
    $KerberosSPN=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("KerberosSPN");
    $KerberosPassword=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("KerberosPassword");
    $kerberosActiveDirectoryHost=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("kerberosActiveDirectoryHost");
    $kerberosActiveDirectory2Host=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("kerberosActiveDirectory2Host");


    $f[]="[logging]";
    $f[]="";
    $f[]="default = FILE:/var/log/krb5libs.log";
    $f[]="kdc = FILE:/var/log/krb5kdc.log";
    $f[]="admin_server = FILE:/var/log/kadmind.log";
    $f[]="";
    $f[]="[libdefaults]";
    $f[]="\tticket_lifetime = 24000";
    $f[]="\trenewable = true";
    $f[]="\tdefault_realm = $kerberosRealm";
    $f[]="\tdefault_keytab_name = /etc/squid3/krb5.keytab";
    $f[]="\tdefault_tgs_enctypes = rc4-hmac des3-hmac-sha1";
    $f[]="\tdefault_tkt_enctypes = rc4-hmac des3-hmac-sha1";
    $f[]="";
    $f[]="[realms]";
    $f[]="\t$kerberosRealm = {";
    $f[]="\t\tkdc = $kerberosActiveDirectoryHost";
    if($kerberosActiveDirectory2Host<>null){
        $f[]="\t\tkdc = $kerberosActiveDirectory2Host";
    }
    $f[]="\t\tadmin_server = $kerberosActiveDirectoryHost";
    $f[]="\t\tdefault_domain = $kerberosRealmLower";
    $f[]=" }";
    $f[]="";
    $f[]="[domain_realm]";
    $f[]="\t.$kerberosRealmLower = $kerberosRealm";
    $f[]="\t$kerberosRealmLower = $kerberosRealm";
    $f[]="";
    $f[]="[pam]";
    $f[]="\tdebug = false";
    $f[]="\tticket_lifetime = 36000";
    $f[]="\trenew_lifetime = 36000";
    $f[]="\tforwardable = true";
    $f[]="\tkrb4_convert = false";
    $f[]="";
    hacluster_syslog("[KEYTAB]: /etc/krb5.conf done");
    @file_put_contents("/etc/krb5.conf",@implode("\n",$f));
    $AUTH=false;
    $tmpfile=$unix->FILE_TEMP();
   // $password=$unix->shellEscapeChars($KerberosPassword);
    $cmd="$kinit \"$KerberosSPN\" -k -t \"/etc/squid3/krb5.keytab\" >$tmpfile 2>&1";
    echo "$cmd\n";
    build_progress(20,"[KEYTAB]: {kerberaus_authentication}");
    system($cmd);
    $res=explode("\n",@file_get_contents($tmpfile));
    @unlink($tmpfile);

    foreach ($res as $line){
        $line=trim($line);
        if($line==null){continue;}
        hacluster_syslog("[KEYTAB]: $line");
        echo $line."\n";
    }

    $tmpfile=$unix->FILE_TEMP();
    $cmd="$kinit \"$KerberosSPN\" -V -v -k -t \"/etc/squid3/krb5.keytab\" >$tmpfile 2>&1";
    echo "$cmd\n";
    build_progress(30,"[KEYTAB]: {kerberaus_authentication}");
    system($cmd);

   $res=explode("\n",@file_get_contents($tmpfile));
   @unlink($tmpfile);

    foreach ($res as $line){
        $line=trim($line);
        if($line==null){continue;}
        hacluster_syslog("[KEYTAB]: $line");
        if(preg_match("#Authenticated to Kerberos#i",$line)){
            $AUTH=true;
            echo "Success, see above\n";
        }

        if(preg_match("#Unsupported key table format#i",$line)){
            build_progress(110, "[KEYTAB]: {failed}");
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EXEC_KEYTAB_ERROR",1);
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EXEC_KEYTAB_ERROR_TEXT","Unsupported key table format");
            return;
        }

        echo $line."\n";
    }


    if(!$AUTH) {
        build_progress(110, "[KEYTAB]: {failed}");
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EXEC_KEYTAB_ERROR",1);
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EXEC_KEYTAB_ERROR_TEXT",@implode("<br>",$res));
        return;
    }

    $myhostname=$unix->hostname_g();
    $tmpfile=$unix->FILE_TEMP();
    $cmd="/lib/squid3/negotiate_kerberos_auth_test $myhostname >$tmpfile 2>&1";
    echo "$cmd\n";
    build_progress(70,"{kerberaus_authentication}");
    system($cmd);
    $res=array();
    foreach ($res as $line){
        $line=trim($line);
        if($line==null){continue;}
        hacluster_syslog("[KEYTAB]: $line");
        if(preg_match("#Token:\s+(.+)#i",$line)){
            hacluster_syslog("[KEYTAB]: Token {success}");
            echo "Success, Token receive..\n";
            break;
        }
        if(preg_match("#Unsupported key table format#i",$line)){
            build_progress(110, "[KEYTAB]: {failed} Unsupported key table format");
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EXEC_KEYTAB_ERROR",1);
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EXEC_KEYTAB_ERROR_TEXT","Unsupported key table format");
            return;
        }

        if(preg_match("#(failed|failure)#",$line)){
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EXEC_KEYTAB_ERROR",1);
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EXEC_KEYTAB_ERROR_TEXT",@implode("<br>",$res));
            echo "$line\n";
            build_progress(110,"[KEYTAB]: {failed} $line");
            return;
        }

    }

    $ad_rootdse=new ad_rootdse($kerberosActiveDirectoryHost,389,$KerberosUsername,$KerberosPassword);

    $TR=explode(".",$kerberosActiveDirectoryHost);
    $TD=explode("@",$KerberosUsername);
    $KerbAuthInfos["LDAP_PORT"]=389;
    $KerbAuthInfos["LDAP_SUFFIX"]=$ad_rootdse->RootDSE();
    $KerbAuthInfos["LDAP_SERVER"]=$kerberosActiveDirectoryHost;
    $KerbAuthInfos["LDAP_DN"]=$KerberosUsername;
    $KerbAuthInfos["LDAP_PASSWORD"]=$KerberosPassword;
    $KerbAuthInfos["ADNETIPADDR"]=gethostbyname($kerberosActiveDirectoryHost);
    $KerbAuthInfos["WINDOWS_SERVER_NETBIOSNAME"]=$TR[0];
    $KerbAuthInfos["WINDOWS_DNS_SUFFIX"]=$TD[1];
    $KerbAuthInfos["COMPUTER_BRANCH"]="CN=Computers";
    $KerbAuthInfos["WINDOWS_SERVER_PASS"]=$KerberosPassword;
    $KerbAuthInfos["WINDOWS_SERVER_ADMIN"]=$TD[0];





    $data=base64_encode(serialize($KerbAuthInfos));
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("KerbAuthInfos",$data);

    build_progress(80, "[KEYTAB]: {reconfiguring}");
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("UseNativeKerberosAuth",1);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableKerbAuth",1);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableKerbNTLM",0);
    $unix->Popuplate_cron_make("kerb-klist","*/20 * * * *",basename(__FILE__)." --klist");
    klist();

    $SQUIDEnable=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable");
    if($SQUIDEnable==1){
        build_progress(85, "[KEYTAB]: {reconfiguring}");
        system("$php /usr/share/artica-postfix/exec.squid.global.access.php --auth");
        $unix->Popuplate_cron_make("squid-negotiateauthenticator-5mn","*/5 * * * *","exec.negotiateauthenticator.php");
    }


    //
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EXEC_KEYTAB_ERROR",0);
    build_progress(100, "[KEYTAB]: {success}");
    cluster_mode();
    return true;

}

function klist(){
    $LockActiveDirectoryToKerberos=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LockActiveDirectoryToKerberos"));
    if($LockActiveDirectoryToKerberos==1){return;}
    $unix = new unix();


    $klist = $unix->find_program("klist");
    $ARRAY = array();
    exec("$klist 2>&1", $results);

    foreach ($results as $line) {
        $line = trim($line);
        if ($line == null) {
            continue;
        }
        hacluster_syslog("klist: $line");
        if (preg_match("#Default principal:\s+(.+)#", $line, $re)) {
            $ARRAY["DEFAULT_PRINCPAL"] = trim($re[1]);
            continue;
        }

        if (preg_match("#([0-9:\/]+)\s+([0-9:]+)\s+([0-9:\/\s]+)\s+krbtgt\/(.+)#", $line, $re)) {
            $stime1 = $re[1] . " " . $re[2];
            $stime2 = $re[3];
            $ticket = $re[4];
            $ARRAY["START"] = strtotime($stime1);
            $ARRAY["STOP"] = strtotime($stime2);
            $ARRAY["TICKET"] = $ticket;

        }

    }
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("KerberosTicketInfo",serialize($ARRAY));
    return $ARRAY;
}

function uninstall(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
    build_progress(10, "{disconnecting}");
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("UseNativeKerberosAuth",0);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableKerbAuth",0);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("KerberosTicketInfo",serialize(array()));
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("KerberosSPN","");
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableKerbNTLM",0);
    $data=base64_encode(serialize(array()));
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("KerbAuthInfos",$data);

    $cron[]="kerb-klist";
    $cron[]="squid-negotiateauthenticator-5mn";

    foreach ($cron as $file){
        if(is_file("/etc/cron.d/$file")){@unlink("/etc/cron.d/$file");}
    }

    build_progress(20, "{disconnecting}");
    system("/etc/init.d/cron reload");

    $SQUIDEnable=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable");
    if($SQUIDEnable==1){
        build_progress(50, "{disconnecting}");
        system("$php /usr/share/artica-postfix/exec.squid.global.access.php --auth");
    }

    build_progress(80, "{disconnecting}");
	$kdestroy=$unix->find_program("kdestroy");
	system("$kdestroy -A");

	@unlink("/etc/squid3/krb5.keytab");
	@unlink("/etc/krb5.conf");


	build_progress(100, "{uninstalling} {done}");
    cluster_mode();

}


function remove_service($INITD_PATH){
	if(!is_file($INITD_PATH)){return;}
	system("$INITD_PATH stop");
	if(is_file('/usr/sbin/update-rc.d')){shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");}
	if(is_file('/sbin/chkconfig')){shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");}
	if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}