#!/usr/bin/php
<?php
if(is_file("/etc/artica-postfix/FROM_ISO")){if(is_file("/etc/init.d/artica-cd")){print "Starting......: ".date("H:i:s")." artica-". basename(__FILE__)." Waiting Artica-CD to finish\n";exit();}}
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
$GLOBALS["SLEEP"]=0;
$GLOBALS["FORCE"]=false;
$GLOBALS["RECONFIGURE"]=false;
$GLOBALS["SWAPSTATE"]=false;
$GLOBALS["MONIT"]=false;
$GLOBALS["PAUSE"]=false;
$GLOBALS["TINYPAUSE"]=false;
$GLOBALS["SERVICE_NAME"]="Artica Web console";
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;$GLOBALS["OUTPUT"]=true;$GLOBALS["debug"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
if(preg_match("#--output#",implode(" ",$argv))){$GLOBALS["OUTPUT"]=true;}
if(preg_match("#schedule-id=([0-9]+)#",implode(" ",$argv),$re)){$GLOBALS["SCHEDULE_ID"]=$re[1];}
if(preg_match("#--force#",implode(" ",$argv),$re)){$GLOBALS["FORCE"]=true;}
if(preg_match("#--reconfigure#",implode(" ",$argv),$re)){$GLOBALS["RECONFIGURE"]=true;}
if(preg_match("#--monit#",implode(" ",$argv),$re)){$GLOBALS["MONIT"]=true;}
if(preg_match("#--pause#",implode(" ",$argv),$re)){$GLOBALS["PAUSE"]=true;}
if(preg_match("#--tinypause#",implode(" ",$argv),$re)){$GLOBALS["TINYPAUSE"]=true;}
if(preg_match("#--sleep=([0-9]+)#",implode(" ",$argv),$re)){$GLOBALS["SLEEP"]=$re[1];}
$GLOBALS["AS_ROOT"]=true;
include_once(dirname(__FILE__).'/ressources/class.ldap.inc');
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.settings.inc');
include_once(dirname(__FILE__).'/ressources/class.apache.certificate.php');
include_once(dirname(__FILE__).'/ressources/class.tcpip.inc');
include_once(dirname(__FILE__).'/ressources/class.webconsole.params.inc');

	$GLOBALS["ARGVS"]=implode(" ",$argv);
	init_syslog("script started with {$GLOBALS["ARGVS"]}");
	if($argv[1]=="--stop"){$GLOBALS["OUTPUT"]=true;stop();exit();}
	if($argv[1]=="--start"){$GLOBALS["OUTPUT"]=true;start();exit();}
	if($argv[1]=="--restart"){$GLOBALS["OUTPUT"]=true;restart();exit();}
	if($argv[1]=="--reload"){$GLOBALS["OUTPUT"]=true;nginx_reload();exit();}
	if($argv[1]=="--status"){$GLOBALS["OUTPUT"]=true;status();exit();}
	if($argv[1]=="--phpmyadmin"){$GLOBALS["OUTPUT"]=true;PHP_MYADMIN();exit();}
	if($argv[1]=="--error500"){$GLOBALS["OUTPUT"]=true;islighttpd_error_500();exit();}
	if($argv[1]=="--phpcgi"){$GLOBALS["OUTPUT"]=true;phpcgi();exit();}
	if($argv[1]=="--tests"){$GLOBALS["OUTPUT"]=true;TESTS_SETTINGS();exit();}
	if($argv[1]=="--apache-build"){$GLOBALS["OUTPUT"]=true;apache_config();exit();}
	if($argv[1]=="--php-snmp"){$GLOBALS["OUTPUT"]=true;php_snmp();exit();}
	if($argv[1]=="--nginx-build"){$GLOBALS["OUTPUT"]=true;nginx_config();exit();}
	if($argv[1]=="--nginx-reload"){$GLOBALS["OUTPUT"]=true;nginx_reload();exit();}
	if($argv[1]=="--fpm-start"){$GLOBALS["OUTPUT"]=true;nginx_fpm_start();exit();}
	if($argv[1]=="--fpm-stop"){$GLOBALS["OUTPUT"]=true;nginx_fpm_stop();exit();}
	if($argv[1]=="--fpm-reload"){$GLOBALS["OUTPUT"]=true;nginx_fpm_reload();exit();}
	if($argv[1]=="--fpm-restart"){$GLOBALS["OUTPUT"]=true;nginx_fpm_restart();exit();}
	
	
	

function init_syslog($text){
	if(!function_exists("openlog")){return;}
	openlog("WebConsole", LOG_PID , LOG_SYSLOG);
	if(!function_exists("syslog")){ return;}
	syslog(true, $text);
	if(function_exists("closelog")){closelog();}
}
	

function restart($nopid=false){
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	if(!$nopid){
		$pid=$unix->get_pid_from_file($pidfile);
		if($unix->process_exists($pid,basename(__FILE__))){
			$time=$unix->PROCCESS_TIME_MIN($pid);
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Already Artica task running PID $pid since {$time}mn\n";}
			return;
		}
	}
	
	if($GLOBALS["TINYPAUSE"]){usleep(1000);}
	if($GLOBALS["PAUSE"]){sleep(5);}
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("need_to_reboot_webconsole", 0);
	@file_put_contents($pidfile, getmypid());
	stop(true);
    stop(true);
    stop(true);
	nginx_config();
    shell_exec("/etc/init.d/memcached restart");
	start(true);

}	



function nginx_reload(){
	nginx_config();
	shell_exec("/usr/local/ArticaWebConsole/sbin/artica-webconsole -c /etc/artica-postfix/webconsole.conf -s reopen");
	shell_exec("/usr/local/ArticaWebConsole/sbin/artica-webconsole -c /etc/artica-postfix/webconsole.conf -s reload");
	shell_exec("/etc/init.d/memcached restart");
}


function TESTS_SETTINGS(){
	require("/usr/share/artica-postfix/ressources/settings.inc");
	echo "OK";
}




function patchHardDrives(){
	$unix=new unix();
	
	
	$APACHE_SRC_ACCOUNT=$unix->APACHE_SRC_ACCOUNT();
	$APACHE_SRC_GROUP=$unix->APACHE_SRC_GROUP();
	
	@mkdir("/var/run/lighttpd",0755,true);
	@mkdir("/var/log/lighttpd",0755,true);
	
	@chown("/var/run/lighttpd",$APACHE_SRC_ACCOUNT);
	@chown("/var/log/lighttpd",$APACHE_SRC_ACCOUNT);
	@chgrp("/var/run/lighttpd", $APACHE_SRC_GROUP);
	@chgrp("/var/log/lighttpd", $APACHE_SRC_GROUP);
	
	
	exec("/sbin/blkid 2>&1",$results);
	
	foreach ($results as $num=>$val){
		$val=trim($val);
		if(preg_match("#^(.+?):.*?UUID=\"(.+?)\"\s+#", $val,$re)){
			$UUIDS[$re[2]]=$re[1];
		}
	
	}
	
	
	$f=explode("\n",@file_get_contents("/etc/fstab"));
	foreach ( $f as $num=>$val ){
		if(preg_match("#(.+?)\s+(.+?)\s+ext4\s+(.+?)\s+([0-9]+)\s+([0-9]+)#", $val,$re)){
			
			$dev=$re[1];
			
			if(preg_match("#UUID=(.+)#", $dev,$rz)){
				if(!isset($UUIDS[$rz[1]])){
					if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} EXT4 $dev ( Unknown )\n";}
					continue;}
				$dev=$UUIDS[$rz[1]];
			}
			
			
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} EXT4 $dev changed to dir_index,journal_data_writeback\n";}
			shell_exec("/sbin/tune2fs -o journal_data_writeback $dev");
			shell_exec("/sbin/tune2fs -O dir_index $dev");
		}
	}	
	
}


function apache_kill_ipcs(){
	$GLOBALS["CLASS_UNIX"]=new unix();
	$ipcs=$GLOBALS["CLASS_UNIX"]->find_program("ipcs");
	$ipcrm=$GLOBALS["CLASS_UNIX"]->find_program("ipcrm");
	$APACHE_SRC_ACCOUNT=$GLOBALS["CLASS_UNIX"]->APACHE_SRC_ACCOUNT();
	$APACHE_SRC_GROUP=$GLOBALS["CLASS_UNIX"]->APACHE_SRC_GROUP();
	$ipcsT=array();
	
	
if(!is_file($ipcs)){
	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} ipcs, no such binary !!!\n";}
	return;
}
$cmd="$ipcs -s 2>&1";
if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} ipcs on $APACHE_SRC_ACCOUNT\n";}
exec("$cmd",$results);
	foreach ($results as $num=>$ligne){
		if(preg_match("#[a-z0-9]+\s+([0-9]+)\s+$APACHE_SRC_ACCOUNT#", $ligne,$re)){$ipcsT[$re[1]]=true;}
	}
	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} kill ". count($ipcsT)." semaphores created by $APACHE_SRC_ACCOUNT...\n";}
	
	while (list ($id, $ligne) = each ($ipcsT) ){
		shell_exec("$ipcrm sem $id");
	}
}


function fuser_port($port){
	$unix=new unix();
	$kill=$unix->find_program("kill");
	$PIDS=$unix->PIDOF_BY_PORT($port);
	if(count($PIDS)==0){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} 0 PID listens $port...\n";}
		
		return;}
	foreach ($PIDS as $pid=>$b){
		if($unix->process_exists($pid)){
			if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} killing PID $pid that listens $port\n";}
			unix_system_kill_force($pid);
		}
	}
}

function nginx_stop($aspid=false){

	$unix=new unix();
	if(!$aspid){
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=$unix->get_pid_from_file($pidfile);
		if($unix->process_exists($pid,basename(__FILE__))){
			$time=$unix->PROCCESS_TIME_MIN($pid);
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Already Artica task running PID $pid since {$time}mn\n";}
			return;
		}
		@file_put_contents($pidfile, getmypid());
	}

	nginx_fpm_stop();
	$GLOBALS["SERVICE_NAME"]="Artica Web console (Main)";
	$pid=nginx_pid();


	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} already stopped...\n";}
		return;
	}

	$pid=nginx_pid();
	if($GLOBALS["MONIT"]){
		@file_put_contents("/var/run/artica-webconsole.pid",$pid);
		return;
	}

	$nohup=$unix->find_program("nohup");
	$php5=$unix->LOCATE_PHP5_BIN();
	$kill=$unix->find_program("kill");


    system("/usr/local/ArticaWebConsole/sbin/artica-webconsole -c /etc/artica-postfix/webconsole.conf -s stop");


	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Shutdown pid $pid...\n";}
	for($i=0;$i<5;$i++){
		$pid=nginx_pid();
		if(!$unix->process_exists($pid)){break;}
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} waiting pid:$pid $i/5...\n";}
        system("/usr/local/ArticaWebConsole/sbin/artica-webconsole -c /etc/artica-postfix/webconsole.conf -s stop");
		sleep(1);
	}

	$pid=nginx_pid();
	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} success...\n";}
		return true;
	}

	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} shutdown - force - pid $pid...\n";}
	unix_system_kill_force($pid);
	for($i=0;$i<5;$i++){
		$pid=nginx_pid();
		if(!$unix->process_exists($pid)){break;}
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} waiting pid:$pid $i/5...\n";}
        unix_system_kill_force($pid);
		sleep(1);
	}

	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} success...\n";}
		return;
	}else{
		echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} failed...\n";
	}
}
	
function stop($aspid=false){
	
nginx_stop();

}
function ngx_stream_access_module(){
    $STATUS[0]  = "deny";
    $STATUS[1]  = "allow";
    $f          = array();
    $q          = new lib_sqlite("/home/artica/SQLITE/webconsole.db");

    $sql="CREATE TABLE IF NOT EXISTS `ngx_stream_access_module` (
		`ID` INTEGER PRIMARY KEY AUTOINCREMENT,
		`zorder` INTEGER,
		`serviceid` INTEGER,
		`allow` INTEGER,
		`item` text
	)";
    $q->QUERY_SQL($sql);

    $results    = $q->QUERY_SQL("SELECT * FROM ngx_stream_access_module ORDER BY zorder");
    if(!$q->ok){return null;}

    if(count($results)==0){return null;}
    $TRCLASS=null;
    $c=0;
    foreach ($results as $md5=>$ligne){

        $pattern    = trim($ligne["item"]);
        $allow      = $ligne["allow"];
        if($pattern=="*"){$pattern="all";}
        if(strpos($pattern,"*")>1){
            echo "Configur......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} invalid pattern $pattern...\n";
            continue;

        }

        if($pattern=="all"){
            if($allow==0){
                if($c==0){continue;}
            }
        }

        $f[]="\t{$STATUS[$allow]} $pattern;";
        $c++;
    }
    return @implode("\n", $f);
}

function killallphpcgi(){
	
	$unix=new unix();
	$phpcgi=$unix->LIGHTTPD_PHP5_CGI_BIN_PATH();
	$kill=$unix->find_program("kill");
	$array=$unix->PIDOF_PATTERN_ALL($phpcgi);
	$userp=LIGHTTPD_GET_USER();
	
	if(preg_match("#^(.+?):#", $userp,$re)){$user=strtolower(trim($re[1]));}
	
	if(count($array)==0){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} No ghost processes...\n";}
		return;
	}
	$c=0;
	foreach ($array as $pid=>$line){
		$username=trim(strtolower($unix->PROCESS_GET_USER($pid)));
		if($username==null){continue;}
		if($username<>$user){continue;}
		$c++;
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Stopping ghots processes $pid\n";}
		unix_system_kill_force($pid);
	}
	
	if($c==0){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} No ghost processes...\n";}
	}
	
}

function status(){
	$unix=new unix();
	$phpcgi=$unix->LIGHTTPD_PHP5_CGI_BIN_PATH();	
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pidtime="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".time";
	$pid=$unix->get_pid_from_file($pidfile);
	$nohup=$unix->find_program("nohup");
	if($unix->process_exists($pid,basename(__FILE__))){
		$time=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Already Artica task running PID $pid since {$time}mn\n";}
		return;
	}
	
	if(!$GLOBALS["VERBOSE"]){
		$timeExec=$unix->file_time_min($pidtime);
		if($timeExec<15){return;}
	}
	@unlink($pidtime);
	@file_put_contents($pidtime, time());
	@file_put_contents($pidfile, getmypid());	
	
	$pid=LIGHTTPD_PID();
	$unix=new unix();
	if($unix->process_exists($pid)){
		$timepid=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} running $pid since {$timepid}Mn...\n";}
	}else{
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} stopped...\n";}
		start();
		return;
	}
	$MAIN_PID=$pid;
	$phpcgi=$unix->LIGHTTPD_PHP5_CGI_BIN_PATH();
	$kill=$unix->find_program("kill");
	$array=$unix->PIDOF_PATTERN_ALL($phpcgi);
	if(count($array)==0){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} no php-cgi processes...\n";}
		ToSyslog("{$GLOBALS["SERVICE_NAME"]} no php-cgi processes restarting PHP-FPM");
		shell_exec("$nohup /etc/init.d/php5-fpm restart >/dev/null 2>&1 &");
		return;
	}
	foreach ($array as $pid=>$line){
		$username=$unix->PROCESS_GET_USER($pid);
		if($username==null){continue;}
		if($username<>"root"){continue;}
		$time=$unix->PROCCESS_TIME_MIN($pid);
		$arrayPIDS[$pid]=$time;
		$ppid=$unix->PPID_OF($pid);
		if($time>20){
			if($ppid<>$MAIN_PID){
				if($GLOBALS["VERBOSE"]){echo "killing $pid {$time}mn ppid:$ppid/$MAIN_PID\n";}
				unix_system_kill_force($pid);
			}
		}
	}

	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} ".count($arrayPIDS)." php-cgi processes...\n";}
	
}

function ToSyslog($text){

	$LOG_SEV=LOG_INFO;
	if(function_exists("openlog")){openlog(basename(__FILE__), LOG_PID , LOG_SYSLOG);}
	if(function_exists("syslog")){ syslog($LOG_SEV, $text);}
	if(function_exists("closelog")){closelog();}
}

function remove_service($INITD_PATH){
    if(!is_file($INITD_PATH)){return;}
    system("$INITD_PATH stop");

    if(is_file('/usr/sbin/update-rc.d')){
        shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");
    }

    if(is_file('/sbin/chkconfig')){
        shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");

    }

    if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}



function nginx_config(){
	include_once(dirname(__FILE__)."/ressources/class.nginx.certificate.inc");

	if(is_file("/usr/sbin/php-fpm7.0")){
        @copy("/usr/sbin/php-fpm7.0", "/usr/local/ArticaWebConsole/sbin/artica-phpfpm");
    }
    if(is_file("/etc/init.d/php7.0-fpm")){
        squid_admin_mysql(1,"Removing unecessary service php7.0-fpm",null,__FILE__,__LINE__);
        remove_service("/etc/init.d/php7.0-fpm");
    }


	@chmod("/usr/local/ArticaWebConsole/sbin/artica-phpfpm",0755);

    $SocksWeb               = new SocksWeb();

    if(!is_file("/etc/artica-postfix/settings/Daemons/ArticaHttpsPort")){
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("ArticaHttpUseSSL",1);
        $SocksWeb->ReplicParams();
    }

	$unix                   = new unix();
	$php                    = $unix->LOCATE_PHP5_BIN();
	$APACHE_SRC_ACCOUNT     = "www-data";
    $ipaddr                 = null;
	$APACHE_SRC_GROUP       = "www-data";

    $EnableNginx            = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableNginx"));
    $ArticaHttpsPort        = intval($SocksWeb->GET_INFO("ArticaHttpsPort"));
    $ArticaHttpUseSSL       = intval($SocksWeb->GET_INFO("ArticaHttpUseSSL"));
    $EnableSquidMicroHotSpot= intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableSquidMicroHotSpot"));
    $LighttpdArticaListenInterface = trim($SocksWeb->GET_INFO("LighttpdArticaListenInterface"));
    $LighttpdArticaCertificateName = trim($SocksWeb->GET_INFO("LighttpdArticaCertificateName"));
    $SSLCipherSuite         = trim($SocksWeb->GET_INFO("SSLCipherSuite"));
    $LighttpdArticaDisableSSLv2 = intval($SocksWeb->GET_INFO("LighttpdArticaDisableSSLv2"));
    $AclsDynamicsWebServerName=trim(strtolower($GLOBALS["CLASS_SOCKETS"]->GET_INFO("AclsDynamicsWebServerName")));
    $FirewallWebServerName  = trim(strtolower($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FirewallWebServerName")));

	
    if($ArticaHttpUseSSL==0){
        $ARTICA_WEB_SAVED=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ARTICA_WEB_SAVED"));
        if($ARTICA_WEB_SAVED==0){
            $ArticaHttpUseSSL=1;
        }
    }



	if($ArticaHttpsPort==0){$ArticaHttpsPort=9000;}
	if($ArticaHttpsPort==443){$ArticaHttpUseSSL=1;}
	$ProxyWebServerName=trim(strtolower($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ProxyWebServerName")));
	$unix=new unix();


	

	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Certificate: $LighttpdArticaCertificateName\n";}
	
	

	if($LighttpdArticaListenInterface<>null){
		$ipaddr=$unix->InterfaceToIPv4($LighttpdArticaListenInterface);
		if($ipaddr<>null){
		    $LighttpdArticaListenIP=$ipaddr;

		}
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LighttpdArticaListenIP",$ipaddr);
		if($LighttpdArticaListenInterface=="lo"){$LighttpdArticaListenIP="127.0.0.1";}
	}

    if($LighttpdArticaListenIP==null){$LighttpdArticaListenIP="0.0.0.0";}
	
	$f=array();
	$f[]="check process APP_ARTICAWEBCONSOLE with pidfile /var/run/artica-webconsole.pid";
	$f[]="\tstart program = \"/etc/init.d/artica-webconsole start --monit\"";
	$f[]="\tstop program = \"/etc/init.d/artica-webconsole stop --monit\"";
	$f[]="\tif 5 restarts within 10 cycles then timeout";
	$f[]="";
	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring Artica Web Console...\n";}
	@file_put_contents("/etc/monit/conf.d/APP_LIGHTTPD.monitrc", @implode("\n", $f));
	
	$f=array();

	shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload >/dev/null 2>&1");
	
	@mkdir("/var/run/lighttpd",0755,true);
	@mkdir("/var/log/lighttpd",0755,true);
	
	@chown("/var/run/lighttpd",$APACHE_SRC_ACCOUNT);
	@chown("/var/log/lighttpd",$APACHE_SRC_ACCOUNT);
	@chgrp("/var/run/lighttpd", $APACHE_SRC_GROUP);
	@chgrp("/var/log/lighttpd", $APACHE_SRC_GROUP);

	if(is_file("/var/log/lighttpd/apache-error.log")){
        @chown("/var/log/lighttpd/apache-error.log",$APACHE_SRC_ACCOUNT);
        @chgrp("/var/log/lighttpd/apache-error.log", $APACHE_SRC_GROUP);
    }

    if(is_file("/var/log/artica-web.log")){
        @chown("/var/log/artica-web.log",$APACHE_SRC_ACCOUNT);
        @chgrp("/var/log/artica-web.log", $APACHE_SRC_GROUP);
    }

	system("$php /usr/share/artica-postfix/exec.php.ini.php");
	
	$f[]="[global]";
	$f[]="pid = /var/run/artica-phpfpm.pid";
	$f[]="error_log = syslog";
	$f[]="syslog.facility = daemon";
	$f[]="syslog.ident = artica-phpfpm";
	$f[]="log_level = notice";
	$f[]=";emergency_restart_threshold = 0";
	$f[]=";emergency_restart_interval = 0";
	$f[]=";process_control_timeout = 0";
	$f[]="; process.max = 128";
	$f[]="process.priority = 10";
	$f[]="daemonize = yes";
	$f[]="rlimit_files = 1024";
	$f[]=";rlimit_core = 0";
	$f[]=";events.mechanism = epoll";
	$f[]=";systemd_interval = 10";
	$f[]="";
	$f[]="";
	$f[]="";
	$f[]="[artica_console]";
	$f[]="user = www-data";
	$f[]="group = www-data";
	$f[]="listen = /var/run/artica-phpfpm.sock";
	$f[]="listen.owner = www-data";
	$f[]="listen.group = www-data";
	$f[]="pm = ondemand";
	$f[]="pm.max_children = 35";
	$f[]="pm.start_servers = 2";
	$f[]="pm.min_spare_servers = 1";
	$f[]="pm.max_spare_servers = 3";
	$f[]="pm.process_idle_timeout = 10s;";
	$f[]="pm.max_requests = 500";
	$f[]="pm.status_path = /fpm.status.php";
	$f[]=";chdir = /usr/share/artica-postfix";
	$f[]=";catch_workers_output = yes";
	$f[]=";clear_env = no";
	$f[]="";
	$f[]=";env[HOSTNAME] = \$HOSTNAME";
	$f[]=";env[PATH] = /usr/local/bin:/usr/bin:/bin";
	$f[]=";env[TMP] = /tmp";
	$f[]=";env[TMPDIR] = /tmp";
	$f[]=";env[TEMP] = /tmp";
	$f[]="";
	$f[]="[framework]";
	$f[]="user = root";
	$f[]="group = root";
	$f[]="listen = /var/run/php-fpm-framework.sock";
	$f[]="listen.mode = 0777";
	$f[]=";listen.allowed_clients = 127.0.0.1";
	$f[]="pm = dynamic";
    $f[]="catch_workers_output = yes";
	$f[]="pm.max_children = 30";
	$f[]="pm.start_servers = 2";
	$f[]="pm.min_spare_servers = 1";
	$f[]="pm.max_spare_servers = 15";
	$f[]="pm.process_idle_timeout = 120s;";
	$f[]="pm.max_requests = 300";
	$f[]="pm.status_path = /fpm.status.php";
	$f[]="request_terminate_timeout = 605";
	$f[]="ping.path = /php-fpm-ping";
	$f[]=";ping.response = pong";
	$f[]="php_flag[display_errors] = on";
	$f[]="php_admin_value[error_log] = /var/log/php.log";
	$f[]="php_admin_flag[log_errors] = on";
	$f[]="chdir = /";
	$f[]="";
	$f[]="";
	

	echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Nginx Enabled = $EnableNginx\n";
	if($EnableNginx==1){
		$f[]="[phpsites]";
		$f[]="user = www-data";
		$f[]="group = www-data";
		$f[]="listen = /var/run/nginx-phpfpm.sock";
		$f[]="listen.owner = www-data";
		$f[]="listen.group = www-data";
		$f[]="pm = dynamic";
		$f[]="pm.max_children = 35";
		$f[]="pm.start_servers = 2";
		$f[]="pm.min_spare_servers = 1";
		$f[]="pm.max_spare_servers = 10";
		$f[]="pm.process_idle_timeout = 10s;";
		$f[]="pm.max_requests = 500";
		$f[]="chdir = /";
		//$f[]="#chroot = /home/wordpress_sites/";
        $f[]="security.limit_extensions =";
        $f[]="php_value[file_uploads] = \"On\"";
        $f[]="php_value[allow_url_fopen] = \"On\"";
        $f[]="php_value[memory_limit] = \"2000M\"";
        $f[]="php_value[upload_max_filesize] = \"512M\"";
        $f[]="php_value[cgi.fix_pathinfo] = \"1\"";
        $f[]="php_value[session.gc_probability]  = \"1\"";
        $f[]="php_value[session.save_handler]  = \"file\"";
        $f[]="php_value[session.save_path]  = \"/var/lib/php5\"";
		$f[]=";catch_workers_output = yes";
		$f[]=";clear_env = no";
        $f[]="php_flag[display_errors] = on";
        //$f[]="php_admin_value[open_basedir] = \"/home/wordpress_sites:/var/lighttpd/upload\"";
        $f[]="php_admin_value[error_log] = /var/log/apache2/php.log";
        $f[]="php_admin_flag[log_errors] = on";
		$f[]="";



		$f[]="[artica_php]";
        $f[]="user = www-data";
        $f[]="group = www-data";
        $f[]="listen = /var/run/phpfpm-articaserv.sock";
        $f[]="listen.owner = www-data";
        $f[]="listen.group = www-data";
        $f[]="pm = dynamic";
        $f[]="pm.max_children = 35";
        $f[]="pm.start_servers = 2";
        $f[]="pm.min_spare_servers = 1";
        $f[]="pm.max_spare_servers = 10";
        $f[]="pm.process_idle_timeout = 10s;";
        $f[]="pm.max_requests = 500";
        $f[]="chdir = /";
        $f[]="security.limit_extensions =";
            $f[]="php_value[file_uploads] = \"On\"";
            $f[]="php_value[allow_url_fopen] = \"On\"";
            $f[]="php_value[memory_limit] = \"2000M\"";
            $f[]="php_value[upload_max_filesize] = \"512M\"";
            $f[]="php_value[cgi.fix_pathinfo] = \"1\"";
            $f[]="php_value[session.gc_probability]  = \"1\"";
            $f[]="php_value[session.save_handler]  = \"file\"";
            $f[]="php_value[session.save_path]  = \"/var/lib/php5\"";
            $f[]=";catch_workers_output = yes";
            $f[]=";clear_env = no";
            $f[]="php_flag[display_errors] = on";
            $f[]="php_admin_value[error_log] = /var/log/php.log";
            $f[]="php_admin_flag[log_errors] = on";
            $f[]="";



		if($EnableSquidMicroHotSpot==1){
			echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} PHP-FPM: Enable PHP HotSpot service\n";
			$f[]="[squid_php]";
			$f[]="user = squid";
			$f[]="group = squid";
			$f[]="listen = /var/run/nginx-squid.sock";
			$f[]="listen.owner = www-data";
			$f[]="listen.group = www-data";
			$f[]="pm = dynamic";
			$f[]="pm.max_children = 35";
			$f[]="pm.start_servers = 2";
			$f[]="pm.min_spare_servers = 1";
			$f[]="pm.max_spare_servers = 10";
			$f[]="pm.process_idle_timeout = 10s;";
			$f[]="pm.max_requests = 500";
			$f[]=";chdir = /usr/share/artica-postfix";
			$f[]=";catch_workers_output = yes";
			$f[]=";clear_env = no";
			$f[]="php_value[session.gc_probability]  = \"1\"";
			$f[]="php_value[session.save_handler]  = \"memcached\"";
			$f[]="php_value[session.save_path]  = \"/var/run/memcached.sock\"";
			
		}
	}
	
	
	$f[]="";
	$EnableRichFileManager=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableRichFileManager"));
	$EnableXapianSearch=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableXapianSearch"));
	$f[]=";EnableRichFileManager = $EnableRichFileManager";
	$f[]=";EnableXapianSearch    = $EnableXapianSearch";
	
	if($EnableRichFileManager==1){
		$f[]="[RICHFILEMANAGER]";
		$f[]="user = root";
		$f[]="group = root";
		$f[]="listen = /var/run/RichFilemanager.sock";
		$f[]="listen.owner = www-data";
		$f[]="listen.group = www-data";
		$f[]="pm = dynamic";
		$f[]="pm.max_children = 5";
		$f[]="pm.start_servers = 2";
		$f[]="pm.min_spare_servers = 1";
		$f[]="pm.max_spare_servers = 3";
		$f[]=";pm.process_idle_timeout = 10s;";
		$f[]="pm.max_requests = 500";
		$f[]="php_value[include_path]  = \"/usr/share/RichFilemanager:/usr/share/php-composer/connectors/php\"";
		$f[]="";
		$f[]="";
		$f[]="";		
		
		
	}
	
	
	if($EnableXapianSearch==1){
		$f[]="[XAPIAN_SEARCH]";
		$f[]="user = www-data";
		$f[]="group = www-data";
		$f[]="listen = /var/run/XapianSearchWeb.sock";
		$f[]="listen.owner = www-data";
		$f[]="listen.group = www-data";
		$f[]="pm = dynamic";
		$f[]="pm.max_children = 5";
		$f[]="pm.start_servers = 2";
		$f[]="pm.min_spare_servers = 1";
		$f[]="pm.max_spare_servers = 3";
		$f[]=";pm.process_idle_timeout = 10s;";
		$f[]="pm.max_requests = 500";
		$f[]="";
		$f[]="";
		$f[]="";
	
	
	}	
	
	
	
	
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} artica-phpfpm.conf done..\n";}

	@mkdir("/usr/local/ArticaWebConsole/working_directory",0755,true);
    @mkdir("/usr/local/ArticaWebConsole/locks",0755,true);

    chown("/usr/local/ArticaWebConsole/locks","www-data");
    chown("/usr/local/ArticaWebConsole/working_directory","www-data");
	
	echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} PHP-FPM: /etc/artica-postfix/artica-phpfpm.conf done\n";
	@file_put_contents("/etc/artica-postfix/artica-phpfpm.conf", @implode("\n", $f));
	$f=array();
	$f[]="user www-data;";
	$f[]="worker_processes auto;";
    $f[]="working_directory /usr/local/ArticaWebConsole/working_directory;";
    $f[]="lock_file /usr/local/ArticaWebConsole/locks/ArticaWebConsole.lock;";

	
	$f[]="events {";
    $f[]="\taccept_mutex on;";
	$f[]="\tworker_connections  768;";
//	$f[]="\tmulti_accept        on;";
	//$f[]="\tuse                 epoll;";
	$f[]="}";
	
	
	$f[]="pid /var/run/artica-webconsole.pid;";
	$f[]="error_log  syslog:server=unix:/dev/log,facility=local0,tag=ArticaWeb,severity=error;";
	
	$f[]="http {";
	$f[]="	server_tokens off;";
	$f[]="	sendfile on;";
	$f[]="	tcp_nopush on;";
	$f[]="	tcp_nodelay on;";
	$f[]="	keepalive_timeout 65;";
	$f[]="	types_hash_max_size 2048;";
	$f[]="	default_type application/octet-stream;";
	$f[]="	client_max_body_size      2000M;";
	$f[]="	client_body_buffer_size   128k;";
	$f[]="";
	$f[]="";
	$f[]="types {";
	$f[]="    text/html                             html htm shtml;";
	$f[]="    text/css                              css;";
	$f[]="    text/xml                              xml;";
	$f[]="    image/gif                             gif;";
	$f[]="    image/jpeg                            jpeg jpg;";
	$f[]="    application/javascript                js;";
	$f[]="    application/atom+xml                  atom;";
	$f[]="    application/rss+xml                   rss;";
	$f[]="";
	$f[]="    text/mathml                           mml;";
	$f[]="    text/plain                            txt;";
	$f[]="    text/vnd.sun.j2me.app-descriptor      jad;";
	$f[]="    text/vnd.wap.wml                      wml;";
	$f[]="    text/x-component                      htc;";
	$f[]="";
	$f[]="    image/png                             png;";
	$f[]="    image/tiff                            tif tiff;";
	$f[]="    image/vnd.wap.wbmp                    wbmp;";
	$f[]="    image/x-icon                          ico;";
	$f[]="    image/x-jng                           jng;";
	$f[]="    image/x-ms-bmp                        bmp;";
	$f[]="    image/svg+xml                         svg svgz;";
	$f[]="    image/webp                            webp;";
	$f[]="";
	$f[]="    application/font-woff                 woff;";
	$f[]="    application/java-archive              jar war ear;";
	$f[]="    application/json                      json;";
	$f[]="    application/mac-binhex40              hqx;";
	$f[]="    application/msword                    doc;";
	$f[]="    application/pdf                       pdf;";
	$f[]="    application/postscript                ps eps ai;";
	$f[]="    application/rtf                       rtf;";
	$f[]="    application/vnd.apple.mpegurl         m3u8;";
	$f[]="    application/vnd.ms-excel              xls;";
	$f[]="    application/vnd.ms-fontobject         eot;";
	$f[]="    application/vnd.ms-powerpoint         ppt;";
	$f[]="    application/vnd.wap.wmlc              wmlc;";
	$f[]="    application/vnd.google-earth.kml+xml  kml;";
	$f[]="    application/vnd.google-earth.kmz      kmz;";
	$f[]="    application/x-7z-compressed           7z;";
	$f[]="    application/x-cocoa                   cco;";
	$f[]="    application/x-java-archive-diff       jardiff;";
	$f[]="    application/x-java-jnlp-file          jnlp;";
	$f[]="    application/x-makeself                run;";
	$f[]="    application/x-perl                    pl pm;";
	$f[]="    application/x-pilot                   prc pdb;";
	$f[]="    application/x-rar-compressed          rar;";
	$f[]="    application/x-redhat-package-manager  rpm;";
	$f[]="    application/x-sea                     sea;";
	$f[]="    application/x-shockwave-flash         swf;";
	$f[]="    application/x-stuffit                 sit;";
	$f[]="    application/x-tcl                     tcl tk;";
	$f[]="    application/x-x509-ca-cert            der pem crt;";
	$f[]="    application/x-xpinstall               xpi;";
	$f[]="    application/xhtml+xml                 xhtml;";
	$f[]="    application/xspf+xml                  xspf;";
	$f[]="    application/zip                       zip;";
	$f[]="";
	$f[]="    application/octet-stream              bin exe dll;";
	$f[]="    application/octet-stream              deb;";
	$f[]="    application/octet-stream              dmg;";
	$f[]="    application/octet-stream              iso img;";
	$f[]="    application/octet-stream              msi msp msm;";
	$f[]="";
	$f[]="    application/vnd.openxmlformats-officedocument.wordprocessingml.document    docx;";
	$f[]="    application/vnd.openxmlformats-officedocument.spreadsheetml.sheet          xlsx;";
	$f[]="    application/vnd.openxmlformats-officedocument.presentationml.presentation  pptx;";
	$f[]="";
	$f[]="    audio/midi                            mid midi kar;";
	$f[]="    audio/mpeg                            mp3;";
	$f[]="    audio/ogg                             ogg;";
	$f[]="    audio/x-m4a                           m4a;";
	$f[]="    audio/x-realaudio                     ra;";
	$f[]="";
	$f[]="    video/3gpp                            3gpp 3gp;";
	$f[]="    video/mp2t                            ts;";
	$f[]="    video/mp4                             mp4;";
	$f[]="    video/mpeg                            mpeg mpg;";
	$f[]="    video/quicktime                       mov;";
	$f[]="    video/webm                            webm;";
	$f[]="    video/x-flv                           flv;";
	$f[]="    video/x-m4v                           m4v;";
	$f[]="    video/x-mng                           mng;";
	$f[]="    video/x-ms-asf                        asx asf;";
	$f[]="    video/x-ms-wmv                        wmv;";
	$f[]="    video/x-msvideo                       avi;";
	$f[]="}";
	$f[]="";
	$f[]="";
	$f[]="";

    $hack[]="Administrator/index";
    $hack[]="Joomla/administrator";
    $hack[]="Cms/administrator";
    $hack[]="joomla/administrator";
    $hack[]="Msd/index";
    $hack[]="MySqlDumper/index";
    $hack[]="Msd124stable/index";
    $hack[]="Msd1244/index";
    $hack[]="Mysqldumper/index";
    $hack[]="MySQLDumper/index";
    $hack[]="Mysql/index";
    $hack[]="mysql/index";
    $hack[]="Sql/index";
    $hack[]="sql/index";
    $hack[]="Cgi-bin/php";
    $hack[]="Cgi-bin/php5";
    $hack[]="Phpmyadmin/index";
    $hack[]="PhpMyAdmin/index";
    $hack[]="Myadmin/index";

    foreach ($hack as $path){
        $f_rewrites[]="\trewrite $path$ /fw.hack.php?ip=\$remote_addr last;";
    }

	$f_rewrites[]="\trewrite ^/smtpurls/(.*)$ /smtpurls.php?msgid=$1 last;";
    $f_rewrites[]="\trewrite ^/api/rest/safe/(.*)$ /rest.mailsecurity.php?url=$1 last;";
	$f_rewrites[]="\trewrite ^/api/rest/system/(.*)(?:/*)(.*)(?:/*)(.*)(?:/*)(.*) /rest.system.php?function1=$1&function2=$2&function3=$3&function4=$4 last;";	
	$f_rewrites[]="\trewrite ^/api/rest/proxy/cache/(.*)(?:/*)(.*)(?:/*)(.*)(?:/*)(.*) /rest.proxy.cache.php?function1=$1&function2=$2&function3=$3&function4=$4 last;";
    $f_rewrites[]="\trewrite ^/api/rest/proxy/stats/(.*)(?:/*)(.*)(?:/*)(.*)(?:/*)(.*) /rest.proxy.stats.php?function1=$1&function2=$2&function3=$3&function4=$4 last;";

    $f_rewrites[]="\trewrite ^/api/rest/proxy/white/(.*)(?:/*)(.*)(?:/*)(.*)(?:/*)(.*) /rest.proxy.white.php?function1=$1&function2=$2&function3=$3&function4=$4 last;";


    $f_rewrites[]="\trewrite ^/api/rest/category/(.*)(?:/*)(.*)(?:/*)(.*)(?:/*)(.*) /rest.categories-ful.php?function1=$1&function2=$2&function3=$3&function4=$4 last;";
	$f_rewrites[]="\trewrite ^/api/rest/categories/(.*)(?:/*)(.*)(?:/*)(.*)(?:/*)(.*) /rest.categories.php?function1=$1&function2=$2&function3=$3&function4=$4 last;";
	$f_rewrites[]="\trewrite ^/api/rest/ldap/(.*)(?:/*)(.*)(?:/*)(.*)(?:/*)(.*) /rest.ldap.php?function1=$1&function2=$2&function3=$3&function4=$4 last;";
    $f_rewrites[]="\trewrite ^/api/rest/dnsfilter/(.*)(?:/*)(.*)(?:/*)(.*)(?:/*)(.*) /rest.dnsfilter.php?function1=$1&function2=$2&function3=$3&function4=$4 last;";
    $f_rewrites[]="\trewrite ^/api/rest/webfilter/(.*)(?:/*)(.*)(?:/*)(.*)(?:/*)(.*) /rest.webfilter.php?function1=$1&function2=$2&function3=$3&function4=$4 last;";

	$f_rewrites[]="\trewrite ^/api/rest/categorization/submit /rest.categorization.php last;";
	$f_rewrites[]="\trewrite ^/api/rest/rbl/query/version /rest.rbl.php?version=yes last;";
	$f_rewrites[]="\trewrite ^/api/rest/rbl/set/black/(.*)$ /rest.rbl.php?setblacklist=$1 last;";
	$f_rewrites[]="\trewrite ^/api/rest/rbl/query/black/(.*)$ /rest.rbl.php?getblacklist=$1 last;";
	$f_rewrites[]="\trewrite ^/api/rest/rbl/query/white/(.*)$ /rest.rbl.php?getwhitelist=$1 last;";
    $f_rewrites[]="\trewrite ^/api/rest/rbl/query/email/(.*)$ /rest.rbl.php?email=$1 last;";

    $f_rewrites[]="\trewrite ^/ha-exchange /fw.haexchange.service.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/haexchange-backends /fw.haexchange.backends.php?page=yes&main-page=yes last;";

    $f_rewrites[]="\trewrite ^/rdpproxy-events /fw.rdpproxy.events.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/rdpproxy-sessions /fw.rdpproxy.sessions.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/rdpproxy-videos /fw.rdpproxy.videos.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/rdpproxy-connections /fw.rdpproxy.connections.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/rdpproxy /fw.rdpproxy.status.php?main-page=yes last;";

    $f_rewrites[]="\trewrite ^/cluster-master /fw.system.cluster.master.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/cluster-client /fw.system.cluster.client.php?main-page=yes last;";

    $f_rewrites[]="\trewrite ^/sql-errors /fw.databases.errors.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/geoip-database /fw.geoip.php?main-page=yes last;";

    $f_rewrites[]="\trewrite ^/filebeat-status /fw.filebeat.status.php?main-page=yes last;";

    $f_rewrites[]="\trewrite ^/kav4proxy /fw.kav4proxy.status.php?main-page=yes last;";

	$f_rewrites[]="\trewrite ^/account /fw.account.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/auth/(.*)$ /fw.login.php?apikey=$1 last;";
	
	$f_rewrites[]="\trewrite ^/nics /fw.network.interfaces.php?section-nics=yes last;";
	$f_rewrites[]="\trewrite ^/lb-status /fw.haproxy.monitor.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/lb-services /fw.haproxy.services.php?main-page=yes last;";
	
	$f_rewrites[]="\trewrite ^/nat /fw.nat.php?main-page=yes last;";
	
	$f_rewrites[]="\trewrite ^/ldap-database /fw.openldap.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/redis-database /fw.redis.php?main-page=yes last;";

    $f_rewrites[]="\trewrite ^/link-balancer /fw.network.balancer.php?main-page=yes last;";

    $f_rewrites[]="\trewrite ^/mail-source-logs /fw.postfix.maillog.php?main-page=yes last;";

    $f_rewrites[]="\trewrite ^/google-safebrowsing fw.proxy.GoogleSafeBrowsing.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/wccp fw.proxy.wccp.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/proxy-statistics-generator /fw.squid.analyzer.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/proxy-statistics-index /fw.squid.analyzer.table.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/proxy-reply-access /fw.http_reply_access.php?main-page=yes last;";

    $f_rewrites[]="\trewrite ^/proxy-objects /fw.proxy.objects.list.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/proxy-acls-bandwidth /fw.proxy.bandwidth.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/proxy-acls-access /fw.proxy.acls.php?main-page=yes last;";

    $f_rewrites[]="\trewrite ^/mikrotik /fw.proxy.mikrotik.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/proxy-caches-center /fw.proxy.caches.center.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/proxy-whitelists /fw.proxy.whitelist.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/proxy-authentication /fw.proxy.members.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/proxy-parents-status /fw.proxy.parents.status.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/proxy-parents-parameters /fw.proxy.parents.parameters.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/proxy-parents-rules /fw.proxy.parents.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/browsers-rules /fw.proxy.browsers.php?main-page=yes last;";

    $f_rewrites[]="\trewrite ^/proxypac-events /fw.proxypac.events.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/proxypac-rules  /fw.proxypac.rules.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/proxypac-status /fw.proxypac.status.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/proxypac-statistics /fw.proxypac.stats.php?main-page=yes last;";
	
	$f_rewrites[]="\trewrite ^/proxy-safe-ports /fw.proxy.general.php?SafePorts-main=yes last;";
	$f_rewrites[]="\trewrite ^/proxy-performance /fw.proxy.general.php?performance-main=yes last;";
	$f_rewrites[]="\trewrite ^/proxy-dns /fw.proxy.general.php?dns-main=yes last;";
	$f_rewrites[]="\trewrite ^/proxy-categorisation /fw.proxy.categorize.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/proxy-statistics$ /fw.proxy.statistics.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/proxy-status /fw.proxy.status.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/proxy-errors /fw.proxy.errors.page.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/proxy-ssl /fw.proxy.ssl.status.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/proxy-ssl-rules /fw.proxy.ssl.rules.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/proxy-global-rules /fw.proxy.global.rules.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/proxy-ports /fw.proxy.ports.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/proxy-parameters /fw.proxy.general.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/proxy-timeouts /fw.proxy.general.php?timeouts-main=yes last;";
	$f_rewrites[]="\trewrite ^/proxy$ /fw.proxy.php last;";
    $f_rewrites[]="\trewrite ^/icap-center /fw.proxy.icap.center.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/it-charters /fw.itcharter.php?main-page=yes last;";

    $f_rewrites[]="\trewrite ^/wanproxy-events /fw.wanproxy.events.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/wanproxy$ /fw.wanproxy.status.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/zabbix /fw.system.zabbix.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/personal-categories$ /fw.ufdb.categories.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/personal-categories-parameters$ /fw.ufdb.categories.settings.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/categories-service$ /fw.dnscat.status.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/categories-services /fw.proxy.categories.services.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/statistics-service$ /fw.proxy.statistics.service.php?main-page=yes last;";

	$f_rewrites[]="\trewrite ^/logoff /fw.login.php?disconnect=yes last;";
	$f_rewrites[]="\trewrite ^/index /fw.index.php last;";
	$f_rewrites[]="\trewrite ^/system-disks /fw.system.hd.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/system-watchdog /fw.system.monit.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/system-swap /fw.system.swap.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/syslogd /fw.syslogd.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/sshportal /fw.sshportal.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/sshd /fw.sshd.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/system-restful /fw.system.restful.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/system-memory /fw.system.memory.config.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/system-tasks /fw.system.tasks.php?main-page=yes last;";

	$f_rewrites[]="\trewrite ^/wizard /fw.wizard.after.php last;";
	$f_rewrites[]="\trewrite ^/features /fw.system.services.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/license-wizard-request /fw.license.php?main-page=yes&request=yes last;";
	$f_rewrites[]="\trewrite ^/license/request /fw.license.php?request-page=yes last;";
	$f_rewrites[]="\trewrite ^/license /fw.license.php?main-page=yes last;";

    $f_rewrites[]="\trewrite ^/cluster-kerberos /fw.system.kerberos.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/hacluster-connections /fw.hacluster.connections.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/hacluster-backend-events /fw.hacluster.events.backends.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/hacluster-events /fw.hacluster.events.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/hacluster-status /fw.hacluster.status.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/hacluster-kerberos /fw.hacluster.AD.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/hacluster-backends /fw.hacluster.backends.php?main-page=yes last;";

    $f_rewrites[]="\trewrite ^/single-kerberos /fw.system.kerberos-single.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/statscom /fw.statscom.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/artica-logger /fw.articalogger.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/klnagent /fw.klnagent.status.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/versions /fw.versions.php?main-page=yes last;";

	$f_rewrites[]="\trewrite ^/routing /fw.network.routing.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/interfaces /fw.network.interfaces.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/computers /fw.computers.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/hostfile /fw.etc-hosts.php?main-page=yes last;";
	
	//3PROXY
	$f_rewrites[]="\trewrite ^/universal-proxy-status /fw.3proxy.status.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/universal-proxy-services /fw.3proxy.services.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/universal-proxy-errors /fw.3proxy.errors.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/universal-proxy-requests /fw.3proxy.requests.php?main-page=yes last;";
	
	//MEMBERS
    $f_rewrites[]="\trewrite ^/local-ldap-members /fw.members.ldap.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/remote-members /fw.members.externldap.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/local-members /fw.members.ldap.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/ad-members /fw.members.activedirectory.php?main-page=yes last;";

	//Fail2Ban
    $f_rewrites[]="\trewrite ^/darkstat /fw.network.darkstat.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/fail2ban-index /fw.fail2ban.dashboard.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/fail2ban-events /fw.fail2ban.events.php?main-page=yes last;";
	
	//DNS
    $f_rewrites[]="\trewrite ^/safesearch /fw.dns.SafeSearch.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/DNSCrypt-events /fw.dnscrypt-proxy.events.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/dns-statistics /fw.dsc.statistics.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/dns-local-domains /fw.dns.local.domains.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/dns-records /fw.dns.records.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/dns-forward /fw.dns.forward.zone.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/pdns-status /fw.pdns.status.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/pdns-config /fw.dns.pdns.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/pdns-events /fw.pdns.events.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/dns-servers /fw.dns.servers.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/dnsdist-acls /fw.dns.dnsdist.rules.php?main-page=yes last;";


    $f_rewrites[]="\trewrite ^/dnsfilter-rules /fw.dns.filterd.rules.php?single-page=yes&main-page=yes last;";
	$f_rewrites[]="\trewrite ^/dnsfilter-statistics /fw.dns.filterd.stats.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/dnsfilter$  /fw.dns.filterd.php?main-page=yes last;";
	
	$f_rewrites[]="\trewrite ^/networks /fw.networks.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/PostgreSQL /fw.postgresql.status.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/dns-cache /fw.dns.unbound.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/webconsole /fw.articaweb.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/artica-cloud /fw.ArticaCloud.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/system-glances /fw.system.glances.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/snmpd /fw.system.snmpd.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/support /fw.bugzilla.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/events /fw.system.watchdog.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/access.log /fw.proxy.relatime.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/milterspy.log /fw.postfix.milterspy.relatime.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/certificate-center /fw.certificates-center.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/admins /fw.system.localadmins.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/artica-update /fw.updates.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/global-proxy /fw.global.proxy.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/rbl-service /fw.rbldnsd.php?main-page=yes last;";
	
	//POSTFIX
	$f_rewrites[]="\trewrite ^/mail-backup /fw.mimedefang.backup.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/quarantine /fw.mimedefang.quarantine.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/greylist /fw.postfix.milter-greylist.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/opendkim /fw.postfix.dkim.php?main-page=yes last;";

	$f_rewrites[]="\trewrite ^/mail-investigate /fw.postfix.investigate.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/logs-rotate /fw.proxy.rotate.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/postfix-settings /fw.postfix.settings.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/postfix-status /fw.postfix.status.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/postfix-routing /fw.postfix.routing.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/postfix-queue /fw.postfix.queue.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/postfix-transactions /fw.postfix.transactions.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/postfix-refused /fw.postfix.refused.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/postfix-policies-service-status /fw.mimedefang.status.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/postfix-policies-asrules /fw.mimedefang.spamassassin.rules.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/postfix-policies-antispam /fw.mimedefang.spamassassin.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/postfix-policies-autowhite /fw.mimedefang.autowhite.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/postfix-firewall /fw.postfix.firewall.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/postfix-rewrite-rules /fw.postfix.rewrite.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/smtp-members-statistics /fw.postfix.statistics.members.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/smtp-url-filtering /fw.mimedefang.urls.php?main-page=yes last;";

    //c-ICAP

    $f_rewrites[]="\trewrite ^/antivirus-proxy  /fw.proxy.c-icap.php?main-page=yes last;";

	// WEB FILTERING
    $f_rewrites[]="\trewrite ^/webfiltering-status  /fw.ufdb.settings.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/webfiltering-client  /fw.ufdb.client.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/webfiltering-parameters /fw.ufdb.settings.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/webfiltering-databases /fw.ufdb.databases.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/webfiltering-webpages /fw.ufdbweb.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/webfiltering-rules /fw.ufdb.rules.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/webfiltering-policies /fw.proxy.urlrewrite.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/error-page-status /fw.ufdbweb.status.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/error-page-rules /fw.ufdb.rules.php?main-page=yes last;";
	
	//IDS
	$f_rewrites[]="\trewrite ^/ids-categories /fw.ids.categories.php?main-page=yes last;";
	
	//memcached
	$f_rewrites[]="\trewrite ^/memcached /fw.system.memcached.php?main-page=yes last;";
	
	//DCHP
    $f_rewrites[]="\trewrite ^/dhcprelay /fw.dhcprelay.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/dhcp-last /fw.dhcp.last.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/dhcp-status /fw.dhcp.status.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/dhcp-config /fw.dhcp.configuration.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/dhcp-events /fw.dhcp.events.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/dhcp-leases /fw.dhcp.leases.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/dhcp-requests /fw.dhcp.requests.php?main-page=yes last;";
	
	$f_rewrites[]="\trewrite ^/license /fw.license.php?main-page=yes last;";
	
	//MySQL
	$f_rewrites[]="\trewrite ^/mysql-service /fw.mysql.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/mysql-events /fw.mysql.events.php?main-page=yes last;";
	
	//NGINX
    $f_rewrites[]="\trewrite ^/firewall-web /fw.nginx.fw.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/wordpress /fw.wordpress.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/nginx-status /fw.nginx.status.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/web-requests /fw.nginx.requests.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/websites /fw.nginx.sites.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/web-events /fw.nginx.events.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/waf /fw.modsecurity.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/threats-waf /fw.modsecurity.threats.php?main-page=yes last;";
	//HotSpot
	$f_rewrites[]="\trewrite ^/hotspot-config /fw.proxy.hotspot.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/hotspot-events /fw.proxy.hotspot.events.php?main-page=yes last;";
	
	//CLAMAV
	$f_rewrites[]="\trewrite ^/clamav-white /fw.clamav.white.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/clamav /fw.clamav.status.php?main-page=yes last;";

    $f_rewrites[]="\trewrite ^/mail2sms /fw.mail2sms.php?main-page=yes last;";
	
	// FireWall
    $f_rewrites[]="\trewrite ^/masquerade /fw.masquerade.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/Cybercrime-IP-Feeds /fw.ipfeeds.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/redsocks /fw.redsocks.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/ffirewall-objects /fw.proxy.objects.list.php?main-page=yes&firewall=yes last;";
	$f_rewrites[]="\trewrite ^/firewall-parameters /fw.settings.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/firewall /fw.rules.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/traffic-shaping /fw.traffic.shaping.php?main-page=yes last;";


	
	
	// Active Directory
	$f_rewrites[]="\trewrite ^/ad-connect /fw.system.ActiveDirectory.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/ad-ldap  /fw.system.activedirectory.ldap.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/ad-white /fw.proxy.ad.white.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/ad-state /fw.proxy.ad.status.php?main-page=yes last;";
    $f_rewrites[]="\trewrite ^/ad-events /fw.activedirectory.watchdog.php?main-page=yes last;";




	//GreenSQL
	$f_rewrites[]="\trewrite ^/greensql-status /fw.greensql.status.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/greensql-routers /fw.greensql.routers.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/greensql-rules /fw.greensql.rules.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/greensql-alerts /fw.greensql.alerts.php?main-page=yes last;";
	$f_rewrites[]="\trewrite ^/greensql-approve /fw.greensql.approve.php?main-page=yes last;";
    $ssl_option=null;
	if($ArticaHttpUseSSL==1){

		if($SSLCipherSuite==null){$SSLCipherSuite="ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-AES256-GCM-SHA384:kEDH+AESGCM:ECDHE-RSA-AES128-SHA256:ECDHE-ECDSA-AES128-SHA256:ECDHE-RSA-AES128-SHA:ECDHE-ECDSA-AES128-SHA:ECDHE-RSA-AES256-SHA384:ECDHE-ECDSA-AES256-SHA384:ECDHE-RSA-AES256-SHA:ECDHE-ECDSA-AES256-SHA:DHE-RSA-AES128-SHA256:DHE-RSA-AES128-SHA:DHE-RSA-AES256-SHA256:DHE-DSS-AES256-SHA:AES128-GCM-SHA256:AES256-GCM-SHA384:ECDHE-RSA-RC4-SHA:ECDHE-ECDSA-RC4-SHA:RC4-SHA:HIGH:!aNULL:!eNULL:!EXPORT:!DES:!3DES:!MD5:!PSK";}

		$f_ssl[]="# SSL ---------------------------------- [".__LINE__."]";

		$nginx_certificate=new nginx_certificate($LighttpdArticaCertificateName);
		$f_ssl[]=$nginx_certificate->GetConf();
		$f_ssl[]="\tssl_session_timeout  5m;";
		if($LighttpdArticaDisableSSLv2==0){
			$f_ssl[]="\tssl_protocols  TLSv1 TLSv1.1 TLSv1.2;";
		}else{
			$f_ssl[]="\tssl_protocols TLSv1.2;";
		}
		$f_ssl[]="\tssl_ciphers '$SSLCipherSuite';";
		$f_ssl[]="\tssl_prefer_server_ciphers   on;";
		$f_ssl[]="\tadd_header Strict-Transport-Security max-age=15768000;";
		$f_ssl[]="\t# OCSP Stapling ---";
		$f_ssl[]="\t# fetch OCSP records from URL in ssl_certificate and cache them";
		$f_ssl[]="\tssl_stapling on;";
		$f_ssl[]="\tssl_stapling_verify on;";
		$ssl=@implode("\n", $f_ssl);
		$ssl_option=" ssl";
	}
	

	$php_params=nginx_php_params();
	

	$f[]="# AclsDynamicsWebServerName ='$AclsDynamicsWebServerName'";
	$f[]="# FirewallWebServerName ='$FirewallWebServerName'";
	$f[]="";
	if($FirewallWebServerName<>null){
		$unix->add_EtcHosts($FirewallWebServerName, "127.0.0.1");
		$f[]="server {";
		$f[]="        listen $LighttpdArticaListenIP:$ArticaHttpsPort{$ssl_option};";
		$f[]="        server_name $FirewallWebServerName;";
		$f[]="        index fw.login.php;";
		$f[]="        root /usr/share/artica-postfix/;";
		$f[]=@implode("\n", $f_rewrites);
		$f[]="$ssl";
		$f[]=$php_params;
		$f[]="}";
		
	}
	if($ProxyWebServerName<>null){
		$unix->add_EtcHosts($ProxyWebServerName, "127.0.0.1");
		$f[]="server {";
		$f[]="        listen $LighttpdArticaListenIP:$ArticaHttpsPort{$ssl_option};";
		$f[]="        server_name $ProxyWebServerName;";
		$f[]="        index fw.login.php;";
		$f[]="        root /usr/share/artica-postfix/;";
		$f[]=@implode("\n", $f_rewrites);
		$f[]="$ssl";
		$f[]=$php_params;
		$f[]="}";
	
	}	
	
	
	if($AclsDynamicsWebServerName<>null){
		$unix->add_EtcHosts($AclsDynamicsWebServerName, "127.0.0.1");
		$f[]="server {";
		$f[]="\tlisten $LighttpdArticaListenIP:$ArticaHttpsPort{$ssl_option};";
		$f[]="\tserver_name $AclsDynamicsWebServerName;";
		$f[]="\tindex fw.login.acls.php;";
		$f[]="\troot /usr/share/artica-postfix/;";
		$f[]=@implode("\n", $f_rewrites);
		$f[]="$ssl";
		$f[]=$php_params;
		$f[]="}";
	
	}
    $f[]="";
    $f[]="server {";
    $f[]="\tlisten 127.0.0.1:8562;";
    $f[]="\tserver_name _;";
    $f[]="\tindex index.html;";
    $f[]="\troot /home/artica/squidanalyzer/proxyreport/;";
    $f[]="\t}";
    $f[]="";





    $err_497=null;
	if($ArticaHttpUseSSL==1){
	    $server_option[]="ssl";
	    $err_497="\terror_page\t497\thttps://\$server_name:\$server_port\$request_uri;";
	}
    $f[]="# ArticaHttpsPort: $ArticaHttpsPort";
    $f[]="# ArticaHttpUseSSL: $ArticaHttpUseSSL";

    squid_admin_mysql(1,"Artica Web console reconfigured (SSL=$ArticaHttpUseSSL port=$ArticaHttpsPort)",null,__FILE__,__LINE__);
	
	$f[]="";
	$f[]="server {";
	$f[]="access_log /var/log/artica-web.log;";
	$f[]="\tlisten $LighttpdArticaListenIP:$ArticaHttpsPort ".@implode(" ", $server_option).";";


	if($LighttpdArticaListenInterface==null){
		$NETWORK_ALL_INTERFACES=$unix->NETWORK_ALL_INTERFACES();
		
		while (list ($val, $ligne) = each ($NETWORK_ALL_INTERFACES) ){
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Detected interface:$val\n";}
			if($val=="lo"){continue;}
			if($val=="tun0"){continue;}
			if(preg_match('#master#',$val)){continue;}
			if(preg_match("#^veth.+?#",$val)){continue;}
			if(preg_match("#^tunl[0-9]+#",$val)){continue;}
			if(preg_match("#^dummy[0-9]+#",$val)){continue;}
			if(preg_match("#^gre[0-9]+#",$val)){continue;}
			if(preg_match("#^ip6tnl[0-9]+#",$val)){continue;}
			if(preg_match("#^sit[0-9]+#",$val)){continue;}
			if(preg_match("#^vlan[0-9]+#",$val)){continue;}
			if(preg_match("#^.*?-ifb$#",$val)){continue;}
			if($ligne["IPADDR"]=="0.0.0.0"){continue;}
			if(trim($ligne["IPADDR"])==null){continue;}
			
			$f[]="\tserver_name {$ligne["IPADDR"]};";
		}
		

	}
	$hostname=$unix->hostname_g();
	if($hostname<>null){$f[]="\tserver_name $hostname;"; }
	if($LighttpdArticaListenInterface==null){$f[]="        server_name _;";}
    $f[]=$err_497;
	$f[]="\terror_page 404 /404.html;";
	$f[]="\tlocation = /404.html {";
	$f[]="\t\troot /usr/share/artica-postfix;";
	$f[]="\t\tinternal;";
	$f[]="\t}";
	
	$f[]="\terror_page 504 /504.html;";
	$f[]="\tlocation = /504.html {";
	$f[]="\t\troot /usr/share/artica-postfix;";
	$f[]="\t\tinternal;";
	$f[]="\t}";

    $f[]="\terror_page 502 /502.html;";
    $f[]="\tlocation = /502.html {";
    $f[]="\t\troot /usr/share/artica-postfix;";
    $f[]="\t\tinternal;";
    $f[]="\t}";

    $f[]="\terror_page 403 /403.html;";
    $f[]="\tlocation = /403.html {";
    $f[]="\t\troot /usr/share/artica-postfix;";
    $f[]="\t\tallow all;";
    $f[]="\t\tinternal;";
    $f[]="\t}";

    $f[]="";
    $f[]="";
    $f[]=ngx_stream_access_module();
    $f[]="";
    $f[]="";
	
	$f[]="\tindex logon.php;";
	$f[]="\troot /usr/share/artica-postfix/;";
	$f[]=@implode("\n", $f_rewrites);
	$f[]="$ssl";
	// /api/2/all
	$f[]="\tlocation / {";
	$f[]="\t\tif (\$http_referer ~ \"^https?://[^/]+/glances\"){";
	$f[]="\t\t\trewrite ^/(.*) https://\$http_host/glances/$1 redirect;";
	$f[]="\t\t}";
	$f[]="\t}";


    $f[]="\tlocation ~* proxystats/([0-9]+)/week([0-9]+)$ {";
    $f[]="\t\treturn 302 /proxystats/$1/week$2/index.html;";
    $f[]="\t}";

    $f[]="\tlocation /proxystats/ {";
    $f[]="\t\tif (\$http_cookie !~ \"shellinaboxCooKie=[0-9]\") {";
    $f[]="\t\t\treturn 403;";
    $f[]="\t}";
    $f[]="\t\tproxy_pass http://127.0.0.1:8562/;";
    $f[]="\t\tproxy_http_version 1.1;";
    $f[]="\t\tproxy_set_header Upgrade \$http_upgrade;";
    $f[]="\t\tproxy_set_header Connection 'upgrade';";
    $f[]="\t\tproxy_set_header Host \$host;";
    $f[]="\t\tproxy_cache_bypass \$http_upgrade;";
    $f[]="\t}";

    $f[]="\tlocation /WanProxyMetrics/ {";
    $f[]="\t\tif (\$http_cookie !~ \"shellinaboxCooKie=[0-9]\") {";
    $f[]="\t\t\treturn 403;";
    $f[]="\t}";
    $f[]="\t\tproxy_pass http://127.0.0.1:9900/;";
    $f[]="\t\tproxy_http_version 1.1;";
    $f[]="\t\tproxy_set_header Upgrade \$http_upgrade;";
    $f[]="\t\tproxy_set_header Connection 'upgrade';";
    $f[]="\t\tproxy_set_header Host \$host;";
    $f[]="\t\tproxy_cache_bypass \$http_upgrade;";
    $f[]="\t}";


    $f[]="\tlocation /tailon/ {";
    $f[]="\t\tif (\$http_cookie !~ \"shellinaboxCooKie=[0-9]\") {";
    $f[]="\t\t\treturn 403;";
    $f[]="\t}";
    $f[]="\t\tproxy_pass http://127.0.0.1:7050/tailon/;";
    $f[]="\t\tproxy_http_version 1.1;";
    $f[]="\t\tproxy_set_header Upgrade \$http_upgrade;";
    $f[]="\t\tproxy_set_header Connection 'upgrade';";
    $f[]="\t\tproxy_set_header Host \$host;";
    $f[]="\t\tproxy_cache_bypass \$http_upgrade;";
    $f[]="\t}";

    $f[]="\tlocation ~ \/exec\. {";
    $f[]="\t\treturn 404;";
    $f[]="\t}";

    $f[]="\tlocation ~ \/(framework|bin)\/.* {";
    $f[]="\t\treturn 404;";
    $f[]="\t}";

    $f[]="\tlocation ~ \/ressources\/.*?\.(php|inc|py)$ {";
    $f[]="\t\treturn 404;";
    $f[]="\t}";
	
	$f[]="\tlocation /netdata {";
	$f[]="\t\treturn 301 /netdata/;";
	$f[]="\t}";
	
	$f[]="\tlocation /ssh {";
	$f[]="\t\treturn 301 /ssh/;";
	$f[]="\t}";
	
	$f[]="";
	$f[]="\tlocation /ntopng {";
	$f[]="\t\treturn 301 /ntopng/;";
	$f[]="\t}";
	$f[]="";
	$f[]="\tlocation /munin-images {";
	$f[]="\t\talias /var/cache/munin/www/localdomain/localhost.localdomain;";
	$f[]="\t}";
	$f[]="";
	$f[]="\tlocation /pdns-cluster {";
	$f[]="\t\talias /home/artica/PowerDNS/Cluster/storage;";
	$f[]="\t}";
	$f[]="";
	$f[]="\tlocation /postfix-search {";
	$f[]="\t\tif (\$http_cookie !~ \"shellinaboxCooKie=[0-9]\") {";
	$f[]="\t\t\treturn 403;";
	$f[]="\t}";	
	$f[]="\t\talias /home/artica/postfix/history;";
	$f[]="\t}";	
	
	
	if(!is_dir("/home/artica/postfix/history")){@mkdir("/home/artica/postfix/history",0755,true);}
	if(!is_dir("/home/artica/PowerDNS/Cluster/storage")){@mkdir("/home/artica/PowerDNS/Cluster/storage",0755,true);}
	
	if(!is_file("/home/artica/PowerDNS/Cluster/storage/index.html")){
		@file_put_contents("/home/artica/PowerDNS/Cluster/storage/index.php","<?php header(\"location: index.html\"); ?>");
		@file_put_contents("/home/artica/PowerDNS/Cluster/storage/index.html", "<html><head></head><body><H1>This is the storage section for PowerDNS cluster system, keep out !</H1></body></html>");
		@chmod("/home/artica/PowerDNS/Cluster/storage/index.html",0644);
		@chmod("/home/artica/PowerDNS/Cluster/storage/index.php",0755);
	}

	
	
	$NetDataListenPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NetDataListenPort"));
	if($NetDataListenPort==0){$NetDataListenPort=19999;}
	$f[]="\tlocation ~ /netdata/(?<ndpath>.*) {";
	$f[]="\t\tproxy_redirect off;";
	$f[]="\t\tproxy_set_header Host \$host;";
	$f[]="\t\tproxy_set_header X-Forwarded-Host \$host;";
	$f[]="\t\tproxy_set_header X-Forwarded-Server \$host;";
	$f[]="\t\tproxy_set_header X-Forwarded-For \$proxy_add_x_forwarded_for;";
	$f[]="\t\tproxy_http_version 1.1;";
	$f[]="\t\tproxy_pass_request_headers on;";
	$f[]="\t\tproxy_set_header Connection \"keep-alive\";";
	$f[]="\t\tproxy_store off;";
	$f[]="\t\tproxy_pass http://127.0.0.1:$NetDataListenPort/\$ndpath\$is_args\$args;";
	$f[]="\t\tgzip on;";
	$f[]="\t\tgzip_proxied any;";
	$f[]="\t\tgzip_types *;";
	$f[]="\t}";
	$f[]="";
	$f[]="\tlocation /kibana {";
    $f[]="\t\tif (\$http_cookie !~ \"AsWebStatisticsCooKie=[0-9]\") {";
    $f[]="\t\t\treturn 403;";
    $f[]="\t}";
    $f[]="\t\trewrite ^/kibana/?(.*)$ /$1 break;";
    $f[]="\t\tproxy_http_version 1.1;";
    $f[]="\t\tproxy_set_header Connection \"\";";
    $f[]="\t\tproxy_pass http://127.0.0.1:5601;";
    $f[]="\t\tproxy_intercept_errors on;";
    $f[]="\t\tproxy_redirect off;";
	$f[]="\t}";
    $f[]="";





	$f[]="\tlocation /ssh/ {";
	$f[]="\t\tif (\$http_cookie !~ \"shellinaboxCooKie=[0-9]\") {";
	$f[]="\t\t\treturn 403;";
	$f[]="\t}";
	$f[]="\t\tproxy_pass http://unix:/var/run/shellinabox.sock:/;";
	$f[]="\t\tproxy_redirect default;";
	$f[]="\t\tproxy_set_header Host \$host;";
	$f[]="\t\tproxy_set_header X-Real-IP \$remote_addr;";
	$f[]="\t\tproxy_set_header X-Forwarded-For \$proxy_add_x_forwarded_for;";
	$f[]="\t\tclient_max_body_size 10m;";
	$f[]="\t\tclient_body_buffer_size 128k;";
	$f[]="\t\tproxy_connect_timeout 90;";
	$f[]="\t\tproxy_send_timeout 90;";
	$f[]="\t\tproxy_read_timeout 90;";
	$f[]="\t\tproxy_buffer_size 4k;";
	$f[]="\t\tproxy_buffers 4 32k;";
	$f[]="\t\tproxy_busy_buffers_size 64k;";
	$f[]="\t\tproxy_temp_file_write_size 64k;";
	$f[]="\t}";
	
	
	$f[]="";
	$f[]="";
	$f[]="\tlocation = /analytics {";
	$f[]="\t\treturn 302 /analytics/;";
	$f[]="\t}";
	$f[]="";
	$f[]="\tlocation = /maillog {";
	$f[]="\t\treturn 302 /maillog/;";
	$f[]="\t}";	
	$f[]="";
	$f[]="\tlocation = /syslog {";
	$f[]="\t\treturn 302 /syslog/;";
	$f[]="\t}";



    $f[]="";
	$arrayConf=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ntopng")));
	if(!is_numeric($arrayConf["HTTP_PORT"])){$arrayConf["HTTP_PORT"]=3000;}
	$f[]="\tlocation /ntopng/ {";
	$f[]="\t\tproxy_redirect off;";
	$f[]="\t\tproxy_set_header Host \$host;";
	$f[]="\t\tproxy_set_header X-Forwarded-Host \$host;";
	$f[]="\t\tproxy_set_header X-Forwarded-Server \$host;";
	$f[]="\t\tproxy_set_header X-Forwarded-For \$proxy_add_x_forwarded_for;";
	$f[]="\t\tproxy_http_version 1.1;";
	$f[]="\t\tproxy_pass_request_headers on;";
	$f[]="\t\tproxy_set_header Connection \"keep-alive\";";
	$f[]="\t\tproxy_store off;";
	$f[]="\t\tproxy_pass http://127.0.0.1:{$arrayConf["HTTP_PORT"]};";
	$f[]="\t\tgzip on;";
	$f[]="\t\tgzip_proxied any;";
	$f[]="\t\tgzip_types *;";
	$f[]="\t}";	
	$f[]="";

    $EnablePDNSRESTFul=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnablePDNSRESTFul"));
	if($EnablePDNSRESTFul==1){
        $f[]="\tlocation /pdnsapi/ {";
        $f[]="\t\tport_in_redirect off;";
        $f[]="\t\trewrite /pdnsapi/(.*) /$1 break;";
        $f[]="\t\tproxy_pass http://127.0.0.1:8081/;";
        $f[]="\t\tproxy_set_header Host \$http_host;";
        $f[]="\t\tproxy_set_header X-Real-IP \$remote_addr;";
        $f[]="\t\tproxy_set_header X-Forwarded-For \$proxy_add_x_forwarded_for;";
        $f[]="\t\tproxy_set_header X-Forwarded-Proto \$scheme;";
        $f[]="\t}";
        $f[]="";


    }
	
	
	$f[]="\tlocation /glances/ {";
	$f[]="\t\tif (\$http_cookie !~ \"shellinaboxCooKie=[0-9]\") {";
	$f[]="\t\t\treturn 403;";
	$f[]="\t}";
	$f[]="\t\tport_in_redirect off;";
	$f[]="\t\trewrite /glances/(.*) /$1 break;";
	$f[]="\t\tproxy_pass http://127.0.0.1:61208/;";
	$f[]="\t\tproxy_set_header Host \$http_host;";
	$f[]="\t\tproxy_set_header X-Real-IP \$remote_addr;";
	$f[]="\t\tproxy_set_header X-Forwarded-For \$proxy_add_x_forwarded_for;";
	$f[]="\t\tproxy_set_header X-Forwarded-Proto \$scheme;";
	$f[]="\t}";
	$f[]="";
	
	$f[]="\tlocation /maillog/ {";
	$f[]="\t\tif (\$http_cookie !~ \"shellinaboxCooKie=[0-9]\") {";
	$f[]="\t\t\treturn 403;";
	$f[]="\t}";
	$f[]="\t\tproxy_pass http://127.0.0.1:2890/maillog/;";
	$f[]="\t\tproxy_http_version 1.1;";
	$f[]="\t\tproxy_set_header Upgrade \$http_upgrade;";
	$f[]="\t\tproxy_set_header Connection \"upgrade\";";
	$f[]="\t}";
	$f[]="";


    $f[]="\tlocation /nginx-access/ {";
    $f[]="\t\tif (\$http_cookie !~ \"shellinaboxCooKie=[0-9]\") {";
    $f[]="\t\t\treturn 403;";
    $f[]="\t}";
    $f[]="\t\tproxy_pass http://127.0.0.1:2892/nginx-access/;";
    $f[]="\t\tproxy_http_version 1.1;";
    $f[]="\t\tproxy_set_header Upgrade \$http_upgrade;";
    $f[]="\t\tproxy_set_header Connection \"upgrade\";";
    $f[]="\t}";
    $f[]="";

    $f[]="\tlocation /syslog/ {";
	$f[]="\t\tif (\$http_cookie !~ \"shellinaboxCooKie=[0-9]\") {";
	$f[]="\t\t\treturn 403;";
	$f[]="\t}";
	$f[]="\t\tproxy_pass http://127.0.0.1:2889/syslog/;";
	$f[]="\t\tproxy_http_version 1.1;";
	$f[]="\t\tproxy_set_header Upgrade \$http_upgrade;";
	$f[]="\t\tproxy_set_header Connection \"upgrade\";";
	$f[]="\t}";
	$f[]="";	
	
	
	
	$f[]="\tlocation /lua/ {";
	$f[]="\t\tproxy_redirect off;";
	$f[]="\t\tproxy_set_header Host \$host;";
	$f[]="\t\tproxy_set_header X-Forwarded-Host \$host;";
	$f[]="\t\tproxy_set_header X-Forwarded-Server \$host;";
	$f[]="\t\tproxy_set_header X-Forwarded-For \$proxy_add_x_forwarded_for;";
	$f[]="\t\tproxy_http_version 1.1;";
	$f[]="\t\tproxy_pass_request_headers on;";
	$f[]="\t\tproxy_set_header Connection \"keep-alive\";";
	$f[]="\t\tproxy_store off;";
	$f[]="\t\tproxy_pass http://127.0.0.1:{$arrayConf["HTTP_PORT"]}/lua/;";
	$f[]="\t\tgzip on;";
	$f[]="\t\tgzip_proxied any;";
	$f[]="\t\tgzip_types *;";
	$f[]="\t}";	
	
	
	$f[]=$php_params;
	$f[]="}";
	$f[]="";
	$f[]="";
	
	
	
	$RichFileManagerAuthent=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("RichFileManagerAuthent"));
	$EnableRichFileManager=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableRichFileManager"));
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Rich Filemanager = $EnableRichFileManager\n";}
	$RichFileManagerListenPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("RichFileManagerListenPort"));
	if($RichFileManagerListenPort==0){$RichFileManagerListenPort=5000;}
	
	if($EnableRichFileManager==1){
		$f[]="server {";
		$f[]="\tlisten $LighttpdArticaListenIP:$RichFileManagerListenPort;";
		$hostname=$unix->hostname_g();
		if($hostname<>null){$f[]="\tserver_name $hostname;";}		
		$f[]="\tindex index.html;";
		$f[]="\troot /usr/share/RichFilemanager/;";
		$f[]="$ssl";
		$f[]="";
		$f_php=array();
		
			
		
		
		$f_php[]="";
		$f_php[]="\tlocation ~ [^/]\.php(/|$) {";
		if($RichFileManagerAuthent==1){
			$ldap=new clladp();
			$password=apache_htpassword($ldap->ldap_password);
			$ppass[]="$ldap->ldap_admin:$password";
			@file_put_contents("/etc/artica-postfix/RichFilemanager-htpasswd", @implode("\n", $ppass));
			$f_php[]="\t\tauth_basic           \"Rich Filemanager\";";
			$f_php[]="\t\tauth_basic_user_file /etc/artica-postfix/RichFilemanager-htpasswd;";
		}
		$f_php[]="\t\tfastcgi_split_path_info ^(.+?\.php)(/.*)$;";
		$f_php[]="\t\tif (!-f \$document_root\$fastcgi_script_name) {";
		$f_php[]="\t\t\treturn 404;";
		$f_php[]="\t\t}";
		$f_php[]="\t\tfastcgi_pass 	   unix:/var/run/RichFilemanager.sock;";
		$f_php[]="\t\tfastcgi_buffers 8 16k;";
		$f_php[]="\t\tfastcgi_buffer_size 32k;";
		$f_php[]="\t\tfastcgi_read_timeout 300;";
		$f_php[]="\t\tfastcgi_connect_timeout 300;";
		$f_php[]="\t\tfastcgi_send_timeout 300;";
		$f_php[]="\t\tfastcgi_param   QUERY_STRING             \$query_string;";
		$f_php[]="\t\tfastcgi_param   REQUEST_METHOD           \$request_method;";
		$f_php[]="\t\tfastcgi_param   CONTENT_TYPE             \$content_type;";
		$f_php[]="\t\tfastcgi_param   CONTENT_LENGTH           \$content_length;";
		$f_php[]="";
		$f_php[]="\t\tfastcgi_param   SCRIPT_FILENAME          \$document_root\$fastcgi_script_name;";
		$f_php[]="\t\tfastcgi_param   SCRIPT_NAME              \$fastcgi_script_name;";
		$f_php[]="\t\tfastcgi_param   PATH_INFO                \$fastcgi_path_info;";
		$f_php[]="\t\tfastcgi_param   PATH_TRANSLATED          \$document_root\$fastcgi_script_name;";
		$f_php[]="\t\tfastcgi_param   REQUEST_URI              \$request_uri;";
		$f_php[]="\t\tfastcgi_param   DOCUMENT_URI             \$document_uri;";
		$f_php[]="\t\tfastcgi_param   DOCUMENT_ROOT            \$document_root;";
		$f_php[]="\t\tfastcgi_param   SERVER_PROTOCOL          \$server_protocol;";
		$f_php[]="";
		$f_php[]="\t\tfastcgi_param   GATEWAY_INTERFACE       CGI/1.1;";
		$f_php[]="\t\tfastcgi_param   SERVER_SOFTWARE         Artica/1.0;";
		$f_php[]="";
		$f_php[]="\t\tfastcgi_param   REMOTE_ADDR              \$remote_addr;";
		$f_php[]="\t\tfastcgi_param   REMOTE_PORT              \$remote_port;";
		$f_php[]="\t\tfastcgi_param   SERVER_ADDR              \$server_addr;";
		$f_php[]="\t\tfastcgi_param   SERVER_PORT              \$server_port;";
		$f_php[]="\t\tfastcgi_param   SERVER_NAME              \$server_name;";
		$f_php[]="";
		$f_php[]="\t\tfastcgi_param   HTTPS                    \$https;";
		$f_php[]="";
		$f_php[]="#\t\tPHP only, required if PHP was built with --enable-force-cgi-redirect";
		$f_php[]="\t\tfastcgi_param   REDIRECT_STATUS         200;";
		$f_php[]="\t}";
		$php_params=@implode("\n", $f_php);		
		$f[]=$php_params;
		
		$f[]="}";
		
	}
	

	
	$f[]="}";	
	
	@file_put_contents("/etc/artica-postfix/webconsole.conf", @implode("\n", $f));
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} /etc/artica-postfix/webconsole.conf done..\n";}
	$f=array();
	system("/usr/local/ArticaWebConsole/sbin/artica-webconsole -c /etc/artica-postfix/webconsole.conf -s reload");

	
	
}

function nginx_php_params(){
	
	$UseUnitd=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UseUnitd"));
	if($UseUnitd==1){
		echo "Using Unitd Daemon...\n";
		
		$f_php[]="";
		$f_php[]="\tlocation ~ \.php$ {";
		$f_php[]="\t\tproxy_pass http://127.0.0.1:49778;";
		$f_php[]="\t\tproxy_set_header Host \$host;";
        $f_php[]="\t\tproxy_set_header X-Real-IP \$remote_addr;";
        $f_php[]="\t\tproxy_set_header X-Forwarded-For \$remote_addr;";
		$f_php[]="\t}";
		$f_php[]="";
		return @implode("\n", $f_php);
		
	}
	
	
	
	$f_php[]="";
	$f_php[]="\tlocation ~ [^/]\.php(/|$) {";
	$f_php[]="\t\tfastcgi_split_path_info ^(.+?\.php)(/.*)$;";
	$f_php[]="\t\tif (!-f \$document_root\$fastcgi_script_name) {";
	$f_php[]="\t\t\treturn 404;";
	$f_php[]="\t\t}";
	$f_php[]="\t\tfastcgi_pass 	   unix:/var/run/artica-phpfpm.sock;";
	//$f_php[]="\t\tfastcgi_index index.php;";
	$f_php[]="\t\tfastcgi_buffers 8 16k;";
	$f_php[]="\t\tfastcgi_buffer_size 32k;";
	$f_php[]="\t\tfastcgi_read_timeout 300;";
	$f_php[]="\t\tfastcgi_connect_timeout 300;";
	$f_php[]="\t\tfastcgi_send_timeout 300;";
	$f_php[]="\t\tfastcgi_param   QUERY_STRING             \$query_string;";
	$f_php[]="\t\tfastcgi_param   REQUEST_METHOD           \$request_method;";
	$f_php[]="\t\tfastcgi_param   CONTENT_TYPE             \$content_type;";
	$f_php[]="\t\tfastcgi_param   CONTENT_LENGTH           \$content_length;";
	$f_php[]="";
	$f_php[]="\t\tfastcgi_param   SCRIPT_FILENAME          \$document_root\$fastcgi_script_name;";
	$f_php[]="\t\tfastcgi_param   SCRIPT_NAME              \$fastcgi_script_name;";
	$f_php[]="\t\tfastcgi_param   PATH_INFO                \$fastcgi_path_info;";
	$f_php[]="\t\tfastcgi_param   PATH_TRANSLATED          \$document_root\$fastcgi_script_name;";
	$f_php[]="\t\tfastcgi_param   REQUEST_URI              \$request_uri;";
	$f_php[]="\t\tfastcgi_param   DOCUMENT_URI             \$document_uri;";
	$f_php[]="\t\tfastcgi_param   DOCUMENT_ROOT            \$document_root;";
	$f_php[]="\t\tfastcgi_param   SERVER_PROTOCOL          \$server_protocol;";
	$f_php[]="";
	$f_php[]="\t\tfastcgi_param   GATEWAY_INTERFACE       CGI/1.1;";
	$f_php[]="\t\tfastcgi_param   SERVER_SOFTWARE         Artica/1.0;";
	$f_php[]="";
	$f_php[]="\t\tfastcgi_param   REMOTE_ADDR              \$remote_addr;";
	$f_php[]="\t\tfastcgi_param   REMOTE_PORT              \$remote_port;";
	$f_php[]="\t\tfastcgi_param   SERVER_ADDR              \$server_addr;";
	$f_php[]="\t\tfastcgi_param   SERVER_PORT              \$server_port;";
	$f_php[]="\t\tfastcgi_param   SERVER_NAME              \$server_name;";
	$f_php[]="";
	$f_php[]="\t\tfastcgi_param   HTTPS                    \$https;";
	$f_php[]="";
	$f_php[]="#\t\tPHP only, required if PHP was built with --enable-force-cgi-redirect";
	$f_php[]="\t\tfastcgi_param   REDIRECT_STATUS         200;";
	$f_php[]="\t}";
	
	return @implode("\n", $f_php);
	
}




function nginx_fpm_pid(){
	$unix=new unix();
	$pid=0;
	$pid=$unix->get_pid_from_file("/var/run/artica-phpfpm.pid");
	if(!$unix->process_exists($pid)){ return $unix->PIDOF("/usr/local/ArticaWebConsole/sbin/artica-phpfpm");}
	return $pid;
}

function nginx_fpm_restart(){
	$GLOBALS["OUTPUT"]=true;
	$GLOBALS["SERVICE_NAME"]="Artica Web console (FPM)";
	$PID_PATH="/var/run/artica-phpfpm.restart.pid";
	$midsuffix="[INIT]: {$GLOBALS["SERVICE_NAME"]}";
    $unix=new unix();
    $pid=$unix->get_pid_from_file($PID_PATH);
    if($unix->process_exists($pid)){
        echo "Restarting....: ".date("H:i:s")." $midsuffix Already task $pid running, aborting\n";
        die();
    }

    if(is_file($PID_PATH)){@unlink($PID_PATH);}
    @file_put_contents($PID_PATH,getmypid());


    $nginx_fpm_pid=nginx_fpm_pid();
    if(!$unix->process_exists($nginx_fpm_pid)){
        nginx_fpm_start();
        return;
    }


    $Time=$unix->PROCCESS_TIME_MIN($nginx_fpm_pid);
    echo "Restarting....: ".date("H:i:s")." $midsuffix task $nginx_fpm_pid running since {$Time}mn\n";

    if($Time==0){
        echo "Restarting....: ".date("H:i:s")." $midsuffix Aborting, need to wait 2mn minimum\n";
        die();
    }
    if($Time==1){
        echo "Restarting....: ".date("H:i:s")." $midsuffix Aborting, need to wait 2mn minimum\n";
        die();
    }

	nginx_fpm_stop();
	nginx_fpm_start();
	
}
function build_progress_fpm_reload($text,$pourc){
    if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).")[{$pourc}%] $text\n";}
    $cachefile="/usr/share/artica-postfix/ressources/logs/web/fpm.reload.progress";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($cachefile, serialize($array));
    @chmod($cachefile,0755);

}

function nginx_fpm_reload(){
	$GLOBALS["OUTPUT"]=true;
	$GLOBALS["SERVICE_NAME"]="Artica Web console (FPM)";
	$unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    build_progress_fpm_reload("{reconfiguring} PHP.INI (FPM)",20);
    if($GLOBALS["SLEEP"]>0){
        $unix->ToSyslog("Sleeping {$GLOBALS["SLEEP"]}s","php-fpm");
        sleep($GLOBALS["SLEEP"]);}

    shell_exec("$php /usr/share/artica-postfix/exec.php.ini.php");

    build_progress_fpm_reload("{reloading} Artica Web console (FPM)",50);
	$pid=nginx_fpm_pid();
    build_progress_fpm_reload("{reconfigure} Artica Web console (FPM) PID $pid",60);
    nginx_config();
	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Reloading.....: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} stopped...\n";}
        build_progress_fpm_reload("{starting} Artica Web console (FPM)",80);
		if(!nginx_fpm_start()){
            build_progress_fpm_reload("{starting} Artica Web console (FPM) {failed}",110);
		    return false;
        }
        build_progress_fpm_reload("{starting} Artica Web console (FPM) {success}",100);
		return;
	}

	$kill=$unix->find_program("kill");
	system("$kill -USR2 $pid");
	if($GLOBALS["OUTPUT"]){echo "Reloading.....: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} PID $pid reloaded...\n";}

	if(is_file("/etc/init.d/nginx")){
        system("/usr/local/ArticaWebConsole/sbin/artica-webconsole -c /etc/artica-postfix/webconsole.conf -s reload");
    }

	build_progress_fpm_reload("{reloading} Artica Web console (FPM) {success}",100);
}

function nginx_fpm_stop($aspid=false){
	$GLOBALS["SERVICE_NAME"]="Artica Web console (FPM)";
	$unix=new unix();
	$pid=nginx_fpm_pid();


	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} already stopped...\n";}
		return;
	}

	$pid=nginx_fpm_pid();

	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Shutdown pid $pid...\n";}
	unix_system_kill($pid);
	for($i=0;$i<5;$i++){
		$pid=nginx_fpm_pid();
		if(!$unix->process_exists($pid)){break;}
		unix_system_kill($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} waiting pid:$pid $i/5...\n";}
		sleep(1);
	}

	$pid=nginx_fpm_pid();
	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} success...\n";}
		return;
	}

	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} shutdown - force - pid $pid...\n";}
	unix_system_kill_force($pid);
	for($i=0;$i<5;$i++){
		$pid=nginx_fpm_pid();
		if(!$unix->process_exists($pid)){break;}
		unix_system_kill_force($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} waiting pid:$pid $i/5...\n";}
		sleep(1);
	}

	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} success...\n";}
		return;
	}else{
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} failed...\n";}
	}
}

function nginx_fpm_locate(){
    $unix=new unix();
    $source_fpm = $unix->find_program("php-fpm7.3");
    if(is_file($source_fpm)){return $source_fpm;};
    $source_fpm = $unix->find_program("php-fpm7.0");
    if(is_file($source_fpm)){return $source_fpm;};
}

function nginx_fpm_start(){
	$GLOBALS["SERVICE_NAME"]="Artica Web console (FPM)";
	$unix=new unix();
	
	$UseUnitd=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UseUnitd"));
	
	
	$pid=nginx_fpm_pid();
	if($unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Already running PID $pid\n";}
		@file_put_contents("/var/run/artica-phpfpm.pid", $pid);
		if($UseUnitd==1){
			echo "Starting......: ".date("H:i:s")." [INIT]: Framework switched to unitd, aborting...\n";
			nginx_fpm_stop();
			return true;
		}
		return true;
	}
	
	if($UseUnitd==1){return true;}
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} UseUnitd==$UseUnitd\n";}



    echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} find old instance\n";


	$php=$unix->LOCATE_PHP5_BIN();
	shell_exec("$php /usr/share/artica-postfix/exec.php-fpm-fake.php");

	$pgrep=$unix->find_program("pgrep");
	exec("$pgrep -l -f \"php-fpm.*?/etc/php/7.3/fpm/php-fpm.conf\" 2>&1",$results);

	foreach ($results as $line){
        $line=trim($line);
        echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} \"$line\"\n";
        if(preg_match("#pgrep#",$line)){continue;}
        if(!preg_match("#^([0-9]+)\s+#",$line,$re)){continue;}
        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Killin pid {$re[1]}\n";}
        $unix->KILL_PROCESS($re[1],9);

    }
    echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]}...\n";

$me=__FILE__;

    $md5=null;
    if(is_file("/usr/local/ArticaWebConsole/sbin/artica-phpfpm")) {
        $md5 = md5_file("/usr/local/ArticaWebConsole/sbin/artica-phpfpm");
    }
	$source_fpm=nginx_fpm_locate();


	if(is_file($source_fpm)){
		$md5src=md5_file($source_fpm);
		if($md5src<>$md5){
			@unlink("/usr/local/ArticaWebConsole/sbin/artica-phpfpm");
			@copy($source_fpm, "/usr/local/ArticaWebConsole/sbin/artica-phpfpm");
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} install new binary\n";}
		}
	}
	@chmod("/usr/local/ArticaWebConsole/sbin/artica-phpfpm",0755);
	$cmd[]="/usr/local/ArticaWebConsole/sbin/artica-phpfpm";
	$cmd[]="-c \"/etc/artica-postfix/php-fpm.ini\"";
	$cmd[]="--fpm-config \"/etc/artica-postfix/artica-phpfpm.conf\"";
	$cmd[]="--pid \"/var/run/artica-phpfpm.pid\" --daemonize -R >/dev/null 2>&1 &";

    $sockets[]="/var/run/artica-phpfpm.sock";
    $sockets[]="/var/run/php-fpm-framework.sock";
    $sockets[]="/var/run/nginx-phpfpm.sock";
    $sockets[]="/var/run/phpfpm-articaserv.sock";
    $sockets[]="/var/run/nginx-squid.sock";
    $sockets[]="/var/run/RichFilemanager.sock";

    foreach ($sockets as $fpath){
        if(is_file($fpath)){
            echo "Starting......: ".date("H:i:s")." [INIT]: removing $fpath\n";
            @unlink($fpath);}
    }

	@unlink("/var/run/artica-phpfpm.pid");
	$cmdline=@implode(" ", $cmd);
    echo "Starting......: ".date("H:i:s")." [INIT]: $cmdline\n";
	system($cmdline);
	
	for($i=0;$i<8;$i++){
		$pid=nginx_fpm_pid();
		if($unix->process_exists($pid)){break;}
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} waiting $i/8...\n";}
		sleep(1);
	}
	
	$pid=nginx_fpm_pid();
	if($unix->process_exists($pid)){
		echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Running PID $pid\n";
        echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Apply permissions\n";
		@chmod("/var/run/artica-phpfpm.sock",0777);
		@chmod("/var/run",0755);
		return true;
	}
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} FAILED!!!!\n";}
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} $cmdline\n";}
	return false;
}

function nginx_pid(){
	$unix=new unix();
	$pid=$unix->get_pid_from_file("/var/run/artica-webconsole.pid");
	if(!$unix->process_exists($pid)){ return $unix->PIDOF("/usr/local/ArticaWebConsole/sbin/artica-webconsole");}
	return $pid;
	
}

function nginx_syslog($text){
	if(!function_exists("openlog")){return;}
	openlog("Artica-WebConsole", LOG_PID , LOG_SYSLOG);
	if(!function_exists("syslog")){ return;}
	syslog(true, $text);
	if(function_exists("closelog")){closelog();}

}


function nginx_start(){
	
	$unix=new unix();
	if(!is_file("/etc/artica-postfix/artica-phpfpm.conf")){nginx_config();}
	if(!is_file("/etc/artica-postfix/webconsole.conf")){nginx_config();}
	if(!nginx_fpm_start()){return;}
	$GLOBALS["SERVICE_NAME"]="Artica Web console (Main)";
	
	
	
	$pid=nginx_pid();
	if($unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Web Service Already running PID $pid\n";}
		nginx_syslog("[START]: {$GLOBALS["SERVICE_NAME"]} Web Service Already running PID $pid");
		if($GLOBALS["MONIT"]){system("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload");}
		@file_put_contents("/var/run/artica-webconsole.pid", $pid);
		return true;
		
	}
	
	@mkdir("/var/lib/php5/sessions",01777,true);
	@chown("/var/lib/php5/sessions", "www-data");
	@chmod("/var/lib/php5/sessions", 01777);
	@chown("/var/lib/php5", "www-data");
	if(!is_dir("/var/lighttpd/upload")){@mkdir("/var/lighttpd/upload",0755,true);}
	@chown("/var/lighttpd/upload","www-data");
	@chgrp("/var/lighttpd/upload", "www-data");
	
	
	$cmdline="/usr/local/ArticaWebConsole/sbin/artica-webconsole -c /etc/artica-postfix/webconsole.conf >/dev/null 2>&1 &";
	system("$cmdline");
	
	for($i=0;$i<8;$i++){
		$pid=nginx_pid();
		if($unix->process_exists($pid)){break;}
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} waiting $i/8...\n";}
		sleep(1);
	}
	
	$pid=nginx_pid();
	if($unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Web Service running PID $pid\n";}
		nginx_syslog("[START]: {$GLOBALS["SERVICE_NAME"]} Web Service Started PID $pid");
		if($GLOBALS["MONIT"]){system("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload");}
		return true;
	}
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Web Service FAILED!!!!\n";}
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} $cmdline\n";}
	
	
}

function start($aspid=false){
	$unix=new unix();
	if(is_file("/etc/artica-postfix/FROM_ISO")){
		if($unix->file_time_min("/etc/artica-postfix/FROM_ISO")<1){return;}
	}
	
	nginx_start();

}


//##############################################################################
function LIGHTTPD_PID(){
	$unix=new unix();
	$pid=$unix->get_pid_from_file('/var/run/lighttpd/lighttpd.pid');
	if($unix->process_exists($pid)){return $pid;}
	$lighttpd_bin=$unix->find_program("lighttpd");
	$LIGHTTPD_CONF_PATH=LIGHTTPD_CONF_PATH();
	return $unix->PIDOF_PATTERN($lighttpd_bin." -f $LIGHTTPD_CONF_PATH");
}
//##############################################################################
function  LIGHTTPD_CONF_PATH(){
	if(isset($GLOBALS["LIGHTTPD_CONF_PATH"])){return $GLOBALS["LIGHTTPD_CONF_PATH"];}
	$f[]="/etc/lighttpd/lighttpd.conf";
 	$f[]="/etc/lighttpd/lighttpd.conf";
  	$f[]="/opt/artica/conf/lighttpd.conf";
 	$f[]="/usr/local/etc/lighttpd.conf";
 	foreach ($f as $pid=>$line){
 		if(is_file($line)){
 			$GLOBALS["LIGHTTPD_CONF_PATH"]=$line;
 			return $line;}
 	}
 	$GLOBALS["LIGHTTPD_CONF_PATH"]="/etc/lighttpd/lighttpd.conf";
 	return $GLOBALS["LIGHTTPD_CONF_PATH"];
}
//##############################################################################
function LIGHTTPD_MODULES_PATH(){
	$f[]="/usr/lib64/lighttpd/mod_alias.so";
	$f[]="/usr/local/lib64/lighttpd/mod_alias.so";
	$f[]="/usr/lib/lighttpd/mod_alias.so";
	$f[]="/usr/local/lib/lighttpd/mod_alias.so";
	foreach ($f as $pid=>$line){
		if(is_file($line)){return dirname($line);}
	}	
}
//##############################################################################
function AWSTATS_www_root(){
	$f[]="/usr/local/awstats/wwwroot/icon";
	$f[]="/usr/share/awstats/icon";
	$f[]="/var/www/awstats/icon";
	$f[]="/usr/share/awstats/wwwroot/icon";
	foreach ($f as $pid=>$line){
		if(is_dir($line)){return $line;}
	}
}
//##############################################################################
function isModule($modulename){
	$LOAD_MODULES=LOAD_MODULES();
	$modulename=trim(strtolower($modulename));
	if(isset($LOAD_MODULES[$modulename])){return true;}
	$libdir=LIGHTTPD_MODULES_PATH();
	if(is_file("$libdir/$modulename.so")){return true;}
	return false;
}
//##############################################################################   
function LOAD_MODULES(){
	
	if(isset($GLOBALS["LIGHTTPDMODS"])){return $GLOBALS["LIGHTTPDMODS"];}
	$unix=new unix();
	$lighttpd=$unix->find_program("lighttpd");
	if(!is_file($lighttpd)){return;}
	exec("$lighttpd -V 2>&1",$results);
	foreach ($results as $pid=>$line){
		if(preg_match('#\+\s+(.+?)\s+support#',$line,$re)){
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Available module.....: \"{$re[1]}\"\n";}
			$re[1]=trim(strtolower($re[1]));
			$GLOBALS["LIGHTTPDMODS"][$re[1]]=true;
			continue;
		}
			
	}
}	
//##############################################################################
function LIGHTTPD_GET_USER(){
	$sock=new sockets();
	$user=trim($sock->GET_INFO('LighttpdUserAndGroup'));
	
	if($user<>null){
		$user=str_replace("lighttpd:lighttpd:lighttpd", "lighttpd:lighttpd", $user);
		$user=str_replace("www-data:www-data:www-data", "www-data:www-data", $user);
		return $user;
	}
	
	$LIGHTTPD_CONF_PATH=LIGHTTPD_CONF_PATH();
	$f=explode("\n",@file_get_contents($LIGHTTPD_CONF_PATH));
	$mem=null;
	$gp=null;
	foreach ($f as $pid=>$line){
		if(preg_match('#^server\.username.+?"(.+?)"#', $line,$re)){$mem=$re[1];continue;}
		if(preg_match('#^server\.groupname.+?"(.+?)"#', $line,$re)){$gp=$re[1];continue;}	
		if( ($mem<>null) && ($gp<>null) ){
			$sock->SET_INFO("LighttpdUserAndGroup", "$mem:$gp");
			return "$mem:$gp";}
		}
		
		return "www-data:www-data";

}
//##############################################################################
function apache_troubleshoot(){}
function debian_version(){
	if(!is_file("/etc/debian_version")){return;}
	$ver=trim(@file_get_contents("/etc/debian_version"));
	preg_match("#^([0-9]+)\.#",$ver,$re);
	if(preg_match("#squeeze\/sid#",$ver)){return 6;}
	$Major=$re[1];
	if(!is_numeric($Major)){return;}

	return $Major;

}





function apache_config(){}




function apache_htpassword($clearTextPassword){
	$password = crypt($clearTextPassword, base64_encode($clearTextPassword));
	return $password;
}


function apache_webdav(){}
function apache_firewall(){}
function buildConfig(){}
function PHP_MYADMIN(){
	$sock=new sockets();
	$phpmyadminAllowNoPassword=$sock->GET_INFO("phpmyadminAllowNoPassword");
	if(!is_numeric($phpmyadminAllowNoPassword)){$phpmyadminAllowNoPassword=0;}
	if(!is_file('/usr/share/phpmyadmin/index.php')){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} PhpMyAdmin: /usr/share/phpmyadmin/index.php no such file\n";}
		return;
	}
	include_once(dirname(__FILE__)."/ressources/class.mysql.inc");
	
	if(is_file('/etc/artica-postfix/phpmyadmin_config.txt')){$phpmyadmin_config_add=@file_get_contents('/etc/artica-postfix/phpmyadmin_config.txt');}
	@mkdir("/usr/share/phpmyadmin/config",0755,true);
	
	
	$database_password=@file_get_contents("/etc/artica-postfix/settings/Mysql/database_password");
	if(database_password=='!nil'){$database_password=null;}
	
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} PhpMyAdmin: AllowNoPassword=$phpmyadminAllowNoPassword\n";}
	//$phpmyadminAllowNoPassword
	
	$q=new mysql();
	$f[]='<?php';
	$f[]='/* Servers configuration */';
	$f[]='$i = 0;';
	$f[]='';
	$f[]='/* Server: Artica Mysql [1] */';
	$f[]='$i++;';
	$f[]='$cfg["Servers"][$i]["verbose"] = "Artica Mysql";';
	$f[]='$cfg["Servers"][$i]["host"] = "'.$q->mysql_server.'";';
	$f[]='$cfg["Servers"][$i]["port"] = '.$q->mysql_port.';';
	$f[]='$cfg["Servers"][$i]["socket"] = "'.$q->SocketName.'";';
	$f[]='$cfg["Servers"][$i]["connect_type"] = "tcp";';
	$f[]='$cfg["Servers"][$i]["extension"] = "mysql";';
	$f[]='$cfg["Servers"][$i]["auth_type"] = "cookie";';
	$f[]='$cfg["Servers"][$i]["user"] = "'.$q->mysql_admin.'";';
	$f[]='$cfg["Servers"][$i]["password"] = "'.$q->mysql_password.'";';
	if($phpmyadminAllowNoPassword==1){  $f[]='$cfg["Servers"][$i]["AllowNoPassword"] = True;';}
	if(is_file('/opt/squidsql/bin/mysqld')){
		$f[]='$i++;';
		$f[]='$cfg["Servers"][$i]["verbose"] = "Squid Mysql";';
		$f[]='$cfg["Servers"][$i]["socket"] = "/var/run/mysqld/squid-db.sock";';
		$f[]='$cfg["Servers"][$i]["connect_type"] = "socket";';
		$f[]='$cfg["Servers"][$i]["extension"] = "mysql";';
		$f[]='$cfg["Servers"][$i]["auth_type"] = "cookie";';
		$f[]='$cfg["Servers"][$i]["user"] = "root";';
		$f[]='$cfg["Servers"][$i]["password"] = "";';
		$f[]='$cfg["Servers"][$i]["AllowNoPassword"] = True;';
	}

	
	
	$f[]='';
	if($phpmyadmin_config_add<>null){$f[]=$phpmyadmin_config_add;}
	$f[]='/* End of servers configuration */';
	$f[]='';
	$f[]='$cfg["blowfish_secret"] = "4bf112360c9db0.66618545";';
	$f[]='$cfg["DefaultLang"] = "en-utf-8";';
	$f[]='$cfg["ServerDefault"] = 1;';
	$f[]='$cfg["UploadDir"] = "";';
	$f[]='$cfg["SaveDir"] = "";';
	$f[]='?>';
	@file_put_contents('/usr/share/phpmyadmin/config.inc.php',@implode("\n", $f));

	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} PhpMyAdmin: Success writing phpmyadmin configuration\n";}
	IF(is_dir('/usr/share/phpmyadmin/setup')){shell_exec('/bin/rm -rf /usr/share/phpmyadmin/setup');}
	IF(is_dir('/usr/share/phpmyadmin/config')){shell_exec('/bin/rm -rf /usr/share/phpmyadmin/config');}
	
}
function islighttpd_error_500(){
	$sock=new sockets();
	$unix=new unix();
	
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pid=$unix->get_pid_from_file($pidfile);
	if($unix->process_exists($pid,basename(__FILE__))){
		$time=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Already Artica task running PID $pid since {$time}mn\n";}
		return;
	}

	@file_put_contents($pidfile, getmypid());	
	
	$curl=$unix->find_program("curl");
	if(!is_file($curl)){return;}
	$LighttpdArticaListenIP=$sock->GET_INFO('LighttpdArticaListenIP');
	$ArticaHttpsPort=9000;
	$ArticaHttpUseSSL=1;
	$ArticaHttpsPort=$sock->GET_INFO("ArticaHttpsPort");
	$ArticaHttpUseSSL=$sock->GET_INFO("ArticaHttpUseSSL");
	if(!is_numeric($ArticaHttpUseSSL)){$ArticaHttpUseSSL=1;}
	if(!is_numeric($ArticaHttpsPort)){$ArticaHttpsPort="9000";}
	$EnableArticaFrontEndToNGninx=$sock->GET_INFO("EnableArticaFrontEndToNGninx");
	if(!is_numeric($EnableArticaFrontEndToNGninx)){$EnableArticaFrontEndToNGninx=0;}
	$proto="http";
	if($ArticaHttpUseSSL==1){$proto="https";}
	
	if($LighttpdArticaListenIP<>null){
		$IPS=$unix->NETWORK_ALL_INTERFACES(true);
		if(!isset($IPS[$LighttpdArticaListenIP])){$LighttpdArticaListenIP=null;}
	}
	
	
	if(strlen($LighttpdArticaListenIP)>3){
		$ips[$LighttpdArticaListenIP]=true;
		$uri="$proto://$LighttpdArticaListenIP:$ArticaHttpsPort/logon.php";
	}else{
		$ips=$unix->NETWORK_ALL_INTERFACES(true);
		unset($ips["127.0.0.1"]);
	}
	
	while (list ($ipaddr, $line) = each ($ips) ){
		$f=array();
		$results=array();
		$uri="$proto://$ipaddr:$ArticaHttpsPort/logon.php";
		$f[]="$curl -I --connect-timeout 5";
		$f[]="--insecure";
		$f[]="--interface $ipaddr";
		$f[]="--url $uri 2>&1";
		$cmdline=@implode(" ", $f);
		if($GLOBALS['VERBOSE']){echo "$cmdline\n";}
		exec(@implode(" ", $f),$results);
		if($GLOBALS['VERBOSE']){echo count($results)." rows\n";}
		
		if(DetectError($results,"Artica Web Interface")){if($EnableArticaFrontEndToNGninx==1){shell_exec("/etc/init.d/nginx restart");}else{restart(true);}}
		
		
	}
	
	$results=array();
	if($GLOBALS['VERBOSE']){echo "done\n";}
	
}
function FrmToSyslog($text){

	$LOG_SEV=LOG_INFO;
	if(function_exists("openlog")){openlog(basename(__FILE__), LOG_PID , LOG_SYSLOG);}
	if(function_exists("syslog")){ syslog($LOG_SEV, $text);}
	if(function_exists("closelog")){closelog();}
}
function DetectError($results,$type){
	foreach ($results as $a=>$b){
		if($GLOBALS["VERBOSE"]){echo "$a \"$b\"\n";}
		if(preg_match("#HTTP.+?200 OK#", $b)){
			if($GLOBALS['VERBOSE']){echo "$type: 200 OK Nothing to do...\n";}
			return false;
		}
	
		IF(preg_match("#HTTP.*?502 Bad Gateway#", $b)){
			$GLOBALS["DetectError"]="$b";
			if($GLOBALS['VERBOSE']){echo "$b detected\n";}
			squid_admin_mysql(2, "$type: $b detected ",__FUNCTION__,__FILE__,__LINE__);
			return true;
		}
			
		IF(preg_match("#HTTP.*?500.*?Error#", $b)){
			$GLOBALS["DetectError"]="$b";
			if($GLOBALS['VERBOSE']){echo "$b detected\n";}
			squid_admin_mysql(2, "$type: $b detected",__FUNCTION__,__FILE__,__LINE__);
			return true;
		}
		
		IF(preg_match("#HTTP.*?500.*?Internal#", $b)){
			$GLOBALS["DetectError"]="$b";
			if($GLOBALS['VERBOSE']){echo "$b detected\n";}
			squid_admin_mysql(2, "$type: $b detected",__FUNCTION__,__FILE__,__LINE__);
			return true;
		}
		
		IF(preg_match("#HTTP.*?503.*?Service Not Available#i", $b)){
			$GLOBALS["DetectError"]="$b";
			if($GLOBALS['VERBOSE']){echo "$b detected\n";}
			squid_admin_mysql(2, "$type: $b detected",__FUNCTION__,__FILE__,__LINE__);
			return true;		
		}		
		
			
	}	
	
	
}

function phpcgi(){
	$unix=new unix();
	$phpcgi=$unix->LIGHTTPD_PHP5_CGI_BIN_PATH();
	
	$pids=$unix->PIDOF_PATTERN_ALL($phpcgi);
	if(count($pids)==0){return;}
	$c=0;
	foreach ($pids as $pid=>$ligne){
		$time=$unix->PROCESS_TTL($pid);
		
		if($time>1640){
			$c++;
			$unix->KILL_PROCESS($pid,9);
		}
	}
}
function php_snmp_progress($text,$pourc){
	if(!$GLOBALS["PROGRESS"]){return;}
	echo $text."\n";
	$cachefile="/usr/share/artica-postfix/ressources/logs/web/php-snmp.progress";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($cachefile, serialize($array));
	@chmod($cachefile,0755);
	sleep(1);
}
function php_snmp(){
	$unix=new unix();
	php_snmp_progress("{checking_php_snmp}",20);
	$unix->DEBIAN_INSTALL_PACKAGE("php5-snmp");
	$nohup=$unix->find_program("nohup");
	
	if(is_file("/usr/lib/php5/20090626/snmp.so")){
		php_snmp_progress("{checking_php_snmp} {success}",100);
		sleep(5);
		system("$nohup /etc/init.d/artica-webconsole restart >/dev/null 2>&1 &");
		system("$nohup /etc/init.d/artica-status restart >/dev/null 2>&1 &");
	}
	
	
	if(is_file("/usr/lib/php5/20100525/snmp.so")){
		php_snmp_progress("{checking_php_snmp} {success}",100);
		sleep(5);
		system("$nohup /etc/init.d/artica-webconsole restart >/dev/null 2>&1 &");
		system("$nohup /etc/init.d/artica-status restart >/dev/null 2>&1 &");
	}
	
	php_snmp_progress("{checking_php_snmp} {failed}",110);
	
	
	//php5-snmp
	
	
}

