<?php
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
$GLOBALS["FORCE"]=false;
$GLOBALS["RECONFIGURE"]=false;
$GLOBALS["SWAPSTATE"]=false;
$GLOBALS["NOSQUIDOUTPUT"]=true;
$GLOBALS["VERBOSE"]=false;
$GLOBALS["RELOAD"]=false;
$GLOBALS["pidStampReload"]="/etc/artica-postfix/pids/".basename(__FILE__).".Stamp.reload.time";
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;$GLOBALS["OUTPUT"]=true;
$GLOBALS["debug"]=true;
ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
if(preg_match("#--output#",implode(" ",$argv))){$GLOBALS["OUTPUT"]=true;}
if(preg_match("#schedule-id=([0-9]+)#",implode(" ",$argv),$re)){$GLOBALS["SCHEDULE_ID"]=$re[1];}
if(preg_match("#--force#",implode(" ",$argv),$re)){$GLOBALS["FORCE"]=true;}
if(preg_match("#--reconfigure#",implode(" ",$argv),$re)){$GLOBALS["RECONFIGURE"]=true;}




$GLOBALS["AS_ROOT"]=true;
include_once(dirname(__FILE__).'/framework/class.unix.inc');
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.settings.inc');
include_once(dirname(__FILE__).'/ressources/class.resolv.conf.inc');
include_once(dirname(__FILE__).'/ressources/class.nginx.params.inc');

	$GLOBALS["ARGVS"]=implode(" ",$argv);
	if($argv[1]=="--dump-modules"){$GLOBALS["OUTPUT"]=true;dump_nginx_params();exit;}
	if($argv[1]=="--reconfigure-all-reboot"){$GLOBALS["OUTPUT"]=true;reconfigure_all();exit;}
	if($argv[1]=="--stop"){$GLOBALS["OUTPUT"]=true;stop();exit();}
	if($argv[1]=="--start"){$GLOBALS["OUTPUT"]=true;start();exit();}
	if($argv[1]=="--restart"){$GLOBALS["OUTPUT"]=true;restart();exit();}
	if($argv[1]=="--restart-build"){$GLOBALS["OUTPUT"]=true;restart_build();exit();}
	if($argv[1]=="--reload"){$GLOBALS["OUTPUT"]=true;reload();exit();}
	if($argv[1]=="--force-restart"){$GLOBALS["OUTPUT"]=true;force_restart();exit();}
	if($argv[1]=="--build"){$GLOBALS["OUTPUT"]=true;$GLOBALS["RECONFIGURE"]=true;build();exit();}
	if($argv[1]=="--main"){$GLOBALS["OUTPUT"]=true;$GLOBALS["RECONFIGURE"]=true;build(true);exit();}
	if($argv[1]=="--status"){die();exit;}
	if($argv[1]=="--rotate"){rotate();exit;}
	if($argv[1]=="--awstats"){awstats();exit;}
	if($argv[1]=="--caches-status"){caches_status();exit;}
	if($argv[1]=="--framework"){$GLOBALS["OUTPUT"]=true;framework();exit;}
	if($argv[1]=="--tests-sources"){test_sources();exit;}
	if($argv[1]=="--authenticator"){$GLOBALS["OUTPUT"]=true;authenticator(true);exit;}
	if($argv[1]=="--purge-cache"){$GLOBALS["OUTPUT"]=true;purge_cache($argv[2]);exit;}
	if($argv[1]=="--purge-all-caches"){$GLOBALS["OUTPUT"]=true;purge_all_caches();exit;}
	if($argv[1]=="--import-file"){$GLOBALS["OUTPUT"]=true;import_file();exit;}
	if($argv[1]=="--import-bulk"){$GLOBALS["OUTPUT"]=true;import_bulk();exit;}
	if($argv[1]=="--mem"){exit;}
	if($argv[1]=="--mymem"){exit;}
	
	echo "Unable to understand this command\n";
	echo "Should be:\n";
	echo "--framework...........: Build framework\n";
	echo "--caches-status.......: Build caches status\n";
	echo "--build-default.......: Build default website\n";
	


function nginx_version(){
	if(isset($GLOBALS["nginx_version"])){return $GLOBALS["nginx_version"];}
	$unix=new unix();
	$bin=$unix->find_program("nginx");
	if(!is_file($bin)){return 0;}

	exec("$bin -v 2>&1",$array);
	foreach ($array as $pid=>$line){
		if(preg_match("#\/([0-9\.\-]+)#i", $line,$re)){
			$GLOBALS["nginx_version"]=$re[1];
			return $re[1];}
			if($GLOBALS['VERBOSE']){echo "nginx_version(), $line, not found \n";}
	}

}

function dump_nginx_params(){
	
		$unix=new unix();
		$ARRAY=$unix->NGINX_COMPILE_PARAMS();
		

	foreach ($ARRAY["MODULES"] as $a=>$b){echo "Module: \"$a\"\n";}
    foreach ($ARRAY["ARGS"] as $a=>$b){echo "Params: \"$a\"\n";}


    if(!isset($ARRAY["MODULES"]["ngx_http_geoip2_module-1.0"])){
        echo "NginxHTTPGeoIP2: \"0\"\n";
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("NginxHTTPGeoIP2", 0);
    }else{
        echo "NginxHTTPGeoIP2: \"1\"\n";
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("NginxHTTPGeoIP2", 1);
    }
    if(!isset($ARRAY["MODULES"]["ngx_http_modsecurity-1.0"])){
        echo "NginxHTTPModSecurity: \"0\"\n";
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("NginxHTTPModSecurity", 0);
    }else{
        echo "NginxHTTPModSecurity: \"1\"\n";
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("NginxHTTPModSecurity", 1);
    }



	if(!isset($ARRAY["ARGS"]["HTTP_SUB_MODULE"])){
        echo "NginxHTTPSubModule: \"0\"\n";
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("NginxHTTPSubModule", 0);
    }else{
        echo "NginxHTTPSubModule: \"1\"\n";
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("NginxHTTPSubModule", 1);
    }

	if(!isset($ARRAY["ARGS"]["WITH-HTTP_AUTH_REQUEST_MODULE"])){
		echo "NginxHTTPAuthRequest: \"0\"\n";
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NginxHTTPAuthRequest", 0);
	}else{
		echo "NginxHTTPAuthRequest: \"1\"\n";
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NginxHTTPAuthRequest", 1);
	}
    if(!isset($ARRAY["ARGS"]["HTTP_V2_MODULE"])){
        echo "NginxHTTPV2Module: \"0\"\n";
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("NginxHTTPV2Module", 0);
    }else{
        echo "NginxHTTPV2Module: \"1\"\n";
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("NginxHTTPV2Module", 1);
    }





	
	
	
	
	
}

function security_limit($APACHE_USER){
	$unix=new unix();
	$workers=$unix->CPU_NUMBER();
	$limit=4096*$workers;
	if($limit>65535){$limit=65535;}
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") Running limit of $limit open files\n";}
	
	
	$L=explode("\n",@file_get_contents("/etc/security/limits.conf"));
	$FOUNDL=false;
	$T=array();
	while (list ($index, $line) = each ($L)){
		$line=trim($line);
		if(trim($line)==null){continue;}
		if(substr($line, 0,1)=="#"){continue;}
		if(preg_match("#^$APACHE_USER#", $line)){continue;}
		$T[]=$line;
	}
	
	if(!$FOUNDL){
		$T[]="$APACHE_USER       soft    nofile   $limit";
		$T[]="$APACHE_USER       hard    nofile   $limit";
	}
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") $APACHE_USER /etc/security/limits.conf DONE\n";}
	@file_put_contents("/etc/security/limits.conf", @implode("\n", $T)."\n");
}
	

function build(){
	if(isset($GLOBALS[__FILE__.__FUNCTION__])){return;}
	$GLOBALS[__FILE__.__FUNCTION__]=true;
	$unix=new unix();
	$php5=$unix->LOCATE_PHP5_BIN();
	build_progress("{building_main_settings}",10);
    $NginxHTTPSubModule=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NginxHTTPSubModule"));
	$APACHE_USER=$unix->APACHE_SRC_ACCOUNT();
	$APACHE_SRC_GROUP=$unix->APACHE_SRC_GROUP();

	$Tempdir=$unix->TEMP_DIR()."/nginx";
    $Dirs[]=$Tempdir;
    $Dirs[]="/var/log/apache2";
    $Dirs[]="/home/nginx/tmp";
    $Dirs[]="/var/log/nginx";
    $Dirs[]="/etc/nginx/sites-enabled";
    $Dirs[]="/etc/nginx/local-sites";
    $Dirs[]="/etc/nginx/local-sslsites";
    $Dirs[]="/var/lib/nginx/fastcgi";
    $Dirs[]="/home/nginx/fastcgi_cache";

    foreach ($Dirs as $directory){
        if(!is_dir($directory)){@mkdir($directory,0755,true);}
        @chown($directory,"www-data");
        @chgrp($directory,"www-data");
        $unix->chown_func($APACHE_USER,$APACHE_SRC_GROUP, $directory);

    }

	nginx_ulimit();
	$workers=$unix->CPU_NUMBER();

	
	build_progress("Building configuration",15);
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Running $APACHE_USER:$APACHE_SRC_GROUP..\n";}
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Running $workers worker(s)..\n";}
	

	
	if(is_file("/etc/nginx/sites-enabled/default")){@unlink("/etc/nginx/sites-enabled/default");}
	if(is_link("/etc/nginx/sites-enabled/default")){@unlink("/etc/nginx/sites-enabled/default");}
	if(is_link("/etc/nginx/conf.d/example_ssl.conf")){@unlink("/etc/nginx/conf.d/example_ssl.conf");}
	
	
	$nginxsock=new socksngix(0);
	$NginxProxyStorePath=$nginxsock->GET_INFO("NginxProxyStorePath");
	
	
	if($NginxProxyStorePath==null){$NginxProxyStorePath="/home/nginx";}
	if(!is_dir($NginxProxyStorePath)) {
        @mkdir($NginxProxyStorePath, 0755, true);
    }
    $unix->chown_func($APACHE_USER,$APACHE_SRC_GROUP, $NginxProxyStorePath);
	$paths[]="tmp";
    $paths[]="disk";
    $paths[]="AuthCache";
    $paths[]="BigCache";

    foreach ($paths as $dir){
        $directory="$NginxProxyStorePath/$dir";
        if(!is_dir($directory)){@mkdir($directory,0755,true);}
        $unix->chown_func($APACHE_USER,$APACHE_SRC_GROUP, $directory);
    }

	
	$limit=4096*$workers;
	if($limit>65535){$limit=65535;}
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") Running limit of $limit open files\n";}
	
	security_limit($APACHE_USER);
	$L=array();
	$T=array();
	
	$MEMORY=$unix->MEM_TOTAL_INSTALLEE();
	$server_names_hash_bucket_size=128;
	$worker_connections=8192;
	
	
	if($MEMORY<624288){
		$server_names_hash_bucket_size=64;
		$worker_connections=1024;
		$workers=4;
	}
	
	$f[]="# Builded on ".date("Y-m-d H:i:s");
	$f[]="user   $APACHE_USER;";
	$f[]="worker_processes  $workers;";
	$nginx_version=nginx_version();
	
	preg_match("#^([0-9])+\.([0-9]+)\.#", $nginx_version,$re);
	$re[1]=intval($re[1]);
	$re[2]=intval($re[2]);
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") Major {$re[1]} Minor:{$re[2]}\n";}
	$syslog=false;
	
	$f[]="worker_rlimit_nofile 65535;";
	$f[]="timer_resolution 1ms;";
	$f[]="";
	if($re[1]>0){
		if($re[2]>6){
			$f[]="error_log syslog:server=127.0.0.1,facility=daemon info;";
			$syslog=true;
		}
	}
	
	
	$syslog=false;
	if(!$syslog){
		$f[]="error_log  /var/log/nginx/error.log warn;";
	}
	$f[]="pid        /var/run/nginx.pid;";
	$f[]="";
	$f[]="";
	$f[]="events {";
	$f[]="    worker_connections  $worker_connections;";
	$f[]="    multi_accept  on;";
	$f[]="    use epoll;";
	$f[]="	  accept_mutex_delay 1ms;";
	$f[]="}";
	
	
	
	$NginxLBIpaddr=$nginxsock->GET_INFO("set_real_ip_from");
	$gzip=intval($nginxsock->GET_INFO("gzip"));
	
	$logf="-";

	$f[]="";
	$f[]="";
	
	$f[]="http {";
	$f[]="geo \$dollar { default \"$\"; }";
	$f[]="\tinclude /etc/nginx/mime.types;";
	
	
	if($NginxLBIpaddr<>null){
		$NginxLBIpaddrZ=explode(",",$NginxLBIpaddr);
		$c=0;
		foreach ($NginxLBIpaddrZ as $ipaddr){
			$f[]="\tset_real_ip_from   $ipaddr;";
			$c++;
		}
		
		if($c>0){
			$f[]="\treal_ip_header      X-Forwarded-For;";
			$logf="\$http_x_forwarded_for";
		}
	}

    if($NginxHTTPSubModule==1) {
        $f[] = "\tsub_filter_types *;";
        $f[] = "\tsub_filter_once off;";
        $f[] = "\tsub_filter_last_modified on;";

    }
	
	$f[]="\tlog_format  awc_log";
	$f[]="\t\t'ngx[\$server_name] \$remote_addr $logf \$remote_user [\$time_local] \$request '";
	$f[]="\t\t'\"\$status\" \$body_bytes_sent \"\$http_referer\" '";
	$f[]="\t\t'\"\$http_user_agent\" \"\$http_x_forwarded_for\" [\$upstream_cache_status]';";
	$f[]="";
    $f[] = "\tlog_format kuu3 '\"\$time_local\",\"\$remote_addr\",\"\$http_x_forwarded_for\",\"\$bytes_sent\",\"\$status\",\"\$request\"';";


	$f[]="\tlimit_conn_zone \$binary_remote_addr zone=LimitCnx:10m;";
	$f[]="\tlimit_conn_log_level info;";
	$f[]="\tclient_body_temp_path $Tempdir 1 2;";
	$f[]="\tclient_header_timeout 5s;";
	$f[]="\tclient_body_timeout 5s;";
	$f[]="\tsend_timeout 10m;";
	$f[]="\tconnection_pool_size 128k;";
	$f[]="\tclient_header_buffer_size 16k;";
	$f[]="\tlarge_client_header_buffers 1024 128k;";
	$f[]="\trequest_pool_size 128k;";
	$f[]="\tkeepalive_requests 1000;";
	$f[]="\tkeepalive_timeout 10;";
	$f[]="\tclient_max_body_size 10g;";
	$f[]="\tclient_body_buffer_size 1m;";
	$f[]="\tclient_body_in_single_buffer on;";
	$f[]="\topen_file_cache max=10000 inactive=300s;";
	$f[]="\treset_timedout_connection on;";
	$f[]="\ttypes_hash_max_size 8192;";
	$f[]="\tserver_names_hash_bucket_size 128;";
	$f[]="\tserver_names_hash_max_size 512;";
	$f[]="\tvariables_hash_max_size 512;";
	$f[]="\tvariables_hash_bucket_size 128;";
    $f[]="\tfastcgi_cache_path /home/nginx/fastcgi_cache levels=1:2 keys_zone=cgicache:10m max_size=2g inactive=60m use_temp_path=off;";
    $f[]="\tfastcgi_cache_key \$scheme\$request_method\$host\$request_uri;";
    $f[]="\tfastcgi_cache_lock on;";
    $f[]="\tfastcgi_cache_revalidate on;";
    $f[]="\tfastcgi_cache_background_update on;";
    $f[]="\tfastcgi_cache_use_stale error timeout invalid_header updating http_500;";
    $f[]="\tfastcgi_cache_valid any 60m;";
    $f[]="\tfastcgi_pass_header Set-Cookie;";
    $f[]="\tfastcgi_pass_header Cookie;";
    $f[]="\tfastcgi_ignore_headers Cache-Control Expires Set-Cookie;";
    $f[]="\tfastcgi_buffers 8 16k;";
	$f[]="\tfastcgi_buffer_size 32k;";
	$f[]="\tfastcgi_connect_timeout 300;";
	$f[]="\tfastcgi_send_timeout 300;";
	$f[]="\tfastcgi_read_timeout 300;";



	$f[]="\tmap \$scheme \$server_https {";
	$f[]="\t\tdefault off;";
	$f[]="\t\thttps on;";
	$f[]="\t}	";	
	$f[]="#";
	$f[]="#----------------- GZIP ---------------------------";
	$f[]="\tgzip           ".$nginxsock->OnOff($gzip).";";
	$f[]="\tgzip_disable    msie6;";
	$f[]="\tgzip_static     on;";
	$f[]="\tgzip_min_length 1100;";
	$f[]="\tgzip_buffers 16 8k;";
	$f[]="\tgzip_comp_level 9;";
	$f[]="\tgzip_types      text/plain text/css application/json application/x-javascript text/xml application/xml application/xml+rss text/javascript;";
	$f[]="\tgzip_vary       on;";
	$f[]="\tgzip_proxied    any;";
	$f[]="#---------------------------------------------------";
	$f[]="#";
	
	$f[]="\toutput_buffers 1000 128k;";
	$f[]="\tpostpone_output 1460;";
	$f[]="\tsendfile on;";
	$f[]="\tsendfile_max_chunk 256k;";
	$f[]="\ttcp_nopush on;";
	$f[]="\ttcp_nodelay on;";
	$f[]="\tserver_tokens off;";
	
	$dns=new resolv_conf();
	$UnboundEnabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundEnabled"));
	if($UnboundEnabled==1) {
        $resolver[] = "127.0.0.1";
    }else {
        if ($dns->MainArray["DNS1"] <> null) {
            $resolver[] = $dns->MainArray["DNS1"];
        }
        if ($dns->MainArray["DNS2"] <> null) {
            $resolver[] = $dns->MainArray["DNS2"];
        }
        if ($dns->MainArray["DNS3"] <> null) {
            $resolver[] = $dns->MainArray["DNS3"];
        }
    }
	
	$f[]="\tresolver ". @implode(" ", $resolver).";";
	$f[]="\tignore_invalid_headers on;";
	$f[]="\tindex index.html;";
	$f[]="\tadd_header X-CDN \"Served by myself\";";

    $BigCacheInactive=intval($nginxsock->GET_INFO("BigCacheInactive"));
    if($BigCacheInactive==0){$BigCacheInactive=180;}

    $BigCacheMaxSize=intval($nginxsock->GET_INFO("BigCacheMaxSize"));
    if($BigCacheMaxSize==0){$BigCacheMaxSize=5;}

    $BigCacheMaxFiles=intval($nginxsock->GET_INFO("BigCacheMaxFiles"));
    if($BigCacheMaxFiles==0){$BigCacheMaxFiles=80000;}

    $BigCacheMaxFilesCacl=round($BigCacheMaxFiles/8000);


	$f[]="\tproxy_cache_path $NginxProxyStorePath/BigCache levels=1:2 keys_zone=bigcache:{$BigCacheMaxFilesCacl}m max_size={$BigCacheMaxSize}g inactive={$BigCacheInactive}m use_temp_path=off;";
	$f[]="\tproxy_cache_path $NginxProxyStorePath/AuthCache keys_zone=auth_cache:10m;";
	$f[]="\tproxy_temp_path $NginxProxyStorePath/tmp/ 1 2;";
	$f[]="\tproxy_cache_valid 404 10m;";
	$f[]="\tproxy_cache_valid 400 501 502 503 504 1m;";
	$f[]="\tproxy_cache_valid any 4320m;";
	$f[]="\tproxy_cache_use_stale updating invalid_header error timeout http_404 http_500 http_502 http_503 http_504;";
	$f[]="\tproxy_next_upstream error timeout invalid_header http_404 http_500 http_502 http_503 http_504;";
	$f[]="\tproxy_redirect off;";
	$f[]="\tproxy_set_header Host \$http_host;";
	$f[]="\tproxy_set_header Server Apache;";
	$f[]="\tproxy_set_header Connection Close;";
	$f[]="\tproxy_pass_header Set-Cookie;";
	$f[]="\tproxy_pass_header User-Agent;";
	$f[]="\tproxy_set_header X-Accel-Buffering on;";
	$f[]="\tproxy_hide_header X-CDN;";
	$f[]="\tproxy_hide_header X-Server;";
	$f[]="\tproxy_intercept_errors off;";
	$f[]="\tproxy_ignore_client_abort on;";
	$f[]="\tproxy_connect_timeout 60s;";
	$f[]="\tproxy_send_timeout 60s;";
	$f[]="\tproxy_read_timeout 150s;";
	$f[]="\tproxy_buffer_size 64k;";
	$f[]="\tproxy_buffers 16384 128k;";
	$f[]="\tproxy_busy_buffers_size 256k;";
	$f[]="\tproxy_temp_file_write_size 128k;";
	$f[]="\tproxy_headers_hash_bucket_size 128;";
	$f[]="\tproxy_cache_min_uses 0;";

    $f[]="\tinclude /etc/nginx/backends.d/*.conf;";
	$f[]="\tinclude /etc/nginx/reverse.d/*.conf;";
	$f[]="\tinclude /etc/nginx/sites-enabled/*.conf;";
	$f[]="\tinclude /etc/nginx/local-sites/*.conf;";
	$f[]="\tinclude /etc/nginx/conf.d/*.conf;";
    $f[]="\tinclude /etc/nginx/wordpress/*.conf;";
	$f[]="\t}";
	$f[]="";
	$f[]="stream {";
	$f[]="\tlog_format  awc_log";
	$f[]="\t\t'\$server_addr:\$server_port \$remote_addr $logf - [\$time_local] \$protocol://\$upstream_addr '";
	$f[]="\t\t'\"\$status\" \$bytes_sent \"-\" '";
	$f[]="\t\t'\"-\" \"-\" [-]';";
	$f[]="\taccess_log  /var/log/nginx/access.log awc_log;";
	$f[]="\terror_log   /var/log/nginx/error.log;";	
	$f[]="\tlimit_conn_zone \$binary_remote_addr zone=addr:10m;";
    $f[]="\tinclude /etc/nginx/ElasticSearch/ElasticSearch.conf;";
	$f[]="\tinclude /etc/nginx/upstream.d/*.conf;";
	$f[]="\tinclude /etc/nginx/stream.d/*.conf;";

	
	$f[]="}";
	$f[]="";
	
	@copy("/etc/nginx/nginx.conf","/etc/nginx/nginx.bak");
	file_put_contents("/etc/nginx/nginx.conf", @implode("\n", $f));
	if(!is_dir("/etc/nginx/stream.d")){@mkdir("/etc/nginx/stream.d",0755,true);}
    if(!is_dir("/etc/nginx/reverse.d")){@mkdir("/etc/nginx/reverse.d",0755,true);}
    if(!is_dir("/etc/nginx/backends.d")){@mkdir("/etc/nginx/backends.d",0755,true);}
    if(!is_dir("/etc/nginx/ElasticSearch")){@mkdir("/etc/nginx/ElasticSearch",0755,true);}
    if(!is_file("/etc/nginx/ElasticSearch/ElasticSearch.conf")){@touch("/etc/nginx/ElasticSearch/ElasticSearch.conf");}

	@unlink("/etc/nginx/sites-enabled/00-default-munin.conf");
	build_progress("Building configuration done",10);
    default_one();


	
}

function default_one(){
    $f[]="server {";
    $f[]="\tlisten 127.0.0.1:1842;";
    $f[]="\tlocation /nginx_status/ {";
    $f[]="\t\tstub_status on;";
    $f[]="\t\taccess_log   off;";
    $f[]="\t\tallow 127.0.0.1;";
    $f[]="\t\tdeny all;";
    $f[]="\t}";
    $f[]="}";

    if(!is_dir("/etc/nginx/conf.d")){@mkdir("/etc/nginx/conf.d",0755,true);}
    @file_put_contents("/etc/nginx/conf.d/nginx_status.conf",@implode("\n",$f));
    return true;

}

function authenticator($alone=false){
	return false;
	if($alone){
		$unix=new unix();
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=$unix->get_pid_from_file($pidfile);
		if($unix->process_exists($pid,basename(__FILE__))){
			$time=$unix->PROCCESS_TIME_MIN($pid);
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx Already Artica task running PID $pid since {$time}mn\n";}
			return;
		}
	}	
	@file_put_contents($pidfile, getmypid());
	
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") Authenticate port /var/run/nginx-authenticator.sock\n";}
	$host=new nginx("unix:/var/run/nginx-authenticator.sock");
	$host->set_proxy_disabled();
	$host->set_DocumentRoot("/usr/share/artica-postfix");
	$host->set_index_file("authenticator.php");
	$host->build_proxy();
	if($alone){
		stop(true);
		start(true);
	}
	
}






function ToSyslog($text){

	$LOG_SEV=LOG_INFO;
	if(function_exists("openlog")){openlog(basename(__FILE__), LOG_PID , LOG_SYSLOG);}
	if(function_exists("syslog")){ syslog($LOG_SEV, $text);}
	if(function_exists("closelog")){closelog();}
}

function rotate(){
	$unix=new unix();
	
	
	
	$pidTime="/etc/artica-postfix/pids/". basename(__FILE__).".".__FUNCTION__.".time";
	if($unix->file_time_min($pidTime)<55){return;}
	@unlink($pidTime);
	@file_put_contents($pidTime, time());	
	
	$sock=new sockets();
	$kill=$unix->find_program("kill");
	$NginxWorkLogsDir=$sock->GET_INFO("NginxWorkLogsDir");
	if($NginxWorkLogsDir==null){$NginxWorkLogsDir="/home/nginx/logsWork";}
	
	@mkdir("$NginxWorkLogsDir",0755,true);
	$directories=$unix->dirdir("/var/log/apache2");
	foreach ($directories as $directory=>$line){
		$sitename=basename($directory);
		$date=date("Y-m-d-H");
		$nginx_source_logs="$directory/nginx.access.log";
		$nginx_dest_logs="$NginxWorkLogsDir/$sitename-$date.log";
		if(is_file("$nginx_dest_logs")){
			echo "$nginx_dest_logs no such file\n";
			continue;}
		if(!is_file($nginx_source_logs)){continue;}
		if(!@copy($nginx_source_logs, $nginx_dest_logs)){
			echo "Failed to copy $nginx_dest_logs\n";
			continue;
		}
		
		@unlink($nginx_source_logs);
		
	}
	
	$pid=PID_NUM();
	shell_exec("$kill -USR1 $pid");
	
	$php5=$unix->LOCATE_PHP5_BIN();
	$nohup=$unix->find_program("nohup");
	$sock=new sockets();
	
	
	$EnableNginxStats=$sock->GET_INFO("EnableNginxStats");
	if(!is_numeric($EnableNginxStats)){$EnableNginxStats=0;}
	
	if($EnableNginxStats==0){
		shell_exec("$nohup $php5 ".__FILE__." --awstats >/dev/null 2>&1 &");
		return;
	}else{
		shell_exec("$nohup $php5 /usr/share/artica-postfix/exec.nginx-stats.php --parse >/dev/null 2>&1 &");	
	}
	
	
	
}









function PID_NUM(){
    $unix=new unix();
	$filename="/var/run/nginx.pid";
	$pid=$unix->get_pid_from_file($filename);
	if($unix->process_exists($pid)){return $pid;}
	$pid=$unix->PIDOF("/usr/sbin/nginx");
	if($unix->process_exists($pid)){return $pid;}
}

function GHOSTS_PID(){
	$unix=new unix();
	$pidof=$unix->find_program("pidof");
	exec("$pidof /usr/sbin/nginx 2>&1",$results);
	
	$zpid=explode(" ",$results[0]);
	foreach ($zpid as $pid){
		if($unix->process_exists($pid)){
			if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: Killing PID $pid\n";}
			$unix->KILL_PROCESS($pid,9);
		}
	}
}

//##############################################################################
function PID_PATH(){
	return '/var/run/nginx.pid';
}
//##############################################################################
function nginx_ulimit(){
	$setup=true;
	
	$unix=new unix();
	$ulimit=$unix->find_program("ulimit");
	if(is_file($ulimit)){shell_exec("$ulimit -n 65535 >/dev/null 2>&1");}

	
	$f=explode("\n",@file_get_contents("/etc/security/limits.conf"));
	foreach ($f as $index=>$line){
		if(preg_match("#^www-data\s+-\s+65535#", $line)){
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") ulimit true\n";}
			return;
		}
		
	}
	
	$f[]="www-data\t-\tnofile\t65535\n";
	@file_put_contents("/etc/security/limits.conf", @implode("\n", $f));
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") ulimit setup done\n";}
	
}

function reload($aspid=false){
    $unix=new unix();
    $MasterPid=PID_NUM();
    $chown=$unix->find_program("chown");
    system("$chown www-data:www-data /var/log/nginx/access.log");
    system("$chown www-data:www-data /var/log/nginx/error.log");
    if(!$unix->process_exists($MasterPid)){
        start(true);
        return;
    }

    $nginx=$unix->find_program("nginx");
    system("$nginx -c /etc/nginx/nginx.conf -s reload");



}

function force_restart(){
	$unix=new unix();
	$MasterPid=PID_NUM();
	$chown=$unix->find_program("chown");
	$php=$unix->LOCATE_PHP5_BIN();
	system("$chown www-data:www-data /var/log/nginx/access.log");
	system("$chown www-data:www-data /var/log/nginx/error.log");
	if(!$unix->process_exists($MasterPid)){
		start(true);
		return;
	}	
	if($GLOBALS["OUTPUT"]){echo "Reloading.....: ".date("H:i:s")." [INIT]: Reconfiguring PHP-FPM\n";}
	system("$php /usr/share/artica-postfix/exec.lighttpd.php --nginx-build >/dev/null 2>&1");
	system("$php /usr/share/artica-postfix/exec.lighttpd.php --fpm-reload >/dev/null 2>&1");
	
	$pids=$unix->PIDOF_PATTERN_ALL("nginx: worker process");
	$kill=$unix->find_program("kill");
	
	if($GLOBALS["OUTPUT"]){echo "Reloading.....: ".date("H:i:s")." [INIT]: Nginx Reloading master $MasterPid\n";}
	system("$kill -HUP $MasterPid");
	
	foreach ($pids as $pid=>$ofnone){
		$maitre=$unix->PROCESS_PPID($pid);
		if($maitre<>$MasterPid){continue;}
		if($GLOBALS["OUTPUT"]){echo "Reloading.....: ".date("H:i:s")." [INIT]: Nginx Shutdown child $pid\n";}
		system("$kill -15 $pid");
		
	}
		
	
}


function reconfigure_all(){
	if($GLOBALS["VERBOSE"]){echo __FUNCTION__.".".__LINE__.": OK...\n";}
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pid=$unix->get_pid_from_file($pidfile);
	if($unix->process_exists($pid,basename(__FILE__))){
		$time=$unix->PROCCESS_TIME_MIN($pid);
		build_progress("Already executed",110);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx Already Artica task running PID $pid since {$time}mn\n";}
		return;
	}
	$php=$unix->LOCATE_PHP5_BIN();
	
	
	
	
	if($GLOBALS["VERBOSE"]){echo __FUNCTION__.".".__LINE__.": OK...\n";}
	build(false);
	if($GLOBALS["VERBOSE"]){echo __FUNCTION__.".".__LINE__.": OK...\n";}
	build_progress("{stopping_service}",80);
	if($GLOBALS["VERBOSE"]){echo __FUNCTION__.".".__LINE__.": OK...\n";}
	stop(true);
	build_progress("{starting_service}",90);
	start(true);
	build_progress("{done}",100);
	squid_admin_mysql(2, "Reconfiguring main service done [action=start]", null,__FILE__,__LINE__);
}

function restart(){
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pid=$unix->get_pid_from_file($pidfile);
	if($unix->process_exists($pid,basename(__FILE__))){
		$time=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx Already Artica task running PID $pid since {$time}mn\n";}
		return;
	}
	@file_put_contents($pidfile, getmypid());
	
	

	nginx_admin_mysql(1, "Restart reverse-proxy service [action=info]", null,__FILE__,__LINE__);
	stop(true);
	build();
	start(true);
	
	
}

function restart_build(){
	
	
	build_progress_restart("{reconfiguring}",10);
	build(true);
	build_progress_restart("{stopping_service}",50);
	stop(true);
	build_progress_restart("{starting_service}",90);
	if(!start(true)) {
		build_progress_restart("{starting_service} {failed}",110);
	}
	build_progress_restart("{starting_service} {success}",100);
}


function start($aspid=false){
	$unix=new unix();
	$sock=new sockets();
	$nginx=$unix->find_program("nginx");
	if(!is_file($nginx)){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") not installed\n";}
		return false;
	}

	if(!$aspid){
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=$unix->get_pid_from_file($pidfile);
		if($unix->process_exists($pid,basename(__FILE__))){
			$time=$unix->PROCCESS_TIME_MIN($pid);
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx Already Artica task running PID $pid since {$time}mn\n";}
			return false;
		}
		@file_put_contents($pidfile, getmypid());
	}
	
	
	$MEMORY=$unix->MEM_TOTAL_INSTALLEE();
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx {$MEMORY}K\n";}
		
	$pid=PID_NUM();
	
	if($unix->process_exists($pid)){
		$timepid=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx Service already started $pid since {$timepid}Mn...\n";}
		@file_put_contents("/var/run/nginx.pid", $pid);
		return true;
	}
	

	$EnableNginx=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableNginx"));
	
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx service \"EnableNginx\" = $EnableNginx\n";}

	if($EnableNginx==0){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx service disabled\n";}
		return false;
	}

	$Dirs[]="/var/log/apache2";
	$Dirs[]="/home/nginx/tmp";
	$Dirs[]="/var/log/nginx";

	foreach ($Dirs as $directory){
        if(!is_dir($directory)){@mkdir($directory,0755,true);}
        @chown($directory,"www-data");
        @chgrp($directory,"www-data");

    }



	if(is_file("/usr/local/modsecurity/lib/libmodsecurity.so")){
	    if(!is_file("/etc/ld.so.conf.d/modsecurity.conf")){
	        @file_put_contents("/etc/ld.so.conf.d/modsecurity.conf","/usr/local/modsecurity/lib\n");
	        $ldconfig=$unix->find_program("ldconfig");
	        shell_exec($ldconfig);
        }
    }


	$pid=$unix->PIDOF("/usr/sbin/apache2");
	if($unix->process_exists($pid)){
        echo "Starting......: ".date("H:i:s")." [INIT]: Killing Apache2 memory instance.\n";
        $unix->KILL_PROCESS($pid,9);
        for($i=0;$i<10;$i++){
            $pid=$unix->PIDOF("/usr/sbin/apache2");
            if(!$unix->process_exists($pid)){break;}
            echo "Starting......: ".date("H:i:s")." [INIT]: Killing Apache2 memory $pid instance ($i/10).\n";
            $unix->KILL_PROCESS($pid,9);
            sleep(1);
        }

    }

	
	
	
	if($unix->is_socket("/var/run/nginx-authenticator.sock")){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Remove authenticator socket\n";}
		@unlink("/var/run/nginx-authenticator.sock");
	}
	
	if(is_file("/var/run/nginx-authenticator.sock")){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Remove authenticator socket\n";}
		@unlink("/var/run/nginx-authenticator.sock");
	}	
	
	nginx_mime_types();
	

	@unlink("/etc/nginx/conf.d/default.conf");
	@unlink("/etc/nginx/sites-enabled/00-default-munin.conf");	
		
	
	$cmd="$nginx -c /etc/nginx/nginx.conf";
	
	if($GLOBALS["VERBOSE"]){echo "$cmd\n";}
	shell_exec($cmd);

	for($i=0;$i<6;$i++){
		$pid=PID_NUM();
		if($unix->process_exists($pid)){break;}
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx service waiting $i/6...\n";}
		sleep(1);
	}

	$pid=PID_NUM();
	if($unix->process_exists($pid)){
		@unlink($GLOBALS["pidStampReload"]);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx service Success service started pid:$pid...\n";}
		return true;
	}
	return false;
	nginx_admin_mysql(0, "Nginx Web service failed to start [action=info]", null,__FILE__,__LINE__);
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx service failed...\n";}
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: $cmd\n";}
	
}

function nginx_mime_types(){
$f[]="\ntypes {";
$f[]="    text/html                             html htm shtml;";
$f[]="    text/css                              css;";
$f[]="    text/xml                              xml;";

$f[]="    application/atom+xml                  atom;";
$f[]="    application/rss+xml                   rss;";
$f[]="";
$f[]="    text/mathml                           mml;";
$f[]="    text/plain                            txt;";
$f[]="    text/plain                            version;";
$f[]="    text/vnd.sun.j2me.app-descriptor      jad;";
$f[]="    text/vnd.wap.wml                      wml;";
$f[]="    text/x-component                      htc;";
$f[]="";
$f[]="    image/gif                             gif;";
$f[]="    image/jpeg                            jpeg jpg;";
$f[]="    image/png                             png;";
$f[]="    image/tiff                            tif tiff;";
$f[]="    image/vnd.wap.wbmp                    wbmp;";
$f[]="    image/x-icon                          ico;";
$f[]="    image/x-jng                           jng;";
$f[]="    image/x-ms-bmp                        bmp;";
$f[]="    image/svg+xml                         svg svgz;";
$f[]="    image/webp                            webp;";
$f[]="";
$f[]="    application/octet-stream				ovf ova xva hdx;";
$f[]="    application/java-archive              jar war ear;";
$f[]="    application/mac-binhex40              hqx;";
$f[]="    application/msword                    doc;";
$f[]="    application/pdf                       pdf;";
$f[]="    application/x-tar						tar;";
$f[]="    application/x-bzip2					bz2;";
$f[]="    application/x-deb						deb;";
$f[]="    application/x-javascript				js;";
$f[]="    application/x-gzip					gz;";
$f[]="    application/postscript                ps eps ai;";
$f[]="    application/rtf                       rtf;";
$f[]="    application/vnd.ms-excel              xls;";
$f[]="    application/vnd.ms-powerpoint         ppt;";
$f[]="    application/vnd.wap.wmlc              wmlc;";
$f[]="    application/vnd.google-earth.kml+xml  kml;";
$f[]="    application/vnd.google-earth.kmz      kmz;";
$f[]="    application/x-7z-compressed           7z;";
$f[]="    application/x-cocoa                   cco;";
$f[]="    application/x-java-archive-diff       jardiff;";
$f[]="    application/x-java-jnlp-file          jnlp;";
$f[]="    application/x-makeself                run;";
$f[]="    application/x-perl                    pl pm;";
$f[]="    application/x-pilot                   prc pdb;";
$f[]="    application/x-rar-compressed          rar;";
$f[]="    application/x-redhat-package-manager  rpm;";
$f[]="    application/x-sea                     sea;";
$f[]="    application/x-shockwave-flash         swf;";
$f[]="    application/x-stuffit                 sit;";
$f[]="    application/x-tcl                     tcl tk;";
$f[]="    application/x-x509-ca-cert            der pem crt;";
$f[]="    application/x-xpinstall               xpi;";
$f[]="    application/xhtml+xml                 xhtml;";
$f[]="    application/zip                       zip;";
$f[]="    application/x-gtar-compressed 		tgz;";
$f[]="";
$f[]="    application/binary					bin;";
$f[]="    application/octet-stream              exe dll;";
$f[]="    application/octet-stream              dmg;";
$f[]="    application/octet-stream              eot;";
$f[]="    application/octet-stream              iso img;";
$f[]="    application/octet-stream              msi msp msm;";
$f[]="";
$f[]="    audio/midi                            mid midi kar;";
$f[]="    audio/mpeg                            mp3;";
$f[]="    audio/ogg                             ogg;";
$f[]="    audio/x-m4a                           m4a;";
$f[]="    audio/x-realaudio                     ra;";
$f[]="";
$f[]="    video/3gpp                            3gpp 3gp;";
$f[]="    video/mp4                             mp4;";
$f[]="    video/mpeg                            mpeg mpg;";
$f[]="    video/quicktime                       mov;";
$f[]="    video/webm                            webm;";
$f[]="    video/x-flv                           flv;";
$f[]="    video/x-m4v                           m4v;";
$f[]="    video/x-mng                           mng;";
$f[]="    video/x-ms-asf                        asx asf;";
$f[]="    video/x-ms-wmv                        wmv;";
$f[]="    video/x-msvideo                       avi;";
$f[]="}\n";
@file_put_contents("/etc/nginx/mime.types", @implode("\n", $f));
if(is_file("/etc/nginx/mime.types.default")){@unlink("/etc/nginx/mime.types.default");}
}





function stop($aspid=false){
	$unix=new unix();
	if(!$aspid){
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=PID_NUM();
		if($unix->process_exists($pid,basename(__FILE__))){
			$time=$unix->PROCCESS_TIME_MIN($pid);
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx (from FILE )service Already Artica task running PID $pid since {$time}mn\n";}
			return;
		}
		@file_put_contents($pidfile, getmypid());
	}

	$pid=PID_NUM();


	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: Nginx service already stopped...\n";}
		GHOSTS_PID();
		return;
	}
	
	
	
	$pid=PID_NUM();
	$nohup=$unix->find_program("nohup");
	$php5=$unix->LOCATE_PHP5_BIN();
	$lighttpd_bin=$unix->find_program("lighttpd");
	$kill=$unix->find_program("kill");
	$nginx=$unix->find_program("nginx");

	
	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: Nginx service Shutdown pid $pid...\n";}
	shell_exec("$nginx -c /etc/nginx/nginx.conf -s quit >/dev/null 2>&1");
	for($i=0;$i<5;$i++){
		$pid=PID_NUM();
		if(!$unix->process_exists($pid)){break;}
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: Nginx service waiting pid:$pid $i/5...\n";}
		sleep(1);
        shell_exec("$nginx -c /etc/nginx/nginx.conf -s quit >/dev/null 2>&1");
	}

	$pid=PID_NUM();
	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: Nginx service success...\n";}
		return;
	}

	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: Nginx service shutdown - force - pid $pid...\n";}
    unix_system_kill_force($pid);
	for($i=0;$i<5;$i++){
		$pid=PID_NUM();
		if(!$unix->process_exists($pid)){break;}
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: Nginx service waiting pid:$pid $i/5...\n";}
		sleep(1);
        unix_system_kill_force($pid);
	}

	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: Nginx service success...\n";}
		GHOSTS_PID();
		return;
	}
	
	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: Nginx service failed...\n";}
	GHOSTS_PID();
}





function status(){
	
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pidTime="/usr/share/artica-postfix/ressources/logs/web/nginx.status.acl";
	
	if(!$GLOBALS["FORCE"]){
		if($unix->file_time_min($pidTime)<5){return;}
	}
	
	$pid=$unix->get_pid_from_file($pidfile);
	if($unix->process_exists($pid,basename(__FILE__))){
		$time=$unix->PROCCESS_TIME_MIN($pid);
		return;
	}
	
	@file_put_contents($pidfile, getmypid());	

	
	caches_status();
	
	
	
	@unlink($pidTime);
if(!is_dir('/usr/share/artica-postfix/ressources/logs/web')){@mkdir('/usr/share/artica-postfix/ressources/logs/web',0755,true);}
	@file_put_contents($pidTime, time());
	@chmod($pidTime,0777);
	rotate();
	
}




function awstats(){
	

}

function awstats_import_sql($servername){

}

function framework(){
	$unix=new unix();
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") Framework...\n";}
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pid=$unix->get_pid_from_file($pidfile);
	if($unix->process_exists($pid,basename(__FILE__))){
		$time=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx Already Artica task running PID $pid since {$time}mn\n";}
		return;
	}
	@file_put_contents($pidfile, getmypid());	
	
	if(!is_file("/etc/artica-postfix/WORDPRESS_APPLIANCE")){
	$lighttpdbin=$unix->find_program("lighttpd");
		if(is_file($lighttpdbin)){
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") $lighttpdbin OK turn, to lighttpd...\n";}
			return;
		}

	}
	
	if(!is_file("/etc/php5/fpm/pool.d/framework.conf")){
		$php=$unix->LOCATE_PHP5_BIN();
		shell_exec("$php /usr/share/artica-postfix/exec.php-fpm.php --build");
	}
	
	if(!is_file("/etc/php5/fpm/pool.d/framework.conf")){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") Unable to stat framework settings\n";}
		return;
	}
	
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") building framework...\n";}
	$host=new nginx(47980);
	
	$host->set_proxy_disabled();
	$host->set_DocumentRoot("/usr/share/artica-postfix/framework");
	$host->set_framework();
	$host->build_proxy();

	$PID=PID_NUM();
	if(!$unix->process_exists($PID)){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") not started, start it...\n";}
		start(true);
	}
	
	$kill=$unix->find_program("kill");
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") reloading PID $PID\n";}
	shell_exec("$kill -HUP $PID >/dev/null 2>&1");
	
}

function test_sources(){
	$unix=new unix();
	
	if(!$GLOBALS["FORCE"]){
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pidTime="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".time";
		if($GLOBALS["VERBOSE"]){echo "pidTime: $pidTime\n";} 
		$pid=$unix->get_pid_from_file($pidfile);
		if($unix->process_exists($pid,basename(__FILE__))){
			$time=$unix->PROCCESS_TIME_MIN($pid);
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx Already Artica task running PID $pid since {$time}mn\n";}
			return;
		}
		
		$pidTimeEx=$unix->file_time_min($pidTime);
		if($pidTime<15){return;}
		@file_put_contents($pidfile, getmypid());
		@unlink($pidTime);
		@file_put_contents($pidTime, time());
	}
	
	$echo=$unix->find_program("echo");
	$nc=$unix->find_program("nc");
	
	$q=new mysql_squid_builder();
	
	if(!$q->FIELD_EXISTS("reverse_sources", "isSuccess")){
		$q->QUERY_SQL("ALTER TABLE `reverse_sources` ADD `isSuccess` smallint(1) NOT NULL DEFAULT '1', ADD INDEX ( `isSuccess`)");
	}
	
	if(!$q->FIELD_EXISTS("reverse_sources", "isSuccesstxt")){
		$q->QUERY_SQL("ALTER TABLE `reverse_sources` ADD `isSuccesstxt` TEXT");
	}

	if(!$q->FIELD_EXISTS("reverse_sources", "isSuccessTime")){
		$q->QUERY_SQL("ALTER TABLE `reverse_sources` ADD `isSuccessTime` datetime");
	}	
	
	$sql="SELECT * FROM reverse_sources";
	$results=$q->QUERY_SQL($sql);
	
	
	while($ligne=mysqli_fetch_array($results,MYSQLI_ASSOC)){
		$ipaddr=$ligne["ipaddr"];
		$ID=$ligne["ID"];
		$port=$ligne["port"];
		$IsSuccess=1;
		$linesrows=array();
		$cmdline="$echo -e -n \"GET / HTTP/1.1\\r\\n\" | $nc -q 2 -v  $ipaddr $port 2>&1";
		if($GLOBALS["VERBOSE"]){echo "$ipaddr: $cmdline\n";}
		exec($cmdline,$linesrows);
		while (list ($a, $b) = each ($linesrows) ){
			if($GLOBALS["VERBOSE"]){echo "$ipaddr: $b\n";}
			if(preg_match("#failed#", $b)){$IsSuccess=0;}}
		reset($linesrows);
		$linesrowsText=mysql_escape_string2(base64_encode(serialize($linesrows)));
		$date=date("Y-m-d H:i:s");
		$q->QUERY_SQL("UPDATE reverse_sources SET isSuccess=$IsSuccess,isSuccesstxt='$linesrowsText',isSuccessTime='$date' WHERE ID=$ID");
		
	}
}

function purge_all_caches(){
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pid=$unix->get_pid_from_file($pidfile);
	if($unix->process_exists($pid,basename(__FILE__))){
		$time=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [PURGE]: Nginx Already Artica task running PID $pid since {$time}mn\n";}
		return;
	}
	
	
	
	$q=new mysql_squid_builder();
	$results=$q->QUERY_SQL("SELECT directory FROM nginx_caches");
	while($ligne=@mysqli_fetch_array($results,MYSQLI_ASSOC)){
		$f[]=$ligne["directory"];
	}
	$f[]="/home/nginx/tmp";
	$rm=$unix->find_program("rm");
	while (list ($index, $value) = each ($f) ){
		if(!is_dir($value)){continue;}
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Removing $value\n";}
		shell_exec("$rm -rf $value/*");
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Removing $value OK\n";}
	}
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Reloading service\n";}
	reload(true);
	
}




function purge_cache($ID){
	if(!is_numeric($ID)){return;}
	$unix=new unix();
	
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pid=$unix->get_pid_from_file($pidfile);
	if($unix->process_exists($pid,basename(__FILE__))){
		$time=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [PURGE]: Nginx Already Artica task running PID $pid since {$time}mn\n";}
		return;
	}
	@file_put_contents($pidfile, getmypid());
	$q=new mysql_squid_builder();
	$ligne=mysqli_fetch_array($q->QUERY_SQL("SELECT directory FROM nginx_caches WHERE ID='$ID'"));
	$directory=$ligne["directory"];
	if(!is_dir($directory)){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [PURGE]: `$directory` no such directory\n";}
	}
	$rm=$unix->find_program("rm");
	shell_exec("$rm -rf \"$directory\"");
	@mkdir($directory,0755,true);
	reload(true);
	caches_status();
	
}

function import_file(){
	$q=new mysql_squid_builder();
	$filename="/usr/share/artica-postfix/ressources/logs/web/nginx.import";
	if(!is_file($filename)){echo "$filename no such file\n";return;}
	
	$f=explode("\n",@file_get_contents($filename));
	
	$IpClass=new IP();
	foreach ($f as $index=>$line){
		if(trim($line)==null){continue;}
		if(strpos($line, ",")==0){continue;}
		$tr=explode(",",$line);
		if(count($tr)<2){continue;}
		$sourceserver=trim($tr[0]);
		$sitename=trim($tr[1]);
		if(!isset($tr[2])){$tr[2]=0;}
		if(!isset($tr[3])){$tr[3]=null;}
		$ssl=$tr[2];
		$forceddomain=$tr[3];
		if(!preg_match("#(.+?):([0-9]+)#", $sourceserver,$re)){
			if($ssl==1){$sourceserver_port=443;}
			if($ssl==0){$sourceserver_port=80;}
		}else{
			$sourceserver=trim($re[1]);
			$sourceserver_port=$re[2];
		}
		
		
		if(!preg_match("#(.+?):([0-9]+)#", $sitename,$re)){
			if($ssl==1){$sitename_port=443;}
			if($ssl==0){$sitename_port=80;}
		}else{
			$sitename=trim($re[1]);
			$sitename_port=$re[2];
		}	
		
		if($forceddomain<>null){$title_source=$forceddomain;}else{$title_source=$sourceserver;}
		echo "Importing $sitename ($sitename_port) -> $sourceserver ($sourceserver_port)\n";
		// On cherche la source:
		
		if($sitename==null){
			 echo "Local sitename is null\n";
			 continue;
		}
		
		if($sourceserver==null){
			echo "Source is null\n";
			continue;
		}	

		if(!$IpClass->isValid($sourceserver)){
			$tcp=gethostbyname($sourceserver);
			if(!$IpClass->isValid($tcp)){
				echo "Source $sourceserver cannot be resolved\n";
				continue;
			}	
		}
		
		$ligne=mysqli_fetch_array($q->QUERY_SQL("SELECT ID FROM reverse_sources WHERE ipaddr='$sourceserver' AND `port`='$sourceserver_port'"));
		$IDS=intval($ligne["ID"]);
		
		if($IDS==0){
			$sql="INSERT IGNORE INTO `reverse_sources` (`servername`,`ipaddr`,`port`,`ssl`,`enabled`,`forceddomain`)
			VALUES ('$title_source','$sourceserver','$sourceserver_port','$ssl',1,'$forceddomain')";
			$q->QUERY_SQL($sql);
			$ligne=mysqli_fetch_array($q->QUERY_SQL("SELECT ID FROM reverse_sources WHERE ipaddr='$sourceserver' AND `port`='$sourceserver_port'"));
			$IDS=intval($ligne["ID"]);
			
		}
		
		if($IDS==0){
			echo "Failed to add $sourceserver/$sourceserver_port/$forceddomain\n";
			continue;
		}

		
		// On attaque  le site web:
		$ligne=mysqli_fetch_array($q->QUERY_SQL("SELECT servername,cache_peer_id FROM reverse_www WHERE servername='$sitename'"));
		if(trim($ligne["servername"]<>null)){
			echo "$sitename already exists on cache ID : {$ligne["cache_peer_id"]}/$IDS\n";
			if($ligne["cache_peer_id"]<>$IDS){
				$q->QUERY_SQL("UPDATE reverse_www SET `cache_peer_id`=$IDS WHERE  servername='$sitename'");
			}
			continue;
		}
		
		$sql="INSERT IGNORE INTO `reverse_www` (`servername`,`cache_peer_id`,`port`,`ssl`) VALUES
		('$sitename','$IDS','$sitename_port','$ssl')";
	
		$q->QUERY_SQL($sql);
		if(!$q->ok){echo $q->mysql_error;continue;}
		
		
	}
	
	
	$unix=new unix();
	$nohup=$unix->find_program("nohup");
	$php5=$unix->LOCATE_PHP5_BIN();
	shell_exec("$nohup $php5 ".__FILE__." --restart >/dev/null 2>&1 &");
	
	
	
}

function import_bulk(){
	$q=new mysql_squid_builder();
	$nginxSources=new nginx_sources();
	$nginx=new nginx();
	$filename="/usr/share/artica-postfix/ressources/logs/web/nginx.importbulk";
	if(!is_file($filename)){echo "$filename no such file\n";return;}	
	$CONF=unserialize(@file_get_contents($filename));
	
	
	
	if($CONF["RemoveOldImports"]==1){
		// on supprime les anciennes entrées:
		$results=$q->QUERY_SQL("SELECT ID FROM reverse_sources WHERE `Imported`=1");
		while ($ligne = mysqli_fetch_assoc($results)) {
			$nginxSources->DeleteSource($ligne["ID"]);
		}
		
		$results=$q->QUERY_SQL("SELECT servername FROM reverse_www WHERE `Imported`=1");
		while ($ligne = mysqli_fetch_assoc($results)) {
			$nginx->Delete_website($ligne["servername"],true);
		}		
		
		
	}
	
	$randomArray[1]="a";
	$randomArray[2]="b";
	$randomArray[3]="c";
	$randomArray[4]="d";
	$randomArray[5]="e";
	$randomArray[6]="f";
	$randomArray[7]="g";
	$randomArray[8]="h";
	$randomArray[9]="i";
	$randomArray[10]="j";
	$randomArray[11]="k";
	$randomArray[12]="l";
	$randomArray[13]="m";
	$randomArray[14]="n";
	$randomArray[15]="o";
	$randomArray[16]="p";
	$randomArray[17]="q";
	$randomArray[18]="r";
	$randomArray[19]="s";
	$randomArray[20]="t";
	$randomArray[21]="u";
	$randomArray[22]="v";
	$randomArray[23]="x";
	$randomArray[24]="y";
	$randomArray[25]="z";
	$RandomText=$CONF["RandomText"];
	$digitAdd=0;
	$webauth=null;
	$authentication_id=$CONF["authentication"];
	if(!is_numeric($authentication_id)){$authentication_id=0;}
	
	
	if($authentication_id>0){
		$AUTHENTICATOR["USE_AUTHENTICATOR"]=1;
		$AUTHENTICATOR["AUTHENTICATOR_RULEID"]=$authentication_id;
		$webauth=mysql_escape_string2(base64_encode(serialize($AUTHENTICATOR)));
	}
	
	
	
	if(preg_match("#\%sx([0-9]+)#", $RandomText,$re)){
		$digitAdd=intval($re[1]);
		$RandomText=str_replace("%sx{$re[1]}", "%s", $RandomText);
		
	}
	
	echo "Random: $RandomText\n";
	

	
	// on parse le fichier en première passe pour le cleaner
	
	$f=explode("\n",$CONF["import"]);
	foreach ($f as $index=>$line){
		$line=trim(strtolower($line));
		if($line==null){continue;}
		if(preg_match("#^http.*?:\/#", $line)){
			// c'est une URI, on la décompose
			$URZ=parse_url($line);
			if(!isset($URZ["host"])){echo "$line -> Unable to determine HOST, skipping\n";}
			$MAIN[$URZ["host"]]=$URZ["scheme"];
			continue;
			
		}
		$MAIN[$line]="http";
		
		
	}
	
	ksort($MAIN);
	$i=1;
	$Letter=1;
	$IpClass=new IP();
	$SUCCESS=0;
	$FAILED=0;
	while (list ($servername, $proto) = each ($MAIN)){
		$LetterText=$randomArray[$Letter];
		$iText=$i;
		$ssl=0;
		if($digitAdd>0){$iText = sprintf("%1$0{$digitAdd}d", $i); }
		$SourceWeb=$RandomText;
		if($SourceWeb<>null){
			$SourceWeb=str_replace("%a", $LetterText, $SourceWeb);
			$SourceWeb=str_replace("%s", $iText, $SourceWeb);
			
		}else{
			$SourceWeb=$servername;
		}
		$sourceserver="$proto://$servername";
		echo "$proto://$servername\n";
		if($proto=="http"){$sourceserver_port=80;}
		if($proto=="https"){$sourceserver_port=443;$ssl=1;}
		if(preg_match("#(.+?):([0-9]+)#", $servername,$re)){$sourceserver_port=$re[1];}
		
		//existe-t-il ? 
		$ligne=mysqli_fetch_array($q->QUERY_SQL("SELECT ID FROM reverse_sources WHERE ipaddr='$sourceserver' AND `port`='$sourceserver_port'"));
		$IDS=intval($ligne["ID"]);
		
		if($IDS==0){
			//non -> Ajout de l'entrée...
			$sql="INSERT IGNORE INTO `reverse_sources` 
			(`servername`,`ipaddr`,`port`,`ssl`,`enabled`,`forceddomain`,`Imported`)
			VALUES ('$servername','$sourceserver','$sourceserver_port','$ssl',1,'$servername',1)";
			$q->QUERY_SQL($sql);
			$ligne=mysqli_fetch_array($q->QUERY_SQL("SELECT ID FROM reverse_sources WHERE ipaddr='$sourceserver' AND `port`='$sourceserver_port'"));
			$IDS=intval($ligne["ID"]);
				
		}
		
		if($IDS==0){
			echo "Failed to add $sourceserver/$sourceserver_port/$servername\n";
			$FAILED++;
			continue;
		}
		
		
		// On attaque  le site web:
		$ligne=mysqli_fetch_array($q->QUERY_SQL("SELECT servername,cache_peer_id FROM reverse_www WHERE servername='$SourceWeb'"));
		if(trim($ligne["servername"]<>null)){
			echo "$SourceWeb already exists on cache ID : {$ligne["cache_peer_id"]}/$IDS\n";
			if($ligne["cache_peer_id"]<>$IDS){
			$q->QUERY_SQL("UPDATE reverse_www SET `cache_peer_id`=$IDS WHERE  servername='$SourceWeb'");
			}
			$SUCCESS++;
			continue;
		}
		
		$sql="INSERT IGNORE INTO `reverse_www` (`servername`,`cache_peer_id`,`port`,`ssl`,`Imported`,`webauth`) VALUES
		('$SourceWeb','$IDS','$sourceserver_port','$ssl',1,'$webauth')";
		
		$q->QUERY_SQL($sql);
		if(!$q->ok){echo $q->mysql_error;$FAILED++;continue;}	
		$SUCCESS++;	
		
		
		$i++;
		$Letter++;
		if($Letter>25){$Letter=1;}
	}
	
	
	echo "$SUCCESS Imported sites, $FAILED failed\n";
	
}
function build_progress_restart($text,$pourc){
	$filename=basename(__FILE__);

	if(function_exists("debug_backtrace")){
		$trace=debug_backtrace();

		if(isset($trace[0])){
			$file=basename($trace[0]["file"]);
			$function=$trace[0]["function"];
			$line=$trace[0]["line"];
		}

		if(isset($trace[1])){
			$file=basename($trace[1]["file"]);
			$function=$trace[1]["function"];
			$line=$trace[1]["line"];
		}



	}


	echo "[{$pourc}%] $filename $text ( $function Line $line)\n";
	$cachefile="/usr/share/artica-postfix/ressources/logs/nginx.restart.progress";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($cachefile, serialize($array));
	@chmod($cachefile,0755);
	if($GLOBALS["OUTPUT"]){usleep(5000);}

}
function build_progress($text,$pourc){
	$filename=basename(__FILE__);
	
	if(function_exists("debug_backtrace")){
		$trace=debug_backtrace();
	
		if(isset($trace[0])){
			$file=basename($trace[0]["file"]);
			$function=$trace[0]["function"];
			$line=$trace[0]["line"];
		}
	
		if(isset($trace[1])){
			$file=basename($trace[1]["file"]);
			$function=$trace[1]["function"];
			$line=$trace[1]["line"];
		}
	
	
	
	}
	
	
	echo "[{$pourc}%] $filename $text ( $function Line $line)\n";
	$cachefile="/usr/share/artica-postfix/ressources/logs/nginx.reconfigure.progress";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($cachefile, serialize($array));
	@chmod($cachefile,0755);
	if($GLOBALS["OUTPUT"]){usleep(5000);}

}
function build_progress_caches($text,$pourc)
{
    if ($GLOBALS["OUTPUT"]) {
        echo "Starting......: " . date("H:i:s") . " [INIT]: Nginx[" . __LINE__ . "](" . basename(__FILE__) . ")[{$pourc}%] $text\n";
    }
    $cachefile = "/usr/share/artica-postfix/ressources/logs/web/nginx-caches.progress";
    $array["POURC"] = $pourc;
    $array["TEXT"] = $text;
    @file_put_contents($cachefile, serialize($array));
    @chmod($cachefile, 0755);
}
?>