<?php
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
$GLOBALS["FORCE"]=false;
$GLOBALS["RECONFIGURE"]=false;
$GLOBALS["SWAPSTATE"]=false;
$GLOBALS["NOSQUIDOUTPUT"]=true;
$GLOBALS["VERBOSE"]=false;
$GLOBALS["RELOAD"]=false;
$GLOBALS["REPLIC_CONF"]=false;
$GLOBALS["NO_RELOAD"]=false;
$GLOBALS["NO_BUILD_MAIN"]=false;
$GLOBALS["OUTPUT"]=true;
$GLOBALS["pidStampReload"]="/etc/artica-postfix/pids/".basename(__FILE__).".Stamp.reload.time";
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;$GLOBALS["OUTPUT"]=true;
$GLOBALS["debug"]=true;
ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
if(preg_match("#--output#",implode(" ",$argv))){$GLOBALS["OUTPUT"]=true;}
if(preg_match("#schedule-id=([0-9]+)#",implode(" ",$argv),$re)){$GLOBALS["SCHEDULE_ID"]=$re[1];}
if(preg_match("#--force#",implode(" ",$argv),$re)){$GLOBALS["FORCE"]=true;}
if(preg_match("#--reconfigure#",implode(" ",$argv),$re)){$GLOBALS["RECONFIGURE"]=true;}
if(preg_match("#--replic-conf#",implode(" ",$argv),$re)){$GLOBALS["REPLIC_CONF"]=true;}
if(preg_match("#--no-reload#",implode(" ",$argv),$re)){$GLOBALS["NO_RELOAD"]=true;}
if(preg_match("#--no-buildmain#",implode(" ",$argv),$re)){$GLOBALS["NO_BUILD_MAIN"]=true;}




$GLOBALS["AS_ROOT"]=true;
include_once(dirname(__FILE__).'/ressources/class.ldap.inc');
include_once(dirname(__FILE__).'/ressources/class.nginx.inc');
include_once(dirname(__FILE__)."/ressources/class.nginx.params.inc");
include_once(dirname(__FILE__)."/ressources/class.nginx.tools.inc");
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__).'/ressources/class.squid.reverse.inc');
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.settings.inc');
include_once(dirname(__FILE__).'/ressources/class.resolv.conf.inc');

if($argv[1]=="--remove"){remove_website($argv[2]);CleanWebAndProxies();exit;}
if($argv[1]=="--clean"){CleanWebAndProxies();exit;}
if($argv[1]=="--clean-reboot"){CleanWebAndProxies(true);exit;}
if($argv[1]=="--all"){compile_allwebsites(true);exit;}
if($argv[1]=="--elastic"){ElasticSearch();exit;}



compile_site($argv[1]);

function build_progress($text,$pourc){
	$filename=basename(__FILE__);
	$GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/web/nginx-single.progress";
	echo "[{$pourc}%] $filename: $text\n";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($GLOBALS["CACHEFILE"], serialize($array));
	@chmod($GLOBALS["CACHEFILE"],0755);
	if($GLOBALS["OUTPUT"]){usleep(5000);}
}

function CheckDB(){
    $q=new lib_sqlite("/home/artica/SQLITE/nginx.db");
    $sql="CREATE TABLE IF NOT EXISTS `ngx_directories` ( `ID` INTEGER PRIMARY KEY AUTOINCREMENT,`directory` TEXT,`serviceid` INTEGER,`deny` INTEGER,`enabled` INTEGER,`options` text)";
    $q->QUERY_SQL($sql);

}

function compile_allwebsites(){
    $q=new lib_sqlite("/home/artica/SQLITE/nginx.db");
    $results=$q->QUERY_SQL("SELECT ID FROM nginx_services WHERE enabled=1");
    foreach ($results as $index=>$ligne){
        compile_site($ligne["ID"]);
    }

    echo "DONE!\n";
    return true;
}

function testMainconfig(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	$auth_cache=false;
	$f=explode("\n", @file_get_contents("/etc/nginx/nginx.conf"));
	
	foreach ($f as $index=>$line){
		if(preg_match("#keys_zone=auth_cache#", $line)){
			sleep(1);
			build_progress("{reconfigure} auth_cache True",5);
			$auth_cache=true;}
		
	}
		
	if(!$auth_cache){
		build_progress("{reconfigure} auth_cache False",5);
		system("$php /usr/share/artica-postfix/exec.nginx.php --build");
		sleep(1);
		
	}
	
	
}



function directorySites_hotspot(){
	$unix=new unix();
	
	$chmod=$unix->find_program("chmod");
	shell_exec("$chmod -R 0777 /home/squid/hotspot");
	
	@mkdir("/home/squid/hotspot/sessions",0755,true);
	@chown("/home/squid/hotspot/sessions","www-data");
	@chgrp("/home/squid/hotspot/sessions", "www-data");
	
	@mkdir("/home/squid/hotspot/caches",0755,true);
	@chown("/home/squid/hotspot/caches","www-data");
	@chgrp("/home/squid/hotspot/caches", "www-data");
}


function compile_site($ID){
	$unix=new unix();
	$ID=intval($ID);
    $DEFAULT_SERVER=false;
	
	if($ID==0){
		build_progress("{failed2} Wrong ID $ID",110);
		return;
	}
	$SERVICE_ID=$ID;
	
	$chown=$unix->find_program("chown");
	@mkdir("/var/lib/nginx/body",0755,true);
	@mkdir("/var/log/apache2",0755,true);
	@mkdir("/etc/nginx/sites-enabled",0755,true);
	@mkdir("/etc/nginx/stream.d",0755,true);
	@mkdir("/etc/nginx/upstream.d",0755,true);
	
	system("$chown -R www-data:www-data /var/lib/nginx");
	system("$chown -R www-data:www-data /var/log/apache2");
	system("$chown -R www-data:www-data /etc/nginx/sites-enabled");
	system("$chown -R www-data:www-data /etc/nginx/stream.d");
	system("$chown -R www-data:www-data /etc/nginx/upstream.d");

    CheckDB();


    $Types[1]="{PHP_WSITE}";
    $Types[2]="{reverse_proxy}";
    $Types[3]="{HOTSPOT_WWW}";
    $Types[4]="{ARTICA_ADM}";
    $Types[5]="{TCP_FORWARD}";
    $Types[6]="{WEBFILTERING_ERROR_SERVICE}";
    $Types[7]="{DOH_WEB_SERVICE}";
    $Types[8]="{PROXY_PAC_SERVICE}";
    $Types[9]="{WEB_HTML_SERVICE}";
    $Types[10]="{IT_charter}";
    $Types[11]="{APP_KASPERSKY_UPDATE_UTILITY}";
	
	$root_path[1]="/home/www/$ID";
	$root_path[2]="/home/www/$ID";
	$root_path[3]="/usr/share/artica-postfix";
	$root_path[4]="/usr/share/artica-postfix";
    $root_path[10]="/usr/share/artica-postfix";
	
	$php=$unix->LOCATE_PHP5_BIN();
	$q=new lib_sqlite("/home/artica/SQLITE/nginx.db");

    if(!$q->FIELD_EXISTS("nginx_services", "WebContent")){
        $q->QUERY_SQL("ALTER TABLE nginx_services ADD WebContent TEXT NULL");
    }
    if(!$q->FIELD_EXISTS("nginx_services", "WebContentSize")){
        $q->QUERY_SQL("ALTER TABLE nginx_services ADD WebContentSize INTEGER DEFAULT 0");
    }
    if(!$q->FIELD_EXISTS("nginx_services", "WebDirectory")){
        $q->QUERY_SQL("ALTER TABLE nginx_services ADD WebDirectory TEXT NULL");
    }



	$ligne=$q->mysqli_fetch_array("SELECT * FROM nginx_services WHERE ID=$ID");
	$servicename=$ligne["servicename"];
	$Type=intval($ligne["type"]);
	$zorder=intval($ligne["zorder"]);
	$enabled=intval($ligne["enabled"]);
	$goodconf_old=$ligne["goodconf"];
	$goodconftime=$ligne["goodconftime"];
    $isDefault=intval($ligne["isDefault"]);
    if($isDefault==1){$DEFAULT_SERVER=true;}
	$mainpath="/etc/nginx/sites-enabled/$zorder-$ID.conf";
	@unlink("/etc/nginx/sites-enabled/-1.conf");
	$index_file="index.php";
	$action="reload";
	if(!is_file($mainpath)){$action="restart";}
	
	if($Type==5){$mainpath="/etc/nginx/stream.d/$zorder-$ID.conf";}
    if($Type==2){$mainpath="/etc/nginx/reverse.d/$zorder-$ID.conf";}
	
	build_progress("type: {$Types[$ligne["type"]]}",110);
	echo "$servicename Type........: $Type\n";
	echo "$servicename Order.......: $zorder\n";
	echo "$servicename Enabled.....: $enabled\n";
	echo "$servicename goodconf....: ".strlen($goodconf_old)." Bytes\n";
	echo "$servicename goodconftime: $goodconftime\n";
    echo "$servicename Config file.: $mainpath\n";
	
	
	if($enabled==0){
	    $action="reload";
        echo "$servicename * * * * * * DISABLED * * * * * *\n";
		if(is_file($mainpath)){@unlink($mainpath);$action="restart";}
		build_progress("{reloading}",99);
		system("/etc/init.d/nginx $action");
		build_progress("{success} {disabled}",100);
		return;
	}
	
	if(strlen($goodconf_old)>10){
		if($goodconftime==0){
			build_progress("{apply_configuration}",80);
			@file_put_contents($mainpath, base64_decode($goodconf_old));
			if(!TestTheWholeConfig()){
				echo @implode("\n", $GLOBALS["NGINX_FATAL_ERRORS"])."\n";
				$q->QUERY_SQL("UPDATE nginx_services SET goodconftime=0,
                                goodconf='',badconf='$goodconf_old' WHERE ID=$ID");
				if(!$q->ok){echo $q->mysql_error."\n";}
				build_progress("{testing_the_configuration} {failed}",110);
				return;
			}
			
			build_progress("{reloading_service}...",90);
			system("/etc/init.d/nginx reload");
			$q->QUERY_SQL("UPDATE nginx_services SET goodconftime=".time().",badconf='' WHERE ID=$ID");
			build_progress("{reloading_service}...{success}",100);
			return;
		}
	}

    echo "Building configuration using Type: $Type\n";
	switch ($Type) {
		case 1:$goodconf=base64_encode(build_local($ligne,$SERVICE_ID));break;
		case 2:
		    include_once(dirname(__FILE__)."/ressources/class.nginx.reverse.http.inc");
            $goodconf=base64_encode(build_httpreverse($ligne,$SERVICE_ID));
		    break;
		case 3:$goodconf=base64_encode(build_local($ligne,$SERVICE_ID));break;
		case 4:$goodconf=base64_encode(build_local($ligne,$SERVICE_ID));break;
		case 5:$goodconf=base64_encode(build_stream($ligne,$SERVICE_ID));break;
		case 6:$goodconf=base64_encode(build_local($ligne,$SERVICE_ID));break;
        case 7:$goodconf=base64_encode(build_local($ligne,$SERVICE_ID));break;
        case 8:$goodconf=base64_encode(build_local($ligne,$SERVICE_ID));break;
        case 9:$goodconf=base64_encode(build_local($ligne,$SERVICE_ID));break;
        case 10:$goodconf=base64_encode(build_local($ligne,$SERVICE_ID));break;
        case 11:$goodconf=base64_encode(build_local($ligne,$SERVICE_ID));break;
		default:break;
	}

	if($goodconf==null){
        build_progress("{failed}",110);
        return false;
    }

	echo "Testing the configuration....\n";
	build_progress("{testing_the_configuration}",90);
	
	CleanWebAndProxies();
	
	
	if(!TestTheWholeConfig()){
		echo @implode("\n", $GLOBALS["NGINX_FATAL_ERRORS"])."\n";
		
		if(strlen($goodconf_old)>50){
			echo "$servicename Back to the old config !!!!\n";
			@file_put_contents($mainpath, base64_decode($goodconf_old));
		}
		
		build_progress("{saving_configuration} ".strlen($goodconf)."bytes",98);
		$q->QUERY_SQL("UPDATE nginx_services SET badconf='$goodconf' WHERE ID=$ID");
		if(!$q->ok){echo $q->mysql_error."\n";}
		build_progress("{testing_the_configuration} {failed}",110);
		return;
	}

	
	$q->QUERY_SQL("UPDATE nginx_services SET goodconftime=".time().
        ",goodconf='$goodconf',badconf='' WHERE ID=$ID");
	build_progress("{reloading_service}...",90);
	system("/etc/init.d/nginx $action");
	build_progress("{reloading_service}...{success}",100);
	if($Type==6){
            $SquidGuardWebWebServiceID=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidGuardWebWebServiceID"));
            if($SquidGuardWebWebServiceID==$SERVICE_ID) {
                $php5 = $unix->LOCATE_PHP5_BIN();
                $cmd = trim("$php5 /usr/share/artica-postfix/exec.ufdbguard.rules.php");
                system($cmd);
            }
    }
	
}

function buildservernames($ligne){
    $DEFAULT_SERVER=false;
    $Zhosts=explode("||",$ligne["hosts"]);
    $Zhosts2=array();
    foreach ($Zhosts as $servername){
        $servername=trim($servername);
        if($servername==null){continue;}
        if($servername=="*"){$DEFAULT_SERVER=true;continue;}
        $Zhosts2[]=$servername;
    }
    $servicesnames=trim(@implode(" ", $Zhosts2));
    if($servicesnames==null){$servicesnames="_";}
    return "  server_name $servicesnames;";

}

function security_of_paths(){

    $hack[]="Administrator/index";
    $hack[]="Joomla/administrator";
    $hack[]="Cms/administrator";
    $hack[]="joomla/administrator";
    $hack[]="Msd/index";
    $hack[]="MySqlDumper/index";
    $hack[]="Msd124stable/index";
    $hack[]="Msd1244/index";
    $hack[]="Mysqldumper/index";
    $hack[]="MySQLDumper/index";
    $hack[]="Mysql/index";
    $hack[]="mysql/index";
    $hack[]="Sql/index";
    $hack[]="sql/index";
    $hack[]="Cgi-bin/php";
    $hack[]="Cgi-bin/php5";
    $hack[]="Phpmyadmin/index";
    $hack[]="PhpMyAdmin/index";
    $hack[]="Myadmin/index";
    $f_rewrites=array();
    foreach ($hack as $path){
        $f_rewrites[] = "\tif (\$uri ~ $path){ return 407;}";


    }

    return @implode("\n",$f_rewrites);
}

function build_local($ligne,$SERVICE_ID){
	$unix=new unix();

	$GLOBALS["CERTIFICATE_ENABLED"]=false;

	$f=array();$DEFAULT_SERVER=false;
	
	$array_path[1]="/home/www/$SERVICE_ID";
	$array_path[2]="/home/www/$SERVICE_ID";
	$array_path[3]="/usr/share/artica-postfix";
	$array_path[4]="/usr/share/artica-postfix";
	$array_path[6]="/usr/share/artica-postfix";
    $array_path[7]="/home/www/$SERVICE_ID";
    $array_path[8]="/home/www/$SERVICE_ID";
    $array_path[11]="/home/kuu3/Updates/Sources";
    $sockngx=new socksngix($SERVICE_ID);

	$servicename=$ligne["servicename"];
	$Type=$ligne["type"];
	$zorder=intval($ligne["zorder"]);
	$isDefault=intval($ligne["isDefault"]);
	if($isDefault==1){$DEFAULT_SERVER=true;}

	if($Type==9){

        if(trim($ligne["WebDirectory"])<>null) {
            $array_path[9]=$ligne["WebDirectory"];
        }else{
            $array_path[9]="/home/www/$SERVICE_ID";

        }

        echo "Target directory [{$array_path[9]}]\n";
        $WebContentSize=intval($ligne["WebContentSize"]);
        if($WebContentSize==0){echo "No content as been defined\n";return null;}
        $unzip=$unix->find_program("unzip");
        $chown=$unix->find_program("chown");
        $chmod=$unix->find_program("chmod");
        $find=$unix->find_program("find");
        $rm=$unix->find_program("rm");

        if(!is_file("$unzip")){echo "No unzip binary\n";return null;}
        $TargetDirectory=$array_path[9];
        $tempzip=$unix->FILE_TEMP().".zip";
        @file_put_contents($tempzip,base64_decode($ligne["WebContent"]));
        echo "Uncompress...\n";
        if(!is_dir($TargetDirectory)){@mkdir($TargetDirectory,0755,true);}
        system("$rm -rf $TargetDirectory/*");
        system("$unzip $tempzip -d $TargetDirectory/");
        @unlink($tempzip);
        echo "Apply permissions...\n";
        shell_exec("$chown -R www-data $TargetDirectory");
        shell_exec("$chmod -R 0644 -R $TargetDirectory");
        shell_exec("$find $TargetDirectory -type d -print0 |xargs -0 $chmod 0755");
	}



	$mainpath="/etc/nginx/sites-enabled/$zorder-$SERVICE_ID.conf";
	$root_path=$array_path[$Type];
	echo "build_local: $servicename Root........: {$array_path[$Type]}\n";
	echo "build_local: $servicename path........: $mainpath\n";
    echo "build_local: $servicename Default serv: $isDefault\n";
	
	$Zhosts=explode("||",$ligne["hosts"]);
    $Zhosts2=array();
	foreach ($Zhosts as $servername){
        $servername=trim($servername);
        if($servername==null){continue;}
        if($servername=="*"){$DEFAULT_SERVER=true;continue;}
        $Zhosts2[]=$servername;
    }


	$servicesnames=trim(@implode(" ", $Zhosts2));
	if($servicesnames==null){$servicesnames="_";}
	echo "$servicename Servers: $servicesnames\n";
	
	switch ($Type) {
		case 3:$index_file="hotspot.php";break;
        case 10:$index_file="itcharter.php";break;
		case 6:$index_file="ufdbguard.php";break;
        case 8:$index_file="proxy.pac";break;
        case 9:$index_file="index.htm index.html";break;
        case 11:$index_file="index.htm index.html";break;
		default:$index_file="index.php";break;
	}
	
	$ssl_directives=ssl_directives($SERVICE_ID);
	$CERTIFICATE_ENABLED=$GLOBALS["CERTIFICATE_ENABLED"];

    if($Type==7) {
        $f[] = "upstream dns-backend {";
        $f[] = "\tserver 127.0.0.1:9053;";
        $f[] = "}";
        $f[] = "";
        $f[] = "";
    }

    $Redirect80To443=intval($sockngx->GET_INFO("Redirect80To443"));

//---------------- LISTEN SECTION -----------------------------------
   if($CERTIFICATE_ENABLED){ $f[]="# Certificated enabled OK";}
    if($Redirect80To443==1){
        if($CERTIFICATE_ENABLED) {
            $f[] = "server {";
            $f[] = "\tserver_name $servicesnames;";
            $f[] = listen_port_Redirect80To443($SERVICE_ID,$DEFAULT_SERVER);
            $f[] = "return 301 https://\$host\$request_uri;";
            $f[] = "}";
            $f[] = "";
        }
    }

	
	
	$f[]="server {";
		$f[]="\tserver_name $servicesnames;";

	
	// ------------------------------------ PORTS ------------------------------------
	$f[]=listen_port_directive($SERVICE_ID, $CERTIFICATE_ENABLED,$DEFAULT_SERVER);
	$f[]=$ssl_directives;
	// ------------------------------------------------------------------------
	$f[]=ngx_stream_access_module($SERVICE_ID);

    switch ($Type) {

        case 11:

            $f[] = "\taccess_log  /var/log/nginx/kuu3.log kuu3;";
            $f[] = "\terror_log   /var/log/nginx/kuu3-error.log;";
            break;
        default:
            $f[]="\taccess_log  /var/log/nginx/access.log awc_log;";
            $f[] = "\terror_log   /var/log/nginx/error.log;";
            break;
    }

            $f[]="\tindex $index_file;";
            $f[]="\troot {$root_path};";
            $f[]="";


            switch ($Type) {
                case 4:$f[]=proxy_path_artica();break;
                case 6:$f[]=weberror_path_artica();break;
                case 3:$f[]=hotspot_path_artica();break;
                case 7:$f[]=doh_path_artica();break;
                case 8:$f[]=_proxy_pac();break;
                case 9:$f[]=static_path($SERVICE_ID);break;
                case 10:$f[]=itcharter_path_artica();break;
                case 11:$f[]=cdn_path();break;
                default:$f[]=standard_path();break;
            }


            $f[]="}";

            echo "build_local: $servicename path........: $mainpath\n";
            @file_put_contents($mainpath, @implode("\n", $f));
            return @implode("\n", $f);


}



function build_stream($ligne,$SERVICE_ID){
	$unix=new unix();
	$servicename=$ligne["servicename"];
	$outgoingaddr=null;
	$zorder=intval($ligne["zorder"]);
	$mainpath="/etc/nginx/stream.d/$zorder-$SERVICE_ID.conf";
	echo "build_stream: $servicename path........: $mainpath\n";
	$q=new lib_sqlite("/home/artica/SQLITE/nginx.db");


	
//---------------- UPSTREAM SECTION -----------------------------------	

	$upstream_file="/etc/nginx/upstream.d/$zorder-$SERVICE_ID.conf";
	$UPS[]="upstream backends{$SERVICE_ID} {";
    $UPS[]="\thash \$remote_addr consistent;";
    $results=$q->QUERY_SQL("SELECT * FROM backends WHERE serviceid='$SERVICE_ID'");
    foreach ($results as $md5=>$ligne){
    	$hostname=$ligne["hostname"];
    	$ID=intval($ligne["ID"]);
    	$port=$ligne["port"];
    	$f[]="# Backend: $hostname:$port";
    	$UPS[]="\tserver $hostname:$port;";
    
    }
	$UPS[]="}";
	@file_put_contents($upstream_file, @implode("\n", $UPS));
	$sockngx=new socksngix($SERVICE_ID);
	$limit_conn=intval($sockngx->GET_INFO("limit_conn"));
	$proxy_download_rate=intval($sockngx->GET_INFO("proxy_download_rate"));
	$proxy_upload_rate=intval($sockngx->GET_INFO("proxy_upload_rate"));
	$proxy_bind=$sockngx->GET_INFO("proxy_bind");
	if($proxy_bind<>null){$outgoingaddr=$unix->InterfaceToIPv4($proxy_bind);}
	$ssl_directives=ssl_directives($SERVICE_ID);
	$CERTIFICATE_ENABLED=$GLOBALS["CERTIFICATE_ENABLED"];


	
	$f[]="server {";
    $f[]=listen_port_directive($SERVICE_ID, $CERTIFICATE_ENABLED);
	if($limit_conn>0){
		$f[]="\tlimit_conn\taddr {$limit_conn};";
		$f[]="\tlimit_conn_log_level error;";
	}
	if($proxy_download_rate>0){$f[]="\tproxy_download_rate {$proxy_download_rate}k;";}
	if($proxy_upload_rate>0){$f[]="\tproxy_upload_rate {$proxy_upload_rate}k;";}
	if($outgoingaddr<>null){$f[]="\tproxy_bind $outgoingaddr;";}
	
	$f[]=ngx_stream_access_module($SERVICE_ID);
	

	

	$f[]="\tproxy_pass backends{$SERVICE_ID};";
	$f[]="\taccess_log  /var/log/nginx/access.log awc_log;";
	$f[]="\terror_log   /var/log/nginx/error.log;";
	$f[]="}";
	@file_put_contents($mainpath, @implode("\n", $f));
	return @implode("\n", $f);
	
}


function default_one(){
    $f[]="server {";
    $f[]="\tlisten 127.0.0.1:1842;";
    $f[]="\tlocation /nginx_status/ {";
    $f[]="\t\taccess_log off;";
    $f[]="\t\tstub_status on;";
    $f[]="\t\taccess_log   off;";
    $f[]="\t\tallow 127.0.0.1;";
    $f[]="\t\tdeny all;";
    $f[]="\t}";
    $f[]="}";

    if(!is_dir("/etc/nginx/conf.d")){@mkdir("/etc/nginx/conf.d",0755,true);}
    @file_put_contents("/etc/nginx/conf.d/nginx_status.conf",@implode("\n",$f));
    return true;

}

function listen_port_Redirect80To443($SERVICE_ID,$DEFAULT_SERVER){
    $q=new lib_sqlite("/home/artica/SQLITE/nginx.db");
    $unix=new unix();
    $results=$q->QUERY_SQL("SELECT * FROM stream_ports WHERE serviceid='$SERVICE_ID'");
    if(!$q->ok){$f[]="# MySQL Error! on line ".__LINE__;}

    foreach ($results as $index=>$ligne) {
        $opts = array();
        if ($DEFAULT_SERVER) {
            $opts[] = "default_server";
        }
        $ipaddr = null;
        $finalopt = ";";
        $interface = $ligne["interface"];
        $port = intval($ligne["port"]);

        if ($port == 0) {
            continue;
        }
        if ($port == 443) {
            continue;
        }
        if ($interface <> null) {
            $ipaddr = $unix->InterfaceToIPv4($interface);
        }
        $f[] = "# $interface ($ipaddr) on port $port";
        $options = unserialize(base64_decode($ligne["options"]));
        if (!isset($options["udp"])) {$options["udp"] = 0;}
        if (!isset($options["http2"])) {$options["http2"] = 0;}
        if (!isset($options["spdy"])) {$options["spdy"] = 0;}
        if ($ipaddr == null) {$ipaddr = "*";}
        $udp = intval($options["udp"]);
        if ($udp == 1) {continue;}
        if ($options["spdy"] == 1) {$options[] = "spdy";}
        if (count($opts) > 0) {$finalopt = " " . @implode(" ", $opts) . ";";}
        $f[] = "   listen $ipaddr:$port{$finalopt}";
    }

    return @implode("\n", $f);
}

function listen_port_directive($SERVICE_ID,$CERTIFICATE_ENABLED,$DEFAULT_SERVER=false){

    $sock=new socksngix($SERVICE_ID);
    $Redirect80To443=intval($sock->GET_INFO("Redirect80To443"));
	$http2_feature=true;
	$unix=new unix();
	$dir_default_server=null;
	if(!isset($NGINX_COMPILE_PARAMS["ARGS"]["HTTP_V2_MODULE"])){$http2_feature=false;}

	
	if(!$http2_feature){
		$f[]="# ngx_http_v2_module not compiled";
	}
	
	$q=new lib_sqlite("/home/artica/SQLITE/nginx.db");
	$results=$q->QUERY_SQL("SELECT * FROM stream_ports WHERE serviceid='$SERVICE_ID'");
	if(!$q->ok){$f[]="# MySQL Error! on line ".__LINE__;}
	
	
	$f[]="# TCP redirector Service ID:$SERVICE_ID ".count($results)." Ports default_server:$DEFAULT_SERVER";
	
	foreach ($results as $index=>$ligne){
		$opts=array();
        if($DEFAULT_SERVER){$opts[]="default_server";}
		$ipaddr=null;
		$finalopt=";";
		$interface=$ligne["interface"];
		$port=intval($ligne["port"]);
		$f[]="# $interface on port $port";
        if($port==0){continue;}

        if($port==80){
            if($Redirect80To443==1){
                $f[]="# Skipped 80 port (Redirect80To443)";
                continue;
            }
        }

		if($interface<>null){$ipaddr=$unix->InterfaceToIPv4($interface);}
		$options=unserialize(base64_decode($ligne["options"]));
		if(!isset($options["udp"])){$options["udp"]=0;}
        if(!isset($options["http2"])){$options["http2"]=0;}
        if(!isset($options["spdy"])){$options["spdy"]=0;}
		if($ipaddr==null){$ipaddr="*";}
		$udp=intval($options["udp"]);
		$ssl=intval($options["ssl"]);
		if($udp==1){$opts[]="udp";}
		if($options["http2"]==1){if($http2_feature){$opts[]="http2";}}
		if($options["spdy"]==1){$options[]="spdy";}
		if($CERTIFICATE_ENABLED){if($ssl==1){$opts[]="ssl";}}
		if(count($opts)>0){$finalopt=" ".@implode(" ", $opts).";";}
		$f[]="   listen $ipaddr:$port{$finalopt}";
	}
	
	return @implode("\n", $f);
}

function CleanWebAndProxies($reboot=false){
	$unix=new unix();
	$FOUND=false;
	$q=new lib_sqlite("/home/artica/SQLITE/nginx.db");
	$sql="SELECT zorder,ID FROM nginx_services WHERE enabled=1";
	$results=$q->QUERY_SQL($sql);
	if(!$q->ok){echo "*********** $q->mysql_error *****************\n";}
	
	foreach ($results as $index=>$ligne){
		$zorder=intval($ligne["zorder"]);
		$ID=$ligne["ID"];
		if($GLOBALS["VERBOSE"]){echo "ADD: UPS[$zorder-$ID.conf]=True\n";}
		$UPS["$zorder-$ID.conf"]=true;
	}
	$files=$unix->DirFiles("/etc/nginx/stream.d");
	foreach ($files as $filename=>$nothing){
		if(isset($UPS[$filename])){continue;}
		echo "Removing /etc/nginx/stream.d/$filename\n";
		$FOUND=true;
		@unlink("/etc/nginx/stream.d/$filename");
	}

    $files=$unix->DirFiles("/etc/nginx/reverse.d");
    foreach ($files as $filename=>$nothing){
        if(isset($UPS[$filename])){continue;}
        echo "Removing /etc/nginx/reverse.d/$filename\n";
        $FOUND=true;
        @unlink("/etc/nginx/reverse.d/$filename");
    }
	
	$files=$unix->DirFiles("/etc/nginx/upstream.d");
	foreach ($files as $filename=>$nothing){
		if(isset($UPS[$filename])){continue;}
		echo "Removing /etc/nginx/upstream.d/$filename\n";
		$FOUND=true;
		@unlink("/etc/nginx/upstream.d/$filename");
	}

    $files=$unix->DirFiles("/etc/nginx/backends.d");
    foreach ($files as $filename=>$nothing){
        if(isset($UPS[$filename])){continue;}
        echo "Removing /etc/nginx/backends.d/$filename\n";
        $FOUND=true;
        @unlink("/etc/nginx/backends.d/$filename");
    }
	
	$files=$unix->DirFiles("/etc/nginx/sites-enabled");
	foreach ($files as $filename=>$nothing){
		if(isset($UPS[$filename])){continue;}
		echo "Removing /etc/nginx/sites-enabled/$filename\n";
		$FOUND=true;
		@unlink("/etc/nginx/sites-enabled/$filename");
	}	
	if(!$reboot){return;}
	if($FOUND){
		system("/etc/init.d/nginx reload");
	}
	
}

function CleanUpstreams(){
	$q=new lib_sqlite("/home/artica/SQLITE/nginx.db");
	$sql="SELECT zorder,ID FROM nginx_services WHERE enabled=1 AND `type`='5'";
	$results=$q->QUERY_SQL($sql);
	
	foreach ($results as $index=>$ligne){
		$zorder=$ligne["zorder"];
		$ID=$ligne["ID"];
		$UPS["$zorder-$ID.conf"]=true;
	}
	
	$unix=new unix();
	$files=$unix->DirFiles("/etc/nginx/stream.d");
	foreach ($files as $filename=>$nothing){
		
	}
	
}

function ngx_stream_access_module($serviceid){

	$q=new lib_sqlite("/home/artica/SQLITE/nginx.db");
	$results=$q->QUERY_SQL("SELECT * FROM ngx_stream_access_module WHERE serviceid='{$serviceid}' ORDER BY zorder");
	if(!$q->ok){return;}
	
	$STATUS[0]="deny";
	$STATUS[1]="allow";
	$f=array();	
	if(count($results)==0){return null;}
	$TRCLASS=null;
	foreach ($results as $md5=>$ligne){
		$pattern=trim($ligne["item"]);
		if($pattern=="*"){$pattern="all";}
		$allow=$ligne["allow"];
		$f[]="\t{$STATUS[$allow]} $pattern;";
	}
	return @implode("\n", $f);
}

function PID_NUM(){
	$filename="/var/run/nginx.pid";
	$pid=trim(@file_get_contents($filename));
	$unix=new unix();
	if($unix->process_exists($pid)){return $pid;}
	return $unix->PIDOF_PATTERN("nginx: master process.*?/etc/nginx/nginx.conf");
}

function itcharter_path_artica(){
    $nginx_tools=new nginx_tools();
    $IF_PROXY_PAC=$nginx_tools->IF_PROXY_PAC();
    if(!$IF_PROXY_PAC){$f_php[]=_proxy_pac(true);}

    $f_php[]=_proxy_pac(true);
    $f_php[]="\trewrite ^/ITCharter/(.*)(?:/*)(.*)(?:/*)(.*)(?:/*)(.*) /itcharter.php?Token=$1&UserKey=$2&redirect=$3 last;";
    $f_php[]="\tlocation ~ /(fw|logon|index|logoff)\.(html|php) {";
    $f_php[]="\t\tdeny all;";
    $f_php[]="\t}";
    $f_php[]="";
    $f_php[]="\tlocation / {";
    $f_php[]="\t\trewrite ^([^.]*[^/])$ $1/ permanent;";
    $f_php[]="\t\ttry_files \$uri \$uri/ /itcharter.php =404;";
    $f_php[]=fastcgi_params("/var/run/phpfpm-articaserv.sock","itcharter.php");
    $f_php[]="}";


    $f_php[]="\tlocation ~ [^/]\.php(/|$) {";
    $f_php[]="\t\tfastcgi_split_path_info ^(.+?\.php)(/.*)$;";
    $f_php[]="\t\tif (!-f \$document_root\$fastcgi_script_name) {";
    $f_php[]="\t\t\treturn 404;";
    $f_php[]="\t\t}";
    $f_php[]=fastcgi_params("/var/run/nginx-phpfpm.sock");
    $f_php[]="\t}";

    return @implode("\n", $f_php);

}

function weberror_path_artica(){
    $nginx_tools=new nginx_tools();
    $IF_PROXY_PAC=$nginx_tools->IF_PROXY_PAC();
    if(!$IF_PROXY_PAC){$f_php[]=_proxy_pac(true);}

    $f_php[]=_proxy_pac(true);
    $f_php[]="\tlocation ~ /(fw|logon|index|logoff)\.(html|php) {";
	$f_php[]="\t\tdeny all;";
	$f_php[]="\t}";
	$f_php[]="";
	$f_php[]="\tlocation / {";
	$f_php[]="\t\trewrite ^([^.]*[^/])$ $1/ permanent;";
	$f_php[]="\t\ttry_files \$uri \$uri/ /ufdbguard.php =404;";
    $f_php[]=fastcgi_params("/var/run/phpfpm-articaserv.sock","ufdbguard.php");
	$f_php[]="}";
	
	
	$f_php[]="\tlocation ~ [^/]\.php(/|$) {";
	$f_php[]="\t\tfastcgi_split_path_info ^(.+?\.php)(/.*)$;";
	$f_php[]="\t\tif (!-f \$document_root\$fastcgi_script_name) {";
	$f_php[]="\t\t\treturn 404;";
	$f_php[]="\t\t}";
    $f_php[]=fastcgi_params("/var/run/nginx-phpfpm.sock");
	$f_php[]="\t}";
	
	return @implode("\n", $f_php);
	
}

function  static_path($ID){

    $f[]="\tlocation ~ [^/]\.php(/|$) {";
    $f[]="\t\t\treturn 404;";
    $f[]="\t}";

    $f[]="\tlocation / {";
    $f[]=   security_of_paths();
    $f[]="\t\ttry_files \$uri \$uri/ =404;";
    $f[]="}";


}

function cdn_path(){
    $nginx_tools=new nginx_tools();
    $IF_PROXY_PAC=$nginx_tools->IF_PROXY_PAC();
    if(!$IF_PROXY_PAC){$f_php[]=_proxy_pac(true);}
    $f[]="\tlocation ~ [^/]\.php(/|$) {";
    $f[]="\t\t\treturn 404;";
    $f[]="\t}";
    $f_php[]="";
    $f_php[]="\tlocation / {";
    $f_php[]=   security_of_paths();
    $f_php[]="\t\tautoindex on;";
    $f_php[]="\t\ttry_files \$uri \$uri/ =404;";
    $f_php[]="\t}";
    return @implode("\n", $f_php);

}

function standard_path(){
    $nginx_tools=new nginx_tools();
    $IF_PROXY_PAC=$nginx_tools->IF_PROXY_PAC();
    if(!$IF_PROXY_PAC){$f_php[]=_proxy_pac(true);}
	$f_php[]="";
	$f_php[]="\tlocation ~ [^/]\.php(/|$) {";
	$f_php[]="\t\tfastcgi_split_path_info ^(.+?\.php)(/.*)$;";
	$f_php[]="\t\tif (!-f \$document_root\$fastcgi_script_name) {";
	$f_php[]="\t\t\treturn 404;";
	$f_php[]="\t\t}";
	$f_php[]=fastcgi_params("/var/run/nginx-phpfpm.sock");
	$f_php[]="\t}";
	return @implode("\n", $f_php);
	
}

function doh_path_artica(){

    $f_php[]="\tlocation /dns-query {";
    $f_php[]="\t\tproxy_set_header     X-Real-IP \$remote_addr;";
    $f_php[]="\t\tproxy_set_header     X-Forwarded-For \$proxy_add_x_forwarded_for;";
    $f_php[]="\t\tproxy_set_header     Host \$http_host;";
    $f_php[]="\t\tproxy_set_header     X-NginX-Proxy true;";
    $f_php[]="\t\tproxy_http_version   1.1;";
    $f_php[]="\t\tproxy_set_header     Upgrade \$http_upgrade;";
    $f_php[]="\t\tproxy_redirect       off;";
    $f_php[]="\t\tproxy_set_header     X-Forwarded-Proto \$scheme;";
    $f_php[]="\t\tproxy_read_timeout   86400;";
    $f_php[]="\t\tproxy_pass           http://dns-backend/dns-query ;";
    $f_php[]="\t}";
    return @implode("\n", $f_php);

}


function _proxy_pac($norestrict=false){
    $f_php[]="";
    default_one();
    $f_php[]="";
    $f_php[]="\trewrite ^/ITCharter/(.*)(?:/*)(.*)(?:/*)(.*)(?:/*)(.*) /itcharter.php?Token=$1&UserKey=$2&redirect=$3 last;";
    $f_php[] = "\tlocation ~ /itcharter\.php {";
    $f_php[]="\t\troot /usr/share/artica-postfix;";
    $f_php[]="\t\tfastcgi_split_path_info ^(.+?\.php)(/.*)$;";
    $f_php[] = fastcgi_params("/var/run/phpfpm-articaserv.sock","itcharter.php");
    $f_php[] = "\t}";

    if(!$norestrict) {
        $f_php[] = "#\t Proxy Pac No restriction";
        $f_php[] = "\tlocation / {";
        $f_php[]=   security_of_paths();
        $f_php[] = "\tif (\$uri !~ (/(wpad|wspad|proxy)\.(dat|pac)$)){";
        $f_php[] = "\t\treturn 302 /proxy.pac;";
        $f_php[] = "\t\t}";
        $f_php[] = "\t}";
    }else{
        $f_php[]=   security_of_paths();
    }

    $f_php[]="";
    $f_php[]="\tlocation ~ /(wpad|wspad|proxy)\.(dat|pac)$ {";
    $f_php[]="\t\tproxy_pass http://127.0.0.1:9505;";
    $f_php[]="\t\tproxy_set_header Host \$host;";
    $f_php[]="\t\tproxy_set_header X-Real-IP \$remote_addr;";
    $f_php[]="\t\tproxy_set_header X-Forwarded-For \$remote_addr;";
    $f_php[]="\t}";



    return @implode("\n", $f_php);

}

function fastcgi_params($fastcgi_path=null,$index=null){

    $f_php[]="\t\tfastcgi_pass 	   unix:$fastcgi_path;";
    if($index<>null){
        $f_php[]="\t\tfastcgi_index $index;";
    }
    $f_php[]="\t\tfastcgi_buffers 8 16k;";
    $f_php[]="\t\tfastcgi_buffer_size 32k;";
    $f_php[]="\t\tfastcgi_read_timeout 300;";
    $f_php[]="\t\tfastcgi_connect_timeout 300;";
    $f_php[]="\t\tfastcgi_send_timeout 300;";
    $f_php[]="\t\tfastcgi_param   QUERY_STRING             \$query_string;";
    $f_php[]="\t\tfastcgi_param   REQUEST_METHOD           \$request_method;";
    $f_php[]="\t\tfastcgi_param   CONTENT_TYPE             \$content_type;";
    $f_php[]="\t\tfastcgi_param   CONTENT_LENGTH           \$content_length;";
    $f_php[]="";
    $f_php[]="\t\tfastcgi_param   SCRIPT_FILENAME          \$document_root\$fastcgi_script_name;";
    $f_php[]="\t\tfastcgi_param   SCRIPT_NAME              \$fastcgi_script_name;";
    $f_php[]="\t\tfastcgi_param   PATH_INFO                \$fastcgi_path_info;";
    $f_php[]="\t\tfastcgi_param   PATH_TRANSLATED          \$document_root\$fastcgi_script_name;";
    $f_php[]="\t\tfastcgi_param   REQUEST_URI              \$request_uri;";
    $f_php[]="\t\tfastcgi_param   DOCUMENT_URI             \$document_uri;";
    $f_php[]="\t\tfastcgi_param   DOCUMENT_ROOT            \$document_root;";
    $f_php[]="\t\tfastcgi_param   SERVER_PROTOCOL          \$server_protocol;";
    $f_php[]="";
    $f_php[]="\t\tfastcgi_param   GATEWAY_INTERFACE       CGI/1.1;";
    $f_php[]="\t\tfastcgi_param   SERVER_SOFTWARE         Artica/1.0;";
    $f_php[]="";
    $f_php[]="\t\tfastcgi_param   REMOTE_ADDR              \$remote_addr;";
    $f_php[]="\t\tfastcgi_param   REMOTE_PORT              \$remote_port;";
    $f_php[]="\t\tfastcgi_param   SERVER_ADDR              \$server_addr;";
    $f_php[]="\t\tfastcgi_param   SERVER_PORT              \$server_port;";
    $f_php[]="\t\tfastcgi_param   SERVER_NAME              \$server_name;";
    $f_php[]="";
    $f_php[]="\t\tfastcgi_param   HTTPS                    \$https;";
    $f_php[]="";
    $f_php[]="#\t\tPHP only, required if PHP was built with --enable-force-cgi-redirect";
    $f_php[]="\t\tfastcgi_param   REDIRECT_STATUS         200;";
    return @implode("\n",$f_php);
}

function hotspot_path_artica(){
	
	directorySites_hotspot();
    $f_php[]=_proxy_pac(true);
	$f_php[]="\tlocation ~ /(fw\..*?|logon|index|logoff)\.(html|php) {";
	$f_php[]="\t\tdeny all;";
	$f_php[]="\t}";
	$f_php[]="";
	$f_php[]="\tlocation ~ [^/]\.php(/|$) {";
	$f_php[]="\t\tfastcgi_split_path_info ^(.+?\.php)(/.*)$;";
	$f_php[]="\t\tif (!-f \$document_root\$fastcgi_script_name) {";
	$f_php[]="\t\t\treturn 404;";
	$f_php[]="\t\t}";
    $f_php[]=fastcgi_params("/var/run/nginx-squid.sock");
	$f_php[]="\t}";
	return @implode("\n", $f_php);
}


function php_params(){

	$UseUnitd=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UseUnitd"));
	if($UseUnitd==1){
		echo "Using Unitd Daemon...\n";

		$f_php[]="";
		$f_php[]="\tlocation ~ \.php$ {";
		$f_php[]="\t\tproxy_pass http://127.0.0.1:49778;";
		$f_php[]="\t\tproxy_set_header Host \$host;";
		$f_php[]="\t\tproxy_set_header X-Real-IP \$remote_addr;";
		$f_php[]="\t\tproxy_set_header X-Forwarded-For \$remote_addr;";
		$f_php[]="\t}";
		$f_php[]="";
		return @implode("\n", $f_php);

	}



	$f_php[]="";
	$f_php[]="\tlocation ~ [^/]\.php(/|$) {";
	$f_php[]="\t\tfastcgi_split_path_info ^(.+?\.php)(/.*)$;";
	$f_php[]="\t\tif (!-f \$document_root\$fastcgi_script_name) {";
	$f_php[]="\t\t\treturn 404;";
	$f_php[]="\t\t}";
	$f_php[]="\t\tfastcgi_pass 	   unix:/var/run/artica-phpfpm.sock;";
	//$f_php[]="\t\tfastcgi_index index.php;";
	$f_php[]="\t\tfastcgi_buffers 8 16k;";
	$f_php[]="\t\tfastcgi_buffer_size 32k;";
	$f_php[]="\t\tfastcgi_read_timeout 300;";
	$f_php[]="\t\tfastcgi_connect_timeout 300;";
	$f_php[]="\t\tfastcgi_send_timeout 300;";
	$f_php[]="\t\tfastcgi_param   QUERY_STRING             \$query_string;";
	$f_php[]="\t\tfastcgi_param   REQUEST_METHOD           \$request_method;";
	$f_php[]="\t\tfastcgi_param   CONTENT_TYPE             \$content_type;";
	$f_php[]="\t\tfastcgi_param   CONTENT_LENGTH           \$content_length;";
	$f_php[]="";
	$f_php[]="\t\tfastcgi_param   SCRIPT_FILENAME          \$document_root\$fastcgi_script_name;";
	$f_php[]="\t\tfastcgi_param   SCRIPT_NAME              \$fastcgi_script_name;";
	$f_php[]="\t\tfastcgi_param   PATH_INFO                \$fastcgi_path_info;";
	$f_php[]="\t\tfastcgi_param   PATH_TRANSLATED          \$document_root\$fastcgi_script_name;";
	$f_php[]="\t\tfastcgi_param   REQUEST_URI              \$request_uri;";
	$f_php[]="\t\tfastcgi_param   DOCUMENT_URI             \$document_uri;";
	$f_php[]="\t\tfastcgi_param   DOCUMENT_ROOT            \$document_root;";
	$f_php[]="\t\tfastcgi_param   SERVER_PROTOCOL          \$server_protocol;";
	$f_php[]="";
	$f_php[]="\t\tfastcgi_param   GATEWAY_INTERFACE       CGI/1.1;";
	$f_php[]="\t\tfastcgi_param   SERVER_SOFTWARE         Artica/1.0;";
	$f_php[]="";
	$f_php[]="\t\tfastcgi_param   REMOTE_ADDR              \$remote_addr;";
	$f_php[]="\t\tfastcgi_param   REMOTE_PORT              \$remote_port;";
	$f_php[]="\t\tfastcgi_param   SERVER_ADDR              \$server_addr;";
	$f_php[]="\t\tfastcgi_param   SERVER_PORT              \$server_port;";
	$f_php[]="\t\tfastcgi_param   SERVER_NAME              \$server_name;";
	$f_php[]="";
	$f_php[]="\t\tfastcgi_param   HTTPS                    \$https;";
	$f_php[]="";
	$f_php[]="#\t\tPHP only, required if PHP was built with --enable-force-cgi-redirect";
	$f_php[]="\t\tfastcgi_param   REDIRECT_STATUS         200;";
	$f_php[]="\t}";

	return @implode("\n", $f_php);

}

function proxy_path_artica(){
	$unix=new unix();
	include_once(dirname(__FILE__)."/ressources/class.webconsole.params.inc");
    $SocksWeb=new SocksWeb();
	$LighttpdArticaListenInterface  = trim($SocksWeb->GET_INFO("LighttpdArticaListenInterface"));
    $ArticaHttpsPort                = intval($SocksWeb->GET_INFO("ArticaHttpsPort"));
    $ArticaHttpUseSSL               = intval($SocksWeb->GET_INFO("ArticaHttpUseSSL"));

	if($LighttpdArticaListenInterface<>null){
		$ipaddr=$unix->InterfaceToIPv4($LighttpdArticaListenInterface);
		if($LighttpdArticaListenInterface=="lo"){$ipaddr="127.0.0.1";}
	}
	if($ipaddr==null){$ipaddr="127.0.0.1";}

	if($ArticaHttpsPort==0){$ArticaHttpsPort=9000;}
	$method="http";
	if($ArticaHttpUseSSL==1){$method="https";}
	$finalURI="$method://$ipaddr:$ArticaHttpsPort";
	
	$f_php[]="";
	$f_php[]="\tlocation / {";
	$f_php[]="\t\tproxy_pass $finalURI;";
	$f_php[]="\t\tproxy_set_header Host \$host;";
	$f_php[]="\t\tproxy_set_header X-Real-IP \$remote_addr;";
	$f_php[]="\t\tproxy_set_header X-Forwarded-For \$remote_addr;";
	$f_php[]="\t}";
	$f_php[]="";
    $f_php[]=_proxy_pac(true);
    $f_php[]="";
	return @implode("\n", $f_php);
	
}

function TestTheWholeConfig(){
	$unix=new unix();
	$nginxbin=$unix->find_program("nginx");
	$php=$unix->LOCATE_PHP5_BIN();
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") testing configuration with $nginxbin...\n";}
	$unix=new unix();
	$GLOBALS["NGINX_FATAL_ERROR"]=null;
	exec("$nginxbin -c /etc/nginx/nginx.conf -t 2>&1",$testsR);
	$tests=false;
	foreach ($testsR as $line){
		if(preg_match("#\[warn\]\s+(.+)#", $line,$re)){$line=$re[1];}
		if(preg_match("#nginx:\s+(.+)#", $line,$re)){$line=$re[1];}

		if(preg_match("#emerg.*?proxy_cache.*?zone.*?is unknown#",$line)){
            echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__.
                "] $line -> Rune global conf\n";
            shell_exec("$php /usr/share/artica-postfix/exec.nginx.php --build");
            if(!isset($GLOBALS["TestTheWholeConfig"])){
                $GLOBALS["TestTheWholeConfig"]=true;
                return TestTheWholeConfig();
            }
            $GLOBALS["NGINX_FATAL_ERROR"]=$line;
            $GLOBALS["NGINX_FATAL_ERRORS"][]=$line;
            return;

        }



			
		if(preg_match("#invalid URL prefix in\s+(.*?):([0-9]+)#",$line,$re)){
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") $line\n";}
			$filename=$re[1];
			$filenameBase=basename($filename);
			$lineError=$re[2];
			$GLOBALS["NGINX_FATAL_ERROR"]=$lineError;
			$GLOBALS["NGINX_FATAL_ERRORS"][]=$line;
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") copy $filenameBase to /root\n";}
			@unlink("/root/$filenameBase");
			@copy($filename,"/root/$filenameBase");
			continue;
		}
			
			
		if(preg_match("#invalid number of arguments in \"(.+?)\" directive in (.+?):([0-9]+)#", $line,$re)){
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") $line\n";}
			$arguments=$re[1];
			$filename=$re[2];
			$filenameBase=basename($filename);
			$lineError=$re[3];
			$GLOBALS["NGINX_FATAL_ERRORS"][]=$line;
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: !!!! ERROR $arguments LINE $lineError !!!!\n";}
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") copy $filenameBase to /root\n";}
			@unlink("/root/$filenameBase");
			@copy($filename,"/root/$filenameBase");
			continue;
		}

		if(preg_match('#open.*?\"(.+)\.log"\s+failed.*?No such file or directory#', $line,$re)){
			$filename=$re[1].".log";
			$dirname=dirname($filename);
			@mkdir($dirname,0755,true);
			$APACHE=$unix->APACHE_SRC_ACCOUNT();
			$APACHEG=$unix->APACHE_SRC_GROUP();
			@chown($dirname,$APACHE);
			@chgrp($dirname, $APACHEG);
			return $this->TestTheWholeConfig();
		}
			
		if(preg_match("#SSL: error:#", $line)){
			$GLOBALS["NGINX_FATAL_ERROR"]="SSL Certificate ERROR!";
			$GLOBALS["NGINX_FATAL_ERRORS"][]=$line;
			if($GLOBALS["OUTPUT"]){echo "***************************************\n";}
			if($GLOBALS["OUTPUT"]){echo "$line\n";}
			if($GLOBALS["OUTPUT"]){echo "***************************************\n";}
			return false;
		}
			
			
			
		if(preg_match("#a duplicate default server for (.+?)\s+in\s+(.+?):#", $line,$re)){
			$filename=$re[2];
			$filenameBase=basename($filename);
			if(preg_match("#^([0-9]+)-([0-9]+)\.conf#",$filenameBase,$ri)){$SERVERID=$ri[2];Make_site_failed($SERVERID,"$line");}
			echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") duplicate default server {$re[1]} remove $filenameBase serverid:$SERVERID\n";
			@unlink($filename);
			TestTheWholeConfig();
			return false;
		}
			
		if(preg_match("#invalid URL prefix in\s+(.+?):#", $line,$re)){
			$filename=$re[1];
			$filenameBase=basename($filename);
            if(preg_match("#^([0-9]+)-([0-9]+)\.conf#",$filenameBase,$ri)){$SERVERID=$ri[2];Make_site_failed($SERVERID,"$line");}
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") invalid URL prefix remove $filenameBase\n";}
			@unlink($filename);
			TestTheWholeConfig();
			return false;
		}
			


		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") $line\n";}
		if(preg_match("#configuration file.*?test is successful#", $line)){
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Nginx[".__LINE__."](".basename(__FILE__).") testing configuration Success...\n";}
			$tests=true;
			break;
		}

	}

	if(!$tests){$GLOBALS["NGINX_FATAL_ERROR"]="Error in config file";}

	return $tests;
}

function Make_site_failed($ID,$error){
    $q=new lib_sqlite("/home/artica/SQLITE/nginx.db");
    $error=$q->sqlite_escape_string2($error);
    $q->QUERY_SQL("UPDATE nginx_services SET goodconftime=0,goodconf='',badconf_error='$error' WHERE ID=$ID");
    if(!$q->ok){echo $q->mysql_error."\n";}

}


function ssl_directives($ID){
	$unix=new unix();
	$sockngix=new socksngix($ID);
	$ssl_protocols=$sockngix->GET_INFO("ssl_protocols");
	$ssl_ciphers=$sockngix->GET_INFO("ssl_ciphers");
	$ssl_prefer_server_ciphers=SwitchOnOff(intval($sockngix->GET_INFO("ssl_prefer_server_ciphers")));
	$ssl_buffer_size=intval($sockngix->GET_INFO("ssl_buffer_size"));
	if($ssl_buffer_size==0){$ssl_buffer_size=16;}
	$ssl_certificate=$sockngix->GET_INFO("ssl_certificate");
	if($ssl_protocols==null){$ssl_protocols="TLSv1 TLSv1.1 TLSv1.2";}
	if($ssl_ciphers==null){$ssl_ciphers="ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-AES256-GCM-SHA384:kEDH+AESGCM:ECDHE-RSA-AES128-SHA256:ECDHE-ECDSA-AES128-SHA256:ECDHE-RSA-AES128-SHA:ECDHE-ECDSA-AES128-SHA:ECDHE-RSA-AES256-SHA384:ECDHE-ECDSA-AES256-SHA384:ECDHE-RSA-AES256-SHA:ECDHE-ECDSA-AES256-SHA:DHE-RSA-AES128-SHA256:DHE-RSA-AES128-SHA:DHE-RSA-AES256-SHA256:DHE-DSS-AES256-SHA:AES128-GCM-SHA256:AES256-GCM-SHA384:ECDHE-RSA-RC4-SHA:ECDHE-ECDSA-RC4-SHA:RC4-SHA:HIGH:!aNULL:!eNULL:!EXPORT:!DES:!3DES:!MD5:!PSK";}
	
	if($ssl_certificate==null){
		$f[]="# No certificate returned";
		$GLOBALS["CERTIFICATE_ENABLED"]=false;
		return @implode("\n",$f);
	}

	$nginx_certificate=new nginx_certificate($ssl_certificate,null);
	
	$f[]="#";
	$f[]="#\tSSL ---------------------------------- [".__LINE__."]";
	$f[]="#\tsslcertificate = <$ssl_certificate>";
	

	if(!is_file("/etc/nginx/certificates/dhparam.pem")){
		if(!is_dir("/etc/nginx/certificates")){@mkdir("/etc/nginx/certificates",0755,true);}
		$openssl=$unix->find_program("openssl");
		system("$openssl dhparam -outform PEM -out /etc/nginx/certificates/dhparam.pem 2048");

	}
	if(!is_file("/etc/nginx/certificates/dhparam.pem")){
		$f[]="\tssl_dhparam /etc/nginx/certificates/dhparam.pem;";
	}
	$f[]=$nginx_certificate->GetConf();
	$f[]="\tssl_session_cache shared:SSL:50m;";
	$f[]="\tssl_session_timeout  5m;";
	$f[]="\tssl_protocols  $ssl_protocols;";
	$f[]="\tssl_ciphers '$ssl_ciphers';";
	$f[]="\tssl_prefer_server_ciphers $ssl_prefer_server_ciphers;";
	$f[]="\tssl_buffer_size {$ssl_buffer_size}k;";
	$GLOBALS["CERTIFICATE_ENABLED"]=true;
	return @implode("\n",$f);
	
}

function SwitchOnOff($value){
	if($value==1){return "on";}
	if($value==0){return "off";}
}

function ElasticSearch(){
    if(!is_dir("/etc/nginx/certificates")){@mkdir("/etc/nginx/certificates",0755,true);}
    if(!is_dir("/etc/nginx/ElasticSearch")){@mkdir("/etc/nginx/ElasticSearch",0755,true);}
    $ElasticsearchBehindReverse     = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ElasticsearchBehindReverse"));
    $ElasticSearchBehindHostname    = trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ElasticSearchBehindHostname"));
    $ElasticSearchBehindCertificate = trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ElasticSearchBehindCertificate"));
    $ElasticsearchAuthenticate      = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ElasticsearchAuthenticate"));

    if($ElasticsearchBehindReverse==0){
        @unlink("/etc/nginx/ElasticSearch/ElasticSearch.conf");
        @touch("/etc/nginx/ElasticSearch/ElasticSearch.conf");
        system("/etc/init.d/nginx reload");
        return;
    }

    $f[]="";
    $f[]="server {";
    $f[]="    listen 443;";
    if($ElasticSearchBehindHostname=="*") {
        $f[] = "    server_name _;";
    }else{
        $f[] = "    server_name $ElasticSearchBehindHostname;";
    }


    $ssl_protocols="TLSv1 TLSv1.1 TLSv1.2";
    $ssl_ciphers="ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-AES256-GCM-SHA384:kEDH+AESGCM:ECDHE-RSA-AES128-SHA256:ECDHE-ECDSA-AES128-SHA256:ECDHE-RSA-AES128-SHA:ECDHE-ECDSA-AES128-SHA:ECDHE-RSA-AES256-SHA384:ECDHE-ECDSA-AES256-SHA384:ECDHE-RSA-AES256-SHA:ECDHE-ECDSA-AES256-SHA:DHE-RSA-AES128-SHA256:DHE-RSA-AES128-SHA:DHE-RSA-AES256-SHA256:DHE-DSS-AES256-SHA:AES128-GCM-SHA256:AES256-GCM-SHA384:ECDHE-RSA-RC4-SHA:ECDHE-ECDSA-RC4-SHA:RC4-SHA:HIGH:!aNULL:!eNULL:!EXPORT:!DES:!3DES:!MD5:!PSK";


    $nginx_certificate=new nginx_certificate($ElasticSearchBehindCertificate,null);

    $f[]="#";
    $f[]="#\tSSL ---------------------------------- [".__LINE__."]";
    $f[]="#\tsslcertificate = <$ElasticSearchBehindCertificate>";


    if(!is_file("/etc/nginx/certificates/dhparam.pem")){

        $unix=new unix();
        $openssl=$unix->find_program("openssl");
        system("$openssl dhparam -outform PEM -out /etc/nginx/certificates/dhparam.pem 2048");

    }
    if(!is_file("/etc/nginx/certificates/dhparam.pem")){
        $f[]="\tssl_dhparam /etc/nginx/certificates/dhparam.pem;";
    }
    $f[]=$nginx_certificate->GetConf();
    $f[]="\tssl_session_cache shared:SSL:50m;";
    $f[]="\tssl_session_timeout  5m;";
    $f[]="\tssl_protocols  $ssl_protocols;";
    $f[]="\tssl_ciphers '$ssl_ciphers';";
    $f[]="\tssl_buffer_size on;";
    $f[]="";
    $f[]="    location / {";
    if($ElasticsearchAuthenticate==1) {
        $f[] = "      auth_basic \"Restricted Access\";";
        $f[] = "      auth_basic_user_file /etc/nginx/ElasticSearch/htpasswd.users;";
    }
    $f[]="      proxy_pass http://127.0.0.1:9200;";
    $f[]="      proxy_redirect off;";
    $f[]="      proxy_buffering off;";
    $f[]="      proxy_http_version 1.1;";
    $f[]="      proxy_set_header Connection \"Keep-Alive\";";
    $f[]="      proxy_set_header Proxy-Connection \"Keep-Alive\";";
    $f[]="    }";
    $f[]="";
    $f[]="  }";
    $f[]="";

    @file_put_contents("/etc/nginx/ElasticSearch/ElasticSearch.conf",@implode("\n",$f));
}
