<?php
$GLOBALS["BYPASS"]=true;
$GLOBALS["REBUILD"]=false;
$GLOBALS["OLD"]=false;
$GLOBALS["FORCE"]=false;
$GLOBALS["VERBOSE"]=false;
$GLOBALS["PERCENT_PR"]=0;
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;}
if(preg_match("#--percent-pr=([0-9])+#",implode(" ",$argv),$re)){$GLOBALS["PERCENT_PR"]=$re[1];}
if(preg_match("#schedule-id=([0-9]+)#",implode(" ",$argv),$re)){$GLOBALS["SCHEDULE_ID"]=$re[1];}
include_once(dirname(__FILE__).'/ressources/class.templates.inc'); 
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.munin.inc');
include_once(dirname(__FILE__)."/framework/frame.class.inc");

if($argv[1]=="--monit"){SQUID_MONIT();exit;}
if($argv[1]=="--remove"){remove();exit;}
if($argv[1]=="--install"){install();exit;}
if($argv[1]=="--cache-logs"){squid_cache_log();exit;}
if($argv[1]=="--squid-service"){create_squid_service();exit;}

//

function build_progress($pourc,$text){
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	echo "[$pourc]: $text\n";
	@file_put_contents("/usr/share/artica-postfix/ressources/logs/squid.disable.progress", serialize($array));
	@chmod("/usr/share/artica-postfix/ressources/logs/squid.disable.progress",0755);
    if($GLOBALS["PERCENT_PR"]>0) {
        $array["POURC"] = $GLOBALS["PERCENT_PR"];
        $array["TEXT"] = "{$pourc}% - $text";
        @file_put_contents("/usr/share/artica-postfix/ressources/logs/web/wizard.progress",
            serialize($array));
    }

}
function build_progress_monit($pourc,$text){
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    echo "[$pourc]: $text\n";
    @file_put_contents("/usr/share/artica-postfix/ressources/logs/squid.monit.progress", serialize($array));
    @chmod("/usr/share/artica-postfix/ressources/logs/squid.monit.progress",0755);
}

function install(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SQUIDEnable", 1);
	squid_admin_mysql(1, "Installing the proxy service...", null,__FILE__,__LINE__);
	build_progress(50, "{reconfigure_proxy_service}");
    system("$php /usr/share/artica-postfix/exec.convert-to-sqlite.php");
    build_progress(51, "{reconfigure_proxy_service}");
	system("$php /usr/share/artica-postfix/exec.squid.php --build --force");
    build_progress(52, "{reconfigure_proxy_service}");
	system("$php /usr/share/artica-postfix/exec.postfix-install.php --uninstall");
	
	build_progress(55, "{reconfigure_proxy_service}");
	system("$php /usr/share/artica-postfix/exec.squid.global.access.php --noverifacls");
	
	
	build_progress(60, "{create_the_service}");
	create_squid_service();
    squid_cache_log();


    build_progress(61, "{create_the_service}");
    $unix->Popuplate_cron_make("squid-storedir-5mn","0,5,10,15,20,25,30,35,40,45,50,55 * * * *","exec.squid.php.storedir.php");
    $unix->Popuplate_cron_make("artica-squid-5min","1,6,11,16,21,26,31,36,41,46,51,56 * * * *","exec.squidMins.php");
    $unix->Popuplate_cron_make("squid-certificates", "0,10,20,30,40,50 * * * *", "exec.squid.ssl.certificates.php --parse-certificates");


    system("/etc/init.d/cron restart");

	build_progress(90, "{restart_status_service}");
	system("/etc/init.d/artica-status restart --force");
	system("/etc/init.d/monit restart");
	system("$php /usr/share/artica-postfix/exec.pam.php --build");
	build_progress(95, "{restart_status_service}");
	system("$php /usr/share/artica-postfix/exec.nsswitch.php");
	system("$php /usr/share/artica-postfix/exec.logrotate.php --reconfigure");
	build_progress(98, "{restart_status_service}");
	if(is_file("/etc/init.d/munin-node")){system("$php /usr/share/artica-postfix/exec.munin.php --reconfigure");}
	build_progress(100, "{done}");
	
    if(is_file("/etc/init.d/zabbix-agent")){
        system("/etc/init.d/zabbix-agent restart");
    }
	
	
	
}

function remove_service($INITD_PATH){
	if(!is_file($INITD_PATH)){return;}
	system("$INITD_PATH stop");

	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");
	}

	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");

	}

	if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}

function squid_cache_log(){
    $unix=new unix();
    $php5=$unix->LOCATE_PHP5_BIN();
    $dirname=dirname(__FILE__);
    $chmod=$unix->find_program("chmod");
    $conf[]="#! /bin/sh";
    $conf[]="# /etc/init.d/cache-tail";
    $conf[]="#";
    $conf[]="# cache-tail Debian init script";
    $conf[]="#";
    $conf[]="### BEGIN INIT INFO";
    $conf[]="# Provides:          cache-tail";
    $conf[]="# Required-Start:    \$syslog";
    $conf[]="# Required-Stop:     \$syslog";
    $conf[]="# Should-Start:      \$local_fs";
    $conf[]="# Should-Stop:       \$local_fs";
    $conf[]="# Default-Start:     3 4 5";
    $conf[]="# Default-Stop:      1";
    $conf[]="# Short-Description: Launch squid-tail on cache.log server";
    $conf[]="# Description:       Launch squid-tail on cache.log server";
    $conf[]="### END INIT INFO";

    $conf[]="";
    $conf[]="case \"\$1\" in";
    $conf[]=" start)";
    $conf[]="    $php5 $dirname/exec.init-tail-cache.php --start \$1 \$2";
    $conf[]="    ;;";
    $conf[]="";
    $conf[]="  stop)";
    $conf[]="    $php5 $dirname/exec.init-tail-cache.php --stop \$1 \$2";
    $conf[]="    ;;";
    $conf[]="";
    $conf[]=" restart)";
    $conf[]="	  $php5 $dirname/exec.init-tail-cache.php --stop \$1 \$2";
    $conf[]="     $php5 $dirname/exec.init-tail-cache.php --start \$1 \$2";
    $conf[]="    ;;";
    $conf[]="";
    $conf[]=" reload)";
    $conf[]="     $php5 $dirname/exec.init-tail-cache.php --stop \$1 \$2";
    $conf[]="     $php5 $dirname/exec.init-tail-cache.php --stop \$1 \$2";
    $conf[]="    ;;";
    $conf[]="";
    $conf[]="";
    $conf[]="  *)";
    $conf[]="    echo \"Usage: \$0 {start|stop|restart|reload}\"";
    $conf[]="    exit 1";
    $conf[]="    ;;";
    $conf[]="esac";
    $conf[]="exit 0\n";
    @file_put_contents("/etc/init.d/cache-tail",@implode("\n",$conf));
    $debianbin=$unix->find_program("update-rc.d");
    $redhatbin=$unix->find_program("chkconfig");

    shell_exec("$chmod +x /etc/init.d/cache-tail >/dev/null 2>&1");
    if(is_file($debianbin)){
        shell_exec("$debianbin -f cache-tail defaults >/dev/null 2>&1");
        return;
    }
    if(is_file($redhatbin)){
        shell_exec("$redhatbin --add cache-tail >/dev/null 2>&1");
        shell_exec("$redhatbin --level 2345 cache-tail on >/dev/null 2>&1");
    }
    if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Squid-Cache Tail success...\n";}
}


function remove(){
	squid_admin_mysql(0, "Removing the proxy service and all associated softwares", null,__FILE__,__LINE__);
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	$servicesINIT[]="squid";
	$servicesINIT[]="squidguard-http";
	$servicesINIT[]="squid-nat";
	$servicesINIT[]="squid-tail";
	$servicesINIT[]="iptables-transparent";
	$servicesINIT[]="hypercache-web";
	$servicesINIT[]="ufdb-tail";
	$servicesINIT[]="wanproxy-parent";
	$servicesINIT[]="wanproxy-childs";
	$servicesINIT[]="zipproxy";
	$servicesINIT[]="ntlm-monitor";
	$servicesINIT[]="proxy-pac";
	$servicesINIT[]="squid-tail-size";
	$servicesINIT[]="squid-tail";
	$servicesINIT[]="cache-scheduler";
	$servicesINIT[]="cache-httpd";
	$servicesINIT[]="ufdb-client";
	$servicesINIT[]="ufdb";
	$servicesINIT[]="microhotspot";
	$servicesINIT[]="hotspot-web";
	$servicesINIT[]="wifidog";
	$servicesINIT[]="c-icap";
	$servicesINIT[]="c-icap-access";
	$servicesINIT[]="c-icap-watchdog";
	$servicesINIT[]="cache-tail";
	$servicesINIT[]="kav4proxy";
	$servicesINIT[]="cntlm";
	$servicesINIT[]="winbind";
	$servicesINIT[]="cache-tail";


	$pourc=30;

    $SERVICES["/etc/init.d/proxy-pac"]="exec.squid.autoconfig.php --uninstall";
    $SERVICES["/etc/init.d/ufdb"]="exec.ufdb.disable.php";
    $SERVICES["/etc/init.d/privoxy"]="exec.privoxy.php --remove";
    $SERVICES["/etc/init.d/wanproxy"]="exec.wanproxy.php --uninstall";
    $SERVICES["/etc/init.d/zipproxy"]="exec.zipproxy.php --uninstall";
    $SERVICES["/etc/init.d/ziproxy"]="exec.zipproxy.php --uninstall";
    $SERVICES["/etc/init.d/c-icap"]="exec.c-icap.install.php --uninstall";
    $SERVICES["/etc/init.d/itcharter"]="exec.itchart.php --uninstall";

	foreach ($SERVICES as $initd=>$script){
        if(is_file($initd)){
            build_progress($pourc++, "{removing} $initd");
            shell_exec("$php /usr/share/artica-postfix/$script");
        }
    }


	foreach ($servicesINIT as $filename){
		build_progress($pourc++, "{removing} $filename");
		remove_service("/etc/init.d/$filename");
	}
	$tokens[]="EnableSS5";
	$tokens[]="kavicapserverEnabled";
	$tokens[]="SQUIDEnable";
	$tokens[]="EnableUfdbGuard";
	$tokens[]="EnableUfdbGuard2";
	$tokens[]="EnableCNTLM";
	$tokens[]="PrivoxyEnabled";
	$tokens[]="EnableKerbAuth";
	$tokens[]="EnableSquidMicroHotSpot";
	$tokens[]="EnableTransparent27";
	$tokens[]="EnableArticaHotSpot";
	$tokens[]="PrivoxyEnabled";
	$tokens[]="WindowsUpdateCaching";
	$tokens[]="EnableQuotaSize";
    $tokens[]="SquidCachesProxyEnabled";
	$tokens[]="HyperCacheStoreID";

	$cron[]="squid-repos";
	$cron[]="artica-squid-5min";
    $cron[]="squid-storedir-5mn";
	$cron[]="squid-rotate";
	$cron[]="artica-calamaris";
	$cron[]="squidping";
	$cron[]="squid-ping-port";
    $cron[]="hotspot-task";
    $cron[]="squid-client-list";
    $cron[]="squid-run-c";
    $cron[]="squid-chown";
    $cron[]="squid-negotiateauthenticator-5mn";
    $cron[]="squid-certificates";




	$cron_reboot=false;
	foreach ($cron as $filename){
		if(is_file("/etc/cron.d/$filename")){@unlink("/etc/cron.d/$filename");$cron_reboot=true;}
		
	}
	if($cron_reboot){system("/etc/init.d/cron restart");}
	
	
	foreach ($tokens as $filename){
		build_progress($pourc++, "{disable} $filename");
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("$filename", 0);
	}
	
	
	build_progress(80, "{remove_service} {APP_UFDBWEBSIMPLE}");
	system("$php /usr/share/artica-postfix/exec.ufdb-lighthttp.php --uninstall-web");
    system("$php /usr/share/artica-postfix/exec.firewall.proxy.transparent.php --build");
	
	@unlink("/etc/monit/conf.d/APP_SQUID.monitrc");
    @unlink("/etc/monit/conf.d/APP_SQUID_CACHE_TAIL.monitrc");
	
	
	
	build_progress(90, "{restart_status_service}");
	system("/etc/init.d/artica-status restart --force");
	system("/etc/init.d/monit restart");
	system("$php /usr/share/artica-postfix/exec.pam.php --build");
	build_progress(95, "{restart_status_service}");
	system("$php /usr/share/artica-postfix/exec.nsswitch.php");
	build_progress(97, "{restart_status_service}");
	if(is_file("/etc/init.d/munin-node")){system("$php /usr/share/artica-postfix/exec.munin.php --reconfigure");}	
	build_progress(100, "{done}");
	
	
	
}


function create_squid_service(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	$cat=$unix->find_program("cat");
	$squid=$unix->LOCATE_SQUID_BIN();
    $max_filedesc=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("max_filedesc"));
    if($max_filedesc==0){$max_filedesc=8096;}
	
	$f[]="#!/bin/sh";
	$f[]="### BEGIN INIT INFO";
	$f[]="# Provides:          squid";
	$f[]="# Required-Start:    \$local_fs \$remote_fs \$syslog \$network \$time";
	$f[]="# Required-Stop:     \$local_fs \$remote_fs \$syslog \$network";
	$f[]="# Should-Start:";
	$f[]="# Should-Stop:";
	$f[]="# Default-Start:     3 4 5";
	$f[]="# Default-Stop:      0 1 6";
	$f[]="# Short-Description: Start squid-cache proxy";
	$f[]="# chkconfig: 2345 11 89";
	$f[]="# description: Squid-cache proxy Daemon";
	$f[]="### END INIT INFO";
	$f[]="SQUID_ARGS=\"-C -f /etc/squid3/squid.conf\"";
	$f[]="ENABLED=1";
	$f[]=". /lib/lsb/init-functions";

    $ulimit=65535;

    if($max_filedesc>$ulimit){
        $ulimit=$max_filedesc;
    }


	$f[]="start () {";
	$f[]="\tulimit -HSn $ulimit ||true";
	$f[]="\texport MALLOC_ARENA_MAX=16 || true";
	$f[]="\t$php /usr/share/artica-postfix/exec.squid.php --security-limit || true";
	$f[]="\tmkdir -p /var/run/squid || true";
	$f[]="\tmkdir -p /var/logs  || true";
	$f[]="\tmkdir -p /var/log/squid  || true";
	$f[]="\tmkdir -p /var/squid/cache || true";
	$f[]="\tchmod 0755 /var/run/squid || true";
	$f[]="\tchmod 0755 /var/logs || true";
	$f[]="\tchmod 0755 /var/log/squid || true";
	$f[]="\tchmod 0755 /var/squid/cache || true";
	$f[]="\tchown squid:squid /var/run/squid || true";
	$f[]="\tchown squid:squid /var/logs || true";
	$f[]="\tchown squid:squid /var/squid/cache || true";
	$f[]="\tchown -R squid:squid /var/log/squid || true";
    $f[]="\tchown squid:squid /var/log/squid/access.log || true";
	$f[]="\tif [ -f /var/run/squid/squid.pid ]; then";
	$f[]="\t\trm /var/run/squid/squid.pid";
	$f[]="\tfi";
	$f[]="\tumask 027";
	$f[]="\tstart-stop-daemon --quiet --start --pidfile /var/run/squid/squid.pid --chuid squid --exec $squid -- \$SQUID_ARGS < /dev/null";
	$f[]="\treturn $?";
	$f[]="\t}";
	$f[]="";
	$f[]="case \"\$1\" in";
	$f[]=" start)";
	$f[]="\tKRB5RCACHETYPE=none ";
	$f[]="\texport KRB5RCACHETYPE";
	$f[]="\tKRB5_KTNAME=/etc/squid3/PROXY.keytab";
	$f[]="\texport KRB5_KTNAME";
	$f[]="\tif pidof -o %PPID -x \"$squid\">/dev/null; then";
	$f[]="\t\tlog_failure_msg \"Squid-Cache already running\"";
	$f[]="\t\texit 0";
	$f[]="\tfi";
	$f[]="\tif [ -f /etc/artica-postfix/settings/Daemons/SQUIDEnable ]; then";
	$f[]="\t\tENABLED=`$cat /etc/artica-postfix/settings/Daemons/SQUIDEnable`";
	$f[]="\tfi";

	$f[]="\tif [ \$ENABLED -eq 0 ]; then";
	$f[]="\t\tlog_failure_msg \"Squid-Cache is disabled - STOPPING -\"";
	$f[]="\t\texit 0";
	$f[]="\tfi";
	$f[]="\tif [ ! -f \"/etc/squid3/squid.conf\" ]; then";
	$f[]="\t\tlog_failure_msg \"Squid-Cache is disabled - missing configuration -\"";
	$f[]="\t\texit 0";
	$f[]="\tfi";
	$f[]="\tlog_daemon_msg \"Starting Squid-Cache HTTP proxy\"";
	$f[]="\tlog_action_end_msg 0";

	$f[]="\tif start ; then";
	$f[]="\t\tlog_success_msg \"Starting Squid-Cache HTTP proxy Success\"";
	$f[]="\t\tlog_end_msg $?";
	$f[]="\telse";
	$f[]="\t\tlog_failure_msg \"Failed to start Squid-Cache\"";
	$f[]="\t\tlog_end_msg $?";
	$f[]="\tfi";

	$f[]=" ;;";
	$f[]="";
	$f[]="  stop)";
	$f[]="\t$php /usr/share/artica-postfix/exec.squid.watchdog.php --stop --byinitd --force \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" restart)";
	$f[]="\t$php /usr/share/artica-postfix/exec.squid.php --security-limit || true";
	$f[]="\t$php /usr/share/artica-postfix/exec.squid.watchdog.php --restart --byinitd --force \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" reload)";
    $f[]="\tKRB5RCACHETYPE=none ";
    $f[]="\texport KRB5RCACHETYPE";
    $f[]="\tKRB5_KTNAME=/etc/squid3/PROXY.keytab";
    $f[]="\texport KRB5_KTNAME";
	$f[]="\t$php /usr/share/artica-postfix/exec.squid.watchdog.php --reload --byinitd \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  *)";
	$f[]="    echo \"Usage: \$0 {start|stop|restart} {ldap|} (+ 'debug' for more infos)\"";
	$f[]="    exit 1";
	$f[]="    ;;";
	$f[]="esac";
	$f[]="exit 0\n";
	@file_put_contents("/etc/init.d/squid", @implode("\n", $f));
	@chmod("/etc/init.d/squid",0755);

	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec('/usr/sbin/update-rc.d -f squid defaults >/dev/null 2>&1');
	}

	if(is_file('/sbin/chkconfig')){
		shell_exec('/sbin/chkconfig --add squid >/dev/null 2>&1');
		shell_exec('/sbin/chkconfig --level 2345 squid on >/dev/null 2>&1');
	}
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Squid-Cache Proxy success...\n";}

	SQUID_MONIT();


}

function SQUID_MONIT(){
	@unlink("/etc/monit/conf.d/APP_SQUID.monitrc");
    $SQUIDEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable"));
    if($SQUIDEnable==0){return;}
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();

    $MonitConfig=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidWatchdogMonitConfig")));
    if(!isset($MonitConfig["watchdog"])){$MonitConfig["watchdog"]=1;}

	if(!isset($MonitConfig["watchdog"])){$MonitConfig["watchdog"]=1;}
	if(!is_numeric($MonitConfig["watchdog"])){$MonitConfig["watchdog"]=1;}
	$LogsRotateDefaultSizeRotation=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LogsRotateDefaultSizeRotation"));
	if($LogsRotateDefaultSizeRotation<5){$LogsRotateDefaultSizeRotation=100;}
	$SquidRotateOnlySchedule=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidRotateOnlySchedule"));

    build_progress_monit(20,"{watchdog}");

	$sh[]="#!bin/sh";
	$sh[]="$php /usr/share/artica-postfix/exec.squid.watchdog.php --notify-monit-start";
	$sh[]="$php /usr/share/artica-postfix/exec.squid.watchdog.php --start";
	$sh[]="exit 0";
	$sh[]="";
	@file_put_contents("/usr/sbin/artica.squid.start.sh", @implode("\n", $sh));
	@chmod("/usr/sbin/artica.squid.start.sh",0755);
	$sh=array();

	$sh[]="#!bin/sh";
	$sh[]="$php /usr/share/artica-postfix/exec.squid.watchdog.php --notify-monit-stop";
	$sh[]="$php /usr/share/artica-postfix/exec.squid.watchdog.php --stop";
	$sh[]="exit 0";
	$sh[]="";
	@file_put_contents("/usr/sbin/artica.squid.stop.sh", @implode("\n", $sh));
	@chmod("/usr/sbin/artica.squid.stop.sh",0755);
	$sh=array();

    $f=array();
    $f[]="check process APP_SQUID_CACHE_TAIL with pidfile /etc/artica-postfix/pids/exec.cache-logs.php.pid";
    $f[]="\tstart program = \"/etc/init.d/cache-tail start --monit\"";
    $f[]="\tstop program = \"/etc/init.d/cache-tail stop --monit\"";
    $f[]="\tif 5 restarts within 5 cycles then timeout";
    $f[]="";
    @file_put_contents("/etc/monit/conf.d/APP_SQUID_CACHE_TAIL.monitrc", @implode("\n", $f));

    build_progress_monit(30,"{watchdog}");
    $f=array();
	$f[]="";
	$f[]="check process APP_SQUID with pidfile /var/run/squid/squid.pid";
	$f[]="\tstart program = \"/usr/sbin/artica.squid.start.sh\"";
	$f[]="\tstop program = \"/usr/sbin/artica.squid.stop.sh\"";

    build_progress_monit(40,"{watchdog}");

	if($MonitConfig["watchdog"]==1){
		$MonitSquidMaxCPU=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MonitSquidMaxCPU"));
        $MonitSquidMaxCPUCycles=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MonitSquidMaxCPUCycles"));
        if($MonitSquidMaxCPUCycles==0){$MonitSquidMaxCPUCycles=5;}

		if($MonitSquidMaxCPU>0){$f[]="\tif cpu usage > {$MonitSquidMaxCPU}% for $MonitSquidMaxCPUCycles cycles then restart";}
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring squid...\n";}
	}
	$f[]="\tif 5 restarts within 5 cycles then timeout";

	$SquidMgrListenPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidMgrListenPort"));

	if($SquidMgrListenPort>0){
		$f[]="\tif failed host 127.0.0.1 port $SquidMgrListenPort protocol http request \"/squid-internal-mgr/utilization\" with timeout 15 seconds then restart";
	}

    build_progress_monit(50,"{watchdog}");


		$f[]="";
		$f[]="check file access_log with path /var/log/squid/access.log";
        $f[]="\tif does not exist then exec \"/usr/sbin/squid-touch.sh\"";
		$f[]="\tif failed uid \"squid\" then exec \"/usr/bin/chown squid:squid /var/log/squid/access.log\"";
    if($SquidRotateOnlySchedule==0){$f[]="\tif size > {$LogsRotateDefaultSizeRotation} MB then exec \"/usr/sbin/squid-rotate.sh\"";}
		$f[]="";

		$SCRIPT=array();
		$SCRIPT[]="#!/bin/sh";
		$SCRIPT[]="";
		$SCRIPT[]="$php /usr/share/artica-postfix/exec.squid.php --rotate";
		$SCRIPT[]="";
		@file_put_contents("/usr/sbin/squid-rotate.sh", @implode("\n", $SCRIPT));
		@chmod("/usr/sbin/squid-rotate.sh", 0755);
		$SCRIPT=array();
		$SCRIPT[]="#!/bin/sh";
		$SCRIPT[]="";
		$SCRIPT[]="/usr/bin/touch /var/log/squid/access.log";
		$SCRIPT[]="/usr/bin/chown squid:squid /var/log/squid/access.log";
		$SCRIPT[]="";
		@file_put_contents("/usr/sbin/squid-touch.sh", @implode("\n", $SCRIPT));
		@chmod("/usr/sbin/squid-touch.sh", 0755);

        $sslcrtd_program_dbsize=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("sslcrtd_program_dbsize"));
        if($sslcrtd_program_dbsize==0){$sslcrtd_program_dbsize=8;}
        $SCRIPT=array();
        $SCRIPT[]="#!/bin/sh";
        $SCRIPT[]="";
        $SCRIPT[]="if [ ! -d \"/var/cache/squid\" ]; then";
        $SCRIPT[]="/usr/bin/mkdir -p /var/cache/squid";
        $SCRIPT[]="fi";
        $SCRIPT[]="if [ ! -d \"/var/cache/squid/ssl_db\" ]; then";
        $SCRIPT[]="/usr/lib/squid3/security_file_certgen -c -s /var/cache/squid/ssl_db -M {$sslcrtd_program_dbsize}MB";
        $SCRIPT[]="fi";
        $SCRIPT[]="/usr/bin/chown -R squid:squid /var/cache/squid";
        $SCRIPT[]="$php /usr/share/artica-postfix/exec.squid.watchdog.php --notify-monit-ssldb >/dev/null 2>&1";
        $SCRIPT[]="/usr/sbin/squid -f /etc/squid3/squid.conf -k reconfigure >/dev/null 2>&1";
        @file_put_contents("/usr/sbin/squid-ssldb.sh", @implode("\n", $SCRIPT));
        @chmod("/usr/sbin/squid-ssldb.sh", 0755);

        $f1[]="";
        $f1[]="check directory ssl_db with path /var/cache/squid/ssl_db";
        $f1[]="\tif does not exist then exec \"/usr/sbin/squid-ssldb.sh\"";
        $f1[]="\tif failed uid \"squid\" then exec \"/bin/chown -R squid:squid /var/cache/squid\"";
        $f1[]="";
        @file_put_contents("/etc/monit/conf.d/ssl_db.monitrc",@implode("\n",$f1));


    build_progress_monit(80,"{watchdog}");

	@file_put_contents("/etc/monit/conf.d/APP_SQUID.monitrc", @implode("\n", $f)."\n");
    shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload");
    build_progress_monit(100,"{watchdog} {success}");


}