#!/usr/bin/php -q
<?php
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
$GLOBALS["FORCE"]=false;
$GLOBALS["RECONFIGURE"]=false;
$GLOBALS["SWAPSTATE"]=false;
$GLOBALS["NOSQUIDOUTPUT"]=true;
$GLOBALS["PROGRESS"]=true;
$GLOBALS["CLI"]=false;
$GLOBALS["TITLENAME"]="Kaspersky Update Utility";


$GLOBALS["AS_ROOT"]=true;
include_once(dirname(__FILE__).'/ressources/class.ldap.inc');
include_once(dirname(__FILE__).'/ressources/class.squid.inc');
include_once(dirname(__FILE__).'/ressources/class.mysql.inc');

include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.settings.inc');
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.ccurl.inc');

xuninstall();

function build_progress($text,$pourc){
	$echotext=$text;
	if(is_numeric($text)){$old=$pourc;$pourc=$text;$text=$old;}
	$echotext=str_replace("{reconfigure}", "Reconfigure", $echotext);
	echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} {$pourc}% $echotext\n";
	$cachefile="/usr/share/artica-postfix/ressources/logs/UpdateUtility.install.progress";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($cachefile, serialize($array));
	@chmod($cachefile,0755);
}


function xuninstall(){
	$unix=new unix();
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableKasperskyUpdateUtility",0);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableKasperskyUpdateUtilityAgreements",0);
	$rm=$unix->find_program("rm");
	build_progress("{remove_software}",20);

	@unlink("/home/kuu3/events.db");
	@unlink("/home/kuu3/stats.db");

    build_progress("{remove_databases}",25);
    if(is_dir("/etc/UpdateUtility")){system("$rm -rf /etc/UpdateUtility");}
	build_progress("{remove_databases}",26);
	if(is_dir("/home/kaspersky/UpdateUtility")){
		echo "Remove /home/kaspersky/UpdateUtility\n";
		system("$rm -rf /home/kaspersky/UpdateUtility");
	}

    $KUU3UpdatesFolder= trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("KUU3UpdatesFolder"));
    if($KUU3UpdatesFolder==null){$KUU3UpdatesFolder="/home/kuu3/Updates";}

    build_progress("{remove_databases}",27);
    if(is_dir($KUU3UpdatesFolder)){
        echo "Remove $KUU3UpdatesFolder\n";
        system("$rm -rf $KUU3UpdatesFolder");
    }

	build_progress("{remove_tasks}",40);
	if(is_file("/etc/cron.d/UpdateUtility")){@unlink("/etc/cron.d/UpdateUtility");}
    if(is_file("/etc/cron.d/UpdateUtility-rotate")){@unlink("/etc/cron.d/UpdateUtility-rotate");}

	if(is_file("/etc/init.d/nginx")) {
        @unlink("/var/log/nginx/kuu3.log");
        @unlink("/var/log/nginx/kuu3-error.log");
    }
    build_progress("{remove_webservices}",45);
    $q=new lib_sqlite("/home/artica/SQLITE/nginx.db");
    $sql = "UPDATE nginx_services SET enabled=0 WHERE `type`=11";
    $q->QUERY_SQL($sql);
    $php5=$unix->LOCATE_PHP5_BIN();
    shell_exec("$php5 /usr/share/artica-postfix/exec.nginx.single.php --clean-reboot >/dev/null 2>&1 ");

    system("/etc/init.d/cron reload");
	build_progress("{remove_software} {success}",100);
	
	
	
	
}