<?php
include_once(dirname(__FILE__)."/ressources/class.template-admin.inc");if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
if(isset($_GET["verbose"])){$GLOBALS["VERBOSE"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
if(isset($_POST["none"])){die();}
if(isset($_GET["tabs"])){tabs();exit;}
if(isset($_GET["table"])){table();exit;}
if(isset($_GET["status"])){status();exit;}
if(isset($_POST["postgresqlPort"])){Save();exit;}
if(isset($_GET["ufdbconf-popup"])){ufdbconf_popup();exit;}
if(isset($_GET["ufdbdebug-popup"])){ufdbdebug_popup();exit;}
if(isset($_GET["graph1"])){graph1();exit;}
if(isset($_GET["remove-database-ask"])){remove_database_ask();exit;}

status();

function tabs(){
	$page=CurrentPageName();
	$tpl=new template_admin();
	$array["{status}"]="$page?table=yes";
    $array["{entities}"]="fw.statscom.entities.php";
	$array["{days}"]="fw.statscom.days.php";
    $array["{data}"]="fw.statscom.data.php";
    $array["{pdf_reports}"]="fw.statscom.reports.php";
    $array["{events}"]="fw.statscom.events.php";
    echo $tpl->tabs_default($array);

}

function remove_database_ask(){
    $page=CurrentPageName();
    $tpl=new template_admin();


    $ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/postgres.remove.progress";
    $ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/postgres.remove.progress.txt";
    $ARRAY["CMD"]="postgres.php?remove-database=yes";
    $ARRAY["TITLE"]="{REMOVE_DATABASE}";
    $ARRAY["AFTER"]="LoadAjax('table-postgresqlstatus','$page?tabs=yes');";
    $prgress=base64_encode(serialize($ARRAY));
    $jsrestart="Loadjs('fw.progress.php?content=$prgress&mainid=postgress-statscom-restart');";
    $tpl->js_confirm_delete("{REMOVE_DATABASE}<hr>{rebuild_database_warn}","none",$tpl->javascript_parse_text("{database}"),$jsrestart);
}

function GET_DATAS(){
    $tpl=new template_admin();
    try {
        $redis = new Redis();
        $redis->connect("127.0.0.1", 4322, 2);
    } catch (Exception $e) {

        echo $tpl->div_error($e->getMessage());
        exit;
    }

    try {
        $datas = unserialize(base64_decode($redis->get("DASBOARD.ALLSTATS")));
    } catch (Exception $e) {
        echo $tpl->div_error($e->getMessage());
        exit;
    }
    $redis->close();
    return $datas;

}


function status(){
	$page=CurrentPageName();
	$tpl=new template_admin();

	$html="
	<div class=\"row border-bottom white-bg dashboard-header\">
	    <div class=\"col-sm-12\">
	            <h1 class=ng-binding>{APP_STATS_COMMUNICATOR}</h1>
	            <p>{APP_STATS_COMMUNICATOR_EXPLAIN}</p>
    	</div>
    </div>
		
	<div class='row'>
	        <div id='postgress-statscom-restart'></div>
	        <div class='ibox-content' style='min-height:600px'>
                <div id='table-statscom-status'></div>
	        </div>
	</div>
		
		
		
	<script>
	$.address.state('/');
	$.address.value('/statscom');
	LoadAjax('table-statscom-status','$page?tabs=yes');
		
	</script>";

	if(isset($_GET["main-page"])){
		$tpl=new template_admin(null,$html);
		echo $tpl->build_firewall();
		return;
	}
	
	$tpl=new template_admin();
	echo $tpl->_ENGINE_parse_body($html);

}

function Access_keys_number(){
    $tpl=new template_admin();

    try {
        $redis = new Redis();
        $redis->connect("127.0.0.1", 4322, 2);
    } catch (Exception $e) {
        echo $tpl->div_error($e->getMessage());
        return false;
    }

    try {
        $ALL_KEYS = $redis->keys("ACCESS.*");
    }catch (Exception $e) {
            echo $tpl->div_error($e->getMessage());
            return false;
        }

    return count($ALL_KEYS);

}

function table(){
	$page=CurrentPageName();
	$tpl=new template_admin();
	$ini=new Bs_IniHandler();
	$sock=new sockets();
	$sock->getFrameWork("statscom.php?status=yes");
	$ini->loadFile("/usr/share/artica-postfix/ressources/logs/web/statscom.status");
    $Access_keys_number=Access_keys_number();
    $MAIN=GET_DATAS();



	
	$ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/statscom.progress";
	$ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/statscom.txt";
	$ARRAY["CMD"]="statscom.php?restart=yes";
	$ARRAY["TITLE"]="{restarting_service}";
	$ARRAY["AFTER"]="LoadAjax('table-statscom-status','$page?tabs=yes');;";
	$prgress=base64_encode(serialize($ARRAY));
	$jsrestart="Loadjs('fw.progress.php?content=$prgress&mainid=postgress-statscom-restart');";

    $LAST_DATE=$MAIN["TOTAL"]["ALL"]["LAST_DATE"];
    $IPADRS=$MAIN["TOTAL"]["ALL"]["IPADRS"];
    $LAST_DATE_BIN=strtotime($LAST_DATE);
    $LAST_DATE=$tpl->time_to_date($LAST_DATE_BIN,true);


    $STATSCOM_LAST_SCAN_TEXT=null;
    $STATSCOM_USERS=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("STATSCOM_USERS"));
    $STATSCOM_PROXYNAME=unserialize($GLOBALS["CLASS_SOCKETS"]->GET_INFO("STATSCOM_PROXYNAME"));
    $STATSCOM_LAST_SCAN=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("STATSCOM_LAST_SCAN"));
    $STATSCOM_COUNT_RQS=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("STATSCOM_COUNT_RQS"));
    $STATSCOM_COUNT_BYTES=$MAIN["TOTAL"]["DAILY"]["DOWN"];
    $STATSCOM_COUNT_SITES=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("STATSCOM_COUNT_SITES"));

    if($STATSCOM_LAST_SCAN>0){
        $STATSCOM_COUNT_ENTRIES=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("STATSCOM_COUNT_ENTRIES"));
        $STATSCOM_LAST_SCAN_TEXT="&nbsp;<small>({last_scan} {since} ".distanceOfTimeInWords($STATSCOM_LAST_SCAN,time())." {$STATSCOM_COUNT_ENTRIES} {rows})</small>";
    }

	$html[]="<table style='width:100%;margin-top:15px'>";
	$html[]="<tr>";
	$html[]="<td style='width:260px' valign='top'>";
	$html[]="<table style='width:100%'>";
	$html[]="<tr><td>
	<div class=\"ibox\">
    	<div class=\"ibox-content\">". $tpl->SERVICE_STATUS($ini, "APP_STATS_COMMUNICATOR",$jsrestart).
        $tpl->SERVICE_STATUS($ini,"APP_STATS_REDIS",$jsrestart)."
	</div>
   
    </td>
    </tr>";

$html[]="</table></td>";

$html[]="<td style='width:99%;vertical-align:top;'>";
    $html[]="<H2>{last_10_minutes}$STATSCOM_LAST_SCAN_TEXT</H2><table style='width:100%;margin-top:5px'>";
    $html[]="<tr>";
    $html[] = "<td style='padding:2px'>" . $tpl->widget_style1("navy-bg", "fas fa-alarm-clock", "{last_date}", $LAST_DATE . "</td>");
    $html[]="<td style='padding:2px'>".$tpl->widget_style1("navy-bg","fas fa-cloud-showers","{requests}",$tpl->FormatNumber($STATSCOM_COUNT_RQS))."</td>";
    $html[]="<td style='padding:2px'>".$tpl->widget_style1("lazur-bg","fas fa-cloud-download","{total_downloaded}",FormatBytes($STATSCOM_COUNT_BYTES/1024))."</td>";
    $html[]="</tr>";
    $html[] = "<td style='padding:2px'>" . $tpl->widget_style1("navy-bg", "fas fa-user-clock", "{nodes}", $tpl->FormatNumber($IPADRS)) . "</td>";
    $html[] = "<td style='padding:2px'>" . $tpl->widget_style1("navy-bg", "fas fa-server", "{entities}", $tpl->FormatNumber(count($STATSCOM_PROXYNAME))) . "</td>";

    if($Access_keys_number<10) {
        $html[] = "<td style='padding:2px'>" . $tpl->widget_style1("red-bg", "fas fa-cloud-showers", "{incoming}", $tpl->FormatNumber($Access_keys_number)) . "</td>";
    }else{
        $html[] = "<td style='padding:2px'>" . $tpl->widget_style1("navy-bg", "fas fa-cloud-showers", "{incoming}", $tpl->FormatNumber($Access_keys_number)) . "</td>";
    }
    $html[]="</tr>";
    $html[]="</table>";

$html[]="</td>";
$html[]="</tr>";

$html[]="</table>";
	echo $tpl->_ENGINE_parse_body(@implode("\n", $html));
	
}

function Save(){
	$sock=new sockets();
	$tpl=new template_admin();
	$tpl->CLEAN_POST();
	
	$_POST["zipproxy_MaxSize"]=$_POST["zipproxy_MaxSize"]*1024;
	
	foreach ($_POST as $key=>$value){
		$sock->SET_INFO($key, $value);
	}
	
}

function graph1(){

	$cacheFile="/usr/share/artica-postfix/ressources/logs/web/InfluxDB.state";
	$tpl=new templates();
	$ARRAY=unserialize(@file_get_contents($cacheFile));
	$ARRAY["PART"]=$ARRAY["PART"]/1024;

	$PART=intval($ARRAY["PART"])-intval($ARRAY["SIZEKB"]);

	$MAIN["Partition " .FormatBytes($ARRAY["PART"])]=$PART;
	$MAIN["DB ".FormatBytes($ARRAY["SIZEKB"])]=$ARRAY["SIZEKB"];

	$PieData=$MAIN;
	$highcharts=new highcharts();
	$highcharts->container="influx-db-size";
	$highcharts->PieDatas=$PieData;
	$highcharts->ChartType="pie";
	$highcharts->PiePlotTitle="{database_size}";
	$highcharts->Title=$tpl->_ENGINE_parse_body("{database_size} ".FormatBytes($ARRAY["SIZEKB"]));
	echo $highcharts->BuildChart();
}
