<?php
if(!isset($GLOBALS["BASE_ROOT"])){$GLOBALS["BASE_ROOT"]="/usr/share/artica-postfix";}
include_once(dirname(__FILE__)."/class.squid.watchdog.inc");
function squid_increment_func($array){
	
	$array[]="adker_watchdog";
	$array[]="squid_nat";
	$array[]="squid_db";
	$array[]="squid_master_status";
	$array[]="squid_cache_tail";
	$array[]="cntlm";
	$array[]="cntlm_parent";
	$array[]="ufdbguardd_tail";
	$array[]="ufdbguardd";
	$array[]="ufdbguardd_client";
	$array[]="squidguardweb";
	$array[]="ufdbguard_http";
	$array[]="ufdbguard_http_light";
	$array[]="WSUS_HTTP";
	$array[]="ziproxy";
	$array[]="articadb";
	$array[]="kav4Proxy_keepup2date";
	$array[]="kav4Proxy_status";
	$array[]="articadb";
	$array[]="HyperCacheWeb";
	$array[]="HyperCacheServer";
	$array[]="iptables_transparent";
	$array[]="hypercache_logger";
	$array[]="wanproxy";
	$array[]="proxypac";
	$array[]="ntlm_monitor";
	$array[]="SQUID_TAIL_SIZE";
	$array[]="SQUID_TAIL_SIZE_HELPERS";
	$array[]="msktutil_watch";
	$array[]="RemoveServices";
    $array[]="itcharter";



	return $array;
}



function zipproxy_pid(){
	
	$masterbin=$GLOBALS["CLASS_UNIX"]->find_program("ziproxy");
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file('/var/run/squid/ziproxy.pid');
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
	return $GLOBALS["CLASS_UNIX"]->PIDOF($masterbin);
}

function LockActiveDirectoryToKerberos(){

    if(!is_file("/etc/squid3/PROXY.keytab")){
        squid_admin_mysql(0,"Active Directory: Fatal missing /etc/squid3/PROXY.keytab [action=reconnect]",null,__FILE__,__LINE__);
        shell_exec2("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.msktutils.php --run >/dev/null 2>&1");

    }

    if(!is_file("/etc/cron.d/squid-negotiateauthenticator-5mn")) {
        $GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("squid-negotiateauthenticator-5mn", "*/5 * * * *", "exec.negotiateauthenticator.php");
        system("/etc/init.d/cron reload");
    }


}

function adker_watchdog(){
	if(is_file("/etc/cron.d/artica-ads-watchdog")){
		@unlink("/etc/cron.d/artica-ads-watchdog");
		shell_exec("/etc/init.d/cron reload");
	}

    $LockActiveDirectoryToKerberos= intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LockActiveDirectoryToKerberos"));
	if($LockActiveDirectoryToKerberos==1){
        LockActiveDirectoryToKerberos();
    }





}
function ___squid_ldap_auth_path(){
	if(is_file('/lib/squid3/basic_ldap_auth')){return '/lib/squid3/basic_ldap_auth';}
	if(is_file('/usr/lib/squid3/squid_ldap_auth')){return '/usr/lib/squid3/squid_ldap_auth';}
	if(is_file('/usr/lib64/squid3/squid_ldap_auth')){return '/usr/lib64/squid3/squid_ldap_auth';}
	if(is_file('/lib/squid3/squid_ldap_auth')){return '/lib/squid3/squid_ldap_auth';}
	if(is_file('/lib64/squid3/squid_ldap_auth')){return '/lib64/squid3/squid_ldap_auth';}
	if(is_file('/usr/lib/squid/ldap_auth')){return '/usr/lib/squid/ldap_auth';}
	if(is_file('/usr/lib/squid/squid_ldap_auth')){return '/usr/lib/squid/squid_ldap_auth';}
	if(is_file('/usr/lib64/squid/squid_ldap_auth')){return '/usr/lib64/squid/squid_ldap_auth';}
	if(is_file('/usr/lib64/squid/ldap_auth')){return '/usr/lib64/squid/ldap_auth';}
	if(is_file('/usr/local/lib/squid/ldap_auth')){return '/usr/local/lib/squid/ldap_auth';}
	if(is_file('/usr/local/lib64/squid/ldap_auth')){return '/usr/local/lib64/squid/ldap_auth';}
	if(is_file('/opt/artica/libexec/squid_ldap_auth')){return '/opt/artica/libexec/squid_ldap_auth';}
}

function RemoveServices(){
	if(!is_file("/etc/artica-postfix/settings/Daemons/SQUIDEnable")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SQUIDEnable", 1);}
	$SQUIDEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable"));
	if($SQUIDEnable==1){return;}
	
	$servicesINIT[]="squid";
	$servicesINIT[]="squidguard-http";
	$servicesINIT[]="squid-nat";
	$servicesINIT[]="squid-tail";
	$servicesINIT[]="iptables-transparent";
	$servicesINIT[]="hypercache-web";
	$servicesINIT[]="wanproxy-parent";
	$servicesINIT[]="wanproxy-childs";
	$servicesINIT[]="zipproxy";
	$servicesINIT[]="ntlm-monitor";
	$servicesINIT[]="cache-scheduler";
	$servicesINIT[]="cache-httpd";
	$servicesINIT[]="ufdb-client";
	$servicesINIT[]="microhotspot";
	$servicesINIT[]="hotspot-web";
	$servicesINIT[]="SquidRouterMode";
	$servicesINIT[]="cache-tail";
	$servicesINIT[]="proxy-wccp";
	$servicesINIT[]="kav4proxy";
	$servicesINIT[]="privoxy";
	$servicesINIT[]="cntlm";
    $servicesINIT[]="itcharter";

	foreach ($servicesINIT as $filename) {
		if(!is_file("/etc/init.d/$filename")){continue;}
		squid_admin_mysql(0, "Removing service $filename ( Proxy is disabled )", "Remove /etc/init.d/$filename",__FILE__,__LINE__);
		remove_service("/etc/init.d/$filename");
	}
		
	
}
function itcharter_pid(){
    $pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/itcharter.pid");
    if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
    return $GLOBALS["CLASS_UNIX"]->PIDOF("/usr/sbin/itcharter");
}

function itcharter(){
    $SQUIDEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable"));
    $EnableITChart=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableITChart"));
    if($SQUIDEnable==0){$EnableITChart=0;}
    $PowerDNSEnableClusterSlave=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PowerDNSEnableClusterSlave"));

    if($PowerDNSEnableClusterSlave==1){
        if($EnableITChart==1){
            if(!is_file("/etc/init.d/itcharter")) {
                squid_admin_mysql("IT Charter: install service...", null, __FILE__, __LINE__);
                shell_exec2("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.itchart.php --install >/dev/null 2>&1 &");
            }
        }
    }


    $l[]="";
    $l[]="[APP_ITCHARTER]";
    $l[]="service_name=APP_ITCHARTER";
    $l[]="service_cmd=/etc/init.d/itcharter";
    $l[]="master_version=1.0";
    $l[]="service_disabled=$EnableITChart";
    $l[]="family=network";
    $l[]="watchdog_features=1";
    $l[]="installed=1";


    if($EnableITChart==0){
        if(is_file("/etc/init.d/itcharter")) {
            squid_admin_mysql("IT Charter: Uninstall service (Proxy is not enabled)", null, __FILE__, __LINE__);
            shell_exec2("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.itchart.php --uninstall >/dev/null 2>&1 &");
            $l[] = "running=0";
            return implode("\n", $l);
        }
        return @implode("\n",$l);
    }
    if($EnableITChart==1){
        if(!is_file("/etc/init.d/itcharter")) {
            squid_admin_mysql("IT Charter: install service...", null, __FILE__, __LINE__);
            shell_exec2("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.itchart.php --install >/dev/null 2>&1 &");
            $l[] = "running=0";
            return implode("\n", $l);
        }


    }
    $master_pid=itcharter_pid();

    if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
        if($GLOBALS["CLASS_UNIX"]->ServerRunSince()>3){
            if(!$GLOBALS["DISABLE_WATCHDOG"]){squid_admin_mysql(0, "IT Charter not running [action=start]", null,__FILE__,__LINE__);}
        }
        if(!$GLOBALS["DISABLE_WATCHDOG"]){
            $nohup=$GLOBALS["CLASS_UNIX"]->find_program("nohup");
            shell_exec2("$nohup {$GLOBALS["NICE"]} /etc/init.d/itcharter start >/dev/null 2>&1 &");

        }

        $l[]="running=0";
        return implode("\n",$l);
    }


    $l[]="running=1";
    $l[]=GetMemoriesOf($master_pid);
    $l[]="";
    return implode("\n",$l);


}

function SquidRouterMode(){
	$SquidInRouterMode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidInRouterMode"));
	if($SquidInRouterMode==0){return;}
	
	$EnableProxyCompressor=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableProxyCompressor"));
	$SquidCachesProxyEnabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidCachesProxyEnabled"));
	$EnableUfdbGuard=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableUfdbGuard"));
	$EnableUfdbSimplePage=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableUfdbSimplePage"));
	$EnablePersonalCategories=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnablePersonalCategories"));
	$CicapEnabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("CicapEnabled"));
	$EnableLocalUfdbCatService=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableLocalUfdbCatService"));
	$EnableSquidLogger=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableSquidLogger"));
	
	if($SquidCachesProxyEnabled==1){
		shell_exec2("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.squid.global.access.php --disable-cache");
	}
	if($EnableProxyCompressor==1){
		shell_exec2("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.zipproxy.php --uninstall >/dev/null 2>&1");
	}
	if($EnableUfdbGuard==1){
		shell_exec2("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.ufdb.disable.php >/dev/null 2>&1");
	}	
	if($EnableUfdbSimplePage==1){
		shell_exec2("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.ufdb-lighthttp.php --uninstall-web >/dev/null 2>&1");
	}	
	if($EnablePersonalCategories==1){
		shell_exec2("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.ufdb.enable.php --ppcategories-disable >/dev/null 2>&1");
	}
	if($CicapEnabled==1){
		shell_exec2("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.c-icap.install.php --uninstall >/dev/null 2>&1");
	}

	if($EnableLocalUfdbCatService==1){
		shell_exec2("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.ufdbcat.php --remove-progress >/dev/null 2>&1");
	}	
	if($EnableSquidLogger==1){
		shell_exec2("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.squid-logger.php --install >/dev/null 2>&1");
	}
	
	
}

function ziproxy(){
	
	$ZIPROXY_INSTALLED=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ZIPROXY_INSTALLED"));
	
	if($ZIPROXY_INSTALLED==0){return;}
	if(!is_file("/etc/init.d/zipproxy")){return;}
	$EnableProxyCompressor=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableProxyCompressor"));
	$l[]="";
	$l[]="[APP_ZIPROXY]";
	$l[]="service_name=APP_ZIPROXY";
	$l[]="service_cmd=/etc/init.d/zipproxy";
	$l[]="master_version=".trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ZIPROXY_VERSION"));
	$l[]="service_disabled=$EnableProxyCompressor";
	$l[]="family=network";
	$l[]="watchdog_features=1";
	$l[]="installed=1";
	
	$SQUIDEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable"));
	if($SQUIDEnable==0){
        if(is_file("/etc/init.d/zipproxy")) {
            shell_exec2("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.zipproxy.php --uninstall >/dev/null 2>&1 &");
        }
		$l[]="running=0";
		return implode("\n",$l);
	}
	
	if($EnableProxyCompressor==0){return implode("\n",$l);return;}	
	$master_pid=zipproxy_pid();
	
	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if($GLOBALS["CLASS_UNIX"]->ServerRunSince()>3){
			if(!$GLOBALS["DISABLE_WATCHDOG"]){squid_admin_mysql(0, "HTTP Proxy compressor nor running [action=start]", null,__FILE__,__LINE__);}
		}
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			$nohup=$GLOBALS["CLASS_UNIX"]->find_program("nohup");
			shell_exec2("$nohup {$GLOBALS["NICE"]} /etc/init.d/zipproxy start >/dev/null 2>&1 &");
		
		}
		
		$l[]="running=0";
		return implode("\n",$l);
	}
	
	
	$l[]="running=1";
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";
	return implode("\n",$l);
	
}

function wanproxy(){

	$WANPROXY_INSTALLED=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("WANPROXY_INSTALLED"));
	if($WANPROXY_INSTALLED==0){return;}
	$binpath='/usr/local/bin/wanproxy';
	$WanProxyEnabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("WanProxyEnabled"));
	
	if(!is_file("/etc/init.d/wanproxy")){return ;}

	$l[]="";
	$l[]="[APP_WANPROXY]";
	$l[]="service_name=APP_WANPROXY";
	$l[]="service_cmd=/etc/init.d/wanproxy";
	$l[]="master_version=1.0";
	$l[]="service_disabled=$WanProxyEnabled";
	$l[]="family=network";
	$l[]="watchdog_features=1";
	$l[]="installed=1";
	
	$SQUIDEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable"));
	if($SQUIDEnable==0){
		shell_exec2("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.wanproxy.php --uninstall >/dev/null 2>&1 &");
		$l[]="running=0";
		return implode("\n",$l);
	}
	
	$master_pid=wanproxy_pid();
	if($GLOBALS["VERBOSE"]){echo "Master PID................. $master_pid\n";}
	if($WanProxyEnabled==0){
		shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.wanproxy.php --remove 2>&1 &");
		return @implode("\n", $l);
	}
	
	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			$nohup=$GLOBALS["CLASS_UNIX"]->find_program("nohup");
			if(!is_file("/etc/init.d/wanproxy")){return;}
			if($GLOBALS["CLASS_UNIX"]->ServerRunSince()>3){squid_admin_mysql(0, "Fatal: Wan Proxy compressor (parent) is not running [action=start]", null,__FILE__,__LINE__);}
			shell_exec2("$nohup {$GLOBALS["NICE"]} /etc/init.d/wanproxy start >/dev/null 2>&1 &");
		}
		
		$l[]="running=0";
		$l[]="";
		if($GLOBALS["VERBOSE"]){echo "--------------- FAILED ---------------\n";}
		return implode("\n",$l);;
	}
	
	
	$l[]="running=1";
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";
	if($GLOBALS["VERBOSE"]){echo "--------------- OK ---------------\n";}
	return implode("\n",$l);;
	
	
}
function wanproxy_pid(){
	$daemonbin=$GLOBALS["CLASS_UNIX"]->find_program("wanproxy");
	return $GLOBALS["CLASS_UNIX"]->PIDOF($daemonbin);
	
}




function hypercache_logger(){
	if(is_file("/usr/share/artica-postfix/exec.init-tail-hypercache.php")){@unlink("/usr/share/artica-postfix/exec.init-tail-hypercache.php"); }
	if(is_file("/usr/share/artica-postfix/exec.hypercache-tail.php")){ @unlink("/usr/share/artica-postfix/exec.hypercache-tail.php"); }
}






function ufdbguard_test_init(){
	if(!is_file("/etc/init.d/ufdb")){return;}
	
	$f=explode("\n",@file_get_contents("/etc/init.d/ufdb"));
	foreach ($f as $line){
		if(preg_match("#\/exec\.ufdb\.php --start#", $line)){return;}
	}
	
	
	$cmd="{$GLOBALS["nohup"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.ufdb.enable.php >/dev/null 2>&1";
	squid_admin_mysql(0, "Corrupted ufdb init.d script [action=rebuild]", $cmd,__FILE__,__LINE__);
	shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.ufdb.enable.php >/dev/null 2>&1");
	
	
}

function ufdbguard_http_light_pid(){

	
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/UfdbWebf.pid");
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){
		return $pid;
	}

	return $GLOBALS["CLASS_UNIX"]->PIDOF("/usr/sbin/ufdbweb");

}

function ufdbguard_http_light(){}

function ufdbguard_http(){
	
	
	$ARTICA_VERSION=@file_get_contents("/usr/share/artica-postfix/VERSION");
	$EnableSquidGuardHTTPService=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableSquidGuardHTTPService"));
	
	if(!is_file("/etc/init.d/ufdb-http")){
		if($EnableSquidGuardHTTPService==0){return null;}
		shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.ufdb-http.php --install-web >/dev/null 2>&1 &");
		squid_admin_mysql(0, "Install the Web-Filtering Web service ( enabled but was not installed)", null,__FILE__,__LINE__);
		return null;
		
	}
	$l[]="";
	$l[]="[APP_UFDB_HTTP]";
	$l[]="service_name=APP_UFDB_HTTP";
	$l[]="master_version=$ARTICA_VERSION";
	$l[]="service_cmd=/etc/init.d/ufdb-http";
	$l[]="service_disabled=$EnableSquidGuardHTTPService";
	$l[]="family=squid";
	$l[]="watchdog_features=1";
	$l[]="installed=1";
	
	if($EnableSquidGuardHTTPService==0){return implode("\n",$l);}
	$master_pid=ufdbguard_http_pid();
	$l[]="pid_path=/var/run/webfilter-http.pid";
	
	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/ufdb-http start >/dev/null 2>&1 &");
		}
		$l[]="";return implode("\n",$l);return;
	}
	
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";
	
	return implode("\n",$l);
}
function ufdbguard_http_pid(){
	$unix=new unix();
	$pid=$unix->get_pid_from_file("/var/run/webfilter-http.pid");
	if($unix->process_exists($pid)){
		return $pid;
	}
	return $unix->PIDOF_PATTERN("/usr/share/artica-postfix/webfilter-http.py");

}


function squidguardweb(){
	if(!is_file("/etc/init.d/squidguard-http")){return null;}
	squid_admin_mysql(0, "Web error page service will be upgraded to 3.x generation", null,__FILE__,__LINE__);
	shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.ufdb-http.php --install-web >/dev/null 2>&1");
}



function iptables_transparent(){
	$SQUIDEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable"));
	if($SQUIDEnable==0){return;}
	if(!$GLOBALS["CLASS_UNIX"]->SQUID_INSTALLED()){
		$l[]="";
		$l[]="[APP_TRANSPARENT_ROUTING]";
		$l[]="service_name=APP_TRANSPARENT_ROUTING";
		$l[]="installed=0";
		$l[]="service_disabled=0";
		$l[]="";
		return @implode("\n", $l);
	}
	
	if(!is_file("/etc/artica-postfix/MYSQL_AS_PROXY_TRANSPARENT")){
		return;
	}
	
	$l[]="\n[APP_TRANSPARENT_ROUTING]";
	$l[]="service_name=APP_TRANSPARENT_ROUTING";
	$ports=intval(@file_get_contents("/etc/artica-postfix/MYSQL_AS_PROXY_TRANSPARENT"));
	if($ports==0){
		$l[]="installed=1";
		$l[]="service_disabled=0";
		$l[]="";
		return @implode("\n", $l);
	}

	$l[]="installed=1";
	$l[]="service_disabled=1";
	$l[]="master_version=".iptables_version();
	$l[]="service_cmd=/etc/init.d/iptables-transparent";
	
	
	
	$iptables_save=$GLOBALS["CLASS_UNIX"]->find_program("iptables-save");
	exec("$iptables_save 2>&1",$results);
	$OK1=false;
	while (list ($pid, $ligne) = each ($results) ){
		if(preg_match("#-A PREROUTING.*?-p tcp -m tcp --dport [0-9]+#", $ligne)){
			$OK1=true;
			break;
	
		}
	
		if(preg_match("#PREROUTING .*?--dport\s+[0-9]+.*?REDIRECT\s+--to-ports\s+[0-9]+#",$ligne)){
			$OK1=true;
			break;
			
		}
	
		if(preg_match("#-A PREROUTING -p tcp -m tcp --dport [0-9]+ -m comment.*?--to-ports\s+[0-9]+#", $ligne)){
			$OK1=true;
			break;
			
		}
	
		if(preg_match("#-A\s+out_trproxy\.[0-9]+.*?-p tcp -j REDIRECT\s+--to-ports\s+[0-9]+#",$ligne)){
			$OK1=true;
			break;
			
		}
	
	}
	
	
	
	if(!$OK1){
		squid_admin_mysql(1, "Transparent method inactive [action=notify]", @implode("\n", $results),__FILE__,__LINE__);
		$depmod=$GLOBALS["CLASS_UNIX"]->find_program("depmod");
		shell_exec("$depmod -a");
		
		$l[]="running=0\ninstalled=1";
		$l[]="";
		return implode("\n",$l);
	}
		
	$l[]="installed=1";
	$l[]="running=1";
	$l[]="master_pid=0";
	$l[]="master_time=0";
	$l[]="master_memory=0";
	$l[]="processes_number=1";
	$l[]="uptime=none";
	$l[]="";
	return @implode("\n", $l);
	
}


//========================================================================================================================================================





function ufdbguardd_client_pids(){
	$unix=new unix();
	$pgrep=$GLOBALS["CLASS_UNIX"]->find_program("pgrep");
	$Masterbin=$GLOBALS["CLASS_UNIX"]->find_program("ufdbgclient");
	if(!is_file($Masterbin)){return;}
	$pids=array();

	exec("$pgrep -l -f ufdbgclient",$f);
	foreach ($f as $index=>$line){
		if(preg_match("#pgrep#", $line)){continue;}
		if(!preg_match("#^([0-9]+)\s+#", $line,$re)){continue;}
		$pid=$re[1];
		if($GLOBALS["VERBOSE"]){echo "-> ufdbguardd_client() -> PID:$pid\n";}
		if(is_numeric(trim($pid))){$pids[trim($pid)]=trim($pid);continue;}
		if(preg_match("#([0-9]+)#", $pid,$re)){$pids[$re[1]]=true;}
	}
	return $pids;
}

function HyperCacheServer_pid(){
	$filename="/var/run/hypercache-service.pid";
	$pid=trim(@file_get_contents($filename));
	$unix=new unix();
	if($unix->process_exists($pid)){return $pid;}
	return $unix->PIDOF("/usr/local/HyperCache/sbin/hypercache-service");
}

function HyperCacheServer_version(){
	if(isset($GLOBALS["HyperCacheServer_version"])){return $GLOBALS["HyperCacheServer_version"];}
	exec("/usr/local/HyperCache/sbin/hypercache-service -V 2>&1",$results);
	
	foreach ($results as $num=>$val){
		if(preg_match("#nginx version: nginx\/([0-9\.]+)#", $val,$re)){
			$GLOBALS["HyperCacheServer_version"]=$re[1];
			return $GLOBALS["squid_master_status_version"];
		}
	}
}
function HyperCacheTail_pid(){
	
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/hypercache-tail.pid");
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
	$pid=$GLOBALS["CLASS_UNIX"]->PIDOF_PATTERN("hypercache-tail.py");
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
	$pid=$GLOBALS["CLASS_UNIX"]->PIDOF("/usr/share/artica-postfix/hypercache-tail.py");
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}

}

function HyperCacheServer(){
	
	if(!is_file("/usr/local/HyperCache/sbin/hypercache-service")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("HyperCacheServiceInstalled", 0);
		return;
	}
	
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableHyperCacheProxy")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableHyperCacheProxy", 0);
	}
	
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("HyperCacheServiceInstalled", 1);
	$EnableHyperCacheProxy=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableHyperCacheProxy"));
	if(!is_file("/etc/artica-postfix/settings/Daemons/SquidCacheLevel")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SquidCacheLevel", 2);}
	$SquidCacheLevel=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidCacheLevel"));
	$SquidDisableCaching=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidDisableCaching"));
	if($SquidDisableCaching==1){return;}
	if($SquidCacheLevel==0){
		if($EnableHyperCacheProxy==1){
			if(!$GLOBALS["DISABLE_WATCHDOG"]){
				shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.hypercache-service.install.php --uninstall >/dev/null 2>&1 &");
				return;
			}
		}
	}
	
	$l[]="";
	$l[]="\n[APP_HYPERCACHE_PROXY]";
	$l[]="service_name=APP_HYPERCACHE_PROXY";
	$l[]="master_version=".HyperCacheServer_version();
	$l[]="service_cmd=/etc/init.d/hypercache-service";
	$l[]="service_disabled=$EnableHyperCacheProxy";
	$l[]="watchdog_features=1";
	$l[]="pid_path=";
	
	$unix=new unix();
	
	if($EnableHyperCacheProxy==0){return @implode("\n", $l);}
	$master_pid=HyperCacheServer_pid();
	
	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			if($GLOBALS["CLASS_UNIX"]->ServerRunSince()>3){squid_admin_mysql(0, "HyperCache Proxy service is not running [action=start]", null,__FILE__,__LINE__);}
			shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/hypercache-service restart >/dev/null 2>&1 &");
		}
	
		$l[]="running=0\ninstalled=1";
		$l[]="";
		$l[]=HyperCacheTail();
		return implode("\n",$l);
	}
	$l[]="running=1";
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";
	
	
	if(!$GLOBALS["CLASS_UNIX"]->IsProductionTime()){
		$CacheSchedules=$GLOBALS["CLASS_UNIX"]->file_time_min("/etc/artica-postfix/pids/exec.hypercache-server.php.scandisk.time");
		if($CacheSchedules>240){
			shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.hypercache-server.php --scandisk >/dev/null 2>&1 &");
		}
	}
	
	return implode("\n",$l)."\n".HyperCacheTail()."\n";
	
}
function HyperCacheTail(){

	$SquidCacheLevel=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidCacheLevel"));
	$SquidDisableCaching=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidDisableCaching"));
	if($SquidDisableCaching==1){return;}
	if(!is_numeric($SquidCacheLevel)){$SquidCacheLevel=3;}
	if($SquidCacheLevel==0){return;}
	$l[]="";
	$l[]="\n[APP_HYPERCACHE_TAIL]";
	$l[]="service_name=APP_HYPERCACHE_TAIL";
	$l[]="master_version=".HyperCacheServer_version();
	$l[]="service_cmd=/etc/init.d/hypercache-tail";
	$l[]="service_disabled=1";
	$l[]="watchdog_features=1";
	$l[]="pid_path=";

	$unix=new unix();
	$master_pid=HyperCacheTail_pid();
	
	if(!is_file("/etc/init.d/hypercache-tail")){
		system("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.hypercache-service.install.php --tailer");
	}

	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/hypercache-tail start >/dev/null 2>&1 &");
		}

		$l[]="running=0\ninstalled=1";
		$l[]="";
		return implode("\n",$l);
	}
	$l[]="running=1";
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";

	$oldsize=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HyperCacheTailfsize"));
	$currentsize=@filesize("/var/log/hypercache-service/access.log");
	if($oldsize>$currentsize){shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/hypercache-tail restart >/dev/null 2>&1 &");}
	if(!is_file("/etc/monit/conf.d/APP_HYPERCACHETAIL.monitrc")){HyperCacheMonit();}
	
	return implode("\n",$l);return;

}

function HyperCacheMonit(){
	
	$f=array();
	@unlink("/etc/monit/conf.d/APP_HYPERCACHETAIL.monitrc");
	$f=array();
	$f[]="check process APP_HYPERCACHETAIL with pidfile /var/run/hypercache-tail.pid";
	$f[]="\tstart program = \"/etc/init.d/hypercache-tail start --monit\"";
	$f[]="\tstop program = \"/etc/init.d/hypercache-tail stop --monit\"";
	$f[]="\tif 5 restarts within 10 cycles then timeout";
	$f[]="";
	@file_put_contents("/etc/monit/conf.d/APP_HYPERCACHETAIL.monitrc", @implode("\n", $f));
	shell_exec2("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload >/dev/null 2>&1");
	
}



function ufdbguardd_client(){
    $prefCmd="{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/";
	$SquidUrgency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidUrgency"));
	if($SquidUrgency==1){return;}

	$squidbin=$GLOBALS["CLASS_UNIX"]->LOCATE_SQUID_BIN();
	if(!is_file($squidbin)){
		$l[]="\n[APP_UFDBGUARD_CLIENT]";
		$l[]="service_name=APP_UFDBGUARD_CLIENT";
		$l[]="installed=0";
		$l[]="service_disabled=0";
		return implode("\n",$l);
		
	}

    $SQUIDEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable"));
    $SquidUrgency=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidUrgency");
    $EnableUfdbGuard=$GLOBALS["CLASS_SOCKETS"]->EnableUfdbGuard();
    $SquidUFDBUrgency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidUFDBUrgency"));
    $UfdbGuardDisabledTemp=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UfdbGuardDisabledTemp"));
    $ufdbguardd_version=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UFDBDaemonVersion"));
    if($SquidUrgency==1){$EnableUfdbGuard=0;}
    if(!is_numeric($SQUIDEnable)){$SQUIDEnable=1;}
    if($SQUIDEnable==0){$EnableUfdbGuard=0;}
    if($SquidUFDBUrgency==1){$EnableUfdbGuard=0;}
    if($UfdbGuardDisabledTemp==1){$EnableUfdbGuard=0;}

    if($EnableUfdbGuard==1) {
        if (!is_file("/etc/init.d/ufdb-client")) {
            shell_exec("$prefCmd/exec.ufdb.enable.php --ufdb-client");
        }
    }



    if(!is_file("/etc/init.d/ufdb-client")){return null;}
	$ufdbguardd_path=$GLOBALS["CLASS_UNIX"]->find_program("ufdbgclient");
	$pidof=$GLOBALS["CLASS_UNIX"]->find_program("pidof");
	
	if(!is_file($ufdbguardd_path)){
		$l[]="\n[APP_UFDBGUARD_CLIENT]";
		$l[]="service_name=APP_UFDBGUARD_CLIENT";
		$l[]="installed=0";
		$l[]="service_disabled=0";
		return implode("\n",$l);
	}


	
	$l[]="";
	$l[]="\n[APP_UFDBGUARD_CLIENT]";
	$l[]="service_name=APP_UFDBGUARD_CLIENT";
	$l[]="master_version=$ufdbguardd_version";
	$l[]="service_cmd=/etc/init.d/ufdb-client";
	$l[]="service_disabled=$EnableUfdbGuard";
	$l[]="watchdog_features=1";
	$l[]="pid_path=";

	if($EnableUfdbGuard==0){return @implode("\n", $l);}

	$pgrep=$GLOBALS["CLASS_UNIX"]->find_program("pgrep");

	if(!is_file($ufdbguardd_path)){
		if($GLOBALS["VERBOSE"]){echo "ufdbguard path none!\n";}
		return null;
	}



	$pids=ufdbguardd_client_pids();

	$count=count($pids);
	events("ufdbguard clients = $count",__FUNCTION__,__LINE__);
	

	if($count==0){
		$l[]="running=0\ninstalled=1";
		$l[]="";

		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			$unix=new unix();
			$ServerRunSince=$GLOBALS["CLASS_UNIX"]->ServerRunSince();
			if($ServerRunSince>2){
				squid_admin_mysql(0, "Web filtering clients are not running [action=start]", null,__FILE__,__LINE__);
				events("/etc/init.d/ufdb-client start",__FUNCTION__,__LINE__);
				shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/ufdb-client start --monitor --force >/dev/null 2>&1 &");
			}
		}

		return implode("\n",$l);
	}


	$rss=0;
	$vm=0;
	if($GLOBALS["VERBOSE"]){echo "-> ufdbguardd_client() -> PIDs:$count\n";}

	foreach ($pids as $num=>$pid){
		if(!is_numeric($pid)){continue;}
		$newrss=$GLOBALS["CLASS_UNIX"]->PROCESS_MEMORY($pid,true);
		if($GLOBALS["VERBOSE"]){echo "-> ufdbguardd_client() -> PID:$num-$pid RSS: $newrss\n";}
		$rss=$rss+$newrss;
		$vm=$vm+$GLOBALS["CLASS_UNIX"]->PROCESS_CACHE_MEMORY($pid,true);
		$uptime=$GLOBALS["CLASS_UNIX"]->PROCESS_UPTIME($pid);
		$master_pid=$pid;
	}
	$l[]="master_pid=$master_pid";
	$l[]="running=1";
	$l[]="master_memory=$rss";
	$l[]="master_cached_memory=$vm";
	$l[]="processes_number=$count";
	$l[]=$uptime;
	$l[]="";
	if($GLOBALS["VERBOSE"]){echo "Return ".count($l)." Lines\n";}
	return implode("\n",$l);


}
function WSUS_HTTP_PID(){
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/wsus-http/http-server.pid");
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){
		return $pid;
	}
	return $GLOBALS["CLASS_UNIX"]->PIDOF_PATTERN("/usr/share/artica-postfix/wsus-http.py");
}

function WSUS_HTTP(){
	$WindowsUpdateCaching=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("WindowsUpdateCaching"));
	
	if(!is_file("/etc/init.d/cache-httpd")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WindowsUpdateCaching", 0);
		return;
	}
	
	squid_admin_mysql(0, "Windows Update Caching will be disabled ( feature replaced by HyperCache Proxy Service)", "The HyperCache Proxy service is able to cache more updates sites than the Windows Updates Feature..");
	shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.squid.windowsupdate.enable.php --disable >/dev/null 2>&1 &");
	
	
	
}
function WSUS_SCHEDULER_PID(){
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/wsus-http/scheduler.pid");
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){
		return $pid;
	}
	return $GLOBALS["CLASS_UNIX"]->PIDOF_PATTERN("/usr/share/artica-postfix/wsus-scheduler.py");
}



function SQUID_TAIL_SIZE_PID(){
	
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/squid-size-tail.pid");
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
	return $GLOBALS["CLASS_UNIX"]->PIDOF_PATTERN("/squid-size-tail.py");
	
}

function SQUID_TAIL_SIZE(){
	$EnableQuotaSize=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableQuotaSize"));
	if(!is_file("/etc/init.d/squid-tail-size")){return;}
	$l[]="";
	$l[]="[SQUID_TAIL_SIZE]";
	$l[]="service_name=SQUID_TAIL_SIZE";
	$l[]="master_version=".@file_get_contents("/usr/share/artica-postfix/VERSION");
	$l[]="service_cmd=/etc/init.d/squid-tail-size";
	$l[]="service_disabled=$EnableQuotaSize";
	$l[]="watchdog_features=1";
	$l[]="pid_path=/var/run/squid-size-tail.pid";
	$l[]="installed=1";
	if($EnableQuotaSize==0){return @implode("\n", $l)."\n";}
	
	
	$master_pid=SQUID_TAIL_SIZE_PID();
	
	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			squid_admin_mysql(1, "Size Quotas checker service is stopped [action=start]",null,__FUNCTION__,__FILE__,__LINE__);
			shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/squid-tail-size start >/dev/null 2>&1 &");
		}
	
		$l[]="running=0";
		return @implode("\n", $l)."\n";
	}
	
	$l[]="running=1";
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";
	return @implode("\n", $l)."\n";
}

function SQUID_TAIL_SIZE_HELPERS_PIDS(){
	$unix=new unix();
	$pgrep=$GLOBALS["CLASS_UNIX"]->find_program("pgrep");
	$pids=array();

	exec("$pgrep -l -f squid-size-helper.py",$f);
	foreach ($f as $index=>$line){
		if(preg_match("#pgrep#", $line)){continue;}
		if(!preg_match("#^([0-9]+)\s+#", $line,$re)){continue;}
		$pid=$re[1];
		if(is_numeric(trim($pid))){$pids[trim($pid)]=trim($pid);continue;}
		if(preg_match("#([0-9]+)#", $pid,$re)){$pids[$re[1]]=true;}
	}
	return $pids;
}

function SQUID_TAIL_SIZE_HELPERS(){ 
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableQuotaSize")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableQuotaSize", 0);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/SizeQuotasCheckerEmergency")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SizeQuotasCheckerEmergency", 0);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/SquidDisableAllFilters")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SquidDisableAllFilters", 0);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/SquidUrgency")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SquidUrgency", 0);}
	
	
	$EnableQuotaSize=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableQuotaSize"));
	$SizeQuotasCheckerEmergency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SizeQuotasCheckerEmergency"));
	$SquidUrgency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidUrgency"));
	$SquidDisableAllFilters=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidDisableAllFilters"));
	if($SizeQuotasCheckerEmergency==1){$EnableQuotaSize=0;}
	if($SquidUrgency==1){$EnableQuotaSize=0;}
	if($SquidDisableAllFilters==1){$EnableQuotaSize=0;}
	
	if(!is_file("/etc/init.d/squid-tail-size")){return;}
	
	
	$l[]="";
	$l[]="[SQUIDTAILSIZE_HELPERS]";
	$l[]="service_name=SQUIDTAILSIZE_HELPERS";
	$l[]="installed=1";
	
	if($EnableQuotaSize==0){
		$l[]="running=0";
		$l[]="service_disabled=0";
		return implode("\n",$l);
		
	}
	
	$pids=SQUID_TAIL_SIZE_HELPERS_PIDS();
	
	$count=count($pids);
	events("Clients = $count",__FUNCTION__,__LINE__);
	
	
	if($count==0){
		$l[]="running=0";
		$l[]="";
	
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			squid_admin_mysql(0, "Size Helpers clients are not running [action=notify]", null,__FILE__,__LINE__);
		}
	
		return implode("\n",$l);
	}
	
	
	$rss=0;
	$vm=0;
	if($GLOBALS["VERBOSE"]){echo "-> SQUID_TAIL_SIZE_HELPERS_PIDS() -> PIDs:$count\n";}
	foreach ($pids as $num=>$pid){
		if(!is_numeric($pid)){continue;}
		$newrss=$GLOBALS["CLASS_UNIX"]->PROCESS_MEMORY($pid,true);
		if($GLOBALS["VERBOSE"]){echo "-> SQUID_TAIL_SIZE_HELPERS_PIDS() -> PID:$num-$pid RSS: $newrss\n";}
		$rss=$rss+$newrss;
		$vm=$vm+$GLOBALS["CLASS_UNIX"]->PROCESS_CACHE_MEMORY($pid,true);
		$uptime=$GLOBALS["CLASS_UNIX"]->PROCESS_UPTIME($pid);
		$master_pid=$pid;
	}
	$l[]="master_pid=$master_pid";
	$l[]="running=1";
	$l[]="master_memory=$rss";
	$l[]="master_cached_memory=$vm";
	$l[]="processes_number=$count";
	$l[]=$uptime;
	$l[]="";
	if($GLOBALS["VERBOSE"]){echo "Return ".count($l)." Lines\n";}
	return implode("\n",$l);return;
	
	
	
}


function ufdbguardd(){
	
	$ufdbguardd_path=$GLOBALS["CLASS_UNIX"]->find_program("ufdbguardd");
	if(is_file($ufdbguardd_path)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_UFDBGUARD_INSTALLED", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_UFDBGUARD_INSTALLED", 0);
		$l[]="";
		$l[]="[APP_UFDBGUARD]";
		$l[]="service_name=APP_UFDBGUARD";
		$l[]="installed=0";
		$l[]="service_disabled=0";
		return implode("\n",$l);
	}
	
	$ufdbgclient_path=$GLOBALS["CLASS_UNIX"]->find_program("ufdbgclient");
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ufdbgclient_path", $ufdbgclient_path);
	if(!is_file("/etc/init.d/ufdb")){return;}
	
	$SquidUrgency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidUrgency"));
	if($SquidUrgency==1){return;}
	$ServerRunSince=$GLOBALS["CLASS_UNIX"]->ServerRunSince();
	$pid_path="/var/tmp/ufdbguardd.pid";
	if(!is_dir("/var/tmp")){@mkdir("/var/tmp",0775,true);}
	

	$master_pid=ufdbguard_pid();
	$EnableUfdbGuard=$GLOBALS["CLASS_SOCKETS"]->EnableUfdbGuard();
	$UseRemoteUfdbguardService=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UseRemoteUfdbguardService"));
	if($UseRemoteUfdbguardService==1){$EnableUfdbGuard=0;}
	
	if($EnableUfdbGuard==1){ ufdbguard_test_init(); }
	
	if($EnableUfdbGuard==0){
		if(is_file("/etc/init.d/ufdb")){
			squid_admin_mysql(0, "Removing Web-Filtering startup script (feature disabled)", null,__FILE__,__LINE__);
			remove_service("/etc/init.d/ufdb");
            return implode("\n",$l);
		}
	}
	
	if(!is_file("/etc/artica-postfix/settings/Daemons/WebFilteringRansomware")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WebFilteringRansomware", 1);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableGoogleSafeSearch")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableGoogleSafeSearch", 1);}
	

	$WindowsUpdateCaching=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("WindowsUpdateCaching"));
	$WebFilteringRansomware=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("WebFilteringRansomware"));
	
	
	if($ServerRunSince>5){
		if(is_file("/home/ufdb/smtp-events/ACCESS_LOG")){
			if($GLOBALS["CLASS_UNIX"]->file_time_min("/home/ufdb/smtp-events/ACCESS_LOG.time")>5){
				shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.ufdb.smtp.release.php >/dev/null 2>&1 &");
				@unlink("/home/ufdb/smtp-events/ACCESS_LOG.time");
				@file_put_contents("/home/ufdb/smtp-events/ACCESS_LOG.time", time());
			}
			
		}
		
		if(is_file("/usr/local/bin/tldextract")){
			$pyhtonbin=$GLOBALS["CLASS_UNIX"]->find_program("python");
			if(!is_file("/usr/local/lib/python2.7/dist-packages/tldextract-2.0.1-py2.7.egg/tldextract/.tld_set")){
				@chmod("/usr/local/bin/tldextract",0755);
				shell_exec2("{$GLOBALS["nohup"]} /usr/local/bin/tldextract --update >/dev/null 2>&1 &");
				
			}else{
				if($GLOBALS["CLASS_UNIX"]->file_time_min("/usr/local/lib/python2.7/dist-packages/tldextract-2.0.1-py2.7.egg/tldextract/.tld_set")>2880){
					@chmod("/usr/local/bin/tldextract",0755);
					shell_exec2("{$GLOBALS["nohup"]} /usr/local/bin/tldextract --update >/dev/null 2>&1 &");
				}
			}
		}
	}
		
	
	
	$ufdbguardd_version=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UFDBDaemonVersion"));
	
	$l[]="";
	$l[]="[APP_UFDBGUARD]";
	$l[]="service_name=APP_UFDBGUARD";
	$l[]="master_version=$ufdbguardd_version";
	$l[]="service_cmd=/etc/init.d/ufdb";
	$l[]="service_disabled=$EnableUfdbGuard";
	$l[]="watchdog_features=1";
	$l[]="pid_path=$pid_path";
	
	if(!$GLOBALS["DISABLE_WATCHDOG"]){
		if($EnableUfdbGuard==0){
			if($GLOBALS["VERBOSE"]){echo "EnableUfdbGuard =  0 SHUTDOWN\n";}
			if($GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
				
				$LOGS=$GLOBALS["CLASS_SOCKETS"]->EnableUfdbGuard(true);
				if(function_exists("squid_admin_mysql")){squid_admin_mysql(1, "Stopping Ufdbguard service it is disabled\n".@implode("\n", $LOGS),__FUNCTION__,__FILE__,__LINE__,"ufdbguard-service");}
				
				$l[]="running=1";
				$l[]=GetMemoriesOf($master_pid);
				$l[]="";
				ToSyslog(basename(__FILE__)." Stopping Ufdbguard !!!! PID: $master_pid in line ".__LINE__);
				
				while (list ($num, $line) = each ($LOGS)){ToSyslog(basename(__FILE__)." Stopping Ufdbguard why: $line");}
				
				
				if(is_file("/proc/$master_pid/cmdline")){
					ToSyslog(basename(__FILE__)." $master_pid is `".trim(@file_get_contents("/proc/$master_pid/cmdline"))."`");
				}
				
					
				
				
				shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/ufdb stop >/dev/null 2>&1 &");
			}
			
			
			if(is_file("/etc/cron.d/ufdb-db-checkv")){
				@unlink("/etc/cron.d/ufdb-db-checkv");
				shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/cron reload >/dev/null 2>&1 &");
			}
			return implode("\n",$l);
			
		}
	}
	
	$TOTAL_MEMORY_MB=$GLOBALS["CLASS_UNIX"]->TOTAL_MEMORY_MB();
	
	
	if($TOTAL_MEMORY_MB>50){
		if($TOTAL_MEMORY_MB<2500){
			squid_admin_mysql(0, "Web-Filtering: FATAL Disable service Not enough memory {$TOTAL_MEMORY_MB}MB, Require at least 2500MB", null,__FILE__,__LINE__);
			shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.ufdb.disable.php --uninstall >/dev/null 2>&1 &");
            return implode("\n",$l);
		}
	}

    $CacheSchedules=$GLOBALS["CLASS_UNIX"]->file_time_min("/etc/artica-postfix/settings/Daemons/UfdbCatCountDatabases");

    if($CacheSchedules>10){
        $cmd=trim("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.ufdb.used.databases.php >/dev/null 2>&1 &");
        shell_exec2($cmd);
    }
	
	
	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		$master_pid=$GLOBALS["CLASS_UNIX"]->PIDOF($ufdbguardd_path);
		@file_put_contents($pid_path,$master_pid);
	}
	
	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			
			if(function_exists("WriteToSyslogMail")){WriteToSyslogMail("UfdGuard master Daemon service is not running -> start it...", basename(__FILE__));}
			$timestamp="/etc/artica-postfix/pids/ufdbguardd.status.notif";
			
			if($GLOBALS["CLASS_UNIX"]->file_time_min($timestamp)>10){
				@unlink($timestamp);
				@file_put_contents($timestamp, time());
				$ps=$GLOBALS["CLASS_UNIX"]->find_program("ps");
				$grep=$GLOBALS["CLASS_UNIX"]->find_program("grep");
				exec("$ps aux|$grep ufdbguardd 2>&1",$ps_aux);
				squid_admin_mysql(1, "UfdGuard master Daemon service is not running -> start it...",__FUNCTION__,__FILE__,__LINE__,"ufdbguard-service");
				squid_admin_mysql(1, "Web filtering Engine is down [action=start]",@implode("\n", $ps_aux),__FUNCTION__,__FILE__,__LINE__);
			}
			
	
			shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/ufdb start >/dev/null 2>&1 &");
		}
		$l[]="running=0\ninstalled=1";$l[]="";return implode("\n",$l);
        return implode("\n",$l);
	}	

	if(!$GLOBALS["DISABLE_WATCHDOG"]){
		if(!is_file("/etc/artica-postfix/ufdbfirst")){
			squid_admin_mysql(2, "Launching first updates of Web Filering databases","",__FILE__,__LINE__);
			squid_admin_mysql(1, "Launching first updates of Web Filering databases",__FUNCTION__,__FILE__,__LINE__,"ufdbguard-service");
			@file_put_contents("/etc/artica-postfix/ufdbfirst", time());
			squid_admin_mysql(1, "Launching first updates of Ufdbguard databases",__FUNCTION__,__FILE__,__LINE__,"ufbd-artica");
			shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.squid.blacklists.php --ufdb-first >/dev/null 2>&1 &");
			
		}
		
		if(is_file("/var/log/squid/UFDB_SOCKET_ERROR")){
			@unlink("/var/log/squid/UFDB_SOCKET_ERROR");
			squid_admin_mysql(1, "Sockets error encountered, restart Web filtering service",__FUNCTION__,__FILE__,__LINE__,"ufdbguard-service");
			squid_admin_mysql(0, "Sockets error encountered, restart Web filtering service",
			"/var/log/squid/UFDB_SOCKET_ERROR exists, see previous errors",__FILE__,__LINE__);
			shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/ufdb restart --force --watchdog >/dev/null 2>&1 &");
		}

		if(!is_dir("/var/log/ufdbguard")){@mkdir("/var/log/ufdbguard",0755,true);}
		if(!is_file("/var/tmp/ufdbguardd.pid")){@file_put_contents("/var/tmp/ufdbguardd.pid", $master_pid);}

		$MaxThreads=140;
		$CurrentThreads=$GLOBALS["CLASS_UNIX"]->PROCESS_SOCKETS_NUM($master_pid);
		if($CurrentThreads>=$MaxThreads){
			squid_admin_mysql(1, "Web filtering, Max threads limit reached - $CurrentThreads - restarting",__FUNCTION__,__FILE__,__LINE__,"ufdbguard-service");
			squid_admin_mysql(0, "Web filtering, Max threads limit reached - $CurrentThreads - restarting", "The Web filtering service threads are freeze, the dameon will be restarted",__FILE__,__LINE__);
			shell_exec("{$GLOBALS["nohup"]} /etc/init.d/ufdb restart --watchdog >/dev/null 2>&1 &");
		}
	
		if($GLOBALS["CLASS_UNIX"]->file_time_min("/etc/artica-postfix/pids/exec.ufdb.queue.release.php.time")>5){
			shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.ufdb.queue.release.php --check >/dev/null 2>&1 &");
		}
	
		if($GLOBALS["CLASS_UNIX"]->file_time_min("/etc/artica-postfix/pids/exec.squidguard.smtp.php.ufdb_all_smtp.time")>15){
			shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.squidguard.smtp.php --smtp >/dev/null 2>&1 &");
		}
		

		
		if($ServerRunSince>5){
		if($WebFilteringRansomware==1){
			$WebFilteringRansomwareSchedule=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("WebFilteringRansomwareSchedule"));
			if($WebFilteringRansomwareSchedule==0){$WebFilteringRansomwareSchedule=180;}
			$time=$GLOBALS["CLASS_UNIX"]->file_time_min("/etc/artica-postfix/pids/exec.abuse-ch.time");
			if($time>$WebFilteringRansomwareSchedule){
				shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.abuse-ch.php  >/dev/null 2>&1 &");
			}
		}}
		
		if($ServerRunSince>5){
		if($WindowsUpdateCaching==1){
			$WindowsUpdateCachingDir=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("WindowsUpdateCachingDir");
					
			$time=$GLOBALS["CLASS_UNIX"]->file_time_min("/usr/share/artica-postfix/ressources/logs/web/WindowsUpdate.state");
			if($time>120){
				Windows_update_events("INFO: Calculating partitions",__LINE__);
				shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.windowsupdate-partials.php --partition  >/dev/null 2>&1 &");
			}
			
		}}
		
		
	}
	
	$l[]="running=1";
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";
    if($GLOBALS["VERBOSE"]){echo "---------- FINISH ".__FUNCTION__." ---------- \n";}
    if($GLOBALS["VERBOSE"]){print_r($l);}
	$results=implode("\n",$l);
    if($GLOBALS["VERBOSE"]){echo $results;}
    return $results;

}

function Windows_update_events($text,$line=0){
	$date=@date("H:i:s");
	if(!isset($GLOBALS["MYPID"])){$GLOBALS["MYPID"]=getmypid();}
	$logFile="/var/log/squid/windowsupdate.debug";
	$size=@filesize($logFile);
	if($size>9000000){@unlink($logFile);@touch($logFile);@chown($logFile,"squid");@chgrp($logFile, "squid"); }
	$line="$date:[Scheduler/$line]:[{$GLOBALS["MYPID"]}]: $text";
	if($GLOBALS["VERBOSE"]){echo "$line\n";}
	$f = @fopen($logFile, 'a');
	@fwrite($f, "$line\n");
	@fclose($f);


}

//========================================================================================================================================================
function ufdbguardd_tail_pid(){
	if(is_file("/etc/artica-postfix/exec.ufdbguard-tail.php.pid")){
		$pid=trim(@file_get_contents("/etc/artica-postfix/exec.ufdbguard-tail.php.pid"));
		if($GLOBALS["VERBOSE"]){echo "/etc/artica-postfix/exec.ufdbguard-tail.php.pid = $pid\n";}
		if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
	}
	return $GLOBALS["CLASS_UNIX"]->PIDOF_PATTERN("exec.ufdbguard-tail.php");

}

function msktutil_watch(){
	
	if(intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MSKTUTIL_INSTALLED"))==0){return;}
	$msktutil=$GLOBALS["CLASS_UNIX"]->find_program("msktutil");
	if($msktutil==null){return;}
	$pids=$GLOBALS["CLASS_UNIX"]->PIDOF_PATTERN_ALL($msktutil);
	
	while (list ($pid, $a) = each ($pids) ){
		$processtime=$GLOBALS["CLASS_UNIX"]->PROCCESS_TIME_MIN($pid);
		if($processtime>5){
			squid_admin_mysql(0, "Killed $msktutil, running more than 5mn ({$processtime}Mn)", null,__FUNCTION__,__FILE__,__LINE__);
			$GLOBALS["CLASS_UNIX"]->KILL_PROCESS($pid);}
	}
}
function StoreID_enabled(){
	$SQUIDEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable"));
	if($SQUIDEnable==0){return 0;}
	$SquidCacheLevel=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidCacheLevel"));
	if($SquidCacheLevel==0){return 0;}
	$EnableIntelCeleron=intval(@file_get_contents("/etc/artica-postfix/settings/Daemons/EnableIntelCeleron"));
	if($EnableIntelCeleron==1){return 0;}
	$SquidUrgency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidUrgency"));
	if($SquidUrgency==1){return 0;}
	$StoreIDUrgency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("StoreIDUrgency"));
	if($StoreIDUrgency==1){return 0;}
	return intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HyperCacheStoreID"));
}



function ufdbguardd_tail(){
	if(!is_file("/usr/share/artica-postfix/exec.ufdbguard-tail.php")){return;}

	if(!$GLOBALS["CLASS_USERS"]->APP_UFDBGUARD_INSTALLED){return;}
	$master_pid=ufdbguardd_tail_pid();
    events("Master PID: $master_pid",__FUNCTION__,__LINE__);
	$EnableUfdbGuard=$GLOBALS["CLASS_SOCKETS"]->EnableUfdbGuard();
	$UseRemoteUfdbguardService=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UseRemoteUfdbguardService"));
	if($UseRemoteUfdbguardService==1){$EnableUfdbGuard=0;}

	if(!is_dir("/home/ufdb/relatime-events")){
		@mkdir("/home/ufdb/relatime-events",0755,true);
	}
	shell_exec("{$GLOBALS["CHOWN"]} -R squid:squid /home/ufdb/relatime-events");

    $pgrep=$GLOBALS["CLASS_UNIX"]->find_program("pgrep");
    exec("$pgrep -l -f \"tail.*?0\s+.*?ufdbguardd.log\" 2>&1",$results);
    $PPIDs=array();
    foreach ($results as $line){
        if(preg_match("#pgrep#",$line)){continue;}
        if(!preg_match("#^([0-9]+)\s+#",$line,$re)){continue;}
        events("Found tail instance pid {$re[1]}",__FUNCTION__,__LINE__);
        $PPIDs[$re[1]]=$line;
    }
    $LOG=array();
    if(count($PPIDs)>2){
        $LOG[]="function: ".__FUNCTION__;
        $LOG[]="class: ".__CLASS__;
        $LOG[]="Source:".__FILE__;
        $LOG[]="---------------------";
        foreach ($PPIDs as $pid=>$none){
            $LOG[]="Pid: $pid cmdline=".@file_get_contents("/proc/$pid/cmdline")." ($none)";
            $GLOBALS["CLASS_UNIX"]->KILL_PROCESS($pid,9);
        }

        squid_admin_mysql(0,"Too many WebFiltering tail instances (".count($PPIDs).") running action=[kill them]",@implode("\n",$LOG),__FILE__,__LINE__);
        $master_pid=ufdbguardd_tail_pid();
    }



	$l[]="";
	$l[]="[APP_UFDBGUARD_TAIL]";
	$l[]="service_name=APP_UFDBGUARD_TAIL";
	$l[]="master_version=".trim(@file_get_contents("/usr/share/artica-postfix/VERSION"));
	$l[]="service_cmd=/etc/init.d/ufdb-tail";
	$l[]="service_disabled=$EnableUfdbGuard";
	$l[]="watchdog_features=1";
	

	if($EnableUfdbGuard==1){
		
		if(!is_file("/etc/init.d/ufdb-tail")){
			squid_admin_mysql(0, "{APP_UFDBGUARD_TAIL} Not Installed [action=install]", "/etc/init.d/ufdb-tail no such file",__FILE__,__LINE__);
			shell_exec2("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.ufdb.enable.php --ufdb-tail");
		}
		
		$filetime=file_time_min("/var/log/artica-postfix/ufdbguard-tail.debug");
		events("ufdbguard-tail.debug {$filetime}Mn ",__FUNCTION__,__LINE__);
		if($filetime>5){
			@unlink("/var/log/artica-postfix/ufdbguard-tail.debug");
			ToSyslog("Ufdbguard:: ufdb-tail, /var/log/artica-postfix/ufdbguard-tail.debug = {$filetime}mn -> restart");
			shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/ufdb-tail restart >/dev/null 2>&1 &");
		}
	}

	if($EnableUfdbGuard==0){
		if($GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
			
			if(is_file("/etc/init.d/ufdb-tail")){
				squid_admin_mysql(0, "{APP_UFDBGUARD_TAIL} Installed [action=remove]", "/etc/init.d/ufdb-tail exists",__FILE__,__LINE__);
				shell_exec2("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.ufdb.enable.php --ufdb-tail-remove");
			}
			if(is_file("/etc/init.d/ufdb-tail")){shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/ufdb-tail stop >/dev/null 2>&1 &");}
			$l[]="installed=1";
			$l[]="running=1";
			$l[]=GetMemoriesOf($master_pid);
			$l[]="";
		}
		
		return implode("\n",$l);
		
	}

	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		ToSyslog("Ufdbguard:: ufdb-tail, Watchdog service is not running -> start it");
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/ufdb-tail start >/dev/null 2>&1 &");
		}
		$l[]="running=0\ninstalled=1";$l[]="";return implode("\n",$l);
		return @implode("\n",$l);
	}






	$l[]="installed=1";
	$l[]="running=1";
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";
    if($GLOBALS["VERBOSE"]){echo "----- FINISH ".__FUNCTION__."--------\n";}
	return implode("\n",$l);
}


//========================================================================================================================================================

function cntlm_pid(){
	$filename="/var/run/cntlm.pid";
	if(is_file($filename)){
		$pid=trim(@file_get_contents($filename));
		if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
	}
	$cntlm=$GLOBALS["CLASS_UNIX"]->find_program("cntlm");
	return $GLOBALS["CLASS_UNIX"]->PIDOF_PATTERN("$cntlm.*?cntlm\.pid");
}
function cntlm_parent_pid(){
	$filename="/var/run/cntlm-parent.pid";
	if(is_file($filename)){
		$pid=trim(@file_get_contents($filename));
		if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
	}
	
	
	$cntlm=$GLOBALS["CLASS_UNIX"]->find_program("cntlm");
	return $GLOBALS["CLASS_UNIX"]->PIDOF_PATTERN("$cntlm.*?cntlm-parent");
}


function cntlm_parent(){
	
	if($GLOBALS["VERBOSE"]){echo "\n\n ***** CNTLM PARENT ******* \n\n";}
	
	$unix=new unix();
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("cntlm");
	if(!is_file($bin)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CNTLMInstalled", 0);
		$l[]="";
		$l[]="[APP_CNTLM_PARENT]";
		$l[]="service_name=APP_CNTLM_PARENT";
		$l[]="installed=0";
		$l[]="service_disabled=0";
		return implode("\n",$l);
	}
	
	$master_pid=cntlm_parent_pid();
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CNTLMInstalled", 1);
	$EnableCNTLM=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidEnableParentNTLM"));
	
	$l[]="";
	$l[]="[APP_CNTLM_PARENT]";
	$l[]="service_name=APP_CNTLM_PARENT";
	$l[]="service_cmd=/etc/init.d/cntlm-parent";
	$l[]="master_version=".cntlm_version();
	$l[]="service_disabled=$EnableCNTLM";
	$l[]="pid_path=/var/run/cntlm-parent.pid";
	$l[]="watchdog_features=1";
	$l[]="family=network";
	
	
	
	if($EnableCNTLM==0){
		if($GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
			$cmd=trim("{$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.cntlm-parent.php --stop >/dev/null 2>&1 &");
			shell_exec2($cmd);
		}
		$l[]="";
		return implode("\n",$l);
	}
	
	
	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			$cmd=trim("{$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.cntlm-parent.php --start >/dev/null 2>&1 &");
			shell_exec2($cmd);
		}
		$l[]="";
		return implode("\n",$l);
	}
	
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";
	
	return implode("\n",$l);return;
	
}


function cntlm(){
	$unix=new unix();
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("cntlm");
	if(!is_file($bin)){
		$l[]="";
		$l[]="[APP_CNTLM]";
		$l[]="service_name=APP_CNTLM";
		$l[]="installed=0";
		$l[]="service_disabled=0";
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CNTLMInstalled", 0);
		return implode("\n",$l);
	}
	
	if($GLOBALS["VERBOSE"]){echo "\n\n ***** CNTLM ******* \n\n";}

	$master_pid=cntlm_pid();
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CNTLMInstalled", 1);
	$EnableCNTLM=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableCNTLM");
	$EnableKerbAuth=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableKerbAuth");
	if(!is_numeric($EnableCNTLM)){$EnableCNTLM=0;}
	if(!is_numeric($EnableKerbAuth)){$EnableKerbAuth=0;}
	if($EnableKerbAuth==0){$EnableCNTLM=0;}
	$l[]="";
	$l[]="[APP_CNTLM]";
	$l[]="service_name=APP_CNTLM";
	$l[]="service_cmd=/etc/init.d/cntlm";
	$l[]="master_version=".cntlm_version();
	$l[]="service_disabled=$EnableCNTLM";
	$l[]="pid_path=/var/run/cntlm.pid";
	$l[]="watchdog_features=1";
	$l[]="family=network";

	

	if($EnableCNTLM==0){
		if($GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
			if(is_file("/etc/init.d/cntlm")){
				squid_admin_mysql(1, "NTLM Proxy service running (disabled) [action=stop]", null,__FILE__,__LINE__);
				$cmd=trim("{$GLOBALS["NICE"]} /etc/init.d/cntlm stop >/dev/null 2>&1 &");
			}
			shell_exec2($cmd);
		}
		if($GLOBALS["VERBOSE"]){echo "CNTLM :Disbaled\n";}
		$l[]="";
		return implode("\n",$l);
	}


	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			if(is_file("/etc/init.d/cntlm")){
				squid_admin_mysql(1, "NTLM Proxy service down [action=start]", null,__FILE__,__LINE__);
				$cmd=trim("{$GLOBALS["NICE"]} /etc/init.d/cntlm start >/dev/null 2>&1 &");
				shell_exec2($cmd);
			}
		}
		$l[]="";
		return implode("\n",$l);
		return;
	}
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";

	return implode("\n",$l);;
}



function hotspot_tail(){
	if(!is_file("/etc/init.d/hotspot-tail")){return;}
	remove_service("/etc/init.d/hotspot-tail");
	
}

function hotspot_web_pid(){

	$unix=new unix();
	$pid=$unix->get_pid_from_file("/var/run/hotspot-web.pid");
	if($unix->process_exists($pid)){
		return $pid;
	}

	return $unix->PIDOF_PATTERN("hotspot.py");

}
function _statussquid($text=null){
	if(!isset($GLOBALS["MIPIDSQUID"])){$GLOBALS["MIPIDSQUID"]=getmypid();}
	
	$TIME=date("M d H:i:s");
	if($GLOBALS["VERBOSE"]){echo "$text\n";}
	$logFile="/var/log/artica-status-squid.log";
	if(!is_dir(dirname($logFile))){mkdir(dirname($logFile));}
	if (is_file($logFile)) {
		$size=filesize($logFile);
		if($size>1000000){@unlink($logFile);}
	}
	$logFile=str_replace("//","/",$logFile);
	$f = @fopen($logFile, 'a');
	@fwrite($f, "$TIME [{$GLOBALS["MIPIDSQUID"]}] $text\n");
	@fclose($f);
}





function squid_nat(){
	if(!is_file("/etc/init.d/squid-nat")){return;}
	$masterbin=$GLOBALS["CLASS_UNIX"]->find_program("squid27");
	if(!is_file($masterbin)){return;}
	$enabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableTransparent27"));
	$l[]="[APP_SQUID_NAT]";
	$l[]="service_name=APP_SQUID_NAT";
	$l[]="master_version=".squid_27_version();
	$l[]="service_cmd=/etc/init.d/squid-nat";
	$l[]="service_disabled=$enabled";
	$l[]="family=proxy";
	$l[]="watchdog_features=1";

	if($enabled==0){return implode("\n",$l);return;}

	$master_pid=squid_nat_pid();
	

	

	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if($GLOBALS["CLASS_UNIX"]->ServerRunSince()>3){
			if(!$GLOBALS["DISABLE_WATCHDOG"]){
				shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/squid-nat reload >/dev/null 2>&1 &");
				squid_admin_mysql(0,"Squid-Cache NAT front-end not running, start it...",null,__FILE__,__LINE__);
			}
		}
		$l[]="running=0\ninstalled=1";$l[]="";
		return implode("\n",$l);
		return;
	}

	$l[]="running=1";
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";

	return implode("\n",$l);return;
}

function squid_db_version(){
	return $GLOBALS["CLASS_UNIX"]->MYSQL_VERSION();
}



function task_squid_license(){
	$SQUIDEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable"));
	if(is_file("/etc/cron.d/squid-analyze-license")){@unlink("/etc/cron.d/squid-analyze-license");}
	
	if($SQUIDEnable==1){
		if(!is_file("/etc/cron.d/proxy-count-users")){
			Popuplate_cron_make("proxy-count-users","0,10,20,30,40,50 * * * *","exec.squid.licenses-users.php");
			shell_exec("/etc/init.d/cron restart");
		}
		
	}else{
		if(is_file("/etc/cron.d/proxy-count-users")){
			@unlink("/etc/cron.d/proxy-count-users");
			shell_exec("/etc/init.d/cron restart");
		}
	}
	
}


function task_squid_stored_objects(){
	$SQUIDEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable"));
	$EnableSquidPurgeStoredObjects=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableSquidPurgeStoredObjects"));
	$EnableSquidPurgeStoredObjectsTime=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableSquidPurgeStoredObjectsTime"));
	$EnableIntelCeleron=intval(@file_get_contents("/etc/artica-postfix/settings/Daemons/EnableIntelCeleron"));
	
	if($SQUIDEnable==0){$EnableSquidPurgeStoredObjects=0;}
	if($EnableIntelCeleron==1){$EnableSquidPurgeStoredObjects=0;}
	if(!preg_match("#([0-9]+):([0-9]+)#", $EnableSquidPurgeStoredObjectsTime,$re)){
		$HOUR=3;
		$MIN=40;
	}else{
		$HOUR=$re[1];
		$MIN=$re[2];
	}
	
	if($EnableSquidPurgeStoredObjects==0){
		if(is_file("/etc/cron.d/squid-analyze-cache")){
			@unlink("/etc/cron.d/squid-analyze-cache");
			shell_exec("/etc/init.d/cron reload");
		}
		return;
	}
	
	if(!is_file("/etc/cron.d/squid-analyze-cache")){
		Popuplate_cron_make("squid-analyze-cache","$MIN $HOUR * * *","exec.purge.php");
		shell_exec("/etc/init.d/cron reload");
	}
	
	
	
}
function squid_kerb_auth_path(){
	if(is_file('/lib/squid3/negotiate_kerberos_auth') ){return '/lib/squid3/negotiate_kerberos_auth';}
	if(is_file('/usr/lib/squid3/squid_kerb_auth') ){return '/usr/lib/squid3/squid_kerb_auth';}
	if(is_file('/usr/lib64/squid3/squid_kerb_auth') ){return '/usr/lib64/squid3/squid_kerb_auth';}
	if(is_file('/lib/squid3/squid_kerb_auth') ){return '/lib/squid3/squid_kerb_auth';}
	if(is_file('/lib64/squid3/squid_kerb_auth') ){return '/lib64/squid3/squid_kerb_auth';}
	if(is_file('/usr/lib/squid/squid_kerb_auth') ){return '/usr/lib/squid/squid_kerb_auth';}
	if(is_file('/usr/lib/squid/squid_kerb_auth') ){return '/usr/lib/squid/squid_kerb_auth';}
	if(is_file('/usr/lib64/squid/squid_kerb_auth') ){return '/usr/lib64/squid/squid_kerb_auth';}
	if(is_file('/usr/lib64/squid/squid_kerb_auth') ){return '/usr/lib64/squid/squid_kerb_auth';}
	if(is_file('/usr/local/lib/squid/squid_kerb_auth') ){return '/usr/local/lib/squid/squid_kerb_auth';}
	if(is_file('/usr/local/lib64/squid/squid_kerb_auth') ){return '/usr/local/lib64/squid/squid_kerb_auth';}
	if(is_file('/opt/artica/libexec/squid_kerb_auth') ){return '/opt/artica/libexec/squid_kerb_auth';}
}
//#############################################################################


function squid_master_status($buildcache=false){
    $txec="{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix";
	$sock=$GLOBALS["CLASS_SOCKETS"];

	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("squid_kerb_auth_path", squid_kerb_auth_path());
	$xCacheTime="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".time";
	$CacheSchedules=$GLOBALS["CLASS_UNIX"]->file_time_sec($xCacheTime);
	if($CacheSchedules<20){return @file_get_contents($xCacheTime);}
	
	
	if(!$GLOBALS["CLASS_UNIX"]->CORP_LICENSE()){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("UseCloudArticaCategories", 0);}

	
	if(!is_file("/etc/artica-postfix/settings/Daemons/MonitSquidMaxRestartMem")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MonitSquidMaxRestartMem", 3000);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/MonitSquidMaxCPU")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MonitSquidMaxCPU", 95);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/SquidSimpleConfig")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SquidSimpleConfig", 1);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/CalamarisSchedules")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CalamarisSchedules", 0);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableProxyInSNMPD")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableProxyInSNMPD", 1);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableSquidPurgeStoredObjects")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableSquidPurgeStoredObjects", 0);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableParentProxy")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableParentProxy", 0);}
	
	if(!is_dir("/home/squid/SQLITE")){@mkdir("/home/squid/SQLITE",0755);}
	@chown("/home/squid", "squid");
	@chgrp("/home/squid", "squid");
	@chown("/home/squid/SQLITE", "squid");
	@chgrp("/home/squid/SQLITE", "squid");
	
	if(is_file("/home/squid/SQLITE/visited.db")){
		@chown("/home/squid/SQLITE/visited.db", "squid");
		@chgrp("/home/squid/SQLITE/visited.db", "squid");
		@chmod("/home/squid/SQLITE/visited.db", 0777);
	}
	
	task_squid_stored_objects();
	task_squid_license();
	
	$SQUIDEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable"));
	
	if($SQUIDEnable==1){
		if(!is_file("/etc/init.d/squid")){
			squid_admin_mysql(0, "Missing init squid script and Proxy service is enabled [action=install]", null,__FILE__,__LINE__);
			shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.squid.disable.php --install >/dev/null 2>&1 &");
		}
	}
	
	
	$EnableArticaMetaClient=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableArticaMetaClient"));
	$EnableArticaMetaServer=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableArticaMetaServer"));
	$CalamarisSchedules=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("CalamarisSchedules"));
	$EnableParentProxy=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableParentProxy"));
	
	if($EnableArticaMetaServer==1){$EnableArticaMetaClient=0;}
	
	
	$prefixcmd=$GLOBALS["nohup"]." {$GLOBALS["NICE"]}".$GLOBALS["CLASS_UNIX"]->LOCATE_PHP5_BIN()." ";
	$sqdbin=$GLOBALS["CLASS_UNIX"]->LOCATE_SQUID_BIN();


	if($SQUIDEnable==0){$CalamarisSchedules=0;}
	
	
	$squid_master_status_version=squid_master_status_version();
	$squid_ldap_auth_path=___squid_ldap_auth_path();
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SquidVersion", $squid_master_status_version);
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SQUID_LDAP_AUTH",$squid_ldap_auth_path);
	
	if(!is_file($sqdbin)){
		$l[]="";
		$l[]="[SQUID]";
		$l[]="service_name=APP_SQUID";
		$l[]="master_version=$squid_master_status_version";
		$l[]="service_cmd=/etc/init.d/squid";
		$l[]="service_disabled=0";
		$l[]="watchdog_features=1";
		$l[]="binpath=$sqdbin";
		$l[]="explain=SQUID_CACHE_TINYTEXT";
		$l[]="remove_cmd=--squid-remove";
		$l[]="family=squid";
		$l[]="running=0\ninstalled=0";$l[]="";
		return @implode("\n", $l);
		
	}
	
	
	if($CalamarisSchedules==0){
		if(is_file("/etc/cron.d/artica-calamaris")){
			@unlink("/etc/cron.d/artica-calamaris");
			shell_exec("/etc/init.d/cron reload");
		}
	}
		
	if($CalamarisSchedules==1){
		$CalamarisSchedulesZ[1]="0 * * * *";
		$CalamarisSchedulesZ[2]="0 0,2,4,6,8,10,12,14,16,18,20,22 * * *";
		$CalamarisSchedulesZ[3]="0 0,4,8,12,16,20 * * *";
		$CalamarisSchedulesZ[4]="0 0,6,12 * * *";
		
		if(!is_file("/etc/cron.d/artica-calamaris")){
			Popuplate_cron_make("artica-calamaris",$CalamarisSchedulesZ[$CalamarisSchedules],"exec.calamaris.php");
			shell_exec("/etc/init.d/cron reload");
		}
	}
	
	
	
	if($SQUIDEnable==0){
		if(is_file("/etc/cron.d/squidping")){@unlink("/etc/cron.d/squidping");shell_exec("/etc/init.d/cron reload");}
		$l[]="";
		$l[]="[SQUID]";
		$l[]="service_name=APP_SQUID";
		$l[]="master_version=". squid_master_status_version();
		$l[]="service_cmd=/etc/init.d/squid";
		$l[]="service_disabled=0";
		$l[]="watchdog_features=1";
		$l[]="binpath=$sqdbin";
		$l[]="explain=SQUID_CACHE_TINYTEXT";
		$l[]="remove_cmd=--squid-remove";
		$l[]="family=squid";
		$l[]="installed=1";
		$l[]="";
		return @implode("\n", $l);
	}else{
		if(!is_file("/etc/cron.d/squidping")){
			Popuplate_cron_make("squidping","0 0,2,4,6,8,10,12,14,16,18,20,22 * * *","exec.ping.proxy.php");
		}
	}
		
	$squid_master_status_version=squid_master_status_version();
	$EnableRemoteStatisticsAppliance=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableRemoteStatisticsAppliance");
	$DisableArticaProxyStatistics=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("DisableArticaProxyStatistics");
	$WindowsActiveDirectoryKerberos=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("WindowsActiveDirectoryKerberos"));
	if(!is_file("/etc/artica-postfix/settings/Daemons/UnlockWebStats")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("UnlockWebStats", 0);}
	$SquidWatchdogTestPortSchedule=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidWatchdogTestPortSchedule"));
	if($SquidWatchdogTestPortSchedule==0){$SquidWatchdogTestPortSchedule=30;}
	if(!is_numeric($EnableRemoteStatisticsAppliance)){$EnableRemoteStatisticsAppliance=0;}
	if(!is_numeric($DisableArticaProxyStatistics)){$DisableArticaProxyStatistics=0;}
	$UnlockWebStats=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnlockWebStats");
	if(!is_numeric($UnlockWebStats)){$UnlockWebStats=0;}
	if($UnlockWebStats==1){$EnableRemoteStatisticsAppliance=0;}
	$DisableStats=0;
	if($EnableRemoteStatisticsAppliance==1){$DisableStats=1;}
	if($DisableArticaProxyStatistics==1){$DisableStats=1;}
	
	
	
	@file_put_contents("/usr/share/artica-postfix/ressources/databases/SQUID.version",$squid_master_status_version);
	@chmod("/usr/share/artica-postfix/ressources/databases/SQUID.version",0755);
	$l[]="";
	$l[]="[SQUID]";
	$l[]="service_name=APP_SQUID";
	$l[]="master_version=". squid_master_status_version();
	$l[]="service_cmd=/etc/init.d/squid";
	$l[]="service_disabled=$SQUIDEnable";
	$l[]="watchdog_features=1";
	$l[]="binpath=$sqdbin";
	$l[]="explain=SQUID_CACHE_TINYTEXT";
	$l[]="remove_cmd=--squid-remove";
	$l[]="family=squid";
	if($GLOBALS["CLASS_UNIX"]->SQUID_ICAP_ENABLED()){
		if($GLOBALS["VERBOSE"]){echo "SQUID_ICAP_ENABLED OK\n";}
		$l[]="icap_enabled=1";
	}
	$ServerRunSince=$GLOBALS["CLASS_UNIX"]->ServerRunSince();


    if($ServerRunSince>3){
        $SquidSSLUrgency = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidSSLUrgency"));
        if($SquidSSLUrgency==1){
            squid_admin_mysql(0,"Proxy is in SSL Emergency mode, trying to repair",null,
                __FILE__,__LINE__);
            shell_exec2("$txec/exec.squid.ssl.emergency.remove.php -off >/dev/null 2>&1 &");
        }
    }

	
	if(!is_file("/etc/squid3/snmpd.conf")){
		if($ServerRunSince>3){
			$timex=$GLOBALS["CLASS_UNIX"]->file_time_min("/etc/artica-postfix/pids/exec.squid.snmpd.check.time");
			if($timex>60){
				squid_admin_mysql(0,"Reconfigure proxy service for adding SNMP settings",null,__FILE__,__LINE__);
				shell_exec2("$txec/exec.squid.global.access.php --snmp --noexternal-scripts >/dev/null 2>&1 &");
				@unlink("/etc/artica-postfix/pids/exec.squid.snmpd.check.time");
				@file_put_contents("/etc/artica-postfix/pids/exec.squid.snmpd.check.time", time());
			}
		}
	}

    $isrtime_logs=isrtime_logs();
    if($isrtime_logs) {
        if (!is_file("/etc/cron.d/postgres-hourly")) {
            $GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("postgres-hourly", "0,10,20,30,40,50 * * * *", "exec.postgres.squid.hourly.php");
            system("/etc/init.d/cron reload");
        }
    }else{
        if (is_file("/etc/cron.d/postgres-hourly")) {
            @unlink("/etc/cron.d/postgres-hourly");
            system("/etc/init.d/cron reload");
        }

    }
    if (!is_file("/etc/cron.d/squid-certificates")) {
        $GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("squid-certificates", "0,10,20,30,40,50 * * * *", "exec.squid.ssl.certificates.php --parse-certificates");
        system("/etc/init.d/cron reload");
    }

	
	
	
	if($ServerRunSince>5){
		
		$EnableNoTracks=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableNoTracks"));
		if($EnableNoTracks==1){
			$NoTracksSchedule=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NoTracksSchedule"));
			if($NoTracksSchedule>0){
				$timex=$GLOBALS["CLASS_UNIX"]->file_time_min("/etc/artica-postfix/settings/Daemons/NoTracksStamp");
				if($timex>$NoTracksSchedule-1){
					shell_exec2("$txec/exec.notrack.update.php >/dev/null 2>&1 &");
					@unlink("/etc/artica-postfix/settings/Daemons/NoTracksStamp");
					$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NoTracksStamp", time());
				}
			}
		}
		$EnableURLhaus=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableURLhaus"));
		if($EnableURLhaus==1){
			$URLhausSchedule=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("URLhausSchedule"));
			if($URLhausSchedule>0){
				$timex=$GLOBALS["CLASS_UNIX"]->file_time_min("/etc/artica-postfix/settings/Daemons/URLhausStamp");
				if($timex>$URLhausSchedule-1){
					shell_exec2("{$txec}/exec.URLhaus.update.php >/dev/null 2>&1 &");
					@unlink("/etc/artica-postfix/settings/Daemons/URLhausStamp");
					$GLOBALS["CLASS_SOCKETS"]->SET_INFO("URLhausStamp", time());
				}
			}
		}		
		

		if($EnableParentProxy==1){
			$timex=$GLOBALS["CLASS_UNIX"]->file_time_min("/usr/share/artica-postfix/ressources/logs/web/squid.peers.db");
			if($timex>5){
				shell_exec2("$txec/exec.squid.watchdog.php --peer-status >/dev/null 2>&1 &");
			}
		}
	

		if(!$buildcache){
			$TimeEX=$GLOBALS["CLASS_UNIX"]->file_time_min("/usr/share/artica-postfix/ressources/databases/ALL_SQUID_STATUS");
			if($TimeEX>10){
				if(!system_is_overloaded(basename(__FILE__))){
					$GLOBALS["CLASS_UNIX"]->THREAD_COMMAND_SET("$txec/exec.status.php --all-squid --nowachdog");
				}
			}
		}
	
	
		if($WindowsActiveDirectoryKerberos==0){
			if($GLOBALS["CLASS_UNIX"]->isSquidNTLM()){
				$TimeEX=$GLOBALS["CLASS_UNIX"]->file_time_min("/usr/share/artica-postfix/ressources/logs/web/ntlmauthenticator.cache");
				if($TimeEX>4){
					shell_exec2("$txec/exec.squid.php.ntlmauthenticator.php >/dev/null 2>&1 &");
				}
			}
		}
	
	}

    $pid=0;
	$pidpath="/var/run/squid/squid.pid";
	$logs[]="pidpath: $pidpath";
	if($SQUIDEnable==0){$l[]="running=0\ninstalled=1";return implode("\n",$l);return;}
	if(is_file($pidpath)) {
        $pid = trim(@file_get_contents($pidpath));
    }

	$logs[]="pid: $pid";
	
	if(!$GLOBALS["CLASS_UNIX"]->process_exists($pid)){
		$pid=$GLOBALS["CLASS_UNIX"]->PIDOF($sqdbin);
		$logs[]="pid: $pid (after pidof $sqdbin)";
		@file_put_contents($pidpath,$pid);
	}
	
	

	squid_tasks_events("Invoke squid_tasks($DisableStats)",__FUNCTION__,__FILE__,__LINE__);
	squid_tasks($DisableStats);
	$notiftime="/etc/artica-postfix/squid-failed-notiftime";
	
	
	$NOTIFY=false;
	
	if(!$GLOBALS["CLASS_UNIX"]->process_exists($pid)){
		if($ServerRunSince>2){
			if(!$GLOBALS["DISABLE_WATCHDOG"]){
				$pgrep=$GLOBALS["CLASS_UNIX"]->find_program("pgrep");
				$logs[]="pgrep:";
				exec("$pgrep -l -f \"$sqdbin\" 2>&1",$logs);
				if(function_exists("debug_backtrace")){$trace=debug_backtrace();if(isset($trace[1])){$sourcefunction=$trace[1]["function"];$sourceline=$trace[1]["line"];$executed="Executed by $sourcefunction() line $sourceline\n";}}
				$notiftimeex=$GLOBALS["CLASS_UNIX"]->file_time_min($notiftime);
				if($notiftimeex>10){$NOTIFY=true;@unlink($notiftime);@file_put_contents($notiftime, time());}
				
				if($NOTIFY){
					if(is_file("/var/log/squid/cache.log")){
						exec("{$GLOBALS["TAILBIN"]} -n 20 /var/log/squid/cache.log 2>&1",$results);
						$tail_results=@implode("\n", $results);
					}
				}
				
				shell_exec("$sqdbin -C -f /etc/squid3/squid.conf >/tmp/squid.watchdog.log 2>&1 &");
				sleep(3);
				$watchdog=@file_get_contents("/tmp/squid.watchdog.log");@unlink("/tmp/squid.watchdog.log");
				squid_admin_mysql(0,"Proxy service is Stopped",
				"launch the start procedure...\n$sqdbin -C -f /etc/squid3/squid.conf >/tmp/squid.watchdog.log 2>&1 &\n$watchdog\nNotif time:$notiftimeex\n$executed\n".@implode("\n", $logs)."\n".
				$tail_results,__FILE__,__LINE__);
			}
		}
		$l[]="running=0\ninstalled=1";
		$l[]="";
		return implode("\n",$l);return;
	}
	
	
	$l[]="running=1";
	$l[]=GetMemoriesOf($pid);

	$l[]="";
	return implode("\n",$l);return;
}
// ========================================================================================================================================================
function squid_master_status_version(){
	if(isset($GLOBALS["squid_master_status_version"])){return $GLOBALS["squid_master_status_version"];}
	$unix=new unix();
	$squidbin=$unix->find_program("squid");
	if($squidbin==null){$squidbin=$unix->find_program("squid3");}
	exec("$squidbin -v 2>&1",$results);
	foreach ($results as $num=>$val){
		if(preg_match("#Squid Cache: Version.*?([0-9\.]+)#", $val,$re)){
			if($GLOBALS["VERBOSE"]){echo "Starting......: ".date("H:i:s")." Squid : Version (as root) '{$re[1]}'\n";}
			$GLOBALS["squid_master_status_version"]=$re[1];
			squid_master_status_version_real($results);
			return $GLOBALS["squid_master_status_version"];
		}
	}
	
}


function squid_master_status_version_real($results){
	reset($results);
	foreach ($results as $num=>$val){
		if(preg_match("#Squid Cache: Version.*?([0-9\.\-a-z]+)#", $val,$re)){
			if(preg_match("#^(.*?)-$#", trim($re[1]),$ri)){$re[1]=$ri[1];}
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SquidRealVersion", $re[1]);
		}
	}

}
//========================================================================================================================================================
function cntlm_version(){
	$cacheFile="/etc/artica-postfix/cntlm_version";
	$unix=new unix();
	if($GLOBALS["CLASS_UNIX"]->file_time_min($cacheFile)<800){return @file_get_contents("/etc/artica-postfix/cntlm_version");}

	$bin=$GLOBALS["CLASS_UNIX"]->find_program("cntlm");
	if(!is_file($bin)){if($GLOBALS['VERBOSE']){echo "cntlm -> no such file\n";}return;}
	exec("$bin -h 2>&1",$array);
	foreach ($array as $pid=>$line){
		if(preg_match("#Proxy version\s+([0-9\.\-a-z]+)#i", $line,$re)){
			@unlink($cacheFile);
			@file_put_contents($cacheFile, $re[1]);
			return $re[1];}
			if($GLOBALS['VERBOSE']){echo "cntlm_version(),  \"$line\", not found \n";}
	}
}
//========================================================================================================================================================


function squid_tasks(){
	
	$nice=$GLOBALS["CLASS_UNIX"]->EXEC_NICE();
	$php=$GLOBALS["CLASS_UNIX"]->LOCATE_PHP5_BIN();
	$ionice=$GLOBALS["CLASS_UNIX"]->EXEC_NICE();
	

	if(!is_file("/etc/cron.d/squid-client-list")){
		$f[]="MAILTO=\"\"";
		$f[]="10,20,30,40,50,0 * * * * root $ionice $php /usr/share/artica-postfix/exec.squidclient.mgr.clientlist.php >/dev/null 2>&1";
		$f[]="";
		@file_put_contents("/etc/cron.d/squid-client-list", @implode("\n", $f));
		@chmod("/etc/cron.d/squid-client-list",0644);
		shell_exec("/etc/init.d/cron reload");
	}
	
	
	if(is_file("/etc/cron.d/squid-run-c")){
		if(is_file("/etc/artica-postfix/pids/exec.squid.run.schedules.php.time")){
			return;
		}
	}
	
	$nice=$GLOBALS["CLASS_UNIX"]->EXEC_NICE();
	$php=$GLOBALS["CLASS_UNIX"]->LOCATE_PHP5_BIN();
	$ionice=$GLOBALS["CLASS_UNIX"]->EXEC_NICE();
	$f=array();
	$f[]="MAILTO=\"\"";
	$f[]="5,10,15,20,25,30,35,40,45 * * * * root $ionice $php /usr/share/artica-postfix/exec.squid.run.schedules.php >/dev/null 2>&1";
	$f[]="";
	@file_put_contents("/etc/cron.d/squid-run-c", @implode("\n", $f));
	@chmod("/etc/cron.d/squid-run-c",0644);
	shell_exec("/etc/init.d/cron reload");
	shell_exec("{$GLOBALS["nohup"]} $php /usr/share/artica-postfix/exec.squid.run.schedules.php >/dev/null 2>&1 &");
	unset($f);
}
function squid_tasks_events($text,$function=null,$line=0){
	$filename=basename(__FILE__);
	$function=__CLASS__."/".$function;
	$GLOBALS["CLASS_UNIX"]->events("$text","/var/log/artica-stats-executor.log",false,$function,$line,$filename);
}

function squid_cache_tail(){
	if(!is_file("/usr/share/artica-postfix/exec.cache-logs.php")){return;}
	if(!$GLOBALS["CLASS_UNIX"]->SQUID_INSTALLED()){if($GLOBALS["VERBOSE"]){echo __FUNCTION__." squid is not installed\n";}return null;}else{if($GLOBALS["VERBOSE"]){echo __FUNCTION__." squid is installed\n";}}
	$SQUIDEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable"));
	

	if(is_file("/etc/artica-postfix/pids/exec.cache-logs.php.pid")){
		$master_pid=trim(@file_get_contents("/etc/artica-postfix/pids/exec.cache-logs.php.pid"));
	}

	
	$monitconfig="/etc/monit/conf.d/APP_SQUID_CACHE_TAIL.monitrc";
	if($SQUIDEnable==0){
		if(is_file($monitconfig)){@unlink($monitconfig);}
		$l[]="running=0\ninstalled=1";
		return implode("\n",$l);
	}
	
	if(!is_file($monitconfig)){
		$f=array();
		$f[]="check process APP_SQUID_CACHE_TAIL with pidfile /etc/artica-postfix/pids/exec.cache-logs.php.pid";
		$f[]="\tstart program = \"/etc/init.d/cache-tail start --monit\"";
		$f[]="\tstop program = \"/etc/init.d/cache-tail stop --monit\"";
		$f[]="\tif 5 restarts within 5 cycles then timeout";
		$f[]="";
		@file_put_contents("/etc/monit/conf.d/APP_SQUID_CACHE_TAIL.monitrc", @implode("\n", $f));
	}

	if(!is_file("/etc/init.d/cache-tail")){
        shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.squid.disable.php --cache-logs >/dev/null 2>&1 &");

    }

	$l[]="[APP_SQUID_CACHE_TAIL]";
	$l[]="service_name=APP_SQUID_CACHE_TAIL";
	$l[]="master_version=".@file_get_contents("/usr/share/artica-postfix/VERSION");
	$l[]="service_cmd=/etc/init.d/cache-tail";
	$l[]="service_disabled=$SQUIDEnable";
	$l[]="watchdog_features=1";


	
	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		$master_pid=$GLOBALS["CLASS_UNIX"]->PIDOF_PATTERN("php.*?exec.cache-logs.php");
	}


	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		squid_watchdog_events("Starting Squid cache tail..");
		shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/cache-tail start >/dev/null 2>&1 &");
		$l[]="running=0\ninstalled=1";
		$l[]="";
		return implode("\n",$l);return;
	}
	$l[]="running=1";
	$l[]=GetMemoriesOf($master_pid);

	$l[]="";
	return implode("\n",$l);return;

}
// ========================================================================================================================================================
function squid_nat_pid(){
	$unix=new unix();
	$masterbin=$GLOBALS["CLASS_UNIX"]->find_program("squid27");
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file('/var/run/squid/squid-nat.pid');
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
	return $GLOBALS["CLASS_UNIX"]->PIDOF_PATTERN($masterbin." -f /etc/squid27/squid.conf");
}
function squid_27_version(){
	if(isset($GLOBALS["squid_27_version"])){return $GLOBALS["squid_27_version"];}
	$squidbin=$GLOBALS["CLASS_UNIX"]->find_program("squid27");
	if(!is_file($squidbin)){return "0.0.0";}
	exec("$squidbin -v 2>&1",$results);
	foreach ($results as $num=>$val){
		if(preg_match("#Squid Cache: Version\s+(.+)#", $val,$re)){
			$GLOBALS["squid_27_version"]=trim($re[1]);
			return $GLOBALS["squid_27_version"];
		}
	}
}
function squid_db_pid(){
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/squid-db.pid");
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
	$SquidStatsDatabasePath=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidStatsDatabasePath");
	if($SquidStatsDatabasePath==null){$SquidStatsDatabasePath="/opt/squidsql";}
	$mysqld=$GLOBALS["CLASS_UNIX"]->find_program("mysqld");

	$WORKDIR=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidStatsDatabasePath");
	if($WORKDIR==null){$WORKDIR="/opt/squidsql";}

	return $GLOBALS["CLASS_UNIX"]->PIDOF_PATTERN("$mysqld.*?squid-db.sock");

}

function ufdbguard_pid(){

	$pid_path="/var/tmp/ufdbguardd.pid";
	if(!is_dir("/var/tmp")){@mkdir("/var/tmp",0775,true);}
	if(!is_file($pid_path)){$pid_path="/var/run/ufdbguard/ufdbguardd.pid";}
	
	
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file($pid_path);
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){
		$cmdline=trim(@file_get_contents("/proc/$pid/cmdline"));
		if(!preg_match("#ufdbcatdd#", $cmdline)){return $pid;}
	}
	
	$ufdbguardd=$GLOBALS["CLASS_UNIX"]->find_program("ufdbguardd");
	return $GLOBALS["CLASS_UNIX"]->PIDOF($ufdbguardd);
}




function articadb(){
	$timefile=$time_file=$GLOBALS["CLASS_UNIX"]->file_time_min("/usr/share/artica-postfix/ressources/logs/ARTICA_DBS_STATUS_FULL.db");
	_statussquid("/usr/share/artica-postfix/ressources/logs/ARTICA_DBS_STATUS_FULL.db ( $timefile mn/30)");
	
	if($time_file>30){
		_statussquid("-> /usr/share/artica-postfix/exec.ufdb.databases.php");
		shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.ufdb.databases.php >/dev/null 2>&1 &");
	}
}



function ss5_pid(){
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/ss5/ss5.pid");
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
	$Masterbin=$GLOBALS["CLASS_UNIX"]->find_program("ss5");
	return $GLOBALS["CLASS_UNIX"]->PIDOF($Masterbin);
	
}
function ss5_version(){

	if(isset($GLOBALS["ss5_version"])){return $GLOBALS["ss5_version"];}
	exec("/usr/sbin/ss5 -v 2>&1",$results);
	foreach ($results as $none=>$line){
		if(preg_match("#SS5 Version\s+([0-9\.]+)#", $line,$re)){
			$GLOBALS["ss5_version"]= $re[1];
			break;
		}
		
	}

	return $GLOBALS["ss5_version"];
}









function ss5(){
	$l[]="[APP_SS5]";
	$l[]="service_name=APP_SS5";
	
	
	
	
	
	
	if(!is_file("/usr/sbin/ss5")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SS5Installed", 0);
		$l[]="installed=0";
		$l[]="";
		return @implode("\n", $l);
		
	}
	if(!is_file("/var/lib/ss5/ss5/mod_socks4.so")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SS5Installed", 0);
		$l[]="installed=0";
		$l[]="";
		return @implode("\n", $l);
	}
	
	if(!is_file("/etc/init.d/ss5")){return;}
	
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SS5Installed", 1);
	$enabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableSS5"));
	
	$l[]="master_version=".ss5_version();
	$l[]="service_cmd=/etc/init.d/ss5";
	$l[]="service_disabled=$enabled";
	$l[]="family=squid";
	if($enabled==0){
		if(is_file("/etc/init.d/ss5")){
			shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.ss5.php --uninstall");
		}
	}
	
	$master_pid=ss5_pid();
	
	if($GLOBALS["VERBOSE"]){echo "Enabled = $enabled PID: $master_pid\n";}
	if($enabled==0){
		if($GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
			squid_admin_mysql(1, "Socks Proxy server MUST not running [action=stop]", null,__FILE__,__LINE__);
			shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/ss5 stop >/dev/null 2>&1 &");
			$l[]="running=1";
			$l[]=GetMemoriesOf($master_pid);
			$l[]="";
			return implode("\n",$l);
		}
	
		return implode("\n",$l)."\n";
	}
	
	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			if($GLOBALS["CLASS_UNIX"]->ServerRunSince()>3){squid_admin_mysql(0, "Socks Proxy server is not running [action=start]", null,__FILE__,__LINE__);}
			shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/ss5 start >/dev/null 2>&1 &");
		}
		$l[]="running=0\ninstalled=1";$l[]="";
	
		return implode("\n",$l);
	}
	
	
	$l[]="running=1";
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";
	return implode("\n",$l);
}




function kav4Proxy_pid(){
	$PID_PATH="/var/run/kav4proxy/kavicapserver.pid";
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file($PID_PATH);
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
	return $GLOBALS["CLASS_UNIX"]->PIDOF("/opt/kaspersky/kav4proxy/sbin/kav4proxy-kavicapserver");

}



function kav4Proxy_status(){
	$Masterbin="/opt/kaspersky/kav4proxy/sbin/kav4proxy-kavicapserver";
	if(!is_file($Masterbin)){
		$l[]="";
		$l[]="[KAV4PROXY]";
		$l[]="service_name=APP_KAV4PROXY";
		$l[]="service_disabled=0";
		$l[]="installed=0";
		$l[]="service_disabled=0";
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("Kav4ProxyInstalled", 0);
		return @implode("\n", $l).kav4Proxy_keepup2date();
	}


	$APP_KAV4PROXY_VERSION=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("APP_KAV4PROXY_VERSION");
	$enabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("kavicapserverEnabled"));
	$master_pid=kav4Proxy_pid();

	$l[]="[KAV4PROXY]";
	$l[]="service_name=APP_KAV4PROXY";
	$l[]="master_version=$APP_KAV4PROXY_VERSION";
	$l[]="service_cmd=/etc/init.d/kav4proxy";
	$l[]="service_disabled=$enabled";
	$l[]="remove_cmd=--kav4Proxy-remove";
	$l[]="explain=enable_kavproxy_text";
	$l[]="installed=1";
	$l[]="family=squid";
	
	
	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		$master_pid=$GLOBALS["CLASS_UNIX"]->PIDOF($Masterbin);
	}
    $php=$GLOBALS["CLASS_UNIX"]->LOCATE_PHP5_BIN();
	if($enabled==0){
		if(is_file("/etc/init.d/kav4proxy")){
            squid_admin_mysql(0,"Kav4Proxy installed but was disabled [action=uninstall]",
                null,__FILE__,__LINE__);
            shell_exec2("{$GLOBALS["nohup"]} $php /usr/share/artica-postfix/exec.kav4Proxy.install.php --uninstall >/dev/null 2>&1 &");


        }
		return @implode("\n",$l);
	}


    if($enabled==1){
	    if(!is_file("/etc/init.d/kav4proxy")){
            squid_admin_mysql(0,"Kav4Proxy uninstalled but was enabled [action=install]",
                null,__FILE__,__LINE__);
            shell_exec2("{$GLOBALS["nohup"]} $php /usr/share/artica-postfix/exec.kav4Proxy.install.php --install >/dev/null 2>&1 &");
            return @implode("\n",$l);
        }

	    if(!is_file("/var/log/kaspersky/kav4proxy/kavicapserver.log")){
            if($GLOBALS["CLASS_UNIX"]->process_exists($master_pid)) {
                squid_admin_mysql(0, "Kav4Proxy kavicapserver.log no such file [action=reload]",
                    null, __FILE__, __LINE__);
                shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/kav4proxy reload");
            }

        }
	
	$licenseManager=$GLOBALS["CLASS_UNIX"]->PIDOF("/opt/kaspersky/kav4proxy/bin/kav4proxy-licensemanager");   if($GLOBALS["CLASS_UNIX"]->process_exists($licenseManager)){
			if($GLOBALS["CLASS_UNIX"]->PROCCESS_TIME_MIN($licenseManager)>1){
				if(function_exists("WriteToSyslog")){WriteToSyslog("Killing kav4proxy-licensemanager",
                    basename(__FILE__));}
				$GLOBALS["CLASS_UNIX"]->KILL_PROCESS($licenseManager,9);
			}
		}
		

	}




	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			squid_admin_mysql(0, "Kaspersky Anti-Virus for Proxy Server is not running [action=start]", null,__FILE__,__LINE__);
			shell_exec2("{$GLOBALS["nohup"]} /etc/init.d/kav4proxy start >/dev/null 2>&1 &");
		}
		$l[]="running=0\ninstalled=1";$l[]="";
		
		return implode("\n",$l).kav4Proxy_keepup2date();
	}

	if(!is_file("/usr/share/artica-postfix/ressources/logs/web/Kav4ProxyDatabaseSize.db")){
		shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.keepup2date.php --update-kav4proxy-status >/dev/null 2>&1 &");
	}
	
	if($GLOBALS["CLASS_UNIX"]->file_time_min("/etc/artica-postfix/KAV4PROXY_LICENSE_INFO")>2880){
		shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.kav4proxy.php --license >/dev/null 2>&1 &");
	}
	
	

	$l[]="running=1";
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";
	return implode("\n",$l).kav4Proxy_keepup2date();

}
function kav4Proxy_keepup2date(){
	if(!$GLOBALS["CLASS_USERS"]->KASPERSKY_WEB_APPLIANCE){
		if(!$GLOBALS["CLASS_UNIX"]->SQUID_INSTALLED()){
			$l[]="";
			$l[]="[KAV4PROXY_KEEPUP2DATE]";
			$l[]="service_name=KAV4PROXY_KEEPUP2DATE";
			$l[]="installed=0";
			$l[]="service_disabled=0";
			return @implode("\n", $l);
		}
		if(!$GLOBALS["CLASS_USERS"]->KAV4PROXY_INSTALLED){
			$l[]="";
			$l[]="[KAV4PROXY_KEEPUP2DATE]";
			$l[]="service_name=KAV4PROXY_KEEPUP2DATE";
			$l[]="installed=0";
			$l[]="service_disabled=0";
			return @implode("\n", $l);
			
		}
		$SQUIDEnable=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable");
		if(!is_numeric($SQUIDEnable)){$SQUIDEnable=1;}
		$enabled=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("kavicapserverEnabled");
		if($SQUIDEnable==0){$enabled=0;}
	}else{
		$enabled=1;
	}

	$pid=$GLOBALS["CLASS_UNIX"]->PIDOF("/opt/kaspersky/kav4proxy/bin/kav4proxy-keepup2date");
	if(!$GLOBALS["CLASS_UNIX"]->process_exists($pid)){return;}
	$l[]="";
	$l[]="[KAV4PROXY_KEEPUP2DATE]";
	$l[]="service_name=KAV4PROXY_KEEPUP2DATE";
	$l[]="master_version=".GetVersionOf("kav4proxy");
	$l[]="service_cmd=kav4proxy";
	$l[]="service_disabled=$enabled";
	$l[]="remove_cmd=--kav4Proxy-remove";
	$l[]="explain=enable_kavproxy_text";
	$l[]="family=squid";
	$l[]="installed=1";
	$l[]="running=1";
	$l[]=GetMemoriesOf($pid);
	$l[]="";
	return implode("\n",$l);
}

function proxypac_pid(){
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/proxy-pac/http-server.pid");
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
	return $GLOBALS["CLASS_UNIX"]->PIDOF_PATTERN("/proxy-pac.py");
}

function proxypac(){
	if(!is_file("/etc/init.d/proxy-pac")){return;}



	


    $EnableProxyPac=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableProxyPac"));
    if($EnableProxyPac==1){
        if(!is_file("/etc/init.d/nginx")){
            squid_admin_mysql(0, "Install web service for Proxy PAC Web server",null,__FILE__,__LINE__);
            shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.nginx.enable.php >/dev/null 2>&1 &");
        }

    }
    $EnableSquidMicroHotSpot=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableSquidMicroHotSpot"));
    if($EnableSquidMicroHotSpot==1){
        if(!is_file("/etc/cron.d/hotspot-task")){
            $GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("hotspot-task","*/2 * * * *","exec.hotspot.task.php");
            system("/etc/init.d/cron reload");
        }
    }else{
        if(is_file("/etc/cron.d/hotspot-task")){
            @unlink("/etc/cron.d/hotspot-task");
            system("/etc/init.d/cron reload");
        }

    }

	
	
	$l[]="";
	$l[]="[APP_PROXY_PAC]";
	$l[]="service_name=APP_PROXY_PAC";
	$l[]="service_cmd=/etc/init.d/proxy-pac";
	$l[]="master_version=".@file_get_contents("/usr/share/artica-postfix/VERSION");
	$l[]="service_disabled=1";
	$l[]="pid_path=/var/run/proxy-pac/http-server.pid";
	$l[]="watchdog_features=1";
	$l[]="installed=1";
	$l[]="family=network";


	$master_pid=proxypac_pid();
	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			$ServerRunSince=$GLOBALS["CLASS_UNIX"]->ServerRunSince();
			if($ServerRunSince>3){squid_admin_mysql(0, "Proxy PAC Web server not running [action=start]", null,__FILE__,__LINE__);}
			$cmd=trim("{$GLOBALS["NICE"]} /etc/init.d/proxy-pac start >/dev/null 2>&1 &");
			shell_exec2($cmd);
		}
		$l[]="running=0";
		$l[]="";
		return implode("\n",$l);
	
	}
	$l[]="running=1";
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";
	return implode("\n",$l);	
	
}
function ntlm_monitor_pid(){
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/artica-ntlm.pid");
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){
		return $pid;
	}
	return $GLOBALS["CLASS_UNIX"]->PIDOF_PATTERN("ntlm-monitor.py");
}

function ntlm_monitor(){
	if(!is_file("/etc/init.d/ntlm-monitor")){return;}
	$l[]="";
	
	$WindowsActiveDirectoryKerberos=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("WindowsActiveDirectoryKerberos"));
	if($WindowsActiveDirectoryKerberos==1){return;}
	$l[]="[APP_NTLM_MONITOR]";
	$l[]="service_name=APP_NTLM_MONITOR";
	$l[]="service_cmd=/etc/init.d/ntlm-monitor";
	$l[]="master_version=".@file_get_contents("/usr/share/artica-postfix/VERSION");
	$l[]="service_disabled=1";
	$l[]="pid_path=/var/run/proxy-pac/http-server.pid";
	$l[]="watchdog_features=1";
	$l[]="installed=1";
	$l[]="family=network";
	$master_pid=ntlm_monitor_pid();
	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			if($GLOBALS["CLASS_UNIX"]->ServerRunSince()>3){squid_admin_mysql(0, "NTLM Monitor not running [action=start]", null,__FILE__,__LINE__);}
			$cmd=trim("{$GLOBALS["NICE"]} /etc/init.d/ntlm-monitor start >/dev/null 2>&1 &");
			shell_exec2($cmd);
		}
		$l[]="running=0";
		$l[]="";
		return implode("\n",$l);

	}
	$l[]="running=1";
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";
	return implode("\n",$l);

}

// ========================================================================================================================================================

function isrtime_logs(){

    $EnableSquidLogger=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableSquidLogger"));
    $EnableRedisServer=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableRedisServer"));
    $SQUIDEnable=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable");
    if($EnableSquidLogger==0){return false;}
    if($EnableRedisServer==0){return false;}
    if($SQUIDEnable==0){return false;}
    return true;
}