<?php
$GLOBALS["YESCGROUP"]=true;
$GLOBALS["FAILED_UPLOADED"]=0;
$GLOBALS["VERBOSE"]=false;
$GLOBALS["CLUSTER_SINGLE"]=false;
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__)."/framework/frame.class.inc");
include_once(dirname(__FILE__)."/ressources/class.categories.inc");
include_once(dirname(__FILE__)."/ressources/class.openssl.aes.inc");
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["debug"]=true;$GLOBALS["VERBOSE"]=true;ini_set('display_errors', 1);	ini_set('html_errors',0);ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);}

if(isset($argv[1])){
    if($argv[1]=="--single"){single($argv[2],$argv[3]);exit;}
    if($argv[1]=="--server"){single_server($argv[2]);exit;}
}

xsync();
function build_progress($text,$pourc){
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    echo "[$pourc]: $text\n";
    @file_put_contents("/usr/share/artica-postfix/ressources/logs/web/categories.services.progress", serialize($array));
    @chmod($GLOBALS["PROGRESS_FILE"],0755);

}

function xsync(){
    $unix=new unix();

    $pidtime="/etc/artica-postfix/pids/".basename(__FILE__).".time";
    $ExecTime=$unix->file_time_min($pidtime);
    if($ExecTime<3){
        build_progress("{$ExecTime}mn, need minimal each 4Mn, retry later",110);
        return;
    }


    $catz=new mysql_catz();
    $q=new lib_sqlite("/home/artica/SQLITE/proxy.db");
    $categories=new categories();
    $categories->output=true;
    $categories->cached=false;
    $i=20;

    $sql="CREATE TABLE IF NOT EXISTS `categories_services` (
		`ID` INTEGER PRIMARY KEY AUTOINCREMENT,
		`port` INTEGER NOT NULL DEFAULT 0,
		`hostname` TEXT NULL,
		`domain` TEXT NOT NULL,
		`zorder` INTEGER NOT NULL DEFAULT 0,        
		`crypt` INTEGER NOT NULL DEFAULT 0,
		`passphrase` TEXT NULL,
		`enabled`  INTEGER NOT NULL DEFAULT 1)";
    $q->QUERY_SQL($sql);

    $results=$q->QUERY_SQL("SELECT * FROM categories_services WHERE enabled=1 ORDER BY zorder");

    build_progress("{synchronize}",$i);

    $CLEAN=false;

    $C=0;
    $MAX=count($results);

    foreach ($results as $index=>$ligne) {

        $ID = intval($ligne["ID"]);
        if ($ID == 0) {continue;}
        $C++;
        $prc=$C/$MAX;
        $prc=round($prc*100);
        build_progress("{synchronize} $ID {$prc}%",50);
        echo "Scanning remote $ID\n";
        $catz->synchronizeCatz("articatech-non-existent-domain.zva",$ID);
        if(!$catz->ok){
            echo "$catz->mysql_error\n";
            continue;
        }

        $ItemsNumber=intval($catz->CategoryNumbers);
        $lastUpdate=intval($catz->CategoryTime);
        $CategoriesCount=count($catz->CategoriesList);
        $CategoriesList=$catz->CategoriesList;
        echo "Number of categories = $CategoriesCount, items=$ItemsNumber, time=$lastUpdate\n";
        if($CategoriesCount==0){continue;}

        $md51=$categories->remote_categories_server_md5($ID);

        $categories->remote_categories_server_del($ID);
        foreach ($CategoriesList as $category_id){

            $catz->ufdbcat_remote("articatech-non-existent-$category_id.zva",$ID);
            $CategoryName=$catz->CategoryName;
            $items=$catz->CategoriesCount;
            if($CategoryName==null){
                echo "Creating category: $category_id No Category name, aborting\n";
                continue;
            }

            echo "Creating category: $category_id ($CategoryName) $items item(s)\n";
            if(!$categories->create_category($CategoryName,null,$ID,$category_id)){
                echo $q->mysql_error."\n";
                return false;
            }
            echo "Updating category: $category_id ($CategoryName) $items item(s)\n";
            $categories->update_category_items($category_id,$items);



        }

        $md52=$categories->remote_categories_server_md5($ID);
        if($md52<>$md51){$CLEAN=true;}



    }

    if($CLEAN){
        echo "Clean Categories memory...\n";
        $catz->categories_descriptions_clean();

    }
    build_progress("{synchronize} done...",90);

    if($C>0){
        $unix=new unix();
        if(!is_file("/etc/cron.d/categories-services")) {
            $unix->Popuplate_cron_make("categories-services", "0,10,20,30,40,50 * * * *", basename(__FILE__));
            shell_exec("/etc/init.d/cron restart");
        }else{
            $unix->Popuplate_cron_make("categories-services", "0,10,20,30,40,50 * * * *", basename(__FILE__));
        }
    }else{
        if(is_file("/etc/cron.d/categories-services")) {
            @unlink("/etc/cron.d/categories-services");
            shell_exec("/etc/init.d/cron restart");
        }
    }
    build_progress("{synchronize} done...",100);

}

function single_server($ID){
    $catz=new mysql_catz();
    $catz->synchronizeCatz("articatech-non-existent-domain.zva",$ID);
    if(!$catz->ok){
        echo "$catz->mysql_error\n";
        return;
    }



    $ItemsNumber=intval($catz->CategoryNumbers);
    $lastUpdate=intval($catz->CategoryTime);
    $CategoriesCount=count($catz->CategoriesList);
    $CategoriesList=$catz->CategoriesList;
    echo "Number of categories = $CategoriesCount, items=$ItemsNumber, time=$lastUpdate\n";
    foreach ($CategoriesList as $category_id){
        echo "$category_id\n";
    }

}

function single($ID,$category_id){
    echo "Scanning remote $ID ($category_id)\n";
    $catz=new mysql_catz();
    $catz->ufdbcat_remote("articatech-non-existent-$category_id.zva",$ID);
    $CategoryName=$catz->CategoryName;
    $items=$catz->CategoriesCount;
    $CategoriesNumber=count($catz->CategoriesList);
    echo "$category_id) $CategoryName Number Of Categories: $CategoriesNumber items:$items\n";

}