<?php
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;$GLOBALS["VERBOSE"]=true;$GLOBALS["debug"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}

if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){
    include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}
    $GLOBALS["CLASS_SOCKETS"]=new sockets();
}

include_once(dirname(__FILE__) . '/framework/class.unix.inc');
include_once(dirname(__FILE__) . '/framework/frame.class.inc');
include_once(dirname(__FILE__) . '/ressources/class.system.nics.inc');
include_once(dirname(__FILE__) . '/ressources/class.os.system.inc');

if($argv[1]=="--install"){$GLOBALS["OUTPUT"]=true;install();exit();}
if($argv[1]=="--uninstall"){$GLOBALS["OUTPUT"]=true;uninstall();exit();}

function install(){

    build_progress(10,"{installing}");
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableDbusDaemon",1);
    build_progress(50,"{installing}");
    create_service();
    build_progress(90,"{installing}");
    shell_exec("/etc/init.d/dbus start");
    build_progress(100,"{installing} {success}");

}

function uninstall(){
    build_progress(10,"{uninstalling}");
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableDbusDaemon",0);
    remove_service("/etc/init.d/dbus");
    if(is_file("/etc/monit/conf.d/APP_DBUS.monitrc")){
        @unlink("/etc/monit/conf.d/APP_DBUS.monitrc");
        shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload >/dev/null 2>&1");
    }
    build_progress(100,"{uninstalling} {success}");
}

function build_progress($pourc,$text){
    $date=date("Y-m-d H:i:s");
    $file="/usr/share/artica-postfix/ressources/logs/web/dbus.service.progress";
    echo "$date: [{$pourc}%] $text\n";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($file, serialize($array));
    @chmod($file,0755);
}

function build_monit(){
    $f[]="check process APP_DBUS with pidfile /var/run/dbus/pid";
    $f[]="\tstart program = \"/etc/init.d/dbus start\"";
    $f[]="\tstop program = \"/etc/init.d/dbus stop\"";
    $f[]="\tif 5 restarts within 5 cycles then timeout";
    $f[]="";
    @file_put_contents("/etc/monit/conf.d/APP_DBUS.monitrc", @implode("\n", $f));
    shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload >/dev/null 2>&1");
}


function create_service(){

    $f[]="#!/bin/sh";
    $f[]="### BEGIN INIT INFO";
    $f[]="# Provides:          dbus";
    $f[]="# Required-Start:    \$remote_fs \$syslog";
    $f[]="# Required-Stop:     \$remote_fs \$syslog";
    $f[]="# Default-Start:     2 3 4 5";
    $f[]="# Default-Stop:";
    $f[]="# Short-Description: D-Bus systemwide message bus";
    $f[]="# Description:       D-Bus is a simple interprocess messaging system, used";
    $f[]="#                    for sending messages between applications.";
    $f[]="### END INIT INFO";
    $f[]="# -*- coding: utf-8 -*-";
    $f[]="# Debian init.d script for D-BUS";
    $f[]="# Copyright © 2003 Colin Walters <walters@debian.org>";
    $f[]="# Copyright © 2005 Sjoerd Simons <sjoerd@debian.org>";
    $f[]="";
    $f[]="set -e";
    $f[]="";
    $f[]="DAEMON=/usr/bin/dbus-daemon";
    $f[]="UUIDGEN=/usr/bin/dbus-uuidgen";
    $f[]="UUIDGEN_OPTS=--ensure";
    $f[]="NAME=dbus";
    $f[]="DAEMONUSER=messagebus";
    $f[]="PIDDIR=/var/run/dbus";
    $f[]="PIDFILE=\$PIDDIR/pid";
    $f[]="DESC=\"system message bus\"";
    $f[]="";
    $f[]="test -x \$DAEMON || exit 0";
    $f[]="";
    $f[]=". /lib/lsb/init-functions";
    $f[]="";
    $f[]="# Source defaults file; edit that file to configure this script.";
    $f[]="PARAMS=\"\"";
    $f[]="if [ -e /etc/default/dbus ]; then";
    $f[]="  . /etc/default/dbus";
    $f[]="fi";
    $f[]="";
    $f[]="create_machineid() {";
    $f[]="  # Create machine-id file";
    $f[]="  if [ -x \$UUIDGEN ]; then";
    $f[]="    \$UUIDGEN \$UUIDGEN_OPTS";
    $f[]="  fi";
    $f[]="}";
    $f[]="";
    $f[]="start_it_up()";
    $f[]="{";
    $f[]="  if [ ! -d \$PIDDIR ]; then";
    $f[]="    mkdir -p \$PIDDIR";
    $f[]="    chown \$DAEMONUSER \$PIDDIR";
    $f[]="    chgrp \$DAEMONUSER \$PIDDIR";
    $f[]="  fi";
    $f[]="";
    $f[]="  if ! mountpoint -q /proc/ ; then";
    $f[]="    log_failure_msg \"Can't start \$DESC - /proc is not mounted\"";
    $f[]="    return";
    $f[]="  fi";
    $f[]="";
    $f[]="  if [ -e \$PIDFILE ]; then";
    $f[]="    if \$0 status > /dev/null ; then";
    $f[]="      log_success_msg \"\$DESC already started; not starting.\"";
    $f[]="      return";
    $f[]="    else";
    $f[]="      log_success_msg \"Removing stale PID file \$PIDFILE.\"";
    $f[]="      rm -f \$PIDFILE";
    $f[]="    fi";
    $f[]="  fi";
    $f[]="";
    $f[]="  create_machineid";
    $f[]="";
    $f[]="  log_daemon_msg \"Starting \$DESC\" \"\$NAME\"";
    $f[]="  start-stop-daemon --start --quiet --pidfile \$PIDFILE \ ";
$f[]="    --exec \$DAEMON -- --system \$PARAMS";
$f[]="  log_end_msg \$?";
$f[]="}";
$f[]="";
$f[]="shut_it_down()";
$f[]="{";
$f[]="  log_daemon_msg \"Stopping \$DESC\" \"\$NAME\"";
$f[]="  start-stop-daemon --stop --retry 5 --quiet --oknodo --pidfile \$PIDFILE \ ";
$f[]="    --user \$DAEMONUSER";
$f[]="  # We no longer include these arguments so that start-stop-daemon";
$f[]="  # can do its job even given that we may have been upgraded.";
$f[]="  # We rely on the pidfile being sanely managed";
$f[]="  # --exec \$DAEMON -- --system \$PARAMS";
$f[]="  log_end_msg \$?";
$f[]="  rm -f \$PIDFILE";
$f[]="}";
$f[]="";
$f[]="reload_it()";
$f[]="{";
$f[]="  create_machineid";
$f[]="  log_action_begin_msg \"Reloading \$DESC config\"";
$f[]="  dbus-send --print-reply --system --type=method_call \ ";
$f[]="            --dest=org.freedesktop.DBus \ ";
$f[]="            / org.freedesktop.DBus.ReloadConfig > /dev/null";
$f[]="  # hopefully this is enough time for dbus to reload it's config file.";
$f[]="  log_action_end_msg \$?";
$f[]="}";
$f[]="";
$f[]="case \"\$1\" in";
$f[]="  start)";
$f[]="    start_it_up";
$f[]="  ;;";
$f[]="  stop)";
$f[]="    shut_it_down";
$f[]="  ;;";
$f[]="  reload|force-reload)";
$f[]="    reload_it";
$f[]="  ;;";
$f[]="  restart)";
$f[]="    shut_it_down";
$f[]="    start_it_up";
$f[]="  ;;";
$f[]="  status)";
$f[]="    status_of_proc -p \$PIDFILE \$DAEMON \$NAME && exit 0 || exit \$?";
$f[]="    ;;";
$f[]="  *)";
$f[]="    echo \"Usage: /etc/init.d/\$NAME {start|stop|reload|restart|force-reload|status}\" >&2";
$f[]="    exit 2";
$f[]="  ;;";
$f[]="esac";
$f[]="";

    @file_put_contents("/etc/init.d/dbus",@implode("\n",$f));
    @chmod("/etc/init.d/dbus",0755);

    if(is_file('/usr/sbin/update-rc.d')){
        shell_exec("/usr/sbin/update-rc.d -f " .basename("/etc/init.d/dbus")." defaults >/dev/null 2>&1");

    }

    if(is_file('/sbin/chkconfig')){
        shell_exec("/sbin/chkconfig --add " .basename("/etc/init.d/dbus")." >/dev/null 2>&1");
        shell_exec("/sbin/chkconfig --level 345 " .basename("/etc/init.d/dbus")." on >/dev/null 2>&1");
    }
}

function remove_service($INITD_PATH){
    if(!is_file($INITD_PATH)){return;}
    system("$INITD_PATH stop");
    if(is_file('/usr/sbin/update-rc.d')){shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");}
    if(is_file('/sbin/chkconfig')){shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");}
    if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}