<?php
$GLOBALS["VERBOSE"]=true;
$GLOBALS["AS_ROOT"]=true;
$GLOBALS["TITLENAME"]="Load-Balancer Daemon";
$GLOBALS["OUTPUT"]=false;
$GLOBALS["COMMANDLINE"]=implode(" ",$argv);
$GLOBALS["NOCONF"]=false;
$GLOBALS["WIZARD"]=false;
$GLOBALS["BY_SCHEDULE"]=false;
if(strpos($GLOBALS["COMMANDLINE"],"--verbose")>0){$GLOBALS["VERBOSE"]=true;$GLOBALS["debug"]=true;$GLOBALS["DEBUG"]=true;ini_set('html_errors',0);ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);}
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__)."/framework/frame.class.inc");
include_once(dirname(__FILE__)."/framework/class.settings.inc");
include_once(dirname(__FILE__)."/ressources/class.resolv.conf.inc");

if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;}
if(preg_match("#--force#",implode(" ",$argv))){$GLOBALS["FORCE"]=true;}
if(preg_match("#--noconf#",implode(" ",$argv))){$GLOBALS["NOCONF"]=true;}
if(preg_match("#--wizard#",implode(" ",$argv))){$GLOBALS["WIZARD"]=true;}
if(preg_match("#--byschedule#",implode(" ",$argv))){$GLOBALS["BY_SCHEDULE"]=true;}

if($argv[1]=="--disconnect"){client_disconnect();}
if($argv[1]=="--connect"){connect_clusters();}
if($argv[1]=="--setup"){client_setup();}
if($argv[1]=="--ping-syslog"){ping_syslog();}
if($argv[1]=="--connect-id"){connect_single($argv[2]);exit;}

function build_progress($text,$pourc){
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    echo "[$pourc]: $text\n";
    @file_put_contents("/usr/share/artica-postfix/ressources/logs/web/hacluster.connect.progress", serialize($array));
    @chmod("/usr/share/artica-postfix/ressources/logs/web/hacluster.connect.progress",0755);


}

function build_disconnect_progress($text,$pourc){
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    echo "[$pourc]: $text\n";
    @file_put_contents("/usr/share/artica-postfix/ressources/logs/web/hacluster.disconnect.progress", serialize($array));
    @chmod("/usr/share/artica-postfix/ressources/logs/web/hacluster.disconnect.progress",0755);

}

function ping_syslog(){

    hacluster_syslog("Ping syslog");

}

function client_disconnect(){
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    build_disconnect_progress("{disconnecting}...",20);
    client_report(500,null);


    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("HaClusterTproxy",0);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("HaClusterTproxyEnabled",0);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("UseNativeKerberosAuth",0);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableKerbAuth",0);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("kerberosActiveDirectoryLBEnable",0);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableActiveDirectoryFeature",0);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("UseNativeKerberosAuth",0);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("KerberosUsername",null);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("kerberosRealm",null);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("KerberosSPN",null);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("KerberosPassword",null);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("kerberosActiveDirectoryHost",null);

    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("HaClusterID",0);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("HaClusterIP",null);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("HaClusterClient",0);


    $PowerDNSEnableClusterSlave=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PowerDNSEnableClusterSlave"));
    $PowerDNSEnableClusterMaster=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PowerDNSEnableClusterMaster"));

    if($PowerDNSEnableClusterSlave==1) {
        $GLOBALS["CLASS_SOCKETS"]->getFrameWork("system.php?uninstall-cluster-slave=yes");
    }

    if($PowerDNSEnableClusterMaster==1) {
        $GLOBALS["CLASS_SOCKETS"]->getFrameWork("system.php?uninstall-cluster-master=yes");
    }
    hacluster_syslog("{disconnecting} From the HaCluster Pool");
    build_disconnect_progress("{disconnecting}...",30);
    $q=new lib_sqlite("/home/artica/SQLITE/proxy.db");
    $q->QUERY_SQL("DELETE FROM proxy_ports WHERE ProxyProtocol=1");
    system("$php /usr/share/artica-postfix/exec.squid.global.access.php --ports");


    build_disconnect_progress("{disconnecting}...",50);
    system("$php /usr/share/artica-postfix/exec.squid.global.access.php --logging");
    build_disconnect_progress("{disconnecting}...",80);
    system("$php /usr/share/artica-postfix/exec.keytab.php --uninstall");


    build_disconnect_progress("{disconnecting}...",90);
    if(is_file("/etc/rsyslog.d/ha-cluster-client.conf")){
        @unlink("/etc/rsyslog.d/ha-cluster-client.conf");
        system("/etc/init.d/rsyslog restart");
    }
    build_disconnect_progress("{disconnecting}...",91);
    if(is_file("/etc/rsyslog.d/hacluster-client.conf")){
        @unlink("/etc/rsyslog.d/ha-cluster-client.conf");
        system("/etc/init.d/rsyslog restart");
    }
    build_disconnect_progress("{disconnecting}...",92);
    if(is_file("/etc/init.d/cache-tail")){
        shell_exec("/etc/init.d/cache-tail restart");
    }

    build_disconnect_progress("{disconnecting} {success}",100);


}

function connect_single($ID){
    $q=new lib_sqlite("/home/artica/SQLITE/haproxy.db");


    $HaClusterTransParentMode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterTransParentMode"));

    $ligne=$q->mysqli_fetch_array("SELECT * FROM hacluster_backends WHERE enabled=1 AND isMaster=1");
    $MasterID=intval($ligne["ID"]);
    if($MasterID>0){
        $MASTER=$ligne["listen_ip"];
        $MASTER_PORT=$ligne["artica_port"];
    }
    $ligne=$q->mysqli_fetch_array("SELECT * FROM hacluster_backends WHERE ID=$ID");
    $artica_port=$ligne["artica_port"];
    $listen_ip=$ligne["listen_ip"];
    $listen_port=$ligne["listen_port"];
    $backendname=$ligne["backendname"];
    $isMaster=$ligne["isMaster"];
    $array=array();

    $array["hacluster-connect"]=$listen_port;
    $array["hacluster-tproxy"]=47887;
    $array["HaClusterTransParentMode"]=$HaClusterTransParentMode;
    $array["hacluster-id"]=$ID;
    if($isMaster==1){
        $array["hacluster-ismaster"]=1;
    }else{
        if($MASTER<>null) {
            $array["hacluster-master"] = $MASTER;
            $array["hacluster-master-port"] = $MASTER_PORT;
        }
    }

    $URI="https://$listen_ip:$artica_port";
    build_progress("$backendname says hello $backendname ?",50);
    if(!POST_INFOS($URI,$array,$ID)){
        $q->QUERY_SQL("UPDATE hacluster_backends SET status=1, errortext='{$GLOBALS["ERROR_INFO"]}' WHERE ID=$ID");
        build_progress("$backendname says {failed}",110);
        return;
    }
    build_progress("{success}",100);

}

function connect_clusters(){

    $unix=new unix();
    if(!$GLOBALS["CLASS_SOCKETS"]->CORP_LICENSE()){
        build_progress("{license_error}",110);
        die();
    }
    $MASTER=null;
    $MASTER_PORT=0;
    $php=$unix->LOCATE_PHP5_BIN();
    $q=new lib_sqlite("/home/artica/SQLITE/haproxy.db");

    if(!is_file("/etc/rsyslog.d/hacluster.conf")){
        shell_exec("$php /usr/share/artica-postfix/exec.hacluster.php --syslog");
    }
    if(!is_file("/etc/rsyslog.d/hacluster-client.conf")){
        shell_exec("$php /usr/share/artica-postfix/exec.hacluster.php --syslog");
    }

    if(!is_file("/etc/init.d/ntp")){
        shell_exec("$php /usr/share/artica-postfix/exec.ntpdate.php --install");
        shell_exec("$php /usr/share/artica-postfix/exec.ntpdate.php --reconfigure");
    }
    if(!is_file("/etc/init.d/dnsdist")){
        if(!is_file("/etc/init.d/unbound")){
            build_progress("{installing} {APP_UNBOUND}",10);
            system("$php /usr/share/artica-postfix/exec.unbound.php --install");
        }
    }
    build_progress("{reconfigure} {APP_UNBOUND}",10);
    system("$php /usr/share/artica-postfix/exec.unbound.php --reload");


    $ligne=$q->mysqli_fetch_array("SELECT * FROM hacluster_backends WHERE enabled=1 AND isMaster=1");
    $ID=intval($ligne["ID"]);
    if($ID>0){
        $MASTER=$ligne["listen_ip"];
        $MASTER_PORT=$ligne["artica_port"];
    }

    $HaClusterTransParentMode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterTransParentMode"));
    $results=$q->QUERY_SQL("SELECT * FROM hacluster_backends WHERE enabled=1");

    $prc=15;
    $FINAL=true;
    foreach ($results as $index=>$ligne){
        $ID=$ligne["ID"];
        $artica_port=$ligne["artica_port"];
        $listen_ip=$ligne["listen_ip"];
        $listen_port=$ligne["listen_port"];
        $backendname=$ligne["backendname"];
        $isMaster=$ligne["isMaster"];
        $array=array();

        $array["hacluster-connect"]=$listen_port;
        $array["hacluster-tproxy"]=47887;
        $array["HaClusterTransParentMode"]=$HaClusterTransParentMode;
        $array["hacluster-id"]=$ID;
        if($isMaster==1){
            $array["hacluster-ismaster"]=1;
        }else{
            if($MASTER<>null) {
                $array["hacluster-master"] = $MASTER;
                $array["hacluster-master-port"] = $MASTER_PORT;
            }
        }




        $URI="https://$listen_ip:$artica_port";
        build_progress("$backendname says hello $backendname ?",$prc++);
        if(!POST_INFOS($URI,$array,$ID)){
            $FINAL=false;
            $q->QUERY_SQL("UPDATE hacluster_backends SET status=1, errortext='{$GLOBALS["ERROR_INFO"]}' WHERE ID=$ID");
        }
    }





    if(!$FINAL){
        build_progress("{errors}",110);
        return;
    }

    build_progress("{success}",100);
}


function hacluster_syslog($text){
    echo $text."\n";
    if(!function_exists("syslog")){return;}
    $LOG_SEV=LOG_INFO;
    openlog("hacluster-client", LOG_PID , LOG_SYSLOG);
    syslog($LOG_SEV, $text);
    closelog();

}
function hacluster_syslog_master($text){
    echo $text."\n";
    if(!function_exists("syslog")){return;}
    $LOG_SEV=LOG_INFO;
    openlog("hacluster", LOG_PID , LOG_SYSLOG);
    syslog($LOG_SEV, $text);
    closelog();
}

function client_download_file($filename,$targetpath){


    $unix=new unix();
    $filetemp=$unix->FILE_TEMP();
    $HaClusterIP=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterIP");
    $uri="$HaClusterIP/pdns-cluster/$filename";
    //krb5.md5

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
    curl_setopt($ch, CURLOPT_DNS_CACHE_TIMEOUT, 360);
    curl_setopt($ch, CURLOPT_FORBID_REUSE, TRUE);
    curl_setopt($ch, CURLOPT_FRESH_CONNECT, TRUE);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array("Pragma: no-cache,must-revalidate", "Cache-Control: no-cache,must revalidate",'Expect:'));
    curl_setopt($ch, CURLOPT_TIMEOUT, 5);
    hacluster_syslog("[$filename]: Dowloading $uri",null,__LINE__);
    curl_setopt($ch, CURLOPT_URL, "$uri");
    curl_setopt($ch, CURLOPT_POST, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,false);curl_setopt($ch, CURLOPT_SSLVERSION,'all');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_NOPROXY,"*");
    curl_setopt($ch, CURLOPT_FILE, $fp = fopen($filetemp,'w'));

    curl_exec($ch);

    $Error=curl_errno($ch);
    if($Error>0) {
        $GLOBALS["ERROR"]="[$filename]: HTTP Error $Error";
        hacluster_syslog("[$filename]: HTTP Error $Error",null,__LINE__);
        curl_close($ch);
        fclose($fp);
        return false;
    }


    fclose($fp);
    curl_close($ch);

    if(is_file($targetpath)){@unlink($targetpath);}
    hacluster_syslog("[$filename]: Copy $filetemp -> $targetpath",null,__LINE__);
    if(!@copy($filetemp,$targetpath)){
        hacluster_syslog("[$filename]: Copy Error $targetpath",null,__LINE__);
        @unlink($filetemp);
        return false;
    }
    @unlink($filetemp);
    return true;


}

function POST_INFOS($uri,$posted=array(),$ID=0){
    $unix=new unix();
    $MyUUID=$unix->GetMyHostId();
    $ArticaHttpsPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ArticaHttpsPort"));
    $RsyslogPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("RsyslogPort"));
    $HaClusterGBConfig=unserialize($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterGBConfig"));

    if(intval($HaClusterGBConfig["HaClusterDecryptSSL"])==1){
        $Certif=$HaClusterGBConfig["HaClusterCertif"];
        $q=new lib_sqlite("/home/artica/SQLITE/certificates.db");
        $ligne=$q->mysqli_fetch_array("SELECT * FROM sslcertificates WHERE CommonName='$Certif'");
        $DataCertif=base64_encode(serialize($ligne));
        $HaClusterGBConfig["CertifData"]=$DataCertif;
    }


    if($RsyslogPort==0){$RsyslogPort=514;}
    if($ArticaHttpsPort==0){$ArticaHttpsPort=9000;}
    $post_data["HaCluster"]=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("haClusterAD");
    $post_data["HaClusterPort"]=$ArticaHttpsPort;
    $post_data["HaClusterUUID"]=$MyUUID;
    $post_data["HaClusterSyslogPort"]=$RsyslogPort;
    $post_data["KerberosSynCAD"]=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("KerberosSynCAD"));
    $post_data["HaClusterGBConfig"]=base64_encode(serialize($HaClusterGBConfig));




    foreach ($posted as $key=>$val){
        $post_data[$key]=$val;
    }

    hacluster_syslog_master("Notify node: $uri");
    $uri_final="$uri/nodes.listener.php";
    if($GLOBALS["VERBOSE"]){echo "$uri_final\n";}

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
    curl_setopt($ch, CURLOPT_DNS_CACHE_TIMEOUT, 360);
    curl_setopt($ch, CURLOPT_FORBID_REUSE, TRUE);
    curl_setopt($ch, CURLOPT_FRESH_CONNECT, TRUE);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array("Pragma: no-cache,must-revalidate", "Cache-Control: no-cache,must revalidate",'Expect:'));
    curl_setopt($ch, CURLOPT_TIMEOUT, 10);
    curl_setopt($ch, CURLOPT_URL, "$uri_final");
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,false);curl_setopt($ch, CURLOPT_SSLVERSION,'all');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_NOPROXY,"*");
    $data=curl_exec($ch);
    $CURLINFO_HTTP_CODE=curl_getinfo($ch,CURLINFO_HTTP_CODE);
    $curl_errno=curl_errno($ch);

    if($curl_errno==28){
        hacluster_syslog("$uri Error 28 Connection timed out...");
        $GLOBALS["ERROR_INFO"]="{connection_timed_out}";
        return false;
    }




    if(preg_match("#<ERROR>(.+?)</ERROR>#is",$data,$re)){
        hacluster_syslog_master("Error $uri says {$re[1]}");
        $GLOBALS["ERROR_INFO"]=$re[1];
        return false;
    }

    if(preg_match("#<STATUS>([0-9]+)</STATUS>#is",$data,$re)){
        hacluster_syslog_master("$uri Entering in setup mode, waiting feedbacks");
        $q=new lib_sqlite("/home/artica/SQLITE/haproxy.db");
        $q->QUERY_SQL("UPDATE hacluster_backends SET status={$re[1]}, errortext='' WHERE ID=$ID");
        return true;
    }

    if(preg_match("#RETURNED_TRUE#is",$data)){
        hacluster_syslog_master("$uri return True for order");
        $q=new lib_sqlite("/home/artica/SQLITE/haproxy.db");
        $q->QUERY_SQL("UPDATE hacluster_backends SET status=2, errortext='' WHERE ID=$ID");
        return true;
    }


    $header_size = curl_getinfo($ch,CURLINFO_HEADER_SIZE);

    if($GLOBALS["VERBOSE"]){echo "CURLINFO_HTTP_CODE = $CURLINFO_HTTP_CODE $curl_errno=$curl_errno\n";}

}

function client_report($status,$error=null){

    $unix=new unix();
    $HaClusterID=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterID");
    $HaClusterIP=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterIP");

    hacluster_syslog("Report status $status ($error)");
    $post_data["HaClusterNode"]=$HaClusterID;
    $post_data["HaClusterStatus"]=$status;
    $post_data["HaClusterError"]=$error;
    $post_data["hostname"]=$unix->hostname_g();
    $uri_final="$HaClusterIP/nodes.listener.php";
    if($GLOBALS["VERBOSE"]){echo "$uri_final\n";}

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
    curl_setopt($ch, CURLOPT_DNS_CACHE_TIMEOUT, 360);
    curl_setopt($ch, CURLOPT_FORBID_REUSE, TRUE);
    curl_setopt($ch, CURLOPT_FRESH_CONNECT, TRUE);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array("Pragma: no-cache,must-revalidate", "Cache-Control: no-cache,must revalidate",'Expect:'));
    curl_setopt($ch, CURLOPT_TIMEOUT, 10);
    curl_setopt($ch, CURLOPT_URL, "$uri_final");
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,false);curl_setopt($ch, CURLOPT_SSLVERSION,'all');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_NOPROXY,"*");
    $data=curl_exec($ch);
    $CURLINFO_HTTP_CODE=curl_getinfo($ch,CURLINFO_HTTP_CODE);
    $curl_errno=curl_errno($ch);

    if($curl_errno>0){
        hacluster_syslog("$uri_final Error $curl_errno ...");
        return false;
    }


}

function syslog_client_install(){
    $HaClusterIP=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterIP");
    $HaClusterSyslogPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterSyslogPort"));
    if($HaClusterSyslogPort==0){$HaClusterSyslogPort=514;}

    if(preg_match("#http(s|):\/\/(.+?):[0-9]+#",$HaClusterIP,$re)){
        $HaClusterIP=$re[2];
    }

    $h[]="if  (\$programname =='hacluster-client') then {";
    $h[]="\taction(type=\"omfile\" dirCreateMode=\"0700\" FileCreateMode=\"0755\" File=\"/var/log/hacluster.log\")";
    $h[]="\taction(type=\"omfwd\" Target=\"$HaClusterIP\" Port=\"$HaClusterSyslogPort\" Protocol=\"udp\")";
    $h[]="}";

    @file_put_contents("/etc/rsyslog.d/hacluster-client.conf",@implode("\n", $h));
    system("/etc/init.d/rsyslog restart");

}


function client_setup_transparent_mode(){

    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    $HaClusterTransParentMode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterTransParentMode"));
    $ProxyPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterTproxy"));
    if(intval($ProxyPort)==0){$HaClusterTransParentMode=0;}
    hacluster_syslog("Transparent Proxy port....$ProxyPort");


    $ISDETECTED_PORT=client_setup_transparent_mode_is_installed();


    if( $HaClusterTransParentMode == 1){
       if($ISDETECTED_PORT==$ProxyPort){
            hacluster_syslog("[SETUP]: [TRANSPARENT] Port $ProxyPort {already_installed}");
            return true;
        }

        hacluster_syslog("[SETUP]: [TRANSPARENT] Reconfiguring proxy server");
        system("$php /usr/share/artica-postfix/exec.squid.global.access.php --ports --firehol");
        $ISDETECTED_PORT=client_setup_transparent_mode_is_installed();
        if($ISDETECTED_PORT==$ProxyPort){
            hacluster_syslog("[SETUP]: [TRANSPARENT] Port $ProxyPort {success}");
            return true;
        }
        return false;

    }

    if($ISDETECTED_PORT==0){
        hacluster_syslog("[SETUP]: [TRANSPARENT] {uninstalled}");
        return true;
    }

    if($ISDETECTED_PORT>0){
        hacluster_syslog("[SETUP]: [TRANSPARENT] {uninstall}");
        system("$php /usr/share/artica-postfix/exec.squid.global.access.php --ports --firehol");
        $ISDETECTED_PORT=client_setup_transparent_mode_is_installed();
        if($ISDETECTED_PORT>0){
            hacluster_syslog("[SETUP]: [TRANSPARENT] {uninstall} {failed}");
            return false;
        }
        return true;
    }


    return true;
}

function client_setup_transparent_mode_is_installed(){
    $f=explode("\n",@file_get_contents("/etc/squid3/listen_ports.conf"));
    foreach ($f as $line){
        $line=trim($line);
        if($line==null){continue;}
        if(preg_match("#^\##",$line)){continue;}
        if(preg_match("#http_port [0-9\.]+:([0-9]+)\s+.*?name=HaClusterTransparent#i",$line,$re)){
            return intval($re[1]);
        }

    }

    return 0;

}


function client_setup(){
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    $BasePath="/home/artica/PowerDNS/Cluster/storage";
    if(!is_dir($BasePath)){@mkdir($BasePath,0755,true);}
    @chmod($BasePath,0755);

    if(is_file("/etc/artica-postfix/ClusterWaitProgram")){@unlink("/etc/artica-postfix/ClusterWaitProgram");}
    if(is_file("/etc/artica-postfix/ClusterTime")){@unlink("/etc/artica-postfix/ClusterTime");}
    if(is_file("/home/artica/PowerDNS/Cluster/storage/index.txt")){@unlink("/home/artica/PowerDNS/Cluster/storage/index.txt");}

    $HaClusterProxyPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterProxyPort"));


    hacluster_syslog("Proxy port....$HaClusterProxyPort");
    syslog_client_install();
    $HaClusterUUID=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterUUID");
    $HaClusterID=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterID");
    $HaClusterIP=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterIP");
    hacluster_syslog("Setup ID=$HaClusterID Load-balancer = $HaClusterIP");
    $HaClusterADContent=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterAD");
    $HaClusterAD=unserialize(base64_decode($HaClusterADContent));
    if(!isset($HaClusterAD["kerberosActiveDirectoryHost"])){$HaClusterAD["kerberosActiveDirectoryHost"]=null;}
    hacluster_syslog("[SETUP]: SET HaClusterClient to 1");
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("HaClusterClient",1);
    $HaClusterGBConfig=unserialize($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterGBConfig"));


    hacluster_syslog("[SETUP]: Modify DNS settings.");
    $resolv=new resolv_conf();
    @file_put_contents("/etc/resolv.conf",$resolv->build());


    if(!is_file("/etc/cron.d/ntp-client")) {
        hacluster_syslog("[SETUP]: Installing NTP Client...");
        shell_exec("$php /usr/share/artica-postfix/exec.ntpdate.php --client-install");
    }

    if(is_file("/etc/init.d/unbound")){
        hacluster_syslog("[SETUP]: Uninstalling local DNS Cache");
        shell_exec("$php /usr/share/artica-postfix/exec.unbound.php --uninstall");
    }

    if(is_file("/etc/init.d/firehol")){
        shell_exec("$php /usr/share/artica-postfix/exec.firehol.php --disable-progress");
    }



    if($HaClusterAD["kerberosActiveDirectoryHost"]<>null){
        $tmp=$unix->FILE_TEMP();
        $TmpDir=$unix->TEMP_DIR();
        $CurrentMD5=null;
        hacluster_syslog("Replicate the kerberos ticket");
        $KerberosSecureTicket=intval($HaClusterAD["KerberosSecureTicket"]);


        if(!client_download_file("krb5.md5",$tmp)){
            client_report(3,"[krb5]: {downloading} krb5.md5 failed...");
            return false;
        }

        $HostMD5=@file_get_contents($tmp);
        hacluster_syslog("$tmp = $HostMD5");
        @unlink($tmp);

        if($KerberosSecureTicket==1) {
            $tmp=$unix->FILE_TEMP();
            $openssl=$unix->find_program("openssl");
            hacluster_syslog("[krb5]: kerberos ticket is encrypted, downloading krb5.crypt");
            if(!client_download_file("krb5.crypt",$tmp)){
                client_report(3,"[krb5.crypt]: {downloading} krb5.crypt failed...");
                return false;
            }
            $md5New=md5_file($tmp);
            hacluster_syslog("[krb5.crypt]: krb5.crypt = $md5New against $HostMD5");
            if($md5New<>$HostMD5){
                client_report(3,"[krb5.crypt]: {downloading} krb5.crypt {corrupted}...");
                $tmp;
                return false;
            }
            hacluster_syslog("[krb5.crypt]: Uncrypt krb5.crypt from $tmp width password lenght ".strlen($HaClusterUUID)." bytes");
            exec("$openssl enc -aes-256-cbc -k $HaClusterUUID -md sha256 -iter 1000 -d -in $tmp -out \"/etc/squid3/krb5.keytab\" 2>&1",$resultsOpenSSL);

            foreach ($resultsOpenSSL as $line){
                $line=trim($line);
                if($line==null){continue;}
                hacluster_syslog("[krb5.crypt]: $line");
                if(preg_match("#bad decrypt#",$line)){
                    @unlink($tmp);
                    @unlink("/etc/squid3/krb5.keytab");
                    client_report(3,"[krb5.crypt]: {uncrypt} krb5.crypt {failed} {corrupted}...");
                    return false;
                }
            }

            if(!is_file("/etc/squid3/krb5.keytab")){
                @unlink($tmp);
                client_report(3,"[krb5.crypt]: {uncrypt} krb5.crypt {failed} (missing /etc/squid3/krb5.keytab)...");
                return false;
            }
            if (is_file("$BasePath/krb5.keytab")) {@unlink("$BasePath/krb5.keytab");}
            if (is_file("$BasePath/krb5.crypt")) {@unlink("$BasePath/krb5.crypt");}

            if (!@copy($tmp, "$BasePath/krb5.crypt")) {
                client_report(3, "[krb5.crypt]: {downloading} krb5.crypt {copy_failed}...");
                @unlink($tmp);
                return false;
            }

            @unlink($tmp);

        }else {


            if (!client_download_file("krb5.keytab", "$TmpDir/krb5.keytab")) {
                @unlink($tmp);
                client_report(3, "[krb5]: {downloading} krb5.keytab failed...");
                return false;
            }

            $md5New = md5_file("$TmpDir/krb5.keytab");
            hacluster_syslog("[krb5]: $TmpDir/krb5.keytab = $md5New");
            if ($md5New <> $HostMD5) {
                client_report(3, "[krb5]: {downloading} krb5.keytab {corrupted}...");
                @unlink("$TmpDir/krb5.keytab");
                return false;
            }

            if (is_file("$BasePath/krb5.keytab")) {
                @unlink("$BasePath/krb5.keytab");
            }
            if (!@copy("$TmpDir/krb5.keytab", "$BasePath/krb5.keytab")) {
                client_report(3, "[krb5]: {downloading} krb5.keytab {copy_failed}...");
                @unlink("$TmpDir/krb5.keytab");
                return false;
            }

            if (is_file("/etc/squid3/krb5.keytab")) {
                @unlink("/etc/squid3/krb5.keytab");
            }
            if (!@copy("$TmpDir/krb5.keytab", "/etc/squid3/krb5.keytab")) {
                client_report(3, "[krb5]: {downloading} krb5.keytab {copy_failed} /etc/squid3...");
                @unlink("$TmpDir/krb5.keytab");
                return false;
            }
            @file_put_contents("$BasePath/krb5.md5", $md5New);
            @unlink("$TmpDir/krb5.keytab");
        }

            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableActiveDirectoryFeature",1);
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("UseNativeKerberosAuth",1);
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("KerberosUsername",$HaClusterAD["KerberosUsername"]);
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("kerberosRealm",$HaClusterAD["kerberosRealm"]);
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("KerberosSPN",$HaClusterAD["KerberosSPN"]);
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("KerberosPassword",$HaClusterAD["KerberosPassword"]);
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("kerberosActiveDirectoryHost",$HaClusterAD["kerberosActiveDirectoryHost"]);


        if(isset($HaClusterAD["kerberosActiveDirectorySuffix"])){
            if(trim($HaClusterAD["kerberosActiveDirectorySuffix"])<>null){
                $GLOBALS["CLASS_SOCKETS"]->SET_INFO("kerberosActiveDirectorySuffix",$HaClusterAD["kerberosActiveDirectorySuffix"]);
            }
        }

        if(isset($HaClusterAD["kerberosActiveDirectory2Host"])){
            if(trim($HaClusterAD["kerberosActiveDirectory2Host"])<>null){
                $GLOBALS["CLASS_SOCKETS"]->SET_INFO("kerberosActiveDirectory2Host",$HaClusterAD["kerberosActiveDirectory2Host"]);
            }
        }else{
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("kerberosActiveDirectory2Host","");
        }

        $size=filesize("/etc/squid3/krb5.keytab");

        hacluster_syslog("[KEYTAB]: Link server to Active Directory (Kerb5.keytab: {$size}Bytes)...");
        system("$php /usr/share/artica-postfix/exec.keytab.php --install --hacluster");
        $EXEC_KEYTAB_ERROR=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EXEC_KEYTAB_ERROR"));

        if($EXEC_KEYTAB_ERROR==1){
            hacluster_syslog("[KEYTAB]: Link server to Active Directory failed...");
            client_report(4,$GLOBALS["CLASS_SOCKETS"]->GET_INFO("EXEC_KEYTAB_ERROR_TEXT"));
            return;
        }
        hacluster_syslog("[KEYTAB]: Link server to Active Directory success...");
        client_report(4,"{success} Active Directory connection");
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("HaClusterADMD5",md5($HaClusterADContent));


    }



    if(!client_setup_transparent_mode()){
        client_report(3,"[SETUP]: {setup} {failed} Transparent port return failed");
        return;
    }



    if($HaClusterProxyPort==0){
        client_report(3,"[SETUP]: {setup} {failed} unable to get my port");
        return;

    }

    $q=new lib_sqlite("/home/artica/SQLITE/proxy.db");
    $zMD5=md5($HaClusterProxyPort);

    hacluster_syslog("[SETUP]: Checking proxy port....$HaClusterProxyPort");
    $RECONF=false;
    $results=$q->mysqli_fetch_array("SELECT ID,port FROM proxy_ports WHERE ProxyProtocol=1 AND NoAuth=0");
    foreach ($results as $index=>$ligne){
        $ID=$ligne["ID"];
        $port=$ligne["port"];
        if($port==$HaClusterProxyPort){continue;}
        $q->QUERY_SQL("DELETE FROM proxy_ports WHERE ID=$ID");
        $RECONF=true;
    }


    $ligne=$q->mysqli_fetch_array("SELECT ID FROM proxy_ports WHERE port=$HaClusterProxyPort and ProxyProtocol=1");
    $ID=intval($ligne["ID"]);


    if($ID==0){
        $RECONF=true;
        hacluster_syslog("[SETUP]: Adding proxy port....$HaClusterProxyPort");
        $xnote="Added by LB on ".date("Y-m-d H:i:s");
            $sqladd="INSERT INTO proxy_ports (WANPROXY_PORT,WANPROXY,FTP,ICP,Parent,WCCP,is_nat,nic,ipaddr,port,xnote,enabled,transparent,TProxy,outgoing_addr,PortName,UseSSL,sslcertificate,NoAuth,MIKROTIK_PORT,FTP_TRANSPARENT,SOCKS,ProxyProtocol,NoCache,NoFilter,zMD5,AuthForced,AuthPort,NoHotspot)
                VALUES ('0','0','0','0','0','0','0','','','$HaClusterProxyPort','$xnote','1','0','0','','Port for the load-balancer','0','',0,'0','0','0','1',0,0,'$zMD5',0,0,0)";

        $q->QUERY_SQL("$sqladd");


   }

   if($RECONF){
       if(is_file("/etc/init.d/squid")) {
           hacluster_syslog("[SETUP]: Reconfiguring proxy server");
           system("$php /usr/share/artica-postfix/exec.squid.global.access.php --ports --firehol");
       }
   }




    if(!is_file("/etc/init.d/squid")){
        hacluster_syslog("[SETUP]: Installing Proxy service...");
        squid_admin_mysql(1,"Installing Proxy service by Load-balancer",null,__FILE__,__LINE__);
        shell_exec("$php /usr/share/artica-postfix/exec.squid.disable.php --install");
    }

    if(is_file("/etc/init.d/cache-tail")){
        shell_exec("/etc/init.d/cache-tail restart");
    }

    hacluster_syslog("[SETUP]: Reconfiguring proxy service");
    shell_exec("$php /usr/share/artica-postfix/exec.squid.global.access.php --auth");
    client_logging();


    hacluster_syslog("[SETUP]: Report, {success}: ready for production mode");

    client_report(100,"OK");

}
function client_logging(){
    $HaClusterIP=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterIP");

    if(preg_match("#https:\/\/(.+?):#",$HaClusterIP,$re)){
        $HaClusterIP=$re[1];
    }

    $f[]="local5.info action(type=\"omfwd\" target=\"$HaClusterIP\" port=\"514\" protocol=\"udp\")\n";
    @file_put_contents("/etc/rsyslog.d/ha-cluster-client.conf",@implode("\n",$f));
    system("/etc/init.d/rsyslog restart");
    $unix=new unix();
    if(!is_logging_configured()) {
        $php = $unix->LOCATE_PHP5_BIN();
        shell_exec("$php /usr/share/artica-postfix/exec.squid.global.access.php --logging");
    }
}

function is_logging_configured(){
    $f=explode("\n",@file_get_contents("/etc/squid3/logging.conf"));
    foreach ($f as $line){
        if(preg_match("#access_log\s+syslog:local5#",$line)){return true;}
    }

    return false;
}