<?php
include_once(dirname(__FILE__)."/ressources/class.sqlite.inc");

if(is_file("/home/artica/SQLITE_TEMP/inodes.db")){@unlink("/home/artica/SQLITE_TEMP/inodes.db");}
$lib=new lib_sqlite("/home/artica/SQLITE_TEMP/inodes.db");
$sql="CREATE TABLE IF NOT EXISTS `inodes` ( `path` TEXT PRIMARY KEY,`inodes` integer)";
$lib->QUERY_SQL($sql);
$lib->QUERY_SQL("DELETE FROM inodes");

build_progress(6,"{scanning} {disk}");
$dirs=expandDirectories("/");
$MaxCount=count($dirs);

$c=0;
foreach ($dirs as $directory){
    if($directory=="/proc"){continue;}
    if($directory=="/sys"){continue;}
    if(strpos($directory,'*')>0){continue;}
    $res=array();
    $c++;
    $reste=$MaxCount-$c;
    $prc=$c/$MaxCount;
    $prc=round($prc*100);
    $dircount=0;
    if($prc>6) {
        build_progress($prc, "$reste {scanning} $directory");
    }else{
        build_progress(6, "$reste {scanning} $directory ({$prc}%)");
    }

    exec("/usr/bin/du --max-dep=1 --inodes $directory 2>&1",$res);

    foreach ($res as $line){
        $line=trim($line);
        if($line==null){continue;}
        if(preg_match("#^([0-9]+)\s+#",$line,$re)){$dircount=$dircount+intval($re[1]);}
        if($dircount<20){continue;}
    }
    $lib->QUERY_SQL("INSERT INTO inodes (path,inodes) VALUES ('$directory','$dircount')");




}

build_progress(100,"{done}");

function build_progress($pourc, $text){
    $cachefile = "/usr/share/artica-postfix/ressources/logs/web/inodes.progress";
    $array["POURC"] = $pourc;
    $array["TEXT"] = $text;
    @file_put_contents($cachefile, serialize($array));
    @chmod($cachefile, 0755);
}

function expandDirectories($base_dir) {
    $directories = array();
    foreach(scandir($base_dir) as $file) {
        if($file == '.' || $file == '..') continue;
        $dir = $base_dir.DIRECTORY_SEPARATOR.$file;
        $dir=str_replace("//","/",$dir);
        if($dir=="/proc"){continue;}
        if($dir=="/sys"){continue;}
        if($dir=="/sys/block"){continue;}
        if($dir=="/sys/bus"){continue;}
        if($dir=="/sys/class"){continue;}
        if($dir=="/sys/devices"){continue;}
        if($dir=="/sys/kernel"){continue;}
        if(strpos($dir,'*')>0){continue;}
        if(is_link($dir)){continue;}

        if(is_dir($dir)) {
            $directories []= $dir;
            $directories = array_merge($directories, expandDirectories($dir));
        }
    }
    return $directories;
}