#!/usr/bin/php
<?php
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');

$unix=new unix();
$SourceIPaddr=$argv[1];
$Queueid=$argv[2];
$Sender=$argv[3];
$MessageContent=null;
$sdate=time();

$fd = fopen("php://stdin", "r");

while (!feof($fd)) {
    $line = fread($fd,2048);
    $MessageContent=$MessageContent.$line;


}

$MessageContentSize=strlen($MessageContent);


$q=new lib_sqlite("/home/mail2sms/SQLITE/database.db");
$sql="CREATE TABLE IF NOT EXISTS `messages` (
			 `ID` INTEGER PRIMARY KEY AUTOINCREMENT,`sdate` INTEGER,parsedate INTEGER,
			  `ipaddr` TEXT,`queueid` TEXT UNIQUE,retried INTEGER,phonenum TEXT,smtpfrom TEXT,
              `message` TEXT,`status` INTEGER,`error` TEXT,finaltext TEXT)";

$q->QUERY_SQL($sql);
if(!$q->ok){
    MailSyslog("$Queueid: reject: RCPT from unknown[$SourceIPaddr]: 554 4.5.1 <unknwon[$SourceIPaddr]>: SQL Error $q->mysql_error from=<$Sender> to=<mail2sms> proto=pipe");
    fclose($fd);
    die(1);
}
$MessageEncoded=base64_encode($MessageContent);
$q->QUERY_SQL("INSERT INTO messages (sdate,ipaddr,queueid,message,status,retried,smtpfrom) 
VALUES ('$sdate','$SourceIPaddr','$Queueid','$MessageEncoded',0,0,'$Sender')");

if(!$q->ok){
    MailSyslog("$Queueid: reject: RCPT from unknown[$SourceIPaddr]: 554 4.5.1 <unknwon[$SourceIPaddr]>: SQL Error $q->mysql_error from=<$Sender> to=<mail2sms> proto=pipe");
    echo "4.5.1 Failed $Queueid";
    fclose($fd);
    exit(1);
}

MailSyslog("$Queueid: from=<$Sender>, size=$MessageContentSize, nrcpt=1 (queue active)");
echo "2.5.0 OK Queued as $Queueid";
shell_exec("/usr/bin/php /usr/share/artica-postfix/exec.mail2sms.parse.php 2>&1 &");

exit(0);

fclose($fd);


function MailSyslog($text){

    if(function_exists("openlog")){openlog("postfix/mail2sms", LOG_PID , LOG_MAIL);}
    if(function_exists("syslog")){ syslog(LOG_INFO, $text);}
    if(function_exists("closelog")){closelog();}
}
