<?php
//http://ftp.linux.org.tr/slackware/slackware_source/n/network-scripts/scripts/netconfig
if(preg_match("#--verbose#",implode(" ",$argv))){
	$GLOBALS["VERBOSE"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);
}
include_once(dirname(__FILE__).'/ressources/class.ldap.inc');
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.settings.inc');
include_once(dirname(__FILE__)."/ressources/class.resolv.conf.inc");
include_once(dirname(__FILE__)."/ressources/class.system.network.inc");
include_once(dirname(__FILE__)."/ressources/class.system.nics.inc");
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__)."/framework/frame.class.inc");
include_once(dirname(__FILE__)."/ressources/class.os.system.inc");
include_once(dirname(__FILE__)."/ressources/class.tcpip.inc");
include_once(dirname(__FILE__)."/ressources/class.webconsole.params.inc");

if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}


if($argv[1]=="--sslon"){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ArticaHttpUseSSL",1);ReplicWebValues();exit;}
if($argv[1]=="--ssloff"){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ArticaHttpUseSSL",0);ReplicWebValues();exit;}


if($argv[1]=="--SuperAdmin"){SuperAdmin();exit;}
if($argv[1]=="--menu"){menu();exit;}
if($argv[1]=="--restart"){restart($argv[2]);exit;}
if($argv[1]=="--savenic"){savenic($argv[2]);exit;}
if($argv[1]=="--savedns"){savedns();exit;}
if($argv[1]=="--reconfigure"){reconfigure();exit;}
if($argv[1]=="--uuid"){new_uuid();exit;}
if($argv[1]=="--reset"){ApacheReset();exit;}
if($argv[1]=="--chport"){nginx_chport();exit;}

//exec.menu.apache.php --menu -  /tmp/bash_apache_menu.sh
$unix=new unix();
$NETWORK_ALL_INTERFACES=$unix->NETWORK_ALL_INTERFACES();


echo "Open you web browser and type:\\n";

while (list ($interface, $line) = each ($NETWORK_ALL_INTERFACES) ){
	if($interface=="lo"){continue;}
	echo "https://{$line["IPADDR"]}:9000\\n";
	
	
}

echo "\n";

function ReplicWebValues(){

    $SocksWeb=new SocksWeb();
    $SocksWeb->ReplicParams();
}

function restart(){
	
	system("/etc/init.d/artica-process1 start --force");
	system("/etc/init.d/artica-webconsole restart --force");
	if(is_file("/etc/init.d/artica-framework")){system("/etc/init.d/artica-framework restart --force");}
	system("/etc/init.d/artica-status restart --force");
	echo "###################################################\n";
	echo "############                          #############\n";
	echo "############         SUCCESS          #############\n";
	echo "############                          #############\n";
	echo "###################################################\n\n\n\n";
}



function ApacheReset(){
	$unix       = new unix();
	$php        = $unix->LOCATE_PHP5_BIN();
    $q          = new lib_sqlite("/home/artica/SQLITE/webconsole.db");

    echo "Remove Security settings\n";

    $q->QUERY_SQL("DELETE FROM ngx_stream_access_module");

	shell_exec("$php /usr/share/artica-postfix/exec.firewall.php --build");
	shell_exec("$php /usr/share/artica-postfix/exec.firewall.php --remove");
	
	$f[]="LighttpdArticaListenIP";
	$f[]="EnableArticaWebLogging";
	$f[]="LighttpdArticaCertificateName";
	$f[]="SSLCipherSuite";
	
	foreach ($f as $filename){
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("$filename","");
		@unlink("/etc/artica-postfix/settings/Daemons/$filename");
		@touch("/etc/artica-postfix/settings/Daemons/$filename");
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("$filename",null);
	}


	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ArticaHttpUseSSL",1);
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ArticaHttpsPort",9000);
	@unlink("/etc/ssl/certs/apache/server.crt");
	@unlink("/etc/ssl/certs/apache/server.key");
    ReplicWebValues();
	system("/etc/init.d/artica-webconsole restart --force");
	
	echo "Done\n";
}
function SuperAdmin(){
    $POSTED["change_admin"]=@file_get_contents("/etc/artica-postfix/WIZARUSERNAME");
    $POSTED["change_password"]=@file_get_contents("/etc/artica-postfix/WIZARUSERNAMEPASSWORD");
    @mkdir("/usr/share/artica-postfix/ressources/conf/upload",0755,true);
    @file_put_contents("/usr/share/artica-postfix/ressources/conf/upload/ChangeLDPSSET", base64_encode(serialize($POSTED)));
    @unlink("/etc/artica-postfix/WIZARUSERNAME");
    @unlink("/etc/artica-postfix/WIZARUSERNAMEPASSWORD");

}

function new_uuid(){
	$unix=new unix();
	$chattr=$unix->find_program("chattr");
	echo "Old uuid:".$GLOBALS["CLASS_SOCKETS"]->GET_INFO("SYSTEMID")."\n";
	shell_exec("$chattr -i /etc/artica-postfix/settings/Daemons/SYSTEMID");
	$uuid=trim($unix->gen_uuid());
	echo "New uuid: $uuid\n";

	if(strlen($uuid)>5){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SYSTEMID", $uuid);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SYSTEMID_CREATED", time());
		@chmod("/etc/artica-postfix/settings/Daemons/SYSTEMID", 0777);
		shell_exec("$chattr +i /etc/artica-postfix/settings/Daemons/SYSTEMID");

	}
	echo "\nSuccess\n\n";
	
	

}

function nginx_chport(){

    $port=intval(@file_get_contents("/etc/artica-postfix/NEWINTEFACEPORT"));
    if($port==0){
        exit;
    }

    $ArticaHttpsPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ArticaHttpsPort"));

    echo "Change port $ArticaHttpsPort to $port\n";
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("ArticaHttpsPort",$port);
    ReplicWebValues();

}


function menu(){
$ARTICAVERSION=@file_get_contents("/usr/share/artica-postfix/VERSION");
$unix=new unix();
$HOSTNAME=$unix->hostname_g();
$DIALOG=$unix->find_program("dialog");	
$php=$unix->LOCATE_PHP5_BIN();



$f=explode("\n",@file_get_contents("/etc/resolv.conf"));


foreach ($f as $gpid=>$val){
	if(preg_match("#^nameserver\s+(.+)#", $val,$re)){
		$DNS[]=$re[1];
		if(count($DNS)>1){break;}
	}

}
    $ArticaHttpsPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ArticaHttpsPort"));
    $ArticaHttpUseSSL=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ArticaHttpUseSSL"));
    if($ArticaHttpsPort==0){$ArticaHttpsPort=9000;}

$diag[]="$DIALOG --clear  --nocancel --backtitle \"Software version $ARTICAVERSION on $HOSTNAME\"";
$diag[]="--title \"[ W E B  I N T E R F A C E  M E N U ]\"";
$diag[]="--menu \"You can use the UP/DOWN arrow keys\nChoose the TASK\" 20 100 10";
$NETWORK_ALL_INTERFACES=$unix->NETWORK_ALL_INTERFACES();


$tt=explode("\n", @file_get_contents("/proc/net/dev"));


$diag[]="RESTART \"Restart Web Console service\"";
$diag[]="CERT \"SSL Certificate\"";


if(is_file("/usr/sbin/unitd")){
	$UseUnitd=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UseUnitd"));
	if($UseUnitd==0){
		$diag[]="iUNITD \"Install unitd\"";
	}else{
		$diag[]="rUNITD \"Remove unitd and back to PHP-FPM\"";
	}
}

$diag[]="ERRORS \"Display error events\"";
$diag[]="MANAGER \"Change SuperAdmin credentials\"";
$diag[]="INTERFACE \"Change listen Interface\"";
$diag[]="PORT \"Change listen Port (current $ArticaHttpsPort)\"";
if($ArticaHttpUseSSL==1) {
    $diag[] = "SSLOFF \"Disable SSL\"";
}else{
    $diag[] = "SSLON \"Enable SSL\"";
}

$diag[]="RESET \"Reset to default settings\"";

$diag[]="Quit \"Return to main menu\" 2>\"\${INPUT}\"";

$f[]="#!/bin/bash";
$f[]="INPUT=/tmp/menu.sh.$$";
$f[]="OUTPUT=/tmp/output.sh.$$";
$f[]="trap \"rm -f \$OUTPUT; rm -f \$INPUT; exit\" SIGHUP SIGINT SIGTERM";
$f[]="DIALOG=\${DIALOG=dialog}";

$f[]="function sslon(){";
    $f[]="$php ".__FILE__." --sslon";
    $f[]="$php /usr/share/artica-postfix/exec.menu.apache.certificate.php --menu >/dev/null";
    $f[]="echo 10 | /usr/bin/dialog --gauge \"Web console SSL ON\" 10 70 0";
    $f[]="/etc/init.d/artica-webconsole restart >/dev/null 2>&1";
    $f[]="echo 50 | /usr/bin/dialog --gauge \"Web console SSL ON\" 10 70 0";
    $f[]="/etc/init.d/artica-webconsole stop >/dev/null 2>&1";
    $f[]="echo 60 | /usr/bin/dialog --gauge \"Web console SSL ON\" 10 70 0";
    $f[]="/etc/init.d/artica-webconsole stop >/dev/null 2>&1";
    $f[]="echo 70 | /usr/bin/dialog --gauge \"Web console SSL ON\" 10 70 0";
    $f[]="/etc/init.d/artica-webconsole start >/dev/null 2>&1";
    $f[]="echo 95 | /usr/bin/dialog --gauge \"Web console SSL ON (success)\" 10 70 0";
    $f[]="$php /usr/share/artica-postfix/exec.menu.apache.certificate.php --menu >/dev/null";
    $f[]="$php ".__FILE__." --menu";
    $f[]="echo 100 | /usr/bin/dialog --gauge \"Web console SSL ON (success)\" 10 70 0";
    $f[]="/tmp/bash_apache_menu.sh";
    $f[]="exit";
    $f[]="}";
    $f[]="function memon(){";
    $f[]="echo 10 | /usr/bin/dialog --gauge \"Web console Use memcache\" 10 70 0";
    $f[]="$php ".__FILE__." --memon";
    $f[]="sleep 2";
    $f[]="echo 50 | /usr/bin/dialog --gauge \"Web console Use Memcache\" 10 70 0";
    $f[]="$php /usr/share/artica-postfix/exec.php.ini.php >/dev/null";
    $f[]="echo 60 | /usr/bin/dialog --gauge \"Web console Use memcache\" 10 70 0";
    $f[]="$php /usr/share/artica-postfix/exec.menu.apache.certificate.php --menu >/dev/null";
    $f[]="echo 70 | /usr/bin/dialog --gauge \"Web console Use memcache\" 10 70 0";
    $f[]="/etc/init.d/artica-webconsole restart >/dev/null 2>&1";
    $f[]="echo 90 | /usr/bin/dialog --gauge \"Web console Memcache ON (success)\" 10 70 0";
    $f[]="$php /usr/share/artica-postfix/exec.menu.apache.certificate.php --menu >/dev/null";
    $f[]="$php ".__FILE__." --menu";
    $f[]="echo 100 | /usr/bin/dialog --gauge \"Web console Memcache ON (success)\" 10 70 0";
    $f[]="/tmp/bash_apache_menu.sh";
    $f[]="exit";
    $f[]="}";
    $f[]="function memoff(){";
    $f[]="echo 10 | /usr/bin/dialog --gauge \"Web console disable memcache\" 10 70 0";
    $f[]="$php ".__FILE__." --memoff";
    $f[]="sleep 2";
    $f[]="echo 50 | /usr/bin/dialog --gauge \"Web console disable Memcache\" 10 70 0";
    $f[]="/etc/init.d/artica-webconsole restart >/dev/null 2>&1";
    $f[]="echo 60 | /usr/bin/dialog --gauge \"Web console disable memcache\" 10 70 0";
    $f[]="$php /usr/share/artica-postfix/exec.menu.apache.certificate.php --menu >/dev/null";
    $f[]="echo 90 | /usr/bin/dialog --gauge \"Web console Memcache OFF (success)\" 10 70 0";

    $f[]="echo 100 | /usr/bin/dialog --gauge \"Web console Memcache OFF (success)\" 10 70 0";
    $f[]="/tmp/bash_apache_menu.sh";
    $f[]="exit 0";
    $f[]="}";

    $f[]="function ssloff(){";
    $f[]="$php ".__FILE__." --ssloff";
    $f[]="$php /usr/share/artica-postfix/exec.menu.apache.certificate.php --menu >/dev/null";
    $f[]="echo 10 | /usr/bin/dialog --gauge \"Web console SSL OFF\" 10 70 0";
    $f[]="/etc/init.d/artica-webconsole restart >/dev/null 2>&1";
    $f[]="echo 50 | /usr/bin/dialog --gauge \"Web console SSL OFF\" 10 70 0";
    $f[]="/etc/init.d/artica-webconsole stop >/dev/null 2>&1";
    $f[]="echo 60 | /usr/bin/dialog --gauge \"Web console SSL OFF\" 10 70 0";
    $f[]="/etc/init.d/artica-webconsole stop >/dev/null 2>&1";
    $f[]="echo 70 | /usr/bin/dialog --gauge \"Web console SSL OFF\" 10 70 0";
    $f[]="/etc/init.d/artica-webconsole start >/dev/null 2>&1";
    $f[]="echo 95 | /usr/bin/dialog --gauge \"Web console SSL OFF\" 10 70 0";
    $f[]="$php /usr/share/artica-postfix/exec.menu.apache.certificate.php --menu >/dev/null";
    $f[]="echo 100 | /usr/bin/dialog --gauge \"Web console SSL OFF (success)\" 10 70 0";
    $f[]="/tmp/bash_apache_menu.sh";
    $f[]="exit 0";
    $f[]="}";

$f[]="function chport(){";
    $f[]="\t$DIALOG --clear --title \"ENTER THE PORT FOR THE WEB CONSOLE\" --inputbox \"Enter the listen port\" 10 68 $ArticaHttpsPort 2>/etc/artica-postfix/NEWINTEFACEPORT";
    $f[]="\tif [ $? = 1 -o $? = 255 ]; then";
    $f[]="\t\trm -f /etc/artica-postfix/NEWINTEFACEPORT";
    $f[]="\t\treturn";
    $f[]="\tfi";
    $f[]="\tphp ".__FILE__." --chport";
    $f[]="port=`cat /etc/artica-postfix/NEWINTEFACEPORT`";
    $f[]="echo 10 | /usr/bin/dialog --gauge \"Web console on port \$port\" 10 70 0";
    $f[]="/etc/init.d/artica-webconsole restart >/dev/null 2>&1";
    $f[]="echo 50 | /usr/bin/dialog --gauge \"Web console on port \$port (stopping)\" 10 70 0";
    $f[]="/etc/init.d/artica-webconsole stop >/dev/null 2>&1";
    $f[]="echo 60 | /usr/bin/dialog --gauge \"Web console on port \$port (stopping)\" 10 70 0";
    $f[]="/etc/init.d/artica-webconsole stop >/dev/null 2>&1";
    $f[]="echo 70 | /usr/bin/dialog --gauge \"Web console on port \$port (starting)\" 10 70 0";
    $f[]="/etc/init.d/artica-webconsole start >/dev/null 2>&1";
    $f[]="if [ -f \"/etc/init.d/firehol\" ]";
    $f[]="then";
    $f[]="  echo 80 | /usr/bin/dialog --gauge \"Web console on port \$port (restarting firewall)\" 10 70 0";
    $f[]="  /etc/init.d/firehol restart";
    $f[]="fi";
    $f[]="echo 95 | /usr/bin/dialog --gauge \"Web console on port \$port (success)\" 10 70 0";
    $f[]="$php /usr/share/artica-postfix/exec.menu.apache.certificate.php --menu >/dev/null";
    $f[]="echo 100 | /usr/bin/dialog --gauge \"Web console on port \$port (success)\" 10 70 0";
    $f[]="/tmp/bash_apache_menu.sh";
    $f[]="exit";
$f[]="}";

    $f[]="";
    $f[]="function SuperAdmin(){";
    $f[]="\tif [ -f /tmp/dns.log ]; then";
    $f[]="\t\trm /tmp/dns.log";
    $f[]="\tfi";
    $Manager=trim(@file_get_contents("/etc/artica-postfix/ldap_settings/admin"));
    $f[]="\t$DIALOG --clear --title \"Username\" --inputbox \"Enter the SuperAdmin username\" 10 68 $Manager 2> /etc/artica-postfix/WIZARUSERNAME";

    $f[]="\tcase $? in";
    $f[]="\t\t1)";
    $f[]="\t\trm /etc/artica-postfix/WIZARUSERNAME || true";
    $f[]="\t\treturn";
    $f[]="\tesac";
    $f[]="WIZARUSERNAME = `cat /etc/artica-postfix/WIZARUSERNAME`";

    $password=trim(@file_get_contents("/etc/artica-postfix/ldap_settings/password"));

    $f[]="\t$DIALOG --clear --insecure --passwordbox \"ENTER SuperAdmin Password for authentication\"  10 68 \"$password\" 2> /etc/artica-postfix/WIZARUSERNAMEPASSWORD";
    $f[]="\tcase $? in";
    $f[]="\t\t1)";
    $f[]="\t\trm /etc/artica-postfix/WIZARUSERNAME || true";
    $f[]="\t\trm /etc/artica-postfix/WIZARUSERNAMEPASSWORD || true";
    $f[]="\t\treturn";
    $f[]="\tesac";
    $f[]="\t$DIALOG --title \"Change SuperAdmin Account\" --yesno \"Do you need to perform this operation ? Press 'Yes' to continue, or 'No' to exit\" 0 0";
    $f[]="\tcase $? in";
    $f[]="\t\t0)";
    $f[]="echo \"10\"|$DIALOG --title \"Change Account\" --gauge \"reconfigure\" 6 80";
    $f[]="\t$php ".__FILE__." --SuperAdmin >/dev/null 2>&1";
    $f[]="echo \"50\"|$DIALOG --title \"Change Account\" --gauge \"reconfigure\" 6 80";
    $f[]="\t$php /usr/share/artica-postfix/exec.artica.account.progress.php --console";
    $f[]="echo \"100\"|$DIALOG --title \"Change Account\" --gauge \"success\" 6 80";
    $f[]="sleep 2";
    $f[]="\t\treturn;;";
    $f[]="\t1)";
    $f[]="\t\trm /etc/artica-postfix/WIZARUSERNAME";
    $f[]="\t\trm /etc/artica-postfix/WIZARUSERNAMEPASSWORD";
    $f[]="\t\treturn;;";
    $f[]="\t255)";
    $f[]="\t\trm /etc/artica-postfix/WIZARUSERNAME";
    $f[]="\t\trm /etc/artica-postfix/WIZARUSERNAMEPASSWORD";
    $f[]="\t\treturn;;";
    $f[]="\tesac";
    $f[]="}";
    $f[]="";
    $f[]="";


$f[]="function ERRORS(){";
$f[]="\t$DIALOG --textbox /var/log/lighttpd/apache-error.log  25 150";	
$f[]="}";

$f[]="function CERT(){";
$f[]="\t$php /usr/share/artica-postfix/exec.menu.apache.certificate.php --menu";
$f[]="\t/tmp/bash_apache_certificate_menu.sh";
$f[]="\texit 0";
$f[]="}";

$f[]="function iUNITD(){";
$f[]="\t$php /usr/share/artica-postfix/exec.unitd.php --install";
$f[]="\t$php /usr/share/artica-postfix/exec.menu.apache.php --menu";
$f[]="\t/tmp/bash_apache_menu.sh";
$f[]="\texit 0";
$f[]="}";

$f[]="function zINTERFACE(){";
$diagz[]="$DIALOG --title \"Network Interface For Artica Web console\"";
$diagz[]="--radiolist \"Select Interface\" 15 60 4";
$LighttpdArticaListenInterface=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LighttpdArticaListenInterface"));
$ff=explode("\n",@file_get_contents("/proc/net/dev"));
foreach ($ff as $line){
	$line=trim($line);
	if($line==null){continue;}
	$ON="OFF";
	if(!preg_match("#^(.+?):\s+#", $line,$re)){continue;}
	$Interface=trim($re[1]);
	if($Interface==$LighttpdArticaListenInterface){$ON="ON";}
	$diagz[]="\"$Interface\" \"Interface $Interface\" $ON";
}
$ON="OFF";
if($LighttpdArticaListenInterface==null){$ON="ON";}
$diagz[]="\"\" \"ALL\" $ON";
$diagz[]="2> /etc/artica-postfix/settings/Daemons/LighttpdArticaListenInterface";
$f[]=@implode(" ", $diagz);
$f[]="\tif [ $? = 1 -o $? = 255 ]; then";
$f[]="\t\t/tmp/bash_apache_menu.sh";
$f[]="\t\texit";
$f[]="\tfi";
$f[]="\t$php /usr/share/artica-postfix/exec.lighttpd.php --restart||true";
$f[]="\t$php ".__FILE__." --menu >/dev/null";
$f[]="\t/tmp/bash_apache_menu.sh";
$f[]="exit";


$f[]="}";

$f[]="";
$f[]="";
$f[]="function reconfigure_network(){";
$f[]="\tif [ -f /tmp/dns.log ]; then";
$f[]="\t\trm /tmp/dns.log";
$f[]="\tfi";
$f[]="\t$php ".__FILE__." --reconfigure >/tmp/dns.log &";
$f[]="\t$DIALOG --tailbox /tmp/dns.log  25 150";
$f[]="}";
$f[]="";
$f[]="";
$f[]="function restart(){";
$f[]="\t/etc/init.d/artica-webconsole restart --force";
$f[]="}";
$f[]="function reset(){";
$f[]="\t$DIALOG --title \"Reset Webconsole settings\" --yesno \"Warning, this operation will remove all settings and back to defaults.\\nDo you need to perform this operation ? Press 'Yes' to continue, or 'No' to exit\" 0 0";
$f[]="\tcase $? in";
$f[]="\t\t0)";
$f[]="\tif [ -f /tmp/dns.log ]; then";
$f[]="\t\trm /tmp/dns.log";
$f[]="\tfi";
$f[]="\t$php ".__FILE__." --reset >/tmp/dns.log &";
$f[]="\t$DIALOG --tailbox /tmp/dns.log  25 150";
$f[]="\t\treturn;;";
$f[]="\t1)";
$f[]="\t\treturn;;";
$f[]="\t255)";
$f[]="\t\treturn;;";
$f[]="\tesac";
$f[]="}";
$f[]="";

$f[]="while true";
$f[]="do";
$f[]=@implode(" ", $diag);
$f[]="menuitem=$(<\"\${INPUT}\")";
$f[]="case \$menuitem in";
$f[]="MANAGER) SuperAdmin;;";
$f[]="SSLOFF) ssloff;;";
$f[]="SSLON) sslon;;";
$f[]="MEMOFF) memoff;;";
$f[]="MEMON) memon;;";
$f[]="PORT) chport;;";
$f[]="RESTART) restart;;";
$f[]="RESET) reset;;";
$f[]="ERRORS) ERRORS;;";
$f[]="CERT) CERT;;";
$f[]="iUNITD) iUNITD;;";
$f[]="rUNITD) rUNITD;;";
$f[]="INTERFACE) zINTERFACE;;";


$f[]="Quit) break;;";
$f[]="esac";
$f[]="done\n";

if($GLOBALS["VERBOSE"]){echo "Writing /tmp/bash_apache_menu.sh\n";}
@file_put_contents("/tmp/bash_apache_menu.sh", @implode("\n",$f));
@chmod("/tmp/bash_apache_menu.sh",0755);
	
}

function interface_menu($eth){
	$ARTICAVERSION=@file_get_contents("/usr/share/artica-postfix/VERSION");
	$unix=new unix();
	$HOSTNAME=$unix->hostname_g();
	$DIALOG=$unix->find_program("dialog");
	$php=$unix->LOCATE_PHP5_BIN();	
	$NETWORK_ALL_INTERFACES=$unix->NETWORK_ALL_INTERFACES();
	$DEFAULT=$NETWORK_ALL_INTERFACES[$eth]["IPADDR"];
	$NETMASK=$NETWORK_ALL_INTERFACES[$eth]["NETMASK"];
	$GATEWAY=$NETWORK_ALL_INTERFACES[$eth]["GATEWAY"];
	
	$f[]="#!/bin/bash";
	$f[]="INPUT=/tmp/menu.sh.$$";
	$f[]="OUTPUT=/tmp/output.sh.$$";
	$f[]="trap \"rm -f \$OUTPUT; rm -f \$INPUT; exit\" SIGHUP SIGINT SIGTERM";
	$f[]="DIALOG=\${DIALOG=dialog}";	
	@unlink("/etc/artica-postfix/WIZARDIP_$eth");
	@unlink("/etc/artica-postfix/WIZARDMASK_$eth");
	$f[]="$DIALOG --clear --title \"ENTER IP ADDRESS FOR '$eth'\" --inputbox \"Enter your IP address for the $eth Interface.\\nExample: 111.112.113.114\" 10 68 $DEFAULT 2> /etc/artica-postfix/WIZARDIP_$eth";
	
	$f[]="if [ $? = 1 -o $? = 255 ]; then";
	$f[]="rm -f /etc/artica-postfix/WIZARDIP_$eth";
	$f[]="\treturn";
	$f[]="fi";
	
	
	$f[]="$DIALOG --clear --title \"ENTER IP ADDRESS FOR '$eth'\" --inputbox \"Enter your netmask for the $eth Interface.\\nExample: 255.255.255.0\" 10 68 $NETMASK 2> /etc/artica-postfix/WIZARDMASK_$eth";
	$f[]="if [ $? = 1 -o $? = 255 ]; then";
	$f[]="rm -f /etc/artica-postfix/WIZARDMASK_$eth";
	$f[]="\treturn";
	$f[]="fi";
	
	$f[]="$DIALOG --clear --title \"ENTER IP ADDRESS FOR '$eth'\" --inputbox \"Enter your gateway for the $eth Interface.\\nExample: 111.112.113.114\\nIf this interface is the main gateway of your network, set 0.0.0.0 here\" 10 68 $GATEWAY 2> /etc/artica-postfix/WIZARDGATEWAY_$eth";
	$f[]="if [ $? = 1 -o $? = 255 ]; then";
	$f[]="rm -f /etc/artica-postfix/WIZARDGATEWAY_$eth";
	$f[]="\treturn";
	$f[]="fi";	
	
	$f[]="WIZARDIP=`cat /etc/artica-postfix/WIZARDIP_$eth`";
	$f[]="WIZARDMASK=`cat /etc/artica-postfix/WIZARDMASK_$eth`";
	$f[]="WIZARDGATEWAY=`cat /etc/artica-postfix/WIZARDGATEWAY_$eth`";
	
	$f[]="$DIALOG --title \"NETWORK SETUP COMPLETE\" --yesno \"Your networking system is now configured to use:\\n\$WIZARDIP/\$WIZARDMASK Gateway \$WIZARDGATEWAY\\nIs this correct?  Press 'Yes' to continue, or 'No' to exit\" 0 0";
  	$f[]="case $? in";
  	$f[]="0)";
  	$f[]="\techo \"$php ".__FILE__." --savenic $eth\"";
    $f[]="\t$php ".__FILE__." --savenic $eth >/tmp/$eth.log &";
    $f[]="\t$DIALOG --tailbox /tmp/$eth.log  25 150"; 
    
    $f[]="\tWIZARDRESULTS=`cat /etc/artica-postfix/WIZARDRESULT_$eth`";
  	$f[]="\tif [ \"\$WIZARDRESULTS\" eq 0 ]; then";
  	$f[]="\t$DIALOG --title \"$eth failed\" --msgbox \"Sorry, An error has occured\" 9 70";
  	$f[]="\tfi";
    $f[]="\treturn;;";
	$f[]="1)";
   	$f[]="\treturn;;";
  	$f[]="255)";
  	$f[]="\treturn;;";
	$f[]="esac";
	
	
	$f[]="\n";
	@file_put_contents("/tmp/bash_network_menu_interface.sh", @implode("\n",$f));
	@chmod("/tmp/bash_network_menu_interface.sh",0755);
	
}

function savenic($NIC){
	$unix=new unix();
	$ipClass=new IP();
	$ETH_IP=trim(@file_get_contents("/etc/artica-postfix/WIZARDIP_$NIC"));
	$NETMASK=trim(@file_get_contents("/etc/artica-postfix/WIZARDMASK_$NIC"));
	$GATEWAY=trim(@file_get_contents("/etc/artica-postfix/WIZARDGATEWAY_$NIC"));
	
	if(!$ipClass->isIPAddress($ETH_IP)){
		echo "* * * * $ETH_IP * * * * WRONG !!!!\n";
		@file_put_contents("/etc/artica-postfix/WIZARDRESULT_$NIC", 0);
		return;
	}
	if(!$ipClass->isIPAddress($GATEWAY)){
		echo "* * * * $GATEWAY * * * * WRONG !!!!\n";
		@file_put_contents("/etc/artica-postfix/WIZARDRESULT_$NIC", 0);
		return;
	}	
	
	$nics=new system_nic($NIC);
	$nics->eth=$NIC;
	$nics->IPADDR=$ETH_IP;
	$nics->NETMASK=$NETMASK;
	$nics->GATEWAY=$GATEWAY;
	$nics->dhcp=0;
	$nics->metric=1;
	$nics->defaultroute=1;
	$nics->enabled=1;	
	
	if(!$nics->SaveNic()){
		echo "* * * * MYSQL ERROR !!! * * * * WRONG !!!!\n";
		@file_put_contents("/etc/artica-postfix/WIZARDRESULT_$NIC", 0);
		return;
	}
	
	$php=$unix->LOCATE_PHP5_BIN();
	$nohup=$unix->find_program("nohup");
	$php5=$php;
	system("$php5 ".dirname(__FILE__)." /exec.virtuals-ip.php --build --force >/dev/null 2>&1");
	echo "20%] Please Wait, apply network configuration....\n";
	system("/etc/init.d/artica-ifup start");
	echo "30%] Please Wait, restarting services....\n";
	
	$unix->THREAD_COMMAND_SET("$php5 /usr/share/artica-postfix/exec.postfix.maincf.php --reconfigure");
	$unix->THREAD_COMMAND_SET("/usr/share/artica-postfix/bin/artica-install --reconfigure-cyrus");
	system("$nohup /etc/init.d/artica-status reload >/dev/null 2>&1 &");
	system("$nohup /etc/init.d/nginx restart >/dev/null 2>&1 &");
	system("$nohup /etc/init.d/monit restart >/dev/null 2>&1 &");
	echo "30%] Please Wait, Changing IP address to $NIC....\n";
	$ifconfig=$unix->find_program("ifconfig");
	system("$ifconfig $NIC down");
		system("$ifconfig $NIC $ETH_IP netmask $NETMASK up");
		system("/bin/ip route add 127.0.0.1 dev lo");
		if($GATEWAY<>"0.0.0.0"){
		echo "31%] Please Wait, Define default gateway to $GATEWAY....\n";
		system("/sbin/route add $GATEWAY dev $NIC");
		$route=$unix->find_program("route");
		shell_exec("$route add -net 0.0.0.0 gw $GATEWAY dev $NIC metric 1");
		}
		echo "95%] Restarting Web Console\n";
		system("/etc/init.d/artica-webconsole restart");
		echo "100%] Configuration done.\n";
		@file_put_contents("/etc/artica-postfix/WIZARDRESULT_$NIC", 1);
	
		echo "###################################################\n";
		echo "############                          #############\n";
		echo "############         SUCCESS          #############\n";
		echo "############                          #############\n";
		echo "###################################################\n\n\n\n";
}

function savedns(){
	
	$DNS1=@file_get_contents("/etc/artica-postfix/WIZARDMASK_DNS1");
	$DNS2=@file_get_contents("/etc/artica-postfix/WIZARDMASK_DNS2");
	
	$resolv=new resolv_conf();
	echo "92%] Set DNS to $DNS1 - $DNS2\n";
	$resolv->MainArray["DNS1"]=$DNS1;
	$resolv->MainArray["DNS2"]=$DNS1;
	$resolv->output=true;
	echo "93%] Saving config\n";
	$resolvDatas=$resolv->build();
	echo "94%] Saving /etc/resolv.conf\n";
	@file_put_contents("/etc/resolv.conf", $resolvDatas);
	echo "###################################################\n";
	echo "############                          #############\n";
	echo "############         SUCCESS          #############\n";
	echo "############                          #############\n";
	echo "###################################################\n\n\n\n";
}

