<?php
//http://ftp.linux.org.tr/slackware/slackware_source/n/network-scripts/scripts/netconfig
if(preg_match("#--verbose#",implode(" ",$argv))){
	$GLOBALS["VERBOSE"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);
}
include_once(dirname(__FILE__).'/ressources/class.ldap.inc');
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.settings.inc');
include_once(dirname(__FILE__)."/ressources/class.resolv.conf.inc");
include_once(dirname(__FILE__)."/ressources/class.system.network.inc");
include_once(dirname(__FILE__)."/ressources/class.system.nics.inc");
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__)."/framework/frame.class.inc");
include_once(dirname(__FILE__)."/ressources/class.os.system.inc");
include_once(dirname(__FILE__)."/ressources/class.tcpip.inc");

if(!isset($argv[1])){$argv[1]=null;$argv[2]=null;}
if(!isset($argv[2])){$argv[2]=null;}

if($argv[1]=="--network-menu"){network_menu();exit;}
if($argv[1]=="--interface"){interface_menu($argv[2]);exit;}
if($argv[1]=="--savenic"){savenic($argv[2]);exit;}
if($argv[1]=="--savedns"){savedns();exit;}
if($argv[1]=="--reconfigure"){reconfigure();exit;}
if($argv[1]=="--uuid"){new_uuid();exit;}
if($argv[1]=="--stopfw"){stopfw();exit;}
if($argv[1]=="--startfw"){startfw();exit;}
if($argv[1]=="--EnableInterface"){interface_enable($argv[2]);exit;}
if($argv[1]=="--DisableInterface"){interface_disable($argv[2]);exit;}
if($argv[1]=="--removerrules"){routing_rules_delete($argv[2]);exit;}
if($argv[1]=="--realtek"){realtek();exit;}
display_menu();


function display_menu(){
    if(!is_file("/etc/artica-postfix/settings/Daemons/ArticaHttpsPort")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ArticaHttpUseSSL",1);}
    $ArticaHttpsPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ArticaHttpsPort"));
    $ArticaHttpUseSSL=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ArticaHttpUseSSL"));
    if($ArticaHttpsPort==0){$ArticaHttpsPort=9000;}

    $proto="http";
    if(  $ArticaHttpUseSSL == 1){ $proto="https";}

    chmod("/usr/share/artica-postfix/bin/exec.ifaces.py",0755);
    @chmod("/usr/share/artica-postfix/listips.sh",0755);
    exec("/usr/share/artica-postfix/bin/exec.ifaces.py",$results);

    $proc_net_dev=explode("\n",@file_get_contents("/proc/net/dev"));
    foreach ($proc_net_dev as $line){
        $line=trim($line);
        if($line==null){continue;}
        if(!preg_match("#^(.+?):\s+[0-9]+#",$line,$re)){continue;}
        if($re[1]=="lo"){continue;}
        $datas[$re[1]]=trim($re[1]);
    }

    foreach ($datas as $Interface=>$none){
        if (preg_match("#^(dummy|teql|ip6tnl|tunl|gre|ifb|sit|gretap|erspan)[0-9]+#", $Interface)) {continue;}

        $NetStatus=new NetStatus($Interface);
        if($NetStatus->IPADDR=="0.0.0.0"){continue;}
        if($NetStatus->IPADDR==null){continue;}
        $f[]="On $proto://{$NetStatus->IPADDR}:$ArticaHttpsPort";
    }

	if(count($f)==0){return;}
	echo "Web interface URIs:\\n".@implode("\\n", $f);
	
}

function interface_enable($eth){
	
	
	$nicClass=new system_nic($eth);
	$nicClass->enabled=1;
	$nicClass->SaveNic();
	network_menu();
	
}
function interface_disable($eth){


	$nicClass=new system_nic($eth);
	$nicClass->enabled=0;
	$nicClass->SaveNic();
	network_menu();

}

function routing_rules_delete($eth){
	
	
	$q=new mysql();
	$results=$q->QUERY_SQL("SELECT ID FROM routing_rules WHERE nic='$eth'","artica_backup");
	while ($ligne = mysqli_fetch_assoc($results)) {
		$ID=$ligne["ID"];
		$q->QUERY_SQL("DELETE FROM routing_rules WHERE ID='$ID'","artica_backup");
		$q->QUERY_SQL("DELETE FROM routing_rules_dest WHERE ruleid='$ID'","artica_backup");
		$q->QUERY_SQL("DELETE FROM routing_rules_src WHERE ruleid='$ID'","artica_backup");
		
	}
	network_menu();
}


function reconfigure(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
    system("echo 10 | /usr/bin/dialog --gauge \"Reconfigure network\" 10 70 0");
	system("$php /usr/share/artica-postfix/exec.convert-to-sqlite.php >/dev/null 2>&1");
    system("echo 30 | /usr/bin/dialog --gauge \"Reconfigure network\" 10 70 0");
	system("$php /usr/share/artica-postfix/exec.virtuals-ip.php --build");
    system("echo 50 | /usr/bin/dialog --gauge \"Stopping Network\" 10 70 0");
	system("/etc/init.d/artica-ifup stop");
    system("echo 90 | /usr/bin/dialog --gauge \"Starting Network\" 10 70 0");
	system("/etc/init.d/artica-ifup start");
    system("echo 100 | /usr/bin/dialog --gauge \"Done...\" 10 70 0");
	
	
}

function stopfw(){
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    system("echo 10 | /usr/bin/dialog --gauge \"Stopping FireWall service\" 10 70 0");
    system("$php /usr/share/artica-postfix/exec.firehol.php --stop >/dev/null 2>&1");
    system("echo 80 | /usr/bin/dialog --gauge \"Cleaning firewall rules\" 10 70 0");
    system("echo 100 | /usr/bin/dialog --gauge \"Success\" 10 70 0");
}

function startfw(){
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    system("echo 50 | /usr/bin/dialog --gauge \"Starting FireWall service\" 10 70 0");
    system("$php /usr/share/artica-postfix/exec.firehol.php --start >/dev/null 2>&1");
    system("echo 100 | /usr/bin/dialog --gauge \"Success\" 10 70 0");
}

function new_uuid(){
	$unix=new unix();
	$chattr=$unix->find_program("chattr");
	$php=$unix->LOCATE_PHP5_BIN();
	echo "Old uuid:".$GLOBALS["CLASS_SOCKETS"]->GET_INFO("SYSTEMID")."\n";
	shell_exec("$chattr -i /etc/artica-postfix/settings/Daemons/SYSTEMID");
	$uuid=trim($unix->gen_uuid());

    system("echo 10 | /usr/bin/dialog --gauge \"New uuid: $uuid\" 10 70 0");


	if(strlen($uuid)>5){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SYSTEMID", $uuid);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SYSTEMID_CREATED", time());
		@chmod("/etc/artica-postfix/settings/Daemons/SYSTEMID", 0777);
        $f[]="echo 50 | /usr/bin/dialog --gauge \"New uuid: $uuid\" 10 70 0";
		shell_exec("$chattr +i /etc/artica-postfix/settings/Daemons/SYSTEMID");

	}
    system("echo 60 | /usr/bin/dialog --gauge \"Register $uuid to License server\" 10 70 0");

	system("$php /usr/share/artica-postfix/exec.web-community-filter.php --register >/dev/null 2>&1");
    system("echo 90 | /usr/bin/dialog --gauge \"Register $uuid to License server\" 10 70 0");

	system("$php /usr/share/artica-postfix/exec.web-community-filter.php --register-lic  >/dev/null 2>&1");
    system("echo 100 | /usr/bin/dialog --gauge \"Register $uuid to License server success\" 10 70 0");

	

}

function realtek(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	system("$php /usr/share/artica-postfix/exec.apt-get.php --sources-list");
	system("/usr/bin/apt-get update");
	$unix->DEBIAN_INSTALL_PACKAGE("firmware-linux-nonfree");
	$unix->DEBIAN_INSTALL_PACKAGE("firmware-realtek");
	$unix->DEBIAN_INSTALL_PACKAGE("firmware-ralink");
}


function network_menu(){
$ARTICAVERSION=@file_get_contents("/usr/share/artica-postfix/VERSION");
$unix=new unix();
$HOSTNAME=$unix->hostname_g();
$DIALOG=$unix->find_program("dialog");	
$php=$unix->LOCATE_PHP5_BIN();

$f=explode("\n",@file_get_contents("/etc/resolv.conf"));


foreach ($f as $gpid=>$val){
	if(preg_match("#^nameserver\s+(.+)#", $val,$re)){
		$DNS[]=$re[1];
		if(count($DNS)>1){break;}
	}

}


$diag[]="$DIALOG --clear  --nocancel --backtitle \"Software version $ARTICAVERSION on $HOSTNAME\"";
$diag[]="--title \"[ N E T W O R K - M E N U ]\"";
$diag[]="--menu \"You can use the UP/DOWN arrow keys\nChoose the TASK\" 20 100 50";
$NETWORK_ALL_INTERFACES=$unix->NETWORK_ALL_INTERFACES();


$TCP_LIST_NICS=$unix->TCP_LIST_NICS();

    $DisableNetworking=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DisableNetworking"));
    if($DisableNetworking==0) {
        $diag[] = "RECONF \"Reconfigure/Rebuild Network\"";
    }
$diag[]="DNS \"DNS setup (".@implode(", ",$DNS).")\"";

foreach ($TCP_LIST_NICS as $Interface=>$line){
	if($Interface=="lo"){continue;}
	if(preg_match("#^(sit|dummy|wccp|tunl|tun|ifb|gretap|gre|ip6tnl|teql|bond|[a-z]+span)[0-9]+#",$Interface)){continue;}
		$DEFAULT = $NETWORK_ALL_INTERFACES[$Interface]["IPADDR"];
		$NETMASK = $NETWORK_ALL_INTERFACES[$Interface]["NETMASK"];
		$GATEWAY = $NETWORK_ALL_INTERFACES[$Interface]["GATEWAY"];
		$MAC     = $NETWORK_ALL_INTERFACES[$Interface]["MAC"];
		
		$nicClass=new system_nic($Interface);
		$conf="$DEFAULT/$NETMASK";
		if($nicClass->enabled==0){$conf=" * disabled *";}
	
		
		$diag[]="{$Interface} \"Modify $Interface interface [$MAC] ($conf)\"";
		$case[]="{$Interface}) modify$Interface;;";
		
		
		$funct[]="function modify$Interface(){";
    if($DisableNetworking==1) {
        $funct[] = "\t$DIALOG --title \"$Interface - $DEFAULT/$NETMASK\" --msgbox \"Sorry, Artica is not allowed to modify your network settings\" 9 70";
        $funct[] = "\treturn";
        $funct[] = "}";
        continue;
    }
		$funct[]="\t$php ".dirname(__FILE__)."/exec.menu.interface.php {$Interface}";
		$funct[]="\t/tmp/bash_interface.sh";
		$funct[]="\t/tmp/bash_network_menu.sh";
		$funct[]="\texit";
		$funct[]="}";

}
    $sock=new sockets();
    $FireHolEnable=intval($sock->GET_INFO("FireHolEnable"));

    if($FireHolEnable==1){
        if(menu_isFw()){
            $diag[]="STOPFW \"Stop the FireWall\"";
        }else{
            $diag[]="STARTFW \"Start the FireWall\"";
        }
        $diag[]="UNSTFW \"Uninstall the FireWall\"";

    }else{
        $diag[]="INSTFW \"Install the FireWall\"";
    }


$diag[]="Broadcom \"Install Broadcom driver\"";
$diag[]="Realtek \"Install Realtek/ralink drivers\"";



$diag[]="Quit \"Return to main menu\" 2>\"\${INPUT}\"";

$f[]="#!/bin/bash";
$f[]="INPUT=/tmp/menu.sh.$$";
$f[]="OUTPUT=/tmp/output.sh.$$";
$f[]="trap \"rm -f \$OUTPUT; rm -f \$INPUT; exit\" SIGHUP SIGINT SIGTERM";
$f[]="DIALOG=\${DIALOG=dialog}";
if($DNS[0]=="127.0.0.1"){unset($DNS[0]);}

$f[]="function change_dns(){";
$f[]="\t$DIALOG --clear --title \"ENTER IP ADDRESS FOR THE DNS 1\" --inputbox \"Enter your IP address for the DNS number 1.\\nExample: 1.1.1.1\" 10 68 {$DNS[0]} 2> /etc/artica-postfix/WIZARDMASK_DNS1";
$f[]="\tif [ $? = 1 -o $? = 255 ]; then";
$f[]="\t\trm -f /etc/artica-postfix/WIZARDMASK_DNS1";
$f[]="\t\treturn";
$f[]="\tfi";		
$f[]="\t$DIALOG --clear --title \"ENTER IP ADDRESS FOR THE DNS 2\" --inputbox \"Enter your IP address for the DNS number 2.\\nExample: 8.8.8.8\" 10 68 {$DNS[1]} 2> /etc/artica-postfix/WIZARDMASK_DNS2";
$f[]="\tif [ $? = 1 -o $? = 255 ]; then";
$f[]="\t\trm -f /etc/artica-postfix/WIZARDMASK_DNS2";
$f[]="\t\treturn";
$f[]="\tfi";	
$f[]="\tif [ -f /tmp/dns.log ]; then";
$f[]="\t\trm /tmp/dns.log";
$f[]="\tfi";
$f[]="\t$php ".__FILE__." --savedns";
$f[]="\tphp /usr/share/artica-postfix/exec.menu.ips.php --network-menu || true";
$f[]="\t/tmp/bash_network_menu.sh";
$f[]="\texit";
$f[]="}";
$f[]="";
$f[]="function reconfigure_network(){";
$f[]="\t$php ".__FILE__." --reconfigure";
$f[]="\tphp /usr/share/artica-postfix/exec.menu.ips.php --network-menu || true";
$f[]="\t/tmp/bash_network_menu.sh";
$f[]="\texit";
$f[]="}";
$f[]="";
$f[]="function stop_firewall(){";
$f[]="\t$DIALOG --title \"STOP the Firewall\" --yesno \"Warning, this operation will remove all NAT/REDIRECT methods.\\nDo you need to perform this operation ? Press 'Yes' to continue, or 'No' to exit\" 0 0";
$f[]="\tcase $? in";
$f[]="\t\t0)";
$f[]="\t$php ".__FILE__." --stopfw";
$f[]="\tphp /usr/share/artica-postfix/exec.menu.ips.php --network-menu || true";
$f[]="\t/tmp/bash_network_menu.sh";
$f[]="\texit";
$f[]="\t\treturn;;";
$f[]="\t1)";
$f[]="\t\treturn;;";
$f[]="\t255)";
$f[]="\t\treturn;;";
$f[]="\tesac";
$f[]="}";
$f[]="";
$f[]="function start_firewall(){";
$f[]="\t$php ".__FILE__." --startfw";
$f[]="\tphp /usr/share/artica-postfix/exec.menu.ips.php --network-menu || true";
$f[]="\t/tmp/bash_network_menu.sh";
$f[]="\texit";
$f[]="}";
    $f[]="function install_firewall(){";
    $f[]="\techo 60 | /usr/bin/dialog --gauge \"Installing Firewall service\" 10 70 0";
    $f[]="\t$php /usr/share/artica-postfix/exec.firehol.php --enable-progress >/dev/null 2>&1";
    $f[]="\techo 90 | /usr/bin/dialog --gauge \"Installing Firewall service done..\" 10 70 0";
    $f[]="\t$php /usr/share/artica-postfix/exec.menu.ips.php --network-menu >/dev/null 2>&1 || true";
    $f[]="\techo 100 | /usr/bin/dialog --gauge \"Installing Firewall service done\" 10 70 0";
    $f[]="\t/tmp/bash_network_menu.sh";
    $f[]="\texit";
    $f[]="}";

    $f[]="function uninstall_firewall(){";
    $f[]="\techo 60 | /usr/bin/dialog --gauge \"Uninstalling Firewall service\" 10 70 0";
    $f[]="\t$php /usr/share/artica-postfix/exec.firehol.php --disable-progress >/dev/null 2>&1";
    $f[]="\techo 90 | /usr/bin/dialog --gauge \"Uninstalling Firewall service done..\" 10 70 0";
    $f[]="\t$php /usr/share/artica-postfix/exec.menu.ips.php --network-menu >/dev/null 2>&1 || true";
    $f[]="\techo 100 | /usr/bin/dialog --gauge \"Uninstalling Firewall service done\" 10 70 0";
    $f[]="\t/tmp/bash_network_menu.sh";
    $f[]="\texit";
    $f[]="}";


$f[]="";

$f[]="function BroadcomInstall(){";
$f[]="\tif [ -f /tmp/dns.log ]; then";
$f[]="\t\trm /tmp/dns.log";
$f[]="\tfi";
$f[]="\t$php /usr/share/artica-postfix/exec.bnx2.enable.php >/tmp/dns.log &";
$f[]="\t$DIALOG --tailbox /tmp/dns.log  25 150";
$f[]="}";
$f[]="function RealtekInstall(){";
$f[]="\tif [ -f /tmp/dns.log ]; then";
$f[]="\t\trm /tmp/dns.log";
$f[]="\tfi";
$f[]="\t$php ".__FILE__." --realtek >/tmp/dns.log &";
$f[]="\t$DIALOG --tailbox /tmp/dns.log  25 150";
$f[]="}";
$f[]="";
$f[]="function zQuit(){";
$f[]="  killall logon.sh";
$f[]="  /usr/share/artica-postfix/logon.sh";
$f[]="  exit";
$f[]="}";
$f[]="";








$f[]=@implode("\n", $funct);
$f[]="while true";
$f[]="do";
$f[]=@implode(" ", $diag);
$f[]="menuitem=$(<\"\${INPUT}\")";
$f[]="case \$menuitem in";
$f[]="RECONF) reconfigure_network;;";
$f[]="DNS) change_dns;;";
$f[]="STOPFW) stop_firewall;;";
$f[]="STARTFW) start_firewall;;";
$f[]="INSTFW) install_firewall;;";
$f[]="UNSTFW) uninstall_firewall;;";
$f[]="Broadcom) BroadcomInstall;;";
$f[]="Realtek) RealtekInstall;;";




$f[]=@implode("\n", $case);
$f[]="Quit) zQuit;;";
$f[]="esac";
$f[]="done\n";

if($GLOBALS["VERBOSE"]){echo "Writing /tmp/bash_network_menu.sh\n";}
@file_put_contents("/tmp/bash_network_menu.sh", @implode("\n",$f));
@chmod("/tmp/bash_network_menu.sh",0755);
	
}

function menu_isFw() {

    $unix=new unix();
    $iptables_save=$unix->find_program("iptables-save");
    exec("$iptables_save -t filter 2>&1",$results);
    if(is_file("/usr/share/artica-postfix/ressources/logs/web/FIREWALL_ACTIVE")) {
        @unlink("/usr/share/artica-postfix/ressources/logs/web/FIREWALL_ACTIVE");
    }
    foreach ($results as $line){
        $line=trim($line);
        if(preg_match("#^:ARTICAFW_([0-9]+)#",$line,$re)){
            return true;
        }
        if(preg_match("#^:SMART_REJECT#",$line,$re)){break;}

    }
    return false;
}

function interface_menu($eth){

    $DisableNetworking=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DisableNetworking"));
	$ARTICAVERSION=@file_get_contents("/usr/share/artica-postfix/VERSION");
	$unix=new unix();
	$HOSTNAME=$unix->hostname_g();
	$DIALOG=$unix->find_program("dialog");
	$php=$unix->LOCATE_PHP5_BIN();	
	$NETWORK_ALL_INTERFACES=$unix->NETWORK_ALL_INTERFACES();
	$DEFAULT=$NETWORK_ALL_INTERFACES[$eth]["IPADDR"];
	$NETMASK=$NETWORK_ALL_INTERFACES[$eth]["NETMASK"];
	$GATEWAY=$NETWORK_ALL_INTERFACES[$eth]["GATEWAY"];

	if($NETMASK==null){$NETMASK="255.255.255.0";}
	
	$f[]="#!/bin/bash";
	$f[]="INPUT=/tmp/menu.sh.$$";
	$f[]="OUTPUT=/tmp/output.sh.$$";
	$f[]="trap \"rm -f \$OUTPUT; rm -f \$INPUT; exit\" SIGHUP SIGINT SIGTERM";
	$f[]="DIALOG=\${DIALOG=dialog}";

    if($DisableNetworking==1) {
        $f[] = "\t$DIALOG --title \"$eth - $DEFAULT/$NETMASK\" --msgbox \"Sorry, Artica is not allowed to modify your network settings\" 9 70";
        $f[] = "\texit 0";
        $f[]="\n";
        @file_put_contents("/tmp/bash_network_menu_interface.sh", @implode("\n",$f));
        @chmod("/tmp/bash_network_menu_interface.sh",0755);
        return;
    }


	@unlink("/etc/artica-postfix/WIZARDIP_$eth");
	@unlink("/etc/artica-postfix/WIZARDMASK_$eth");
	$f[]="$DIALOG --clear --title \"ENTER IP ADDRESS FOR '$eth'\" --inputbox \"Enter your IP address for the $eth Interface.\\nExample: 111.112.113.114\" 10 68 $DEFAULT 2> /etc/artica-postfix/WIZARDIP_$eth";
	
	$f[]="if [ $? = 1 -o $? = 255 ]; then";
	$f[]="rm -f /etc/artica-postfix/WIZARDIP_$eth";
	$f[]="\treturn";
	$f[]="fi";
	
	
	$f[]="$DIALOG --clear --title \"ENTER IP ADDRESS FOR '$eth'\" --inputbox \"Enter your netmask for the $eth Interface.\\nExample: 255.255.255.0\" 10 68 $NETMASK 2> /etc/artica-postfix/WIZARDMASK_$eth";
	$f[]="if [ $? = 1 -o $? = 255 ]; then";
	$f[]="rm -f /etc/artica-postfix/WIZARDMASK_$eth";
	$f[]="\treturn";
	$f[]="fi";
	
	$f[]="$DIALOG --clear --title \"ENTER IP ADDRESS FOR '$eth'\" --inputbox \"Enter your gateway for the $eth Interface.\\nExample: 111.112.113.114\\nIf this interface is the main gateway of your network, set 0.0.0.0 here\" 10 68 $GATEWAY 2> /etc/artica-postfix/WIZARDGATEWAY_$eth";
	$f[]="if [ $? = 1 -o $? = 255 ]; then";
	$f[]="rm -f /etc/artica-postfix/WIZARDGATEWAY_$eth";
	$f[]="\treturn";
	$f[]="fi";	
	
	$f[]="WIZARDIP=`cat /etc/artica-postfix/WIZARDIP_$eth`";
	$f[]="WIZARDMASK=`cat /etc/artica-postfix/WIZARDMASK_$eth`";
	$f[]="WIZARDGATEWAY=`cat /etc/artica-postfix/WIZARDGATEWAY_$eth`";
	
	$f[]="$DIALOG --title \"NETWORK SETUP COMPLETE\" --yesno \"Your networking system is now configured to use:\\n\$WIZARDIP/\$WIZARDMASK Gateway \$WIZARDGATEWAY\\nIs this correct?  Press 'Yes' to continue, or 'No' to exit\" 0 0";
  	$f[]="case $? in";
  	$f[]="0)";
  	$f[]="\tkill -9 `pidof -s /sbin/dhclient` >/dev/null";
    $f[]="\t$php ".__FILE__." --savenic $eth";
    $f[]="\tWIZARDRESULTS=`cat /etc/artica-postfix/WIZARDRESULT_$eth`";
  	$f[]="\tif [ \"\$WIZARDRESULTS\" eq 0 ]; then";
  	$f[]="\t$DIALOG --title \"$eth failed\" --msgbox \"Sorry, An error has occured\" 9 70";
  	$f[]="\tfi";
    $f[]="\treturn;;";
	$f[]="1)";
   	$f[]="\treturn;;";
  	$f[]="255)";
  	$f[]="\treturn;;";
	$f[]="esac";
	
	
	$f[]="\n";
	@file_put_contents("/tmp/bash_network_menu_interface.sh", @implode("\n",$f));
	@chmod("/tmp/bash_network_menu_interface.sh",0755);
	
}

function savenic($NIC){
	$unix=new unix();
	$ipClass=new IP();
	$ETH_IP=trim(@file_get_contents("/etc/artica-postfix/WIZARDIP_$NIC"));
	$NETMASK=trim(@file_get_contents("/etc/artica-postfix/WIZARDMASK_$NIC"));
	$GATEWAY=trim(@file_get_contents("/etc/artica-postfix/WIZARDGATEWAY_$NIC"));
    $ifconfig=$unix->find_program("ifconfig");
	if(!$ipClass->isIPAddress($ETH_IP)){
		echo "* * * * $ETH_IP * * * * WRONG !!!!\n";
		@file_put_contents("/etc/artica-postfix/WIZARDRESULT_$NIC", 0);
		return;
	}
	if(!$ipClass->isIPAddress($GATEWAY)){
		echo "* * * * $GATEWAY * * * * WRONG !!!!\n";
		@file_put_contents("/etc/artica-postfix/WIZARDRESULT_$NIC", 0);
		return;
	}	
	
	$nics=new system_nic($NIC);
	$nics->eth=$NIC;
	$nics->IPADDR=$ETH_IP;
	$nics->NETMASK=$NETMASK;
	$nics->GATEWAY=$GATEWAY;
	$nics->dhcp=0;
	$nics->metric=1;
	$nics->defaultroute=1;
	$nics->enabled=1;	
	
	if(!$nics->SaveNic()){
		echo "* * * * MYSQL ERROR !!! * * * * WRONG !!!!\n";
		@file_put_contents("/etc/artica-postfix/WIZARDRESULT_$NIC", 0);
		return;
	}
	
	$php=$unix->LOCATE_PHP5_BIN();
	$nohup=$unix->find_program("nohup");
	$php5=$php;

    DialogPercent(10,"Interface $NIC","Change to $ETH_IP/$NETMASK $GATEWAY");
	system("$php5 ".dirname(__FILE__)." /exec.virtuals-ip.php --build --force >/dev/null 2>&1");
    DialogPercent(20,"Interface $NIC","Reloading network");

    shell_exec("$php5 /usr/share/artica-postfix/exec.convert-to-sqlite.php --net");

	$unix->THREAD_COMMAND_SET("$php5 /usr/share/artica-postfix/exec.postfix.maincf.php --reconfigure");
	$unix->THREAD_COMMAND_SET("/usr/share/artica-postfix/bin/artica-install --reconfigure-cyrus");

    DialogPercent(30,"Interface $NIC","Restarting Artica Status");
	system("$nohup /etc/init.d/artica-status reload >/dev/null 2>&1 &");
    DialogPercent(40,"Interface $NIC","Restarting Web services");
	system("$nohup /etc/init.d/nginx restart >/dev/null 2>&1 &");
    DialogPercent(50,"Interface $NIC","Restarting Watchdog services");
	system("$nohup /etc/init.d/monit restart >/dev/null 2>&1 &");
	echo "30%] Please Wait, Changing IP address to $NIC....\n";
    DialogPercent(60,"Interface $NIC","reconfiguring...");
	system("$ifconfig $NIC down >/dev/null 2>&1");
	system("$ifconfig $NIC $ETH_IP netmask $NETMASK up");
	system("/bin/ip route add 127.0.0.1 dev lo >/dev/null 2>&1");
	if($GATEWAY<>"0.0.0.0"){
        DialogPercent(70,"Interface $NIC","reconfiguring gateway..");
		system("/sbin/route add $GATEWAY dev $NIC >/dev/null 2>&1");
		$route=$unix->find_program("route");
		shell_exec("$route add -net 0.0.0.0 gw $GATEWAY dev $NIC metric 1 >/dev/null 2>&1");
	}
    DialogPercent(80,"Interface $NIC","Restarting Web console");
	system("/etc/init.d/artica-webconsole restart >/dev/null 2>&1");
	if(is_file("/etc/init.d/ssh")){
        DialogPercent(85,"Interface $NIC","Restarting SSH service");
        shell_exec("$php5 /usr/share/artica-postfix/exec.sshd.php --progress >/dev/null 2>&1");
        system("/etc/init.d/ssh restart >/dev/null 2>&1");
    }


    DialogPercent(100,"Interface $NIC","Done");;
	file_put_contents("/etc/artica-postfix/WIZARDRESULT_$NIC", 1);

}

function DialogPercent($percent,$title,$text){

    system("echo $percent| dialog --title \"$title\" --gauge \"$text\" 6 80");
}

function savedns(){
	
	$DNS1=@file_get_contents("/etc/artica-postfix/WIZARDMASK_DNS1");
	$DNS2=@file_get_contents("/etc/artica-postfix/WIZARDMASK_DNS2");
    $resolv=new resolv_conf();
	if(is_file("/etc/init.d/unbound")){
        DialogPercent(10,"Reconfigure DNS","Set DNS to 127.0.0.1 - $DNS1 - $DNS2");
        $resolv->MainArray["DNS1"]="127.0.0.1";
        $resolv->MainArray["DNS2"]=$DNS1;
        $resolv->MainArray["DNS3"]=$DNS2;
    }else{
        DialogPercent(10,"Reconfigure DNS","Set DNS to $DNS1 - $DNS2");
        $resolv->MainArray["DNS1"]=$DNS1;
        $resolv->MainArray["DNS2"]=$DNS1;
        $resolv->output=true;
    }



    DialogPercent(50,"Reconfigure DNS","Saving config");
	$resolvDatas=$resolv->build();
    DialogPercent(60,"Reconfigure DNS","Saving /etc/resolv.conf");
	@file_put_contents("/etc/resolv.conf", $resolvDatas);

    if(is_file("/etc/init.d/unbound")){
        DialogPercent(70,"Reconfigure DNS","Restarting DNS cache Service");
        shell_exec("/etc/init.d/unbound restart");
    }
    $unix=new unix();
    $killall=$unix->find_program("killall");
    $php=$unix->LOCATE_PHP5_BIN();
    DialogPercent(80,"Reconfigure DNS","Please wait");
    shell_exec("$killall bash_network_menu.sh");

    DialogPercent(100,"Reconfigure DNS","Please wait");
    shell_exec("$php /usr/share/artica-postfix/exec.menu.ips.php --network-menu >/dev/null 2>&1");
    shell_exec("/tmp/bash_network_menu.sh");


}

