<?php

if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(!isset($GLOBALS["ARTICALOGDIR"])){$GLOBALS["ARTICALOGDIR"]=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("ArticaLogDir"); if($GLOBALS["ARTICALOGDIR"]==null){ $GLOBALS["ARTICALOGDIR"]="/var/log/artica-postfix"; } }
$GLOBALS["VERBOSE"]=false;
$GLOBALS["DEBUG"]=false;;
$GLOBALS["FORCE"]=false;
$GLOBALS["VERBOSE"]=false;
$GLOBALS["RESTART"]=false;
if(preg_match("#--verbose#",implode(" ",$argv))){
	$GLOBALS["DEBUG_SQL"]=true;
	$GLOBALS["VERBOSE"]=true;
	ini_set('display_errors', 1);
	ini_set('error_reporting', E_ALL);
	ini_set('error_prepend_string',null);
	ini_set('error_append_string',null);
}
if(preg_match("#schedule-id=([0-9]+)#",implode(" ",$argv),$re)){$GLOBALS["SCHEDULE_ID"]=$re[1];}
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}

$BASEDIR="/usr/share/artica-postfix";

include_once($BASEDIR . '/ressources/class.users.menus.inc');
include_once($BASEDIR . '/ressources/class.sockets.inc');
include_once($BASEDIR . '/framework/class.unix.inc');
include_once($BASEDIR. '/framework/frame.class.inc');
include_once($BASEDIR. '/ressources/class.iptables-chains.inc');
include_once($BASEDIR . '/ressources/class.mysql.haproxy.builder.php');
include_once($BASEDIR . "/ressources/class.mysql.squid.builder.php");
include_once($BASEDIR. "/ressources/class.mysql.builder.inc");
include_once($BASEDIR . "/ressources/class.mysql.syslogs.inc");
if(preg_match("#--norestart#",implode(" ",$argv))){$GLOBALS["NORESTART"]=true;}
if(preg_match("#--reload#",implode(" ",$argv))){$GLOBALS["RELOAD"]=true;}
if(preg_match("#--force#",implode(" ",$argv))){$GLOBALS["FORCE"]=true;}
if(preg_match("#--syslogmini#",implode(" ",$argv))){$GLOBALS["SYSLOGMINI"]=true;}
if(preg_match("#--restart#",implode(" ",$argv))){$GLOBALS["RESTART"]=true;}

$unix=new unix();
$pids=$unix->PIDOF_PATTERN_ALL(basename(__FILE__));
if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." instances:".count($pids)."\n";}
if(count($pids)>3){
	echo "Starting......: ".date("H:i:s")." Too many instances ". count($pids)." starting squid, kill them!\n";
	$mypid=getmypid();
	foreach ($pids as $pid=>$ligne){
		if($pid==$mypid){continue;}
		echo "Starting......: ".date("H:i:s")." killing $pid\n";
		unix_system_kill_force($pid);
	}

}

$pids=$unix->PIDOF_PATTERN_ALL(basename(__FILE__));
if(count($pids)>3){
	echo "Starting......: ".date("H:i:s")." Too many instances ". count($pids)." dying\n";
	exit();
}

if($GLOBALS["VERBOSE"]){echo __LINE__." TRUE\n";}


if(is_file("/etc/artica-postfix/FROM_ISO")){
	if($unix->file_time_min("/etc/artica-postfix/FROM_ISO")<1){
		if($GLOBALS["VERBOSE"]){echo __LINE__." FALSE\n";}
		return;
	}
}

if($argv[1]=='--seeker'){$GLOBALS["VERBOSE"]=true;seeker();exit();}
if($argv[1]=='--purge'){$GLOBALS["VERBOSE"]=true;clean_mysql_events();exit();}
if($argv[1]=='--imap-bw'){blackwhite_admin_mysql_check(true);exit();}
if($argv[1]=='--rotate'){squid_notifications();exit();}
if($argv[1]=='--updtev'){udfbguard_update_events();exit();}
if($argv[1]=='--rsylogd'){rsyslog_check_includes();exit();}
//exec.syslog-engine.php --rsylogd

if($argv[1]=='--sysev'){sysev();exit();}
if($argv[1]=='--admin-evs'){scan_queue();exit();}
if($argv[1]=='--squid-rt-failed'){squid_rt_mysql_failed();exit();}
if($argv[1]=='--loadavg'){system_admin_events_checks();exit();}
if($argv[1]=='--buildconf'){rsyslog_check_includes();exit;}
if($argv[1]=='--apache'){squid_admin_mysql_check();exit;}
if($argv[1]=='--restart'){syslog_restart();exit;}





if(!$GLOBALS["FORCE"]){
	if(system_is_overloaded(basename(__FILE__))){exit();}
}
if($GLOBALS["VERBOSE"]){echo __LINE__." TRUE\n";}
if(!isset($argv[1])){$argv[1]="--auth-logs";}

if($argv[1]=='--restart-syslog'){restart_syslog();exit();}
if($argv[1]=='--build-server'){build_server_mode();exit();}
if($argv[1]=='--build-client'){build_client_mode();exit();}
if($argv[1]=='--haproxy'){haproxy_events();exit();}
if($argv[1]=='--squid-notifs'){squid_admin_notifs_check();exit();}
if($argv[1]=='--squid-mysql'){squid_notifications();exit();}
if($argv[1]=='--load-stats'){load_stats();exit();}
if($argv[1]=='--install'){install();exit();}
if($argv[1]=='--uninstall'){uninstall();exit();}


if($argv[1]=='--auth-logs'){
		$GLOBALS["YESCGROUP"]=true;xcgroups();
		$TimeFile="/etc/artica-postfix/pids/exec.syslog-engine.auth.time";
		$unix=new unix();
		$TimExec=$unix->file_time_min($TimeFile);
		if($TimExec<5){exit();}
		@unlink($TimeFile);
		@file_put_contents($TimeFile, time());
		authlogs();
		sessions_logs();
		admin_logs();
		scan_queue();
		seeker();
		system_admin_events_checks();
		squid_admin_mysql_check();
		exit();
}
if($argv[1]=='--authfw'){authfw();sessions_logs();exit();system_admin_events_checks();}
if($argv[1]=='--authfw-compile'){compile_sshd_rules();sessions_logs();system_admin_events_checks();exit();}
if($argv[1]=='--snort'){snort_logs();sessions_logs();system_admin_events_checks();exit();}
if($argv[1]=='--sessions'){sessions_logs();system_admin_events();exit();}

if($argv[1]=='--;'){scan_queue(true);exit();}
if($argv[1]=='--adminlogs'){admin_logs();exit();}
if($argv[1]=='--squid-tasks'){exit();}
if($argv[1]=='--update-events-check'){sarg_admin_events_checks(true);update_events_check(true);system_admin_events_checks();squid_admin_notifs_check();exit();}
if($argv[1]=='--squidsys'){exit();}
if($argv[1]=='--localx'){build_localx_servers();exit();}


if($GLOBALS["VERBOSE"]){echo __LINE__." TRUE\n";}
$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".pid";
$timefile="/etc/artica-postfix/pids/".basename(__FILE__).".time";
$unix=new unix();
$pid=$unix->get_pid_from_file($pidfile);
if($unix->process_exists($pid,basename(__FILE__))){
	ssh_events("Already PID $pid exists, aborting" , "MAIN", __FILE__, __LINE__);
	exit();
}

if(!$GLOBALS["VERBOSE"]){
	$time=$unix->file_time_min($timefile);
	if($time<5){exit();}
}

@file_put_contents($pidfile, getmypid());
@unlink($timefile);
@file_put_contents($timefile, time());


if($GLOBALS["VERBOSE"]){echo "MAIN::".__LINE__." ->admin_logs()\n";}
admin_logs();
if(system_is_overloaded(basename(__FILE__))){squid_admin_mysql(2, "OVERLOADED system: {$GLOBALS["SYSTEM_INTERNAL_LOAD"]}, aborting",ps_report(),__FILE__,__LINE__);exit();}
if($GLOBALS["VERBOSE"]){echo "MAIN::".__LINE__." ->ps_mem()\n";}
ps_mem(true);
if($GLOBALS["VERBOSE"]){echo "MAIN::".__LINE__." ->authlogs()\n";}
authlogs();
if(system_is_overloaded(basename(__FILE__))){squid_admin_mysql(2, "OVERLOADED system: {$GLOBALS["SYSTEM_INTERNAL_LOAD"]}, aborting",ps_report(),__FILE__,__LINE__);exit();}
if($GLOBALS["VERBOSE"]){echo "MAIN::".__LINE__." ->sessions_logs()\n";}
sessions_logs();
if(system_is_overloaded(basename(__FILE__))){squid_admin_mysql(2, "OVERLOADED system: {$GLOBALS["SYSTEM_INTERNAL_LOAD"]}, aborting",ps_report(),__FILE__,__LINE__);exit();}
if($GLOBALS["VERBOSE"]){echo __LINE__." TRUE\n";}
$EnableArticaMetaClient=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableArticaMetaClient"));
if($GLOBALS["VERBOSE"]){echo __LINE__." TRUE\n";}
if($GLOBALS["VERBOSE"]){echo "MAIN::".__LINE__." ->mysql_admin_events_check()\n";}
mysql_admin_events_check();
if($GLOBALS["VERBOSE"]){echo "MAIN::".__LINE__." ->squid_admin_mysql_check()\n";}
squid_admin_mysql_check();

seeker();
if($EnableArticaMetaClient==0){meta_client_clean_logs();exit;}

if($GLOBALS["VERBOSE"]){echo "MAIN::".__LINE__." ->END\n";}
exit();


function squid_notifications(){
	
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pid=@file_get_contents($pidfile);
	if($unix->process_exists($pid)){writelogs("Already running pid $pid",__FUNCTION__,__FILE__,__LINE__);return;}
	@file_put_contents($pidfile, getmypid());
	rotate_admin_events_checks();
	squid_admin_mysql_check();
	rdpproxy_admin_mysql_check();
	sarg_admin_events_checks();	
	seeker();
	
}


function sysev(){
	
		$unix=new unix();
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=@file_get_contents($pidfile);
		if($unix->process_exists($pid)){writelogs("Already running pid $pid",__FUNCTION__,__FILE__,__LINE__);return;}

		
		$t=0;		
		system_admin_events_checks();
		squid_admin_mysql_check();
		nginx_admin_mysql_check();
		sys_load();
		scan_queue();
	
}

function build_progress($pourc,$text){
	$date=date("Y-m-d H:i:s");
	$GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/syslog.install.progress";
	echo "$date: [{$pourc}%] $text\n";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($GLOBALS["CACHEFILE"], serialize($array));
	@chmod($GLOBALS["CACHEFILE"],0755);
}
function build_progress_restart($pourc,$text){
	$date=date("Y-m-d H:i:s");
	$GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/syslog.restart.progress";
	echo "$date: [{$pourc}%] $text\n";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($GLOBALS["CACHEFILE"], serialize($array));
	@chmod($GLOBALS["CACHEFILE"],0755);
}
function install(){

	build_progress(10,"{installing}");
	$sock=new sockets();
	$sock->SET_INFO("ActAsASyslogServer",1);
	build_progress(50,"{configuring}");
	rsyslog_check_includes();
	build_progress(90,"{restarting}");
	restart_syslog();
	build_progress(100,"{installing} {success}");

}
function uninstall(){

	build_progress(10,"{uninstalling}");
	$sock=new sockets();
	$sock->SET_INFO("ActAsASyslogServer",0);
	build_progress(50,"{configuring}");
	rsyslog_check_includes();
	build_progress(90,"{restarting}");
	restart_syslog();
	build_progress(100,"{uninstalling} {success}");

}

function build_server_mode(){
	echo "Starting......: ".date("H:i:s")." syslog rsyslog mode\n";
	rsyslog_check_includes();
	if($GLOBALS["NORESTART"]){return;}
	shell_exec("/etc/init.d/auth-tail restart");
}






function rsyslogd_version(){
	$unix=new unix();
	$rsyslogd=$unix->find_program("rsyslogd");
	exec("$rsyslogd -v 2>&1",$results);
	foreach ($results as $line) {
		if(!preg_match("#syslogd\s+([0-9\.]+)#", $line,$re)){continue;}
		return $re[1];
	}
}

function build_remote_syslog($enabled=0,$enabletcp=0,$useSSL=0,$certificate=null,$hostname=null,$port=0){

	if($enabled==0){return "#Remote syslog disabled";}
	if($hostname==null){return "#Hostname is not set";}
	if($certificate==null){$useSSL=0;}
	if($port==0){$port=514;}
	$proto="udp";
	$h=array();
	$StreamDriver=null;
	if($useSSL==1) {$enabletcp=1;}



	if($enabletcp==1){$proto="tcp";}
	if($useSSL==1) {
		$q = new lib_sqlite("/home/artica/SQLITE/certificates.db");
		$sql = "SELECT `srca` FROM sslcertificates WHERE CommonName='$certificate'";
		$ligne = $q->mysqli_fetch_array($sql);
		$Expose_content = $ligne["srca"];
		$Expose_content = str_replace("\\n", "\n", $Expose_content);
		@file_put_contents("/etc/rsyslog.d/$hostname.pem", $Expose_content);
		$StreamDriver="StreamDriver=\"gtls\" ";
		$h[] = "\$DefaultNetstreamDriverCAFile /etc/rsyslog.d/$hostname.pem";
	}

	$h[] = "\taction(type=\"omfwd\" Protocol=\"$proto\" Target=\"$hostname\" Port=\"$port\" StreamDriverMode=\"1\"  {$StreamDriver}StreamDriverAuthMode=\"anon\")";
	return @implode("\n",$h);
}

function rsyslog_check_includes(){
	if(!is_file("/etc/rsyslog.conf")){return;}
	$imudp="#";
	$imtcp="#";
	$unix=new unix();
	
	$haproxy=$unix->find_program("haproxy");
	
	
	$rsyslogd_version=rsyslogd_version();
	
	if(is_file($haproxy)){
		$imudp=null;
		
	}
	
	$SystemLogRateLimitInterval=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SystemLogRateLimitInterval"));
	$SystemLogRateLimitBurst=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SystemLogRateLimitBurst"));
	$ActAsASyslogServer=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ActAsASyslogServer"));
	
	if($SystemLogRateLimitInterval==0){$SystemLogRateLimitInterval=10;}
	if($SystemLogRateLimitBurst==0){$SystemLogRateLimitBurst=10000;}

	$RsyslogInterface=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("RsyslogInterface");
	$RsyslogTCPInterface=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("RsyslogTCPInterface");
	$RsyslogPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("RsyslogPort"));
	$RsyslogProtoTCP=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("RsyslogProtoTCP"));
	$RsyslogTCPPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("RsyslogTCPPort"));
	$RsyslogDisableProtoUDP=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("RsyslogDisableProtoUDP"));
	$RsyslogTCPUseSSL=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("RsyslogTCPUseSSL"));
	$RsyslogTCPCertificateName=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("RsyslogTCPCertificateName");
	$UnboundLogSyslogDoNotStorelogsLocally=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundLogSyslogDoNotStorelogsLocally"));
	$Enablehacluster=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("Enablehacluster"));
	$EnableHaProxy=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("Enablehacluster"));
	$EnableHaExchange=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableHaExchange"));

	if($RsyslogTCPPort==0){$RsyslogTCPPort=5514;}
	if($RsyslogPort==0){$RsyslogPort=514;}

	if($ActAsASyslogServer==1){
		if($RsyslogDisableProtoUDP==0){$imudp=null;}
		if($RsyslogProtoTCP==1){$imtcp=null;}
	}
	if($Enablehacluster==1){$ActAsASyslogServer=1;}
	if($EnableHaProxy==1){$ActAsASyslogServer=1;}
	if($EnableHaExchange==1){$ActAsASyslogServer=1;}

	$f[]="#  /etc/rsyslog.conf	Configuration file for rsyslog v{$rsyslogd_version}.";
	$f[]="#";
	$f[]="#			Written by Artica " .date("Y-m-d H:i:s");
	$f[]="#			See ".__FILE__." function ". __FUNCTION__."() line ". __LINE__;
	$f[]="#			For more information see";
	$f[]="#			/usr/share/doc/rsyslog-doc/html/rsyslog_conf.html";
	$f[]="";
	$f[]="";
	$f[]="#################";
	$f[]="#### MODULES ####";
	$f[]="#################";
	$f[]="";
	$f[]="\$ModLoad imuxsock # provides support for local system logging";
	$f[]="\$ModLoad imklog   # provides kernel logging support (previously done by rklogd)";
	$f[]="#\$ModLoad immark  # provides --MARK-- message capability";
	$f[]="";
	$f[]="# provides UDP syslog reception";
	$f[]="$imudp\$ModLoad imudp";
	$f[]="$imudp\$UDPServerRun $RsyslogPort";
	if($RsyslogInterface<>null){$f[]="$imudp\$UDPServerAddress ".$unix->InterfaceToIPv4($RsyslogInterface);}
	$f[]="";
	$f[]="# provides TCP syslog reception";
	$f[]="$imtcp\$ModLoad imtcp";
	$f[]="$imtcp\$InputTCPServerRun $RsyslogTCPPort";

	$f[]="";
	$f[]="\$SystemLogRateLimitInterval $SystemLogRateLimitInterval";
	$f[]="\$SystemLogRateLimitBurst $SystemLogRateLimitBurst";
	$f[]="";
	$f[]="\$WorkDirectory /var/spool/rsyslog # where to place spool files";
	$f[]="\$ActionQueueFileName uniqName # unique name prefix for spool files";
	$f[]="\$ActionQueueMaxDiskSpace 1g   # 1gb space limit (use as much as possible)";
	$f[]="\$ActionQueueSaveOnShutdown on # save messages to disk on shutdown";
	$f[]="\$ActionQueueType LinkedList   # run asynchronously";
	$f[]="\$ActionResumeRetryCount -1    # infinite retries if host is down";
	$f[]="# TCP enabled      = $RsyslogProtoTCP";
	$f[]="# SSL enabled      = $RsyslogTCPUseSSL";
	$f[]="# Certificate name = $RsyslogTCPCertificateName";

	if(!is_file("/usr/lib/x86_64-linux-gnu/rsyslog/lmnsd_gtls.so")){
		$f[]="# lmnsd_gtls.so missing";
		$RsyslogTCPUseSSL=0;
	}

	if($RsyslogProtoTCP==1) {
		if($RsyslogTCPUseSSL==1) {
			if (strlen($RsyslogTCPCertificateName) >4) {
				$q = new lib_sqlite("/home/artica/SQLITE/certificates.db");
				$sql = "SELECT `srca`,`SquidCert`,`privkey`,`crt`,`Squidkey`,`UsePrivKeyCrt`  FROM sslcertificates WHERE CommonName='$RsyslogTCPCertificateName'";
				$ligne = $q->mysqli_fetch_array($sql);
				@mkdir("/etc/rsyslog.d", 0755, true);
				$Expose_content = $ligne["srca"];
				$Expose_content = str_replace("\\n", "\n", $Expose_content);
				@file_put_contents("/etc/rsyslog.d/ca.pem", $Expose_content);

				$field = "privkey";
				if ($ligne["UsePrivKeyCrt"] == 0) {
					$field = "Squidkey";
					if (strlen($ligne[$field]) < 10) {
						if (strlen($ligne["privkey"]) > 10) {
							$field = "privkey";
						}
					}

				}
				$Expose_content = $ligne[$field];
				$Expose_content = str_replace("\\n", "\n", $Expose_content);

				@file_put_contents("/etc/rsyslog.d/server_key.pem", $Expose_content);


				$field="crt";
				if($ligne["UsePrivKeyCrt"]==0){$field="SquidCert";}
				$Expose_content = $ligne[$field];
				$Expose_content = str_replace("\\n", "\n", $Expose_content);
				@file_put_contents("/etc/rsyslog.d/server_cert.pem", $Expose_content);

				$f[] = "";
				$f[] = "\$DefaultNetstreamDriver gtls";
				$f[] = "\$DefaultNetstreamDriverCAFile /etc/rsyslog.d/ca.pem";
				$f[] = "\$DefaultNetstreamDriverCertFile /etc/rsyslog.d/server_cert.pem";
				$f[] = "\$DefaultNetstreamDriverKeyFile /etc/rsyslog.d/server_key.pem";
				$f[] = "\$InputTCPServerStreamDriverMode 1 # run driver in TLS-only mode";
				$f[] = "\$InputTCPServerStreamDriverAuthMode anon # client is NOT authenticated";
				$f[] = "";
				$f[] = "#\$DefaultNetstreamDriverCAFile /etc/rsyslog.d/ca.pem";
				$f[] = "#\$DefaultNetstreamDriver gtls # use gtls netstream driver";
				$f[] = "#\$ActionSendStreamDriverMode 1 # require TLS for the connection";
				$f[] = "#\$ActionSendStreamDriverAuthMode anon # server is NOT authenticated";
				$f[] = "#*.* @@(o)server.example.net:10514 # send (all) messages";
				$f[] = "";
			}
		}
	}

	$f[]="";
	$f[]="###########################";
	$f[]="#### GLOBAL DIRECTIVES ####";
	$f[]="###########################";
	$f[]="";
	$f[]="#";
	$f[]="# Use traditional timestamp format.";
	$f[]="# To enable high precision timestamps, comment out the following line.";
	$f[]="#";
	$f[]="\$ActionFileDefaultTemplate RSYSLOG_TraditionalFileFormat";
	$f[]="";
	$f[]="#";
	$f[]="# Set the default permissions for all log files.";
	$f[]="#";
	$f[]="\$FileOwner root";
	$f[]="\$FileGroup adm";
	$f[]="\$FileCreateMode 0640";
	$f[]="\$DirCreateMode 0755";
	$f[]="\$Umask 0022";
	$f[]="";
	$f[]="#";
	$f[]="# Include all config files in /etc/rsyslog.d/";
	$f[]="#";
	$f[]="\$IncludeConfig /etc/rsyslog.d/*.conf";
	$f[]="";
	$f[]="";
	$f[]="###############";
	$f[]="#### RULES ####";
	$f[]="###############";
	$f[]="";
	$f[]="#";
	$f[]="# First some standard log files.  Log by facility.";
	$f[]="#";
	$f[]="auth,authpriv.*			/var/log/auth.log";
	$f[]="*.*;auth,authpriv.none		-/var/log/syslog";
	$f[]="#cron.*				-/var/log/cron.log";
	$f[]="daemon.*				-/var/log/daemon.log";
	$f[]="kern.=debug 			-/var/log/iptables.log";
	$f[]="kern.*;kern.!=debug	-/var/log/kern.log";
	$f[]="lpr.*					-/var/log/lpr.log";
	$f[]="mail.*				-/var/log/mail.log";
	$f[]="user.*				-/var/log/user.log";
	$f[]="mail.info			-/var/log/mail.info";
	$f[]="mail.warn			-/var/log/mail.warn";
	$f[]="mail.err			/var/log/mail.err";
	$f[]="news.crit			/var/log/news/news.crit";
	$f[]="news.err			/var/log/news/news.err";
	$f[]="news.notice			-/var/log/news/news.notice";

	
	$f[]="";
	$f[]="#";
	$f[]="# Some \"catch-all\" log files.";
	$f[]="#";
	$f[]="*.=debug;\ ";
	$f[]="	auth,authpriv.none;\ ";
	$f[]="	news.none;mail.none	-/var/log/debug";
	$f[]="*.=info;*.=notice;*.=warn;\ ";
	$f[]="	auth,authpriv.none;\ ";
	$f[]="	cron,daemon.none;\ ";
	$f[]="	mail,news.none		-/var/log/messages";
	$f[]="";
	$f[]="#";
	$f[]="# Emergencies are sent to everybody logged in.";
	$f[]="#";
	$f[]="#*.emerg				*";
	$f[]="";
	$f[]="#";
	$f[]="# I like to have messages displayed on the console, but only on a virtual";
	$f[]="# console I usually leave idle.";
	$f[]="#";
	$f[]="#daemon,mail.*;\ ";
	$f[]="#	news.=crit;news.=err;news.=notice;\ ";
	$f[]="#	*.=debug;*.=info;\ ";
	$f[]="#	*.=notice;*.=warn	/dev/tty8";
	$f[]="";
	$f[]="# The named pipe /dev/xconsole is for the `xconsole' utility.  To use it,";
	$f[]="# you must invoke `xconsole' with the `-file' option:";
	$f[]="# ";
	$f[]="#    \$ xconsole -file /dev/xconsole [...]";
	$f[]="#";
	$f[]="# NOTE: adjust the list below, or you'll go crazy if you have a reasonably";
	$f[]="#      busy site..";
	$f[]="#";
	$f[]="daemon.*;mail.*;\ ";
	$f[]="	news.err;\ ";
	$f[]="	*.=debug;*.=info;\ ";
	$f[]="	*.=notice;*.=warn	|/dev/xconsole";
	$f[]="";
	@file_put_contents("/etc/rsyslog.conf", @implode("\n", $f)."\n");
	echo "Starting......: ".date("H:i:s")." [INIT]: Sylog daemon Building /etc/rsyslog.conf done\n";
	echo "Starting......: ".date("H:i:s")." [INIT]: Sylog daemon You can restart syslog by typing `".$unix->LOCATE_SYSLOG_INITD()." restart`\n";
	
	


	$h=array();
	$h[]="if ( \$syslogfacility-text == 'local5' ) then {";
	$h[]="\t-/var/log/squid/squidtail.log";
	$h[]="\t& stop";
	$h[]="}";
	$h[]="";
	@file_put_contents("/etc/rsyslog.d/stats-appliance.conf",@implode("\n", $h));

	$EnableUnboundLogSyslog=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableUnboundLogSyslog"));
	$UnboundLogSyslogServer=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundLogSyslogServer"));
	$UnboundLogSyslogDoNotStorelogsLocally=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundLogSyslogDoNotStorelogsLocally"));
	$UnboundLogSyslogServerPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundLogSyslogServerPort"));
	$UnboundLogSyslogServerTCP=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundLogSyslogServerTCP"));
	if($UnboundLogSyslogServerPort==0){$UnboundLogSyslogServerPort=514;}
	$UnboundLogSyslogUseSSL=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundLogSyslogUseSSL"));
	$UnboundLogSyslogCertificate=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundLogSyslogCertificate"));

	$FirewallSyslogUseSSL=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FirewallSyslogUseSSL"));
	$FirewallSyslogServer=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FirewallSyslogServer"));
	$FirewallSyslogServerTCP=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FirewallSyslogServerTCP"));
	$EnableFireWallLogSyslog=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableFireWallLogSyslog"));
	$FirewallSyslogServerPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FirewallSyslogServerPort"));
	$FirewallSyslogCertificate=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FirewallSyslogCertificate"));
	if($FirewallSyslogServerPort==0){$FirewallSyslogServerPort=514;}
	$FirewallSyslogDoNotStorelogsLocally=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FirewallSyslogDoNotStorelogsLocally"));


	if($ActAsASyslogServer==1){
		$EnableUnboundLogSyslog=1;
		$UnboundLogSyslogServer=null;
		$UnboundLogSyslogDoNotStorelogsLocally=0;
		$FirewallSyslogDoNotStorelogsLocally=0;
		$EnableFireWallLogSyslog=0;
	}
	if($EnableFireWallLogSyslog==0){
		$FirewallSyslogDoNotStorelogsLocally=0;
		$FirewallSyslogCertificate=null;
	}

	if($EnableUnboundLogSyslog==0){
		$UnboundLogSyslogDoNotStorelogsLocally=0;
	}

	
	$h=array();
	$h[] = "# ActAsASyslogServer = $ActAsASyslogServer";
	$h[] = "# EnableFireWallLogSyslog = $EnableFireWallLogSyslog";
	$h[]="";
	$h[]="if  (\$msg contains 'FIREHOL') then {";
	if($FirewallSyslogDoNotStorelogsLocally==0) {

		$h[] = "\t-/var/log/firewall.log";
	}

	$h[]=build_remote_syslog($EnableFireWallLogSyslog,
		$FirewallSyslogServerTCP,
		$FirewallSyslogUseSSL,
		$FirewallSyslogCertificate,
		$FirewallSyslogServer,
		$FirewallSyslogServerPort
	);

	$h[]="\t& stop";
	$h[]="}";
	$h[]="";
	@file_put_contents("/etc/rsyslog.d/firewall.conf",@implode("\n", $h));

	$h=array();
	$h[]="if  (\$programname =='sshd') then {";
	$h[]="\t-/var/log/sshd.log";
	$h[]="\t& stop";
	$h[]="}";
	$h[]="";
	@file_put_contents("/etc/rsyslog.d/sshd.conf",@implode("\n", $h));

	$h=array();
	$h[]="if  (\$programname =='proxy_geoip') then {";
	$h[]="\t-/var/log/proxy-geoip.log";
	$h[]="\t& stop";
	$h[]="}";
	$h[]="";
	@file_put_contents("/etc/rsyslog.d/proxy_geoip.conf",@implode("\n", $h));

	$h=array();
	$h[]="if  (\$programname =='unbound') then {";



	if($UnboundLogSyslogDoNotStorelogsLocally==0) {
		$h[] = "\t-/var/log/unbound.log";
	}

	$h[]=build_remote_syslog($EnableUnboundLogSyslog,
		$UnboundLogSyslogServerTCP,
		$UnboundLogSyslogUseSSL,
		$UnboundLogSyslogCertificate,
		$UnboundLogSyslogServer,
		$UnboundLogSyslogServerPort
	);

	$h[]="\t& stop";
	$h[]="}";
	$h[]="";
	@file_put_contents("/etc/rsyslog.d/unbound.conf",@implode("\n", $h));

	$h=array();
	$h[]="if  (\$programname =='class.process.inc') then {";
	$h[]="\t-/var/log/class.process.log";
	$h[]="\t& stop";
	$h[]="}";
	$h[]="";
	$h[]="if  (\$programname =='iscsid') then {";
	$h[]="\t-/var/log/iscsid.log";
	$h[]="\t& stop";
	$h[]="}";
	$h[]="";
	$h[]="if  (\$programname =='ntpd') then {";
	$h[]="\t-/var/log/ntpd.log";
	$h[]="\t& stop";
	$h[]="}";
	$h[]="";
	$h[]="if  (\$programname =='haproxy') then {";
	$h[]="\t-/var/log/haproxy.log";
	$h[]="\t& stop";
	$h[]="}";
	$h[]="";
	$h[]="if  (\$programname =='wpa_supplicant') then {";
	$h[]="\t-/var/log/wpa_supplicant.log";
	$h[]="\t& stop";
	$h[]="}";
	$h[]="";
	$h[]="if  (\$msg contains '%ASA-') then  {";
	$h[]="\t-/var/log/cisco-asa.log";
	$h[]="\t& stop";
	$h[]="}";

	@file_put_contents("/etc/rsyslog.d/class-process-inc.conf",@implode("\n", $h));
	
	if($GLOBALS["RELOAD"]){
		system("/etc/init.d/rsyslog restart");
	}
	
	if($GLOBALS["RESTART"]){
		system("/etc/init.d/rsyslog restart");
	}
	return true;


}


function build_client_mode(){
	$sock=new sockets();
	$ActAsASyslogClient=$sock->GET_INFO("ActAsASyslogClient");
	$ActAsASyslogSMTPClient=$sock->GET_INFO("ActAsASyslogSMTPClient");
	if(!is_numeric($ActAsASyslogSMTPClient)){$ActAsASyslogSMTPClient=0;}
	if(!is_numeric($ActAsASyslogClient)){$ActAsASyslogClient=0;}
	$EnableRemoteSyslogStatsAppliance=$sock->GET_INFO("EnableRemoteSyslogStatsAppliance");
	if(!is_numeric($EnableRemoteSyslogStatsAppliance)){$EnableRemoteSyslogStatsAppliance=0;}
	if($EnableRemoteSyslogStatsAppliance==1){$ActAsASyslogClient=1;}
	
	if(($ActAsASyslogClient==0) OR ($ActAsASyslogSMTPClient==0)){
		echo "Starting......: ".date("H:i:s")." syslog client parameters not defined, aborting tasks\n";
	}
	
	if(is_file("/etc/default/syslogd")){
		echo "Starting......: ".date("H:i:s")." syslog client old syslog mode\n";
		build_client_mode_debian();
		shell_exec("/etc/init.d/auth-tail restart");
		return;
	}
	
	if(is_dir("/etc/rsyslog.d")){
		echo "Starting......: ".date("H:i:s")." syslog client rsyslog mode\n";
		build_client_mode_ubuntu();
		shell_exec("/etc/init.d/auth-tail restart");
	}
}

function build_client_mode_ubuntu(){
	
	$sock=new sockets();
	$ActAsASyslogServer=$sock->GET_INFO("ActAsASyslogServer");
	$ActAsASyslogClient=$sock->GET_INFO("ActAsASyslogClient");
	$EnableRemoteSyslogStatsAppliance=$sock->GET_INFO("EnableRemoteSyslogStatsAppliance");
	$ActAsASyslogSMTPClient=$sock->GET_INFO("ActAsASyslogSMTPClient");
	if(!is_numeric($EnableRemoteSyslogStatsAppliance)){$EnableRemoteSyslogStatsAppliance=0;}	
	if(!is_numeric($ActAsASyslogClient)){$ActAsASyslogClient=0;}
	if(!is_numeric($ActAsASyslogSMTPClient)){$ActAsASyslogSMTPClient=0;}	
	if($EnableRemoteSyslogStatsAppliance==1){$ActAsASyslogClient=1;}
	
	
	
	$serversList=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ActAsASyslogClientServersList")));
	@unlink("/etc/rsyslog.d/artica-client.conf");
	$g[]="";

if($EnableRemoteSyslogStatsAppliance==1){
	$RemoteStatisticsApplianceSettings=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("RemoteStatisticsApplianceSettings")));
	if(isset($RemoteStatisticsApplianceSettings["SERVER"])){
		$s[]="authpriv.info\t@{$RemoteStatisticsApplianceSettings["SERVER"]}";
	}
	
	$RemoteSyslogAppliance=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("RemoteSyslogAppliance")));
	if(isset($RemoteSyslogAppliance["SERVER"])){
		$s[]="authpriv.info\t@{$RemoteSyslogAppliance["SERVER"]}";
	}
}

if($ActAsASyslogClient==1){
	if(count($serversList)>0){
		while (list ($num, $server) = each ($serversList) ){
			if($server==null){continue;}
			if(preg_match("#(.+?):([0-9]+)#",$server,$re)){$server=$re[1];}
			echo "Starting......: ".date("H:i:s")." syslog client $server (forced to 514 port)\n";
			$s[]="*.*\t@$server";
		}
	}
}

if($ActAsASyslogSMTPClient==1){
	$serversList=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ActAsASyslogClientSMTPList")));
	if(count($serversList)>0){
		while (list ($num, $server) = each ($serversList) ){
			if($server==null){continue;}
			if(preg_match("#(.+?):([0-9]+)#",$server,$re)){$server=$re[1];}
			echo "Starting......: ".date("H:i:s")." syslog mail.* client $server (forced to 514 port)\n";
			$s[]="mail.*\t@$server";
		}
	}	
}


$g[]="";

if(is_array($s)){
	$final=@implode("\n",$s)."\n".@implode("\n",$g);
}else{
	$final=@implode("\n",$g);
}

@file_put_contents("/etc/rsyslog.d/artica-client.conf",$final);
echo "Starting......: ".date("H:i:s")." syslog client /etc/rsyslog.d/artica-client.conf done\n";

@unlink("/etc/rsyslog.d/artica-authpriv.conf");
if(!ParseDirAuthpriv("/etc/rsyslog.d")){
	@file_put_contents("/etc/rsyslog.d/artica-authpriv.conf","authpriv.*			/var/log/auth.log");
}

restart_syslog();	
	
	
}

function ParseDirAuthpriv($dirname){
	foreach (glob("$dirname/*") as $filename) {
		if(CheckAuthAuthpriv($filename)){return true;}
	}
	return false;
	
}


function CheckAuthAuthpriv($filename){
	$f=explode("\n", @file_get_contents($filename));
	while (list ($num, $line) = each ($f) ){
		if(preg_match("#authpriv#", $line)){echo "Starting......: ".date("H:i:s")." syslog client $filename has Authpriv\n";return true;}
	}
	return false;
}





function build_localx_servers(){
	
	for($i=0;$i<8;$i++){
		@unlink("/etc/rsyslog.d/artica-server-local$i.conf");
		
	}
	
	$sock=new sockets();
	$datas=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SyslogLocals")));
	while (list ($local, $path) = each ($datas) ){
		if(!preg_match("#\.[a-z]+$#", $path)){
			$path=$path."/$local.log";
		}
		@file_put_contents("/etc/rsyslog.d/artica-server-$local.conf", "$local.*\t-$path\n");
	}
	rsyslog_check_includes();
	restart_syslog();
	
}



function build_client_mode_debian(){
	
	$sock=new sockets();
	$ActAsASyslogServer=$sock->GET_INFO("ActAsASyslogServer");
	$ActAsASyslogClient=$sock->GET_INFO("ActAsASyslogClient");
	$ActAsASyslogSMTPClient=$sock->GET_INFO("ActAsASyslogSMTPClient");
		
	$EnableRemoteSyslogStatsAppliance=$sock->GET_INFO("EnableRemoteSyslogStatsAppliance");
	if(!is_numeric($EnableRemoteSyslogStatsAppliance)){$EnableRemoteSyslogStatsAppliance=0;}	
	if(!is_numeric($ActAsASyslogClient)){$ActAsASyslogClient=0;}
	if(!is_numeric($ActAsASyslogServer)){$ActAsASyslogServer=0;}	
	if(!is_numeric($ActAsASyslogSMTPClient)){$ActAsASyslogSMTPClient=0;}
	if($EnableRemoteSyslogStatsAppliance==1){$ActAsASyslogClient=1;}
	
	
	$serversList=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ActAsASyslogClientServersList")));
	$f=explode("\n",@file_get_contents("/etc/syslog.conf"));
	while (list ($num, $line) = each ($f) ){
		if(preg_match("#\.+?\.\.+?\s+@#",$line,$re)){
			$f[$num]=null;
			echo "Starting......: ".date("H:i:s")." syslog client removing $line\n";
		}
	}
	
	reset($f);
	while (list ($num, $line) = each ($f) ){
		if(trim($line)==null){continue;}
		$g[]=$line;
	}
$g[]="";

if($EnableRemoteSyslogStatsAppliance==1){
	$RemoteStatisticsApplianceSettings=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("RemoteStatisticsApplianceSettings")));
	if(isset($RemoteStatisticsApplianceSettings["SERVER"])){
		$s[]="authpriv.info\t@{$RemoteStatisticsApplianceSettings["SERVER"]}";
	}
	
	$RemoteSyslogAppliance=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("RemoteSyslogAppliance")));
	if(isset($RemoteSyslogAppliance["SERVER"])){
		$s[]="authpriv.info\t@{$RemoteSyslogAppliance["SERVER"]}";
	}
}

if($ActAsASyslogClient==1){
	if(count($serversList)>0){
		while (list ($num, $server) = each ($serversList) ){
			if($server==null){continue;}
			if(preg_match("#(.+?):([0-9]+)#",$server,$re)){$server=$re[1];}
			echo "Starting......: ".date("H:i:s")." syslog client $server (forced to 514 port)\n";
			$s[]="*.*\t@$server";
		}
	}
}

if($ActAsASyslogSMTPClient==1){
	$serversList=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ActAsASyslogClientSMTPList")));
	if(count($serversList)>0){
		while (list ($num, $server) = each ($serversList) ){
			if($server==null){continue;}
			if(preg_match("#(.+?):([0-9]+)#",$server,$re)){$server=$re[1];}
			echo "Starting......: ".date("H:i:s")." syslog mail.* client $server (forced to 514 port)\n";
			$s[]="mail.*\t@$server";
		}
	}	
}




$g[]="";

if(is_array($s)){
	$final=@implode("\n",$s)."\n".@implode("\n",$g);
}else{
	$final=@implode("\n",$g);
}

@file_put_contents("/etc/syslog.conf",$final);
echo "Starting......: ".date("H:i:s")." syslog client /etc/syslog.conf done\n";
restart_syslog();	
	
	
}




function rsyslog_pid(){
	$GLOBALS["CLASS_UNIX"]=new unix();
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/rsyslogd.pid");
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return $pid;}
	$rsyslogd=$GLOBALS["CLASS_UNIX"]->find_program("rsyslogd");
	return $GLOBALS["CLASS_UNIX"]->PIDOF($rsyslogd);

}


function restart_syslog(){
	if($GLOBALS["NORESTART"]){return;}
	echo "Starting......: ".date("H:i:s")." syslog restart daemon\n";
	$unix=new unix();
	$sysloginit=$unix->LOCATE_SYSLOG_INITD();
	if(!is_file($sysloginit)){echo "Starting......: ".date("H:i:s")." syslog init.d/*? no such file\n";
	build_progress_restart(110,"init.d no such file");
	return;}

	build_progress_restart(10,"{configuring}");
	rsyslog_check_includes();

	$pid1=rsyslog_pid();
	build_progress_restart(20,"{restarting} PID:$pid1");
	exec("$sysloginit restart 2>&1",$results);
	foreach ($results as $num=>$line){
		if(trim($line)==null){continue;}
		echo "Starting......: ".date("H:i:s")." syslog $line\n";
	}
	$pid2=rsyslog_pid();

	if($pid1==$pid2){
		build_progress_restart(110,"{restarting} PID:$pid1 {failed} detected $pid2");
		return;
	}
	if(is_file("/etc/init.d/artica-syslog")) {
		build_progress_restart(30,"{restarting} artica-syslog");
		shell_exec("/etc/init.d/artica-syslog restart");
	}

	if(is_file("/etc/init.d/auth-tail")) {
		build_progress_restart(40,"{restarting} auth-tail");
		shell_exec("/etc/init.d/auth-tail restart");
	}
	
	$squidbin=$unix->LOCATE_SQUID_BIN();
	$SQUIDEnable=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable");
	if($SQUIDEnable==1) {
		if (is_file($squidbin)) {
			build_progress_restart(40,"{reloading} {APP_SQUID}");
			squid_admin_mysql(2, "Reloading Proxy service (" . __FUNCTION__ . ")", null, __FILE__, __LINE__);
			shell_exec("/etc/init.d/squid reload --script=" . basename(__FILE__) . " >/dev/null 2>&1");
		}
	}

	$EnablePostfix=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnablePostfix");
	if($EnablePostfix==1) {
		$postfix = $unix->find_program("postfix");
		if (is_file($postfix)) {
			build_progress_restart(50,"{reloading} {APP_POSTFIX}");
			shell_exec("$postfix reload >/dev/null 2>&1");
		}
	}
	build_progress_restart(100,"{restarting} {success}");
	return true;
		
}

function locate_rsyslog_lib(){
	if(is_file("/usr/lib/rsyslog/imudp.so")){return "/usr/lib/rsyslog";}
	if(is_file("/usr/lib64/rsyslog/imudp.so")){return "/usr/lib64/rsyslog";}
	if(is_file("/lib/rsyslog/imudp.so")){return "/lib/rsyslog";}
	if(is_file("/lib64/rsyslog/imudp.so")){return "/lib64/rsyslog";}
	
}


function admin_logs(){
	
	if(system_is_overloaded()){return;}
	
	
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pid=@file_get_contents($pidfile);
	if($unix->process_exists($pid)){writelogs("Already running pid $pid",__FUNCTION__,__FILE__,__LINE__);return;}	
	$t=0;
	include_once(dirname(__FILE__) . '/ressources/class.mysql.inc');
	$q=new mysql();
	foreach (glob("{$GLOBALS["ARTICALOGDIR"]}/adminevents/*") as $filename) {
		$sql=@file_get_contents($filename);
		if(trim($sql)==null){@unlink($filename);}
		$q->QUERY_SQL($sql,"artica_events");
		if(!$q->ok){writelogs("Fatal, $q->mysql_error",__FUNCTION__,__FILE__,__LINE__);
		continue;}
		@unlink($filename);
	}
	
	ps_mem();
		
}


function checks_squid_admin_mysql($nopid=false){
	squid_admin_mysql_check($nopid);
}


function checks_hotspot_admin_mysql($nopid=false){
}

function scan_queue($nopid=false){
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pidTime="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".time";
	$unix=new unix();
	
	if(!$GLOBALS["VERBOSE"]) {
		if ($nopid) {
			$pid = @file_get_contents($pidfile);
			if ($unix->process_exists($pid)) {
				writelogs("Already running pid $pid", __FUNCTION__, __FILE__, __LINE__);
				return;
			}
			$t = 0;
		}

		$pids = $unix->PIDOF_PATTERN_ALL("exec.syslog-engine.php --admin-evs");
		if (count($pids) > 1) {
			writelogs("2 instances already runnin.. aborting", __FUNCTION__, __FILE__, __LINE__);
			return;
		}

		$TimeExec = $unix->file_time_min($pidTime);
		if ($TimeExec < 5) {
			echo "Only each 5 m ({$TimeExec}mn)\n";
			return;
		}
	}
	
	@unlink($pidTime);
	@file_put_contents($pidTime, time());
	@file_put_contents($pidfile, getmypid());
	blackwhite_admin_mysql_check(true);
	squid_admin_notifs_check(true);
	
	haproxy_events();
	sys_load();
	squid_admin_mysql_check(true);
	vsftpd_admin_mysql_check(true);
	squid_admin_mysql_check(true);
	squid_admin_mysql_check(true);
	nginx_admin_mysql_check(true);
	system_admin_events_checks(true);
	checks_hotspot_admin_mysql(true);
	checks_squid_admin_mysql(true);
	squid_admin_mysql_check(true);
	rotate_admin_events_checks(true);
	clean_mysql_events(true);
	seeker();
	
	
	
	
}





function squid_admin_mysql_check($nopid=false){
	if(isset($GLOBALS["squid_admin_mysql_check_checked"])){return;}
	$GLOBALS["squid_admin_mysql_check_checked"]=true;
	
	$f=array();
	$unix=new unix();
	
	
	
	if($nopid){

		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=@file_get_contents($pidfile);
		if($unix->process_exists($pid)){writelogs("Already running pid $pid",__FUNCTION__,__FILE__,__LINE__);return;}
		$t=0;

	}



	$BaseWorkDir="{$GLOBALS["ARTICALOGDIR"]}/squid_admin_mysql";
	if(!is_dir($BaseWorkDir)){return;}
	if (!$handle = opendir($BaseWorkDir)) {echo "Failed open $BaseWorkDir\n";return;}
	

	$q=new lib_sqlite("/home/artica/SQLITE/system_events.db");
	@chmod("/home/artica/SQLITE/system_events.db", 0644);
	@chown("/home/artica/SQLITE/system_events.db", "www-data");
	$sql="CREATE TABLE IF NOT EXISTS `squid_admin_mysql` (
			`ID` INTEGER PRIMARY KEY AUTOINCREMENT,
			`zDate` int,
			`content` text,
			`subject` text,
			`function` text,
			`filename` text,
			`line` int,
			`severity` int,
			`TASKID` int)";
	$q->QUERY_SQL($sql);
	if(!$q->ok){echo $q->mysql_error."\n";return;}

	$sql="CREATE TABLE IF NOT EXISTS `ntlm_admin_mysql` (
			`ID` INTEGER PRIMARY KEY AUTOINCREMENT,
			`zDate` int,
			`content` text,
			`subject` text,
			`function` text,
			`filename` text,
			`line` int,
			`severity` int,
			`TASKID` int)";
	$q->QUERY_SQL($sql);
	if(!$q->ok){echo $q->mysql_error."\n";return;}
	



	while (false !== ($filename = readdir($handle))) {
		if($filename=="."){continue;}
		if($filename==".."){continue;}
		$targetFile="$BaseWorkDir/$filename";
		if($unix->file_time_min($targetFile)>240){@unlink($targetFile);continue;}
		$array=unserialize(@file_get_contents($targetFile));
		if(!is_array($array)){@unlink($targetFile);continue;}

		if(!is_numeric($array["TASKID"])){$array["TASKID"]=0;}
		$file=$array["file"];
		$unix->_syslog($array["subject"],basename($file));
		$content=str_replace("'", "''", $array["text"]);
		$subject=str_replace("'", "''", $array["subject"]);
		
		

		$zdate=strtotime($array["zdate"]);
		$zdate=str_replace("'","",$zdate);
		$function=$array["function"];
		$file=$array["file"];
		$line=$array["line"];
		$TASKID=$array["TASKID"];
		$severity=$array["severity"];
		$content=str_replace("'", "`", $content);
		$subject=str_replace("'", "`", $subject);

		if(preg_match("#(Active directory|NTLM|KERBEROS)#i",$subject)){
			$q->QUERY_SQL("INSERT OR IGNORE INTO `ntlm_admin_mysql` 
			(`zDate`,`content`,`subject`,`function`,`filename`,`line`,`severity`) 
			VALUES ('$zdate','$content','$subject','$function','$file','$line','$severity')");
			if(!$q->ok){$unix->_syslog($q->mysql_error,basename(__FILE__));}
			@unlink($targetFile);
			continue;
		}



		$q->QUERY_SQL("INSERT OR IGNORE INTO `squid_admin_mysql` (`zDate`,`content`,`subject`,`function`,`filename`,`line`,`severity`) VALUES ('$zdate','$content','$subject','$function','$file','$line','$severity')");




		if(!$q->ok){$unix->_syslog($q->mysql_error,basename(__FILE__));}

		@unlink($targetFile);

	}

}






function rotate_admin_events_checks($nopid=false){
	$f=array();
	$unix=new unix();

	$BaseWorkDir="{$GLOBALS["ARTICALOGDIR"]}/rotate_admin_events";
	if(!is_dir($BaseWorkDir)){return;}
	if (!$handle = opendir($BaseWorkDir)) {echo "Failed open $BaseWorkDir\n";return;}
	
	$sock=new sockets();
	$users=new usersMenus();
	$hostname=$unix->hostname_g();
	
	
	
	
	
	$hostname=$unix->hostname_g();
	$q=new mysql();
	if(!$q->test_mysqli_connection()){
		if($GLOBALS["VERBOSE"]){echo " **** rotate_admin_events_checks() test_mysqli_connection() FAILED **** \n";}
		return;}
	
	
	$sql="CREATE TABLE IF NOT EXISTS `artica_events`.`rotate_admin_events` (
	`zDate` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
	`description` MEDIUMTEXT NOT NULL ,
	`function` VARCHAR( 60 ) NOT NULL ,
	`filename` VARCHAR( 50 ) NOT NULL ,
	`line` INT( 10 ) NOT NULL ,
	`category` VARCHAR( 50 ) NOT NULL ,
	`TASKID` INT(10) NOT NULL,
	KEY  `zDate` ( `zDate`),
	KEY `function` (`function`),
	KEY `filename` (`filename`),
	KEY `line` (`line`),
	KEY `TASKID` (`TASKID`),
	KEY `category` (`category`)
	) ENGINE=MYISAM;";
	$q->QUERY_SQL($sql,"artica_events");
	
	if(!$q->FIELD_EXISTS("rotate_admin_events", "hostname", "artica_events")){
		$q->QUERY_SQL("ALTER TABLE `rotate_admin_events` ADD `hostname` VARCHAR( 255 ),ADD INDEX ( `hostname` )","artica_events");
	}
	
	if($GLOBALS["VERBOSE"]){echo " **** rotate_admin_events_checks() START LOOP ON $BaseWorkDir **** \n";}
	while (false !== ($filename = readdir($handle))) {
		if($filename=="."){continue;}
		if($filename==".."){continue;}
		
		$targetFile="$BaseWorkDir/$filename";
		
		
		if($unix->file_time_min($targetFile)>240){@unlink($targetFile);continue;}
		if($GLOBALS["VERBOSE"]){echo " **** $targetFile PARSE **** \n";}
		
		
		$array=unserialize(@file_get_contents($targetFile));
		if(!is_array($array)){@unlink($targetFile);continue;}
	
		if(!is_numeric($array["TASKID"])){$array["TASKID"]=0;}
		$content=mysql_escape_string2($array["text"]);
		
		$zdate=$array["zdate"];
		$function=$array["function"];
		$file=$array["file"];
		$line=$array["line"];
		$TASKID=$array["TASKID"];
		$category=$array["category"];
	
		$q->QUERY_SQL("INSERT IGNORE INTO `rotate_admin_events`
				(`zDate`,`description`,`function`,`filename`,`line`,`category`,`hostname`,`TASKID`) VALUES
				('$zdate','$content','$function','$file','$line','$category','$hostname','$TASKID')","artica_events");
	
		if(!$q->ok){continue;}
	
		@unlink($targetFile);
	
	}	

}

function rdpproxy_admin_mysql_check($nopid=false){
	$f=array();
	$unix=new unix();


	$sock=new sockets();
	$users=new usersMenus();
	$hostname=$unix->hostname_g();
	$BaseWorkDir="{$GLOBALS["ARTICALOGDIR"]}/rdpproxy_admin_mysql";

	if (!$handle = opendir($BaseWorkDir)) {return;}


	$hostname=$unix->hostname_g();
	$q=new mysql();
	if(!$q->test_mysqli_connection()){return;}


	$sql="CREATE TABLE IF NOT EXISTS `artica_events`.`rdpproxy_admin_mysql` (
		`ID` int(11) NOT NULL AUTO_INCREMENT,
		`zDate` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
		`content` MEDIUMTEXT NOT NULL ,
		`hostname` VARCHAR( 255 ),
		`subject` VARCHAR( 255 ) NOT NULL ,
		`function` VARCHAR( 60 ) NOT NULL ,
		`filename` VARCHAR( 50 ) NOT NULL ,
		`line` INT( 10 ) NOT NULL ,
		`severity` smallint( 1 ) NOT NULL ,
		`TASKID` BIGINT UNSIGNED ,
		PRIMARY KEY (`ID`),
		  KEY `zDate` (`zDate`),
		  KEY `subject` (`subject`),
		  KEY `hostname` (`hostname`),
		  KEY `function` (`function`),
		  KEY `filename` (`filename`),
		  KEY `severity` (`severity`)
		) ENGINE=MYISAM;";
	$q->QUERY_SQL($sql,"artica_events");
	if(!$q->ok){echo $q->mysql_error."\n";return;}



	while (false !== ($filename = readdir($handle))) {
		if($filename=="."){continue;}
		if($filename==".."){continue;}
		$targetFile="$BaseWorkDir/$filename";
		if($GLOBALS["VERBOSE"]){echo "rdpproxy_admin_mysql_check:: $targetFile\n";}
		if($unix->file_time_min($targetFile)>240){@unlink($targetFile);continue;}
		$array=unserialize(@file_get_contents($targetFile));
		if(!is_array($array)){@unlink($targetFile);continue;}

		if(!is_numeric($array["TASKID"])){$array["TASKID"]=0;}
		$content=mysql_escape_string2($array["text"]);
		$subject=mysql_escape_string2($array["subject"]);

		$zdate=$array["zdate"];
		$function=$array["function"];
		$file=$array["file"];
		$line=$array["line"];
		$TASKID=$array["TASKID"];
		$severity=$array["severity"];

		$q->QUERY_SQL("INSERT IGNORE INTO `rdpproxy_admin_mysql`
				(`zDate`,`content`,`subject`,`function`,`filename`,`line`,`severity`,`hostname`) VALUES
				('$zdate','$content','$subject','$function','$file','$line','$severity','$hostname')","artica_events");

		if(!$q->ok){
			if($GLOBALS["VERBOSE"]){echo "rdpproxy_admin_mysql_check:: $q->mysql_error\n";}
			return;}

		@unlink($targetFile);

	}

}


function blackwhite_admin_mysql_check($nopid=false){
	$f=array();
	$unix=new unix();
	if($nopid){
	
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=@file_get_contents($pidfile);
		if($unix->process_exists($pid)){writelogs("Already running pid $pid",__FUNCTION__,__FILE__,__LINE__);return;}
		$t=0;
	
	}
	
	$sock=new sockets();
	$users=new usersMenus();
	$hostname=$unix->hostname_g();
	$BaseWorkDir="{$GLOBALS["ARTICALOGDIR"]}/blackwhite_admin_mysql";
	if(!is_dir($BaseWorkDir)){return; }
	if (!$handle = opendir($BaseWorkDir)) {echo "Failed open $BaseWorkDir\n";return;}
	
	
	$hostname=$unix->hostname_g();
	$q=new mysql();
	if(!$q->test_mysqli_connection()){return;}
	
	
	$sql="CREATE TABLE IF NOT EXISTS `artica_events`.`blackwhite_admin_mysql` (
		`ID` int(11) NOT NULL AUTO_INCREMENT,
		`zDate` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
		`content` MEDIUMTEXT NOT NULL ,
		`hostname` VARCHAR( 255 ),
		`subject` VARCHAR( 255 ) NOT NULL ,
		`function` VARCHAR( 60 ) NOT NULL ,
		`filename` VARCHAR( 50 ) NOT NULL ,
		`line` INT( 10 ) NOT NULL ,
		`severity` smallint( 1 ) NOT NULL ,
		`TASKID` BIGINT UNSIGNED ,
		PRIMARY KEY (`ID`),
		  KEY `zDate` (`zDate`),
		  KEY `subject` (`subject`),
		  KEY `hostname` (`hostname`),
		  KEY `function` (`function`),
		  KEY `filename` (`filename`),
		  KEY `severity` (`severity`)
		) ENGINE=MYISAM;";
	$q->QUERY_SQL($sql,"artica_events");
	if(!$q->ok){echo $q->mysql_error."\n";return;}
	
	if(!$q->FIELD_EXISTS("blackwhite_admin_mysql", "hostname", "artica_events")){
		$q->QUERY_SQL("ALTER TABLE `squid_admin_mysql` ADD `hostname` VARCHAR( 255 ),ADD INDEX ( `hostname` )","artica_events");
	}	
	
	while (false !== ($filename = readdir($handle))) {
		if($filename=="."){continue;}
		if($filename==".."){continue;}
		$targetFile="$BaseWorkDir/$filename";
		if($unix->file_time_min($targetFile)>240){@unlink($targetFile);continue;}
		$array=unserialize(@file_get_contents($targetFile));
		if(!is_array($array)){@unlink($targetFile);continue;}
	
		if(!is_numeric($array["TASKID"])){$array["TASKID"]=0;}
		$content=mysql_escape_string2($array["text"]);
		$subject=mysql_escape_string2($array["subject"]);
	
		$zdate=$array["zdate"];
		$function=$array["function"];
		$file=$array["file"];
		$line=$array["line"];
		$TASKID=$array["TASKID"];
		$severity=$array["severity"];
	
		$q->QUERY_SQL("INSERT IGNORE INTO `blackwhite_admin_mysql`
				(`zDate`,`content`,`subject`,`function`,`filename`,`line`,`severity`,`hostname`) VALUES
				('$zdate','$content','$subject','$function','$file','$line','$severity','$hostname')","artica_events");
	
		if(!$q->ok){return;}
	
		@unlink($targetFile);
	
	}	
	
}




function meta_events($text,$function,$file=null,$line=0){
	if($file==null){$file=basename(__FILE__);}else{$file=basename($file);}
	$pid=@getmypid();
	$date=@date("H:i:s");
	$logFile="/var/log/artica-meta-agent.log";
	$size=@filesize($logFile);
	if($size>1000000){@unlink($logFile);}
	$f = @fopen($logFile, 'a');
	$text="[$file][$pid] $date $function:: $text (L.$line)\n";
	if($GLOBALS["VERBOSE"]){echo $text;}
	@fwrite($f, $text);
	@fclose($f);

	$logFile="/var/log/artica-meta.log";
	$size=@filesize($logFile);
	if($size>1000000){@unlink($logFile);}
	$f = @fopen($logFile, 'a');
	@fwrite($f, $text);
	@fclose($f);


}



function meta_client_clean_logs(){
	$BaseWorkDir="/home/artica-meta/events";
	if(!is_dir($BaseWorkDir)){return;}
	if (!$handle = opendir($BaseWorkDir)) {echo "Failed open $BaseWorkDir\n";return;}
	
	while (false !== ($filename = readdir($handle))) {
		if($filename=="."){continue;}
		if($filename==".."){continue;}
		$targetFile="$BaseWorkDir/$filename";
		if(is_dir($targetFile)){continue;}
		@unlink($targetFile);
	}
	
}



function nginx_admin_mysql_check($nopid=false){
	$f=array();
	$unix=new unix();



	$BaseWorkDir="{$GLOBALS["ARTICALOGDIR"]}/nginx_admin_mysql";
	if(!is_dir($BaseWorkDir)){return;}
	if (!$handle = opendir($BaseWorkDir)) {echo "Failed open $BaseWorkDir\n";return;}

	$sock=new sockets();
	$users=new usersMenus();
	$hostname=$unix->hostname_g();

	$q=new mysql();
	if(!$q->test_mysqli_connection()){return;}


	$sql="CREATE TABLE IF NOT EXISTS `artica_events`.`nginx_admin_mysql` (
		`ID` int(11) NOT NULL AUTO_INCREMENT,
		`zDate` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
		`content` MEDIUMTEXT NOT NULL ,
		`hostname` VARCHAR( 255 ),
		`subject` VARCHAR( 255 ) NOT NULL ,
		`function` VARCHAR( 60 ) NOT NULL ,
		`filename` VARCHAR( 50 ) NOT NULL ,
		`line` INT( 10 ) NOT NULL ,
		`severity` smallint( 1 ) NOT NULL ,
		`sended` smallint( 1 ) NOT NULL DEFAULT 0,
		`TASKID` BIGINT UNSIGNED ,
		PRIMARY KEY (`ID`),
		  KEY `zDate` (`zDate`),
		  KEY `subject` (`subject`),
		  KEY `hostname` (`hostname`),
		  KEY `function` (`function`),
		  KEY `filename` (`filename`),
		  KEY `sended` (`sended`),
		  KEY `severity` (`severity`)
		) ENGINE=MYISAM;";
	$q->QUERY_SQL($sql,"artica_events");
	if(!$q->ok){echo $q->mysql_error."\n";return;}

	if(!$q->FIELD_EXISTS("nginx_admin_mysql", "hostname", "artica_events")){
		$q->QUERY_SQL("ALTER TABLE `nginx_admin_mysql` ADD `hostname` VARCHAR( 255 ),ADD INDEX ( `hostname` )","artica_events");
	}
	if(!$q->FIELD_EXISTS("nginx_admin_mysql", "sended", "artica_events")){
		$q->QUERY_SQL("ALTER TABLE `nginx_admin_mysql` ADD `sended` smallint(1) NOT NULL DEFAULT 0,ADD INDEX ( `sended` )","artica_events");
	}


	while (false !== ($filename = readdir($handle))) {
		if($filename=="."){continue;}
		if($filename==".."){continue;}
		$targetFile="$BaseWorkDir/$filename";
		if($unix->file_time_min($targetFile)>240){@unlink($targetFile);continue;}
		$array=unserialize(@file_get_contents($targetFile));
		if(!is_array($array)){@unlink($targetFile);continue;}

		if(!is_numeric($array["TASKID"])){$array["TASKID"]=0;}
		$content=mysql_escape_string2($array["text"]);
		$subject=mysql_escape_string2($array["subject"]);

		$zdate=$array["zdate"];
		$function=$array["function"];
		$file=$array["file"];
		$line=$array["line"];
		$TASKID=$array["TASKID"];
		$severity=$array["severity"];

		$q->QUERY_SQL("INSERT IGNORE INTO `nginx_admin_mysql`
				(`zDate`,`content`,`subject`,`function`,`filename`,`line`,`severity`,`hostname`) VALUES
				('$zdate','$content','$subject','$function','$file','$line','$severity','$hostname')","artica_events");

		if(!$q->ok){return;}

		@unlink($targetFile);

	}

	
}



function squid_admin_notifs_check($nopid=false){
	squid_admin_mysql_check(true);
}


// {$GLOBALS["ARTICALOGDIR"]}/system_failover_events
function system_failover_events_checks($nopid=false){
	$f=array();
	if($nopid){
		$unix=new unix();
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=@file_get_contents($pidfile);
		if($unix->process_exists($pid)){writelogs("Already running pid $pid",__FUNCTION__,__FILE__,__LINE__);return;}
		$t=0;
		@file_put_contents($pidfile, getmypid());
	}
	
	$BaseWorkDir="{$GLOBALS["ARTICALOGDIR"]}/system_failover_events";
	if (!$handle = opendir($BaseWorkDir)) {echo "Failed open $BaseWorkDir\n";return;}
	
	$q=new mysql();
	
	$prefix="INSERT IGNORE INTO system_failover_events (`zDate`,`function`,`filename`,`line`,`description`) VALUES ";
	while (false !== ($filename = readdir($handle))) {
		if($filename=="."){continue;}
		if($filename==".."){continue;}
		$targetFile="$BaseWorkDir/$filename";
		$array=unserialize(@file_get_contents($targetFile));
		if(!is_array($array)){
			$array["text"]=basename($filename)." is not an array, skip event \n".@file_get_contents($targetFile);
			$array["zdate"]=date('Y-m-d H:i:s');
			$array["pid"]=getmypid();
			$array["function"]=__FUNCTION__;
			$array["category"]="none";
			$array["file"]=basename(__FILE__);
			$array["line"]=__LINE__;
		}
			
			
		while (list ($key, $val) = each ($array)){
			$val=mysql_escape_string2($val);
			$array[$key]=str_replace("'", "`", $val);
		}
	
		$suffix="('{$array["zdate"]}','{$array["function"]}','{$array["file"]}','{$array["line"]}','{$array["text"]}')";
		if(count($f)>1500){
			$q->QUERY_SQL($prefix.$suffix);
			$f=array();
		}
		
	
		@unlink($targetFile);
	}
	
	if(count($f)>0){
		$q->QUERY_SQL($prefix.@implode(",", $f));
		$f=array();
	}
	

	
	
}

function system_admin_events_checks($nopid=false){
	$f=array();
	$unix=new unix();
	$TRW=array();
	if($nopid){
		$unix=new unix();
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=@file_get_contents($pidfile);
		if($unix->process_exists($pid)){writelogs("Already running pid $pid",__FUNCTION__,__FILE__,__LINE__);return;}	
		$t=0;		
		@file_put_contents($pidfile, getmypid());
	}	
	

	$BaseWorkDir="{$GLOBALS["ARTICALOGDIR"]}/system_admin_events";
	if(!is_dir($BaseWorkDir)){return;}
	if (!$handle = opendir($BaseWorkDir)) {echo "Failed open $BaseWorkDir\n";return;}
	while (false !== ($filename = readdir($handle))) {
			if($filename=="."){continue;}
			if($filename==".."){continue;}
			$targetFile="$BaseWorkDir/$filename";
			if(is_dir($targetFile)){continue;}
			@unlink($targetFile);
		}
		
	return;

}



function vsftpd_admin_mysql_check($nopid=false){
	$f=array();
	$unix=new unix();
	if($nopid){
	
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=@file_get_contents($pidfile);
		if($unix->process_exists($pid)){writelogs("Already running pid $pid",__FUNCTION__,__FILE__,__LINE__);return;}
		$t=0;
	
	}
	
	$sock=new sockets();
	$users=new usersMenus();
	$hostname=$unix->hostname_g();
	$BaseWorkDir="{$GLOBALS["ARTICALOGDIR"]}/vsftpd_admin_mysql";
	if(!is_dir($BaseWorkDir)){return;}
	if (!$handle = opendir($BaseWorkDir)) {echo "Failed open $BaseWorkDir\n";return;}
	
	
	$hostname=$unix->hostname_g();
	$q=new mysql();
	if(!$q->test_mysqli_connection()){return;}
	
	
	$sql="CREATE TABLE IF NOT EXISTS `artica_events`.`vsftpd_admin_mysql` (
		`ID` int(11) NOT NULL AUTO_INCREMENT,
		`zDate` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
		`content` MEDIUMTEXT NOT NULL ,
		`hostname` VARCHAR( 255 ),
		`subject` VARCHAR( 255 ) NOT NULL ,
		`function` VARCHAR( 60 ) NOT NULL ,
		`filename` VARCHAR( 50 ) NOT NULL ,
		`line` INT( 10 ) NOT NULL ,
		`severity` smallint( 1 ) NOT NULL ,
		`TASKID` BIGINT UNSIGNED ,
		PRIMARY KEY (`ID`),
		  KEY `zDate` (`zDate`),
		  KEY `subject` (`subject`),
		  KEY `hostname` (`hostname`),
		  KEY `function` (`function`),
		  KEY `filename` (`filename`),
		  KEY `severity` (`severity`)
		) ENGINE=MYISAM;";
	$q->QUERY_SQL($sql,"artica_events");
	if(!$q->ok){echo $q->mysql_error."\n";return;}

	
	
	while (false !== ($filename = readdir($handle))) {
		if($filename=="."){continue;}
		if($filename==".."){continue;}
		$targetFile="$BaseWorkDir/$filename";
		if($unix->file_time_min($targetFile)>240){@unlink($targetFile);continue;}
		$array=unserialize(@file_get_contents($targetFile));
		if(!is_array($array)){@unlink($targetFile);continue;}
	
		if(!is_numeric($array["TASKID"])){$array["TASKID"]=0;}
		$content=mysql_escape_string2($array["text"]);
		$subject=mysql_escape_string2($array["subject"]);
	
		$zdate=$array["zdate"];
		$function=$array["function"];
		$file=$array["file"];
		$line=$array["line"];
		$TASKID=$array["TASKID"];
		$severity=$array["severity"];
	
		$q->QUERY_SQL("INSERT IGNORE INTO `vsftpd_admin_mysql`
				(`zDate`,`content`,`subject`,`function`,`filename`,`line`,`severity`,`hostname`) VALUES
				('$zdate','$content','$subject','$function','$file','$line','$severity','$hostname')","artica_events");
	
		if(!$q->ok){return;}
	
		@unlink($targetFile);
	
	}
	
	
}


function sarg_admin_events_checks($nopid=false){
	$f=array();
	$unix=new unix();

	if(!is_dir("{$GLOBALS["ARTICALOGDIR"]}/sarg_admin_events")){return;}
	$q=new mysql();
	$q->BuildTables();
	
	$prefix="INSERT IGNORE INTO sarg_admin_events 
			(`zDate`,`function`,`filename`,`line`,`description`,`category`,`TASKID`) VALUES ";

	
	if (!$handle = opendir("{$GLOBALS["ARTICALOGDIR"]}/sarg_admin_events")){return;}

	$countDeFiles=0;
	while (false !== ($filename = readdir($handle))) {
		if($filename=="."){continue;}
		if($filename==".."){continue;}
		$filename="{$GLOBALS["ARTICALOGDIR"]}/sarg_admin_events/$filename";

		$filetime=$unix->file_time_min($filename);
		if($filetime>240){@unlink($filename);continue;}

		$array=unserialize(@file_get_contents($filename));
		if(!is_array($array)){@unlink($filename);continue;}
		if(!is_numeric($array["TASKID"])){$array["TASKID"]=0;}
		$array["text"]=substr($array["text"], 0,254);
		$array["text"]=mysql_escape_string2($array["text"]);
		
		$line="('{$array["zdate"]}','{$array["function"]}','{$array["file"]}','{$array["line"]}','{$array["text"]}','{$array["category"]}','{$array["TASKID"]}')";
		$q->QUERY_SQL($prefix.$line,"artica_events");
		if(!$q->ok){echo $q->mysql_error;continue;}
		@unlink($filename);
	}

	if($GLOBALS["VERBOSE"]){echo __FUNCTION__."::".__LINE__." ->END\n";}

}



function udfbguard_update_events($nopid=false){}
function udfbguard_admin_events_smtp($array){
	include_once(dirname(__FILE__) . '/ressources/class.mail.inc');
	include_once(dirname(__FILE__)."/ressources/smtp/class.smtp.loader.inc");
	
	if(count($array)==0){return;}
	
	$users=new usersMenus();
	$sock=new sockets();
	$UfdbguardSMTPNotifs=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UfdbguardSMTPNotifs")));
	if(!isset($UfdbguardSMTPNotifs["ENABLED"])){return ;}
	if($UfdbguardSMTPNotifs["ENABLED"]==0){return ;}
	$smtp_dest=$UfdbguardSMTPNotifs["smtp_dest"];
	$smtp_sender=$UfdbguardSMTPNotifs["smtp_sender"];
	if($smtp_dest==null){return;}
	if($smtp_sender==null){$smtp_sender="root@artica.localhost.localdomain";}
	
	while (list ($a, $b) = each ($array)){$TEXTZ[]="$a = $b";}
	
	$subject="[$users->hostname]: Web filtering service notification";
	$text=@implode("\r\n", $TEXTZ);
	 $mail = new PHPMailer\PHPMailer\PHPMailer();
	$mail->IsSMTP();

	if(strpos($smtp_dest,",")>0){
		$smtp_dest_array=explode(",",$smtp_dest);
		foreach ($smtp_dest_array as $to){
			$mail->AddAddress(trim($to),trim($to));
		}
	}else{
		$mail->AddAddress($smtp_dest,$smtp_dest);

	}


	$mail->AddReplyTo($smtp_sender,$smtp_sender);
	$mail->From=$smtp_sender;
	$mail->FromName=$smtp_sender;
	$mail->Subject=$subject;
	$mail->Body=$text;
	$mail->Host=$UfdbguardSMTPNotifs["smtp_server_name"];
	$mail->Port=$UfdbguardSMTPNotifs["smtp_server_port"];
	
	if(($UfdbguardSMTPNotifs["smtp_auth_user"]<>null) && ($UfdbguardSMTPNotifs["smtp_auth_passwd"]<>null)){
		$mail->SMTPAuth=true;
		$mail->Username=$UfdbguardSMTPNotifs["smtp_auth_user"];
		$mail->Password=$UfdbguardSMTPNotifs["smtp_auth_passwd"];
		if($UfdbguardSMTPNotifs["tls_enabled"]==1){$mail->SMTPSecure = 'tls';}
		if($UfdbguardSMTPNotifs["ssl_enabled"]==1){$mail->SMTPSecure = 'ssl';}
	
	
	}
	
	$mail->Send();	
	
	
}


function mysql_admin_events_check($nopid=false){
	$f=array();
	$unix=new unix();
	if($nopid){
		
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=@file_get_contents($pidfile);
		if($unix->process_exists($pid)){writelogs("Already running pid $pid",__FUNCTION__,__FILE__,__LINE__);return;}	
		$t=0;		
		
	}	
	
	$q=new mysql();	
	if(!$q->TABLE_EXISTS('mysql_events','artica_events')){$q->BuildTables();}
	
	$users=new usersMenus();
	$hostname=$users->hostname;
	$prefix="INSERT IGNORE INTO mysql_events (`zDate`,`function`,`process`,`line`,`description`,`category`,`servername`) VALUES ";
	@mkdir("{$GLOBALS["ARTICALOGDIR"]}/mysql_admin_events",0755,true);
		
	
	if (!$handle = opendir("{$GLOBALS["ARTICALOGDIR"]}/mysql_admin_events")){return;}
	$countDeFiles=0;
	while (false !== ($filename = readdir($handle))) {
		if($filename=="."){continue;}
		if($filename==".."){continue;}
		$filename="{$GLOBALS["ARTICALOGDIR"]}/mysql_admin_events/$filename";	

		$timeFile=$unix->file_time_min($filename);
		if($timeFile>240){@unlink($filename);continue;}
		
		$array=unserialize(@file_get_contents($filename));
		if(!is_array($array)){@unlink($filename);continue;}
		
		$array["text"]=addslashes($array["text"]);
		$f[]="('{$array["zdate"]}','{$array["function"]}','{$array["file"]}','{$array["line"]}','{$array["text"]}','{$array["category"]}','$hostname')";
		@unlink($filename);
		
		if(count($f)>500){
			$sql=$prefix.@implode(",", $f);
			$q->QUERY_SQL($sql,"artica_events");
			if(!$q->ok){writelogs("$q->mysql_error",__FUNCTION__,__FILE__,__LINE__);}
			$f=array();
		}
	
	}
	
	if(count($f)>0){
		$sql=$prefix.@implode(",", $f);
		$q->QUERY_SQL($sql,"artica_events");
		if(!$q->ok){writelogs("$q->mysql_error",__FUNCTION__,__FILE__,__LINE__);}
	
	}
	
	
	update_events_check();
	
	
}


function clean_mysql_events(){
	$sock=new sockets();
	$unix=new unix();
	
	
	$file_time="/etc/artica-postfix/pids/". basename(__FILE__).".".__FUNCTION__.".time";
	if(!$GLOBALS["VERBOSE"]){
		if($unix->file_time_min($file_time)<300){return;}
		@unlink($file_time);
		@file_put_contents($file_time,time());
	
	}
	$settings=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FcronSchedulesParams")));
	if(!is_numeric($settings["max_events"])){$settings["max_events"]="10000";}
	$q=new mysql();
	
	$array["artica_events"]=true;
	$array["hotspot_admin_mysql"]=true;
	$array["squid_admin_mysql"]=true;
	$array["system_failover_events"]=true;
	$array["system_admin_events"]=true;
	$array["system_rotate_events"]=true;
	$array["update_events"]=true;
	$array["nginx_admin_mysql"]=true;
	$array["vsftpd_admin_mysql"]=true;
	$array["blackwhite_admin_mysql"]=true;
	$array["auth_events"]=true;
	
	$max=count($array);$c=0;
	if($GLOBALS["VERBOSE"]){echo "Checking $c tables\n";}
	while (list ($table, $lib) = each ($array) ){
		$c++;
	
		
		if(!$q->TABLE_EXISTS($table, "artica_events")){
			if($GLOBALS["VERBOSE"]){echo "$table: No such table\n";}
			continue;
		}
		$FileData="/var/lib/mysql/artica_events/$table.MYD";
		$NumRows=$q->COUNT_ROWS($table, "artica_events");
		$size=@filesize($FileData);
		$size=$size/1024;
		$size=$size/1024;
		$size=round($size,2);
		if($GLOBALS["VERBOSE"]){echo "$table:[$c/$max] $NumRows rows, {$size}MB Max rows:{$settings["max_events"]}\n";}
		
		if($size>500){
			if($GLOBALS["VERBOSE"]){echo "$table is more than 500MB > purge it\n";}
			$q->QUERY_SQL("TRUNCATE TABLE `$table` ","artica_events");
			continue;
		}
		
	
		
		if($NumRows>$settings["max_events"]){
			$toDelete=$NumRows-$settings["max_events"];
			if($GLOBALS["VERBOSE"]){echo "$table DELETING $toDelete rows\n";}
			$q->QUERY_SQL("DELETE FROM `$table` ORDER BY zDate LIMIT $toDelete","artica_events");
			continue;
		}
		
		
		$q->QUERY_SQL("DELETE FROM `$table` WHERE zDate<DATE_SUB(NOW(),INTERVAL 60 DAY)","artica_events");
	}
	

	if($q->TABLE_EXISTS("evnts", "artica_events")){
		$q->QUERY_SQL("DELETE FROM evnts WHERE zDate<DATE_SUB(NOW(),INTERVAL 15 DAY)","artica_events");
	}
	

	
	if($q->TABLE_EXISTS("ps_mem_tot", "artica_events")){
		$q->QUERY_SQL("DELETE FROM ps_mem_tot WHERE zDate<DATE_SUB(NOW(),INTERVAL 35 DAY)","artica_events");
	}
	
	if($q->TABLE_EXISTS("ps_mem", "artica_events")){
		$q->QUERY_SQL("DELETE FROM ps_mem WHERE zDate<DATE_SUB(NOW(),INTERVAL 35 DAY)","artica_events");
	}

	

	
	if($q->TABLE_EXISTS("loadavg", "artica_events")){
		$q->QUERY_SQL("DELETE FROM loadavg WHERE stime < DATE_SUB( NOW( ) , INTERVAL 7 DAY )","artica_events");
	}
	
	if($q->TABLE_EXISTS("rotate_admin_events", "artica_events")){
		$q->QUERY_SQL("DELETE FROM rotate_admin_events WHERE zDate < DATE_SUB( NOW( ) , INTERVAL 7 DAY )","artica_events");
	}

	if($q->TABLE_EXISTS("rdpproxy_admin_mysql", "artica_events")){
		$q->QUERY_SQL("DELETE FROM rdpproxy_admin_mysql WHERE zDate < DATE_SUB( NOW( ) , INTERVAL 30 DAY )","artica_events");
	}	
	
	
	$q=new mysql_squid_builder();
	
	if($q->TABLE_EXISTS("wpad_events")){
		if($q->COUNT_ROWS("wpad_events")>0){
			$q->QUERY_SQL("DELETE FROM wpad_events WHERE zDate < DATE_SUB( NOW( ) , INTERVAL 7 DAY )");
		}
	}
	
	
	
	
	
	
	
	
}


function update_events_check($nopid=false){
	$f=array();
	if($nopid){
		$unix=new unix();
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=@file_get_contents($pidfile);
		if($unix->process_exists($pid)){writelogs("Already running pid $pid",__FUNCTION__,__FILE__,__LINE__);return;}	
		$t=0;		
		
	}	
	
	$q=new mysql();	
	if(!$q->TABLE_EXISTS('update_events','artica_events')){$q->BuildTables();}
	if(!$q->TABLE_EXISTS('update_events','artica_events',true)){return;}
	$users=new usersMenus();
	$hostname=$users->hostname;
	$prefix="INSERT IGNORE INTO update_events (`zDate`,`function`,`process`,`line`,`description`,`category`,`servername`) VALUES ";
	foreach (glob("{$GLOBALS["ARTICALOGDIR"]}/update_admin_events/*") as $filename) {
		$array=unserialize(@file_get_contents($filename));
		if(!is_array($array)){
			$array["text"]=basename($filename)." is not an array, skip event ".@file_get_contents($filename);
			$array["date"]=date('Y-m-d H:i:s');
			$array["pid"]=getmypid();
			$array["function"]=__FUNCTION__;
			$array["category"]="sys-update";
			$array["file"]=basename(__FILE__);
			$array["line"]=__LINE__;
		}			
			
			
			
		$array["text"]=addslashes($array["text"]);
		$f[]="('{$array["zdate"]}','{$array["function"]}','{$array["file"]}','{$array["line"]}','{$array["text"]}','{$array["category"]}','$hostname')";
		@unlink($filename);
	}
	
	if(count($f)>0){$sql=$prefix.@implode(",", $f);
		$q->QUERY_SQL($sql,"artica_events");
		if(!$q->ok){
			writelogs("$q->mysql_error",__FUNCTION__,__FILE__,__LINE__);
		}
	
	}
	
	$f=array();
	
	foreach (glob("{$GLOBALS["ARTICALOGDIR"]}/artica-update-*.debug") as $filename) {
		$file=basename($filename);
		$unix=new unix();
		$last_modified = filemtime($filename);
		$array["zdate"]=date('Y-m-d H:i:s',$last_modified);
		$array["pid"]=0;
		$array["function"]="update-deamon";
		$array["category"]="firmware-update";
		$array["file"]="artica-update";
		$array["line"]=0;
		$array["text"]=addslashes(@file_get_contents($filename));
		$f[]="('{$array["zdate"]}','{$array["function"]}','{$array["file"]}','{$array["line"]}','{$array["text"]}','{$array["category"]}','$hostname')";
		@unlink($filename);
		
		
	}
	
	
if(count($f)>0){$sql=$prefix.@implode(",", $f);
		$q->QUERY_SQL($sql,"artica_events");
		if(!$q->ok){
			writelogs("$q->mysql_error",__FUNCTION__,__FILE__,__LINE__);
		}
	
	}	
	
	


	
	
}





function squid_rt_mysql_failed(){
	if($GLOBALS["VERBOSE"]){echo "Start squid_rt_mysql_failed()\n";}
	$DirPath="{$GLOBALS["ARTICALOGDIR"]}/mysql-failed";
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$timefile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".time";
	if(!is_dir($DirPath)){
		
		if($GLOBALS["VERBOSE"]){echo "$DirPath, no such directory\n";}
		return;}
	///etc/artica-postfix/pids/exec.syslog-engine.php.squid_rt_mysql_failed.time
	if($GLOBALS["VERBOSE"]){echo "timefile=$timefile\n";}
	
	$pid=@file_get_contents($pidfile);
	
	
	if(!$GLOBALS["FORCE"]){
		if($pid<100){$pid=null;}
		$unix=new unix();
		if($unix->process_exists($pid,basename(__FILE__))){if($GLOBALS["VERBOSE"]){echo "Already executed pid $pid\n";}return;}
		$timeexec=$unix->file_time_min($timefile);
		if($timeexec<5){if($GLOBALS["VERBOSE"]){echo "Only each 5mn - current {$timeexec}mn, use --force to bypass\n";}return;}
		$mypid=getmypid();
		@file_put_contents($pidfile,$mypid);
	}
	
	if($GLOBALS["VERBOSE"]){echo "Time File: $timefile\n";}
	@file_put_contents($timefile, time());
	if(system_is_overloaded(basename(__FILE__))){exit();}
	
	
	if(system_is_overloaded()){if($GLOBALS["VERBOSE"]){echo "system_is_overloaded\n";}return;}
	if (!$handle = opendir($DirPath)) {if($GLOBALS["VERBOSE"]){echo "$DirPath ERROR\n";}return;}
	$q=new mysql_squid_builder();
	if($GLOBALS["VERBOSE"]){echo "Start Loop\n";}
	
	
	
	$c=0;
	while (false !== ($file = readdir($handle))) {
		if ($file == "."){continue;}
		if ($file == ".."){continue;}
		if(is_dir("$DirPath/$file")){if($GLOBALS["VERBOSE"]){echo "$DirPath/$file -> DIR\n";} continue;}
		$filename="$DirPath/$file";
		if($GLOBALS["VERBOSE"]){echo "$filename -> file_time_min();\n";}
		$timeTemp=$unix->file_time_min($filename);
		if($GLOBALS["VERBOSE"]){echo "$filename {$timeTemp}Mn\n";}
		if($timeTemp>180){@unlink($filename);continue;}
		$sql=@file_get_contents($filename);
		if($GLOBALS["VERBOSE"]){echo "->QUERY_SQL($sql)\n";}
		$q->QUERY_SQL($sql);
		if(!$q->ok){
			if($GLOBALS["VERBOSE"]){echo "Error$q->mysql_error\n";}
			continue;}
		@unlink($filename);
		if($c>1000){
			if(system_is_overloaded()){if($GLOBALS["VERBOSE"]){echo "system_is_overloaded\n";}return;}
			$c=0;
		}
		
	}
}


function load_stats(){}
function seeker(){}
function sys_load(){}
function ps_mem(){}

		
function snort_logs(){
	
	if(system_is_overloaded()){return;}
	
	
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pid=@file_get_contents($pidfile);
	if($unix->process_exists($pid)){
		echo "Already running pid $pid\n";
		return;
	}	
	$t=0;
	include_once(dirname(__FILE__) . '/ressources/class.mysql.inc');
	$q=new mysql();
	foreach (glob("{$GLOBALS["ARTICALOGDIR"]}/snort-queue/*") as $filename) {
		$base=basename($filename);
		if(!preg_match("#([0-9]+)\..+?\.snort#",$base,$re)){@unlink($filename);continue;}
		$zDate=date("Y-m-d H:i:s",$re[1]);
		echo $zDate." -> {$re[1]}\n";
		$array=unserialize(@file_get_contents($filename));
		if(!is_array($array)){@unlink($filename);continue;}
		$local_ipaddr=$array[7];
		$port=$array[8];
		$ipaddr=$array[5];
		if(!isset($GLOBALS["RESOLV"][$ipaddr])){
			$hostname=gethostbyaddr($ipaddr);
			$GLOBALS["RESOLV"][$ipaddr]=$hostname;
		}else{
			$hostname=$GLOBALS["RESOLV"][$ipaddr];
		}
		if(!isset($GLOBALS["GEO"][$ipaddr])){
			if(function_exists("geoip_record_by_name")){
				$record = geoip_record_by_name($ipaddr);
				if ($record) {
					$country=$record["country_name"];
					$GLOBALS["GEO"][$ipaddr]=$country;
				}
			}
		}else{
			$country=$GLOBALS["GEO"][$ipaddr];
		}	
		$infos=$array[1];
		$classification=$array[2];
		if(preg_match("#SCAN.+?Port.+?attempt#",$infos)){$unix->send_email_events("$infos FROM $ipaddr","Country:$country\nHostname:$hostname\nclassification:$classification","security");}

		$proto=$array[4];
		$priority=$array[3];
		if($GLOBALS["VERBOSE"]){echo "$hostname\n";}
		
		
		
		$sql="INSERT IGNORE INTO `snort`
		(`zDate`,`hostname`,`ipaddr` ,`local_ipaddr`,`port`,`infos`,`classification`,`priority`,`proto` ,`country`)
  VALUES('$zDate','$hostname','$ipaddr' ,'$local_ipaddr','$port','$infos','$classification','$priority','$proto' ,'$country')";

		$q->QUERY_SQL($sql,"artica_events");
		if(!$q->ok){
			if($GLOBALS["VERBOSE"]){echo $q->mysql_error."\n";}
			continue;
		}
		$t++;
		@unlink($filename);
	}
	
	if($t>0){
		writelogs("Adding $t entries",__FUNCTION__,__FILE__,__LINE__);
	}
	

	
}


function authlogs(){
	include_once(dirname(__FILE__) . '/ressources/class.mysql.inc');
	include_once(dirname(__FILE__) . '/ressources/class.auth.tail.inc');
	include_once(dirname(__FILE__) . '/ressources/class.iptables-chains.inc');
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pid=@file_get_contents($pidfile);
	if($unix->process_exists($pid)){echo "Already running pid $pid\n";return;}
	
	$q=new mysql();
	
	$DirPath="{$GLOBALS["ARTICALOGDIR"]}/sshd-failed";
	if(!is_dir($DirPath)){return;}
	if (!$handle = opendir($DirPath)) {return;}
	while (false !== ($file = readdir($handle))) {
		if ($file == "."){continue;}
		if ($file == ".."){continue;}
		$filename="{$GLOBALS["ARTICALOGDIR"]}/sshd-failed/$file";
		if(is_dir($filename)){continue;}
		
		if($unix->file_time_min($filename)>120){
			@unlink($filename);
			continue;
		}
		
		events("Open $filename",__FUNCTION__,__FILE__,__LINE__);
		$array=unserialize(@file_get_contents($filename));
		if(!is_array($array)){
			@unlink($filename);
			continue;
		}
		
		$zdate=date("Y-m-d H:i:s",basename($filename));
		if(is_array($array)){
			while (list ($ip, $uid) = each ($array)){
				$hostname=gethostbyaddr($ip);
				if(function_exists("geoip_record_by_name")){
					$record = geoip_record_by_name($ip);
					if (!$record) {ssh_events("Unable to detect country for $ip",__FUNCTION__,__FILE__,__LINE__);}else{
						$Country=$record["country_name"];
					}
				}
				$Country=addslashes($Country);
				$hostname=addslashes($hostname);
				$uid=addslashes($uid);
				ssh_events("SSH Failed $ip $hostname ($Country)",__FUNCTION__,__FILE__,__LINE__);
				$sql="INSERT IGNORE INTO auth_events (ipaddr,hostname,success,uid,zDate,Country) VALUES ('$ip','$hostname','0','$uid','$zdate','$Country')";
				$q->QUERY_SQL($sql,"artica_events");
				if(!$q->ok){@unlink($filename);}
			}
		}
	}
	
	foreach (glob("{$GLOBALS["ARTICALOGDIR"]}/sshd-success/*") as $filename) {
		$array=unserialize(@file_get_contents($filename));
		$zdate=date("Y-m-d H:i:s",basename($filename));
		while (list ($ip, $uid) = each ($array)){
			if(!isset($GLOBALS["HOSTNAME"][$ip])){$GLOBALS["HOSTNAME"][$ip]=gethostbyaddr($ip);}
			$hostname=$GLOBALS["HOSTNAME"][$ip];
			
			if(!is_file("/usr/share/GeoIP/GeoIPCity.dat")){
				_UpdateGeoip();
			}
			
			if(function_exists("geoip_record_by_name")){
					$record = geoip_record_by_name($ip);
					if (!$record) {ssh_events("Unable to detect country for $ip",__FUNCTION__,__FILE__,__LINE__);}else{
						$Country=$record["country_name"];
					}
				}	
			$Country=addslashes($Country);
			$hostname=addslashes($hostname);
			$uid=addslashes($uid);					
			$sql="INSERT IGNORE INTO auth_events (ipaddr,hostname,success,uid,zDate,Country) VALUES ('$ip','$hostname','1','$uid','$zdate','$Country')";
			ssh_events("SSH Success $ip $hostname ($Country) `$sql`",__FUNCTION__,__FILE__,__LINE__);
			$q->QUERY_SQL($sql,"artica_events");
			if(!$q->ok){ssh_events($q->mysql_error,__FUNCTION__,__FILE__,__LINE__);}else{@unlink($filename);}}
		}

		authfw();
		snort_logs();

		
}

function _UpdateGeoip(){
	if(isset($GLOBALS["UpdateGeoip_executed"])){return;}
	$GLOBALS["UpdateGeoip_executed"]=true;
	$unix=new unix();
	$ln=$unix->find_program("ln");
	$database="/usr/share/GeoIP/GeoIP.dat";
	if(!is_file($database)){_installgeoip();return null;}
	if(!is_file("/usr/local/share/GeoIP/GeoIPCity.dat")){
		if(is_file("/usr/local/share/GeoIP/GeoLiteCity.dat")){
			shell_exec("$ln -s /usr/local/share/GeoIP/GeoLiteCity.dat /usr/local/share/GeoIP/GeoIPCity.dat >/dev/null 2>&1");
		}
	}


	if(!is_file("/usr/share/GeoIP/GeoIPCity.dat")){
		if(is_file("/usr/share/GeoIP/GeoLiteCity.dat")){
			system("$ln -s /usr/share/GeoIP/GeoLiteCity.dat /usr/share/GeoIP/GeoIPCity.dat >/dev/null 2>&1");
		}
	}

	if(!function_exists("geoip_record_by_name")){installgeoip();return null;}

}

function _installgeoip(){
	if(isset($GLOBALS["installgeoip_executed"])){return;}
	$GLOBALS["installgeoip_executed"]=true;

	$unix=new unix();
	if(is_file("/etc/artica-postfix/FROM_ISO")){$time=$unix->file_time_min("/etc/artica-postfix/FROM_ISO");if($time<60){return;}}
	$php5=$unix->LOCATE_PHP5_BIN();
	$nohup=$unix->find_program("nohup");
	$pecl=$unix->find_program("pecl");

	shell_exec("$nohup $php5 /usr/share/artica-postfix/exec.geoip.update.php >/dev/null 2>&1 &");

	if(is_file($pecl)){
		if(!is_file("/etc/artica-postfix/php-geoip-checked")){
			shell_exec("$pecl install geoip");
			shell_exec("/etc/init.d/artica-postfix restart apache");
			@file_put_contents("/etc/artica-postfix/php-geoip-checked",time());
		}
	}

}



function sessions_logs(){

}




function authfw(){}

	function ssh_events($text,$function,$file,$line){
		writelogs($text,$function,$file,$line);
		$pid=@getmypid();
		$filename=basename(__FILE__);
		$date=@date("H:i:s");
		$logFile="{$GLOBALS["ARTICALOGDIR"]}/auth-tail.debug";
		$size=@filesize($logFile);
		if($size>1000000){@unlink($logFile);}
		$f = @fopen($logFile, 'a');
		@fwrite($f, "$pid ".basename(__FILE__)." $text\n");
		@fclose($f);	
		$logFile="{$GLOBALS["ARTICALOGDIR"]}/syslogger.debug";
		if(!isset($GLOBALS["CLASS_UNIX"])){
			include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
			$GLOBALS["CLASS_UNIX"]=new unix();
		}
		$GLOBALS["CLASS_UNIX"]->events("$filename $text",$logFile);
		}



function compile_sshd_rules(){}

function iptables_delete_all(){
$unix=new unix();
$iptables_restore=$unix->find_program("iptables-restore");
$iptables_save=$unix->find_program("iptables-save");	
events("Exporting datas iptables-save > /etc/artica-postfix/iptables.conf");
system("$iptables_save > /etc/artica-postfix/iptables.conf");
$data=file_get_contents("/etc/artica-postfix/iptables.conf");
$datas=explode("\n",$data);
$conf=null;
$pattern="#.+?ArticaInstantSSH#";	
foreach ($datas as $num=>$ligne){
		if($ligne==null){continue;}
		if(preg_match($pattern,$ligne)){continue;}
		events("skip rule $ligne from deletion");
		$conf=$conf . $ligne."\n";
		}

events("restoring datas $iptables_restore < /etc/artica-postfix/iptables.new.conf");
file_put_contents("/etc/artica-postfix/iptables.new.conf",$conf);
system("$iptables_restore < /etc/artica-postfix/iptables.new.conf");


}

function events($text){
		$pid=@getmypid();
		$filename=basename(__FILE__);
		$date=@date("H:i:s");
		$logFile="{$GLOBALS["ARTICALOGDIR"]}/auth-tail.debug";
		$size=@filesize($logFile);
		if($size>1000000){@unlink($logFile);}
		$f = @fopen($logFile, 'a');
		@fwrite($f, "$pid ".basename(__FILE__)." $text\n");
		@fclose($f);	
		$logFile="{$GLOBALS["ARTICALOGDIR"]}/syslogger.debug";
		if(!isset($GLOBALS["CLASS_UNIX"])){include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}$GLOBALS["CLASS_UNIX"]=new unix();}
		$GLOBALS["CLASS_UNIX"]->events("$filename $text",$logFile);
}







function haproxy_events(){
	$qs=new mysql_squid_builder();
	$q=new mysql_haproxy_builder();
	if(!is_dir("{$GLOBALS["ARTICALOGDIR"]}/haproxy-rtm")){return;}
	if (!$handle = opendir("{$GLOBALS["ARTICALOGDIR"]}/haproxy-rtm")) {@mkdir("{$GLOBALS["ARTICALOGDIR"]}/haproxy-rtm",0755,true);return;}
	$hash=array();
	$prefixMid=" (sitename,uri,td,http_code,client,hostname,familysite,service,backend,zDate,size,MAC,zMD5,statuslb)";
	$countDeFiles=0;
	$array=array();
	while (false !== ($filename = readdir($handle))) {
		if($filename=="."){continue;}
		if($filename==".."){continue;}
			$targetFile="{$GLOBALS["ARTICALOGDIR"]}/haproxy-rtm/$filename";
			$countDeFiles++;
			$ARRAY=unserialize(@file_get_contents($targetFile));
			foreach ($array as $key=>$value){$ARRAY[$key]=trim(addslashes($value));}
			$ARRAY["MAC"]=GetMacFromIP($ARRAY["SOURCE"]);
			$hostname=GetComputerName($ARRAY["SOURCE"]);
			$dayhour=date("YmdH",$ARRAY["TIME"]);
			$time=date("H:i:s",$ARRAY["TIME"]);
			$fulldate=date('Y-m-d H:i:s',$ARRAY["TIME"]);
			$table="hour_$dayhour";
			if(preg_match("#(.+?)\s+(.*?)#", $ARRAY["SERVICE"],$ri)){$ARRAY["SERVICE"]=$ri[1];}
			if(preg_match("#(.+?)\s+(.*?)#", $ARRAY["BACKEND"],$ri)){$ARRAY["BACKEND"]=$ri[1];}
			$uri=$ARRAY["URI"];
			$md5=md5(serialize($ARRAY));
			if(preg_match("#^(?:[^/]+://)?([^/:]+)#",$uri,$re)){
				$sitename=$re[1];
				if(preg_match("#^www\.(.+)#",$sitename,$ri)){$sitename=$ri[1];}
				$familysite=$qs->GetFamilySites($sitename);
			}
			
		  $linsql="('$sitename','$uri','{$ARRAY["TD"]}','{$ARRAY["HTTP_CODE"]}','{$ARRAY["SOURCE"]}','$hostname','$familysite','{$ARRAY["SERVICE"]}','{$ARRAY["BACKEND"]}','$fulldate','{$ARRAY["BYTES"]}','{$ARRAY["MAC"]}','$md5','{$ARRAY["STATUSLB"]}')";
		  $hash[$table][]=$linsql;
		  if($GLOBALS["VERBOSE"]){echo "Remove: $targetFile\n";}
  		  @unlink($targetFile);
		  if(system_is_overloaded()){break;}
		}
		
		foreach ($hash as $table=>$tr){
			if(trim($table)==null){continue;}
			if(!$q->create_TableHour($table)){
				@mkdir("{$GLOBALS["ARTICALOGDIR"]}/haproxy-errors",0755,true);
				@file_put_contents("{$GLOBALS["ARTICALOGDIR"]}/haproxy-errors/".md5(serialize($hash)), serialize($hash));
				return;
			}
			
			$sql="INSERT IGNORE INTO $table $prefixMid VALUES ".@implode(",", $tr);
			$q->QUERY_SQL($sql);
			if(!$q->ok){
				WriteMyLogs($q->mysql_error,__FUNCTION__,__FILE__,__LINE__);
				@mkdir("{$GLOBALS["ARTICALOGDIR"]}/haproxy-errors",0755,true);
				@file_put_contents("{$GLOBALS["ARTICALOGDIR"]}/haproxy-errors/".md5(serialize($hash)), serialize($hash));
				return;				
			}
			
			
		}
		
	haproxy_errors();
	
}

function haproxy_errors(){
	$q=new mysql_haproxy_builder();
	$prefixMid=" (sitename,uri,td,http_code,client,hostname,familysite,service,backend,zDate,size,MAC,zMD5,statuslb)";
	foreach (glob("{$GLOBALS["ARTICALOGDIR"]}/haproxy-errors/*") as $filename) {
		$hash=unserialize(@file_get_contents($filename));
		while (list ($table, $tr) = each ($hash)){
			if(!$q->create_TableHour($table)){continue;}
			$sql="INSERT IGNORE INTO $table $prefixMid VALUES ".@implode(",", $tr);
			$q->QUERY_SQL($sql);
			if(!$q->ok){
				WriteMyLogs($q->mysql_error,__FUNCTION__,__FILE__,__LINE__);
				continue;}
			@unlink($filename);
			if(system_is_overloaded()){return;}
		}		
		
		
	}
	
	
}



function GetComputerName($ip){
		if($GLOBALS["resvip"][$ip]<>null){return $GLOBALS["resvip"][$ip];}
		$name=gethostbyaddr($ip);
		$GLOBALS["resvip"]=$name;
		return $name;
		}

function GetMacFromIP($ipaddr){
		$ipaddr=trim($ipaddr);
		$ttl=date('YmdH');
		if(count($GLOBALS["CACHEARP"])>3){unset($GLOBALS["CACHEARP"]);}
		if(isset($GLOBALS["CACHEARP"][$ttl][$ipaddr])){return $GLOBALS["CACHEARP"][$ttl][$ipaddr];}
		
		if(!isset($GLOBALS["SBIN_ARP"])){$unix=new unix();$GLOBALS["SBIN_ARP"]=$unix->find_program("arp");}
		if(strlen($GLOBALS["SBIN_ARP"])<4){return;}
		
		if(!isset($GLOBALS["SBIN_PING"])){$unix=new unix();$GLOBALS["SBIN_PING"]=$unix->find_program("ping");}
		if(!isset($GLOBALS["SBIN_NOHUP"])){$unix=new unix();$GLOBALS["SBIN_NOHUP"]=$unix->find_program("nohup");}
		
		$cmd="{$GLOBALS["SBIN_ARP"]} -n \"$ipaddr\" 2>&1";
		events($cmd);
		exec("{$GLOBALS["SBIN_ARP"]} -n \"$ipaddr\" 2>&1",$results);
		foreach ($results as $num=>$line){
			if(preg_match("#^[0-9\.]+\s+.+?\s+([0-9a-z\:]+)#", $line,$re)){
				if($re[1]=="no"){continue;}
				$GLOBALS["CACHEARP"][$ttl][$ipaddr]=$re[1];
				return $GLOBALS["CACHEARP"][$ttl][$ipaddr];
			}
			
		}
		events("$ipaddr not found (".__LINE__.")");
		if(!isset($GLOBALS["PINGEDHOSTS"][$ipaddr])){
			shell_exec("{$GLOBALS["SBIN_NOHUP"]} {$GLOBALS["SBIN_PING"]} $ipaddr -c 3 >/dev/null 2>&1 &");
			$GLOBALS["PINGEDHOSTS"][$ipaddr]=true;
		}
			
		
	}
function WriteMyLogs($text,$function,$file,$line){
	$mem=round(((memory_get_usage()/1024)/1000),2);
	if(!isset($GLOBALS["MYPID"])){$GLOBALS["MYPID"]=getmypid();}
	writelogs($text,$function,__FILE__,$line);
	$logFile="{$GLOBALS["ARTICALOGDIR"]}/".basename(__FILE__).".log";
	if(!is_dir(dirname($logFile))){mkdir(dirname($logFile));}
   	if (is_file($logFile)) { 
   		$size=filesize($logFile);
   		if($size>9000000){unlink($logFile);}
   	}
   	$date=date('m-d H:i:s');
	$logFile=str_replace("//","/",$logFile);
	$f = @fopen($logFile, 'a');
	if($GLOBALS["VERBOSE"]){echo "$date [{$GLOBALS["MYPID"]}][{$mem}MB]: [$function::$line] $text\n";}
	@fwrite($f, "$date [{$GLOBALS["MYPID"]}][{$mem}MB][Task:{$GLOBALS["SCHEDULE_ID"]}]: [$function::$line] $text\n");
	@fclose($f);
}

?>
