<?php

include_once(dirname(__FILE__)."/frame.class.inc"); 
include_once(dirname(__FILE__)."/class.unix.inc");

if(isset($_GET["service-cmds"])){service_cmds();exit;}
if(isset($_GET["reload-tenir"])){reload_tenir();exit;}
if(isset($_GET["reload"])){reload();exit;}
if(isset($_GET["rebuild-database"])){rebuild_database();exit;}
if(isset($_GET["replic"])){replic_artica_servers();exit;}
if(isset($_GET["digg"])){digg();exit;}
if(isset($_GET["repair-tables"])){repair_tables();exit;}
if(isset($_GET["build-smooth-tenir"])){reload_tenir();exit;}
if(isset($_GET["reconfigure"])){reconfigure();exit;}
if(isset($_GET["import-file"])){import_fromfile();exit;}
if(isset($_GET["events-query"])){events_query();exit;}
if(isset($_GET["uninstall"])){uninstall_unbound();exit;}
if(isset($_GET["install"])){install_unbound();exit;}
if(isset($_GET["activate-ufdb"])){activate_ufdb();exit;}
if(isset($_GET["status"])){status();exit;}
if(isset($_GET["restart"])){restart_unbound();exit;}
if(isset($_GET["poweradmin-install"])){poweradmin_install();exit;}
if(isset($_GET["poweradmin-disable"])){poweradmin_disable();exit;}
if(isset($_GET["poweradmin-enable"])){poweradmin_enable();exit;}
if(isset($_GET["reload-poweradmin"])){poweradmin_reload();exit;}
if(isset($_GET["activate-dsc"])){dsc_install();exit;}
if(isset($_GET["disable-dsc"])){dsc_uninstall();exit;}
if(isset($_GET["blacklists-enable"])){blacklists_enable();exit;}
if(isset($_GET["blacklists-disable"])){blacklists_disable();exit;}
if(isset($_GET["unbound-control-stats"])){unbound_control_stats();exit;}
if(isset($_GET["compile-categories"])){unbound_compile_categories();exit;}
if(isset($_GET["install-dns"])){install_unbound_dns();exit;}
if(isset($_GET["uninstall-dns"])){uninstall_unbound_dns();exit;}
if(isset($_GET["cache-search"])){cache_search();exit;}
if(isset($_GET["cache-clear"])){cache_clear();exit;}
if(isset($_GET["requests"])){requests();exit;}
if(isset($_GET["install-redis"])){install_redis();exit;}
if(isset($_GET["uninstall-redis"])){uninstall_redis();exit;}




if(isset($_GET["restart-recusor"])){recursor_restart();exit;}

writelogs_framework("Unable to understand the query ".@implode(" ",$_GET),__FUNCTION__,__FILE__,__LINE__);	


function service_cmds(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	$nohup=$unix->find_program("nohup");
	$cmds=$_GET["service-cmds"];
	$results[]="Postition: $cmds";
	exec("$php /usr/share/artica-postfix/exec.pdns_server.php --$cmds  2>&1",$results);
	echo "<articadatascgi>".base64_encode(serialize($results))."</articadatascgi>";
}

function rebuild_database(){
	$unix=new unix();
	$nohup=$unix->find_program("nohup");
	$php5=$unix->LOCATE_PHP5_BIN();
	$cmd=trim("$nohup $php5 /usr/share/artica-postfix/exec.pdns.php --rebuild-database 2>&1 &");	
	writelogs_framework("$cmd",__FUNCTION__,__FILE__,__LINE__);	
	shell_exec($cmd);
}


function status(){
	$unix=new unix();
	$php5=$unix->LOCATE_PHP5_BIN();
	$GLOBALS["LOGSFILES"]="/usr/share/artica-postfix/ressources/logs/web/unbound.status";
	$cmd="$php5 /usr/share/artica-postfix/exec.status.php --unbound >{$GLOBALS["LOGSFILES"]} 2>&1";
	writelogs_framework($cmd ,__FUNCTION__,__FILE__,__LINE__);
	shell_exec($cmd);
}
function reload(){
	$unix=new unix();
	$php5=$unix->LOCATE_PHP5_BIN();
	$nohup=$unix->find_program("nohup");
	$cmd="$nohup $php5 /usr/share/artica-postfix/exec.unbound.php --reload >/dev/null 2>&1 &";
	writelogs_framework($cmd ,__FUNCTION__,__FILE__,__LINE__);
	shell_exec($cmd);
}
function restart_unbound(){
	$GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php";
	$GLOBALS["LOGSFILES"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php.log";
	@unlink($GLOBALS["CACHEFILE"]);
	@unlink($GLOBALS["LOGSFILES"]);
	@touch($GLOBALS["CACHEFILE"]);
	@touch($GLOBALS["LOGSFILES"]);
	@chmod($GLOBALS["CACHEFILE"],0777);
	@chmod($GLOBALS["LOGSFILES"],0777);
	$unix=new unix();
	$php5=$unix->LOCATE_PHP5_BIN();
	$nohup=$unix->find_program("nohup");
	$cmd="$nohup $php5 /usr/share/artica-postfix/exec.unbound.php --restart >{$GLOBALS["LOGSFILES"]} 2>&1 &";
	writelogs_framework($cmd ,__FUNCTION__,__FILE__,__LINE__);
	shell_exec($cmd);	
	
}

function unbound_control_stats(){
	if(is_file("/usr/share/artica-postfix/ressources/logs/web/unbound.control.stats")){return;}
	$unix=new unix();
	
	$unbound_control=$unix->find_program("unbound-control");
	if(!is_file($unbound_control)){ return;}
	$cmd="$unbound_control -c /etc/unbound/unbound.conf stats_noreset >/usr/share/artica-postfix/ressources/logs/web/unbound.control.stats 2>&1";
	writelogs_framework($cmd ,__FUNCTION__,__FILE__,__LINE__);
	shell_exec($cmd);
	
	
}

function blacklists_enable(){
	$GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php";
	$GLOBALS["LOGSFILES"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php.log";
	@unlink($GLOBALS["CACHEFILE"]);
	@unlink($GLOBALS["LOGSFILES"]);
	@touch($GLOBALS["CACHEFILE"]);
	@touch($GLOBALS["LOGSFILES"]);
	@chmod($GLOBALS["CACHEFILE"],0777);
	@chmod($GLOBALS["LOGSFILES"],0777);
	$unix=new unix();
	$php5=$unix->LOCATE_PHP5_BIN();
	$nohup=$unix->find_program("nohup");
	$cmd="$nohup $php5 /usr/share/artica-postfix/exec.unbound.php --blacklists-enable >{$GLOBALS["LOGSFILES"]} 2>&1 &";
	writelogs_framework($cmd ,__FUNCTION__,__FILE__,__LINE__);
	shell_exec($cmd);
	
}
function blacklists_disable(){
	$GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php";
	$GLOBALS["LOGSFILES"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php.log";
	@unlink($GLOBALS["CACHEFILE"]);
	@unlink($GLOBALS["LOGSFILES"]);
	@touch($GLOBALS["CACHEFILE"]);
	@touch($GLOBALS["LOGSFILES"]);
	@chmod($GLOBALS["CACHEFILE"],0777);
	@chmod($GLOBALS["LOGSFILES"],0777);
	$unix=new unix();
	$php5=$unix->LOCATE_PHP5_BIN();
	$nohup=$unix->find_program("nohup");
	$cmd="$nohup $php5 /usr/share/artica-postfix/exec.unbound.php --blacklists-disable >{$GLOBALS["LOGSFILES"]} 2>&1 &";
	writelogs_framework($cmd ,__FUNCTION__,__FILE__,__LINE__);
	shell_exec($cmd);

}


function activate_ufdb(){
	$GLOBALS["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/pdns.first.install";
	$GLOBALS["CACHEFILE"]=$GLOBALS["PROGRESS_FILE"];
	$GLOBALS["LOGSFILES"]="/usr/share/artica-postfix/ressources/logs/web/pdns.first.install.log";
	@unlink($GLOBALS["CACHEFILE"]);
	@unlink($GLOBALS["LOGSFILES"]);
	@touch($GLOBALS["CACHEFILE"]);
	@touch($GLOBALS["LOGSFILES"]);
	@chmod($GLOBALS["CACHEFILE"],0777);
	@chmod($GLOBALS["LOGSFILES"],0777);
	$unix=new unix();
	$php5=$unix->LOCATE_PHP5_BIN();
	$nohup=$unix->find_program("nohup");
	$cmd="$nohup $php5 /usr/share/artica-postfix/exec.pdns_server.install.php --install-ufdb >{$GLOBALS["LOGSFILES"]} 2>&1 &";
	writelogs_framework($cmd ,__FUNCTION__,__FILE__,__LINE__);
	shell_exec($cmd);
	
}


function install_unbound(){
	$GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php";
	$GLOBALS["LOGSFILES"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php.log";
	@unlink($GLOBALS["CACHEFILE"]);
	@unlink($GLOBALS["LOGSFILES"]);
	@touch($GLOBALS["CACHEFILE"]);
	@touch($GLOBALS["LOGSFILES"]);
	@chmod($GLOBALS["CACHEFILE"],0777);
	@chmod($GLOBALS["LOGSFILES"],0777);
	$unix=new unix();
	$php5=$unix->LOCATE_PHP5_BIN();
	$nohup=$unix->find_program("nohup");
	$cmd="$nohup $php5 /usr/share/artica-postfix/exec.unbound.php --install >{$GLOBALS["LOGSFILES"]} 2>&1 &";
	writelogs_framework($cmd ,__FUNCTION__,__FILE__,__LINE__);
	shell_exec($cmd);	
	
}
function install_redis(){
    $GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php";
    $GLOBALS["LOGSFILES"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php.log";
    @unlink($GLOBALS["CACHEFILE"]);
    @unlink($GLOBALS["LOGSFILES"]);
    @touch($GLOBALS["CACHEFILE"]);
    @touch($GLOBALS["LOGSFILES"]);
    @chmod($GLOBALS["CACHEFILE"],0777);
    @chmod($GLOBALS["LOGSFILES"],0777);
    $unix=new unix();
    $php5=$unix->LOCATE_PHP5_BIN();
    $nohup=$unix->find_program("nohup");
    $cmd="$nohup $php5 /usr/share/artica-postfix/exec.unbound.php --install-redis >{$GLOBALS["LOGSFILES"]} 2>&1 &";
    writelogs_framework($cmd ,__FUNCTION__,__FILE__,__LINE__);
    shell_exec($cmd);


}
function uninstall_redis(){
    $GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php";
    $GLOBALS["LOGSFILES"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php.log";
    @unlink($GLOBALS["CACHEFILE"]);
    @unlink($GLOBALS["LOGSFILES"]);
    @touch($GLOBALS["CACHEFILE"]);
    @touch($GLOBALS["LOGSFILES"]);
    @chmod($GLOBALS["CACHEFILE"],0777);
    @chmod($GLOBALS["LOGSFILES"],0777);
    $unix=new unix();
    $php5=$unix->LOCATE_PHP5_BIN();
    $nohup=$unix->find_program("nohup");
    $cmd="$nohup $php5 /usr/share/artica-postfix/exec.unbound.php --uninstall-redis >{$GLOBALS["LOGSFILES"]} 2>&1 &";
    writelogs_framework($cmd ,__FUNCTION__,__FILE__,__LINE__);
    shell_exec($cmd);


}

function install_unbound_dns(){
	$GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php";
	$GLOBALS["LOGSFILES"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php.log";
	@unlink($GLOBALS["CACHEFILE"]);
	@unlink($GLOBALS["LOGSFILES"]);
	@touch($GLOBALS["CACHEFILE"]);
	@touch($GLOBALS["LOGSFILES"]);
	@chmod($GLOBALS["CACHEFILE"],0777);
	@chmod($GLOBALS["LOGSFILES"],0777);
	$unix=new unix();
	$php5=$unix->LOCATE_PHP5_BIN();
	$nohup=$unix->find_program("nohup");
	$cmd="$nohup $php5 /usr/share/artica-postfix/exec.unbound.php --install-dns >{$GLOBALS["LOGSFILES"]} 2>&1 &";
	writelogs_framework($cmd ,__FUNCTION__,__FILE__,__LINE__);
	shell_exec($cmd);

}
function uninstall_unbound_dns(){
	$GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php";
	$GLOBALS["LOGSFILES"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php.log";
	@unlink($GLOBALS["CACHEFILE"]);
	@unlink($GLOBALS["LOGSFILES"]);
	@touch($GLOBALS["CACHEFILE"]);
	@touch($GLOBALS["LOGSFILES"]);
	@chmod($GLOBALS["CACHEFILE"],0777);
	@chmod($GLOBALS["LOGSFILES"],0777);
	$unix=new unix();
	$php5=$unix->LOCATE_PHP5_BIN();
	$nohup=$unix->find_program("nohup");
	$cmd="$nohup $php5 /usr/share/artica-postfix/exec.unbound.php --uninstall-dns >{$GLOBALS["LOGSFILES"]} 2>&1 &";
	writelogs_framework($cmd ,__FUNCTION__,__FILE__,__LINE__);
	shell_exec($cmd);

}
function uninstall_unbound(){
	$GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php";
	$GLOBALS["LOGSFILES"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php.log";
	@unlink($GLOBALS["CACHEFILE"]);
	@unlink($GLOBALS["LOGSFILES"]);
	@touch($GLOBALS["CACHEFILE"]);
	@touch($GLOBALS["LOGSFILES"]);
	@chmod($GLOBALS["CACHEFILE"],0777);
	@chmod($GLOBALS["LOGSFILES"],0777);
	$unix=new unix();
	$php5=$unix->LOCATE_PHP5_BIN();
	$nohup=$unix->find_program("nohup");
    squid_admin_mysql("Launch command: Removing DNS Cache service",null,__FILE__,__LINE__);
	$cmd="$nohup $php5 /usr/share/artica-postfix/exec.unbound.php --uninstall >{$GLOBALS["LOGSFILES"]} 2>&1 &";
	writelogs_framework($cmd ,__FUNCTION__,__FILE__,__LINE__);
	shell_exec($cmd);	
	
}

function replic_artica_servers(){
	$unix=new unix();
	$nohup=$unix->find_program("nohup");
	$php5=$unix->LOCATE_PHP5_BIN();
	$cmd=trim("$nohup $php5 /usr/share/artica-postfix/exec.pdns.php --replic-artica 2>&1 &");	
	writelogs_framework("$cmd",__FUNCTION__,__FILE__,__LINE__);	
	shell_exec($cmd);	
	
}
function digg(){
	$unix=new unix();
	$digg=$unix->find_program("dig");
	if(!is_file($digg)){
		echo "<articadatascgi>".base64_encode(serialize(array("dig, nos such binary")))."</articadatascgi>";
		return;
	}
	
	$hostname=$_GET["hostname"];
	$interface=$_GET["interface"];
	if($interface==null){$interface="127.0.0.1";}
	if($hostname==null){$hostname="www.google.com";}
	$cmd="$digg @$interface $hostname 2>&1";
	writelogs_framework("$cmd",__FUNCTION__,__FILE__,__LINE__);	
	exec($cmd,$results);
	echo "<articadatascgi>".base64_encode(serialize($results))."</articadatascgi>";
	
}

function unbound_compile_categories(){
	$unix=new unix();
	$nohup=$unix->find_program("nohup");
	$php5=$unix->LOCATE_PHP5_BIN();
	$cmd=trim("$nohup $php5 /usr/share/artica-postfix/exec.unbound.php --reload 2>&1 &");
	writelogs_framework("$cmd",__FUNCTION__,__FILE__,__LINE__);
	shell_exec($cmd);
}
function cache_clear(){
	$host=$_GET["cache-clear"];
	$unix=new unix();
	$unbound_control=$unix->find_program("unbound-control");
	$cmd="$unbound_control flush_zone $host";
	writelogs_framework("$cmd",__FUNCTION__,__FILE__,__LINE__);
	shell_exec($cmd);
}

function cache_search(){
	$rp=$_GET["rp"];
	$pattern=$_GET["query"];
	if($pattern=="yes"){$pattern=null;}
	$pattern=str_replace("  "," ",$pattern);
	$pattern=str_replace(" ","\s+",$pattern);
	$pattern=str_replace(".","\.",$pattern);
	$pattern=str_replace("*",".+?",$pattern);
	$pattern=str_replace("/","\/",$pattern);
	$syslogpath="/var/log/unbound.log";
	$maxrows=0;

	$unix=new unix();
	$grepbin=$unix->find_program("grep");
	$tail = $unix->find_program("tail");
	$head = $unix->find_program("head");
	$unbound_control=$unix->find_program("unbound-control");
	if($tail==null){return;}
	
	$cmd="$unbound_control dump_cache |$grepbin -E '(.+?)\.\s+[0-9]+\s+([A-Z]+)\s+(A|SOA|AAAA|CNAME|RRSIG|SIG|PTR|TXT)\s+'";

	
	if(isset($_GET["rp"])){$maxrows=$_GET["rp"];}
	if($maxrows==0){$maxrows=250;}
	
	
	if(strlen($pattern)>1){
		$cmd=$cmd."|$grepbin -E -i '$pattern'";
	}
	
	unset($results);
	$l=$unix->FILE_TEMP();
	
	
	$cmd=$cmd."|$head -n $maxrows >/usr/share/artica-postfix/ressources/logs/web/unbound.cache 2>&1";
	writelogs_framework("\"$cmd\"" ,__FUNCTION__,__FILE__,__LINE__);
	shell_exec($cmd);
	@file_put_contents("/usr/share/artica-postfix/ressources/logs/web/unbound.cache.query", $cmd);
	@chmod("/usr/share/artica-postfix/ressources/logs/web/unbound.cache", 0755);
	
}

function requests(){
    $unix=new unix();
    $tail=$unix->find_program("tail");
    $targetfile="/usr/share/artica-postfix/ressources/logs/unbound.log.tmp";
    $sourceLog="/var/log/unbound.log";
    $grep=$unix->find_program("grep");
    $rp=$_GET["rp"];
    $query=$_GET["query"];

    $cmd="$tail -n $rp $sourceLog >$targetfile 2>&1";

    if($query<>null){
        if(preg_match("#regex:(.*)#", $query,$re)){$pattern=$re[1];}else{
            $pattern=str_replace(".", "\.", $query);
            $pattern=str_replace("*", ".*?", $pattern);
            $pattern=str_replace("/", "\/", $pattern);
        }
    }
    if($pattern<>null){

        $cmd="$grep --binary-files=text -Ei \"$pattern\" $sourceLog|$tail -n $rp  >$targetfile 2>&1";
    }
    writelogs_framework($cmd ,__FUNCTION__,__FILE__,__LINE__);
    @file_put_contents("/usr/share/artica-postfix/ressources/logs/unbound.log.cmd", $cmd);
    shell_exec($cmd);
    @chmod("$targetfile",0755);
}
