<?php
include_once(dirname(__FILE__)."/ressources/class.template-admin.inc");if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__)."/ressources/class.system.network.inc");
if(isset($_GET["verbose"])){$GLOBALS["VERBOSE"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
if(isset($_GET["table"])){table();exit;}
if(isset($_GET["table2"])){table2();exit;}
if(isset($_GET["tabs"])){tabs();exit;}
if(isset($_POST["SquidDNSUseSystem"])){DNS_PROXY_SAVE();exit;}
if(isset($_POST["DOMAINS1"])){DNS_SERVERS_SAVE();exit;}
if(isset($_GET["namebench"])){NAMEBENCH();exit;}
if(isset($_GET["namebench-start"])){NAMEBENCH_START();exit;}
if(isset($_POST["QUERY_COUNT"])){NAMEBENCH_SAVE();exit;}
if(isset($_GET["namebench-report-js"])){NAMEBENCH_REPORT_JS();exit;}
if(isset($_GET["namebench-report"])){NAMEBENCH_REPORT();exit;}
page();
function page(){
	$page=CurrentPageName();
	$tpl=new template_admin();

	
	$html="
	<div class=\"row border-bottom white-bg dashboard-header\">
	<div class=\"col-sm-12\"><h1 class=ng-binding>{dns_servers}</h1>
	<p>{dns_servers_explain}</p>
	</div>

	</div>



	<div class='row'><div id='progress-firehol-restart'></div>
	<div class='ibox-content'>

	<div id='table-loader-dns-servers'></div>

	</div>
	</div>



	<script>
	$.address.state('/');
	$.address.value('/dns-servers');	
	LoadAjax('table-loader-dns-servers','$page?tabs=yes');

	</script>";

	if(isset($_GET["main-page"])){
		$tpl=new template_admin("{dns_servers} ",$html);
		echo $tpl->build_firewall();
		return;
	}
	
	
	echo $tpl->_ENGINE_parse_body($html);

}


function NAMEBENCH_START(){
	$page=CurrentPageName();
	echo "<div style='margin-top:10px' id='namebench-progress'></div><div id='namebench-start'></div><script>LoadAjax('namebench-start','$page?namebench=yes');</script>";
}

function tabs(){
	$page=CurrentPageName();
	$tpl=new template_admin();
	$sock=new sockets();

	$array["{dns_servers}"]="$page?table=yes";
	$NAMEBENCH_INSTALLED=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NAMEBENCH_INSTALLED"));
	
	$EnableDNSCryptProxy=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableDNSCryptProxy"));
	
	if($EnableDNSCryptProxy==1){
		$array["{public_dns_servers}"]="fw.dnscrypt-proxy.list.php";
	}
	
	
	if($NAMEBENCH_INSTALLED==1){
		$array["{dns_benchmark}"]="$page?namebench-start=yes";
	}
	echo $tpl->tabs_default($array);

}

function NAMEBENCH(){
	$tpl=new template_admin();
	$page=CurrentPageName();
	$sock=new sockets();
	$SquidNameServer1=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidNameServer1"));
	$SquidNameServer2=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidNameServer2"));
	$UnboundInstalled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundInstalled"));
	$UnboundEnabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundEnabled"));
	if($UnboundInstalled==0){$UnboundEnabled=1;}
	$EnablePDNS=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnablePDNS"));
	if($EnablePDNS==1){$DNS[]="127.0.0.1";}
	if($UnboundEnabled==1){$DNS[]="127.0.0.1";}
	if($SquidNameServer1<>null){$DNS[]=$SquidNameServer1;}
	if($SquidNameServer2<>null){$DNS[]=$SquidNameServer2;}
	$resolv=new resolv_conf();
	if($resolv->MainArray["DNS1"]<>null){$DNS[]=$resolv->MainArray["DNS1"];}
	if($resolv->MainArray["DNS2"]<>null){$DNS[]=$resolv->MainArray["DNS2"];}
	if($resolv->MainArray["DNS3"]<>null){$DNS[]=$resolv->MainArray["DNS3"];}
	$NAMEBENCH_ARRAY=unserialize($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NAMEBENCH_ARRAY"));
	
	$data=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("NameBenchReport");
	if(strlen($data)>100){
		$html[]=$tpl->button_autnonome("{display_report}", "Loadjs('$page?namebench-report-js')", "fa-pie-chart");
	}
	
	for($i=0;$i<8;$i++){
		if(!isset($NAMEBENCH_ARRAY["DNS$i"])){$NAMEBENCH_ARRAY["DNS$i"]=$DNS[$i];}
		$form[]=$tpl->field_text("DNS$i", "{dns_server}", $DNS[$i]);
		
	}
	if(intval($NAMEBENCH_ARRAY["QUERY_COUNT"])==0){$NAMEBENCH_ARRAY["QUERY_COUNT"]=80;}
	if(intval($NAMEBENCH_ARRAY["PING_TIMEOUT"])==0){$NAMEBENCH_ARRAY["PING_TIMEOUT"]=2;}
	$form[]=$tpl->field_numeric("QUERY_COUNT","{query_count}",$NAMEBENCH_ARRAY["QUERY_COUNT"]);
	$form[]=$tpl->field_numeric("PING_TIMEOUT","{PING_TIMEOUT}",$NAMEBENCH_ARRAY["PING_TIMEOUT"]);
	
	
	$ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/admin.dashboard.dnsperfs.progress";
	$ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/admin.dashboard.dnsperfs.progress.txt";
	$ARRAY["CMD"]="system.php?dnsperf-progress=yes";
	$ARRAY["TITLE"]="{html_report})";
	$ARRAY["AFTER"]="LoadAjax('namebench-start','$page?namebench=yes');";
	$prgress=base64_encode(serialize($ARRAY));
	$jsafter="Loadjs('fw.progress.php?content=$prgress&mainid=namebench-progress')";
	

	$html[]=$tpl->form_outside("{performance_report}", @implode("\n", $form),
			"{check_your_dns_servers_performance}","{launch_scan}",$jsafter,"AsDnsAdministrator");
	
	
	echo $tpl->_ENGINE_parse_body(@implode("\n", $html));
}

function NAMEBENCH_SAVE(){
	$tpl=new template_admin();
	$tpl->CLEAN_POST();
	$sock=new sockets();
	$sock->SaveConfigFile(serialize($_POST), "NAMEBENCH_ARRAY");
	
}
function NAMEBENCH_REPORT_JS(){
	$page=CurrentPageName();
	$tpl=new template_admin();
	$tpl->js_dialog1("{dns_performance}", "$page?namebench-report=yes");
}

function NAMEBENCH_REPORT(){
	$page=CurrentPageName();
	$tpl=new template_admin();
	$dns_performance_time=null;
	$data=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("NameBenchReport");

	if(preg_match("#<body>(.*?)</body>#is", $data,$re)){$data=$re[1];}
	$data=str_replace("<img src=","</center><center><img src=",$data);

	$DNSPerfsDate=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NameBenchReport"));
	if($DNSPerfsDate>0){
		$dns_performance_time="&laquo;".$tpl->time_to_date($DNSPerfsDate,true)."&raquo;";
	}

	$html[]="<h2>{dns_performance}&nbsp;&nbsp;$dns_performance_time</h2>";
	$html[]="<div class=NameBenchReport>";
	$html[]=$data;
	$html[]="</div>";
	echo $tpl->_ENGINE_parse_body(@implode("\n", $html));

}
function table(){
	$page=CurrentPageName();
	$html="<div id='dns-servers-main-table'></div><script>LoadAjax('dns-servers-main-table','$page?table2=yes');</script>";
	echo $html;
}

function table2(){
	
	$tpl=new template_admin();
	$page=CurrentPageName();
	$sock=new sockets();
	$resolv=new resolv_conf();
	$users=new usersMenus();
	$btname="{apply}";
	$DisableNetworksManagement=$sock->GET_INFO("DisableNetworksManagement");
	if(!is_numeric($DisableNetworksManagement)){$DisableNetworksManagement=0;}
	$EnableDNSMASQ=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableDNSMASQ"));
	$SquidDNSUseSystem=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidDNSUseSystem"));
	$UnboundInstalled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundInstalled"));
	$UnboundEnabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundEnabled"));
	$SQUIDEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable"));
	$EnableUnboundDOHBackend=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableUnboundDOHBackend"));
	$apply_to_the_system=$tpl->javascript_parse_text("{apply_to_the_system}");	
	
	$SquidNameServer1=$sock->GET_INFO("SquidNameServer1");
	$SquidNameServer2=$sock->GET_INFO("SquidNameServer2");
	if($SquidNameServer1==null){
		$q=new mysql_squid_builder();
		$results=$q->QUERY_SQL("SELECT * FROM dns_servers ORDER BY zOrder");
		$DNSZZ=array();
		while ($ligne = mysqli_fetch_assoc($results)) {$DNSZZ[]=$ligne["dnsserver"];}
		$SquidNameServer1=$DNSZZ[0];
		$SquidNameServer2=$DNSZZ[1];
	}
	if($SquidNameServer1==null){$SquidNameServer1=$resolv->MainArray["DNS1"];}
	if($SquidNameServer2==null){$SquidNameServer2=$resolv->MainArray["DNS2"];}
	if(!$users->SQUID_INSTALLED){$SQUID_INSTALLED=0;}	
	if(!$resolv->isValidDomain($resolv->MainArray["DOMAINS1"])){$resolv->MainArray["DOMAINS1"]="localhost.local";}
	$HaClusterClient=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterClient"));
	if($HaClusterClient==0) {
		if ($UnboundInstalled == 1) {
			if ($UnboundEnabled == 1) {

					$form[] = $tpl->field_info("NONE", "{local_dns_service}", "127.0.0.1");
				if($EnableUnboundDOHBackend==0){
					$q = new lib_sqlite("/home/artica/SQLITE/dns.db");
					$sql = "SELECT *  FROM pdns_fwzones WHERE zone='*'";
					$results = $q->QUERY_SQL($sql);

					foreach ($results as $index => $ligne) {
						$hostname = $ligne["hostname"] . ":" . $ligne["port"];
						$form[] = $tpl->field_info("NONE", "{APP_UNBOUND}", "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i class=\"fas fa-arrow-alt-right\"></i>&nbsp;$hostname");
					}
				}
			$form[]=$tpl->field_onoff_newlayer("{use_doh_to_resolve}",$EnableUnboundDOHBackend,"blur()","{use_doh_to_resolve_explain}");

			}
		}
	}

	$HaClusterGBConfig=unserialize($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterGBConfig"));
	$HaClusterUseLBAsDNS=intval($HaClusterGBConfig["HaClusterUseLBAsDNS"]);
	if($HaClusterClient==1) {
		$btname=null;
		if($HaClusterUseLBAsDNS==1) {
			$HaClusterIP = $GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterIP");
			if (preg_match("#http(s|):\/\/(.+?):[0-9]+#", $HaClusterIP, $re)) {
				$HaClusterIP = $re[2];
			}
			$form[] = $tpl->field_info("NONE", "{APP_HAPROXY_CLUSTER}", "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i class=\"fas fa-arrow-alt-right\"></i>&nbsp;$HaClusterIP");
		}
	}



	$ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/dnsparams.progress";
	$ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/dnsparams.log";
	$ARRAY["CMD"]="services.php?resolvConf=yes";
	$ARRAY["TITLE"]="({dns_used_by_the_system})";
	$ARRAY["AFTER"]="LoadAjax('dns-servers-main-table','$page?table2=yes');";
	$prgress=base64_encode(serialize($ARRAY));
	$jsafter="Loadjs('fw.progress.php?content=$prgress&mainid=dns-apply-system')";


	$html[]="<div id='dns-apply-system'></div>";
	$form[]=$tpl->field_ipv4("DNS1", "{primary_dns} ", $resolv->MainArray["DNS1"], false,null,false);
	$form[]=$tpl->field_ipv4("DNS2", "{secondary_dns} ", $resolv->MainArray["DNS2"], false,null,false);
	$form[]=$tpl->field_ipv4("DNS3", "{nameserver} 3 ", $resolv->MainArray["DNS3"], false,null,false);
	$form[]=$tpl->field_text("DOMAINS1", "{InternalDomain} 1", $resolv->MainArray["DOMAINS1"]);
	$form[]=$tpl->field_text("DOMAINS2", "{InternalDomain} 2", $resolv->MainArray["DOMAINS2"]);
	$form[]=$tpl->field_text("DOMAINS3", "{InternalDomain} 3", $resolv->MainArray["DOMAINS3"]);
	$form[]=$tpl->field_numeric("TIMEOUT", "{xtimeout} ({seconds}):", $resolv->MainArray["TIMEOUT"]);
	$form[]=$tpl->field_numeric("ATTEMPTS", "{max-attempts} ({times}):", $resolv->MainArray["ATTEMPTS"]);
	$form[]=$tpl->field_checkbox("USEROTATION","{UseRotation}",$resolv->MainArray["USEROTATION"]);

	$html[]=$tpl->form_outside("{dns_used_by_the_system}", @implode("\n", $form),null,$btname,$jsafter,"AsDnsAdministrator");

	if($SquidDNSUseSystem==1){$SquidDNSUseSystem=0;}else{$SquidDNSUseSystem=1;}
	
if($users->SQUID_INSTALLED){

	$ARRAY=array();
	$ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.access.center.progress";
	$ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.access.center.progress.log";
	$ARRAY["CMD"]="squid2.php?global-dns-tuning=yes";
	$ARRAY["TITLE"]="({proxy_use_its_own_dns})";
	$ARRAY["AFTER"]="LoadAjax('dns-servers-main-table','$page?table2=yes');";
	$prgress=base64_encode(serialize($ARRAY));
	$jsafter="Loadjs('fw.progress.php?content=$prgress&mainid=form-progress-SquidDNSUseSystem')";


	$form=array();
	$tpl=new template_admin();
	if($SQUIDEnable==1){
		$html[]="<div id='form-progress-SquidDNSUseSystem'></div>";
		$form[]=$tpl->field_checkbox("SquidDNSUseSystem","{proxy_use_its_own_dns}",$SquidDNSUseSystem,"SquidNameServer1,SquidNameServer2");
		$form[]=$tpl->field_ipv4("SquidNameServer1", "{primary_dns} ", $SquidNameServer1, false,null,false);
		$form[]=$tpl->field_ipv4("SquidNameServer2", "{secondary_dns} ", $SquidNameServer2, false,null,false);
		$html[]=$tpl->form_outside("{APP_SQUID}", @implode("\n", $form),null,"{apply}",$jsafter,"AsDnsAdministrator");
	}
}


echo $tpl->_ENGINE_parse_body($html);
}

function DNS_SERVERS_SAVE(){
	$resolv=new resolv_conf();
	$tpl=new template_admin();
	$tpl->CLEAN_POST();

	foreach ($_POST as $key=>$value){

		$resolv->MainArray[$key]=$value;
	}

	$resolv->save();

	

}

function DNS_PROXY_SAVE(){

	$tpl=new template_admin();
	$tpl->CLEAN_POST();

		if ($_POST["SquidDNSUseSystem"] == 1) {
			$_POST["SquidDNSUseSystem"] = 0;
		} else {
			$_POST["SquidDNSUseSystem"] = 1;
		}
		$sock = new sockets();

		$tpl->SAVE_POSTs();



}

?>	
	
	
