<?php
include_once(dirname(__FILE__)."/ressources/class.template-admin.inc");if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
$users=new usersMenus();if(!$users->AsFirewallManager){exit();}
if(isset($_GET["verbose"])){$GLOBALS["VERBOSE"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}

if(isset($_GET["firewall-status"])){firewall_status();exit;}
if(isset($_POST["nic-settings"])){nic_settings();exit;}
if(isset($_POST["FireHoleStoreEvents"])){logs_settings_save();exit;}
if(isset($_GET["main"])){main();exit;}
if(isset($_GET["nic-fw-edit"])){nic_form_settings();exit;}
if(isset($_GET["nic-form-settings-build"])){nic_form_settings_build();exit;}
if(isset($_GET["tabs"])){tabs();exit;}
if(isset($_GET["interfaces-start"])){interfaces_start();exit;}
if(isset($_GET["interfaces"])){interfaces();exit;}
if(isset($_GET["modules-start"])){modules_start();exit;}
if(isset($_GET["modules-table"])){modules_table();exit;}
page();


function tabs(){
    $page   = CurrentPageName();
    $tpl    = new template_admin();
    $array["{interfaces}"]="$page?interfaces-start=yes";
    $array["{options}"]="$page?main=yes";
    $array["{modules}"]="fw.settings.php?modules-start=yes";
    echo $tpl->tabs_default($array);
}

function nic_settings(){
	//print_r($_POST);
	$nic=new system_nic($_POST["nic-settings"]);
	$nic->isFW=$_POST["isFW"];
	$nic->firewall_policy=$_POST["firewall_policy"];
	$nic->firewall_behavior=$_POST["firewall_behavior"];
	$nic->firewall_masquerade=$_POST["firewall_masquerade"];
	$nic->firewall_artica=$_POST["firewall_artica"];
	$nic->firewall_ping=$_POST["firewall_ping"];
	//$nic->DenyCountries=$_POST["DenyCountries"];
	$nic->SaveNic();
	
}

function firewall_status(){
    $page       = CurrentPageName();
    $tpl        = new template_admin();
    $GLOBALS["CLASS_SOCKETS"]->getFrameWork("firehol.php?isActive=yes");
    if(!is_file("/usr/share/artica-postfix/ressources/logs/web/FIREWALL_ACTIVE")){
        $ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/firehol.reconfigure.progress";
        $ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/firehol.reconfigure.progress.txt";
        $ARRAY["CMD"]="firehol.php?reconfigure-progress=yes";
        $ARRAY["TITLE"]="{reconfiguring_firewall}";
        $ARRAY["AFTER"]="LoadAjax('table-loader','$page?tabs=yes');";

        $prgress=base64_encode(serialize($ARRAY));
        $jsrestart="Loadjs('fw.progress.php?content=$prgress&mainid=progress-firehol-restart')";

        $btn[0]["name"]="{start}";
        $btn[0]["icon"]="fas fa-play";
        $btn[0]["js"]=$jsrestart;
        $status=$tpl->widget_rouge("{firewall_status}","{inactive}",$btn);
    }else{
        $time=intval(@file_get_contents("/usr/share/artica-postfix/ressources/logs/web/FIREWALL_ACTIVE"));
        $ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/firehol.reconfigure.progress";
        $ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/firehol.reconfigure.progress.txt";
        $ARRAY["CMD"]="firehol.php?reconfigure-progress=yes&comand=stop";
        $ARRAY["TITLE"]="{stopping_firewall}";
        $ARRAY["AFTER"]="LoadAjax('table-loader','$page?tabs=yes');";

        $prgress=base64_encode(serialize($ARRAY));
        $jsrestart="Loadjs('fw.progress.php?content=$prgress&mainid=progress-firehol-restart')";

        $btn[0]["name"]="{stop}";
        $btn[0]["icon"]="fas fa-stop";
        $btn[0]["js"]=$jsrestart;

        $ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/firehol.reconfigure.progress";
        $ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/firehol.reconfigure.progress.txt";
        $ARRAY["CMD"]="firehol.php?reconfigure-progress=yes";
        $ARRAY["TITLE"]="{restart}";
        $ARRAY["AFTER"]="LoadAjax('table-loader','$page?tabs=yes');";

        $prgress=base64_encode(serialize($ARRAY));
        $jsrestart="Loadjs('fw.progress.php?content=$prgress&mainid=progress-firehol-restart')";

        $btn[1]["name"]="{restart}";
        $btn[1]["icon"]="fas fa-sync";
        $btn[1]["js"]=$jsrestart;
        $sdate=$tpl->time_to_date($time,true);
        $status=$tpl->widget_vert("{firewall_status}","{active2}<br><small style='color:white;font-size: 12px'>{last_config}:&nbsp;$sdate</small>",$btn);
    }

    echo $tpl->_ENGINE_parse_body($status);
}

function modules_start(){
    $page       = CurrentPageName();
    $addon=null;
    if(isset($_GET["OnlyLoaded"])){$addon="&OnlyLoaded=yes";}
    echo        "<div id='iptables-modules-start' style='margin-top:10px'></div><script>LoadAjax('iptables-modules-start','$page?modules-table=yes$addon')</script>";
}

function page(){
	$page               = CurrentPageName();
	$tpl                = new template_admin();
	$IPTABLES_VERSION   = $GLOBALS["CLASS_SOCKETS"]->GET_INFO("IPTABLES_VERSION");

	$html="
	<div class=\"row border-bottom white-bg dashboard-header\">
	<div class=\"col-sm-12\"><h1 class=ng-binding>{firewall_parameters} v$IPTABLES_VERSION</h1></div>
	</div>
    <div class='row'><div id='progress-firehol-restart'></div>
	<div class='ibox-content'>
    <div id='table-loader'></div>
    </div>
	</div>
    <script>
	$.address.state('/');
	$.address.value('/firewall-parameters');	
	LoadAjax('table-loader','$page?tabs=yes');
	</script>";
	
	if(isset($_GET["main-page"])){
		$tpl=new template_admin("{firewall_parameters}",$html);
		echo $tpl->build_firewall();
		return;
	}
	echo $tpl->_ENGINE_parse_body($html);

}

function logs_settings_save(){
	$tpl=new template_admin();
	$tpl->SAVE_POSTs();

}
function nic_form_settings(){
	$tpl=new template_admin();
	$page=CurrentPageName();	
	$val=$_GET["nic-fw-edit"];
	$nic=new system_nic($val);
	$tpl->js_dialog1("$val $nic->NICNAME $nic->IPADDR", "$page?nic-form-settings-build=$val");
}
function nic_form_settings_build(){
	$tpl=new template_admin();
	$page=CurrentPageName();
	$val=$_GET["nic-form-settings-build"];
	$BEHA["reject"]="{finally_deny_all}";
	$BEHA["accept"]="{finally_allow_all}";
		
	$BEHA2[0]="{not_defined}";
	$BEHA2[1]="{act_as_lan}";
	$BEHA2[2]="{act_as_wan}";

    $BEHA3["accept"]="{accept}";
    $BEHA3["trusted"]="{accept_trusted}";
    $BEHA3["deny"]="{deny}";
		
	$masquerade[0]="{none}";
	$masquerade[1]="{masquerading}";
	$masquerade[2]="{masquerading_invert}";
	$nic=new system_nic($val);
	
	$ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/firehol.reconfigure.progress";
	$ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/firehol.reconfigure.progress.txt";
	$ARRAY["CMD"]="firehol.php?reconfigure-progress=yes";
	$ARRAY["TITLE"]="{reconfiguring_firewall}";
	$prgress=base64_encode(serialize($ARRAY));
	$jsrestart="Loadjs('fw.progress.php?content=$prgress&mainid=progress-firehol-restart')";
	
	
	$form[]=$tpl->field_hidden("nic-settings", $val);
	$form[]=$tpl->field_checkbox("isFW", "{activate_firewall_nic}", $nic->isFW,true,"{activate_firewall_nic_explain}");
	$form[]=$tpl->field_array_hash($BEHA, "firewall_policy", "{firewall_policy}", $nic->firewall_policy);
	$form[]=$tpl->field_array_hash($BEHA2, "firewall_behavior", "{firewall_behavior}", $nic->firewall_behavior);
    $form[]=$tpl->field_array_hash($BEHA3, "firewall_ping", "{firewall_ping}", $nic->firewall_ping);
    $form[]=$tpl->field_checkbox("firewall_masquerade", "{masquerading}", $nic->firewall_masquerade);
	$form[]=$tpl->field_checkbox("firewall_artica", "{accept_artica_w}", $nic->firewall_artica);
	$html[]=$tpl->form_outside("$val $nic->NICNAME $nic->IPADDR", @implode("\n", $form),null,"{apply}","dialogInstance1.close();LoadAjax('table-loader','$page?tabs=yes');$jsrestart","AsSystemAdministrator");
	echo $tpl->_ENGINE_parse_body(@implode("\n", $html));
}



function main(){
	$tpl=new template_admin();
	$page=CurrentPageName();
	$eth_sql=null;
	$token=null;
	$class=null;
	$t=$_GET["t"];
	if(!is_numeric($t)){$t=time();}


	if(!isset($_GET["eth"])){$_GET["eth"]=null;}
	$FireHoleStoreEvents=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FireHoleStoreEvents"));
	$FireHoleStoreEventsMaxSize=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FireHoleStoreEvents"));
	$FireHoleLogAllEvents=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FireHoleLogAllEvents"));
	$BackupMaxDaysDir=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("BackupMaxDaysDir"));;
	if($FireHoleStoreEventsMaxSize==0){$FireHoleStoreEventsMaxSize=100;}
	if($BackupMaxDaysDir==null){$BackupMaxDaysDir="/home/logrotate_backup";}

	$BackupSquidLogsUseNas=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("BackupSquidLogsUseNas"));
    $DNSAmplificationProtection=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DNSAmplificationProtection"));
    $EnableIPsetsProtection=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableIPsetsProtection"));


	
	$ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/firehol.reconfigure.progress";
	$ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/firehol.reconfigure.progress.txt";
	$ARRAY["CMD"]="firehol.php?reconfigure-progress=yes";
	$ARRAY["TITLE"]="{reconfiguring_firewall}";
	$prgress=base64_encode(serialize($ARRAY));
	$jsrestart="Loadjs('fw.progress.php?content=$prgress&mainid=progress-firehol-restart')";

    $form[]=$tpl->field_section("{global_rules}");
    $form[]=$tpl->field_checkbox("DNSAmplificationProtection","{DNSAmplificationProtection}",$DNSAmplificationProtection,false,"");
    $form[]=$tpl->field_checkbox("FireHoleLogAllEvents","{log_all_events}",$FireHoleLogAllEvents,false,"{firewall_log_all_events}");


    $FirewallSyslogUseSSL=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FirewallSyslogUseSSL"));
    $FirewallSyslogServerTCP=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FirewallSyslogServerTCP"));
    $EnableFireWallLogSyslog=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableFireWallLogSyslog"));
    $FirewallSyslogServerPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FirewallSyslogServerPort"));
    $FirewallSyslogServer=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FirewallSyslogServer"));
    $FirewallSyslogCertificate=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FirewallSyslogCertificate"));

    if($FirewallSyslogServerPort==0){$FirewallSyslogServerPort=514;}
    $FirewallSyslogDoNotStorelogsLocally=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FirewallSyslogDoNotStorelogsLocally"));






    $form[]=$tpl->field_section("{remote_syslog_server}");

    $form[] = $tpl->field_checkbox("EnableFireWallLogSyslog",
        "{send_syslog_logs}",$EnableFireWallLogSyslog, "FirewallSyslogServer");
    $form[] = $tpl->field_checkbox("FirewallSyslogDoNotStorelogsLocally",
        "{not_store_log_locally}", $FirewallSyslogDoNotStorelogsLocally);
    $form[] = $tpl->field_ipv4("FirewallSyslogServer", "{remote_syslog_server}", $FirewallSyslogServer);
    $form[] = $tpl->field_numeric("FirewallSyslogServerPort", "{listen_port}", $FirewallSyslogServerPort);
    $form[] = $tpl->field_checkbox("FirewallSyslogServerTCP",
        "{enable_tcpsockets}", $FirewallSyslogServerTCP);

    $form[] = $tpl->field_checkbox("FirewallSyslogUseSSL",
        "{useSSL}", $FirewallSyslogUseSSL);
    $form[] = $tpl->field_certificate("FirewallSyslogCertificate",
        "{certificate}", $FirewallSyslogCertificate);


    $form[]=$tpl->field_section("{logs_storage}");
	$form[]=$tpl->field_checkbox("FireHoleStoreEvents","{backup_firewall_events}",$FireHoleStoreEvents,false,"{FireHoleStoreEvents_explain}");
	$form[]=$tpl->field_numeric("FireHoleStoreEventsMaxSize","{export_log_if_size_exceed} (MB)",$FireHoleStoreEventsMaxSize,"{FireHoleStoreEventsMaxSize_explain}");
	$form[]=$tpl->field_text("BackupMaxDaysDir", "{backup_folder}", $BackupMaxDaysDir,true,"{BackupMaxDaysDir_explain}",true);
	$form[]=$tpl->field_checkbox("BackupSquidLogsUseNas","{use_remote_nas}",$BackupSquidLogsUseNas,false,"{log_retention_nas_text}",true);
	$html[]=$tpl->form_outside(null, @implode("\n", $form),null,'{apply}',$jsrestart,"AsSystemAdministrator",true);
	
	
	$t=time();
	$add="Loadjs('$page?service-js=',true);";

    echo $tpl->_ENGINE_parse_body(@implode("\n", $html));

			
						
}

function modules_table(){
    $t                          = time();
    $TRCLASS                    = null;
    $tpl                        = new template_admin();
    $IPTABLES_MODULES_INFO_TIME = intval($GLOBALS["CLASS_SOCKETS"]->getFrameWork("IPTABLES_MODULES_INFO_TIME"));
    $tt                         = $tpl->time_diff_min($IPTABLES_MODULES_INFO_TIME);
    $ONLYLOADED                 = false;
    if(isset($_GET["OnlyLoaded"])){$ONLYLOADED=true;}

    if($tt>30) {
        $GLOBALS["CLASS_SOCKETS"]->getFrameWork("firehol.php?modules-infos=yes");
    }
    $IPTABLES_MODULES_INFO=unserialize( $GLOBALS["CLASS_SOCKETS"]->GET_INFO("IPTABLES_MODULES_INFO"));



    $html[] = "<table id='table-$t' class=\"footable table table-stripped\" data-page-size=\"100\" data-paging=\"true\">";
    $html[] = "<thead>";
    $html[]="<tr>";

    $html[]="<th data-sortable=true class='text-capitalize' data-type='text'>{status}</th>";
    $html[]="<th data-sortable=true class='text-capitalize' data-type='text'>{module}</th>";
    $html[]="<th data-sortable=true class='text-capitalize' data-type='text' nowrap >{description}</th>";
    $html[]="<th data-sortable=true class='text-capitalize' data-type='text' nowrap>{aliases}</th>";
    $html[]="<th data-sortable=true class='text-capitalize' data-type='text' nowrap>{depends}</th>";
    $html[]="</tr>";
    $html[]="</thead>";
    $html[]="<tbody>";

    foreach ($IPTABLES_MODULES_INFO as $modulename=>$MAIN){
        if($TRCLASS=="footable-odd"){$TRCLASS=null;}else{$TRCLASS="footable-odd";}
        if(!isset($MAIN["DESC"])){$MAIN["DESC"]="&nbsp;";}
        $DESC       = $MAIN["DESC"];
        $status     = "<span class='label'>{unknown}</span>";
        $color      = "#CCCCCC";
        $ALIASES    = $tpl->icon_nothing();
        $depends    = $tpl->icon_nothing();



        if(isset($MAIN["depends"])){
            $depends=$MAIN["depends"];
            $depends=str_replace(",",", ",$depends);
        }

        if(isset($MAIN["ALIASES"])) {
            $tDESC=array();
            foreach ($MAIN["ALIASES"] as $line){
                $line=trim($line);
                if($line==null){continue;}
                if(preg_match("#^(pci|input):#",$line)){continue;}
                $tDESC[]=$line;
            }
            $ALIASES = @implode(", ",$tDESC);
        }
        if(!isset($MAIN["LOADED"])){
            if($ONLYLOADED){continue;}
            $MAIN["LOADED"]=0;
        }



        if(isset($MAIN["INSTALLED"])) {
            if($MAIN["INSTALLED"]) {
                $status     = "<span class='label label-warning'>&nbsp;&nbsp;{unloaded}&nbsp;&nbsp;</span>";
                $color      = "#CCCCCC";
            }else{
                if($ONLYLOADED){continue;}
                $status     ="<span class='label'>{not_installed}</span>";
                $color      ="#CCCCCC";
            }
        }

        if($MAIN["LOADED"]==1){
            $status     = "<span class='label label-primary'>&nbsp;&nbsp;&nbsp;&nbsp;{loaded}&nbsp;&nbsp;&nbsp;&nbsp;</span>";
            $color      = "#000000";
        }else{

            if($ONLYLOADED){continue;}
        }


        if(!isset($MAIN["INSTALLED"])){
            $status="<span class='label'>{not_installed}</span>";
            $color="#CCCCCC";
            if($ONLYLOADED){continue;}
        }
        if($DESC==null){$DESC="&nbsp;";}
        $html[]="<tr class='$TRCLASS'>";
        $html[]="<td nowrap width=1%>$status</td>";
        $html[]="<td nowrap width=1% style='color:$color'><i class=\"fas fa-cube\" style='color:$color'></i>&nbsp;$modulename</td>";
        $html[]="<td style='color:$color'>$DESC</td>";
        $html[]="<td style='color:$color'>$ALIASES</td>";
        $html[]="<td style='color:$color'>$depends</td>";

        $html[]="</tr>";

    }

    $html[]="<tr>";
    $html[]="<td colspan='4'>";
    $html[]="<ul class='pagination pull-right'></ul>";
    $html[]="</td>";
    $html[]="</tr>";
    $html[]="</tfoot>";
    $html[]="</table>";
    $html[]="
<script>
    NoSpinner();\n".@implode("\n",$tpl->ICON_SCRIPTS)."
	$(document).ready(function() { $('#table-$t').footable( { \"paging\": { \"size\": 150}, \"filtering\": { \"enabled\": true }, \"sorting\": { \"enabled\": true } } ); });
</script>";
    echo $tpl->_ENGINE_parse_body($html);
}

function interfaces_start(){
    $page               = CurrentPageName();
    $tpl                = new template_admin();
    $html[]="<table style='width:100%;margin-top:10px'>";
    $html[]="<tr>";
    $html[]="<td valign='top' width='250px' style='padding-left: 10px;padding-right: 10px'><div id='Firewall-status'>". $tpl->spinner()."</div></td>";
    $html[]="<td valign='top' width='99%'><div id='Firewall-interfaces-table'>". $tpl->spinner()."</div></td>";
    $html[]="</tr>";
    $html[]="<script>";
    $html[]="LoadAjax('Firewall-interfaces-table','$page?interfaces=yes');";
    $html[]="</script>";

    echo @implode("\n",$html);

}

function interfaces(){
    $page               = CurrentPageName();
    $tpl                = new template_admin();
    $t                  = time();
    $interface          = $tpl->_ENGINE_parse_body("{interface}");
    $enabled_text       = $tpl->_ENGINE_parse_body("{enabled}");
    $firewall_policy    = $tpl->_ENGINE_parse_body("{firewall_policy}");
    $firewall_behavior  = $tpl->_ENGINE_parse_body("{firewall_behavior}");
    $masquerading       = $tpl->_ENGINE_parse_body("{masquerading}");
    $accept_artica_w    = $tpl->_ENGINE_parse_body("{accept_artica_w}");

    $html[] = "<table id='table-$t' class=\"footable table table-stripped\" data-page-size=\"100\" data-paging=\"true\">";
    $html[] = "<thead>";
    $html[]="<tr>";
    $html[]="<th data-sortable=true class='text-capitalize' data-type='text'>$interface</th>";
    $html[]="<th data-sortable=true class='text-capitalize center' data-type='text' nowrap >$enabled_text</th>";
    $html[]="<th data-sortable=true class='text-capitalize center' data-type='text' nowrap>$firewall_policy</th>";
    $html[]="<th data-sortable=true class='text-capitalize center' data-type='text' nowrap>$firewall_behavior</th>";
    $html[]="<th data-sortable=true class='text-capitalize center' data-type='text' nowrap>$masquerading</th>";
    $html[]="<th data-sortable=true class='text-capitalize center' data-type='text' nowrap>$accept_artica_w</th>";
    $html[]="</tr>";
    $html[]="</thead>";
    $html[]="<tbody>";

    $jsAfter="LoadAjax('table-loader','$page?table=yes&eth={$_GET["eth"]}');";
    $GLOBALS["jsAfterEnc"]=base64_encode($jsAfter);
    $TRCLASS=null;

    $datas=TCP_LIST_NICS_W();

    $BEHA["reject"]="<span class='label label-danger'>{deny_all}</span>";
    $BEHA["accept"]="<span class='label label-primary'>{allow_all}</span>";

    $BEHA2[0]="<span class='label'>{none}</span>";
    $BEHA2[1]="<span class='label label-primary'>LAN</span>";
    $BEHA2[2]="<span class='label label-warning'>WAN</span>";

    $masquerade[0]="{none}";
    $masquerade[1]="{masquerading}";
    $masquerade[2]="{masquerading_invert}";
    $tpl=new template_admin();

    foreach ($datas as $num=>$val){
        $masquerade_F       = $tpl->icon_nothing();
        $val=trim($val);
        $fa_ethernet_class=null;
        if($val==null){continue;}
        $nic                = new system_nic($val);
        if($nic->enabled==0){continue;}
        if($TRCLASS=="footable-odd"){$TRCLASS=null;}else{$TRCLASS="footable-odd";}
        $firewall_policy_F=$BEHA[$nic->firewall_policy];
        $firewall_behavior_F=$BEHA2[$nic->firewall_behavior];
        $firewall_articaF=$tpl->icon_nothing();
        $isFW_icon=$tpl->icon_nothing();
        if($nic->firewall_masquerade==1){
            $masquerade_F="<i class='fas fa-check'></i>";
        }
        if($nic->firewall_artica==1){
            $firewall_articaF="<i class='fas fa-check'></i>";
        }

        if($nic->isFW==1){
            $isFW_icon="<i class='fas fa-check'></i>";
            $fa_ethernet_class="style='color:#1ab394'";
        }else{
            $firewall_policy_F=$tpl->icon_nothing();
            $firewall_behavior_F=$tpl->icon_nothing();

            $firewall_articaF=$tpl->icon_nothing();
        }
//
        $link=$tpl->td_href("$val $nic->NICNAME $nic->IPADDR","{click_to_edit}","Loadjs('$page?nic-fw-edit=$val')");

        $html[]="<tr class='$TRCLASS'>";
        $html[]="<td nowrap><i class='fas fa-ethernet' $fa_ethernet_class></i>&nbsp;$link</td>";
        $html[]="<td width=1% class='center' nowrap>$isFW_icon</td>";
        $html[]="<td width=1% class='center' nowrap>$firewall_policy_F</td>";
        $html[]="<td width=1% class='center' nowrap>$firewall_behavior_F</td>";
        $html[]="<td width=1% class='center' nowrap>$masquerade_F</td>";
        $html[]="<td width=1% class='center' nowrap>$firewall_articaF</td>";
        $html[]="</tr>";
    }
    $html[]="</tbody>";
    $html[]="<tfoot>";

    $html[]="<tr>";
    $html[]="<td colspan='6'>";
    $html[]="<ul class='pagination pull-right'></ul>";
    $html[]="</td>";
    $html[]="</tr>";
    $html[]="</tfoot>";
    $html[]="</table>";
    $html[]="
<script>
    NoSpinner();\n".@implode("\n",$tpl->ICON_SCRIPTS)."
	$(document).ready(function() { $('#table-$t').footable( { \"filtering\": { \"enabled\": false }, \"sorting\": { \"enabled\": true } } ); });
    LoadAjax('Firewall-status','$page?firewall-status=yes');
</script>";

    echo $tpl->_ENGINE_parse_body(@implode("\n", $html));

}