<?php
include_once(dirname(__FILE__)."/ressources/class.template-admin.inc");
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__)."/ressources/class.squid.templates-simple.inc");
include_once(dirname(__FILE__)."/ressources/class.snapshots.blacklists.inc");
include_once(dirname(__FILE__)."/ressources/externals/class.aesCrypt.inc");

if(isset($_GET["tabs"])){tabs();exit;}
if(isset($_GET["parameters"])){parameters();exit;}
if(isset($_GET["status"])){status();exit;}
if(isset($_POST["PowerDNSClusterSlaveInterface"])){Save();exit;}
page();
function page(){
    $page=CurrentPageName();
    $tpl=new template_admin();



    $html[]="
	<div class=\"row border-bottom white-bg dashboard-header\">
		<div class=\"col-sm-12\"><h1 class=ng-binding>Cluster ({slave_mode})</h1><p>{pdns_slave_mode_explain}</p></div>
	</div>
	<div class='row'>
	<div id='progress-cluster-restart'></div>
	";
    $html[]="</div><div class='row'><div class='ibox-content'>";
    $html[]="
	<div id='table-cluster-client'></div>

	</div>
	</div>
	<script>
	$.address.state('/');
	$.address.value('/cluster-client');
	LoadAjax('table-cluster-client','$page?tabs=yes');
	</script>";

    if(isset($_GET["main-page"])){
        $tpl=new template_admin("Cluster ({slave_mode})",$html);
        echo $tpl->build_firewall();return;}
    echo $tpl->_ENGINE_parse_body(@implode("\n", $html));

}
function tabs(){
    $page=CurrentPageName();
    $tpl=new template_admin();
    $sock=new sockets();
    $array["{parameters}"]="$page?parameters=yes";
    $array["{events}"]="fw.system.cluster.events.php";
    echo $tpl->tabs_default($array);
}

function parameters(){
    $tpl=new template_admin();
    $page=CurrentPageName();


    $ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/artica.cluster.progress";
    $ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/artica.cluster.log";
    $ARRAY["CMD"]="system.php?install-cluster-slave=yes";
    $ARRAY["TITLE"]="Cluster {slave_mode}";
    $ARRAY["AFTER"]="LoadAjax('table-cluster-client','$page?tabs=yes');";
    $prgress=base64_encode(serialize($ARRAY));
    $jsRestart="Loadjs('fw.progress.php?content=$prgress&mainid=progress-cluster-restart')";


    $PowerDNSClusterSlaveInterface=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PowerDNSClusterSlaveInterface"));
    $PowerDNSClusterMasterAddress=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PowerDNSClusterMasterAddress"));
    $PowerDNSClusterMasterPort=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PowerDNSClusterMasterPort"));
    $PowerDNSEnableClusterSlaveSchedule=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PowerDNSEnableClusterSlaveSchedule"));
    if($PowerDNSEnableClusterSlaveSchedule<5){$PowerDNSEnableClusterSlaveSchedule=15;}

    if($PowerDNSClusterMasterPort==0){$PowerDNSClusterMasterPort=9000;}

    $MINS[5]="{each} 5 {minutes}";
    $MINS[10]="{each} 10 {minutes}";
    $MINS[15]="{each} 15 {minutes}";
    $MINS[20]="{each} 20 {minutes}";
    $MINS[30]="{each} 30 {minutes}";


    $form[]=$tpl->field_interfaces("PowerDNSClusterSlaveInterface", "{interface}", $PowerDNSClusterSlaveInterface);
    $form[]=$tpl->field_text("PowerDNSClusterMasterAddress", "{master_address}", $PowerDNSClusterMasterAddress);
    $form[]=$tpl->field_numeric("PowerDNSClusterMasterPort","{remote_port}",$PowerDNSClusterMasterPort);

    $form[]=$tpl->field_array_hash($MINS,"PowerDNSEnableClusterSlaveSchedule","{schedule}",$PowerDNSEnableClusterSlaveSchedule);

    if($PowerDNSClusterMasterAddress<>null){

        $ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/artica.cluster.progress";
        $ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/artica.cluster.log";
        $ARRAY["CMD"]="system.php?cluster-slave=yes";
        $ARRAY["TITLE"]="{synchronize}";
        $ARRAY["AFTER"]="LoadAjax('table-cluster-client','$page?tabs=yes');";
        $prgress=base64_encode(serialize($ARRAY));
        $jsRestart2="Loadjs('fw.progress.php?content=$prgress&mainid=progress-cluster-restart')";

        $tpl->form_add_button("{synchronize}",$jsRestart2);
    }

    $formz=$tpl->form_outside("{cluster_configuration}", $form,null,"{apply}",$jsRestart,"AsSystemAdministrator",true);

    $html[]="<table style='width:100%;margin-top:20px'>";
    $html[]="<tr>";
    $html[]="<td style='width:400px' valign='top'>";
    $html[]="<div id='cluster-status' style='width:400px'></div>";
    $html[]="</td>";
    $html[]="<td style='width:99%' valign='top'>";
    $html[]=$formz;
    $html[]="</td>";
    $html[]="</tr>";
    $html[]="</table>";
    $html[]="<script>";
    $html[]="LoadAjax('cluster-status','$page?status=yes');";
    $html[]="</script>";

    echo $tpl->_ENGINE_parse_body($html);

}

function Save(){
    $tpl=new template_admin();

    $PowerDNSClusterMasterAddress=$_POST["PowerDNSClusterMasterAddress"];
    $PowerDNSClusterMasterPort=$_POST["PowerDNSClusterMasterPort"];

    $uri="https://$PowerDNSClusterMasterAddress:$PowerDNSClusterMasterPort/pdns-cluster/index.txt";
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
    curl_setopt($ch, CURLOPT_DNS_CACHE_TIMEOUT, 360);
    curl_setopt($ch, CURLOPT_FORBID_REUSE, TRUE);
    curl_setopt($ch, CURLOPT_FRESH_CONNECT, TRUE);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array("Pragma: no-cache,must-revalidate", "Cache-Control: no-cache,must revalidate",'Expect:'));
    curl_setopt($ch, CURLOPT_TIMEOUT, 5);
    curl_setopt($ch, CURLOPT_URL, "$uri");
    curl_setopt($ch, CURLOPT_POST, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,false);curl_setopt($ch, CURLOPT_SSLVERSION,'all');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_NOPROXY,"*");
    $data=curl_exec($ch);
    $CURLINFO_HTTP_CODE=curl_getinfo($ch,CURLINFO_HTTP_CODE);
    $header_size = curl_getinfo($ch,CURLINFO_HEADER_SIZE);
    $curl_errno=curl_errno($ch);

    $error=curl_errno($ch);
    if($error>0){
        $text=curl_error($ch);
        echo "jserror:".$tpl->_ENGINE_parse_body("{error} $error $text");
        return;
    }

    if($CURLINFO_HTTP_CODE>200){
        echo "jserror:".$tpl->_ENGINE_parse_body("https://$PowerDNSClusterMasterAddress:$PowerDNSClusterMasterPort<br>{error} $CURLINFO_HTTP_CODE");
        return;
    }

    $data=unserialize(base64_decode($data));

    if(!isset($ARRAY["UUID"])){$ARRAY["UUID"]=null;}
    $uuid=base64_decode($GLOBALS["CLASS_SOCKETS"]->getFrameWork("cmd.php?system-unique-id=yes"));
    if($ARRAY["UUID"]<>null){
        if(trim($ARRAY["UUID"])==trim($uuid)){
            echo "jserror:Loop back to myself, same uuid";
            return;
        }
    }

    $tpl->SAVE_POSTs();


}

function status(){
    $tpl=new template_admin();
   $PowerDNSClusterClientDate=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PowerDNSClusterClientDate"));


   if($PowerDNSClusterClientDate==0){
        $html=$tpl->widget_h("gray","fas fa-database","-","{last_sync}");
        echo $tpl->_ENGINE_parse_body($html);
        return false;
   }

   $time=$tpl->time_to_date($PowerDNSClusterClientDate,true);

   $html=$tpl->widget_h("green","fas fa-database","$time","{last_sync}");
    echo $tpl->_ENGINE_parse_body($html);
    return false;
}