<?php

include_once(dirname(__FILE__) . "/ressources/class.template-admin.inc");
if (!isset($GLOBALS["CLASS_SOCKETS"])) {
    if (!class_exists("sockets")) {
        include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");
    }
    $GLOBALS["CLASS_SOCKETS"] = new sockets();
}
include_once(dirname(__FILE__) . '/ressources/class.os.system.inc');
include_once(dirname(__FILE__) . '/ressources/class.os.system.tools.inc');
include_once(dirname(__FILE__) . '/ressources/class.main_cf.inc');

if(isset($_GET["table"])){table();exit;}
if(isset($_GET["kernel-modules-disabled-js"])){kernel_modules_disabled_js();exit;}
if(isset($_GET["loaded-modules-js"])){loaded_kernel_modules_js();exit;}
if(isset($_GET["loaded-modules-popup"])){loaded_kernel_modules_popup();exit;}
if(isset($_POST["kernel_modules_disabled"])){kernel_modules_disabled_save();exit;}
page();



function page(){
    $page=CurrentPageName();
    $tpl=new template_admin();




    $html="
<div class=\"row border-bottom white-bg dashboard-header\" >
	<div class=\"col-sm-12\"><h1 class=ng-binding>{system_information}</h1>
</div>
	
</div>
			
                            
			
<div class='row'><div id='progress-hd-restart' style='background-color:white'></div>
			<div class='ibox-content' style='background-image: url(img/debian_512.png);background-repeat: no-repeat'>
       	
			 	<div id='table-loader-system'></div>
                                    
			</div>
</div>
					
			
			
<script>
	$.address.state('/');
	$.address.value('system-info');
	$.address.title('System Information');
    LoadAjax('table-loader-system','$page?table=yes');
			
</script>";

    if(isset($_GET["main-page"])){
        $tpl=new template_admin(null,$html);
        echo $tpl->build_firewall();
        return;
    }

    $tpl=new templates();
    echo $tpl->_ENGINE_parse_body($html);

}

function loaded_kernel_modules_js(){
    $page=CurrentPageName();
    $tpl=new template_admin();
    echo $tpl->js_dialog2("{loaded_kernel_modules}","fw.settings.php?modules-start=yes&OnlyLoaded=yes",950);
}
function loaded_kernel_modules_popup(){
    $tpl=new template_admin();
    $page=CurrentPageName();
    $t                          = time();
    $TRCLASS                    = null;
    $tpl                        = new template_admin();
    $IPTABLES_MODULES_INFO_TIME = intval($GLOBALS["CLASS_SOCKETS"]->getFrameWork("IPTABLES_MODULES_INFO_TIME"));
    $tt                         = $tpl->time_diff_min($IPTABLES_MODULES_INFO_TIME);

    if($tt>30) {
        $GLOBALS["CLASS_SOCKETS"]->getFrameWork("firehol.php?modules-infos=yes");
    }
    $IPTABLES_MODULES_INFO=unserialize( $GLOBALS["CLASS_SOCKETS"]->GET_INFO("IPTABLES_MODULES_INFO"));



}
function kernel_modules_disabled_js(){
    $tpl=new template_admin();
    $page=CurrentPageName();
    $kernel_modules_disabled=intval($GLOBALS["CLASS_SOCKETS"]->getFrameWork("cmd.php?sysctl-value=yes&key=".base64_encode("kernel.modules_disabled")));

    if($kernel_modules_disabled==1){
        echo $tpl->js_dialog_confirm_action("<strong>{disable_feature}</strong><br>{kernel_modules_disabled}",
            "kernel_modules_disabled",0,"LoadAjax('table-loader-system','$page?table=yes');");

    }else{
       echo $tpl->js_dialog_confirm_action("<strong>{enable_feature}</strong><br>{kernel_modules_disabled}<br>This operation should make some services unavailable like the FireWall and nDPI.",
            "kernel_modules_disabled",1,"LoadAjax('table-loader-system','$page?table=yes');");
    }



}

function kernel_modules_disabled_save(){
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("KernelModulesDisabledSaved",1);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("KernelModulesDisabled",$_POST["kernel_modules_disabled"]);
    $GLOBALS["CLASS_SOCKETS"]->getFrameWork("system.php?sysctl-reconfigure=yes");

}

function table(){
    $tpl=new template_admin();
    $page=CurrentPageName();
    $LINUX_INFO_TXT=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("LINUX_INFO_TXT");
    $sock=new sockets();
    $CPU_NUMBER=intval($GLOBALS["CLASS_SOCKETS"]->getFrameWork("services.php?CPU-NUMBER=yes"));

    $datas=unserialize($sock->getFrameWork("services.php?dmicode=yes"));
    $img="img/server-256.png";
    $foundChassis=false;

    $INSTALL_TIME=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("INSTALL_TIME"));



    if(is_array($datas)){
        $proc_type=$datas["PROC_TYPE"];
        $MANUFACTURER =$datas["MANUFACTURER"];
        $PRODUCT=$datas["PRODUCT"];
        $CHASSIS=$datas["CHASSIS"];
        $md5Chassis=md5("{$datas["MANUFACTURER"]}{$datas["CHASSIS"]}{$datas["PRODUCT"]}");
        if(is_file("img/vendors/$md5Chassis.jpg")){$img="img/vendors/$md5Chassis.jpg";$foundChassis=true;}
        if(is_file("img/vendors/$md5Chassis.jpeg")){$img="img/vendors/$md5Chassis.jpeg";$foundChassis=true;}
        if(is_file("img/vendors/$md5Chassis.png")){$img="img/vendors/$md5Chassis.png";$foundChassis=true;}

    }


    //echo $LINUX_INFO_TXT;

if(!preg_match_all("#([A-Za-z]+)\s+\{(.+?)\}#s",$LINUX_INFO_TXT,$re)){echo "<H1>No data</H1>";return;}
$c=0;
    $UUIDadded=false;
$html[]="<table class=table>";

    if($INSTALL_TIME>0){
        $install_text=$tpl->time_to_date($INSTALL_TIME);
        $install_was=distanceOfTimeInWords($INSTALL_TIME,time());

        $html[]="<tr>
                <td style='width=1% !important;' nowrap>&nbsp;</td>
                <td style='width=1% !important;' align='right' nowrap><strong>{install_date}:</strong></td>
                <td style='width=99% !important;'>$install_text ($install_was)</td>
                </tr>";

    }

    $EnableSystemOptimize=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableSystemOptimize"));
 if($EnableSystemOptimize==1){
     $html[]="<tr>
                <td style='width=1% !important;' nowrap>&nbsp;</td>
                <td style='width=1% !important;' align='right' nowrap><strong>{enable_system_optimization}:</strong></td>
                <td style='width=99% !important;'><span class='label label'>{inactive2}</td>
                </tr>";

 }else{
     $html[]="<tr>
                <td style='width=1% !important;' nowrap>&nbsp;</td>
                <td style='width=1% !important;' align='right' nowrap><strong>{enable_system_optimization}:</strong></td>
                <td style='width=99% !important;'><span class='label label-primary'>{active2}</td>
                </tr>";

 }

    $DailyReboot=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DailyReboot"));
    $DailyRebootHour=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DailyRebootHour"));
    if($DailyRebootHour==null){$DailyRebootHour="06:00:00";}

    if($DailyReboot==1){
        $html[]="<tr>
                <td style='width=1% !important;' nowrap>&nbsp;</td>
                <td style='width=1% !important;' align='right' nowrap><strong>{DAILY_REBOOT_SERVER}:</strong></td>
                <td style='width=99% !important;'><span class='label label-primary'>{active2} {each} $DailyRebootHour</td>
                </tr>";

    }else{
        $html[]="<tr>
                <td style='width=1% !important;' nowrap>&nbsp;</td>
                <td style='width=1% !important;' align='right' nowrap><strong>{DAILY_REBOOT_SERVER}:</strong></td>
                <td style='width=99% !important;'><span class='label label'>{inactive2}</td>
                </tr>";

    }

    $kernel_modules_disabled=intval($GLOBALS["CLASS_SOCKETS"]->getFrameWork("cmd.php?sysctl-value=yes&key=".base64_encode("kernel.modules_disabled")));
    $GLOBALS["CLASS_SOCKETS"]->getFrameWork("kernel.php?nb-modules-loaded=yes");
    $loaded_modules=intval(@file_get_contents("/usr/share/artica-postfix/ressources/logs/web/NB_MODULES_LOADED"));
    $hostname=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("myhostname"));

    $KernelModulesDisabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("KernelModulesDisabled"));
    $KernelModulesDisabledSaved=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("KernelModulesDisabledSaved"));

    if($KernelModulesDisabledSaved==1){
        if($KernelModulesDisabled<>$kernel_modules_disabled){
            $html[]="<tr>
                <td style='width=1% !important;' nowrap>&nbsp;</td>
                <td style='width=1% !important;' align='right' nowrap><strong>{kernel_modules_disabled}:</strong></td>
                <td style='width=99% !important;'><span class='label label-warning'>{you_should_reboot_the_server}</td>
                </tr>";

        }
    }


if($kernel_modules_disabled==1){
    $html[]="<tr>
                <td style='width=1% !important;' nowrap>&nbsp;</td>
                <td style='width=1% !important;' align='right' nowrap><strong>{kernel_modules_disabled}:</strong></td>
                <td style='width=99% !important;'>
                    <a href=\"#\" OnClick=\"Loadjs('$page?kernel-modules-disabled-js=yes');\">
                    <span class='label label-primary'>{active2}</td>
                    </a>
                </tr>";

}else{
    $html[]="<tr>
                <td style='width=1% !important;' nowrap>&nbsp;</td>
                <td style='width=1% !important;' align='right' nowrap><strong>{kernel_modules_disabled}:</strong></td>
                <td style='width=99% !important;'>
                    <a href=\"#\" OnClick=\"Loadjs('$page?kernel-modules-disabled-js=yes');\">
                    <span class='label label'>{inactive2}
                    </span>
                </td>
                </tr>";

}
    $html[]="<tr>
                <td style='width=1% !important;' nowrap>&nbsp;</td>
                <td style='width=1% !important;' align='right' nowrap><strong>{loaded_kernel_modules}:</strong></td>
                <td style='width=99% !important;'>
                <a href=\"#\" OnClick=\"Loadjs('$page?loaded-modules-js=yes');\">
                <span class='label label-primary'>{$loaded_modules}</a></td>
                </tr>";

    $html[]="<tr>
                <td style='width=1% !important;' nowrap>&nbsp;</td>
                <td style='width=1% !important;' align='right' nowrap><strong>{hostname}:</strong></td>
                <td style='width=99% !important;'>".$tpl->td_href($hostname,null,"Loadjs('fw.system.info.php?chhostname-js=yes')")."
                </td>
                </tr>";


    $DebianVersion=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("DEBIAN_VERSION_NAME");

foreach ($re[1] as $titles){
   
    if(preg_match("#system#i",$titles)){$titles=$DebianVersion;}
    $XVALS=array();
    $html[]="<tr>
        <thead>
            <th colspan='3' style='text-align: left'><H2>$titles</H2></th>
        </thead>
        </tr>";



    $data=explode("\n",$re[2][$c]);
    foreach ($data as $line){
        if(!$UUIDadded) {
            if (!isset($XVALS["UUID"])) {
                $UUIDadded = true;
                $XVALS["{uuid}"] = $GLOBALS["CLASS_SOCKETS"]->GET_INFO("SYSTEMID");
            }
        }

        $line=trim($line);
        if($line==null){continue;}
        if(preg_match("#^(.+?):(.+)#",$line,$ri)){
            $key=trim($ri[1]);
            $val=trim($ri[2]);
            $val=str_replace(" days"," {days}",$val);
            $val=str_replace("of RAM",null,$val);
            if($key==null){continue;}
            $XVALS["{".strtolower($key)."}"]=$val;
        }else{
            if($XVALS["{".strtolower($key)."}"]<>null) {
                $XVALS["{".strtolower($key)."}"] = $XVALS["{".strtolower($key)."}"] . "<br>" . $line;
            }
        }
    }


    if($titles=="Hardware"){

        $XVALS["{cpu_cores}"]=$CPU_NUMBER;
        $XVALS["{vendor}"]="$MANUFACTURER $PRODUCT $CHASSIS";
    }


    foreach ($XVALS as $key=>$val){
        $val=trim($val);
        if($val==null){continue;}
        if($key==null){continue;}
        $img    = null;

        if(preg_match("#(User name|vendor name|current cpu frequency|date\/time|load average|hostname)#i",$key)){continue;}
        if(preg_match("#(XDG_CURRENT_DESKTOP|can not find|not running|Load Average|GPL v)#",$val)){continue;}

        if(preg_match("#(Gigabit Ethernet Controller|virtual NIC driver|vmxnet)#i",$val)){
            $img="<img src='img/ethernet_32.png'>";

        }
        if(preg_match("#\s+Wireless\s+#i",$val)) {
            $img = "<img src='img/wifi_32.png'>";
        }
        if(preg_match("#intel\s+#i",$val)) {
            $img = "<img src='img/intel_32.png'>";
        }
        if($img==null) {
            if (preg_match("#VMware#i", $val)) {
                $img = "<img src='img/vmware_32.png'>";


            }

            if (preg_match("#\s+cpu\s+#i", $key)) {
                $img = "<img src='img/cpu_32.png'>";
            }
            if (preg_match("#(Cache Size|Flags|CPU Cores|Processor)#i", $key)) {
                $img = "<img src='img/cpu_32.png'>";
            }
            if (preg_match("#Physical Memory#i", $key)) {
                $img = "<img src='img/memory_32.png'>";
            }




        }

        if($key=="{uptime}"){
            $val=$tpl->uptime();
        }

        if($img==null){$img="&nbsp;";}
        $html[]="<tr>
            <td style='width=1% !important;' nowrap>$img</td>
            <td style='width=1% !important;' align='right' nowrap><strong>$key:</strong></td>
            <td style='width=99% !important;'>$val</td>
            </tr>";
    }


    $c++;

}


    $html[]="</table>";

    echo $tpl->_ENGINE_parse_body($html);

}