<?php
include_once(dirname(__FILE__).'/class.os.system.tools.inc');

class features{
	private $users;
	public $OnlyActive=false;
	private $MEMORY=0;
	private $sockets;
	private $cmd=null;
	public $json=false;
	public $CMDLINES=false;
	function __construct(){
		
		foreach ($_GET as $xkey=>$value){$tt[]="$xkey=$value";}
		$this->cmd=@implode("&", $tt);
		
		$this->users=new usersMenus();
		$os_system=new os_system();
		$results=$os_system->memory();
		$this->sockets=new sockets();
		$this->MEMORY=intval($results['ram']['total']/1024)*1.02;
	}
	
	private function isSecurity($privileges=null){
		if($privileges==null){return true;}
		if($privileges=="AsSystemAdministrator"){if($this->users->AsSystemAdministrator){return true;}}
		if($privileges=="AsSquidAdministrator"){if($this->users->AsSquidAdministrator){return true;}}
		if($privileges=="AsDansGuardianAdministrator"){if($this->users->AsDansGuardianAdministrator){return true;}}
		if($privileges=="AsDnsAdministrator"){if($this->users->AsDnsAdministrator){return true;}}
		if($privileges=="AsPostfixAdministrator"){if($this->users->AsPostfixAdministrator){return true;}}
		if($privileges=="AsFirewallManager"){if($this->users->AsFirewallManager){return true;}}
        if($privileges=="AsSystemWebMaster"){if($this->users->AsSystemWebMaster){return true;}}

		
	}
	
	private function build_paragraph($config){
		$this->JSAFTER="LoadAjax('table-loader','fw.system.services.php?$this->cmd');RefreshSecondInterfaceBarrs();RefreshSecondInterfaceBarrs();";
		$this->JSAFTER="location.reload(true);";
		$LOCK=false;
		$classbt="btn-primary";
		$color="#000000";
		$enable_feature="{install2}";
		$disable_feature="{uninstall}";
		$TOKEN_INSTALLED=1;
		$label=null;
		$TOKEN=$config["TOKEN"];
		if(preg_match("#\{(.+?)\}#",$config["TITLE"],$re)){$KEY_JSON=$re[1];}
        if(!isset($config["TOKEN_REQUIRE"])){$config["TOKEN_REQUIRE"]=null;}
        if(!isset($config["SECURITY"])){$config["SECURITY"]=null;}
		$HideCorporateFeatures=intval($this->sockets->GET_INFO("HideCorporateFeatures"));
        if($this->json){
            $HideCorporateFeatures=0;
            $this->OnlyActive=false;
        }
        if(!$this->json) {
            if (!$this->isSecurity($config["SECURITY"])) {
                return $this->build_paragraphe_failed("{wrong_privileges}",$config["TITLE"] , $config["EXPLAIN"]);
            }
        }

		if(isset($config["LICENSE"])){
			if(!$GLOBALS["CLASS_SOCKETS"]->CORP_LICENSE()){
			    VERBOSE("feature: CORP_LICENSE = False",__LINE__);
				if($HideCorporateFeatures==1){return;}
				return $this->build_paragraphe_failed("{require} <strong>Entreprise License</strong>",$config["TITLE"],$config["EXPLAIN"]);
			}
		}
		
		$INVALIDVA=false;
		if(isset($config["INVALIDVA"])){
			$users=new usersMenus();
			if($users->HYPERV_HOST){$INVALIDVA=true;}
			if($users->VPS_OPENVZ){$INVALIDVA=true;}
			if($users->VMWARE_HOST){$INVALIDVA=true;}
			if($users->XEN_HOST){$INVALIDVA=true;}
		}
		
		if(isset($config["REBOOT"])){$this->JSAFTER=$this->JSAFTER."Loadjs('fw.system.restart.php');";}
			
		
		if($INVALIDVA){
			return $this->build_paragraphe_failed("{incompatible}",$config["TITLE"],$config["EXPLAIN"]);
		}

		if(isset($config["TOKEN_INSTALLED"])){
			$TOKEN_INSTALLED=intval($this->sockets->GET_INFO("{$config["TOKEN_INSTALLED"]}"));
			
			if(!isset($config["DEBIAN"])){
			if($TOKEN_INSTALLED==0){
				return $this->build_paragraphe_failed("{not_installed}",$config["TITLE"],$config["EXPLAIN"],__FUNCTION__);
			}}else{
				$TOKEN_INSTALLED=1;
			}
		}
		
		

		
			
		if(isset($config["TOKENS_REQUIRE_INSTALLED"])){
		    foreach ($config["TOKENS_REQUIRE_INSTALLED"] as $xkey=>$ProductName){
				$TOKEN_REQUIRE_INSTALLED=intval($this->sockets->GET_INFO("$xkey"));
				if($TOKEN_REQUIRE_INSTALLED==0){
					if($this->OnlyActive){return;}
					return $this->build_paragraphe_failed("{require_installed} {{$ProductName}}",$config["TITLE"],$config["EXPLAIN"]);
				}
			}
			
		}
	
		if(isset($config["TOKEN_REQUIRE_INSTALLED"])){
			$TOKEN_REQUIRE_INSTALLED=intval($this->sockets->GET_INFO("{$config["TOKEN_REQUIRE_INSTALLED"]}"));
			if($TOKEN_REQUIRE_INSTALLED==0){
				if($this->OnlyActive){return;}
				return $this->build_paragraphe_failed("{require_installed} {$config["TOKEN_REQUIRE"]}",
                    $config["TITLE"],$config["EXPLAIN"]);
			}
			
		}
		
		if(isset($config["TOKEN_REQUIRE_ENABLED"])){
			$TOKEN_REQUIRE_ENABLED=intval($this->sockets->GET_INFO("{$config["TOKEN_REQUIRE_ENABLED"]}"));
			if($TOKEN_REQUIRE_ENABLED==0){
				if($this->OnlyActive){return;}
				return $this->build_paragraphe_failed("{require_enabled} {$config["TOKEN_REQUIRE"]}",
                    $config["TITLE"],$config["EXPLAIN"]);
			}
		}
		
		if(isset($config["ON_CONFLICTS"])) {
            if (is_array($config["ON_CONFLICTS"])) {
                foreach ($config["ON_CONFLICTS"] as $xkey => $ProductName) {
                    $TOKEN_ON_CONFLICT = intval($this->sockets->GET_INFO("$xkey"));
                    if ($TOKEN_ON_CONFLICT == 1) {
                        if ($this->OnlyActive) {
                            return;
                        }
                        return $this->build_paragraphe_failed("{conflict_with} {{$ProductName}}",
                            $config["TITLE"], $config["EXPLAIN"]);
                    }
                }

            }
        }


		$ARRAY["PROGRESS_FILE"]=$config["PROGRESS_FILE"];
		$ARRAY["LOG_FILE"]=$config["LOG_FILE"];
		
		$ENABLE=intval($this->sockets->GET_INFO("$TOKEN"));
		if($ENABLE==0){
			if($this->OnlyActive){return;}
			if($color=="#000000"){$color="#ABABAB";}
			$application_status="<span class='label label-default'>{uninstalled}</span>";
			$ARRAY["CMD"]=$config["CMD_ON"];
			$ARRAY["TITLE"]="{$config["TITLE"]}:{enable_feature}";
            $ARRAY["AFTER"]=$this->JSAFTER;
			$prgress=base64_encode(serialize($ARRAY));
			$jsrestart="Loadjs('fw.progress.modal.lock.php?content=$prgress&mainid=progress-$TOKEN-restart')";
			$label="<a href=\"javascript:blur()\" OnClick=\"$jsrestart\" class='btn $classbt btn-sm'>
			<i class='fas fa-check'></i> $enable_feature </a>";

            if($this->json){
                $tpl=new template_admin();
                $array[$KEY_JSON]["TITLE"]=$tpl->javascript_parse_text($config["TITLE"]);
                $array[$KEY_JSON]["AVAILABLE"]=true;
                $array[$KEY_JSON]["INSTALLED"]=false;
                $array[$KEY_JSON]["INFO"]="Uninstalled";
                if($this->CMDLINES){$array[$KEY_JSON]["FRAMEWORK"]=$config["CMD_ON"];}
                $array[$KEY_JSON]["EXPLAIN"]=$tpl->javascript_parse_text($config["EXPLAIN"]);
                return $array;
            }



		}else{
			$application_status="<span class='label label-primary'>&nbsp;&nbsp;&nbsp;{installed}&nbsp;&nbsp;&nbsp;</span>";
			$ARRAY["CMD"]=$config["CMD_OFF"];
			$ARRAY["TITLE"]="{$config["TITLE"]}:{disable_feature}";
			$ARRAY["AFTER"]=$this->JSAFTER;
			$prgress=base64_encode(serialize($ARRAY));
			$jsrestart="Loadjs('fw.progress.modal.lock.php?content=$prgress&mainid=progress-$TOKEN-restart')";
			if($disable_feature<>null){
			$label="<a href=\"javascript:blur()\" OnClick=\"$jsrestart\" class='btn btn-warning btn-sm'>
			<i class='fas fa-check'></i> $disable_feature </a>";
			}


            if($this->json){
                $tpl=new template_admin();
                $array[$KEY_JSON]["TITLE"]=$tpl->javascript_parse_text($config["TITLE"]);
                $array[$KEY_JSON]["AVAILABLE"]=true;
                $array[$KEY_JSON]["INSTALLED"]=true;
                $array[$KEY_JSON]["INFO"]="Installed";
                if($this->CMDLINES){$array[$KEY_JSON]["FRAMEWORK"]=$config["CMD_OFF"];}
                $array[$KEY_JSON]["EXPLAIN"]=$tpl->javascript_parse_text($config["EXPLAIN"]);
                return $array;
            }
			
		}
		
		if($TOKEN_INSTALLED==0){$application_status="&nbsp;";}
		if($classbt=="btn-default"){$application_status="&nbsp;";}
		
		$tpl=new template_admin();
		
		$EXPLAIN_TEXT=null;
		if(intval($_GET["expand"])==1){
			$EXPLAIN_TEXT=$tpl->_ENGINE_parse_body("<br><small style='color:$color'>{$config["EXPLAIN"]}</small>");
			
		}
		
		
		
		if(isset($config["MEMMIN"])){
			if($this->MEMORY<$config["MEMMIN"]){
				$config["MEMMIN"]=$config["MEMMIN"]/1000;
			$label="<a href=\"javascript:blur()\" OnClick=\"blur()\" class='btn btn-default btn-sm'>
			<i class='fas fa-exclamation-triangle'></i> {require} ". $config["MEMMIN"]."GB {memory}</a>";
			
			
			$color="#CCCCCC";
			$html[]="<tr>
			<td class='project-status' style='width:1%;color:$color' nowrap class='center'></td>
			<td class='project-title' ><strong style='color:$color'>{$config["TITLE"]}</strong>$EXPLAIN_TEXT</td>
			<td class='project-actions' style='width:1%;color:$color' nowrap>$label</td>
			</tr>";
			return @implode("\n", $html);
			}
			
		}
		
		
		$html[]="<tr>
		<td class='project-status' style='width:1%;color:$color' class='center'nowrap>$application_status</td>
		<td class='project-title'><strong style='color:$color'>{$config["TITLE"]}</strong>$EXPLAIN_TEXT</td>
		<td class='project-actions' style='width:1%;color:$color' nowrap>$label</td>
		</tr>";
		
		return @implode("\n", $html);
		
	}
	
	private function build_paragraphe_failed($button_name,$title,$explain){
        if(preg_match("#\{(.+?)\}#",$title,$re)){$KEY_JSON=$re[1];}

	    if($this->json){
	        $tpl=new template_admin();
	        $array[$KEY_JSON]["TITLE"]=$tpl->javascript_parse_text($title);
            $array[$KEY_JSON]["AVAILABLE"]=false;
            $array[$KEY_JSON]["INFO"]=$button_name;
            $array[$KEY_JSON]["INSTALLED"]=false;
            $array[$KEY_JSON]["EXPLAIN"]=$tpl->javascript_parse_text($explain);
            return $array;

        }

		
		if($this->OnlyActive){return;}
		$color="#CCCCCC";
		$TOKEN=md5(time()."$button_name,$title,$explain");
		$label="<a href=\"javascript:blur()\" OnClick=\"javascript:blur()\" class='btn btn-default btn-sm'>
				<i class='fas fa-exclamation-triangle'></i> $button_name</strong></a>";
		
		$explain_text=null;
		if($_GET["expand"]==1){
			$explain_text="<br><small style='color:$color'>$explain</small>";
		}
		
		
		$html[]="<tr>
		<td class='project-status' style='width:1%;color:$color' nowrap class='center'></td>
		<td class='project-title'><strong style='color:$color'>$title</strong>$explain_text</td>
		<td class='project-actions' style='width:1%' nowrap>$label</td>
		</tr>";
		
		$tpl=new templates();
		return $tpl->_ENGINE_parse_body(@implode("\n", $html));
		
	}
	
	
	public function OPENLDAP(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{APP_OPENLDAP}";
		$config["EXPLAIN"]="{APP_OPENLDAP_EXPLAIN}";
		$config["TOKEN"]="EnableOpenLDAP";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/openldap.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/openldap.log";
		$config["CMD_ON"]="system.php?openldap-enable-progress=yes";
		$config["CMD_OFF"]="system.php?openldap-disable-progress=yes";
		return $this->build_paragraph($config);
	}
	
	public function OPENLDAP_REST(){
		$config["LICENSE"]=true;
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{APP_OPENLDAP_RESTFUL}";
		$config["EXPLAIN"]="{APP_OPENLDAP_RESTFUL_EXPLAIN}";
		$config["TOKEN"]="EnableOpenLDAPRestFul";
		$config["TOKEN_REQUIRE_ENABLED"]="EnableOpenLDAP";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/openldap.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/openldap.log";
		$config["CMD_ON"]="openldap.php?rest-enable=yes";
		$config["CMD_OFF"]="openldap.php?rest-disable=yes";
		return $this->build_paragraph($config);
	}
	
	public function APP_PRIVOXY(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_REQUIRE"]="{proxy_service}";
		$config["TITLE"]="{APP_PRIVOXY}";
		$config["EXPLAIN"]="{privoxy_explain}";
		$config["TOKEN_INSTALLED"]="APP_PRIVOXY_INSTALLED";
		$config["TOKEN_REQUIRE_INSTALLED"]="SQUID_INSTALLED";
		$config["TOKEN_REQUIRE_ENABLED"]="SQUIDEnable";
		$config["TOKEN"]="PrivoxyEnabled";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/privoxy.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/privoxy.txt";
		$config["CMD_ON"]="privoxy.php?install=yes";
		$config["CMD_OFF"]="privoxy.php?disable=yes";
		return $this->build_paragraph($config);
	}

	public function APP_ZABBIX_AGENT(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TOKEN_REQUIRE"]="{proxy_service}";
        $config["TITLE"]="{APP_ZABBIX_AGENT}";
        $config["EXPLAIN"]="{APP_ZABIX_SERVER_TEXT}";
        $config["TOKEN_INSTALLED"]="APP_ZABBIX_AGENT_INSTALLED";
        $config["TOKEN"]="EnableZabbixAgent";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/zabbix.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/zabbix.txt";
        $config["CMD_ON"]="zabbix.php?install=yes";
        $config["CMD_OFF"]="zabbix.php?uninstall=yes";
        return $this->build_paragraph($config);


    }

	public function APP_RDPPROXY(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TITLE"]="{APP_RDPPROXY}";
        $config["EXPLAIN"]="{APP_RDPPROXY_EXPLAIN}";
        $config["TOKEN_INSTALLED"]="APP_RDPPROXY_INSTALLED";
        $config["TOKEN"]="EnableRDPProxy";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/squid.rdpproxy.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/squid.rdpproxy.progress.txt";
        $config["CMD_ON"]="rdpproxy.php?install=yes";
        $config["CMD_OFF"]="rdpproxy.php?uninstall=yes";
        return $this->build_paragraph($config);
     }

    public function APP_KAV4PROXY(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TITLE"]="{APP_KAV4PROXY}";
        $config["EXPLAIN"]="{kav4proxy_about}";
        $config["TOKEN_INSTALLED"]="Kav4ProxyInstalled";
        $config["TOKEN"]="kavicapserverEnabled";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/KAV4PROXYINST.status";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/KAV4PROXYINST.log";
        $config["CMD_ON"]="kav4proxy.php?install=yes";
        $config["CMD_OFF"]="kav4proxy.php?uninstall=yes";
        return $this->build_paragraph($config);
    }

    public function APP_WORDPRESS(){
        $config["TOKENS_REQUIRE_INSTALLED"]["APP_NGINX_INSTALLED"]="APP_NGINX";
        $config["SECURITY"]="AsSystemWebMaster";
        $config["TITLE"]="{wordpress_websites}";
        $config["EXPLAIN"]="{APP_WORDPRESS_ARTICA_TEXT}";
        $config["TOKEN_INSTALLED"]="WP_CLIENT_INSTALLED";
        $config["TOKEN"]="EnableWordpressManagement";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/wordpress.install.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/wordpress.install.progress.txt";
        $config["CMD_ON"]="wordpress.php?install=yes";
        $config["CMD_OFF"]="wordpress.php?uninstall=yes";
        return $this->build_paragraph($config);
    }


	
	public function APP_SNMPD(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["DEBIAN"]=true;
		$config["TITLE"]="{APP_SNMPD}";
		$config["TOKEN_INSTALLED"]="SNMPD_INSTALLED";
		$config["TOKEN"]="EnableSNMPD";
		$config["EXPLAIN"]="{SNMPD_ABOUT}";
		$config["CMD_ON"]="snmpd.php?install=yes";
		$config["CMD_OFF"]="snmpd.php?uninstall=yes";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/snmpd.service.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/snmpd.service.progress.txt";
		return $this->build_paragraph($config);
		
	}

	public function APP_DNSFILTER_CLOUD(){
        $config["ON_CONFLICTS"]["EnableUfdbGuard"]="APP_UFDBGUARD";
        $config["ON_CONFLICTS"]["EnableDNSFilterd"]="APP_DNSFILTERD";
        $config["SECURITY"]="AsDnsAdministrator";
        $config["TOKEN_REQUIRE_ENABLED"]="UnboundEnabled";
        $config["TOKEN_REQUIRE_INSTALLED"]="UnboundInstalled";
        $config["TOKEN_REQUIRE"]="{APP_UNBOUND}";
        $config["TOKEN"]="EnableDNSFilterCloud";
        $config["EXPLAIN"]="{APP_DNSFILTER_CLOUD_EXPLAIN}";
        $config["TITLE"]="{APP_DNSFILTERD_CLOUD}";
        $config["CMD_ON"]="dnsfilterd.php?install-cloud=yes";
        $config["CMD_OFF"]="dnsfilterd.php?uninstall-cloud=yes";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/dnsfilterd.service.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/dnsfilterd.service.progress.txt";
        return $this->build_paragraph($config);

    }

	
	public function APP_DNSFILTERD(){
		$config["ON_CONFLICTS"]["EnableUfdbGuard"]="APP_UFDBGUARD";
        $config["ON_CONFLICTS"]["EnableDNSFilterCloud"]="APP_DNSFILTER_CLOUD";
		$config["SECURITY"]="AsDnsAdministrator";
		$config["TOKEN_REQUIRE_ENABLED"]="UnboundEnabled";
		$config["TOKEN_REQUIRE_INSTALLED"]="UnboundInstalled";
		$config["TOKEN_REQUIRE"]="{APP_UNBOUND}";
		$config["TOKEN_INSTALLED"]="APP_DNSFILTERD_INSTALLED";
		$config["TOKEN"]="EnableDNSFilterd";
		$config["EXPLAIN"]="{APP_DNSFILTERD_EXPLAIN}";
		$config["TITLE"]="{APP_DNSFILTERD}";
		$config["CMD_ON"]="dnsfilterd.php?install=yes";
		$config["CMD_OFF"]="dnsfilterd.php?uninstall=yes";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/dnsfilterd.service.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/dnsfilterd.service.progress.txt";
		return $this->build_paragraph($config);
	}

	public function APP_DOH_BACKEND(){
        $config["SECURITY"]="AsDnsAdministrator";
        $config["TOKEN_REQUIRE_ENABLED"]="UnboundEnabled";
        $config["TOKEN_REQUIRE_INSTALLED"]="UnboundInstalled";
        $config["TOKEN_REQUIRE"]="{APP_UNBOUND}";
        $config["TOKEN_INSTALLED"]="APP_DNSCRYPT_PROXY_INSTALLED";
        $config["TOKEN"]="EnableUnboundDOHBackend";
        $config["EXPLAIN"]="{APP_DOH_BACKEND_EXPLAIN}";
        $config["TITLE"]="{APP_DOH_BACKEND} (DOH)";
        $config["CMD_ON"]="unbound.php?doh-install=yes";
        $config["CMD_OFF"]="unbound.php?doh-uninstall=yes";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/doh.service.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/doh.service.progress.txt";
        return $this->build_paragraph($config);
    }

    public function APP_UDEV_DAEMON(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TOKEN"]="EnableUdevDaemon";
        $config["EXPLAIN"]="{APP_UDEVD}";
        $config["TITLE"]="{APP_UDEVD} (udev)";
        $config["CMD_ON"]="udev.php?install=yes";
        $config["CMD_OFF"]="udev.php?uninstall=yes";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/udev.service.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/udev.service.progress.txt";
        return $this->build_paragraph($config);
    }
    public function APP_DBUS_DAEMON(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TOKEN"]="EnableDbusDaemon";
        $config["EXPLAIN"]="{APP_DBUS}";
        $config["TITLE"]="{APP_DBUS} (dbus)";
        $config["CMD_ON"]="dbus.php?install=yes";
        $config["CMD_OFF"]="dbus.php?uninstall=yes";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/dbus.service.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/dbus.service.progress.txt";
        return $this->build_paragraph($config);
    }

    public function APP_DNSFILTERD_REST(){
        $config["LICENSE"]=true;
        $config["TOKEN_REQUIRE_INSTALLED"]="APP_DNSFILTERD_INSTALLED";
        $config["TOKEN_REQUIRE_ENABLED"]="EnableDNSFilterd";
        $config["TOKEN_REQUIRE"]="{APP_DNSFILTERD}";
        $config["SECURITY"]="AsDnsAdministrator";
        $config["TITLE"]="{APP_DNSFILTERD_REST}";
        $config["EXPLAIN"]="{APP_DNSFILTERD_REST_EXPLAIN}";
        $config["TOKEN"]="EnableDNSFilterdRest";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/dnsfilterd.service.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/dnsfilterd.service.progress.txt";
        $config["CMD_ON"]="dnsfilterd.php?rest-enable=yes";
        $config["CMD_OFF"]="dnsfilterd.php?rest-disable=yes";
        return $this->build_paragraph($config);
    }

	
	
	

	
	
	public function APP_VNSTAT(){
		$config["SECURITY"]="AsSystemAdministrator";
		
		$config["TITLE"]="{APP_VNSTAT}";
		$config["TOKEN_INSTALLED"]="APP_VNSTAT_INSTALLED";
		$config["TOKEN"]="EnableVnStat";
		$config["EXPLAIN"]="{vnstat_service_explain}";
		$config["CMD_ON"]="vnstat.php?install=yes";
		$config["CMD_OFF"]="vnstat.php?uninstall=yes";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/vnstat.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/vnstat.progress.log";
		return $this->build_paragraph($config);
	}

	function APP_SYSLOG_SERVER(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TITLE"]="{APP_SYSLOGD}";
        $config["TOKEN"]="ActAsASyslogServer";
        $config["EXPLAIN"]="{APP_SYSLOG_SERVER_EXPLAIN}";
        $config["CMD_ON"]="syslog.php?install=yes";
        $config["CMD_OFF"]="syslog.php?uninstall=yes";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/syslog.install.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/syslog.install.progress.log";
        return $this->build_paragraph($config);
    }


	
	function APP_FRONTAIL_LINUX(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{APP_FRONTAIL_LINUX}";
		$config["TOKEN_INSTALLED"]="FRONTAIL_LINUX_INSTALLED";
		$config["TOKEN"]="EnableFrontail";
		$config["EXPLAIN"]="{APP_FRONTAIL_LINUX_EXPLAIN}";
		$config["CMD_ON"]="frontail.php?install=yes";
		$config["CMD_OFF"]="frontail.php?uninstall=yes";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/frontail.install.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/frontail.install.progress.log";
		return $this->build_paragraph($config);
	}
    function APP_TAILON(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TITLE"]="{APP_TAILON}";
        $config["TOKEN_INSTALLED"]="TAILON_INSTALLED";
        $config["TOKEN"]="EnableTailon";
        $config["EXPLAIN"]="{APP_FRONTAIL_LINUX_EXPLAIN}";
        $config["CMD_ON"]="tailon.php?install=yes";
        $config["CMD_OFF"]="tailon.php?uninstall=yes";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/tailon.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/tailon.progress.log";
        return $this->build_paragraph($config);
    }


	
	function APP_MULTIPATH_TCP(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{APP_MULTIPATH_TCP}";
		$config["TOKEN"]="APP_MULTIPATH_TCP_ENABLED";
		$config["EXPLAIN"]="{APP_MULTIPATH_TCP_EXPLAIN}";
		$config["CMD_ON"]="tcpmultipath.php?install=yes";
		$config["CMD_OFF"]="tcpmultipath.php?uninstall=yes";
		$config["REBOOT"]=true;
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/tcpmultipath.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/tcpmultipath.progress.log";
		return $this->build_paragraph($config);
	}	
	
	
	
	function APP_MUNIN(){
		$config["SECURITY"]="AsSystemAdministrator";
		
		$config["TITLE"]="{APP_MUNIN}";
		$config["TOKEN_INSTALLED"]="MUNIN_CLIENT_INSTALLED";
		$config["TOKEN"]="EnableMunin";
		$config["EXPLAIN"]="{munin_service_explain}";
		$config["CMD_ON"]="munin.php?install=yes";
		$config["CMD_OFF"]="munin.php?uninstall=yes";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/munin.install.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/munin.install.progress.log";
		return $this->build_paragraph($config);
	}
	
	public function APP_FREERADIUS(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{APP_FREERADIUS}";
		$config["TOKEN_INSTALLED"]="FREERADIUS_INSTALLED";
		$config["TOKEN"]="EnableFreeRadius";
		$config["EXPLAIN"]="{activate_freeradius_explain}";
		$config["CMD_ON"]="freeradius.php?install=yes";
		$config["CMD_OFF"]="freeradius.php?uninstall=yes";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/freeradius.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/freeradius.progress";
		return $this->build_paragraph($config);
	}
	
	public function ELASTICSEARCH(){
		$config["LICENSE"]=true;
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{APP_ELASTICSEARCH}";
		$config["EXPLAIN"]="{APP_ELASTICSEARCH_EXPLAIN}";
		$config["TOKEN_INSTALLED"]="ELASTICSEARCH_INSTALLED";
		$config["TOKEN"]="EnableElasticSearch";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/ElasticSearch.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/ElasticSearch.log";
		$config["CMD_ON"]="elasticsearch.php?install=yes";
		$config["CMD_OFF"]="elasticsearch.php?uninstall=yes";
		$config["MEMMIN"]="3000";
		return $this->build_paragraph($config);
	
	}

    public function ELASTICSEARCH_CLIENT(){
        $config["LICENSE"]=true;
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TITLE"]="{APP_ELASTICSEARCH_CLIENT}";
        $config["EXPLAIN"]="{APP_ELASTICSEARCH_CLIENT_EXPLAIN}";
        $config["TOKEN"]="AsElasticClient";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/AsElasticClient.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/AsElasticClient.log";
        $config["CMD_ON"]="elasticsearch.php?artica-install=yes";
        $config["CMD_OFF"]="elasticsearch.php?artica-uninstall=yes";
        return $this->build_paragraph($config);

    }

    public function APP_VMTOOLS(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TITLE"]="{APP_VMTOOLS}";
        $config["EXPLAIN"]="{INSTALL_VMWARE_TOOLS_TEXT}";
        $config["TOKEN_INSTALLED"]="VMWARE_TOOLS_INSTALLED";
        $config["TOKEN"]="EnableVMWareTools";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/vmware.install.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/vmware.install.log";
        $config["CMD_ON"]="vmtools.php?install=yes";
        $config["CMD_OFF"]="vmtools.php?uninstall=yes";
        return $this->build_paragraph($config);
    }

	
	public function KIBANA(){
		$config["LICENSE"]=true;
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{APP_KIBANA}";
		$config["EXPLAIN"]="{APP_KIBANA_EXPLAIN}";
		$config["TOKEN_INSTALLED"]="APP_KIBANA_INSTALLED";
		$config["TOKEN"]="EnableKibana";
		$config["TOKEN_REQUIRE"]="{APP_ELASTICSEARCH}";
		$config["TOKEN_REQUIRE_INSTALLED"]="ELASTICSEARCH_INSTALLED";
		$config["TOKEN_REQUIRE_ENABLED"]="EnableElasticSearch";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/kibana.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/kibana.log";
		$config["CMD_ON"]="kibana.php?install=yes";
		$config["CMD_OFF"]="kibana.php?uninstall=yes";
		$config["MEMMIN"]="3000";
		return $this->build_paragraph($config);
	}
	
	
	public function FAIL2BAN(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{APP_FAIL2BAN}";
		$config["EXPLAIN"]="{APP_FAIL2BAN_EXPLAIN}";
		$config["TOKEN"]="EnableFail2Ban";
		$config["TOKEN_INSTALLED"]="FAIL2BAN_INSTALLED";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/fail2ban.install.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/fail2ban.install.progress.txt";
		$config["CMD_ON"]="fail2ban.php?install=yes";
		$config["CMD_OFF"]="fail2ban.php?uninstall=yes";
		return $this->build_paragraph($config);
	
	}
	public function PROFTPD(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{APP_PROFTPD}";
		$config["EXPLAIN"]="{APP_PROFTPD_EXPLAIN}";
		$config["TOKEN"]="EnableProFTPD";
		$config["TOKEN_INSTALLED"]="ProFTPDInstalled";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/proftpd.install.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/proftpd.install.progress.txt";
		$config["CMD_ON"]="proftpd.php?install=yes";
		$config["CMD_OFF"]="proftpd.php?uninstall=yes";
		return $this->build_paragraph($config);
	
	}	
	
	
	public function UBOUND(){
		$config["SECURITY"]="AsDnsAdministrator";
		$config["TITLE"]="{APP_UNBOUND}";
		$config["EXPLAIN"]="{didyouknow_unbound}";
		$config["TOKEN"]="UnboundEnabled";
		$config["TOKEN_INSTALLED"]="UnboundInstalled";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php.log";
		$config["CMD_ON"]="unbound.php?install=yes";
		$config["CMD_OFF"]="unbound.php?uninstall=yes";
		return $this->build_paragraph($config);

	}
	public function UBOUND_DNS(){
		$config["TOKENS_REQUIRE_INSTALLED"]["EnableMySQL"]="APP_MYSQL";
		$config["TOKENS_REQUIRE_INSTALLED"]["UnboundEnabled"]="APP_UNBOUND";
		$config["SECURITY"]="AsDnsAdministrator";
		$config["TITLE"]="{UBOUND_DNS}";
		$config["EXPLAIN"]="{ubound_dns_explain}";
		$config["TOKEN"]="UnboundDNSEnabled";
		$config["TOKEN_INSTALLED"]="UnboundInstalled";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php.log";
		$config["CMD_ON"]="unbound.php?install-dns=yes";
		$config["CMD_OFF"]="unbound.php?uninstall-dns=yes";
		return $this->build_paragraph($config);
	
	}

	public function APP_DOH_SERVER(){
        $config["TOKENS_REQUIRE_INSTALLED"]["UnboundEnabled"]="APP_UNBOUND";
        $config["TOKENS_REQUIRE_INSTALLED"]["EnableNginx"]="APP_NGINX";
        $config["SECURITY"]="AsDnsAdministrator";
        $config["TITLE"]="{APP_DOH_SERVER}";
        $config["EXPLAIN"]="{APP_DOH_SERVER_EXPLAIN}";
        $config["TOKEN"]="DOHServerEnabled";
        $config["TOKEN_INSTALLED"]="APP_DOH_SERVER_INSTALLED";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/doh.install";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/doh.install.log";
        $config["CMD_ON"]="doh.php?install=yes";
        $config["CMD_OFF"]="doh.php?uninstall=yes";
        return $this->build_paragraph($config);

    }
	
	public function APP_DNSCRYPT_PROXY(){
		$config["TOKENS_REQUIRE_INSTALLED"]["UnboundEnabled"]="APP_UNBOUND";
        $config["SECURITY"]="AsDnsAdministrator";
		$config["TOKEN_INSTALLED"]="APP_DNSCRYPT_PROXY_INSTALLED";
		$config["TITLE"]="{APP_DNSCRYPT_PROXY}";
		$config["EXPLAIN"]="{APP_DNSCRYPT_PROXY_ABOUT}";
		$config["TOKEN"]="EnableDNSCryptProxy";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/DNSCryptProxy.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/DNSCryptProxy.progress.log";
		$config["CMD_ON"]="dnscrypt-proxy.php?install=yes";
		$config["CMD_OFF"]="dnscrypt-proxy.php?uninstall=yes";
		return $this->build_paragraph($config);
	}

	FUNCTION APP_GEOIP_UPDATES(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TOKEN_INSTALLED"]="GEOIPUPDATE_INSTALLED";
        $config["TITLE"]="{APP_GEOIPUPDATE}";
        $config["EXPLAIN"]="{APP_GEOIPUPDATE_ABOUT}";
        $config["TOKEN"]="EnableGeoipUpdate";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/GeoipUpdate.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/GeoipUpdate.progress.log";
        $config["CMD_ON"]="geoipupdate.php?install=yes";
        $config["CMD_OFF"]="geoipupdate.php?uninstall=yes";
        return $this->build_paragraph($config);

    }


	
	
	public function APP_PDNS(){
		$config["TOKENS_REQUIRE_INSTALLED"]["EnableMySQL"]="APP_MYSQL";
		$config["SECURITY"]="AsDnsAdministrator";
		$config["TITLE"]="{APP_PDNS}";
		$config["EXPLAIN"]="{APP_PDNS_EXPLAIN}";
		$config["TOKEN"]="EnablePDNS";
		$config["TOKEN_INSTALLED"]="PDNSInstalled";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/pdns.first.install";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/pdns.first.install.log";
		$config["CMD_ON"]="pdns.php?first-install=yes";
		$config["CMD_OFF"]="pdns.php?remove=yes";
		return $this->build_paragraph($config);
	
	}

    public function APP_POWERDNS_RESTFUL(){
        $config["TOKENS_REQUIRE_INSTALLED"]["EnablePDNS"]="APP_PDNS";
        $config["LICENSE"]=true;
        $config["SECURITY"]="AsDnsAdministrator";
        $config["TITLE"]="{APP_POWERDNS_RESTFUL}";
        $config["EXPLAIN"]="{APP_POWERDNS_RESTFUL_EXPLAIN}";
        $config["TOKEN"]="EnablePDNSRESTFul";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/pdns.first.install";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/pdns.first.install.log";
        $config["CMD_ON"]="pdns.php?rest-install=yes";
        $config["CMD_OFF"]="pdns.php?rest-remove=yes";
        return $this->build_paragraph($config);

    }


	
	public function APP_DSC(){
		$config["SECURITY"]="AsDnsAdministrator";
		$config["TITLE"]="{APP_DSC}";
		$config["EXPLAIN"]="{activate_dnsstats_explain}<br>{APP_DSC_EXPLAIN}";
		$config["TOKEN"]="PDNSStatsEnabled";
		$config["TOKEN_INSTALLED"]="PDNSStatsInstalled";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/pdns.dsc.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/pdns.dsc.progress.txt";
		$config["CMD_ON"]="pdns.php?activate-dsc=yes";
		$config["CMD_OFF"]="pdns.php?disable-dsc=yes";
		return $this->build_paragraph($config);
		
	}
	
	public function APP_PDNS_RECURSOR(){
		$config["SECURITY"]="AsDnsAdministrator";
		$config["TITLE"]="{APP_PDNS_RECURSOR}";
		$config["EXPLAIN"]="{APP_PDNS_RECURSOR_EXPLAIN}";
		$config["TOKEN_INSTALLED"]="PDNSInstalled";
		$config["TOKEN"]="PowerDNSEnableRecursor";
		$config["TOKEN_REQUIRE"]="{APP_PDNS}";
		$config["TOKEN_REQUIRE_ENABLED"]="EnablePDNS";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/pdns.recursor.install";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/pdns.recursor.install.log";
		$config["CMD_ON"]="pdns.php?recursor-install=yes";
		$config["CMD_OFF"]="pdns.php?recursor-uninstall=yes";
		return $this->build_paragraph($config);
	}

    public function APP_DNSDIST(){
        $config["SECURITY"]="AsDnsAdministrator";
        $config["TITLE"]="{APP_DNSDIST}";
        $config["EXPLAIN"]="{APP_DNSDIST_EXPLAIN}";
        $config["TOKEN_INSTALLED"]="APP_DNSDIST_INSTALLED";
        $config["TOKEN"]="EnableDNSDist";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/dnsdist.install";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/dnsdist.install.log";
        $config["CMD_ON"]="dnsdist.php?install=yes";
        $config["CMD_OFF"]="dnsdist.php?uninstall=yes";
        return $this->build_paragraph($config);
    }
	
	public function APP_CYRUS(){
		$config["SECURITY"]="AsMailBoxAdministrator";
		$config["TITLE"]="{APP_CYRUS}";
		$config["EXPLAIN"]="{about_cyrus}";
		$config["TOKEN_INSTALLED"]="APP_CYRUS_INSTALLED";
		$config["TOKEN"]="EnableCyrusImap";
		$config["TOKEN_REQUIRE"]="{APP_OPENLDAP}";
		$config["TOKEN_REQUIRE_ENABLED"]="EnableOpenLDAP";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/cyrus.install";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/cyrus.install.log";
		$config["CMD_ON"]="cyrus.php?install=yes";
		$config["CMD_OFF"]="cyrus.php?uninstall=yes";
		return $this->build_paragraph($config);
	}

	public function APP_CGROUPS(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TITLE"]="{APP_CGROUPS}";
        $config["EXPLAIN"]="{howto_cgroups}";
        $config["TOKEN"]="cgroupsEnabled";
        $config["TOKEN_INSTALLED"]="CGROUPS_INSTALLED";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/cgroups.install.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/cgroups.install.progress.txt";
        $config["CMD_ON"]="cgroup.php?install=yes";
        $config["CMD_OFF"]="cgroup.php?uninstall=yes";
        return $this->build_paragraph($config);
    }
	
	
	public function APP_KLNAGENT(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{APP_KLNAGENT}";
		$config["EXPLAIN"]="{APP_KLNAGENT_EXPLAIN}";
		$config["TOKEN"]="EnableKlnagent";
		$config["TOKEN_INSTALLED"]="KLNAGENT_INSTALLED";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/klnagent.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/klnagent.progress.txt";
		$config["CMD_ON"]="klnagent.php?install=yes";
		$config["CMD_OFF"]="klnagent.php?uninstall=yes";
		return $this->build_paragraph($config);
	}
	
	
	
	
	
	public function SURICATA(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{IDS} (IDS)";
		$config["EXPLAIN"]="{about_ids}";
		$config["TOKEN"]="EnableSuricata";
		$config["TOKEN_INSTALLED"]="SURICATA_INSTALLED";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/suricata.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/suricata.progress.txt";
		$config["CMD_ON"]="suricata.php?enable-progress=yes";
		$config["CMD_OFF"]="suricata.php?disable-progress=yes";
		$config["MEMMIN"]="1999";
		return $this->build_paragraph($config);
	
	}
	public function ISCSI_CLIENT(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{APP_IETD}";
		$config["EXPLAIN"]="{iscsi_explain}";
		$config["TOKEN"]="EnableISCSI";
		$config["TOKEN_INSTALLED"]="ISCSI_CLIENT_INSTALLED";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php.log";
		$config["CMD_ON"]="iscsi.php?install=yes";
		$config["CMD_OFF"]="iscsi.php?uninstall=yes";
		return $this->build_paragraph($config);
		
		
	}
	
	public function RICHFILEMANAGER(){
		
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{APP_RICHFILEMANAGER}";
		$config["EXPLAIN"]="{APP_RICHFILEMANAGER_ABOUT}";
		$config["TOKEN"]="EnableRichFileManager";
		$config["TOKEN_INSTALLED"]="RICHFILEMANAGER_INSTALLED";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/RichFileManager.install.prg";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/RichFileManager.install.log";
		$config["CMD_ON"]="richfilemanager.php?install=yes";
		$config["CMD_OFF"]="richfilemanager.php?uninstall=yes";
		return $this->build_paragraph($config);

	}
	public function NTPD_CLIENT(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{ENABLE_APP_NTPDCLI}";
		$config["EXPLAIN"]="{ENABLE_APP_NTPDCLI_TEXT}";
		$config["TOKEN"]="NTPDClientEnabled";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/ntpd.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/ntpd.progress.log";
		$config["CMD_ON"]="ntpd.php?client-install=yes";
		$config["CMD_OFF"]="ntpd.php?client-uninstall=yes";
		return $this->build_paragraph($config);
		
	}
	
	
	public function NTPD_SERVER(){
		
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{APP_NTPD} ({server})";
		$config["EXPLAIN"]="{ntp_about}";
		$config["TOKEN"]="NTPDEnabled";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/ntpd.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/ntpd.progress.log";
		$config["CMD_ON"]="ntpd.php?enable=yes";
		$config["CMD_OFF"]="ntpd.php?uninstall=yes";
		return $this->build_paragraph($config);
	}
	
	
	public function RSYNC(){
		
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="RSYNC_INSTALLED";
		$config["TITLE"]="{APP_RSYNC_SERVER}";
		$config["EXPLAIN"]="{APP_RSYNC_SERVER_EXPLAIN}";
		$config["TOKEN"]="EnableRsyncDaemon";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/rsync.install.prg";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/rsync.install.log";
		$config["CMD_ON"]="rsync.php?install=yes";
		$config["CMD_OFF"]="rsync.php?uninstall=yes";
		return $this->build_paragraph($config);
	}


	public function ReverseExchange(){
        $config["SECURITY"]="AsSquidAdministrator";
        $config["TOKEN_INSTALLED"]="HAPROXY_INSTALLED";
        $config["TITLE"]="{APP_HAPROXY_EXCHANGE}";
        $config["EXPLAIN"]="{APP_HAPROXY_EXCHANGE_TEXT}";
        $config["TOKEN"]="EnableHaExchange";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/haexchnage.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/haexchange.progress.txt";
        $config["CMD_ON"]="haexchange.php?install=yes";
        $config["CMD_OFF"]="haexchange.php?uninstall=yes";
        $config["MEMMIN"]="1900";
        return $this->build_paragraph($config);
    }
	
	public function HAPROXY(){
		$config["SECURITY"]="AsSquidAdministrator";
		$config["TOKEN_INSTALLED"]="HAPROXY_INSTALLED";
		$config["TITLE"]="{APP_HAPROXY_SERVICE2}";
		$config["EXPLAIN"]="{APP_HAPROXY_ABOUT}";
		$config["TOKEN"]="EnableHaProxy";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/haproxy.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/haproxy.progress.txt";
		$config["CMD_ON"]="haproxy.php?install=yes";
		$config["CMD_OFF"]="haproxy.php?uninstall=yes";
		$config["MEMMIN"]="1900";
		return $this->build_paragraph($config);
	}


	public function HA_CLUSTER(){
        $config["SECURITY"]="AsSquidAdministrator";
        $config["TOKEN_INSTALLED"]="HAPROXY_INSTALLED";
        $config["TITLE"]="{APP_HAPROXY_CLUSTER} (HaCluster)";
        $config["EXPLAIN"]="{APP_HAPROXY_CLUSTER_EXPLAIN}";
        $config["TOKEN"]="Enablehacluster";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/hacluster.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/hacluster.progress.txt";
        $config["CMD_ON"]="hacluster.php?install=yes";
        $config["CMD_OFF"]="hacluster.php?uninstall=yes";
        $config["MEMMIN"]="1900";
        $config["LICENSE"]=True;
        return $this->build_paragraph($config);

    }

    public function APP_CISCO_REPORTER(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TOKEN_INSTALLED"]="FLOWD_INSTALLED";
        $config["TITLE"]="{APP_CISCO_REPORTER}";
        $config["EXPLAIN"]="{APP_CISCO_REPORTER_EXPLAIN}";
        $config["TOKEN"]="EnableCISCOReporter";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/cisco.reporter.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/cisco.reporter.progress.txt";
        $config["CMD_ON"]="cisco.php?install=yes";
        $config["CMD_OFF"]="cisco.php?uninstall=yes";
        $config["MEMMIN"]="1900";
        $config["LICENSE"]=True;
        return $this->build_paragraph($config);

    }


	
	public function WSUSOFFLINE(){
		
		$config["SECURITY"]="AsSquidAdministrator";
		$config["TOKEN_INSTALLED"]="WSUSOFFLINE_INSTALLED";
		$config["TITLE"]="{APP_WSUSOFFLINE}";
		$config["EXPLAIN"]="{APP_WSUSOFFLINE_EXPLAIN}";
		$config["TOKEN"]="EnableWsusOffline";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/wsusoffline.install.prg";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/wsusoffline.install.log";
		$config["CMD_ON"]="wsusoffline.php?install=yes";
		$config["CMD_OFF"]="wsusoffline.php?uninstall=yes";
		return $this->build_paragraph($config);
	
	}
	public function INSTANTSEARCH(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="XAPIAN_PHP_INSTALLED";
		$config["TITLE"]="{InstantSearch}";
		$config["EXPLAIN"]="{InstantSearch_explain}";
		$config["TOKEN"]="EnableXapianSearch";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/xapian.install.prg";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/xapian.install.log";
		$config["CMD_ON"]="xapian.php?install=yes";
		$config["CMD_OFF"]="xapian.php?uninstall=yes";
		return $this->build_paragraph($config);
	}
	
	public function SPLUNK(){
		
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="APP_SPLUNK_FORWARDER_INSTALLED";
		$config["TITLE"]="{APP_SPLUNK_FORWARDER}";
		$config["EXPLAIN"]="{APP_SPLUNK_FORWARDER_EXPLAIN}";
		$config["TOKEN"]="SplunkForwarderEnabled";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/splunk.install.prg";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/splunk.install.log";
		$config["CMD_ON"]="splunk.php?install=yes";
		$config["CMD_OFF"]="splunk.php?uninstall=yes";
		$config["MEMMIN"]="1500";
		return $this->build_paragraph($config);
	}
	
	public function FIREHOL(){
		$config["SECURITY"]="AsFirewallManager";
		$config["TITLE"]="{your_firewall}";
		$config["EXPLAIN"]="{your_firewall_explain}";
		$config["TOKEN"]="FireHolEnable";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/firehol.reconfigure.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/firehol.reconfigure.progress.txt";
		$config["CMD_ON"]="firehol.php?enable-progress=yes";
		$config["CMD_OFF"]="firehol.php?disable-progress=yes";
		return $this->build_paragraph($config);
	}

    public function APP_LINK_BALANCER(){
        $config["TOKENS_REQUIRE_INSTALLED"]["FireHolEnable"]="your_firewall";
        $config["SECURITY"]="AsFirewallManager";
        $config["TOKEN_INSTALLED"]="APP_LINK_BALANCER_INSTALLED";
        $config["TITLE"]="{APP_LINK_BALANCER}";
        $config["EXPLAIN"]="{APP_LINK_BALANCER_EXPLAIN}";
        $config["TOKEN"]="EnableLinkBalancer";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/LinkBalancer.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/LinkBalancer.progress.log";
        $config["CMD_ON"]="firehol.php?install-link-balancer=yes";
        $config["CMD_OFF"]="firehol.php?uninstall-link-balancer=yes";
        return $this->build_paragraph($config);
    }

    public function APP_NDPI(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TOKEN_INSTALLED"]="APP_NDPI_INSTALLED";


        $config["TITLE"]="{APP_NDPI}";
        $config["EXPLAIN"]="{APP_NDPI_EXPLAIN}";
        $config["TOKEN"]="EnablenDPI";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/firehol.reconfigure.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/firehol.reconfigure.progress.txt";
        $config["CMD_ON"]="firehol.php?enable-ndpi=yes";
        $config["CMD_OFF"]="firehol.php?disable-ndpi=yes";
        return $this->build_paragraph($config);
    }

    public function VLANS(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TOKEN_INSTALLED"]="APP_VLAN_INSTALLED";
        $config["TITLE"]="{APP_VLAN}";
        $config["EXPLAIN"]="{APP_VLAN_EXPLAIN}";
        $config["TOKEN"]="EnableVLANs";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/vlans.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/vlans.install.log";
        $config["CMD_ON"]="network.php?install-vlan=yes";
        $config["CMD_OFF"]="network.php?uninstall-vlan=yes";
        return $this->build_paragraph($config);


    }
	
	public function APP_3PROXY(){
		$config["SECURITY"]="AsFirewallManager";
		$config["TOKEN_INSTALLED"]="APP_3PROXY_INSTALLED";
		$config["TITLE"]="{APP_3PROXY}";
		$config["EXPLAIN"]="{APP_3PROXY_EXPLAIN}";
		$config["TOKEN"]="Enable3Proxy";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/3proxy.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/3proxy.progress.log";
		$config["CMD_ON"]="3proxy.php?install=yes";
		$config["CMD_OFF"]="3proxy.php?uninstall=yes";
		return $this->build_paragraph($config);
		
	}
	
	public function APP_REDSOCKS(){
		$config["TOKEN_REQUIRE_ENABLED"]="FireHolEnable";
		$config["TOKEN_REQUIRE"]="{your_firewall}";
		$config["SECURITY"]="AsFirewallManager";
		$config["TOKEN_INSTALLED"]="APP_REDSOCKS_INSTALLED";
		$config["TITLE"]="{APP_REDSOCKS}";
		$config["EXPLAIN"]="{APP_REDSOCKS_EXPLAIN}";
		$config["TOKEN"]="EnableRedSocks";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/redsocks.install.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/redsocks.install.log";
		$config["CMD_ON"]="redsocks.php?install=yes";
		$config["CMD_OFF"]="redsocks.php?uninstall=yes";
		return $this->build_paragraph($config);
		
	}
    public function APP_SSHPORTAL(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TOKEN_INSTALLED"]="APP_SSHPORTAL_INSTALLED";
        $config["TITLE"]="{APP_SSHPORTAL}";
        $config["EXPLAIN"]="{APP_SSHPORTAL_EXPLAIN}";
        $config["TOKEN"]="EnableSSHPortal";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/sshportal.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/sshportal.log";
        $config["CMD_ON"]="sshd.php?install-portal=yes";
        $config["CMD_OFF"]="sshd.php?uninstall-portal=yes";
        return $this->build_paragraph($config);
    }

	
	public function OPENSSH(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{APP_OPENSSH}";
		$config["EXPLAIN"]="{OPENSSH_EXPLAIN}";
		$config["TOKEN"]="EnableOpenSSH";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/sshd.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/sshd.log";
		$config["CMD_ON"]="sshd.php?install=yes";
		$config["CMD_OFF"]="sshd.php?uninstall=yes";
		return $this->build_paragraph($config);

	}
	
	public function APP_SHELLINABOX(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{APP_SHELLINABOX}";
		$config["EXPLAIN"]="{APP_SHELLINABOX_EXPLAIN}";
		$config["TOKEN_INSTALLED"]="APP_SHELLINABOX_INSTALLED";
		$config["TOKEN"]="EnableShellInABox";
		$config["TOKEN_REQUIRE"]="{APP_OPENSSH}";
		$config["TOKEN_REQUIRE_ENABLED"]="EnableOpenSSH";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/shellinabox.install";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/shellinabox.install.log";
		$config["CMD_ON"]="sshd.php?shellinabox-install=yes";
		$config["CMD_OFF"]="sshd.php?shellinabox-uninstall=yes";
		return $this->build_paragraph($config);
	}	
	
	
	public function DHCPD(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="DHCPD_INSTALLED";
		$config["TITLE"]="{APP_DHCP}";
		$config["EXPLAIN"]="{EnableDHCPServer_text}";
		$config["TOKEN"]="EnableDHCPServer";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/dhcpd.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/dhcpd.progress.txt";
		$config["CMD_ON"]="dhcpd.php?wizard-enable=yes";
		$config["CMD_OFF"]="dhcpd.php?uninstall=yes";
		return $this->build_paragraph($config);
	}


	
	public function NTOPNG(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="NtopNGInstalled";
		$config["TITLE"]="{APP_NTOPNG}";
		$config["EXPLAIN"]="{enable_ntopng_text}";
		$config["TOKEN"]="Enablentopng";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/ntopng.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/ntopng.progress.txt";
		$config["CMD_ON"]="ntopng.php?install=yes";
		$config["CMD_OFF"]="ntopng.php?uninstall=yes";
		return $this->build_paragraph($config);
	}
	
	
	public function GLANCES(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="GLANCES_INSTALLED";
		$config["TITLE"]="{APP_GLANCES}";
		$config["EXPLAIN"]="{GLANCES_EXPLAIN}";
		$config["TOKEN"]="EnableGlances";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/glances.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/glances.progress.txt";
		$config["CMD_ON"]="glances.php?install=yes";
		$config["CMD_OFF"]="glances.php?uninstall=yes";
		return $this->build_paragraph($config);
	}	
	public function POSTFIX(){
		
		
		$config["ON_CONFLICTS"]["SQUIDEnable"]="proxy_service";
		
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="POSTFIX_INSTALLED";
		$config["TITLE"]="{APP_POSTFIX}";
		$config["EXPLAIN"]="{APP_POSTFIX_TEXT}";
		$config["TOKEN"]="EnablePostfix";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/postfix.install";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/postfix.install.txt";
		$config["CMD_ON"]="postfix.php?install=yes";
		$config["CMD_OFF"]="postfix.php?uninstall=yes";
		return $this->build_paragraph($config);
	}


	public function APP_MAIL_TO_SMS(){
        $config["TOKEN_REQUIRE_ENABLED"]="EnablePostfix";
        $config["SECURITY"]="AsPostfixAdministrator";
        $config["TITLE"]="{APP_MAIL2SMS}";
        $config["EXPLAIN"]="{APP_MAIL2SMS_EXPLAIN}";
        $config["TOKEN"]="EnableMail2SMS";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/mail2sms.install";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/mail2sms.install.txt";
        $config["CMD_ON"]="mail2sms.php?install=yes";
        $config["CMD_OFF"]="mail2sms.php?uninstall=yes";
        return $this->build_paragraph($config);

    }
	
	public function APP_MAIL_SPY(){
		$config["TOKENS_REQUIRE_INSTALLED"]["PROCMAIL_INSTALLED"]="APP_PROCMAIL";
		$config["TOKENS_REQUIRE_INSTALLED"]["POSTFIX_INSTALLED"]="APP_POSTFIX";
		$config["TOKEN_REQUIRE_ENABLED"]="EnablePostfix";
		
		$config["SECURITY"]="AsPostfixAdministrator";
		$config["TOKEN_INSTALLED"]="MILTER_SPY_INSTALLED";
		$config["TITLE"]="{APP_MAILSPY}";
		$config["EXPLAIN"]="{APP_MAILSPY_EXPLAIN}";
		$config["TOKEN"]="EnableMilterSpyDaemon";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/mailspy.install";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/mailspy.install.txt";
		$config["CMD_ON"]="mailspy.php?install=yes";
		$config["CMD_OFF"]="mailspy.php?uninstall=yes";
		return $this->build_paragraph($config);
		
		
	}

    public function APP_FILEBEAT(){

        $config["SECURITY"]="AsSystemAdministrator";
        $config["TOKEN_INSTALLED"]="APP_FILEBEAT_INSTALLED";
        $config["TITLE"]="{APP_FILEBEAT}";
        $config["EXPLAIN"]="{APP_FILEBEAT_EXPLAIN}";
        $config["TOKEN"]="EnableFileBeat";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/filebeat.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/filebeat.log";
        $config["CMD_ON"]="filebeat.php?install=yes";
        $config["CMD_OFF"]="filebeat.php?uninstall=yes";
        $config["LICENSE"]=true;
        return $this->build_paragraph($config);
    }
	
	
	public function APP_MIMEDEFANG(){
		$config["TOKENS_REQUIRE_INSTALLED"]["POSTFIX_INSTALLED"]="APP_POSTFIX";
		$config["TOKEN_REQUIRE_ENABLED"]="EnablePostfix";
		$config["SECURITY"]="AsPostfixAdministrator";
		$config["TOKEN_INSTALLED"]="MimeDefangInstalled";
		$config["TITLE"]="{APP_VALVUAD}";
		$config["EXPLAIN"]="{MIMEDEFANG_TEXT}";
		$config["TOKEN"]="MimeDefangEnabled";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/mimedefang.reconfigure.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/mimedefang.reconfigure.progress.log";
		$config["CMD_ON"]="mimedefang.php?install=yes";
		$config["CMD_OFF"]="mimedefang.php?uninstall=yes";
		$config["LICENSE"]=true;
		return $this->build_paragraph($config);
	}
	
	public function APP_MILTER_REGEX(){
		$config["TOKENS_REQUIRE_INSTALLED"]["POSTFIX_INSTALLED"]="APP_POSTFIX";
		$config["TOKEN_REQUIRE_ENABLED"]="EnablePostfix";
		
		$config["SECURITY"]="AsPostfixAdministrator";
		$config["TOKEN_INSTALLED"]="APP_MILTER_REGEX_INSTALLED";
		$config["TITLE"]="{APP_MILTER_REGEX}";
		$config["EXPLAIN"]="{milter_regex_explain}";
		$config["TOKEN"]="EnableMilterRegex";
		
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/milter-regex.reconfigure.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/milter-regex.reconfigure.progress.log";
		$config["CMD_ON"]="milter-regex.php?install=yes";
		$config["CMD_OFF"]="milter-regex.php?uninstall=yes";
		$config["LICENSE"]=true;
		return $this->build_paragraph($config);
	}	
	
	public function APP_MILTERGREYLIST(){
		$config["TOKENS_REQUIRE_INSTALLED"]["POSTFIX_INSTALLED"]="APP_POSTFIX";
		$config["TOKEN_REQUIRE_ENABLED"]="EnablePostfix";
		$config["SECURITY"]="AsPostfixAdministrator";
		$config["TITLE"]="{APP_MILTERGREYLIST}";
		$config["EXPLAIN"]="{APP_MILTERGREYLIST_TEXT}";
		$config["TOKEN"]="MilterGreyListEnabled";
		$config["TOKEN_INSTALLED"]="APP_MILTER_GREYLIST_INSTALLED";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/milter-greylist.install.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/milter-greylist.install.log";
		$config["CMD_ON"]="milter-greylist.php?install=yes";
		$config["CMD_OFF"]="milter-greylist.php?uninstall=yes";
		return $this->build_paragraph($config);
	}
    public function APP_OPENDKIM(){
        $config["TOKENS_REQUIRE_INSTALLED"]["POSTFIX_INSTALLED"]="APP_POSTFIX";
        $config["TOKEN_REQUIRE_ENABLED"]="EnablePostfix";
        $config["SECURITY"]="AsPostfixAdministrator";
        $config["TITLE"]="{APP_OPENDKIM}";
        $config["EXPLAIN"]="{APP_OPENDKIM_TEXT}";
        $config["TOKEN"]="EnableDKFilter";
        $config["TOKEN_INSTALLED"]="OPENDKIM_INSTALLED";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/opendkim.install.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/opendkim.install.log";
        $config["CMD_ON"]="opendkim.php?install=yes";
        $config["CMD_OFF"]="opendkim.php?uninstall=yes";
        return $this->build_paragraph($config);
    }
    public function APP_SAMBA(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TOKEN_INSTALLED"]="SAMBA_INSTALLED";
        $config["TITLE"]="{APP_SAMBA}";
        $config["EXPLAIN"]="{APP_SAMBA_TEXT}";
        $config["TOKEN"]="EnableSamba";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/samba.install.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/samba.install.log";
        $config["CMD_ON"]="samba.php?install=yes";
        $config["CMD_OFF"]="samba.php?uninstall=yes";
        return $this->build_paragraph($config);
    }

	
	public function APP_RBLDNSD(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="APP_RBLDNSD_INSTALLED";
		$config["TITLE"]="{APP_RBLDNSD}";
		$config["EXPLAIN"]="{APP_RBLDNSD_EXPLAIN}";
		$config["TOKEN"]="APP_RBLDNSD_ENABLED";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/rbldnsd.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/rbldnsd.progress.log";
		$config["CMD_ON"]="rbldnsd.php?install=yes";
		$config["CMD_OFF"]="rbldnsd.php?uninstall=yes";
		return $this->build_paragraph($config);
	}


	
	
	public function FIREQOS(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="FIREQOS_INSTALLED";
		$config["TITLE"]="{traffic_shapping}";
		$config["EXPLAIN"]="{traffic_shapping_explain}";
		$config["TOKEN"]="EnableFireQOS";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/fireqos.reconfigure.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/fireqos.reconfigure.progress.txt";
		$config["CMD_OFF"]="firehol.php?qos-remove=yes";
		$config["CMD_ON"]="firehol.php?qos-install=yes";
		return $this->build_paragraph($config);
	}	
	
	public function OPENVPN(){
		
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="OPENVPN_INSTALLED";
		$config["TITLE"]="{APP_OPENVPN}";
		$config["EXPLAIN"]="{APP_OPENVPN_TEXT}";
		$config["TOKEN"]="EnableOpenVPNServer";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/openvpn.enable.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/openvpn.enable.log";
		$config["CMD_ON"]="openvpn.php?enable=yes";
		$config["CMD_OFF"]="openvpn.php?disable=yes";
		return $this->build_paragraph($config);
	}
	
	public function AUTOFS(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="AutoFSInstalled";
		$config["TITLE"]="{automount_center}";
		$config["EXPLAIN"]="{autofs_about}";
		$config["TOKEN"]="AutoFSEnabled";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/autofs.install.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/autofs.install.progress.txt";
		$config["CMD_ON"]="autofs.php?autofs-install=yes";
		$config["CMD_OFF"]="autofs.php?autofs-uninstall=yes";
		return $this->build_paragraph($config);
	}
	
	public function NETDATA(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="NetDataInstalled";
		$config["TITLE"]="{APP_NETDATA}";
		$config["EXPLAIN"]="{APP_NETDATA_EXPLAIN}";
		$config["TOKEN"]="NetDATAEnabled";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/netdata.install.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/netdata.progress.txt";
		$config["CMD_ON"]="system.php?netdata-enable=yes";
		$config["CMD_OFF"]="system.php?netdata-disable=yes";
		return $this->build_paragraph($config);
	}

	public function DARKSTAT(){
		$config["SECURITY"]="AsSystemAdministrator";
		//$config["TOKEN_INSTALLED"]="NetDataInstalled";
		$config["TITLE"]="{APP_DARKSTAT}";
		$config["EXPLAIN"]="{APP_DARKSTAT_EXPLAIN}";
		$config["TOKEN"]="EnableDarkStat";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/darkstat.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/darkstat.progress.txt";
		$config["CMD_ON"]="darkstat.php?enable=yes";
		$config["CMD_OFF"]="darkstat.php?disable=yes";
		return $this->build_paragraph($config);
	}
	
	public function APP_IWCONFIG(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="IWCONFIG_INSTALLED";
		$config["TITLE"]="{APP_IWCONFIG}";
		$config["EXPLAIN"]="{APP_IWCONFIG_EXPLAIN}";
		$config["TOKEN"]="EnableIwConfig";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/iwlwifi.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/iwlwifi.progress.txt";
		$config["CMD_ON"]="iwconfig.php?install=yes";
		$config["CMD_OFF"]="iwconfig.php?uninstall=yes";
		return $this->build_paragraph($config);
	}
    public function APP_PRADS(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TOKEN_INSTALLED"]="APP_PRADS_INSTALLED";
        $config["TITLE"]="{APP_PRADS}";
        $config["EXPLAIN"]="{APP_PRADS_EXPLAIN}";
        $config["TOKEN"]="EnablePrads";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/prads.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/prads.log";
        $config["CMD_ON"]="prads.php?install=yes";
        $config["CMD_OFF"]="prads.php?uninstall=yes";
        return $this->build_paragraph($config);
    }

    public function APP_STATS_COMMUNICATOR(){
        $config["SECURITY"]="AsSquidAdministrator";
        $config["TITLE"]="{APP_STATS_COMMUNICATOR}";
        $config["EXPLAIN"]="{APP_STATS_COMMUNICATOR_EXPLAIN}";
        $config["TOKEN"]="EnableStatsCommunicator";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/stats-com.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/stats-com.log";
        $config["CMD_ON"]="statscom.php?install=yes";
        $config["CMD_OFF"]="statscom.php?uninstall=yes";
        return $this->build_paragraph($config);
    }


	
	public function IWLWIFI(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="IWLWIFI_INSTALLED";
		$config["TITLE"]="{APP_WIFI_INTEL}";
		$config["EXPLAIN"]="{APP_WIFI_INTEL_EXPLAIN}";
		$config["TOKEN"]="EnableIwlwifi";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/iwlwifi.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/iwlwifi.progress.txt";
		$config["CMD_ON"]="iwlwifi.php?install=yes";
		$config["CMD_OFF"]="iwlwifi.php?uninstall=yes";
		return $this->build_paragraph($config);
	}
	
	
	public function SQUID(){
		$config["SECURITY"]="AsSquidAdministrator";
		$config["TOKEN_INSTALLED"]="SQUID_INSTALLED";
		$config["TITLE"]="{proxy_service}";
		$config["EXPLAIN"]="{proxy_service_about}";
		$config["TOKEN"]="SQUIDEnable";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.disable.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.disable.progress.txt";
		$config["CMD_ON"]="squid2.php?enable-proxy-service=yes";
		$config["CMD_OFF"]="squid2.php?disable-proxy-service=yes";
		$config["MEMMIN"]="1000";
		return $this->build_paragraph($config);
	}

	
	public function APP_NGINX(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="APP_NGINX_INSTALLED";
		$config["TITLE"]="{APP_NGINX2}";
		$config["EXPLAIN"]="{enable_nginx_text}";
		$config["TOKEN"]="EnableNginx";
		$config["CMD_ON"]="nginx.php?enable-service=yes";
		$config["CMD_OFF"]="nginx.php?disable-service=yes";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/nginx-enable.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/nginx-enable.log";
		$config["MEMMIN"]="1800";
		return $this->build_paragraph($config);
	}
    public function APP_NGINX_FW(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TOKEN_INSTALLED"]="APP_NGINX_INSTALLED";
        $config["TITLE"]="{APP_NGINX_FW}";
        $config["EXPLAIN"]="{APP_NGINX_FW_EXPLAIN}";
        $config["TOKEN"]="EnableNginxFW";
        $config["CMD_ON"]="nginxfw.php?install=yes";
        $config["CMD_OFF"]="nginxfw.php?uninstall=yes";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/nginxfw.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/nginxfw.log";
        return $this->build_paragraph($config);
    }

    public function speedtest(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TITLE"]="{EnableBandwithCalculation}";
        $config["EXPLAIN"]="{EnableBandwithCalculation_explain}";
        $config["TOKEN"]="EnableBandwithCalculation";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/speedtests.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/speedtests.log";
        $config["CMD_ON"]="speedtests.php?install=yes";
        $config["CMD_OFF"]="speedtests.php?uninstall=yes";
        return $this->build_paragraph($config);

    }
    public function UBOUND_REDIS(){
        $config["TOKENS_REQUIRE_INSTALLED"]["APP_REDIS_SERVER_INSTALLED"]="{APP_REDIS}";
        $config["TOKENS_REQUIRE_INSTALLED"]["UnboundEnabled"]="APP_UNBOUND";
        $config["SECURITY"]="AsDnsAdministrator";
        $config["TITLE"]="{UBOUND_REDIS}";
        $config["EXPLAIN"]="{ubound_redis_explain}";
        $config["TOKEN"]="UnboundRedisEnabled";
        $config["TOKEN_INSTALLED"]="UnboundInstalled";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php.log";
        $config["CMD_ON"]="unbound.php?install-redis=yes";
        $config["CMD_OFF"]="unbound.php?uninstall-redis=yes";
        return $this->build_paragraph($config);

    }

	public function APP_KASPERSKY_UPDATE_UTILITY(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TOKEN_INSTALLED"]="KASPERSKY_UPDATE_UTILITY_INSTALLED";
        $config["TITLE"]="{APP_KASPERSKY_UPDATE_UTILITY}";
        $config["EXPLAIN"]="{APP_KASPERSKY_UPDATE_UTILITY_EXPLAIN}";
        $config["TOKEN"]="EnableKasperskyUpdateUtility";
        $config["CMD_ON"]="updateutility.php?install=yes";
        $config["CMD_OFF"]="updateutility.php?uninstall=yes";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/UpdateUtility.install.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/UpdateUtility.install.progress.txt";
        return $this->build_paragraph($config);

    }




	public function APP_CENTRAL_NODE(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TOKEN_INSTALLED"]="APP_NGINX_INSTALLED";
        $config["TITLE"]="{central_node}";
        $config["EXPLAIN"]="{central_node_explain}";
        $config["TOKEN"]="EnableCentralNode";
        $config["CMD_ON"]="cluster.php?enable-central-node=yes";
        $config["CMD_OFF"]="cluster.php?disable-central-node=yes";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/central-node.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/disable-central-node.log";
        $config["MEMMIN"]="2000";
        return $this->build_paragraph($config);


    }
	
	public function APP_CLAMAV(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="ClamAVDaemonInstalled";
		$config["TITLE"]="{APP_CLAMAV}";
		$config["EXPLAIN"]="{APP_CLAMAV_TEXT}";
		$config["TOKEN"]="EnableClamavDaemon";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/clamd.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/clamd.progress.logs";
		$config["CMD_ON"]="clamav.php?install=yes";
		$config["CMD_OFF"]="clamav.php?uninstall=yes";
		$config["MEMMIN"]="2000";
		return $this->build_paragraph($config);
	}

    public function APP_CISCO_SMARTFILTER(){


    }

    public function APP_REDIS_SERVER(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TOKEN_INSTALLED"]="APP_REDIS_SERVER_INSTALLED";
        $config["TITLE"]="{APP_REDIS_SERVER}";
        $config["EXPLAIN"]="{APP_REDIS_SERVER_TEXT}";
        $config["TOKEN"]="EnableRedisServer";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/redis.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/redis.progress.logs";
        $config["CMD_ON"]="redis.php?install=yes";
        $config["CMD_OFF"]="redis.php?uninstall=yes";
        return $this->build_paragraph($config);

    }


    public function APP_DHCP_RELAY(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TOKEN_INSTALLED"]="APP_DHCP_RELAY_INSTALLED";
        $config["TITLE"]="{APP_DHCP_RELAY}";
        $config["EXPLAIN"]="{APP_DHCP_RELAY_EXPLAIN}";
        $config["TOKEN"]="EnableDHCPRelay";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/dhcrelay.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/dhcrelay.progress.logs";
        $config["CMD_ON"]="dhcpd.php?relay-install=yes";
        $config["CMD_OFF"]="dhcpd.php?relay-uninstall=yes";
        return $this->build_paragraph($config);

    }
	

	
	public function HOTSPOT(){
		$config["TOKENS_REQUIRE_INSTALLED"]["SQUIDEnable"]="proxy_service";
		$config["MEMMIN"]="2000";
		$config["CMD_ON"]="squid2.php?enable-hotspot=yes";
		$config["CMD_OFF"]="squid2.php?disable-hotspot=yes";
		$config["TOKEN"]="EnableSquidMicroHotSpot";
		
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.access.center.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.access.center.progress.log";
		$config["MEMMIN"]="2000";
		$config["TITLE"]="{web_portal_authentication} (hotspot)";
		$config["EXPLAIN"]="{HotSpot_text}";
		return $this->build_paragraph($config);
	}

    public function CLOUD_CATEGORIES(){
        $config["LICENSE"]=true;
        $config["CMD_ON"]="filebeat.php?cloud-install=yes";
        $config["CMD_OFF"]="filebeat.php?cloud-uninstall=yes";
        $config["TOKEN"]="UseCloudArticaCategories";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/filebeat.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/filebeat.log";
        $config["TITLE"]="{UseCloudArticaCategories} ({categories})";
        $config["EXPLAIN"]="{UseCloudArticaCategories_explain}";
        return $this->build_paragraph($config);
    }
	
	public function APP_ARTICALOGGER(){
		$SquidInRouterMode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidInRouterMode"));
		if($SquidInRouterMode==1){return;}
		$config["LICENSE"]=true;
		$config["SECURITY"]="AsSquidAdministrator";
		$config["TOKEN_INSTALLED"]="SQUIDEnable";
		$config["TOKEN_REQUIRE"]="{proxy_service}";
		$config["TITLE"]="{APP_ARTICALOGGER}";
		$config["EXPLAIN"]="{APP_ARTICALOGGER_EXPLAIN}";
		$config["TOKEN"]="EnableSquidLogger";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/SquidLogger.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/SquidLogger.progress.log";
		$config["CMD_ON"]="squidlogger.php?install=yes";
		$config["CMD_OFF"]="squidlogger.php?uninstall=yes";
		return $this->build_paragraph($config);
	}

	public function SQUID_MIKROTIK(){
        $config["SECURITY"]="AsSquidAdministrator";
        $config["TOKEN_INSTALLED"]="SQUIDEnable";
        $config["TOKEN_REQUIRE"]="{proxy_service}";
        $config["TITLE"]="{APP_MIKROTIK_SUPPORT}";
        $config["EXPLAIN"]="{APP_MIKROTIK_SUPPORT_EXPLAIN}";
        $config["TOKEN"]="SquidMikrotikEnabled";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/mikrotik.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/mikrotik.progress.log";
        $config["CMD_ON"]="mikrotik.php?install=yes";
        $config["CMD_OFF"]="mikrotik.php?uninstall=yes";
        return $this->build_paragraph($config);

    }
	
	public function SQUID_ACLS(){
		$config["SECURITY"]="AsSquidAdministrator";
		$config["TOKEN_INSTALLED"]="SQUIDEnable";
		$config["TOKEN_REQUIRE"]="{proxy_service}";
		$config["TITLE"]="{WAF_LONG}";
		$config["EXPLAIN"]="{PROXY_ACLS_EXPLAIN}";
		$config["TOKEN"]="SQUIDACLsEnabled";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.access.center.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.access.center.progress.log";
		$config["CMD_ON"]="squid2.php?enable-acls-service=yes";
		$config["CMD_OFF"]="squid2.php?disable-acls-service=yes";
		return $this->build_paragraph($config);
	}
    public function IT_CHARTERS(){
        $config["SECURITY"]="AsSquidAdministrator";
        $config["TOKENS_REQUIRE_INSTALLED"]["APP_REDIS_SERVER_INSTALLED"]="{APP_REDIS}";
        $config["SQUIDEnable"]["APP_REDIS_SERVER_INSTALLED"]="{proxy_service}";
        $config["TITLE"]="{it_charters}";
        $config["EXPLAIN"]="{IT_charter_explain}";
        $config["TOKEN"]="EnableITChart";
        $config["LICENSE"]=true;
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/itchart.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/itchart.install.log";


        $config["CMD_ON"]="itchart.php?install=yes";
        $config["CMD_OFF"]="itchart.php?uninstall=yes";
        return $this->build_paragraph($config);
    }




    public function GOOGLE_SAFE_BROWSING(){
        $config["SECURITY"]="AsSquidAdministrator";
        $config["TOKEN_INSTALLED"]="SQUIDEnable";
        $config["TOKEN_REQUIRE"]="{proxy_service}";
        $config["TITLE"]="Google Safe Browsing";
        $config["EXPLAIN"]="{EnableGoogleSafeBrowsing_explain}";
        $config["TOKEN"]="EnableGoogleSafeBrowsing";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.access.center.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.access.center.progress.log";
        $config["CMD_ON"]="squid2.php?enable-gsb-service=yes";
        $config["CMD_OFF"]="squid2.php?disable-gsb-service=yes";
        return $this->build_paragraph($config);
    }

    public function APP_SQUIDANALYZER(){
        $config["TOKENS_REQUIRE_INSTALLED"]["SQUIDEnable"]="APP_SQUID";
        $config["SECURITY"]="AsSquidAdministrator";
        $config["TOKEN_INSTALLED"]="APP_SQUIDANALYZER_INSTALLED";
        $config["TITLE"]="{APP_SQUIDANALYZER}";
        $config["EXPLAIN"]="{APP_SQUIDANALYZER_EXPLAIN}";
        $config["TOKEN"]="EnableSquidAnalyzer";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/squidanalyzer.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/squidanalyzer.log";
        $config["CMD_ON"]="squid2.php?enable-squid-analyzer=yes";
        $config["CMD_OFF"]="squid2.php?disable-squid-analyzer=yes";
        $config["MEMMIN"]="8500";
        return $this->build_paragraph($config);

    }


    public function APP_CLUSTER_INFRA(){
        $config["LICENSE"]=true;
        $config["TOKENS_REQUIRE_INSTALLED"]["SQUIDEnable"]="APP_SQUID";
        $config["SECURITY"]="AsSquidAdministrator";
        $config["TITLE"]="{APP_CLUSTER_INFRA}";
        $config["EXPLAIN"]="{APP_CLUSTER_INFRA_EXPLAIN}";
        $config["TOKEN"]="EnableClusterInfra";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/ClusterInfra.progress";
        $config["CMD_ON"]="cluster.php?enable-infra=yes";
        $config["CMD_OFF"]="cluster.php?disable-infra=yes";
        return $this->build_paragraph($config);
    }





	public function SQUID_RESTFULL(){
		$config["LICENSE"]=true;
		$config["SECURITY"]="AsSquidAdministrator";
		$config["TOKEN_INSTALLED"]="SQUIDEnable";
		$config["TOKEN_REQUIRE"]="{proxy_service}";
		$config["TITLE"]="{PROXY_RESTFULL}";
		$config["EXPLAIN"]="{PROXY_RESTFULL_EXPLAIN}";
		$config["TOKEN"]="SQUIDRESTFulEnabled";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.access.center.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.access.center.progress.log";
		$config["CMD_ON"]="squid2.php?enable-restful-service=yes";
		$config["CMD_OFF"]="squid2.php?disable-restful-service=yes";
		return $this->build_paragraph($config);
	}
	
	public function SYSTEM_RESTFULL(){
		$config["LICENSE"]=true;
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TITLE"]="{SYSTEM_RESTFULL}";
		$config["EXPLAIN"]="{SYSTEM_RESTFULL_EXPLAIN}";
		$config["TOKEN"]="EnableRESTFulSystem";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/system.restful";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/system.restful.log";
		$config["CMD_ON"]="netdata.php?restfull-install=yes";
		$config["CMD_OFF"]="netdata.php?restfull-uninstall=yes";
		return $this->build_paragraph($config);
	}	
	
	public function SQUID_PARENTS(){
		$config["SECURITY"]="AsSquidAdministrator";
		$config["TOKEN_INSTALLED"]="SQUIDEnable";
		$config["TITLE"]="{squid_parent_feature}";
		$config["TOKEN_REQUIRE"]="{proxy_service}";
		$config["EXPLAIN"]="{squid_parent_feature_explain}";
		$config["TOKEN"]="EnableParentProxy";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.access.center.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.access.center.progress.txt";
		$config["CMD_ON"]="squid2.php?parents-proxy-check=yes";
		$config["CMD_OFF"]="squid2.php?parents-proxy-disable=yes";
		return $this->build_paragraph($config);
	}
	
	public function LM_SENSORS(){
		$config["INVALIDVA"]=true;
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="SENSORS_INSTALLED";
		$config["TITLE"]="{LMSensorsEnable}";
		$config["EXPLAIN"]="{LMSensorsEnable_text}";
		$config["TOKEN"]="LMSensorsEnable";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.access.center.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.access.center.progress.txt";
		$config["CMD_ON"]="squid2.php?parents-proxy-check=yes";
		$config["CMD_OFF"]="squid2.php?parents-proxy-disable=yes";
		
	}

	public function APP_WANPROXY(){
		
		$config["SECURITY"]="AsSquidAdministrator";
		$config["TOKEN_INSTALLED"]="WANPROXY_INSTALLED";
		$config["TOKEN"]="WanProxyEnabled";
		$config["TOKEN_REQUIRE"]="{proxy_service}";
		$config["TOKEN_REQUIRE_INSTALLED"]="SQUID_INSTALLED";
		$config["TOKEN_REQUIRE_ENABLED"]="SQUIDEnable";
		$config["TITLE"]="{APP_WANPROXY}";
		$config["EXPLAIN"]="{WANPROXY_ABOUT}";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/wanproxy.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/wanproxy.progress.log";
		$config["CMD_ON"]="wanproxy.php?install=yes";
		$config["CMD_OFF"]="wanproxy.php?uninstall=yes";
		return $this->build_paragraph($config);
	}	
	
	function APP_ZIPROXY(){
		$SquidInRouterMode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidInRouterMode"));
		if($SquidInRouterMode==1){return;}
		$config["SECURITY"]="AsSquidAdministrator";
		$config["TOKEN_INSTALLED"]="ZIPROXY_INSTALLED";
		$config["TOKEN"]="EnableProxyCompressor";
		
		
		
		$config["TOKEN_REQUIRE"]="{proxy_service}";
		$config["TOKEN_REQUIRE_INSTALLED"]="SQUID_INSTALLED";
		$config["TOKEN_REQUIRE_ENABLED"]="SQUIDEnable";
		
		$config["TITLE"]="{APP_ZIPROXY}";
		$config["EXPLAIN"]="{APP_ZIPROXY_ABOUT}";
		
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/zipproxy.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/zipproxy.progress.log";
		$config["CMD_ON"]="zipproxy.php?install=yes";
		$config["CMD_OFF"]="zipproxy.php?uninstall=yes";
		return $this->build_paragraph($config);
		
	}


	public function MOD_SECURITY(){
        $config["TOKENS_REQUIRE_INSTALLED"]["EnableNginx"]="APP_NGINX";
        $config["SECURITY"]="AsSquidAdministrator";
        $config["TITLE"]="Web Application Firewall (reverse-proxy)";
        $config["EXPLAIN"]="{ModSecurityExplain}";
        $config["TOKEN_REQUIRE_INSTALLED"]="NginxHTTPModSecurity";
        $config["TOKEN_REQUIRE_ENABLED"]="EnableNginx";
        $config["TOKEN"]="EnableModSecurityIngix";
        $config["CMD_ON"]="nginx.php?modsecurity-install=yes";
        $config["CMD_OFF"]="nginx.php?modsecurity-uninstall=yes";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/modsecurity.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/modsecurity.progress.log";
        return $this->build_paragraph($config);
    }
	

	
	public function PROXY_PAC(){
        $config["TOKENS_REQUIRE_INSTALLED"]["EnableNginx"]="APP_NGINX";
		$config["SECURITY"]="AsSquidAdministrator";
		$config["LICENSE"]=true;
		$config["TITLE"]="{APP_PROXY_PAC}";
		$config["TOKEN"]="EnableProxyPac";
		$config["EXPLAIN"]="{wpad_service_explain}";
		$config["CMD_ON"]="proxypac.php?reinstall-progress=yes";
		$config["CMD_OFF"]="proxypac.php?disable-progress=yes";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/squid-autoconf.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/autoconfiguration.apply.log";
		return $this->build_paragraph($config);
	}
	
	public function ACTIVEDIRECTORY(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["LICENSE"]=true;
		$config["TITLE"]="Active Directory";
		$config["TOKEN_REQUIRE"]="{APP_MSKTUTIL}";
		$config["TOKEN_REQUIRE_INSTALLED"]="MSKTUTIL_INSTALLED";
		$config["EXPLAIN"]="{feature_active_directory_explain}";
		$config["TOKEN"]="EnableActiveDirectoryFeature";
		$config["CMD_ON"]="activedirectory.php?install=yes";
		$config["CMD_OFF"]="activedirectory.php?uninstall=yes";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/ActiveDirectoryFeature.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/ActiveDirectoryFeature.log";
		return $this->build_paragraph($config);		
	}
	
	public function APP_MYSQL(){
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="APP_MYSQL_INSTALLED";
		$config["TITLE"]="{APP_MYSQL}";
		$config["EXPLAIN"]="{APP_MYSQL_ABOUT}";
		$config["TOKEN"]="EnableMySQL";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/mysql.install.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/mysql.install.progress.log";
		$config["CMD_ON"]="mysql.php?install=yes";
		$config["CMD_OFF"]="mysql.php?uninstall=yes";
		return $this->build_paragraph($config);
	}
	
	
	public function APP_GREENSQL(){
		$config["TOKENS_REQUIRE_INSTALLED"]["EnableMySQL"]="APP_MYSQL";
		$config["SECURITY"]="AsSystemAdministrator";
		$config["TOKEN_INSTALLED"]="APP_GREENSQL_INSTALLED";
		$config["TITLE"]="{APP_GREENSQL}";
		$config["EXPLAIN"]="{APP_GREENSQL_ABOUT}";
		$config["TOKEN"]="EnableGreenSQL";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/greensql.install.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/greensql.install.progress.log";
		$config["CMD_ON"]="greensql.php?install=yes";
		$config["CMD_OFF"]="greensql.php?uninstall=yes";
		return $this->build_paragraph($config);
	}


	public function SQUID_WCCP(){
        $config["SECURITY"]="AsSquidAdministrator";
        $config["TOKEN_INSTALLED"]="SQUIDEnable";
        $config["TOKEN_REQUIRE"]="{proxy_service}";
        $config["TITLE"]="{WCCP_NAME}";
        $config["LICENSE"]=false;
        $config["EXPLAIN"]="{WCCP_NAME_EXPLAIN}";
        $config["TOKEN"]="SquidWCCPEnabled";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.wccp.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.wccp.log";
        $config["CMD_ON"]="squid2.php?install-wccp-service=yes";
        $config["CMD_OFF"]="squid2.php?uninstall-wccp-service=yes";
        return $this->build_paragraph($config);
    }
	
	
	public function SQUID_CACHE(){
		$SquidInRouterMode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidInRouterMode"));
		if($SquidInRouterMode==1){return;}
		$config["SECURITY"]="AsSquidAdministrator";
		$config["TOKEN_INSTALLED"]="SQUIDEnable";
		$config["TOKEN_REQUIRE"]="{proxy_service}";
		$config["TITLE"]="{PROXY_CACHE_FEATURE}";
		$config["LICENSE"]=true;
		$config["EXPLAIN"]="{PROXY_CACHE_FEATURE_EXPLAIN}";
		$config["TOKEN"]="SquidCachesProxyEnabled";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.access.center.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.access.center.progress.log";
		$config["CMD_ON"]="squid2.php?install-cache-service=yes";
		$config["CMD_OFF"]="squid2.php?disable-cache-service=yes";
		$config["MEMMIN"]="1500";
		return $this->build_paragraph($config);
	}
	
	
	public function UFDBGUARD(){
		$SquidInRouterMode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidInRouterMode"));
		if($SquidInRouterMode==1){return;}
		$config["SECURITY"]="AsDansGuardianAdministrator";
		$config["TOKEN_INSTALLED"]="APP_UFDBGUARD_INSTALLED";
		$config["TITLE"]="{APP_UFDBGUARD}";
		$config["EXPLAIN"]="{ufdbgdb_explain}";
		$config["TOKEN"]="EnableUfdbGuard";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/ufdb.enable.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/ufdb.enable.progress.log";
		$config["CMD_ON"]="squid.php?ufdbguard_enable_progress=yes";
		$config["CMD_OFF"]="squid.php?ufdbguard_disable_progress=yes";
		$config["MEMMIN"]="2500";
		return $this->build_paragraph($config);
	}
	



	public function PERSONAL_CATEGORIES(){
		$SquidInRouterMode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidInRouterMode"));
		if($SquidInRouterMode==1){return;}
		$config["SECURITY"]="AsDansGuardianAdministrator";
		//$config["TOKEN_INSTALLED"]="APP_UFDBGUARD_INSTALLED";
		$config["LICENSE"]=true;
		$config["TITLE"]="{personal_categories}";
		$config["EXPLAIN"]="{personal_categories_explain}";
		$config["TOKEN"]="EnablePersonalCategories";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/ufdb.enable.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/ufdb.enable.progress.log";
		$config["CMD_ON"]="ufdbguard.php?ppcategories-enable=ye";
		$config["CMD_OFF"]="ufdbguard.php?ppcategories-disable=yes";
		return $this->build_paragraph($config);
	}

	public function ADMIN_TRACK(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TITLE"]="{track_administrators}";
        $config["EXPLAIN"]="{log_administrators_operations}";
        $config["LICENSE"]=true;
        $config["TOKEN"]="TrackAdmins";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/TrackAdmins.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/TrackAdmins.log";
        $config["CMD_ON"]="system.php?TrackAdmins-install=yes";
        $config["CMD_OFF"]="system.php?TrackAdmins-uninstall=yes";
        return $this->build_paragraph($config);

    }

	public function APP_CLUSTER_MASTER(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TITLE"]="Cluster ({master_mode})";
        $config["EXPLAIN"]="{pdns_master_mode_explain}";
        $config["LICENSE"]=true;
        $config["TOKEN"]="PowerDNSEnableClusterMaster";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/artica.cluster.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/artica.cluster.log";
        $config["CMD_ON"]="system.php?install-cluster-master=yes";
        $config["CMD_OFF"]="system.php?uninstall-cluster-master=yes";
        return $this->build_paragraph($config);
    }
    public function APP_CLUSTER_SLAVE(){
        $config["SECURITY"]="AsSystemAdministrator";
        $config["TITLE"]="Cluster ({slave_mode})";
        $config["EXPLAIN"]="{pdns_slave_mode_explain}";
        $config["LICENSE"]=true;
        $config["TOKEN"]="PowerDNSEnableClusterSlave";
        $config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/artica.cluster.progress";
        $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/artica.cluster.log";
        $config["CMD_ON"]="system.php?install-cluster-slave=yes";
        $config["CMD_OFF"]="system.php?uninstall-cluster-slave=yes";
        return $this->build_paragraph($config);
    }

	
	public function CICAP(){
		$SquidInRouterMode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidInRouterMode"));
		if($SquidInRouterMode==1){return;}
		$config["SECURITY"]="AsDansGuardianAdministrator";
		$config["TOKEN_INSTALLED"]="C_ICAP_INSTALLED";
		$config["TITLE"]="{SERVICE_WEBAVEX}";
		$config["EXPLAIN"]="{ACTIVATE_ICAP_AV_TEXT}";
		$config["TOKEN"]="CicapEnabled";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/cicap.install.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/cicap.install.log";
		$config["CMD_ON"]="cicap.php?install-progress=yes";
		$config["CMD_OFF"]="cicap.php?uninstall-progress=yes";
		$config["MEMMIN"]="3200";
		return $this->build_paragraph($config);

	}

	public function UFDBCAT(){
		$SquidInRouterMode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidInRouterMode"));
		if($SquidInRouterMode==1){return;}
		$config["SECURITY"]="AsDansGuardianAdministrator";
		$config["TITLE"]="{APP_UFDBCAT}";
		$config["EXPLAIN"]="{APP_UFDBCAT_EXPLAIN}";
		$config["TOKEN"]="EnableLocalUfdbCatService";
		$config["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/dnscatz.install.progress";
		$config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/dnscatz.install.progress.log";
		$config["CMD_ON"]="dnscat.php?install=yes";
		$config["CMD_OFF"]="dnscat.php?uninstall=yes";
		$config["MEMMIN"]="1500";
        $config["LICENSE"]=true;
		return $this->build_paragraph($config);
	}	
	
	
	
	
	
}